
-- #########################################################
-- #########################################################
-- ConfigEnv.sql
-- #########################################################
-- #########################################################

SPOOL spool.txt
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

-- #########################################################
-- #########################################################
-- VersionCheck.sql
-- #########################################################
-- #########################################################

declare
  curMajor number;
  curMinor number;
  apos number;
  npos number;
  verOk number;
  curVer varchar2(20);
  tstVer varchar2(20);
  aver varchar2(80);
begin
  aver := '13.20.00'; /*    ! */
  verOk := 0;
  select max(Major) into curMajor from DatabaseVersion;
  select max(Minor) into curMinor from DatabaseVersion where Major = curMajor;
  curVer := curMajor;
  apos := LENGTH(curVer) - 1;
  curVer := SUBSTR(curVer, 1, (apos - 1)) || '.' || SUBSTR(curVer, apos, 2) || '.' || TO_CHAR(curMinor, 'FM00');

  apos := 1;
  npos := 0;
  while ((verOk = 0) and (npos < LENGTH(aver))) loop
    npos := INSTR(aver, ',', apos);
    if (npos = 0) then
      npos := LENGTH(aver) + 1;
    end if;
    tstVer := SUBSTR(aver, apos, npos - apos);
    apos := npos + 1;
    if (SUBSTR(curVer, 1, LENGTH(tstVer)) = tstVer) then
      verOk := 1;
    end if;
  end loop;
  
  if (verOk = 0 ) then
    raise_application_error(-20000, '  [' || curVer || ']    ['|| aver ||']');
  end if;
  
end;
/

-- #########################################################
-- #########################################################
-- Insert_IntConst_30_48.sql
-- #########################################################
-- #########################################################

CREATE OR REPLACE procedure InsertConst(progindex$ NUMBER,                             constindex$ NUMBER,
                                 constvalue$ NUMBER,                             note$ VARCHAR2)
AS
  CNT$1 NUMBER(10);
BEGIN
  SELECT COUNT(ID ) INTO CNT$1
  from intconst where (progindex= progindex$  and constindex = constindex$) AND (ROWNUM = 1);
  if (not (CNT$1<> 0)) then
    insert into intconst(progindex, constindex, constvalue, note)
    values(progindex$, constindex$, constvalue$, note$);
  END IF;
END;
/
CALL InsertConst(30, 48, 1000, ' ,         .  0,        ')
/
drop procedure InsertConst
/
commit work
/


-- #########################################################
-- #########################################################
-- alter_AssignmentSource_Name_2000.sql
-- #########################################################
-- #########################################################

/*    ""   " "  4000  */
ALTER TRIGGER TR_ASSIGNMENTSOURCE_BU_500 DISABLE
/
ALTER TABLE ASSIGNMENTSOURCE ADD (
  TempName VARCHAR2(4000)
)
/
commit work 
/
update ASSIGNMENTSOURCE set
  TempName = Name
/
ALTER TABLE ASSIGNMENTSOURCE DROP (Name)
/
commit work 
/
ALTER TABLE ASSIGNMENTSOURCE ADD (
  Name VARCHAR2(4000)
)
/
commit work 
/
update ASSIGNMENTSOURCE set
  Name = TempName
/
ALTER TABLE ASSIGNMENTSOURCE DROP (TempName)
/
ALTER TRIGGER TR_ASSIGNMENTSOURCE_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_Agreements_PurportDoc_2000.sql
-- #########################################################
-- #########################################################

/*    " "  25.04  25.02  2000  */
ALTER TRIGGER TR_AGREEMENTS_BU_500 DISABLE
/
ALTER TABLE TB_Agreements ADD (
  TempPurportDoc VARCHAR2(2000)
)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  PURPORTDOC,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  TEMPPURPORTDOC)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;

  else
    /*    */
    /*       */
    select count(ID), max(DocNumber)
    into Tmp$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum$;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$PURPORTDOC,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$TEMPPURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  rnClientID11$ VARCHAR2(15);
  rnYear11$ VARCHAR2(15);
  rnNumber11$ VARCHAR2(15);
  ReestrVersion11$ VARCHAR2(15);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion) or
  (:old.rnClientID is null) or (:old.rnYear is null) or (:old.ReestrVersion is null)
  ) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID11$ := new$rnClientID;
    rnYear11$ := new$rnYear;
    rnNumber11$ := new$rnNumber;
    ReestrVersion11$ := new$ReestrVersion;
    while (LENGTH(rnClientID11$) < 11) LOOP
      rnClientID11$ := '0' || rnClientID11$;
    END LOOP;
    while (LENGTH(rnNumber11$) < 6) LOOP
      rnNumber11$ := '0' || rnNumber11$;
    END LOOP;
    if (LENGTH(ReestrVersion11$) < 2) then
      ReestrVersion11$ := '0' || ReestrVersion11$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$;

    else
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$ || ReestrVersion11$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    TEMPPURPORTDOC = new$TEMPPURPORTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work 
/
update Agreements set
  TempPurportDoc = PurportDoc
/
ALTER TABLE TB_Agreements DROP (PurportDoc)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  TEMPPURPORTDOC)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;

  else
    /*    */
    /*       */
    select count(ID), max(DocNumber)
    into Tmp$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum$;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$TEMPPURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  rnClientID11$ VARCHAR2(15);
  rnYear11$ VARCHAR2(15);
  rnNumber11$ VARCHAR2(15);
  ReestrVersion11$ VARCHAR2(15);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion) or
  (:old.rnClientID is null) or (:old.rnYear is null) or (:old.ReestrVersion is null)
  ) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID11$ := new$rnClientID;
    rnYear11$ := new$rnYear;
    rnNumber11$ := new$rnNumber;
    ReestrVersion11$ := new$ReestrVersion;
    while (LENGTH(rnClientID11$) < 11) LOOP
      rnClientID11$ := '0' || rnClientID11$;
    END LOOP;
    while (LENGTH(rnNumber11$) < 6) LOOP
      rnNumber11$ := '0' || rnNumber11$;
    END LOOP;
    if (LENGTH(ReestrVersion11$) < 2) then
      ReestrVersion11$ := '0' || ReestrVersion11$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$;

    else
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$ || ReestrVersion11$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    TEMPPURPORTDOC = new$TEMPPURPORTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work 
/
ALTER TABLE TB_Agreements ADD (
  PurportDoc VARCHAR2(2000)
)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  TEMPPURPORTDOC,
  PURPORTDOC)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC,
    PURPORTDOC
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;

  else
    /*    */
    /*       */
    select count(ID), max(DocNumber)
    into Tmp$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum$;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    TEMPPURPORTDOC,
    PURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$TEMPPURPORTDOC,
    new$PURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$TEMPPURPORTDOC AGREEMENTS.TEMPPURPORTDOC%TYPE := :NEW.TEMPPURPORTDOC;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  rnClientID11$ VARCHAR2(15);
  rnYear11$ VARCHAR2(15);
  rnNumber11$ VARCHAR2(15);
  ReestrVersion11$ VARCHAR2(15);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion) or
  (:old.rnClientID is null) or (:old.rnYear is null) or (:old.ReestrVersion is null)
  ) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID11$ := new$rnClientID;
    rnYear11$ := new$rnYear;
    rnNumber11$ := new$rnNumber;
    ReestrVersion11$ := new$ReestrVersion;
    while (LENGTH(rnClientID11$) < 11) LOOP
      rnClientID11$ := '0' || rnClientID11$;
    END LOOP;
    while (LENGTH(rnNumber11$) < 6) LOOP
      rnNumber11$ := '0' || rnNumber11$;
    END LOOP;
    if (LENGTH(ReestrVersion11$) < 2) then
      ReestrVersion11$ := '0' || ReestrVersion11$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$;

    else
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$ || ReestrVersion11$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    TEMPPURPORTDOC = new$TEMPPURPORTDOC,
    PURPORTDOC = new$PURPORTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work 
/
update Agreements set
  PurportDoc = TempPurportDoc
/
ALTER TABLE TB_Agreements DROP (TempPurportDoc)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  PURPORTDOC)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;

  else
    /*    */
    /*       */
    select count(ID), max(DocNumber)
    into Tmp$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum$;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  rnClientID11$ VARCHAR2(15);
  rnYear11$ VARCHAR2(15);
  rnNumber11$ VARCHAR2(15);
  ReestrVersion11$ VARCHAR2(15);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion) or
  (:old.rnClientID is null) or (:old.rnYear is null) or (:old.ReestrVersion is null)
  ) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID11$ := new$rnClientID;
    rnYear11$ := new$rnYear;
    rnNumber11$ := new$rnNumber;
    ReestrVersion11$ := new$ReestrVersion;
    while (LENGTH(rnClientID11$) < 11) LOOP
      rnClientID11$ := '0' || rnClientID11$;
    END LOOP;
    while (LENGTH(rnNumber11$) < 6) LOOP
      rnNumber11$ := '0' || rnNumber11$;
    END LOOP;
    if (LENGTH(ReestrVersion11$) < 2) then
      ReestrVersion11$ := '0' || ReestrVersion11$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$;

    else
      new$ReestrRecordNumber := rnClientID11$ || rnYear11$ || rnNumber11$ || ReestrVersion11$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    PURPORTDOC = new$PURPORTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
ALTER TRIGGER TR_AGREEMENTS_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_TargetCls_init_TransferBudgetRef.sql
-- #########################################################
-- #########################################################

/*     " ".  "- "    */
-- ALTER TRIGGER tr_targetcls_bi
CREATE OR REPLACE TRIGGER TR_TARGETCLS_BI
  BEFORE INSERT
  ON TARGETCLS
  FOR EACH ROW
DECLARE
  FedBudget$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_targetcls_bi)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.TransferKVSR is null) then 
    :new.TransferKVSR := '000';
  END IF;
  if (:new.TransferKFSR is null) then 
    :new.TransferKFSR := '0000';
  END IF;
  if (:new.TransferKCSR is null) then 
    BEGIN
      select CODE into :new.TransferKCSR from KCSR where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.TransferKVR is null) then 
    BEGIN
      select CODE into :new.TransferKVR from KVR where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.ReceiveKDValue is null) then 
    BEGIN
      select KDValue into :new.ReceiveKDValue from KD where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.TransfertKind is null) then 
    :new.TransfertKind := 0;
  END IF;
  if (:new.TransferBudgetRef is null) then
    /*     ( ) */
    select min(id)     into FedBudget$ from budgets_s
    where (BudgetLevel = 1) and (IsConsolidated = 0)
    ;
    if (FedBudget$ is null) then
      :new.TransferBudgetRef := 0;
          
    else
      :new.TransferBudgetRef := FedBudget$;
      
    END IF;
  END IF;
  if (:new.ControlFK is null) then 
    :new.ControlFK := 1; 
  END IF;
  if (:new.LowerBudgetKD is null) then 
    BEGIN
      select KDValue into :new.LowerBudgetKD from KD where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.BudgetLevel is null) then 
    :new.BudgetLevel := 0;
  END IF;
  if (:new.IsTransfert is null) then 
    :new.IsTransfert := 1;
  END IF;
  if (:new.IsCofinancing is null) then 
    :new.IsCofinancing := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TARGETCLS_BI_500)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER tr_targetcls_bu
CREATE OR REPLACE TRIGGER TR_TARGETCLS_BU
  BEFORE UPDATE
  ON TARGETCLS
  FOR EACH ROW
DECLARE
  FedBudget$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_targetcls_bu)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.TransferKVSR is null) then 
    :new.TransferKVSR := '000';
  END IF;
  if (:new.TransferKFSR is null) then 
    :new.TransferKFSR := '0000';
  END IF;
  if (:new.TransferKCSR is null) then 
    BEGIN
      select CODE into :new.TransferKCSR from KCSR where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.TransferKVR is null) then 
    BEGIN
      select CODE into :new.TransferKVR from KVR where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.ReceiveKDValue is null) then 
    BEGIN
      select KDValue into :new.ReceiveKDValue from KD where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.TransfertKind is null) then 
    :new.TransfertKind := 0;
  END IF;
  if (:new.TransferBudgetRef is null) then
    /*     ( ) */
    select min(id)     into FedBudget$ from budgets_s
    where (BudgetLevel = 1) and (IsConsolidated = 0)
    ;
    if (FedBudget$ is null) then
      :new.TransferBudgetRef := 0;
          
    else
      :new.TransferBudgetRef := FedBudget$;
      
    END IF;
  END IF;
  if (:new.ControlFK is null) then 
    :new.ControlFK := 1;
  END IF;
  if (:new.LowerBudgetKD is null) then 
    BEGIN
      select KDValue into :new.LowerBudgetKD from KD where id = 0 ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.BudgetLevel is null) then 
    :new.BudgetLevel := 0;
  END IF;
  if (:new.IsTransfert is null) then 
    :new.IsTransfert := 1;
  END IF;
  if (:new.IsCofinancing is null) then 
    :new.IsCofinancing := 0;
  END IF;

END;
/
commit work
/
ALTER TRIGGER TR_TARGETCLS_BU_500 DISABLE
/
commit work
/
/*    "" ,  " " */
update TargetCls set
  TransferBudgetRef = null
where
  TransferBudgetRef = 0
/
commit work
/
ALTER TRIGGER TR_TARGETCLS_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- Layers_CreateViewNonSynchr.sql
-- #########################################################
-- #########################################################


CREATE OR REPLACE VIEW Layers_ForURM
(LayerRef,UserName,CLIENTID)
AS
select l.ID,dbu.USERNAME,rc.ClientID
FROM LAYERS l
INNER JOIN REMOTECLIENT rc ON 1=1
INNER JOIN DBUSERS dbu ON dbu.REMOTECLIENTREF=rc.ID
LEFT JOIN (
    select dbu.ID UserID,ld_GroupForbid.STRFIELD02 Alias
    FROM LayerData ld_GroupForbid
    INNER JOIN DBGroups dbg
      ON (ld_GroupForbid.STRFIELD00=dbg.Name)
        AND (ld_GroupForbid.INTFIELD03=0)
        AND ld_GroupForbid.LAYERREF=(select lg.ID from Layers lg where 
lg.ALIAS='..')
    INNER JOIN USERSINGROUPS uig
      ON uig.GroupRef=dbg.ID
    INNER JOIN DBUSERS dbu
      ON uig.UserRef=dbu.ID
  ) GrForbid ON
    GrForbid.UserID=dbu.ID AND GrForbid.Alias=l.Alias
  LEFT JOIN (
   SELECT ld_UserForbid.STRFIELD02 UserName,ld_UserForbid.STRFIELD01 Alias
    FROM LayerData ld_UserForbid
    WHERE ld_UserForbid.LAYERREF=(
         select lu.ID from Layers lu where 
lu.ALIAS='..'
     )
     AND
     (ld_UserForbid.INTFIELD03=0)
   ) UserForbid
   ON (UserForbid.UserName=dbu.UserName||'@'||rc.CLIENTID)
     AND (UserForbid.Alias=l.Alias)
WHERE
   UserForbid.UserName is NULL
   AND
   GrForbid.UserID is NULL
/



/* <TRANS_COMMAND>
CREATE TABLE Layers_NonSynchr 
   (	
  	ID NUMBER(10,0) NOT NULL, 
	  LAYERREF NUMBER(10,0) NOT NULL, 
	  LAYERVERSION NUMBER(10,0) NOT NULL, 
    ASSEMBLY NUMBER(10,0),
    CREATEDATE DATE NOT NULL, 
	  CREATERUSER VARCHAR2(30) NOT NULL, 
	  UPDATEDATE DATE NOT NULL, 
	  UPDATERUSER VARCHAR2(30) NOT NULL, 
    
	
	 CHECK ((ID<=2147483647)AND(ID>-2147483648)), 
	 CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)), 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)), 
	 CHECK ((ASSEMBLY<=2147483647)AND(ASSEMBLY>-2147483648)), 
  
   CONSTRAINT "PK_L_NS" PRIMARY KEY ("ID")
   )
/
CREATE INDEX L_NS_Layer ON Layers_NonSynchr(LayerRef)
/
CREATE INDEX L_NS_LayerVersion ON Layers_NonSynchr(LayerRef,LayerVersion)
/
GRANT ALL ON Layers_NonSynchr TO PUBLIC
/
COMMIT WORK
/
*/

-- <TRANS_IGNORE>
DECLARE
  cnt integer;
BEGIN
  SELECT count(*) INTO cnt 
    FROM user_views WHERE lower(view_name)='layers_nonsynchr';
  IF cnt>0 THEN
    EXECUTE IMMEDIATE 'DROP VIEW Layers_NonSynchr';
  END IF;
  
  SELECT count(*) INTO cnt 
    FROM user_tables WHERE lower(table_name)='layers_nonsynchr';
  IF cnt=0  THEN
    EXECUTE IMMEDIATE 'CREATE TABLE Layers_NonSynchr 
   (	
  	ID NUMBER(10,0) NOT NULL, 
	  LAYERREF NUMBER(10,0) NOT NULL, 
	  LAYERVERSION NUMBER(10,0) NOT NULL, 
    ASSEMBLY NUMBER(10,0),
    CREATEDATE DATE NOT NULL, 
	  CREATERUSER VARCHAR2(30) NOT NULL, 
	  UPDATEDATE DATE NOT NULL, 
	  UPDATERUSER VARCHAR2(30) NOT NULL, 
    
	
	 CHECK ((ID<=2147483647)AND(ID>-2147483648)) ENABLE, 
	 CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)) ENABLE, 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)) ENABLE, 
	 CHECK ((ASSEMBLY<=2147483647)AND(ASSEMBLY>-2147483648)) ENABLE, 
  
   CONSTRAINT "PK_L_NS" PRIMARY KEY ("ID")
   )';
   
   EXECUTE IMMEDIATE 'CREATE INDEX L_NS_Layer ON Layers_NonSynchr(LayerRef)';
   EXECUTE IMMEDIATE 'CREATE INDEX L_NS_LayerVersion ON Layers_NonSynchr(LayerRef,LayerVersion)';
   
   EXECUTE IMMEDIATE 'GRANT ALL ON Layers_NonSynchr TO PUBLIC';
   
   EXECUTE IMMEDIATE 'INSERT INTO Layers_NonSynchr
    SELECT ID,INTFIELD00,INTFIELD01,INTFIELD02,
       CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER FROM
    LayerData WHERE LayerRef=(SELECT ID FROM Layers WHERE ALIAS=''..'')';

  EXECUTE IMMEDIATE 'UPDATE Layers SET TableName=''Layers_NonSynchr''
   WHERE ALIAS=''..''';

  END IF;
END;
/


CREATE OR REPLACE TRIGGER TR_L_NS_BI 
 BEFORE
  INSERT
 ON Layers_NonSynchr
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
begin
-- - - - - - - - - - - - -
-- BI_500
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;
/

CREATE OR REPLACE TRIGGER TR_L_NS_BU_500 before update on Layers_NonSynchr for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;
/



-- #########################################################
-- #########################################################
-- Add_Date_Extr_ED_Corr.sql
-- #########################################################
-- #########################################################

/*    Date_Extr ( )   ed_correctioncaption*/
ALTER TABLE ed_correctioncaption ADD (
  Date_Extr NUMBER
)
/
commit work 
/



-- #########################################################
-- #########################################################
-- Extend_FacialFinCaption_DocOsn.sql
-- #########################################################
-- #########################################################

/*    " "   FacialFinCaption  4000  */
ALTER TABLE TB_FacialFinCaption MODIFY (DocOsn VARCHAR2(4000))
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_MailMessages_autorization_fix.sql
-- #########################################################
-- #########################################################

/*     REMOTEMAILMESSAGES.
          */
-- ALTER TRIGGER TR_REMOTEMAILMESSAGES_BI_500
CREATE OR REPLACE TRIGGER TR_REMOTEMAILMESSAGES_BI
  BEFORE INSERT
  ON REMOTEMAILMESSAGES
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_REMOTEMAILMESSAGES_BI)
-- - - - - - - - - - - - -

  if (:new.ID is null) then select g_Shared.NextVal into :new.ID from dual; end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_REMOTEMAILMESSAGES_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := User;
  :new.UpdaterUser := User;

END;
/
-- ALTER TRIGGER TR_REMOTEMAILMESSAGES_BU_500
CREATE OR REPLACE TRIGGER TR_REMOTEMAILMESSAGES_BU_500
  BEFORE UPDATE
  ON REMOTEMAILMESSAGES
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_RemoteMailMessages_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := User;

END;
/
commit work
/
ALTER TRIGGER TR_REMOTEMAILMESSAGES_BU_500 DISABLE
/
update REMOTEMAILMESSAGES set
  CreaterUser = User
where
  CreaterUser is null
/
update REMOTEMAILMESSAGES set
  UpdaterUser = User
where
  UpdaterUser is null
/
update REMOTEMAILMESSAGES set
  UpdateDate = CreateDate
where
  UpdateDate is null
/
ALTER TRIGGER TR_REMOTEMAILMESSAGES_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- Add_FacFinCap_Index.sql
-- #########################################################
-- #########################################################

/* ,     DocumentDate  facialfincaption
*/
CREATE INDEX IDX_FACIALFINCAPTION_DOCDATE on TB_facialfincaption (DocumentDate)
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_SubKESR_add_KESR.sql
-- #########################################################
-- #########################################################

/*       .
            (32, 51) */
/*        " " (32, 51) */
CREATE OR REPLACE procedure GetDocumentKESR(OldSubKESR$ NUMBER,NewSubKESR$ NUMBER,
    NewKESR$ NUMBER,BudgetRef$ NUMBER,  KESR$ out NUMBER)
AS
BEGIN
  KESR$ := 0;
END;
/
grant execute on GetDocumentKESR to BUDGET_USERS
/
ALTER TABLE KESRSUBCODE ADD (
  KESR NUMBER(10)/*  */,
    CHECK((KESR<=2147483647)AND(KESR>-2147483648))
)
/
commit work
/
ALTER TRIGGER TR_KESRSUBCODE_BU_500 DISABLE
/
update KESRSUBCODE set
  KESR = 0
/
ALTER TRIGGER TR_KESRSUBCODE_BU_500 ENABLE
/
commit work
/
ALTER TABLE KESRSUBCODE ADD (
  CONSTRAINT FK_KESRSUBCODE_KESR FOREIGN KEY (KESR) REFERENCES KESR (ID)
)
/
CREATE INDEX FK_KESRSUBCODE_KESR ON KESRSUBCODE(KESR)
/
-- ALTER TRIGGER tr_kesrsubcode_bi_0
CREATE OR REPLACE TRIGGER TR_KESRSUBCODE_BI
  BEFORE INSERT
  ON KESRSUBCODE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KESRSUBCODE_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.KESR is null) then
    :new.KESR := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KESRSUBCODE_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;

END;
/
-- ALTER TRIGGER tr_kesrsubcode_bu_0
CREATE OR REPLACE TRIGGER TR_KESRSUBCODE_BU
  BEFORE UPDATE
  ON KESRSUBCODE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KESRSUBCODE_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.KESR is null) then
    :new.KESR := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
commit work
/
-- ALTER TRIGGER tr_BudgetData_bi
CREATE OR REPLACE TRIGGER TR_BUDGETDATA_BI
  BEFORE INSERT
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OrgRefByAcc1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  AutoKvrCorr1$ NUMBER(10);
  doubleUse$ NUMBER(10);
  BALBOFlag$ NUMBER(10);
  AllowDivideBA$ NUMBER(10);
  StimateKind$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDGETDATA_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (:new.id IS NULL) THEN 
    select g_shared.nextval into :new.id from dual;
  END IF;
  IF (:new.KFSR IS NULL) THEN  
    :new.KFSR := 0;
  END IF;
  IF (:new.KVSR IS NULL) THEN  
    :new.KVSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN  
    :new.KVR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN  
    :new.KCSR := 0;
  END IF;
  IF (:new.SubKESR IS NULL) THEN  
    :new.SubKESR := 0;
  END IF;
  IF (:new.RegionCLS IS NULL) THEN  
    :new.RegionCLS := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN 
    :new.DirectionCls := 0;
  END IF;
  IF (:new.FundsSource IS NULL) THEN 
    :new.FundsSource := 0;
  END IF;
  IF (:new.KD IS NULL) THEN 
    :new.KD := 0;
  END IF;
  IF (:new.subkd IS NULL) THEN 
    :new.subkd := 0;
  END IF;
  IF (:new.Fact IS NULL) THEN  
    :new.Fact := 0;
  END IF;
  IF (:new.FacialAcc_Cls IS NULL) THEN 
    :new.FacialAcc_Cls := 0;
  END IF;
  IF (:new.KVRCorr IS NULL) THEN 
    :new.KVRCorr := 0;
  END IF;
  IF (:new.KESRCorr IS NULL) THEN 
    :new.KESRCorr := 0;
  END IF;
  IF (:new.AssignmentKind IS NULL) THEN 
    :new.AssignmentKind := 0;
  END IF;
  IF (:new.Quarter1 IS NULL) THEN  
    :new.Quarter1 := 0;
  END IF;
  IF (:new.Quarter2 IS NULL) THEN  
    :new.Quarter2 := 0;
  END IF;
  IF (:new.Quarter3 IS NULL) THEN  
    :new.Quarter3 := 0;
  END IF;
  IF (:new.Quarter4 IS NULL) THEN  
    :new.Quarter4 := 0;
  END IF;
  IF (:new.DayPlanSumma IS NULL) THEN 
    :new.DayPlanSumma := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN  
    :new.FinType := 0;
  END IF;
  IF (:new.MeansType IS NULL) THEN 
    :new.MeansType := 0;
  END IF;
  IF (:new.DepartmentCls IS NULL) THEN 
    :new.DepartmentCls := 0;
  END IF;
  /*   .      */
  IF (:new.IFS IS NULL) THEN 
    :new.IFS := 0;
  END IF;
  IF (:new.BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
  BEGIN

    /*  .   */
    SELECT bn.BudgetRef      INTO :new.BudgetRef FROM BudNotify bn
    WHERE bn.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  IF (:new.Month01 IS NULL) THEN  
    :new.Month01 := 0;
  END IF;
  IF (:new.Month02 IS NULL) THEN  
    :new.Month02 := 0;
  END IF;
  IF (:new.Month03 IS NULL) THEN  
    :new.Month03 := 0;
  END IF;
  IF (:new.Month04 IS NULL) THEN  
    :new.Month04 := 0;
  END IF;
  IF (:new.Month05 IS NULL) THEN  
    :new.Month05 := 0;
  END IF;
  IF (:new.Month06 IS NULL) THEN  
    :new.Month06 := 0;
  END IF;
  IF (:new.Month07 IS NULL) THEN  
    :new.Month07 := 0;
  END IF;
  IF (:new.Month08 IS NULL) THEN  
    :new.Month08 := 0;
  END IF;
  IF (:new.Month09 IS NULL) THEN  
    :new.Month09 := 0;
  END IF;
  IF (:new.Month10 IS NULL) THEN  
    :new.Month10 := 0;
  END IF;
  IF (:new.Month11 IS NULL) THEN  
    :new.Month11 := 0;
  END IF;
  IF (:new.Month12 IS NULL) THEN  
    :new.Month12 := 0;
  END IF;
  IF (:new.SummaYear1 IS NULL) THEN  
    :new.SummaYear1 := 0;
  END IF;
  IF (:new.SummaYear2 IS NULL) THEN  
    :new.SummaYear2 := 0;
  END IF;
  IF (:new.SummaYear3 IS NULL) THEN  
    :new.SummaYear3 := 0;
  END IF;
  IF (:new.SummaYear4 IS NULL) THEN  
    :new.SummaYear4 := 0;
  END IF;
  IF (:new.SummaOtherYears IS NULL) THEN  
    :new.SummaOtherYears := 0; 
  END IF;
  BEGIN

    SELECT
    c.BA_LBO_FLAG
    INTO
    BALBOFlag$  FROM
    BudNotify c
    WHERE
    c.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*   */
  IF (:new.ProgIndex = 262) THEN
    GetIntConst(32, 43,StimateKind$);
    IF ((StimateKind$  = 0) OR (StimateKind$  IS NULL)) THEN
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
         
    ELSE
      IF (StimateKind$  = 1) THEN
        :new.Quarter1 := :new.SummaYear1;
             
      ELSE
        :new.Quarter1 := :new.Month01 + :new.Month02 +:new.Month03;
        :new.Quarter2 := :new.Month04 + :new.Month05 +:new.Month06;
        :new.Quarter3 := :new.Month07 + :new.Month08 +:new.Month09;
        :new.Quarter4 := :new.Month10 + :new.Month11 +:new.Month12;
        :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
             
      END IF; 
    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 260) THEN
    GetIntConst(32, 30,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 264) THEN
    GetIntConst(32, 34,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 32) THEN
    GetIntConst(32, 31,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*          ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 215) THEN
    GetIntConst(32, 35,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*         ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /* 
   IF ((NEW.TransfertOrg_Ref IS NULL) AND (NEW.REGIONCLS <> 0)) THEN
      SELECT Organizations FROM REGIONCLS
        WHERE NEW.REGIONCLS = ID
      INTO NEW.TransfertOrg_Ref;
  *//*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
  :new.targetcls,:new.targetcls);
  /*   */
  GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_10 (tr_BudgetData_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (:new.SenderID is null) then
    :new.SenderIDKey := -1;

  else
    :new.SenderIDKey := :new.SenderID;
  END IF;

  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_BUDGETDATA_BI_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if (:new.ClsType is NULL) then
    BEGIN
      select
      bn.ClsType
      into
      CapClsType1$     from
      BudNotify bn
      where
      bn.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (CapClsType1$  = 3) then
      if (:new.IFS <> 0) then
        :new.ClsType := 1; /*       ClsType */

      else
        if (:new.KD <> 0) then
          :new.ClsType := 2; /* */

        else
          :new.ClsType := 0; /* */
        END IF;
      END IF;
    else
      :new.ClsType := CapClsType1$;

    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.IFS <> 0)or(:new.KD <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  if (((:new.ClsType = 1)and(:new.KD <> 0))or((:new.ClsType = 2)and(:new.IFS <> 0))) then
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1) AND (:new.ClsType <> 2)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;
  IF (:new.ACC_REF IS NOT NULL) THEN /*    / */
    BEGIN
      SELECT oa.ORG_REF
      INTO OrgRefByAcc1$     FROM ORG_ACCOUNTS oa
      WHERE (oa.ID = :new.ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (:new.FacialAcc_CLS = 0) then
      :new.Org_Ref := OrgRefByAcc1$;

    END IF;
  END IF;
  /*  \ ,       \    \,  \ */
  if (:new.FacialAcc_CLS <> 0) then
    BEGIN
      SELECT
      fac.ORG_REF
      INTO :new.Org_Ref     FROM
      FacialACC_CLS fac
      WHERE
      (fac.ID = :new.FacialAcc_CLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (OrgRefByAcc1$<>:new.Org_Ref) then
      :new.ACC_REF := null;

    END IF;
  END IF;
  if ((:new.ProgIndex in (252, 253))and(:new.FacialAcc_CLS = 0)) then
    BEGIN
      SELECT
      bn.FacialAccCLS
      INTO :new.FacialAcc_CLS     FROM
      BudNotify bn
      WHERE
      (bn.ID = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_BUDGETDATA_BI_200)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*       32-, 260-, 261-, 262-  , 263-, 268-  , 252-. */
  if (:new.ProgIndex in (32, 252, 260, 261, 262, 263, 268)) then
    /*     (32  ())
             :
           =0     ,
           =1  ,
           =2   0  .*//*     260 ()
             :
           =2   0  .*/
    GetIntConst(32, 25,AutoKvrCorr1$);
    if (:new.ProgIndex = 32) then /*  ()*/
      if (AutoKvrCorr1$  = 0) then
        :new.KvrCorr := :new.Kvr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KvrCorr := 0;
        END IF;
      END IF;
      /* KESR   */
      if (AutoKvrCorr1$  = 0) then
        :new.KesrCorr := :new.Kesr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KesrCorr := 0;
        END IF;
      END IF;
    else
      if ((:new.ProgIndex = 260)and (AutoKvrCorr1$  = 2)) then  /* ()*/
        :new.KvrCorr := 0;
        --   ,    new.Kvr = 0;
        /* KESR   */

        :new.KesrCorr := 0;

      else
        :new.KvrCorr := :new.Kvr; /*         */
        /* KESR   */
        :new.KesrCorr := :new.Kesr;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDGETDATA_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

  Update BudNotify set
  DocChangeDate = :new.UpdateDate,
  RVersion = -1
  where id = :new.recordindex;

END;
/
-- ALTER TRIGGER tr_BudgetData_bu
CREATE OR REPLACE TRIGGER TR_BUDGETDATA_BU
  BEFORE UPDATE
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OrgRefByAcc1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  AutoKvrCorr1$ NUMBER(10);
  doubleUse$ NUMBER(10);
  BALBOFlag$ NUMBER(10);
  AllowDivideBA$ NUMBER(10);
  StimateKind$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDGETDATA_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (:new.KFSR IS NULL) THEN  
    :new.KFSR := 0;
  END IF;
  IF (:new.KVSR IS NULL) THEN  
    :new.KVSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN  
    :new.KVR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN  
    :new.KCSR := 0;
  END IF;
  IF (:new.SubKESR IS NULL) THEN  
    :new.SubKESR := 0;
  END IF;
  IF (:new.RegionCLS IS NULL) THEN  
    :new.RegionCLS := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN 
    :new.DirectionCls := 0;
  END IF;
  IF (:new.FundsSource IS NULL) THEN 
    :new.FundsSource := 0;
  END IF;
  IF (:new.KD IS NULL) THEN 
    :new.KD := 0;
  END IF;
  IF (:new.subkd IS NULL) THEN 
    :new.subkd := 0;
  END IF;
  IF (:new.Fact IS NULL) THEN  
    :new.Fact := 0;
  END IF;
  IF (:new.FacialAcc_Cls IS NULL) THEN 
    :new.FacialAcc_Cls := 0;
  END IF;
  IF (:new.KVRCorr IS NULL) THEN 
    :new.KVRCorr := 0;
  END IF;
  IF (:new.KesrCorr IS NULL) THEN 
    :new.KesrCorr := 0;
  END IF;
  IF (:new.AssignmentKind IS NULL) THEN 
    :new.AssignmentKind := 0;
  END IF;
  IF (:new.Quarter1 IS NULL) THEN  
    :new.Quarter1 := 0;
  END IF;
  IF (:new.Quarter2 IS NULL) THEN  
    :new.Quarter2 := 0;
  END IF;
  IF (:new.Quarter3 IS NULL) THEN  
    :new.Quarter3 := 0;
  END IF;
  IF (:new.Quarter4 IS NULL) THEN  
    :new.Quarter4 := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN  
    :new.FinType := 0;
  END IF;
  IF (:new.MeansType IS NULL) THEN  
    :new.MeansType := 0;
  END IF;
  IF (:new.DepartmentCls IS NULL) THEN 
    :new.DepartmentCls := 0;
  END IF;
  /*   .        */
  IF (:new.IFS IS NULL) THEN 
    :new.IFS := 0;
  END IF;
  IF (:new.BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
  IF (:new.Month01 IS NULL) THEN  
    :new.Month01 := 0;
  END IF;
  IF (:new.Month02 IS NULL) THEN  
    :new.Month02 := 0;
  END IF;
  IF (:new.Month03 IS NULL) THEN  
    :new.Month03 := 0;
  END IF;
  IF (:new.Month04 IS NULL) THEN  
    :new.Month04 := 0;
  END IF;
  IF (:new.Month05 IS NULL) THEN  
    :new.Month05 := 0;
  END IF;
  IF (:new.Month06 IS NULL) THEN  
    :new.Month06 := 0;
  END IF;
  IF (:new.Month07 IS NULL) THEN  
    :new.Month07 := 0;
  END IF;
  IF (:new.Month08 IS NULL) THEN  
    :new.Month08 := 0;
  END IF;
  IF (:new.Month09 IS NULL) THEN  
    :new.Month09 := 0;
  END IF;
  IF (:new.Month10 IS NULL) THEN  
    :new.Month10 := 0;
  END IF;
  IF (:new.Month11 IS NULL) THEN  
    :new.Month11 := 0;
  END IF;
  IF (:new.Month12 IS NULL) THEN  
    :new.Month12 := 0;
  END IF;
  IF (:new.SummaYear1 IS NULL) THEN  
    :new.SummaYear1 := 0;
  END IF;
  IF (:new.SummaYear2 IS NULL) THEN  
    :new.SummaYear2 := 0;
  END IF;
  IF (:new.SummaYear3 IS NULL) THEN  
    :new.SummaYear3 := 0;
  END IF;
  IF (:new.SummaYear4 IS NULL) THEN  
    :new.SummaYear4 := 0;
  END IF;
  IF (:new.SummaOtherYears IS NULL) THEN  
    :new.SummaOtherYears := 0; 
  END IF;
  IF (:new.DayPlanSumma IS NULL) THEN 
    :new.DayPlanSumma := 0;
  END IF;
  /*     */
  IF (:new.BudgetRef <> :old.BudgetRef) THEN
    IF ( NOT((:new.BudgetRef IS NULL) AND (:old.BudgetRef IS NULL)) ) THEN
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  BEGIN

    SELECT
    c.BA_LBO_FLAG
    INTO
    BALBOFlag$  FROM
    BudNotify c
    WHERE
    c.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*   */
  IF (:new.ProgIndex = 262) THEN
    GetIntConst(32, 43,StimateKind$);
    IF ((StimateKind$  = 0) OR (StimateKind$  IS NULL)) THEN
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
         
    ELSE
      IF (StimateKind$  = 1) THEN
        :new.Quarter1 := :new.SummaYear1;
             
      ELSE
        :new.Quarter1 := :new.Month01 + :new.Month02 +:new.Month03;
        :new.Quarter2 := :new.Month04 + :new.Month05 +:new.Month06;
        :new.Quarter3 := :new.Month07 + :new.Month08 +:new.Month09;
        :new.Quarter4 := :new.Month10 + :new.Month11 +:new.Month12;
        :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
             
      END IF; 
    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 260) THEN
    GetIntConst(32, 30,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 264) THEN
    GetIntConst(32, 34,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 32) THEN
    GetIntConst(32, 31,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*          ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 215) THEN
    GetIntConst(32, 35,doubleUse$);
    GetIntConst(32, 40,AllowDivideBA$);
    IF ((doubleUse$=1) AND ((BALBOFlag$  <> 1) OR (AllowDivideBA$ = 1))) THEN  /*         ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;
     
    END IF;
  END IF;
  /* 
   IF ((NEW.TransfertOrg_Ref IS NULL) AND (NEW.REGIONCLS <> 0)) THEN
       SELECT Organizations FROM REGIONCLS
         WHERE NEW.REGIONCLS = ID
       INTO NEW.TransfertOrg_Ref;
  *//*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.meanstype, :new.meanstype,
  :new.targetcls,:new.targetcls);
  /*   */
  GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BU_100 (TR_BUDGETDATA_BU_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if (:new.ClsType is NULL) then
    BEGIN
      select
      bn.ClsType
      into
      CapClsType1$     from
      BudNotify bn
      where
      bn.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (CapClsType1$  = 3) then
      if (:new.IFS <> 0) then
        :new.ClsType := 1; /*       ClsType */

      else
        if (:new.KD <> 0) then
          :new.ClsType := 2; /* */

        else
          :new.ClsType := 0; /* */
        END IF;
      END IF;
    else
      :new.ClsType := CapClsType1$;

    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.IFS <> 0)or(:new.KD <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  if (((:new.ClsType = 1)and(:new.KD <> 0))or((:new.ClsType = 2)and(:new.IFS <> 0))) then
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1) AND (:new.ClsType <> 2)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;
  IF (:new.ACC_REF IS NOT NULL) THEN /*    / */
    BEGIN
      SELECT oa.ORG_REF
      INTO OrgRefByAcc1$     FROM ORG_ACCOUNTS oa
      WHERE (oa.ID = :new.ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (:new.FacialAcc_CLS = 0) then
      :new.Org_Ref := OrgRefByAcc1$;

    END IF;
  END IF;
  /*  \ ,       \    \,  \ */
  if (:new.FacialAcc_CLS <> 0) then
    BEGIN
      SELECT
      fac.ORG_REF
      INTO :new.Org_Ref     FROM
      FacialACC_CLS fac
      WHERE
      (fac.ID = :new.FacialAcc_CLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (OrgRefByAcc1$<>:new.Org_Ref) then
      :new.ACC_REF := null;

    END IF;
  END IF;
  if ((:new.ProgIndex in (252, 253))and(:new.FacialAcc_CLS = 0)) then
    BEGIN
      SELECT
      bn.FacialAccCLS
      INTO :new.FacialAcc_CLS     FROM
      BudNotify bn
      WHERE
      (bn.ID = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDGETDATA_BU_200)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*       32-, 260-, 261-, 262-  , 263-, 268-  , 252-. */
  if (:new.ProgIndex in (32, 252, 260, 261, 262, 263, 268)) then
    /*     (32  ())
             :
           =0     ,
           =1  ,
           =2   0  .*//*     260 ()
             :
           =2   0  .*/
    GetIntConst(32, 25,AutoKvrCorr1$);
    if (:new.ProgIndex = 32) then /*  ()*/
      if (AutoKvrCorr1$  = 0) then
        :new.KvrCorr := :new.Kvr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KvrCorr := 0;
        END IF;
      END IF;
      /* KESR   */
      if (AutoKvrCorr1$  = 0) then
        :new.KesrCorr := :new.Kesr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KesrCorr := 0;
        END IF;
      END IF;
    else
      if ((:new.ProgIndex = 260)and (AutoKvrCorr1$  = 2)) then  /* ()*/
        :new.KvrCorr := 0;
        --   ,    new.Kvr = 0;
        /* KESR   */

        :new.KesrCorr := 0;

      else
        :new.KvrCorr := :new.Kvr; /*         */
        /* KESR   */
        :new.KesrCorr := :new.Kesr;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDGETDATA_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (:NEW.RVersion IS NULL) THEN
     :NEW.RVersion := 1;
  ELSIF ((:NEW.RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
     :NEW.RVersion := :OLD.RVersion;
  ELSE
     :NEW.RVersion := :OLD.RVersion + 1;
  END IF;

END;
/
-- ALTER TRIGGER tr_LimitFinDetail_bi
CREATE OR REPLACE TRIGGER TR_LIMITFINDETAIL_BI
  BEFORE INSERT
  ON LIMITFINDETAIL
  FOR EACH ROW
DECLARE
  DFAcc1$ NUMBER(10);
  SFacialAcc1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_LIMITFINDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  (   ) */
  if ((:new.ProgIndex = 56) and ((:new.DFAccount is null) or (:new.SourceFacialAcc is null))) then
    BEGIN
      select
      DFAccount, SourceFacialAcc
      into
      DFAcc1$, SFacialAcc1$     from
      RequestFinCaption
      where
      (id = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (:new.DFAccount is null) then 
      :new.DFAccount := DFAcc1$;
    END IF;
    if (:new.SourceFacialAcc is null) then 
      :new.SourceFacialAcc := SFacialAcc1$;
      
    END IF;
  END IF;
  /*     */
  if ((:new.ProgIndex = 57) and ((:new.DFAccount is null) or (:new.SourceFacialAcc is null))) then
    BEGIN
      select
      DFAccount, SourceFacialAcc
      into
      DFAcc1$, SFacialAcc1$     from
      LimitNotifyCaption
      where
      (id = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (:new.DFAccount is null) then 
      :new.DFAccount := DFAcc1$;
    END IF;
    if (:new.SourceFacialAcc is null) then 
      :new.SourceFacialAcc := SFacialAcc1$;
      
    END IF;
  END IF;
  BEGIN
    /*        , */
    select
    AcceptDate
    into
    :new.AcceptDate   from
    LimitNotifyCaption
    where
    (id = :new.RecordIndex)
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /* 1 - ., 2 - ., 3 -  . */
  if (:new.RequestFlag is null) then 
    :new.RequestFlag := 3;
  END IF;
  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
      
  if (:new.AcceptDate is not null)
  then 
    if((:new.RequestFlag=3)and(:new.AcceptSumma=0))then 
      :new.AcceptSumma:= :new.Summa;
    END IF;
    if(:new.RequestFlag=3)then 
      :new.RequestFlag:= 2; 
     
    END IF;
  END IF;
   
  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.SubKESR is null) then 
    :new.SubKESR := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  /*     */
  IF (:new.FundsSource IS NULL) THEN 
    :new.FundsSource := 0;
  END IF;
  if (:new.FacialAcc is null) then 
    :new.FacialAcc := 0;
  END IF;
  if (:new.RegionCLS is null) then
    BEGIN
      select fac.RegionCLS       into :new.regioncls from facialacc_cls fac
      where fac.id = :new.facialacc
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.FinSource is null) then 
    :new.FinSource := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.Fact is null) then  
    :new.Fact := 0;
  END IF;
  if (:new.DocTypes is null) then 
    :new.DocTypes := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.SourceFacialAcc is null) then 
    :new.SourceFacialAcc := 0;
  END IF;
  /*   .     */
  if (:new.IFS is null) then 
    :new.IFS := 0;
  END IF;
  if (:new.BuhOperationCLS is null)
  then 
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
    
  /*  .    ,    */
  if ((:new.BudgetRef is null) or (:new.BudgetRef = 0)) then
    BEGIN
      select lim.BudgetRef         into :new.BudgetRef from LimitFinCaption lim
      where lim.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,     */
  if ((:new.BudgetRef is null) or (:new.BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into :new.BudgetRef from FacialAcc_Cls fa
      where fa.Id = :new.FacialAcc
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*  ,    */
  if ((:new.BudgetRef is null) or (:new.BudgetRef = 0))
  then 
    GetIntConst(-1, 3,:new.BudgetRef);
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
  :new.targetcls,:new.targetcls); 
  /*   */
  GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_100 (TR_LIMITFINDETAIL_BI_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((:new.ClsType is NULL) and (:new.IFS <> 0)) then
    :new.ClsType := 1; /*       ClsType */

  else
    if (:new.ClsType is null) then
      :new.ClsType := 0; /*  -  */
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND (:new.IFS <> 0)) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType = 1) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_LIMITFINDETAIL_BI_500)
-- Last update 29.06.2005
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
-- ALTER TRIGGER tr_LimitFinDetail_bu
CREATE OR REPLACE TRIGGER TR_LIMITFINDETAIL_BU
  BEFORE UPDATE
  ON LIMITFINDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_LIMITFINDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.SubKESR is null) then  
    :new.SubKESR := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  /*     */
  IF (:new.FundsSource IS NULL) THEN 
    :new.FundsSource := 0;
  END IF;

  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
  if (:new.RequestFlag is null) then 
    :new.RequestFlag := 3; /* 1 - ., 2 - ., 3 -  . */
  END IF;
  if (:new.FacialAcc is null) then 
    :new.FacialAcc := 0;
  END IF;
  if (:new.RegionCLS is null) then
    BEGIN
      select fac.RegionCLS       into :new.regioncls from facialacc_cls fac
      where fac.id = :new.facialacc
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.FINSOURCE is null) then 
    :new.FINSOURCE := 0;
  END IF;
  if (:new.FINType is null) then 
    :new.FINType := 0;
  END IF;
  if (:new.Fact is null) then  
    :new.Fact := 0;
  END IF;
  if (:new.DocTypes is null) then 
    :new.DocTypes := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.SourceFacialAcc is null) then 
    :new.SourceFacialAcc := 0;
  END IF;
   
  /* ----*/
  /*   .     */
  if (:new.IFS is null) then 
    :new.IFS := 0;
  END IF;
  if (:new.BuhOperationCLS is null)
  then 
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
  /*     */
  if (:new.BudgetRef <> :old.BudgetRef) then
    if ( not((:new.BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.meanstype, :new.meanstype,
  :new.targetcls,:new.targetcls);    
  /*   */
  GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BU_10 (TR_LIMITFINDETAIL_BU_10)
-- Last update 14.02.2006
-- - - - - - - - - - - - -

  if ((:new.AcceptDate is null) and (:old.AcceptDate is not null)) then
    if ((:new.RequestFlag=2) and (:new.AcceptSumma = :new.Summa)) then :new.AcceptSumma := 0; end if;
    if (:new.RequestFlag=2) then :new.RequestFlag := 3; end if;
  end if;

  if ((:new.AcceptDate is not null) and (:new.RequestFlag = 3)) then
    :new.RequestFlag := 2;
  end if;
  if ((:new.AcceptDate is not null) and (:new.RequestFlag = 2) and (:new.AcceptSumma = 0)) then
     :new.AcceptSumma := :new.Summa;
  end if;

-- - - - - - - - - - - - -
-- BU_100 (TR_LIMITFINDETAIL_BU_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((:new.ClsType is NULL) and (:new.IFS <> 0)) then
    :new.ClsType := 1; /*       ClsType */

  else
    if (:new.ClsType is null) then
      :new.ClsType := 0; /*  -  */
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND (:new.IFS <> 0)) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType = 1) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_LIMITFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (:NEW.RVersion IS NULL) THEN
      :NEW.RVersion := 1;
   ELSIF ((:NEW.RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      :NEW.RVersion := :OLD.RVersion;
   ELSE
      :NEW.RVersion := :OLD.RVersion + 1;
   END IF;

END;
/
-- ALTER TRIGGER tr_FacialFinDetail_bi_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CapBuhOperationCLS$ NUMBER(10);
  CapClsType$ NUMBER(10);
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  i_fintype1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Last update 12.01.2009
-- - - - - - - - - - - - -

 /*  ,    */
   BEGIN

     select
       ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate,
       ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
     into new$BudgetRef, CapBuhOperationCls$, CapClsType$, CapAcceptDate$,
       new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause
     from
       FacialFinCaption ffc
     where
       ffc.id = new$RecordIndex;

   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       new$BudgetRef := NULL;
       CapBuhOperationCls$ := NULL;
       CapClsType$ := NULL;
       CapAcceptDate$ := NULL;
   END;

   /*      */
   if (new$BuhOperationCls is null) then new$BuhOperationCls := CapBuhOperationCls$; end if;

   /*      */
   if (new$ClsType is null) then new$ClsType := CapClsType$; end if;

   if (new$DestClsType is null) then new$DestClsType := new$ClsType; end if;

   /*      */
   if (new$AcceptDate is null) then new$AcceptDate := CapAcceptDate$; end if;

   /*      */
   if ((new$SourceFacialAcc_CLS is null) or (new$DestFacialAcc_CLS is null)) then
     BEGIN
       select SourceFacialAcc_CLS, DestFacialAcc_CLS
         into SourceFacialAcc_CLS$, DestFacialAcc_CLS$
       from FacialFinCaption
       where new$RecordIndex = id;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         SourceFacialAcc_CLS$ := NULL;
         DestFacialAcc_CLS$ := NULL;
     END;

     if (new$SourceFacialAcc_CLS is null) then new$SourceFacialAcc_CLS := SourceFacialAcc_CLS$; end if;
     if (new$DestFacialAcc_CLS is null) then new$DestFacialAcc_CLS := DestFacialAcc_CLS$; end if;
   end if;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);
  /*      */
  GetDocumentKESR(null, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(null, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER tr_FacialFinDetail_bu_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls1$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls1$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls1$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls1$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls1$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Create 20.02.2006
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select c.AcceptDate into CapAcceptDate$
      from facialfincaption c
      where c.id = new$RecordIndex;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        CapAcceptDate$ := NULL;
    END;

    if ((new$AcceptDate = CapAcceptDate$) or (CapAcceptDate$ is null)) then
      new$AcceptDate := new$AcceptDate;
    else
      RaiseException('ex_wrongacceptdate');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER TR_PAYMENTSCHEDULE_BI
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  Tmp1$ NUMBER(10);
  AdjDocNum1$ NUMBER(10);
  InnerNumber_parent1$ NUMBER(10);
  InnerNumber_child1$ NUMBER(10);
  PreviousInner1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum 
        into PreviousInner1$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum 
        into PreviousInner1$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner1$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner1$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/

  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from PaymentSchedule
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;

  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;

  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    /*       (    )*/
    new$ParentNumber := null;

  else
    /*      -    */
    select count(ID), max(ANumber)
    into Tmp1$, AdjDocNum1$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp1$ = 0) then
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp1$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$ParentNumber := AdjDocNum1$;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child1$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent1$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent1$ <> InnerNumber_child1$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');
      END IF;
    else
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child1$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent1$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent1$ <> InnerNumber_child1$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    OLDNUMBER,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$OLDNUMBER,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_PAYMENTSCHEDULE_BU
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.Reject_Cls ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    OLDNUMBER = new$OLDNUMBER,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER TR_TENDERPRODUCT_BI
CREATE OR REPLACE TRIGGER TR_TENDERPRODUCT_BI
  BEFORE INSERT
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  PosNumber$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERPRODUCT_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.SubKESR is null) then 
    :new.SubKESR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.FinSourceCls is null) then 
    :new.FinSourceCls := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.TenderObjectCls is null) then 
    :new.TenderObjectCls := 0;
  END IF;
  if (:new.FactCls is null) then 
    :new.FactCls := 0;
  END IF;
  if (:new.OKATO is null) then 
    :new.OKATO := 0;
  END IF;
  if (:new.MeansTypeCls is null) then 
    :new.MeansTypeCls := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.AcceptPrice is null) then 
    :new.AcceptPrice := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  if (:new.AcceptAmount is null) then 
    :new.AcceptAmount := 0;
  END IF;
  if (:new.AcceptMonth01 is null) then 
    :new.AcceptMonth01 := 0;
  END IF;
  if (:new.AcceptMonth02 is null) then 
    :new.AcceptMonth02 := 0;
  END IF;
  if (:new.AcceptMonth03 is null) then 
    :new.AcceptMonth03 := 0;
  END IF;
  if (:new.AcceptMonth04 is null) then 
    :new.AcceptMonth04 := 0;
  END IF;
  if (:new.AcceptMonth05 is null) then 
    :new.AcceptMonth05 := 0;
  END IF;
  if (:new.AcceptMonth06 is null) then 
    :new.AcceptMonth06 := 0;
  END IF;
  if (:new.AcceptMonth07 is null) then 
    :new.AcceptMonth07 := 0;
  END IF;
  if (:new.AcceptMonth08 is null) then 
    :new.AcceptMonth08 := 0;
  END IF;
  if (:new.AcceptMonth09 is null) then 
    :new.AcceptMonth09 := 0;
  END IF;
  if (:new.AcceptMonth10 is null) then 
    :new.AcceptMonth10 := 0;
  END IF;
  if (:new.AcceptMonth11 is null) then 
    :new.AcceptMonth11 := 0;
  END IF;
  if (:new.AcceptMonth12 is null) then 
    :new.AcceptMonth12 := 0;
  END IF;
  if (:new.AcceptQuarter1 is null) then 
    :new.AcceptQuarter1 := 0;
  END IF;
  if (:new.AcceptQuarter2 is null) then 
    :new.AcceptQuarter2 := 0;
  END IF;
  if (:new.AcceptQuarter3 is null) then 
    :new.AcceptQuarter3 := 0;
  END IF;
  if (:new.AcceptQuarter4 is null) then 
    :new.AcceptQuarter4 := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
  if (:new.DeliverySpec is null) then 
    :new.DeliverySpec := 0;
  END IF;
  if (:new.DeliveryPeriod is null) then 
    :new.DeliveryPeriod := 0;
  END IF;
  if (:new.DeliveryAmount is null) then 
    :new.DeliveryAmount := 0;
  END IF;
  if (:new.VatPercent is null) then 
    :new.VatPercent := 0;
  END IF;
  if (:new.AcceptVatSumma is null) then 
    :new.AcceptVatSumma := 0;
  END IF;
  if (:new.AcceptCost is null) then 
    :new.AcceptCost := 0;
  END IF;
  if (:new.AcceptTotalSumma is null) then 
    :new.AcceptTotalSumma := 0;
  END IF;
  if (:new.Equivalent is null) then 
    :new.Equivalent := 0;
  END IF;
  if (:new.SummaYear2 is null) then 
    :new.SummaYear2 := 0;
  END IF;
  if (:new.SummaYear3 is null) then 
    :new.SummaYear3 := 0;
  END IF;
  if (:new.SummaOtherYears is null) then 
    :new.SummaOtherYears := 0;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.MEANSTYPECLS,
  :new.targetcls,:new.targetcls); 
  /*   */
  GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERPRODUCT_BI_10)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

    /*   1.2 */
   IF (:NEW.FacialAccCls IS NULL) THEN :NEW.FacialAccCls := 0; END IF;

   /*  .  ,     */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      BEGIN
         SELECT fa.BudgetRef
           INTO :NEW.BudgetRef
           FROM FacialAcc_Cls fa
          WHERE fa.ID = :NEW.FacialAccCls;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            :NEW.BudgetRef := NULL;
      END;
   END IF;

   /*  ,    */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      GetIntConst (-1, 3, :NEW.BudgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_TENDERPRODUCT_BI_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.PositionNumber is null) then
    select Max(PositionNumber)     INTO PosNumber$ from TenderProduct
    where (RecordIndex = :new.RecordIndex) and (ProgIndex = :new.ProgIndex)
    ;
    if (PosNumber$ is null) then
      PosNumber$ := 0;
    END IF;
    :new.PositionNumber := PosNumber$ + 1;

  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERPRODUCT_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then
    :new.senderIdKey := -1;

  else
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_410 (TR_TENDERPRODUCT_BI_410)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  FOR REC$1 IN (SELECT tl.ID  AS lotref FROM TenderLot tl WHERE (tl.ID = :new.LotRef) AND (tl.RecordIndex = :new.RecordIndex)   )
  LOOP
    if (not ((REC$1.lotref  = :new.LotRef) or (:new.lotref is null))) then
      RaiseException('EX_TEN_UNKNOWNLOT');
    END IF;
  END LOOP;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERPRODUCT_BI_500)
-- Last update 18.04.2006
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
-- ALTER TRIGGER TR_TENDERPRODUCT_BU_0
CREATE OR REPLACE TRIGGER TR_TENDERPRODUCT_BU
  BEFORE UPDATE
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  PosNumber$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERPRODUCT_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;
  END IF;
  if (:new.SubKESR is null) then 
    :new.SubKESR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.FinSourceCls is null) then 
    :new.FinSourceCls := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.TenderObjectCls is null) then 
    :new.TenderObjectCls := 0;
  END IF;
  if (:new.FactCls is null) then 
    :new.FactCls := 0;
  END IF;
  if (:new.OKATO is null) then 
    :new.OKATO := 0;
  END IF;
  if (:new.MeansTypeCls is null) then 
    :new.MeansTypeCls := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.AcceptPrice is null) then 
    :new.AcceptPrice := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  if (:new.AcceptAmount is null) then 
    :new.AcceptAmount := 0;
  END IF;
  if (:new.AcceptMonth01 is null) then 
    :new.AcceptMonth01 := 0;
  END IF;
  if (:new.AcceptMonth02 is null) then 
    :new.AcceptMonth02 := 0;
  END IF;
  if (:new.AcceptMonth03 is null) then 
    :new.AcceptMonth03 := 0;
  END IF;
  if (:new.AcceptMonth04 is null) then 
    :new.AcceptMonth04 := 0;
  END IF;
  if (:new.AcceptMonth05 is null) then 
    :new.AcceptMonth05 := 0;
  END IF;
  if (:new.AcceptMonth06 is null) then 
    :new.AcceptMonth06 := 0;
  END IF;
  if (:new.AcceptMonth07 is null) then 
    :new.AcceptMonth07 := 0;
  END IF;
  if (:new.AcceptMonth08 is null) then 
    :new.AcceptMonth08 := 0;
  END IF;
  if (:new.AcceptMonth09 is null) then 
    :new.AcceptMonth09 := 0;
  END IF;
  if (:new.AcceptMonth10 is null) then 
    :new.AcceptMonth10 := 0;
  END IF;
  if (:new.AcceptMonth11 is null) then 
    :new.AcceptMonth11 := 0;
  END IF;
  if (:new.AcceptMonth12 is null) then 
    :new.AcceptMonth12 := 0;
  END IF;
  if (:new.AcceptQuarter1 is null) then 
    :new.AcceptQuarter1 := 0;
  END IF;
  if (:new.AcceptQuarter2 is null) then 
    :new.AcceptQuarter2 := 0;
  END IF;
  if (:new.AcceptQuarter3 is null) then 
    :new.AcceptQuarter3 := 0;
  END IF;
  if (:new.AcceptQuarter4 is null) then 
    :new.AcceptQuarter4 := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
  if (:new.DeliverySpec is null) then 
    :new.DeliverySpec := 0;
  END IF;
  if (:new.DeliveryPeriod is null) then 
    :new.DeliveryPeriod := 0;
  END IF;
  if (:new.DeliveryAmount is null) then 
    :new.DeliveryAmount := 0;
  END IF;
  if (:new.VatPercent is null) then 
    :new.VatPercent := 0;
  END IF;
  if (:new.AcceptVatSumma is null) then 
    :new.AcceptVatSumma := 0;
  END IF;
  if (:new.AcceptCost is null) then 
    :new.AcceptCost := 0;
  END IF;
  if (:new.AcceptTotalSumma is null) then 
    :new.AcceptTotalSumma := 0;
  END IF;
  if (:new.Equivalent is null) then 
    :new.Equivalent := 0;    
  END IF;
  if (:new.SummaYear2 is null) then 
    :new.SummaYear2 := 0;
  END IF;
  if (:new.SummaYear3 is null) then 
    :new.SummaYear3 := 0;
  END IF;
  if (:new.SummaOtherYears is null) then 
    :new.SummaOtherYears := 0;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.MEANSTYPECLS, :new.MEANSTYPECLS,
  :new.targetcls,:new.targetcls);   
  /*   */
  GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BU_20 (TR_TENDERPRODUCT_BU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.PositionNumber is null) then
    select Max(PositionNumber)     INTO PosNumber$ from TenderProduct
    where (RecordIndex = :new.RecordIndex) and (ProgIndex = :new.ProgIndex)
    ;
    if (PosNumber$ is null) then
      PosNumber$ := 0;
    END IF;
    :new.PositionNumber := PosNumber$ + 1;

  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_TenderProduct_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_410 (TR_TENDERPRODUCT_BU_410)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  FOR REC$1 IN (SELECT tl.ID  AS lotref FROM TenderLot tl WHERE (tl.ID = :new.LotRef) AND (tl.RecordIndex = :new.RecordIndex)   )
  LOOP
    if (not ((REC$1.lotref  = :new.LotRef) or (:new.lotref is null))) then
      RaiseException('EX_TEN_UNKNOWNLOT');
    END IF;
  END LOOP;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERPRODUCT_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

  if (:New.RVersion is null) then
    :New.RVersion := 1;
  elsif ((:New.RVersion = -1) and (:Old.RVersion <> -1)) then
    :New.RVersion := :Old.RVersion;
  else
    :New.RVersion := :Old.RVersion + 1;
  end if;

END;
/
-- ALTER TRIGGER tr_CorrectionDetail_bi
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  BEGIN

    /*  ,    */
    select
    CorCap.BudgetRef
    into new$BudgetRef   from
    correctioncaption CorCap
    where
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER tr_CorrectionDetail_bu
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_IU
  INSTEAD OF UPDATE
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CORRECTIONDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  /*     \*/
  IF ((new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType IS NULL)) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  ON (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);    
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_100 (tr_correctiondetail_bu_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$buhoperationcls <> :old.buhoperationcls) and (new$progindex = 316)) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_CORRECTIONDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_CORRECTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise )) and
    (new$BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /*  BudgetPromise    Promise=NULL,   Promise */
    if (new$Promise is null and ((new$BudgetPromise is not null and :old.BudgetPromise is null) or
    (new$BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;

    /*  BudgetPromise -   Promise */
    if ((new$BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      new$Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((new$Promise is null) and (:old.Promise is not null)) then
      new$BudgetPromise := null;
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_CORRECTIONDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null and (
    (:old.Promise is null or :old.Promise <> new$Promise) or
    (:old.ExecDoc is null or new$ExecDoc is null or :old.ExecDoc <> new$ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$ExecDoc is null or :old.ExecDoc is null or new$ExecDoc <> :old.ExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_CORRECTIONDETAIL_BU_700)
-- Create 13.08.2007
-- - - - - - - - - - - - -

 if (new$RVersion is null) then
   new$RVersion:=1;
 else
   if ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
     new$RVersion:=:Old.RVersion;
   else
     new$RVersion:=:Old.RVersion+1;
   end if;
 end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_CORRECTIONDETAIL SET
    ID = new$ID,
    PARENTID = new$PARENTID,
    BUDGETREF = new$BUDGETREF,
    SUMMA = new$SUMMA,
    CLSTYPE = new$CLSTYPE,
    FACIALACC_CLS = new$FACIALACC_CLS,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    MEANSTYPE = new$MEANSTYPE,
    FACT = new$FACT,
    REGIONCLS = new$REGIONCLS,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    DOCTYPE = new$DOCTYPE,
    SUBKESR = new$SUBKESR,
    FUNDSSOURCE = new$FUNDSSOURCE,
    KD = new$KD,
    IFS = new$IFS,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CHANGEACC_REF = new$CHANGEACC_REF,
    CHANGEACC = new$CHANGEACC,
    CHANGEORGINN = new$CHANGEORGINN,
    CHANGEORGINN20 = new$CHANGEORGINN20,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    DOCUMENTPROGINDEX = new$DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX = new$DOCUMENTRECORDINDEX,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    RVERSION = new$RVERSION,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    NOTE = new$NOTE,
    ISCLSCHANGED = new$ISCLSCHANGED,
    PROMISE = new$PROMISE,
    BUDGETPROMISE = new$BUDGETPROMISE,
    EXECDOC = new$EXECDOC,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    TRANSFERTCLS = new$TRANSFERTCLS,
    ORIGINALCLSSUMMA = new$ORIGINALCLSSUMMA,
    NOTECLS = new$NOTECLS,
    OPERATIONTYPE = new$OPERATIONTYPE,
    REVERSEFLAG = new$REVERSEFLAG,
    EXECINNERNUMBER = new$EXECINNERNUMBER,
    CLSFIELFCHANGED = new$CLSFIELFCHANGED,
    FAORGTYPE = new$FAORGTYPE,
    SUBSIDYCLS = new$SUBSIDYCLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    NOTEQUALEX = new$NOTEQUALEX,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    INVESTOBJECT = new$INVESTOBJECT,
    CHANGEORGNAME = new$CHANGEORGNAME,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_CORRECTIONDETAIL_AU_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (5504, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=5504) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER tr_WritExecutionDetail_bi
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONDETAIL_BI
  BEFORE INSERT
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  ScheduleRef1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_WRITEXECUTIONDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then
    BEGIN
      select 
      writ_c.BudgetRef 
      into :new.BudgetRef     from 
      WritExecutionCaption writ_c
      where 
      writ_c.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
    
  if (:new.Progindex is null) then 
    :new.Progindex := 556;  
  END IF;
  if (:new.FacialAcc_Cls is null) then 
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then 
    :new.Fact := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.RegionCLS is null) then 
    :new.RegionCLS := 0;
  END IF;
  if (:new.Finsource is null) then 
    :new.Finsource := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.DocType is null) then 
    :new.DocType := 0;
  END IF;
  if (:new.SubKesr is null) then 
    :new.SubKesr := 0;
  END IF;
    
  if (:new.Month01 IS NULL) then  
    :new.Month01 := 0;
  END IF;
  if (:new.Month02 IS NULL) then  
    :new.Month02 := 0;
  END IF;
  if (:new.Month03 IS NULL) then  
    :new.Month03 := 0;
  END IF;
  if (:new.Month04 IS NULL) then  
    :new.Month04 := 0;
  END IF;
  if (:new.Month05 IS NULL) then  
    :new.Month05 := 0;
  END IF;
  if (:new.Month06 IS NULL) then  
    :new.Month06 := 0;
  END IF;
  if (:new.Month07 IS NULL) then  
    :new.Month07 := 0;
  END IF;
  if (:new.Month08 IS NULL) then  
    :new.Month08 := 0;
  END IF;
  if (:new.Month09 IS NULL) then  
    :new.Month09 := 0;
  END IF;
  if (:new.Month10 IS NULL) then  
    :new.Month10 := 0;
  END IF;
  if (:new.Month11 IS NULL) then  
    :new.Month11 := 0;
  END IF;
  if (:new.Month12 IS NULL) then  
    :new.Month12 := 0;
  END IF;
    
  if (:new.Quarter1 IS NULL) then  
    :new.Quarter1 := 0;
  END IF;
  if (:new.Quarter2 IS NULL) then  
    :new.Quarter2 := 0;
  END IF;
  if (:new.Quarter3 IS NULL) then  
    :new.Quarter3 := 0;
  END IF;
  if (:new.Quarter4 IS NULL) then  
    :new.Quarter4 := 0;
  END IF;
    
  if (:new.WritExecutionSumma is Null) then 
    :new.WritExecutionSumma := 0; 
  END IF;
  if ((not :new.PROMISE is null) and (not :new.BUDGETPROMISE is null)) then
    BEGIN
      select ps.id     into ScheduleRef1$ from PaymentSchedule ps
      where (ps.InnerPromiseNum = :new.BUDGETPROMISE) and
      (ps.ANumber = :new.PROMISE)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (ScheduleRef1$ <> 0) then
    :new.PScheduleRef := ScheduleRef1$;
      
  else
    :new.PScheduleRef := null;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
  :new.targetcls,:new.targetcls); 
  /*   */
  GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_110 (TR_WritExecutionDetail_BI_110)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  if (:new.KD is NULL) then
    :new.KD := 0;
  END IF;
  if (:new.IFS is NULL) then
    :new.IFS := 0;
  END IF;

  if (:new.ClsType is NULL) then
    if (:new.KD <> 0) then
      :new.ClsType := 2; /*       ClsType */

    else
      if (:new.IFS <> 0) then
        :new.ClsType := 1;

      else
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.KD <> 0) or (:new.ifs <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 2) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_WRITEXECUTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (:new.Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = :new.PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((:new.Promise is not null) and (:new.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = :new.Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        :new.BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((:new.BudgetPromise is not null) and (:new.Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = :new.BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      :new.Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (:new.BudgetPromise is not null and :new.Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_WRITEXECUTIONDETAIL_BI_210)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (:new.Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = :new.Promise and ps.InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_WRITEXECUTIONDETAIL_BI_500)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER tr_WritExecutionDetail_bu
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONDETAIL_BU
  BEFORE UPDATE
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  ConstCheck$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  ScheduleRef1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_WRITEXECUTIONDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.BudgetRef is null) then
    BEGIN
      select 
      writ_c.BudgetRef 
      into :new.BudgetRef     from 
      WritExecutionCaption writ_c
      where 
      writ_c.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.Progindex is null) then 
    :new.Progindex := 556;    
  END IF;
  if (:new.FacialAcc_Cls is null) then 
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then 
    :new.Fact := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.RegionCLS is null) then 
    :new.RegionCLS := 0;
  END IF;
  if (:new.Finsource is null) then 
    :new.Finsource := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.DocType is null) then 
    :new.DocType := 0;
  END IF;
  if (:new.SubKesr is null) then 
    :new.SubKesr := 0;
  END IF;
    
  if (:new.Month01 IS NULL) then  
    :new.Month01 := 0;
  END IF;
  if (:new.Month02 IS NULL) then  
    :new.Month02 := 0;
  END IF;
  if (:new.Month03 IS NULL) then  
    :new.Month03 := 0;
  END IF;
  if (:new.Month04 IS NULL) then  
    :new.Month04 := 0;
  END IF;
  if (:new.Month05 IS NULL) then  
    :new.Month05 := 0;
  END IF;
  if (:new.Month06 IS NULL) then  
    :new.Month06 := 0;
  END IF;
  if (:new.Month07 IS NULL) then  
    :new.Month07 := 0;
  END IF;
  if (:new.Month08 IS NULL) then  
    :new.Month08 := 0;
  END IF;
  if (:new.Month09 IS NULL) then  
    :new.Month09 := 0;
  END IF;
  if (:new.Month10 IS NULL) then  
    :new.Month10 := 0;
  END IF;
  if (:new.Month11 IS NULL) then  
    :new.Month11 := 0;
  END IF;
  if (:new.Month12 IS NULL) then  
    :new.Month12 := 0;
  END IF;
    
  if (:new.Quarter1 IS NULL) then  
    :new.Quarter1 := 0;
  END IF;
  if (:new.Quarter2 IS NULL) then  
    :new.Quarter2 := 0;
  END IF;
  if (:new.Quarter3 IS NULL) then  
    :new.Quarter3 := 0;
  END IF;
  if (:new.Quarter4 IS NULL) then  
    :new.Quarter4 := 0;
  END IF;
    
  if (:new.WritExecutionSumma is Null) then 
    :new.WritExecutionSumma := 0; 
  END IF;
  if ((not :new.PROMISE is null) and (not :new.BUDGETPROMISE is null)) then
    BEGIN
      select ps.id     into ScheduleRef1$ from PaymentSchedule ps
      where (ps.InnerPromiseNum = :new.BUDGETPROMISE) and
      (ps.ANumber = :new.PROMISE)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (ScheduleRef1$ <> 0) then
    :new.PScheduleRef := ScheduleRef1$;
      
  else
    :new.PScheduleRef := null;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.meanstype, :new.meanstype,
  :new.targetcls,:new.targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BU_110 (TR_WritExecutionDetail_BU_110)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  if (:new.KD is NULL) then
    :new.KD := 0;
  END IF;
  if (:new.IFS is NULL) then
    :new.IFS := 0;
  END IF;
  if (:new.ClsType is NULL) then
    if (:new.KD <> 0) then
      :new.ClsType := 2; /*       ClsType */

    else
      if (:new.IFS <> 0) then
        :new.ClsType := 1;

      else
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.KD <> 0) or (:new.ifs <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 2) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_WRITEXECUTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck$ = 1)) then
    if ((:new.Promise is not null)and((:old.Promise is null)or(:old.Promise <> :new.Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$        from
      promise_detail pr
      where
      (pr.registrnumber = :new.PROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((:new.Promise is not null)and((:old.Promise is null)or(:old.Promise <> :new.Promise )) and
    (:new.BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum$       from
      PaymentSchedule
      where
      (ANumber = :new.Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        :new.BudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /*  BudgetPromise    Promise=NULL,   Promise */
    if (:new.Promise is null and ((:new.BudgetPromise is not null and :old.BudgetPromise is null) or
    (:new.BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select
        ANumber
        into BPInnerNum$       from
        PaymentSchedule
        where
        (InnerPromiseNum = :new.BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      :new.Promise := BPInnerNum$;

    END IF;

    /*  BudgetPromise -   Promise */
    if ((:new.BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      :new.Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((:new.Promise is null) and (:old.Promise is not null)) then
      :new.BudgetPromise := null;
    END IF;
    /*     */
    if (:new.BudgetPromise is not null and :new.Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_WRITEXECUTIONDETAIL_BU_210)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (:new.Promise is not null and (
    (:old.Promise is null or :old.Promise <> :new.Promise) or
    (:old.ExecDoc is null or :new.ExecDoc is null or :old.ExecDoc <> :new.ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = :new.Promise and ps.InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_WRITEXECUTIONDETAIL_BU_700)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion + 1;
  end if;

END;
/
-- ALTER TRIGGER TR_RepClsDetailInfo_BI
CREATE OR REPLACE TRIGGER TR_REPLACEMENTCLSDETAILINFO_BI
  BEFORE INSERT
  ON REPLACEMENTCLSDETAILINFO
  FOR EACH ROW
DECLARE
  const$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_RepClsDetailInfo_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
  :new.targetcls,:new.targetcls);
  /*   */
  getintconst(32, 51,const$);
  if ((:new.SubKESR is not null) and (const$ <> 0)) then
    GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_REPCLSDETINFO_BI_10)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    select
    rep_c.BudgetRef
    into
    :new.BudgetRef   from
    ReplacementClsCaption rep_c
    where
    rep_c.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;

-- - - - - - - - - - - - -
-- BI_120 (TR_REPLCLSDETINFO_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((:new.ClsType is NULL) and (:new.IFS <> 0)) then
    :new.ClsType := 1;

  else
    if ((:new.ClsType is NULL) and (:new.KD <> 0)) then
      :new.ClsType := 2;

    else
      if (:new.ClsType is null) then
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.IFS <> 0) or (:new.KD <> 0)))THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (:new.ClsType = 1) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0) OR
  (:new.KD <> 0)
  ))
  THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType = 2) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0) OR
  (:new.IFS <> 0)
  ))
  THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_RepClsDetailInfo_BI_500)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER TR_RepClsDetailInfo_BU
CREATE OR REPLACE TRIGGER TR_REPLACEMENTCLSDETAILINFO_BU
  BEFORE UPDATE
  ON REPLACEMENTCLSDETAILINFO
  FOR EACH ROW
DECLARE
  const$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_RepClsDetailInfo_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.meanstype, :new.meanstype,
  :new.targetcls,:new.targetcls); 
  /*   */
  getintconst(32, 51,const$);
  if ((:new.SubKESR is not null) and (const$ <> 0)) then
    GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);
  END IF;
  if ((const$ in (2, 3)) and (:new.SubKESR is null)) then
    :new.KESR := null;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_REPLCLSDETINFO_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((:new.ClsType is NULL) and (:new.IFS <> 0)) then
    :new.ClsType := 1;

  else
    if ((:new.ClsType is NULL) and (:new.KD <> 0)) then
      :new.ClsType := 2;

    else
      if (:new.ClsType is null) then
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.IFS <> 0) or (:new.KD <> 0)))THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (:new.ClsType = 1) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0) OR
  (:new.KD <> 0)
  ))
  THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType = 2) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0) OR
  (:new.IFS <> 0)
  ))
  THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;

END;
/
commit work 
/
ALTER TABLE KESRSUBCODE MODIFY(KESR NOT NULL)
/

-- #########################################################
-- #########################################################
-- create_GetDocumentKESR.sql
-- #########################################################
-- #########################################################


/*        " " (32, 51) */
CREATE OR REPLACE procedure GetDocumentKESR(OldSubKESR$ NUMBER, NewSubKESR$ NUMBER,
    NewKESR$ NUMBER, BudgetRef$ NUMBER, KESR$ out NUMBER)
AS
  const$ NUMBER(10);
  KESRCode$ VARCHAR(20);
  CurDate$ TIMESTAMP;
  CurYear$ NUMBER(10);
  BudYear$ NUMBER(10);
BEGIN
  getintconst(32, 51, const$);
  if (((const$ = 3) and (((OldSubKESR$  is null) and (NewSubKESR$  is not null)) or
     ((OldSubKESR$  is not null) and (NewSubKESR$  is null)) or 
     ((OldSubKESR$  is not null) and (NewSubKESR$  is not null) and (OldSubKESR$  <> NewSubKESR$))))) then
    /*     3   */
    select SUBSTR(CODE, 1, 3) into KESRCode$ from KESRSubCode where (id = NewSubKESR$);
    /*   */
    getintconst(-1, 73, BudYear$);
    /*   */
    select extract(YEAR from cast(SYSDATE as TIMESTAMP)) into CurYear$ from dual;
    /*      ,   01.01  ,   */
    if (CurYear$ < BudYear$) then
      CurDate$ := TO_DATE('01.01.' || BudYear$, 'DD.MM.YYYY');
    else
      CurDate$ := cast(SYSDATE as TIMESTAMP);
    end if;
    begin
      /*      */
      select Max(ID) into KESR$ from KESR where (Code = KESRCode$) and (BudgetRef = BudgetRef$) and 
        ((StartDate is null) or (StartDate <= CurDate$)) and ((DeleteDate is null) or (DeleteDate >= CurDate$));
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
    end;
    if (KESR$ is null) then
      begin
        /*    " " */
        select Max(ID) into KESR$ from KESR where (Code = KESRCode$) and (BudgetRef = 0) and 
          ((StartDate is null) or (StartDate <= CurDate$)) and ((DeleteDate is null) or (DeleteDate >= CurDate$));
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
      end;
      if (KESR$ is null) then
        begin
          /*      */
          select Max(ID) into KESR$ from KESR where (Code = KESRCode$) and (BudgetRef = BudgetRef$);
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
        end;
        if (KESR$ is null) then
          begin
            /*    " " */
            select Max(ID) into KESR$ from KESR where (Code = KESRCode$) and (BudgetRef = 0);
            EXCEPTION
              WHEN NO_DATA_FOUND THEN NULL;
          end;
        end if;
      end if;
    end if;
  ELSE
    if (((const$ = 2) and (((OldSubKESR$  is null) and (NewSubKESR$  is not null)) or
       ((OldSubKESR$  is not null) and (NewSubKESR$  is null)) or 
       ((OldSubKESR$  is not null) and (NewSubKESR$  is not null) and (OldSubKESR$  <> NewSubKESR$)))) or
       ((const$ = 1) and (NewKESR$ is null))) then
    BEGIN
      /*      */
      select KESR into KESR$ from KESRSUBCODE where (id = NewSubKESR$);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
    END;
    else 
      /*         */    
      KESR$ := NewKESR$;
    END IF;
  END IF;
  if (KESR$ is null) then
    KESR$ := 0;
  END IF;
END;
/

grant execute on GetDocumentKESR to BUDGET_USERS
/

commit work
/



-- #########################################################
-- #########################################################
-- Del_OldField_Object.sql
-- #########################################################
-- #########################################################

/*    Object   ESTIMATE  EXECDOCDETAIL*/
-- ALTER TRIGGER TR_ESTIMATE_BI
CREATE OR REPLACE TRIGGER TR_ESTIMATE_BI
  BEFORE INSERT
  ON ESTIMATE
  FOR EACH ROW
DECLARE
  TempFacialAcc_CLS$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ESTIMATE_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if  (:new.FacialAcc_Cls is null) then
    BEGIN
      select FacialAcc_Cls    into TempFacialAcc_CLS$ from Agreements
      where (ID = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    :new.FacialAcc_Cls := TempFacialAcc_CLS$;
     
  END IF;
  if (:new.ProductCls is null) then 
    :new.ProductCls := 0;
  END IF;
  if (:new.Amount is null) then 
    :new.amount := 0;
  END IF;
  if (:new.Price is null) then 
    :new.Price := 0;
  END IF;
  if (:new.Cost is null) then 
    :new.Cost := 0;
  END IF;
  if (:new.VATPercent is null) then 
    :new.VATPercent := 0;
  END IF;
  if (:new.VATSumma is null) then 
    :new.VATSumma := 0;
  END IF;
  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.FinSumma is null) then 
    :new.FinSumma := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  BEGIN

    /*  ,    */
    select agr.BudgetRef      into :new.BudgetRef from Agreements agr
    where agr.ID = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;

-- - - - - - - - - - - - -
-- BI_10 (TR_ESTIMATE_BI_10)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (:new.senderId is null) then 
    :new.senderIdKey := -1;
  else
    :new.senderIdKey := :new.senderId;
  end if;

  if (:new.SenderRecordID is null)then
    :new.SenderRecordIDKey := :new.ID;
  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  end if;   

-- - - - - - - - - - - - -
-- BI_20 (TR_ESTIMATE_BI_20)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if ((:new.COST < 0) or (:new.SUMMA < 0)) then
    RaiseException('EX_EXECDOCEST_NEGATIVECOST');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ESTIMATE_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
commit work
/
-- ALTER TRIGGER TR_ESTIMATE_BU
CREATE OR REPLACE TRIGGER TR_ESTIMATE_BU
  BEFORE UPDATE
  ON ESTIMATE
  FOR EACH ROW
DECLARE
  TempFacialAcc_CLS$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ESTIMATE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if  (:new.FacialAcc_Cls is null) then
    BEGIN
      select FacialAcc_Cls    into TempFacialAcc_CLS$ from Agreements
      where (ID = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    :new.FacialAcc_Cls := TempFacialAcc_CLS$;
     
  END IF;
  if (:new.ProductCls is null) then 
    :new.ProductCls := 0;
  END IF;
  if (:new.Amount is null) then 
    :new.amount := 0;
  END IF;
  if (:new.Price is null) then 
    :new.Price := 0;
  END IF;
  if (:new.VATPercent is null) then 
    :new.VATPercent := 0;
  END IF;
  if (:new.Cost is null) then 
    :new.Cost := 0;
  END IF;
  if (:new.VATSumma is null) then 
    :new.VATSumma := 0;
  END IF;
  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.FinSumma is null) then 
    :new.FinSumma := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  /*     */
  if (:new.BudgetRef <> :old.BudgetRef) then
    if ( not((:new.BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_ESTIMATE_BU_20)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if ((:new.COST < 0) or (:new.SUMMA < 0)) then
    RaiseException('EX_EXECDOCEST_NEGATIVECOST');
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_Estimate_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ESTIMATE_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

   IF (:NEW.RVersion IS NULL) THEN
      :NEW.RVersion := 1;
   ELSE
      IF ((:NEW.RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         :NEW.RVersion := :OLD.RVersion;
      ELSE
         :NEW.RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

END;
/
commit work
/
ALTER TABLE ESTIMATE DROP (Object)
/
commit work
/
-- ALTER TRIGGER TR_EXECDOCDETAIL_BI
CREATE OR REPLACE TRIGGER TR_EXECDOCDETAIL_BI
  BEFORE INSERT
  ON EXECUTIONDOCUMENTSDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_EXECDOCDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Amount is null) then 
    :new.amount := 0;
  END IF;
  if (:new.ProductCls is null) then 
    :new.ProductCls := 0;
  END IF;
  if (:new.Price is null) then 
    :new.Price := 0;
  END IF;
  if (:new.Cost is null) then 
    :new.Cost := 0;
  END IF;
  if (:new.VATPercent is null) then 
    :new.VATPercent := 0;
  END IF;
  if (:new.VATSumma is null) then 
    :new.VATSumma := 0;
  END IF;
  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  BEGIN
    /*  ,    */
    select edc.BudgetRef       into :new.BudgetRef from ExecutionDocumentsCaption edc
    where edc.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;

-- - - - - - - - - - - - -
-- BI_10 (tr_execdocdetail_bi_10)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (:new.senderId is null) then 
    :new.senderIdKey := -1;
  else
    :new.senderIdKey := :new.senderId;
  end if;

  if (:new.SenderRecordID is null)then
    :new.SenderRecordIDKey := :new.ID;
  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  end if;   

-- - - - - - - - - - - - -
-- BI_20 (TR_EXECDOCDETAIL_BI_20)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if ((:new.COST < 0) or (:new.SUMMA < 0)) then
    RaiseException('EX_EXECDOCEST_NEGATIVECOST');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_EXECDOCDETAIL_BI_500)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
commit work
/
-- ALTER TRIGGER TR_EXECDOCDETAIL_BU
CREATE OR REPLACE TRIGGER TR_EXECDOCDETAIL_BU
  BEFORE UPDATE
  ON EXECUTIONDOCUMENTSDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_EXECDOCDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Amount is null) then 
    :new.amount := 0;
  END IF;
  if (:new.ProductCls is null) then 
    :new.ProductCls := 0;
  END IF;
  if (:new.Price is null) then 
    :new.Price := 0;
  END IF;
  if (:new.Cost is null) then 
    :new.Cost := 0;
  END IF;
  if (:new.VATPercent is null) then 
    :new.VATPercent := 0;
  END IF;
  if (:new.VATSumma is null) then 
    :new.VATSumma := 0;
  END IF;
  if (:new.Summa is null) then 
    :new.Summa := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  /*     */
  if (:new.BudgetRef <> :old.BudgetRef) then
    if ( not((:new.BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_EXECDOCDETAIL_BU_20)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if ((:new.COST < 0) or (:new.SUMMA < 0)) then
    RaiseException('EX_EXECDOCEST_NEGATIVECOST');
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_ExecDocDet_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_EDDETAIL_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

   IF (:NEW.RVersion IS NULL) THEN
      :NEW.RVersion := 1;
   ELSE
      IF ((:NEW.RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         :NEW.RVersion := :OLD.RVersion;
      ELSE
         :NEW.RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

END;
/
commit work
/
ALTER TABLE EXECUTIONDOCUMENTSDETAIL DROP (Object)
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_Agreements_ReestrRecordNumber.sql
-- #########################################################
-- #########################################################

/*    "  /"   c   */
INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_USEDOLDFIELDRNUM', -20370, '/    : rnClientID, rnYear, rnNumber!')
/
commit work
/
-- ALTER TRIGGER TR_AGREEMENTS_BI_400
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CountAcc$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;

  else
    /*    */
    /*       */
    select count(ID), max(DocNumber)
    into Tmp$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum$;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) or (new$rnYear is not null) or (new$rnNumber is not null)) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
commit work
/
-- ALTER TRIGGER TR_AGREEMENTS_BU_400
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID is not null) and (:old.rnClientID is null or new$rnClientID <> :old.rnClientID)) or
  ((new$rnYear is not null) and (:old.rnYear is null or new$rnYear <> :old.rnYear)) or
  ((new$rnNumber is not null) and (:old.rnNumber is null or new$rnNumber <> :old.rnNumber))) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    PURPORTDOC = new$PURPORTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_ps_tr_parentnumber.sql
-- #########################################################
-- #########################################################

/*     .    ,      ,    ,  . #1491681 */
-- ALTER TRIGGER TR_PAYMENTSCHEDULE_BI
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  Tmp1$ NUMBER(10);
  AdjDocNum1$ NUMBER(10);
  InnerNumber_parent1$ NUMBER(10);
  InnerNumber_child1$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/

  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from PaymentSchedule
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;

  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;

  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    /*       (    )*/
    new$ParentNumber := null;

  else
    /*      -    */
    select count(ID), max(ANumber)
    into Tmp1$, AdjDocNum1$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp1$ = 0) then
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp1$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$ParentNumber := AdjDocNum1$;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child1$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent1$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent1$ <> InnerNumber_child1$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');
      END IF;
    else
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child1$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent1$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent1$ <> InnerNumber_child1$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    OLDNUMBER,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$OLDNUMBER,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_PAYMENTSCHEDULE_BI_10
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    OLDNUMBER,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$OLDNUMBER,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_PayPromiseCls_Name_2000.sql
-- #########################################################
-- #########################################################

/*    ""   "  "  2000  */
ALTER TRIGGER TR_PAYPROMISECLS_BU_500 DISABLE
/
ALTER TABLE PayPromiseCls ADD (
  TempName VARCHAR2(2000)
)
/
commit work 
/
update PayPromiseCls set
  TempName = Name
/
ALTER TABLE PayPromiseCls DROP (Name)
/
commit work 
/
ALTER TABLE PayPromiseCls ADD (
  Name VARCHAR2(2000)
)
/
commit work 
/
update PayPromiseCls set
  Name = TempName
/
ALTER TABLE PayPromiseCls DROP (TempName)
/
ALTER TRIGGER TR_PAYPROMISECLS_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- DocStateRef_Fix_25_30.sql
-- #########################################################
-- #########################################################

/*        DocStateRef (   ,  FK -  ) */
/*      -    */
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 2504, 0, 0  from Agreements
where progindex = 314 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 2502, 0, 0  from Agreements
where progindex = 304 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/

commit work
/
ALTER TABLE TB_Agreements ADD (
  constraint FK_AgrCAPT_DocStateRef foreign key (DocStateRef) references State_DocStates(ID) 
)
/
CREATE INDEX FK_AgrCAPT_DocStateRef ON TB_Agreements(DocStateRef)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 2503, 0, 0  from ExecutionDocumentsCaption
where DocStateRef is not null and DocStateRef not in (select id from State_DocStates) 
/
commit work
/
ALTER TABLE TB_ExecutionDocumentsCaption ADD (
  constraint FK_ExecCAPT_DocStateRef foreign key (DocStateRef) references State_DocStates(ID) 
)
/
CREATE INDEX FK_ExecCAPT_DocStateRef ON TB_ExecutionDocumentsCaption(DocStateRef)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3001, 0, 0  from TenderCaption
where progindex = 230 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3005, 0, 0  from TenderCaption
where progindex = 240 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3006, 0, 0  from TenderCaption
where progindex = 241 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3010, 0, 0  from TenderCaption
where progindex = 242 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3011, 0, 0  from TenderCaption
where progindex = 243 and DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
commit work
/
ALTER TABLE TB_TenderCaption ADD (
  constraint FK_TenderCAPT_DocStateRef foreign key (DocStateRef) references State_DocStates(ID) 
)
/
CREATE INDEX FK_TenderCAPT_DocStateRef ON TB_TenderCaption(DocStateRef)
/
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3003, 0, 0  from TenderResultCaption
where DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
commit work
/
ALTER TABLE TenderResultCaption ADD (
  constraint FK_TRC_DocStateRef foreign key (DocStateRef) references State_DocStates(ID)
)
/
CREATE INDEX FK_TRC_DocStateRef ON TenderResultCaption(DocStateRef)
/
commit work
/

insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, 3701, 0, 0  from TENDEROBJECTS
where DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
commit work
/
ALTER TABLE TENDEROBJECTS ADD (
  constraint FK_TENDEROBJECTS_DocStateRef foreign key (DocStateRef) references State_DocStates(ID) 
)
/
CREATE INDEX FK_TENDEROBJECTS_DocStateRef ON TENDEROBJECTS(DocStateRef)
/
commit work
/

-- #########################################################
-- #########################################################
-- Del_Table_FaxDocs.sql
-- #########################################################
-- #########################################################

/*  FAXDOCS   .     */
-- ALTER TRIGGER tr_facialfincaption_bi
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  UseFax$ NUMBER(10);
  pdt$ NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Create 04.12.2004
-- Last update 11.10.2006
-- - - - - - - - - - - - -

  IF (NEW$SenderID IS NOT NULL) THEN
    pdt$ := NULL;
    IF (NEW$progindex = 63) THEN pdt$ := 302; END IF;
    IF (NEW$progindex = 66) THEN pdt$ := 301; END IF;
    IF (NEW$progindex = 64) THEN pdt$ := 304; END IF;

    /*       */
    GetIntConst(30, 19, UseFax$);
    IF ((new$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      new$BidNumber := new$DocNumber;
    END IF;
    SELECT COUNT(*) INTO new$FaxDocCount
    FROM FaxDocs
      WHERE (OwnerDocNumber=new$BidNumber)
        AND (ClientID=new$SenderID)
        AND (FacialAcc_Cls=new$SourceFacialAcc_CLS)
        AND (OwnerDate = new$DocumentDate)
        AND (PrimaryDocType = PDT$);
  ELSE
    new$FaxDocCount := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    FAXDOCCOUNT,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$FAXDOCCOUNT,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Create 04.12.2004
-- Last update 11.10.2006
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN
      /*       */
      pdt$ := NULL;
      IF (new$progindex = 63) THEN pdt$ := 302; END IF;
      IF (new$progindex = 66) THEN pdt$ := 301; END IF;
      IF (new$progindex = 64) THEN pdt$ := 304; END IF;

        UPDATE FaxDocs
            SET OwnerId=new$id
        WHERE
            (OwnerDocNumber=new$BidNumber)
            AND (ClientID=new$SenderID)
            AND (FacialAcc_Cls=new$SourceFacialAcc_CLS)
            AND (OwnerDate = new$DocumentDate)
            AND (primarydoctype = pdt$);
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/
commit work
/
-- ALTER TRIGGER tr_facialfincaption_bu
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  UseFax1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  DetCount1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    /*      */
    GetIntConst(30, 19,UseFax1$);
    if ((new$BidNumber is null) and (UseFax1$ = 1)) then 
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber1$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount1$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/
-- ALTER TRIGGER tr_facialfincaption_bu
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/
-- ALTER TRIGGER tr_facialfincaption_bi_430
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  pdt$ NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
    END IF;
    SELECT COUNT(*)         INTO
    new$FaxDocCount FROM FaxDocs WHERE 
    (OwnerDocNumber=new$BidNumber)
    AND (ClientID=new$SenderID)
    AND (FacialAcc_Cls=new$SourceFacialAcc_CLS)
    AND (OwnerDate = new$DocumentDate)
    AND (PrimaryDocType = pdt1$)
    ;
  ELSE
    new$FaxDocCount:= 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    FAXDOCCOUNT,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$FAXDOCCOUNT,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Create 04.12.2004
-- Last update 11.10.2006
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN
      /*       */
      pdt$ := NULL;
      IF (new$progindex = 63) THEN pdt$ := 302; END IF;
      IF (new$progindex = 66) THEN pdt$ := 301; END IF;
      IF (new$progindex = 64) THEN pdt$ := 304; END IF;

        UPDATE FaxDocs
            SET OwnerId=new$id
        WHERE
            (OwnerDocNumber=new$BidNumber)
            AND (ClientID=new$SenderID)
            AND (FacialAcc_Cls=new$SourceFacialAcc_CLS)
            AND (OwnerDate = new$DocumentDate)
            AND (primarydoctype = pdt$);
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/
commit work
/
-- ALTER TRIGGER tr_facialfincaption_ai_430
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
    END IF;
    SELECT COUNT(*)         INTO
    new$FaxDocCount FROM FaxDocs WHERE 
    (OwnerDocNumber=new$BidNumber)
    AND (ClientID=new$SenderID)
    AND (FacialAcc_Cls=new$SourceFacialAcc_CLS)
    AND (OwnerDate = new$DocumentDate)
    AND (PrimaryDocType = pdt1$)
    ;
  ELSE
    new$FaxDocCount:= 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    FAXDOCCOUNT,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$FAXDOCCOUNT,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/
commit work
/
-- ALTER TRIGGER tr_facialfincaption_bi_430
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$FAXDOCCOUNT FACIALFINCAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    FAXDOCCOUNT,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$FAXDOCCOUNT,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/
commit work
/
-- drop trigger TR_FACIALFINCAPTION_BD_430
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_300 (TR_FACIALFINCAPTION_AD_300)
-- Create 24.02.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  IF (:OLD.FaxDocCount > 0) THEN
--    :old.FaxDocCount := :old.FaxDocCount;
    NULL;
  ELSE
    UPDATE FaxDocs
       SET OwnerID = NULL
     WHERE OwnerID = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/
commit work
/
-- drop trigger TR_FACIALFINCAPTION_AD_300
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/
commit work
/
-- drop trigger TR_FAXDOCS_BU
DROP TRIGGER TR_FAXDOCS_BU
/
commit work
/
-- drop trigger TR_FAXDOCS_BI
CREATE OR REPLACE TRIGGER TR_FAXDOCS_BI
  BEFORE INSERT
  ON FAXDOCS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_500 (TR_FAXDOCS_BI_500)
-- Create 09.03.2005
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;

END;
/
commit work
/
-- drop trigger TR_FAXDOCS_BD
DROP TRIGGER TR_FAXDOCS_BD
/
commit work
/
-- drop trigger TR_FAXDOCS_AI_500
DROP TRIGGER TR_FAXDOCS_AI
/
commit work
/
-- drop trigger TR_FAXDOCS_AD_500
DROP TRIGGER TR_FAXDOCS_AD
/
commit work
/
-- drop trigger TR_FAXDOCS_AU_500
DROP TRIGGER TR_FAXDOCS_AU
/
commit work
/
-- drop trigger TR_FAXDOCS_BI_500
DROP TRIGGER TR_FAXDOCS_BI
/
commit work
/
-- drop trigger TR_FAXDOCS_BU_500
DROP TRIGGER TR_FAXDOCS_BU_500
/
commit work
/
-- drop trigger TR_PROMISE_CAPTION_BI_430
CREATE OR REPLACE TRIGGER TR_PROMISE_CAPTION_II
  INSTEAD OF INSERT
  ON PROMISE_CAPTION
  FOR EACH ROW
DECLARE
  new$ID PROMISE_CAPTION.ID%TYPE := :NEW.ID;
  new$ACCEPTDATE PROMISE_CAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$ACCEPTED_REVERTED PROMISE_CAPTION.ACCEPTED_REVERTED%TYPE := :NEW.ACCEPTED_REVERTED;
  new$AGREEMENT_DATE PROMISE_CAPTION.AGREEMENT_DATE%TYPE := :NEW.AGREEMENT_DATE;
  new$AGREEMENT_END PROMISE_CAPTION.AGREEMENT_END%TYPE := :NEW.AGREEMENT_END;
  new$AGREEMENT_NOTE PROMISE_CAPTION.AGREEMENT_NOTE%TYPE := :NEW.AGREEMENT_NOTE;
  new$AGREEMENT_TYPE PROMISE_CAPTION.AGREEMENT_TYPE%TYPE := :NEW.AGREEMENT_TYPE;
  new$AGREEMENT_SUMMA PROMISE_CAPTION.AGREEMENT_SUMMA%TYPE := :NEW.AGREEMENT_SUMMA;
  new$SUPPLIER_REF PROMISE_CAPTION.SUPPLIER_REF%TYPE := :NEW.SUPPLIER_REF;
  new$DELIVERY_RULES PROMISE_CAPTION.DELIVERY_RULES%TYPE := :NEW.DELIVERY_RULES;
  new$TOTALSUMM PROMISE_CAPTION.TOTALSUMM%TYPE := :NEW.TOTALSUMM;
  new$BUDGETORG_REF PROMISE_CAPTION.BUDGETORG_REF%TYPE := :NEW.BUDGETORG_REF;
  new$FACIALACC_CLS PROMISE_CAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$BUDGETREF PROMISE_CAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREATERUSER PROMISE_CAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PROMISE_CAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PROMISE_CAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PROMISE_CAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$ANUMBER PROMISE_CAPTION.ANUMBER%TYPE := :NEW.ANUMBER;
  new$REJECT_CLS PROMISE_CAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CRYPTOSTATUS PROMISE_CAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PROMISE_CAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PROMISE_CAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCUMENTSTATE PROMISE_CAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA PROMISE_CAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$RVERSION PROMISE_CAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF PROMISE_CAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$STIMATEID PROMISE_CAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$BIDNUMBER PROMISE_CAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT PROMISE_CAPTION.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$SUPPLIER_ACC_REF PROMISE_CAPTION.SUPPLIER_ACC_REF%TYPE := :NEW.SUPPLIER_ACC_REF;
  new$AGREEMENT_NUM PROMISE_CAPTION.AGREEMENT_NUM%TYPE := :NEW.AGREEMENT_NUM;
  new$INFONUMBER PROMISE_CAPTION.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$ADVANCESUMMA PROMISE_CAPTION.ADVANCESUMMA%TYPE := :NEW.ADVANCESUMMA;
  new$REJECTCAUSE PROMISE_CAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PROMISE_CAPTION_BI)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted_Reverted is null) then
    new$Accepted_Reverted := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$TotalSumm is null) then
    new$TotalSumm := 0;
  END IF;
  if (new$Agreement_Type is null) then
    new$Agreement_Type := 0;
  END IF;
  if (new$Agreement_Summa is null) then
    new$Agreement_Summa := 0;
  END IF;
  if ((new$reject_cls is not null))then
    new$Accepted_Reverted := 1;
  END IF;
  if ((new$reject_cls is null))then
    new$Accepted_Reverted := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef         into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select ConstValue         into new$BudgetRef from IntConst where (ProgIndex = -1) and (ConstIndex = 3)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PROMISE_CAPTION_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PROMISE_CAPTION (
    ID,
    ACCEPTDATE,
    ACCEPTED_REVERTED,
    AGREEMENT_DATE,
    AGREEMENT_END,
    AGREEMENT_NOTE,
    AGREEMENT_TYPE,
    AGREEMENT_SUMMA,
    SUPPLIER_REF,
    DELIVERY_RULES,
    TOTALSUMM,
    BUDGETORG_REF,
    FACIALACC_CLS,
    BUDGETREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    ANUMBER,
    REJECT_CLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCUMENTSTATE,
    USERSVISA,
    RVERSION,
    DOCSTATEREF,
    STIMATEID,
    BIDNUMBER,
    FAXDOCCOUNT,
    SUPPLIER_ACC_REF,
    AGREEMENT_NUM,
    INFONUMBER,
    ADVANCESUMMA,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$ACCEPTDATE,
    new$ACCEPTED_REVERTED,
    new$AGREEMENT_DATE,
    new$AGREEMENT_END,
    new$AGREEMENT_NOTE,
    new$AGREEMENT_TYPE,
    new$AGREEMENT_SUMMA,
    new$SUPPLIER_REF,
    new$DELIVERY_RULES,
    new$TOTALSUMM,
    new$BUDGETORG_REF,
    new$FACIALACC_CLS,
    new$BUDGETREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$ANUMBER,
    new$REJECT_CLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$RVERSION,
    new$DOCSTATEREF,
    new$STIMATEID,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$SUPPLIER_ACC_REF,
    new$AGREEMENT_NUM,
    new$INFONUMBER,
    new$ADVANCESUMMA,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_500 (TR_PROMISECAPTION_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 77) AND (RecordID = new$ID);

END;
/
commit work
/
ALTER TABLE TB_FACIALFINCAPTION DROP (FAXDOCCOUNT)
/

CREATE OR REPLACE VIEW FACIALFINCAPTION (
  ID,
  DOCNUMBER,
  SOURCEDOCNUM,
  PAYDATE,
  ACCEPTDATE,
  DOCUMENTDATE,
  REESTRDATE,
  CREDIT,
  SOURCEACCOUNT,
  SOURCEFACIALACC_CLS,
  DESTACCOUNT,
  DESTFACIALACC_CLS,
  PROGINDEX,
  ARHIVEDOC,
  PAYSYMBOLCLS,
  PAYTYPECLS,
  NOTE,
  PERIOD,
  PAYPRIORITY,
  TYPEOPERATIONCLS,
  BUHPAYMENTCLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  RECORDINDEX,
  SENDERID,
  SENDERRECORDID,
  REESTR_REF,
  REJECT_CLS,
  CLIENTBANKNUMBER,
  CRYPTOSTATUS,
  TRUSTNUMBER,
  LINKEDDOCUMENT,
  BNKRECORDID,
  SUBPROGINDEX,
  DOCUMENTSTATE,
  USERSVISA,
  TREASUARYDOCSTATECLS,
  DEPARTMENTCLS,
  NDS,
  TAXNOTE,
  MANAGERBID,
  BIDNUMBER,
  GROUPID,
  GROUPSUMMA,
  DOCSTATEREF,
  LASTEXTRCHANGE,
  STIMATEID,
  INTEGRATEDDOCREF,
  REQUESTNUMBER,
  REQUESTDATE,
  RVERSION,
  FEDERALFUNDSREF,
  ELDOCREF,
  BUHOPERATIONCLS,
  CLSTYPE,
  OPERATIONDIRECTION,
  SOURCETYPE,
  DESTTYPE,
  CARDNUMBER,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  CASHIERPERSONALINFO,
  BIDDATE,
  CARDREF,
  SOURCESTOREDPAYMENTPROPS,
  DESTSTOREDPAYMENTPROPS,
  STOREDPAYMENTNOTE,
  DOCCHANGEDATE,
  UINCODE,
  DOCOSN,
  SIGNERS,
  DESTCLSTYPE,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  AUTOSANCTION,
  STOREDPAYMENTCONTENT,
  REJECTCAUSE)
AS
  SELECT
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  FROM TB_FACIALFINCAPTION
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/
DROP TABLE FAXDOCS
/
commit work
/

-- #########################################################
-- #########################################################
-- DocStateRef_Fix.sql
-- #########################################################
-- #########################################################

/*        DocStateRef (   ,  FK -  ) 
            DocStateRef
*/
/*      -    */
insert into State_DocStates(Id, DocTypeRef, StateTypeRef, IsActive)
select distinct DocStateRef, DocStateRef / 100, 0, 0  from FacialFinCaption
where DocStateRef is not null and DocStateRef not in (select id from State_DocStates)
/
commit work
/
ALTER TABLE TB_FacialFinCaption ADD (
  constraint FK_FCFINCAPT_DocStateRef foreign key (DocStateRef) references State_DocStates(ID) 
)
/
CREATE INDEX FK_FCFINCAPT_DocStateRef ON TB_FacialFinCaption(DocStateRef)
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_TR_AGREEMENTS_BI_10.sql
-- #########################################################
-- #########################################################

/*     ,   (FB)   (ORA)   ,     "614",    "614 "     . #1692830 *//*        */
-- ALTER TRIGGER tr_agreements_bi_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
--
  CountAcc$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*       */
    select count(ID) 
    into Tmp1$         from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp1$ = 0) then 
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    BEGIN
      select DocNumber 
      into new$AdjustmentDocNumber         from Agreements
      where ID=new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) or (new$rnYear is not null) or (new$rnNumber is not null)) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- Update_ENUMVALUES_VAL_314.sql
-- #########################################################
-- #########################################################

/*     " "  " " */
update ENUMVALUES
set NAME = ' '
where VAL = 314   
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_RemoteClients_Add_EnableWebAccess_Ora.sql
-- #########################################################
-- #########################################################


/* <TRANS_COMMAND>
ALTER TABLE RemoteClient
      ADD (EnableWebAccess Number(5))
/
COMMIT WORK
/
*/
-- <TRANS_IGNORE>

DECLARE 
  v_exists integer;
BEGIN
  SELECT count(*) 
    INTO v_exists
    FROM USER_TAB_COLUMNS 
    WHERE Upper(TABLE_NAME)=Upper('RemoteClient') AND Upper(COLUMN_NAME)=Upper('EnableWebAccess');
  IF (v_exists=0) THEN
    EXECUTE IMMEDIATE 'ALTER TABLE RemoteClient
      ADD (EnableWebAccess Number(5))';
    EXECUTE IMMEDIATE 'COMMIT WORK';
  END IF;
END;
/



-- #########################################################
-- #########################################################
-- Alter_TR_FacialFinDetail_BU_210.sql
-- #########################################################
-- #########################################################

/*          */
-- ALTER TRIGGER TR_FacialFinDetail_BU_210
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Create 20.02.2006
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select c.AcceptDate into CapAcceptDate$
      from facialfincaption c
      where c.id = new$RecordIndex;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        CapAcceptDate$ := NULL;
    END;

    if ((new$AcceptDate = CapAcceptDate$) or (CapAcceptDate$ is null)) then
      new$AcceptDate := new$AcceptDate;
    else
      RaiseException('ex_wrongacceptdate');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_PaymentSchedule_setOldNumberStr.sql
-- #########################################################
-- #########################################################

ALTER TRIGGER TR_PAYMENTSCHEDULE_BU_500 DISABLE
/
ALTER TABLE TB_PaymentSchedule ADD (
  TempOldNumber VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  OLDNUMBER,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR1,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR1DELTA,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  TEMPOLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    OLDNUMBER,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.SummaYear1;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    OLDNUMBER,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$OLDNUMBER,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$TEMPOLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.Reject_Cls ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    OLDNUMBER = new$OLDNUMBER,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    TEMPOLDNUMBER = new$TEMPOLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
update PaymentSchedule ps set
   TempOldNumber = OldNumber
/
commit work 
/
ALTER TABLE TB_PaymentSchedule DROP (OldNumber)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR1,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR1DELTA,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  TEMPOLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.SummaYear1;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$TEMPOLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.Reject_Cls ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    TEMPOLDNUMBER = new$TEMPOLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
ALTER TABLE TB_PaymentSchedule ADD (
  OldNumber VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR1,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR1DELTA,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  TEMPOLDNUMBER,
  OLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER,
    OLDNUMBER
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.SummaYear1;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    TEMPOLDNUMBER,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$TEMPOLDNUMBER,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$TEMPOLDNUMBER PAYMENTSCHEDULE.TEMPOLDNUMBER%TYPE := :NEW.TEMPOLDNUMBER;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.Reject_Cls ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    TEMPOLDNUMBER = new$TEMPOLDNUMBER,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
update PaymentSchedule ps set
   OldNumber = TempOldNumber
/
ALTER TABLE TB_PaymentSchedule DROP (TempOldNumber)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR1,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR1DELTA,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.SummaYear1;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Create 05.03.2004
-- Last update 29.12.2007
-- - - - - - - - - - - - -

/*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.Reject_Cls ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
ALTER TRIGGER TR_PAYMENTSCHEDULE_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- Create_tr_FacialFinCaption_bu_200.sql
-- #########################################################
-- #########################################################

/*    ,          */
-- CREATE TRIGGER TR_FACIALFINCAPTION_BU_200
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/


-- #########################################################
-- #########################################################
-- Update_RemoteDocument.sql
-- #########################################################
-- #########################################################

/*         /    *//*   25.01     *//*     RemoteDocument    DocumentTypes (  44885) */
CREATE OR REPLACE PROCEDURE UpdateRemoteDocumentName
AS
BEGIN
  FOR REC$1 IN (select rd.id AS rdID, dt.name
   AS dtName        from RemoteDocument rd
  join documenttypes dt on dt.progindex=rd.id
  where rd.name <> dt.name
  )
  LOOP
    update REMOTEDOCUMENT
    set NAME = REC$1.dtName

    where ID = REC$1.rdID;
       
  END LOOP;
END;
/
CALL UpdateRemoteDocumentName() 
/
DROP PROCEDURE UpdateRemoteDocumentName 
/
commit work 
/
delete from REMOTECLIENTACCOUNT
where remotedocument = 305
/
delete from REMOTEINPUTRIGHT
where remotedocument = 305
/
update REMOTEDOCUMENT
set NAME = ' , '
where ID = 262
/
update REMOTEDOCUMENT
set NAME = ' '
where ID = 304
/
update REMOTEDOCUMENT
set NAME = ' '
where ID = 314
/
update REMOTEDOCUMENT
set NAME = '   223-'
where ID = 240
/
update REMOTEDOCUMENT
set NAME = '    223-'
where ID = 241
/
update REMOTEDOCUMENT
set NAME = '- '
where ID = 242
/
update REMOTEDOCUMENT
set NAME = ' - '
where ID = 243
/
delete from REMOTEDOCUMENT
where ID = 305
/
commit work 
/



-- #########################################################
-- #########################################################
-- Alter_TR_PaymentSchedulel_BU_200.sql
-- #########################################################
-- #########################################################

/*      ,       */
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BU_200
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Create 05.03.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  /*   1.0*/
    if (new$Quarter1 = 0) then new$Quarter1 := new$Month01 + new$Month02 + new$Month03; end if;
    if (new$Quarter2 = 0) then new$Quarter2 := new$Month04 + new$Month05 + new$Month06; end if;
    if (new$Quarter3 = 0) then new$Quarter3 := new$Month07 + new$Month08 + new$Month09; end if;
    if (new$Quarter4 = 0) then new$Quarter4 := new$Month10 + new$Month11 + new$Month12; end if;
    new$SummaYear1 := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work
/


-- #########################################################
-- #########################################################
-- Alter_TR_TENDERPRODUCT_BI_BU_1.sql
-- #########################################################
-- #########################################################

/*         TenderProduct*//*         PAYMENTSCHEDULE*/
-- CREATE TRIGGER TR_TENDERPRODUCT_BU_1
CREATE OR REPLACE TRIGGER TR_TENDERPRODUCT_BU
  BEFORE UPDATE
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  PosNumber$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERPRODUCT_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;
  END IF;
  if (:new.SubKESR is null) then 
    :new.SubKESR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.FinSourceCls is null) then 
    :new.FinSourceCls := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.TenderObjectCls is null) then 
    :new.TenderObjectCls := 0;
  END IF;
  if (:new.FactCls is null) then 
    :new.FactCls := 0;
  END IF;
  if (:new.OKATO is null) then 
    :new.OKATO := 0;
  END IF;
  if (:new.MeansTypeCls is null) then 
    :new.MeansTypeCls := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.AcceptPrice is null) then 
    :new.AcceptPrice := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  if (:new.AcceptAmount is null) then 
    :new.AcceptAmount := 0;
  END IF;
  if (:new.AcceptMonth01 is null) then 
    :new.AcceptMonth01 := 0;
  END IF;
  if (:new.AcceptMonth02 is null) then 
    :new.AcceptMonth02 := 0;
  END IF;
  if (:new.AcceptMonth03 is null) then 
    :new.AcceptMonth03 := 0;
  END IF;
  if (:new.AcceptMonth04 is null) then 
    :new.AcceptMonth04 := 0;
  END IF;
  if (:new.AcceptMonth05 is null) then 
    :new.AcceptMonth05 := 0;
  END IF;
  if (:new.AcceptMonth06 is null) then 
    :new.AcceptMonth06 := 0;
  END IF;
  if (:new.AcceptMonth07 is null) then 
    :new.AcceptMonth07 := 0;
  END IF;
  if (:new.AcceptMonth08 is null) then 
    :new.AcceptMonth08 := 0;
  END IF;
  if (:new.AcceptMonth09 is null) then 
    :new.AcceptMonth09 := 0;
  END IF;
  if (:new.AcceptMonth10 is null) then 
    :new.AcceptMonth10 := 0;
  END IF;
  if (:new.AcceptMonth11 is null) then 
    :new.AcceptMonth11 := 0;
  END IF;
  if (:new.AcceptMonth12 is null) then 
    :new.AcceptMonth12 := 0;
  END IF;
  if (:new.AcceptQuarter1 is null) then 
    :new.AcceptQuarter1 := 0;
  END IF;
  if (:new.AcceptQuarter2 is null) then 
    :new.AcceptQuarter2 := 0;
  END IF;
  if (:new.AcceptQuarter3 is null) then 
    :new.AcceptQuarter3 := 0;
  END IF;
  if (:new.AcceptQuarter4 is null) then 
    :new.AcceptQuarter4 := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
  if (:new.DeliverySpec is null) then 
    :new.DeliverySpec := 0;
  END IF;
  if (:new.DeliveryPeriod is null) then 
    :new.DeliveryPeriod := 0;
  END IF;
  if (:new.DeliveryAmount is null) then 
    :new.DeliveryAmount := 0;
  END IF;
  if (:new.VatPercent is null) then 
    :new.VatPercent := 0;
  END IF;
  if (:new.AcceptVatSumma is null) then 
    :new.AcceptVatSumma := 0;
  END IF;
  if (:new.AcceptCost is null) then 
    :new.AcceptCost := 0;
  END IF;
  if (:new.AcceptTotalSumma is null) then 
    :new.AcceptTotalSumma := 0;
  END IF;
  if (:new.Equivalent is null) then 
    :new.Equivalent := 0;    
  END IF;
  if (:new.SummaYear2 is null) then 
    :new.SummaYear2 := 0;
  END IF;
  if (:new.SummaYear3 is null) then 
    :new.SummaYear3 := 0;
  END IF;
  if (:new.SummaOtherYears is null) then 
    :new.SummaOtherYears := 0;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.MEANSTYPECLS, :new.MEANSTYPECLS,
  :new.targetcls,:new.targetcls);   
  /*   */
  GetDocumentKESR(:old.SubKESR, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_TENDERPRODUCT_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  :new.AcceptQuarter1 := :new.AcceptMonth01 + :new.AcceptMonth02 + :new.AcceptMonth03;
  :new.AcceptQuarter2 := :new.AcceptMonth04 + :new.AcceptMonth05 + :new.AcceptMonth06;
  :new.AcceptQuarter3 := :new.AcceptMonth07 + :new.AcceptMonth08 + :new.AcceptMonth09;
  :new.AcceptQuarter4 := :new.AcceptMonth10 + :new.AcceptMonth11 + :new.AcceptMonth12;
  :new.AcceptSumma := :new.AcceptQuarter1 + :new.AcceptQuarter2 + :new.AcceptQuarter3 + :new.AcceptQuarter4;

-- - - - - - - - - - - - -
-- BU_20 (TR_TENDERPRODUCT_BU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.PositionNumber is null) then
    select Max(PositionNumber)     INTO PosNumber$ from TenderProduct
    where (RecordIndex = :new.RecordIndex) and (ProgIndex = :new.ProgIndex)
    ;
    if (PosNumber$ is null) then
      PosNumber$ := 0;
    END IF;
    :new.PositionNumber := PosNumber$ + 1;

  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_TenderProduct_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_410 (TR_TENDERPRODUCT_BU_410)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  FOR REC$1 IN (SELECT tl.ID  AS lotref FROM TenderLot tl WHERE (tl.ID = :new.LotRef) AND (tl.RecordIndex = :new.RecordIndex)   )
  LOOP
    if (not ((REC$1.lotref  = :new.LotRef) or (:new.lotref is null))) then
      RaiseException('EX_TEN_UNKNOWNLOT');
    END IF;
  END LOOP;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERPRODUCT_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

  if (:New.RVersion is null) then
    :New.RVersion := 1;
  elsif ((:New.RVersion = -1) and (:Old.RVersion <> -1)) then
    :New.RVersion := :Old.RVersion;
  else
    :New.RVersion := :Old.RVersion + 1;
  end if;

END;
/
-- CREATE TRIGGER TR_TENDERPRODUCT_BI_1
CREATE OR REPLACE TRIGGER TR_TENDERPRODUCT_BI
  BEFORE INSERT
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  PosNumber$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERPRODUCT_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.SubKESR is null) then 
    :new.SubKESR := 0;
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KVR is null) then 
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.FinSourceCls is null) then 
    :new.FinSourceCls := 0;
  END IF;
  if (:new.FinType is null) then 
    :new.FinType := 0;
  END IF;
  if (:new.TenderObjectCls is null) then 
    :new.TenderObjectCls := 0;
  END IF;
  if (:new.FactCls is null) then 
    :new.FactCls := 0;
  END IF;
  if (:new.OKATO is null) then 
    :new.OKATO := 0;
  END IF;
  if (:new.MeansTypeCls is null) then 
    :new.MeansTypeCls := 0;
  END IF;
  if (:new.DirectionCls is null) then 
    :new.DirectionCls := 0;
  END IF;
  if (:new.AcceptPrice is null) then 
    :new.AcceptPrice := 0;
  END IF;
  if (:new.PriceVAT is null) then 
    :new.PriceVAT := 0;
  END IF;
  if (:new.AcceptAmount is null) then 
    :new.AcceptAmount := 0;
  END IF;
  if (:new.AcceptMonth01 is null) then 
    :new.AcceptMonth01 := 0;
  END IF;
  if (:new.AcceptMonth02 is null) then 
    :new.AcceptMonth02 := 0;
  END IF;
  if (:new.AcceptMonth03 is null) then 
    :new.AcceptMonth03 := 0;
  END IF;
  if (:new.AcceptMonth04 is null) then 
    :new.AcceptMonth04 := 0;
  END IF;
  if (:new.AcceptMonth05 is null) then 
    :new.AcceptMonth05 := 0;
  END IF;
  if (:new.AcceptMonth06 is null) then 
    :new.AcceptMonth06 := 0;
  END IF;
  if (:new.AcceptMonth07 is null) then 
    :new.AcceptMonth07 := 0;
  END IF;
  if (:new.AcceptMonth08 is null) then 
    :new.AcceptMonth08 := 0;
  END IF;
  if (:new.AcceptMonth09 is null) then 
    :new.AcceptMonth09 := 0;
  END IF;
  if (:new.AcceptMonth10 is null) then 
    :new.AcceptMonth10 := 0;
  END IF;
  if (:new.AcceptMonth11 is null) then 
    :new.AcceptMonth11 := 0;
  END IF;
  if (:new.AcceptMonth12 is null) then 
    :new.AcceptMonth12 := 0;
  END IF;
  if (:new.AcceptQuarter1 is null) then 
    :new.AcceptQuarter1 := 0;
  END IF;
  if (:new.AcceptQuarter2 is null) then 
    :new.AcceptQuarter2 := 0;
  END IF;
  if (:new.AcceptQuarter3 is null) then 
    :new.AcceptQuarter3 := 0;
  END IF;
  if (:new.AcceptQuarter4 is null) then 
    :new.AcceptQuarter4 := 0;
  END IF;
  if (:new.AcceptSumma is null) then 
    :new.AcceptSumma := 0;
  END IF;
  if (:new.DeliverySpec is null) then 
    :new.DeliverySpec := 0;
  END IF;
  if (:new.DeliveryPeriod is null) then 
    :new.DeliveryPeriod := 0;
  END IF;
  if (:new.DeliveryAmount is null) then 
    :new.DeliveryAmount := 0;
  END IF;
  if (:new.VatPercent is null) then 
    :new.VatPercent := 0;
  END IF;
  if (:new.AcceptVatSumma is null) then 
    :new.AcceptVatSumma := 0;
  END IF;
  if (:new.AcceptCost is null) then 
    :new.AcceptCost := 0;
  END IF;
  if (:new.AcceptTotalSumma is null) then 
    :new.AcceptTotalSumma := 0;
  END IF;
  if (:new.Equivalent is null) then 
    :new.Equivalent := 0;
  END IF;
  if (:new.SummaYear2 is null) then 
    :new.SummaYear2 := 0;
  END IF;
  if (:new.SummaYear3 is null) then 
    :new.SummaYear3 := 0;
  END IF;
  if (:new.SummaOtherYears is null) then 
    :new.SummaOtherYears := 0;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.MEANSTYPECLS,
  :new.targetcls,:new.targetcls); 
  /*   */
  GetDocumentKESR(null, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_TENDERPRODUCT_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  :new.AcceptQuarter1 := :new.AcceptMonth01 + :new.AcceptMonth02 + :new.AcceptMonth03;
  :new.AcceptQuarter2 := :new.AcceptMonth04 + :new.AcceptMonth05 + :new.AcceptMonth06;
  :new.AcceptQuarter3 := :new.AcceptMonth07 + :new.AcceptMonth08 + :new.AcceptMonth09;
  :new.AcceptQuarter4 := :new.AcceptMonth10 + :new.AcceptMonth11 + :new.AcceptMonth12;
  :new.AcceptSumma := :new.AcceptQuarter1 + :new.AcceptQuarter2 + :new.AcceptQuarter3 + :new.AcceptQuarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERPRODUCT_BI_10)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

    /*   1.2 */
   IF (:NEW.FacialAccCls IS NULL) THEN :NEW.FacialAccCls := 0; END IF;

   /*  .  ,     */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      BEGIN
         SELECT fa.BudgetRef
           INTO :NEW.BudgetRef
           FROM FacialAcc_Cls fa
          WHERE fa.ID = :NEW.FacialAccCls;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            :NEW.BudgetRef := NULL;
      END;
   END IF;

   /*  ,    */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      GetIntConst (-1, 3, :NEW.BudgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_TENDERPRODUCT_BI_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.PositionNumber is null) then
    select Max(PositionNumber)     INTO PosNumber$ from TenderProduct
    where (RecordIndex = :new.RecordIndex) and (ProgIndex = :new.ProgIndex)
    ;
    if (PosNumber$ is null) then
      PosNumber$ := 0;
    END IF;
    :new.PositionNumber := PosNumber$ + 1;

  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERPRODUCT_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then
    :new.senderIdKey := -1;

  else
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_410 (TR_TENDERPRODUCT_BI_410)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  FOR REC$1 IN (SELECT tl.ID  AS lotref FROM TenderLot tl WHERE (tl.ID = :new.LotRef) AND (tl.RecordIndex = :new.RecordIndex)   )
  LOOP
    if (not ((REC$1.lotref  = :new.LotRef) or (:new.lotref is null))) then
      RaiseException('EX_TEN_UNKNOWNLOT');
    END IF;
  END LOOP;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERPRODUCT_BI_500)
-- Last update 18.04.2006
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
commit
/
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BU_1
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BI_1
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear1 is null) then 
    new$SummaYear1 := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear1Delta is null) then 
    new$SummaYear1Delta := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
commit
/

-- #########################################################
-- #########################################################
-- Del_OldField_TenderObjects.sql
-- #########################################################
-- #########################################################

/*    KESR, TENDEROBJREPLACE, WEBID   TENDEROBJECTS*/
-- CREATE TRIGGER tr_tenderobjects_bi
CREATE OR REPLACE TRIGGER TR_TENDEROBJECTS_BI
  BEFORE INSERT
  ON TENDEROBJECTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDEROBJECTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.MEASUREMENTCLS is null) then 
    :new.MEASUREMENTCLS := 0;
  END IF;
  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;
  END IF;
  if (:new.OKPD2 is null) then 
    :new.OKPD2 := 0;
  END IF;
  if (:new.OKVED2 is null) then 
    :new.OKVED2 := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDEROBJECTS_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then
    :new.senderIdKey := -1;

  else
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDEROBJECTS_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tenderobjects_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (:new.realid is null) then
    :new.realid := :new.id;
  END IF;

END;
/
commit work
/
-- CREATE TRIGGER tr_tenderobjects_bu_0
CREATE OR REPLACE TRIGGER TR_TENDEROBJECTS_BU
  BEFORE UPDATE
  ON TENDEROBJECTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDEROBJECTS_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.MEASUREMENTCLS is null) then 
    :new.MEASUREMENTCLS := 0;
  END IF;
  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;
  END IF;
  if (:new.OKPD2 is null) then 
    :new.OKPD2 := 0;
  END IF;
  if (:new.OKVED2 is null) then 
    :new.OKVED2 := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDEROBJECTS_BU_200)
-- Create 01.11.2004
-- - - - - - - - - - - - -

  /*        */
  if (:new.DocStateRef <> :old.DocStateRef) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
    values(:new.id, :old.DocStateRef, :new.DocStateRef);
  end if;

-- - - - - - - - - - - - -
-- BU_600 (tenderobjects_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (:new.realid is null) then
    :new.realid := :new.id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDEROBJECTS_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

  if (:New.RVersion is null) then
    :New.RVersion := 1;
  elsif ((:New.RVersion = -1) and (:Old.RVersion <> -1)) then
    :New.RVersion := :Old.RVersion;
  else
    :New.RVersion := :Old.RVersion + 1;
  end if;

END;
/
commit work
/
DROP INDEX IDX_TENDEROBJECTS_WEBID
/
commit work
/
ALTER TABLE TENDEROBJECTS DROP (KESR)
/
commit work
/
ALTER TABLE TENDEROBJECTS DROP (TENDEROBJREPLACE)
/
commit work
/
ALTER TABLE TENDEROBJECTS DROP (WEBID)
/
commit work
/
delete from DESCRDOCUMENTFIELDS where id in (110005, 110013)
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_BudStruct_add_InvestObject_KRKS.sql
-- #########################################################
-- #########################################################

/*  ""  ""    */
ALTER TABLE TB_BudStruct ADD (
  ContractCostsCls NUMBER(10),/*  */
    CHECK((ContractCostsCls<=2147483647)AND(ContractCostsCls>-2147483648)),
  InvestObject NUMBER(10)/*  */,
    CHECK((InvestObject<=2147483647)AND(InvestObject>-2147483648))
)
/

CREATE OR REPLACE VIEW BudStruct (
  ID,
  KFSR,
  KVSR,
  KCSR,
  KVR,
  KESR,
  SUBKESR,
  REGIONCLS,
  FACT,
  FINTYPE,
  MEANSTYPE,
  ACTUALDATE,
  CREATEDATE,
  CREATERUSER,
  UPDATEDATE,
  UPDATERUSER,
  DIRECTIONCLS,
  BUDGETREF,
  TRANSFERTCLS,
  STARTDATE,
  ISLIMITSPEND,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  SUBSIDYCLS,
  ASSIGNMENTKIND,
  TARGETCLS,
  CONTRACTCOSTSCLS,
  INVESTOBJECT)
AS
  SELECT
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT
  FROM TB_BudStruct
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_ID
  INSTEAD OF DELETE
  ON BUDSTRUCT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDSTRUCT_BD_0)
-- - - - - - - - - - - - -

--      BudStrLink
  delete from BudStrLink
  where BudStruct = :old.Id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDSTRUCT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDSTRUCT_AD_500)
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate)
    values(141, :old.ID, SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_II
  INSTEAD OF INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCT_BI_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (tr_budstruct_bi_100)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null)))
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCT_BI_500)
-- Last update 22.02.2004
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDSTRUCT (
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT
  ) VALUES (
    new$ID,
    new$KFSR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$REGIONCLS,
    new$FACT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$ACTUALDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$DIRECTIONCLS,
    new$BUDGETREF,
    new$TRANSFERTCLS,
    new$STARTDATE,
    new$ISLIMITSPEND,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$SUBSIDYCLS,
    new$ASSIGNMENTKIND,
    new$TARGETCLS,
    new$CONTRACTCOSTSCLS,
    new$INVESTOBJECT);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_IU
  INSTEAD OF UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCT_BU_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (tr_budstruct_bu_100)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  (id <> :old.id)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDSTRUCT SET
    ID = new$ID,
    KFSR = new$KFSR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    REGIONCLS = new$REGIONCLS,
    FACT = new$FACT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    ACTUALDATE = new$ACTUALDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    DIRECTIONCLS = new$DIRECTIONCLS,
    BUDGETREF = new$BUDGETREF,
    TRANSFERTCLS = new$TRANSFERTCLS,
    STARTDATE = new$STARTDATE,
    ISLIMITSPEND = new$ISLIMITSPEND,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TARGETCLS = new$TARGETCLS,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    INVESTOBJECT = new$INVESTOBJECT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDSTRUCT_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (141, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=141) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE BudStructRights ADD (
  ContractCostsCls VARCHAR2(20),/* ,   */
  ContractCostsClsUp VARCHAR2(20),/* ,   */
  InvestObject VARCHAR2(50),/* ,   */
  InvestObjectUp VARCHAR2(50)/* ,   */
)
/
commit work 
/
ALTER TABLE TB_BUDSTRUCT ADD (
  CONSTRAINT FK_BUDSTRUCT_CONTRACTCOST FOREIGN KEY (ContractCostsCls) REFERENCES ContractCostsCls(ID)
)
/
CREATE INDEX FK_BUDSTRUCT_CONTRACTCOST ON TB_BUDSTRUCT(ContractCostsCls)
/
ALTER TABLE TB_BUDSTRUCT ADD (
  CONSTRAINT FK_BUDSTRUCT_INVESTOBJECT FOREIGN KEY (INVESTOBJECT) REFERENCES INVESTOBJECT(ID)
)
/
CREATE INDEX FK_BUDSTRUCT_INVESTOBJECT ON TB_BUDSTRUCT(INVESTOBJECT)
/
ALTER TRIGGER TR_BUDSTRUCTRIGHTS_BU_500 DISABLE
/
commit work 
/
UPDATE BudStructRights SET 
  ContractCostsCls = '000',
  ContractCostsClsUp = '',
  InvestObject = '00000000000000000000',
  InvestObjectUp = ''
/
commit work 
/
ALTER TRIGGER TR_BUDSTRUCTRIGHTS_BU_500 ENABLE
/
commit work 
/
-- ALTER TRIGGER tr_budstruct_bi_100
CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_II
  INSTEAD OF INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCT_BI_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (tr_budstruct_bi_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null)))
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCT_BI_500)
-- Last update 22.02.2004
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDSTRUCT (
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT
  ) VALUES (
    new$ID,
    new$KFSR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$REGIONCLS,
    new$FACT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$ACTUALDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$DIRECTIONCLS,
    new$BUDGETREF,
    new$TRANSFERTCLS,
    new$STARTDATE,
    new$ISLIMITSPEND,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$SUBSIDYCLS,
    new$ASSIGNMENTKIND,
    new$TARGETCLS,
    new$CONTRACTCOSTSCLS,
    new$INVESTOBJECT);

END;
/
-- ALTER TRIGGER tr_budstruct_bu_100
CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_IU
  INSTEAD OF UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCT_BU_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (tr_budstruct_bu_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null))) and
  (id <> :old.id)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDSTRUCT SET
    ID = new$ID,
    KFSR = new$KFSR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    REGIONCLS = new$REGIONCLS,
    FACT = new$FACT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    ACTUALDATE = new$ACTUALDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    DIRECTIONCLS = new$DIRECTIONCLS,
    BUDGETREF = new$BUDGETREF,
    TRANSFERTCLS = new$TRANSFERTCLS,
    STARTDATE = new$STARTDATE,
    ISLIMITSPEND = new$ISLIMITSPEND,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TARGETCLS = new$TARGETCLS,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    INVESTOBJECT = new$INVESTOBJECT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDSTRUCT_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (141, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=141) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER tr_budstructrights_bi_0
CREATE OR REPLACE TRIGGER TR_BUDSTRUCTRIGHTS_BI
  BEFORE INSERT
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCTRIGHTS_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID is null) then 
    select g_shared.nextval into :new.ID from dual;
  END IF;
  if (:new.RightRef is null) then 
    :new.RightRef := 4;
  END IF;
  if (:new.IsGroup is null) then 
    :new.IsGroup := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if ((:new.KCSR is null) or (:new.KCSR  is null)) then 
    :new.KCSR := '0';
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if ((:new.KVR is null) or (:new.KVR  is null)) then 
    :new.KVR := '0';
  END IF;
  if ((:new.KESR is null) or (:new.KESR  is null)) then 
    :new.KESR := '0';
  END IF;
  if ((:new.SubKESR is null) or (:new.SubKESR  is null)) then 
    :new.SubKESR := '0';
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if ((:new.DirectionCls is null) or (:new.DirectionCls  is null)) then 
    :new.DirectionCls := '0';
  END IF;
  if ((:new.Fact is null) or (:new.Fact  is null)) then 
    :new.Fact := '0';
  END IF;
  if ((:new.FinType is null) or (:new.FinType  is null)) then 
    :new.FinType := '0';
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.TransfertCls is null) then 
    :new.TransfertCls := 0;
  END IF;
  if ((:new.BudAllocationCls is null) or (:new.BudAllocationCls  is null)) then 
    :new.BudAllocationCls := '0';
  END IF;
  if ((:new.PayPromiseCls is null) or (:new.PayPromiseCls  is null)) then 
    :new.PayPromiseCls := '0';
  END IF;
  if ((:new.SubsidyCls is null) or (:new.SubsidyCls  is null)) then 
    :new.SubsidyCls := '0';
  END IF;
  if (:new.AssignmentKind is null) then 
    :new.AssignmentKind := 0;
  END IF;
  if ((:new.ContractCostsCls is null) or (:new.ContractCostsCls  is null)) then 
    :new.ContractCostsCls := '0';
  END IF;
  if ((:new.InvestObject is null) or (:new.InvestObject  is null)) then 
    :new.InvestObject := '0';
  END IF;
  if (:new.KfsrUP is null) then 
    :new.KFSRUp := :new.KFSR;
  END IF;
  if (:new.KVSRUP is null) then 
    :new.KVSRUP := :new.KVSR;
  END IF;
  if (:new.KCSRUP is null) then 
    :new.KCSRUP := :new.KCSR;
  END IF;
  if (:new.KVRUP is null) then 
    :new.KVRUP := :new.KVR;
  END IF;
  if (:new.KesrUP is null) then 
    :new.KesrUP := :new.Kesr;
  END IF;
  if (:new.SubKESRUP is null) then 
    :new.SubKESRUP := :new.SubKESR;
  END IF;
  if (:new.RegionClsUP is null) then 
    :new.RegionClsUP := :new.RegionCls;
  END IF;
  if ((:new.DirectionClsUp is null) or (:new.DirectionClsUp  is null)) then 
    :new.DirectionClsUp := :new.DirectionCls;
  END IF;
  if ((:new.FactUP is null) or (:new.FactUP is null)) then 
    :new.FactUP := :new.Fact;
  END IF;
  if ((:new.FinTypeUP is null) or (:new.FinTypeUP is null)) then 
    :new.FinTypeUP := :new.FinType;
  END IF;
  if (:new.MeansTypeUP is null) then 
    :new.MeansTypeUP := :new.MeansType;
  END IF;
  if (:new.TransfertClsUp is null) then 
    :new.TransfertClsUp := :new.TransfertCls;
  END IF;
  if ((:new.BudAllocationClsUp is null) or (:new.BudAllocationClsUp  is null)) then 
    :new.BudAllocationClsUp := :new.BudAllocationCls;
  END IF;
  if ((:new.PayPromiseClsUp is null) or (:new.PayPromiseClsUp  is null)) then 
    :new.PayPromiseClsUp := :new.PayPromiseCls;
  END IF;
  if ((:new.SubsidyClsUp is null) or (:new.SubsidyClsUp  is null)) then 
    :new.SubsidyClsUp := :new.SubsidyCls;
  END IF;
  if (:new.AssignmentKindUP is null) then 
    :new.AssignmentKindUP := :new.AssignmentKind;
  END IF;
  if ((:new.ContractCostsClsUp is null) or (:new.ContractCostsClsUp  is null)) then 
    :new.ContractCostsClsUp := :new.ContractCostsCls;
  END IF;
  if ((:new.InvestObjectUp is null) or (:new.InvestObjectUp  is null)) then 
    :new.InvestObjectUp := :new.InvestObject;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCTRIGHTS_BI_500)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER tr_budstructrights_bu_0
CREATE OR REPLACE TRIGGER TR_BUDSTRUCTRIGHTS_BU
  BEFORE UPDATE
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCTRIGHTS_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.RightRef is null) then 
    :new.RightRef := 4;
  END IF;
  if (:new.IsGroup is null) then 
    :new.IsGroup := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if ((:new.KCSR is null) or (:new.KCSR  is null)) then 
    :new.KCSR := '0';
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if ((:new.KVR is null) or (:new.KVR  is null)) then 
    :new.KVR := '0';
  END IF;
  if ((:new.KESR is null) or (:new.KESR  is null)) then 
    :new.KESR := '0';
  END IF;
  if ((:new.SubKESR is null) or (:new.SubKESR  is null)) then 
    :new.SubKESR := '0';
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if ((:new.DirectionCls is null) or (:new.DirectionCls  is null)) then 
    :new.DirectionCls := '0';
  END IF;
  if ((:new.Fact is null) or (:new.Fact  is null)) then 
    :new.Fact := '0';
  END IF;
  if ((:new.FinType is null) or (:new.FinType  is null)) then 
    :new.FinType := '0';
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.TransfertCls is null) then 
    :new.TransfertCls := 0;
  END IF;
  if ((:new.BudAllocationCls is null) or (:new.BudAllocationCls  is null)) then 
    :new.BudAllocationCls := '0';
  END IF;
  if ((:new.PayPromiseCls is null) or (:new.PayPromiseCls  is null)) then 
    :new.PayPromiseCls := '0';
  END IF;
  if ((:new.SubsidyCls is null) or (:new.SubsidyCls  is null)) then 
    :new.SubsidyCls := '0';
  END IF;
  if (:new.AssignmentKind is null) then 
    :new.AssignmentKind := 0;
  END IF;
  if ((:new.ContractCostsCls is null) or (:new.ContractCostsCls  is null)) then 
    :new.ContractCostsCls := '0';
  END IF;
  if ((:new.InvestObject is null) or (:new.InvestObject  is null)) then 
    :new.InvestObject := '0';
  END IF;
  if (:new.KfsrUP is null) then 
    :new.KFSRUp := :new.KFSR;
  END IF;
  if (:new.KVSRUP is null) then 
    :new.KVSRUP := :new.KVSR;
  END IF;
  if (:new.KCSRUP is null) then 
    :new.KCSRUP := :new.KCSR;
  END IF;
  if (:new.KVRUP is null) then 
    :new.KVRUP := :new.KVR;
  END IF;
  if (:new.KesrUP is null) then 
    :new.KesrUP := :new.Kesr;
  END IF;
  if (:new.SubKESRUP is null) then 
    :new.SubKESRUP := :new.SubKESR;
  END IF;
  if (:new.RegionClsUP is null) then 
    :new.RegionClsUP := :new.RegionCls;
  END IF;
  if ((:new.DirectionClsUp is null) or (:new.DirectionClsUp  is null)) then 
    :new.DirectionClsUp := :new.DirectionCls;
  END IF;
  if ((:new.FactUP is null) or (:new.FactUP is null)) then 
    :new.FactUP := :new.Fact;
  END IF;
  if ((:new.FinTypeUP is null) or (:new.FinTypeUP is null)) then 
    :new.FinTypeUP := :new.FinType;
  END IF;
  if (:new.MeansTypeUP is null) then 
    :new.MeansTypeUP := :new.MeansType;
  END IF;
  if (:new.TransfertClsUp is null) then 
    :new.TransfertClsUp := :new.TransfertCls;
  END IF;
  if ((:new.BudAllocationClsUp is null) or (:new.BudAllocationClsUp  is null)) then 
    :new.BudAllocationClsUp := :new.BudAllocationCls;
  END IF;
  if ((:new.PayPromiseClsUp is null) or (:new.PayPromiseClsUp  is null)) then 
    :new.PayPromiseClsUp := :new.PayPromiseCls;
  END IF;
  if ((:new.SubsidyClsUp is null) or (:new.SubsidyClsUp  is null)) then 
    :new.SubsidyClsUp := :new.SubsidyCls;
  END IF;
  if (:new.AssignmentKindUP is null) then 
    :new.AssignmentKindUP := :new.AssignmentKind;
  END IF;
  if ((:new.ContractCostsClsUp is null) or (:new.ContractCostsClsUp  is null)) then 
    :new.ContractCostsClsUp := :new.ContractCostsCls;
  END IF;
  if ((:new.InvestObjectUp is null) or (:new.InvestObjectUp  is null)) then 
    :new.InvestObjectUp := :new.InvestObject;
  END IF;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_TargetCls_InvestObject_Code_50.sql
-- #########################################################
-- #########################################################


/* <InvestObject_FixTargeCls.sql
     ""   " "   "", "   ",
  " "   ""  50  */
ALTER TRIGGER TR_TARGETCLS_BU_500 DISABLE
/

ALTER TABLE targetcls ADD (
  TempStrCode VARCHAR2(50)
)
/

ALTER TABLE TARGETCLS DROP CONSTRAINT UQ_TARGETCLS_VER_KEY DROP INDEX
/

commit work 
/

update targetcls set
  TempStrCode = StrCode
/

ALTER TABLE targetcls DROP (StrCode)
/

commit work 
/

ALTER TABLE targetcls ADD (
  StrCode VARCHAR2(50)
)
/

commit work 
/

update targetcls set
  StrCode = TempStrCode
/

ALTER TABLE targetcls DROP (TempStrCode)
/

ALTER TABLE TARGETCLS ADD (
  CONSTRAINT UQ_TARGETCLS_VER_KEY UNIQUE (STRCODE, BUDGETREF, EXTID)
)
/

ALTER TRIGGER TR_TARGETCLS_BU_500 ENABLE
/

commit work 
/

ALTER TRIGGER TR_INVESTOBJECT_BU_500 DISABLE
/

ALTER TABLE INVESTOBJECT ADD (
  TempCODE VARCHAR2(50),
  TempSUBCODE VARCHAR2(50),
  TempBUDGETFINSOURCEOBJECTCODE VARCHAR2(50)
)
/

-- drop trigger tr_InvestObject_bi_0
CREATE OR REPLACE TRIGGER TR_INVESTOBJECT_BI
  BEFORE INSERT
  ON INVESTOBJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_500 (tr_InvestObject_bi_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/

-- drop trigger tr_InvestObject_bu_0
DROP TRIGGER TR_INVESTOBJECT_BU
/

/*  tr_InvestObject_bi_0  tr_InvestObject_bu_0   SQL  InvestObject_FixTargeCls.sql */
ALTER TABLE INVESTOBJECT DROP CONSTRAINT UQ_INVESTOBJECT_VER_KEY DROP INDEX
/

commit work 
/

update INVESTOBJECT set
  TempCODE = CODE,
  TempSUBCODE = SUBCODE,
  TempBUDGETFINSOURCEOBJECTCODE = BUDGETFINSOURCEOBJECTCODE
/

ALTER TABLE INVESTOBJECT DROP (CODE)
/

ALTER TABLE INVESTOBJECT DROP (SUBCODE)
/

ALTER TABLE INVESTOBJECT DROP (BUDGETFINSOURCEOBJECTCODE)
/

commit work 
/

ALTER TABLE INVESTOBJECT ADD (
  CODE VARCHAR2(50),
  SUBCODE VARCHAR2(50),
  BUDGETFINSOURCEOBJECTCODE VARCHAR2(50)
)
/

commit work 
/

update INVESTOBJECT set
  CODE = TempCODE,
  SUBCODE = TempSUBCODE,
  BUDGETFINSOURCEOBJECTCODE = TempBUDGETFINSOURCEOBJECTCODE
/

ALTER TABLE INVESTOBJECT DROP (TempCODE)
/

ALTER TABLE INVESTOBJECT DROP (TempSUBCODE)
/

ALTER TABLE INVESTOBJECT DROP (TempBUDGETFINSOURCEOBJECTCODE)
/

ALTER TABLE INVESTOBJECT ADD (
  CONSTRAINT UQ_INVESTOBJECT_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/

ALTER TRIGGER TR_INVESTOBJECT_BU_500 ENABLE
/

commit work 
/

ALTER TRIGGER TR_LAYERDATA_BU_500 DISABLE
/

ALTER TABLE LAYERDATA ADD (
  TempTARGETCLS VARCHAR2(50),
  TempINVESTOBJECT VARCHAR2(50)
)
/

drop index IDX_LAYERDATA_INVESTOBJECT
/

drop index IDX_LAYERDATA_TARGETCLS
/

commit work 
/

update LAYERDATA set
  TempTARGETCLS = TARGETCLS,
  TempINVESTOBJECT = INVESTOBJECT
/

ALTER TABLE LAYERDATA DROP (TARGETCLS)
/

ALTER TABLE LAYERDATA DROP (INVESTOBJECT)
/

commit work 
/

ALTER TABLE LAYERDATA ADD (
  TARGETCLS VARCHAR2(50),
  INVESTOBJECT VARCHAR2(50)
)
/

commit work 
/

update LAYERDATA set
  TARGETCLS = TempTARGETCLS,
  INVESTOBJECT = TempINVESTOBJECT
/

ALTER TABLE LAYERDATA DROP (TempTARGETCLS)
/

ALTER TABLE LAYERDATA DROP (TempINVESTOBJECT)
/

create index IDX_LAYERDATA_INVESTOBJECT on LAYERDATA (INVESTOBJECT)
/

/*   ,     FB */
create index IDX_LAYERDATA_TARGETCLSCLS on LAYERDATA (TARGETCLS)
/

ALTER TRIGGER TR_LAYERDATA_BU_500 ENABLE
/

ALTER TABLE targetcls MODIFY(StrCode NOT NULL)
/

ALTER TABLE INVESTOBJECT MODIFY(CODE NOT NULL)
/

commit work 
/



-- #########################################################
-- #########################################################
-- InvestObject_FixTargeCls.sql
-- #########################################################
-- #########################################################

/*   InvestObject.TargetCls      -   GETTARGETCLS
*/
-- CREATE TRIGGER tr_InvestObject_bi_0
CREATE OR REPLACE TRIGGER TR_INVESTOBJECT_BI
  BEFORE INSERT
  ON INVESTOBJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_InvestObject_bi_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then  
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.OwnerLevel is null) then 
    :new.OwnerLevel := 0;
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if (:new.BudgetFinSourceLevel is null) then 
    :new.BudgetFinSourceLevel := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then 
    :new.Fact := 0;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.InvestDirection is null) then 
    :new.InvestDirection := 0;
  END IF;
  if (:new.DevelopCost is null) then 
    :new.DevelopCost := 0;
  END IF;
  if (:new.TotalCost is null) then 
    :new.TotalCost := 0;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.TransfertCls, null, :new.MeansType,
  :new.TargetCls,:new.TargetCls);

-- - - - - - - - - - - - -
-- BI_500 (tr_InvestObject_bi_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER tr_InvestObject_bu_0
CREATE OR REPLACE TRIGGER TR_InvestObject_BU
  BEFORE UPDATE
  ON InvestObject
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_InvestObject_bu_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     */
  if (:new.Code is null) then  
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.OwnerLevel is null) then 
    :new.OwnerLevel := 0;
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if (:new.BudgetFinSourceLevel is null) then 
    :new.BudgetFinSourceLevel := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if (:new.KCSR is null) then 
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then 
    :new.Fact := 0;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.InvestDirection is null) then 
    :new.InvestDirection := 0;
  END IF;
  if (:new.DevelopCost is null) then 
    :new.DevelopCost := 0;
  END IF;
  if (:new.TotalCost is null) then 
    :new.TotalCost := 0;
  END IF;
  /*    */
  GETTARGETCLS(:old.TransfertCls, :new.TransfertCls, :old.MeansType, :new.MeansType,
  :new.TargetCls,:new.TargetCls);

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- Add_CP_to_Merdoc_OutPayDoc.sql
-- #########################################################
-- #########################################################

/*    CodePurpose (  )   BANKEXCH_MERDOC, ED_OUTPAYDOC*/
ALTER TABLE bankexch_merdoc ADD (
  CodePurpose VARCHAR2(50)
)
/
ALTER TABLE ed_outpaydoc ADD (
  CodePurpose VARCHAR2(50)
)
/
commit work 
/


-- #########################################################
-- #########################################################
-- Alter_SignCertificate.sql
-- #########################################################
-- #########################################################

ALTER TRIGGER TR_SIGNCERT_BU_500 DISABLE
/
commit work 
/
ALTER TABLE SignCertificate ADD (
  RVersion NUMBER(10),
    CHECK((RVersion<=2147483647)AND(RVersion>-2147483648)),
  SenderID NUMBER(10),
    CHECK((SenderID<=2147483647)AND(SenderID>-2147483648)),
  SenderRecordId NUMBER(10),
    CHECK((SenderRecordId<=2147483647)AND(SenderRecordId>-2147483648)),
  DocStateRef NUMBER(10),/*  */
    CHECK((DocStateRef<=2147483647)AND(DocStateRef>-2147483648)),
  AcceptDate NUMBER,/*  */
  RejectCls NUMBER(10),/*  */
    CHECK((RejectCls<=2147483647)AND(RejectCls>-2147483648)),
  RejectCause VARCHAR2(1000),/*   */
  OperationType NUMBER(5),/*  */
  Accepted NUMBER(5),/*  */
  UseStartDate DATE,/*  */
  UseEndDate DATE,/*  */
  AuthSerialNumber VARCHAR2(255),/*   */
  AuthOwnerOrganization VARCHAR2(255),/*  */
  AuthStartDate DATE,/*     */
  AuthEndDate DATE,/*     */
  AdditionalInfo VARCHAR2(255),/*  */
  CryptoStatus NUMBER(10),/*   */
    CHECK((CryptoStatus<=2147483647)AND(CryptoStatus>-2147483648)),
  LastExtrChange DATE/*    */
)
/
commit work 
/

update SignCertificate set Accepted = 1
/
--   
update SignCertificate set DocStateRef = 470103
/
ALTER TRIGGER TR_SIGNCERT_BU_500 ENABLE
/
commit work 
/

ALTER TABLE SignCertificate MODIFY(Accepted NOT NULL)
/

-- #########################################################
-- #########################################################
-- alter_FacialAcc_add_Code.sql
-- #########################################################
-- #########################################################

/*     Code    */
ALTER TABLE TB_FacialAcc_Cls ADD (
  Code VARCHAR2(20)/*    */
)
/

CREATE OR REPLACE VIEW FacialAcc_Cls (
  ID,
  CODE1,
  CODE2,
  CODE3,
  CODE4,
  KVSR,
  KCSR,
  KFSR,
  KVR,
  KESR,
  FINTYPE,
  ORG_REF,
  DATEOPEN,
  SERVICEACCOUNT,
  STATUSACCOUNT,
  HARACTERACCOUNT,
  REGIONCLS,
  CREATEDATE,
  UPDATEDATE,
  FACIALCODE,
  MEANSTYPE,
  GENERALORG_REF,
  DEPARTMENTCLS,
  RVERSION,
  CLOSEDOCNUMBER,
  HIGHERORG_REF,
  BUDGETREF,
  FCACCOUNT,
  CLOSECODE,
  DATECLOSE,
  CREATERUSER,
  UPDATERUSER,
  NOTE,
  NAME,
  ISRBS,
  ISPBS,
  ISBU,
  ISSEPARATEBU,
  ISPROXY,
  OPENDOCNUMBER,
  ISOMS,
  CHANGEDOCNUMBER,
  DATECHANGE,
  GENERALORGFACIALACC,
  GRANTEEORG_REF,
  PREVCLS,
  FACIALCODEEX,
  EXTID,
  EXTROOTID,
  CODE)
AS
  SELECT
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE
  FROM TB_FacialAcc_Cls
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_ID
  INSTEAD OF DELETE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (facialacc_cls_bd0)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(CONSTVALUE ) INTO CNT$1
  from INTCONST where ((CONSTVALUE = :old.id)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('EX_CANNOTDELETE_FACIAL_ACC');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALACC_CLS
  WHERE ID = :OLD.ID
       AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALACC_CLS_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
     VALUES (19, :OLD.ID, SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_II
  INSTEAD OF INSERT
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
--
  OrgDateClose$ Number;
  id_org$ NUMBER(10);
  id_reg$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALACC_CLS_BI_0)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
  if (new$kvsr is null) then
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then
    new$fintype := 0;
  END IF;
  if (new$meanstype is null) then
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then
    new$org_ref := 0; -- ,   select min (...)
  END IF;
  BEGIN

    --     
    select o.generalorg_ref
    into id_org$     from organizations o
    where o.id = new$org_ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (id_org$  is null) then
    id_org$ := new$org_ref;
  END IF;
  new$generalorg_ref := id_org$;
  BEGIN

    --      
    --  -
    --   --------------------------
    select o.RegionCLS
    into id_reg$     from Organizations o
    where o.ID = new$Org_Ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  new$regioncls := id_reg$;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALACC_CLS_BI_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

/*    -    */
   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALACC_CLS_BI_200)
-- Create 27.07.2007
-- - - - - - - - - - - - -

    if (new$Org_Ref is not null) then
      select DateClose into OrgDateClose$ from organizations where Id = new$Org_ref;
      if (OrgDateClose$ is not null) then
         if ((new$DateClose is null) or (new$DateClose > OrgDateClose$)) then
           new$DateClose := OrgDateClose$;
         end if;
         new$StatusAccount := 1;
         new$CloseCode := 10; /*   */
      end if;
    end if;

    if ((new$DateClose is not null) and (new$StatusAccount = 0)) then
      new$StatusAccount := 1;
      new$CloseCode := 1;
    end if;

    if (new$CloseCode is null) then new$CloseCode := 0; end if;

-- - - - - - - - - - - - -
-- BI_400 (TR_FACIALACC_CLS_BI_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALACC_CLS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALACC_CLS (
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE
  ) VALUES (
    new$ID,
    new$CODE1,
    new$CODE2,
    new$CODE3,
    new$CODE4,
    new$KVSR,
    new$KCSR,
    new$KFSR,
    new$KVR,
    new$KESR,
    new$FINTYPE,
    new$ORG_REF,
    new$DATEOPEN,
    new$SERVICEACCOUNT,
    new$STATUSACCOUNT,
    new$HARACTERACCOUNT,
    new$REGIONCLS,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$FACIALCODE,
    new$MEANSTYPE,
    new$GENERALORG_REF,
    new$DEPARTMENTCLS,
    new$RVERSION,
    new$CLOSEDOCNUMBER,
    new$HIGHERORG_REF,
    new$BUDGETREF,
    new$FCACCOUNT,
    new$CLOSECODE,
    new$DATECLOSE,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$NOTE,
    new$NAME,
    new$ISRBS,
    new$ISPBS,
    new$ISBU,
    new$ISSEPARATEBU,
    new$ISPROXY,
    new$OPENDOCNUMBER,
    new$ISOMS,
    new$CHANGEDOCNUMBER,
    new$DATECHANGE,
    new$GENERALORGFACIALACC,
    new$GRANTEEORG_REF,
    new$PREVCLS,
    new$FACIALCODEEX,
    new$EXTID,
    new$EXTROOTID,
    new$CODE);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALACC_CLS_AI_500)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 19) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_IU
  INSTEAD OF UPDATE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
--
  id_org$ NUMBER(10);
  vOrgType$ NUMBER(10);
  id_org1$ NUMBER(10);
  id_reg1$ NUMBER(10);
  DiffCode$ NUMBER(10);
  Code1$ NUMBER(10);
  Code2$ NUMBER(10);
  Code51$ NUMBER(10);
  CodeX$ NUMBER(10);
  vOrgType1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALACC_CLS_BU_0)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$id <> :old.id) then
    facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
  END IF;
  if (new$kvsr is null) then
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then
    new$fintype := 0;
  END IF;
  if (new$regioncls is null) then
    new$regioncls := 0;
  END IF;
  if (new$meanstype is null) then
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then
    new$org_ref := 0; -- ,   select min (...)
  END IF;
  if ((new$org_ref <> :old.org_ref) and not(new$fcaccount is null)) then
    BEGIN
      select org_ref      into id_org1$ from org_accounts
      where id = new$fcaccount
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (id_org1$ <> new$org_ref) then
      new$fcaccount := null;

    END IF;
  END IF;
  if (:old.Org_Ref <> new$Org_Ref) then
    BEGIN
      --   --------------------------
      select o.RegionCLS
      into id_reg1$        from Organizations o
      where o.ID = new$Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    --   -----------------

    new$regioncls := id_reg1$;
    BEGIN
      --       /----
      select o.Org_Type
      into vOrgType$      from Organizations o
      where o.ID = :old.Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType$  >= 10800)and(vOrgType$  <= 10900)) then
      update org_accounts
      set facialacc_cls = null
      where facialacc_cls = :old.id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_FACIALACC_CLS_BU_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALACC_CLS_BU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /* /  ??     ??   AU   */
  if ((((new$DateClose is not null) and (:old.DateClose is null)) or
  ((new$DateClose is null) and (:old.DateClose is not null)))
  and (new$CloseCode = :old.CloseCode))
  then
    BEGIN
      /*      /    .
                / ??    ?
          */
      select o.Org_Type     into vOrgType1$ from Organizations o where o.id = new$org_ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType1$  >= 10800)and(vOrgType1$  <= 10900)) then
      if (new$DateClose is not null or (new$statusaccount = 1 and :old.statusaccount=0))
      then
        update org_accounts set
        CloseCode = CloseCode + 10000,
        DateClose = new$DateClose
        where facialacc_cls = new$id;

      END IF;
      if (new$DateClose is null or (new$statusaccount = 0 and :old.statusaccount=1))
      then
        update org_accounts set
        CloseCode = CloseCode - 10000
        where facialacc_cls = new$id;

      END IF;
    END IF;
    if (new$DateClose is not null) then
      new$CloseCode := 1;
    END IF;
    if (new$DateClose is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /* /   (only      ) */
  if (new$CloseCode <> :old.CloseCode)
  then
    DiffCode$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */
    CloseOrgCls_Div(:old.CloseCode,Code1$, Code2$, CodeX$, CodeX$, Code51$);

    /*   "" */
    if (DiffCode$ = 1) then
      Code1$ := 1;
    END IF;
    if (DiffCode$ = 10) then
      Code2$ := 1;
    END IF;
    if (DiffCode$ = 10000) then
      Code51$ := 1;
    END IF;
    if (DiffCode$ = -1) then
      Code1$ := 0;
    END IF;
    if (DiffCode$ = -10) then
      Code2$ := 0;
    END IF;
    if (DiffCode$ = -10000) then
      Code51$ := 0;
    END IF;
    new$CloseCode := Code1$ + Code2$*10 + Code51$*10000;

    if (new$CloseCode <> 0) then
      new$StatusAccount := 1;
    END IF;

    /*     ??      -  - !*/
    if (((new$CloseCode <> 0) and (new$DateClose is null)) or (new$DateClose >= :old.DateClose)) then
      new$DateClose := :old.DateClose;

    else
      if (new$CloseCode = 0) then
        new$DateClose := null;
        if (new$StatusAccount <> 0) then
          new$StatusAccount := 0;

        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_FACIALACC_CLS_BU_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_550 (TR_FACIALACC_CLS_BU_550)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF ((new$GeneralOrg_ref IS NULL)or(new$Org_Ref <> :old.Org_Ref)) THEN
     select
       o.GeneralOrg_Ref
     into
       id_org$
     from
       Organizations o
     where
       o.id = new$Org_Ref;
      /*      */
     if (id_org$ is Null)
       then id_org$ := new$Org_Ref;
     end if;
     new$GeneralOrg_ref := id_org$;

   END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALACC_CLS_BU_700)
-- Create 19.09.2004
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (NEW$RVersion IS NULL) THEN
      NEW$RVersion := 1;
   ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      NEW$RVersion := :OLD.RVersion;
   ELSE
      NEW$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALACC_CLS SET
    ID = new$ID,
    CODE1 = new$CODE1,
    CODE2 = new$CODE2,
    CODE3 = new$CODE3,
    CODE4 = new$CODE4,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KFSR = new$KFSR,
    KVR = new$KVR,
    KESR = new$KESR,
    FINTYPE = new$FINTYPE,
    ORG_REF = new$ORG_REF,
    DATEOPEN = new$DATEOPEN,
    SERVICEACCOUNT = new$SERVICEACCOUNT,
    STATUSACCOUNT = new$STATUSACCOUNT,
    HARACTERACCOUNT = new$HARACTERACCOUNT,
    REGIONCLS = new$REGIONCLS,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    FACIALCODE = new$FACIALCODE,
    MEANSTYPE = new$MEANSTYPE,
    GENERALORG_REF = new$GENERALORG_REF,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    RVERSION = new$RVERSION,
    CLOSEDOCNUMBER = new$CLOSEDOCNUMBER,
    HIGHERORG_REF = new$HIGHERORG_REF,
    BUDGETREF = new$BUDGETREF,
    FCACCOUNT = new$FCACCOUNT,
    CLOSECODE = new$CLOSECODE,
    DATECLOSE = new$DATECLOSE,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    NOTE = new$NOTE,
    NAME = new$NAME,
    ISRBS = new$ISRBS,
    ISPBS = new$ISPBS,
    ISBU = new$ISBU,
    ISSEPARATEBU = new$ISSEPARATEBU,
    ISPROXY = new$ISPROXY,
    OPENDOCNUMBER = new$OPENDOCNUMBER,
    ISOMS = new$ISOMS,
    CHANGEDOCNUMBER = new$CHANGEDOCNUMBER,
    DATECHANGE = new$DATECHANGE,
    GENERALORGFACIALACC = new$GENERALORGFACIALACC,
    GRANTEEORG_REF = new$GRANTEEORG_REF,
    PREVCLS = new$PREVCLS,
    FACIALCODEEX = new$FACIALCODEEX,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    CODE = new$CODE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALACC_CLS_AU_500)
-- Create 28.04.2005
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (19, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 19) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/
ALTER TRIGGER TR_FACIALACC_CLS_BU_500 DISABLE
/
update FacialAcc_Cls set
  Code = id
/
update FacialAcc_Cls set
  code='00000000' || code
where
  code like '_'
/
update FacialAcc_Cls set
  code='0000000' || code
where
  code like '__'
/
update FacialAcc_Cls set
  code='000000' || code
where
  code like '___'
/
update FacialAcc_Cls set
  code='00000' || code
where
  code like '____'
/
update FacialAcc_Cls set
  code='0000' || code
where
  code like '_____'
/
update FacialAcc_Cls set
  code='000' || code
where
  code like '______'
/
update FacialAcc_Cls set
  code='00' || code
where
  code like '_______'
/
update FacialAcc_Cls set
  code='0' || code
where
  code like '________'
/
ALTER TRIGGER TR_FACIALACC_CLS_BU_500 ENABLE
/
commit work
/
-- ALTER TRIGGER TR_FACIALACC_CLS_BI_0
CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_II
  INSTEAD OF INSERT
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
--
  OrgDateClose$ Number;
  id_org1$ NUMBER(10);
  id_reg1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALACC_CLS_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
  --   ,   
  if (new$Code is null) then
    FormatClsStr(new$ID, 9,new$Code);
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0;
  END IF;
  BEGIN

    --     
    select o.generalorg_ref
    into id_org1$   from organizations o
    where o.id = new$org_ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (id_org1$  is null) then 
    id_org1$ := new$org_ref;
  END IF;
  new$generalorg_ref := id_org1$;
  BEGIN

    --  /  -
    select o.RegionCLS
    into id_reg1$   from Organizations o
    where o.ID = new$Org_Ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  new$regioncls := id_reg1$;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALACC_CLS_BI_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

/*    -    */
   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALACC_CLS_BI_200)
-- Create 27.07.2007
-- - - - - - - - - - - - -

    if (new$Org_Ref is not null) then
      select DateClose into OrgDateClose$ from organizations where Id = new$Org_ref;
      if (OrgDateClose$ is not null) then
         if ((new$DateClose is null) or (new$DateClose > OrgDateClose$)) then
           new$DateClose := OrgDateClose$;
         end if;
         new$StatusAccount := 1;
         new$CloseCode := 10; /*   */
      end if;
    end if;

    if ((new$DateClose is not null) and (new$StatusAccount = 0)) then
      new$StatusAccount := 1;
      new$CloseCode := 1;
    end if;

    if (new$CloseCode is null) then new$CloseCode := 0; end if;

-- - - - - - - - - - - - -
-- BI_400 (TR_FACIALACC_CLS_BI_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALACC_CLS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALACC_CLS (
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE
  ) VALUES (
    new$ID,
    new$CODE1,
    new$CODE2,
    new$CODE3,
    new$CODE4,
    new$KVSR,
    new$KCSR,
    new$KFSR,
    new$KVR,
    new$KESR,
    new$FINTYPE,
    new$ORG_REF,
    new$DATEOPEN,
    new$SERVICEACCOUNT,
    new$STATUSACCOUNT,
    new$HARACTERACCOUNT,
    new$REGIONCLS,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$FACIALCODE,
    new$MEANSTYPE,
    new$GENERALORG_REF,
    new$DEPARTMENTCLS,
    new$RVERSION,
    new$CLOSEDOCNUMBER,
    new$HIGHERORG_REF,
    new$BUDGETREF,
    new$FCACCOUNT,
    new$CLOSECODE,
    new$DATECLOSE,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$NOTE,
    new$NAME,
    new$ISRBS,
    new$ISPBS,
    new$ISBU,
    new$ISSEPARATEBU,
    new$ISPROXY,
    new$OPENDOCNUMBER,
    new$ISOMS,
    new$CHANGEDOCNUMBER,
    new$DATECHANGE,
    new$GENERALORGFACIALACC,
    new$GRANTEEORG_REF,
    new$PREVCLS,
    new$FACIALCODEEX,
    new$EXTID,
    new$EXTROOTID,
    new$CODE);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALACC_CLS_AI_500)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 19) AND (RecordID = new$ID);

END;
/
-- ALTER TRIGGER tr_facialacc_cls_bu_0
CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_IU
  INSTEAD OF UPDATE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
--
  id_org$ NUMBER(10);
  DiffCode$ NUMBER(10);
  Code1$ NUMBER(10);
  Code2$ NUMBER(10);
  Code51$ NUMBER(10);
  CodeX$ NUMBER(10);
  vOrgType1$ NUMBER(10);
  id_org2$ NUMBER(10);
  id_reg$ NUMBER(10);
  vOrgType2$ NUMBER(10);
  IsNumeric$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALACC_CLS_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> :old.id) then
    facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
    --    ,        
    IsNumericString(new$Code,IsNumeric$);
    if ((new$Code is null) or (new$Code  is null) or ((IsNumeric$ = 1) and (new$Code = :old.Code) and (new$Code = :old.id))) then
      FormatClsStr(new$ID, 9,new$Code);
      
    END IF;
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$regioncls is null) then 
    new$regioncls := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0; -- ,   select min (...)
  END IF;
  if ((new$org_ref <> :old.org_ref) and not(new$fcaccount is null)) then
    BEGIN
      select org_ref     into id_org2$ from org_accounts
      where id = new$fcaccount
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (id_org2$ <> new$org_ref) then 
      new$fcaccount := null;
      
    END IF;
  END IF;
  if (:old.Org_Ref <> new$Org_Ref) then 
    BEGIN
      --   --------------------------
      select o.RegionCLS
      into id_reg$        from Organizations o
      where o.ID = new$Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    --   -----------------
         
    new$regioncls := id_reg$;
    BEGIN
      --       /----
      select o.Org_Type
      into vOrgType2$      from Organizations o
      where o.ID = :old.Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900)) then
      update org_accounts
      set facialacc_cls = null
      where facialacc_cls = :old.id;
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_FACIALACC_CLS_BU_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALACC_CLS_BU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /* /  ??     ??   AU   */
  if ((((new$DateClose is not null) and (:old.DateClose is null)) or
  ((new$DateClose is null) and (:old.DateClose is not null)))
  and (new$CloseCode = :old.CloseCode))
  then
    BEGIN
      /*      /    .
                / ??    ?
          */
      select o.Org_Type     into vOrgType1$ from Organizations o where o.id = new$org_ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType1$  >= 10800)and(vOrgType1$  <= 10900)) then
      if (new$DateClose is not null or (new$statusaccount = 1 and :old.statusaccount=0))
      then
        update org_accounts set
        CloseCode = CloseCode + 10000,
        DateClose = new$DateClose
        where facialacc_cls = new$id;

      END IF;
      if (new$DateClose is null or (new$statusaccount = 0 and :old.statusaccount=1))
      then
        update org_accounts set
        CloseCode = CloseCode - 10000
        where facialacc_cls = new$id;

      END IF;
    END IF;
    if (new$DateClose is not null) then
      new$CloseCode := 1;
    END IF;
    if (new$DateClose is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /* /   (only      ) */
  if (new$CloseCode <> :old.CloseCode)
  then
    DiffCode$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */
    CloseOrgCls_Div(:old.CloseCode,Code1$, Code2$, CodeX$, CodeX$, Code51$);

    /*   "" */
    if (DiffCode$ = 1) then
      Code1$ := 1;
    END IF;
    if (DiffCode$ = 10) then
      Code2$ := 1;
    END IF;
    if (DiffCode$ = 10000) then
      Code51$ := 1;
    END IF;
    if (DiffCode$ = -1) then
      Code1$ := 0;
    END IF;
    if (DiffCode$ = -10) then
      Code2$ := 0;
    END IF;
    if (DiffCode$ = -10000) then
      Code51$ := 0;
    END IF;
    new$CloseCode := Code1$ + Code2$*10 + Code51$*10000;

    if (new$CloseCode <> 0) then
      new$StatusAccount := 1;
    END IF;

    /*     ??      -  - !*/
    if (((new$CloseCode <> 0) and (new$DateClose is null)) or (new$DateClose >= :old.DateClose)) then
      new$DateClose := :old.DateClose;

    else
      if (new$CloseCode = 0) then
        new$DateClose := null;
        if (new$StatusAccount <> 0) then
          new$StatusAccount := 0;

        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_FACIALACC_CLS_BU_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_550 (TR_FACIALACC_CLS_BU_550)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF ((new$GeneralOrg_ref IS NULL)or(new$Org_Ref <> :old.Org_Ref)) THEN
     select
       o.GeneralOrg_Ref
     into
       id_org$
     from
       Organizations o
     where
       o.id = new$Org_Ref;
      /*      */
     if (id_org$ is Null)
       then id_org$ := new$Org_Ref;
     end if;
     new$GeneralOrg_ref := id_org$;

   END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALACC_CLS_BU_700)
-- Create 19.09.2004
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (NEW$RVersion IS NULL) THEN
      NEW$RVersion := 1;
   ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      NEW$RVersion := :OLD.RVersion;
   ELSE
      NEW$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALACC_CLS SET
    ID = new$ID,
    CODE1 = new$CODE1,
    CODE2 = new$CODE2,
    CODE3 = new$CODE3,
    CODE4 = new$CODE4,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KFSR = new$KFSR,
    KVR = new$KVR,
    KESR = new$KESR,
    FINTYPE = new$FINTYPE,
    ORG_REF = new$ORG_REF,
    DATEOPEN = new$DATEOPEN,
    SERVICEACCOUNT = new$SERVICEACCOUNT,
    STATUSACCOUNT = new$STATUSACCOUNT,
    HARACTERACCOUNT = new$HARACTERACCOUNT,
    REGIONCLS = new$REGIONCLS,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    FACIALCODE = new$FACIALCODE,
    MEANSTYPE = new$MEANSTYPE,
    GENERALORG_REF = new$GENERALORG_REF,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    RVERSION = new$RVERSION,
    CLOSEDOCNUMBER = new$CLOSEDOCNUMBER,
    HIGHERORG_REF = new$HIGHERORG_REF,
    BUDGETREF = new$BUDGETREF,
    FCACCOUNT = new$FCACCOUNT,
    CLOSECODE = new$CLOSECODE,
    DATECLOSE = new$DATECLOSE,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    NOTE = new$NOTE,
    NAME = new$NAME,
    ISRBS = new$ISRBS,
    ISPBS = new$ISPBS,
    ISBU = new$ISBU,
    ISSEPARATEBU = new$ISSEPARATEBU,
    ISPROXY = new$ISPROXY,
    OPENDOCNUMBER = new$OPENDOCNUMBER,
    ISOMS = new$ISOMS,
    CHANGEDOCNUMBER = new$CHANGEDOCNUMBER,
    DATECHANGE = new$DATECHANGE,
    GENERALORGFACIALACC = new$GENERALORGFACIALACC,
    GRANTEEORG_REF = new$GRANTEEORG_REF,
    PREVCLS = new$PREVCLS,
    FACIALCODEEX = new$FACIALCODEEX,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    CODE = new$CODE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALACC_CLS_AU_500)
-- Create 28.04.2005
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (19, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 19) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/
ALTER TABLE TB_FacialAcc_Cls MODIFY(Code NOT NULL)
/

-- #########################################################
-- #########################################################
-- Add_ContractSubject_OOS_Contract.sql
-- #########################################################
-- #########################################################

/*    ContractSubject " "   OOS_CONTRACT*/
ALTER TABLE OOS_CONTRACT ADD (
  ContractSubject VARCHAR2(2000)
)
/
commit work 
/




-- #########################################################
-- #########################################################
-- Alter_Agreements_TreasurySupportID.sql
-- #########################################################
-- #########################################################

ALTER TABLE TB_Agreements ADD (
  TreasurySupportID VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  PURPORTDOC,
  TREASURYSUPPORTID)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC,
    TREASURYSUPPORTID
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
--
  CountAcc$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*       */
    select count(ID) 
    into Tmp1$         from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp1$ = 0) then 
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    BEGIN
      select DocNumber 
      into new$AdjustmentDocNumber         from Agreements
      where ID=new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) or (new$rnYear is not null) or (new$rnNumber is not null)) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC,
    TREASURYSUPPORTID
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC,
    new$TREASURYSUPPORTID);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID is not null) and (:old.rnClientID is null or new$rnClientID <> :old.rnClientID)) or
  ((new$rnYear is not null) and (:old.rnYear is null or new$rnYear <> :old.rnYear)) or
  ((new$rnNumber is not null) and (:old.rnNumber is null or new$rnNumber <> :old.rnNumber))) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    PURPORTDOC = new$PURPORTDOC,
    TREASURYSUPPORTID = new$TREASURYSUPPORTID
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_NationalProject.sql
-- #########################################################
-- #########################################################

CREATE TABLE NATIONALPROJECT (
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  CODE VARCHAR2(20) NOT NULL,
  NAME VARCHAR2(2000) NOT NULL,
  NAMEMAINEVENT VARCHAR2(2000),
  PARENTPROJECT NUMBER(10),
    CHECK((PARENTPROJECT<=2147483647)AND(PARENTPROJECT>-2147483648)),
  CREATEDATE DATE NOT NULL,
  UPDATEDATE DATE NOT NULL,
  BUDGETREF NUMBER(10) NOT NULL,
    CHECK((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)),
  DELETEDATE DATE,
  STARTDATE DATE,
  CREATERUSER VARCHAR2(30) NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  EXTID VARCHAR2(50),
  EXTOWNER VARCHAR2(50),
  EXTSYNCDATE DATE,
  EXTROOTID VARCHAR2(50),
  EXTVERSION VARCHAR2(50),
  EXTVERSIONDATE DATE
)
/
ALTER TABLE NATIONALPROJECT ADD (
  CONSTRAINT UQ_NATIONALPROJECT_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/
ALTER TABLE NATIONALPROJECT ADD (
  CONSTRAINT NATIONALPROJECT_PK_ID PRIMARY KEY (ID)
)
/
ALTER TABLE NATIONALPROJECT ADD (
  CONSTRAINT FK_NATIONALPROJECT_BUDGETREF FOREIGN KEY (BUDGETREF) REFERENCES TB_BUDGETS_S (ID)
)
/
CREATE INDEX FK_NATIONALPROJECT_BUDGETREF ON NATIONALPROJECT(BUDGETREF)
/
ALTER TABLE NATIONALPROJECT ADD (
  CONSTRAINT FK_NATIONALPROJECT_PARENTPRJ FOREIGN KEY (PARENTPROJECT) REFERENCES NATIONALPROJECT (ID)
)
/
CREATE INDEX FK_NATIONALPROJECT_PARENTPRJ ON NATIONALPROJECT(PARENTPROJECT)
/
CREATE INDEX IDX_NATIONALPROJECT_EXTID ON NATIONALPROJECT (EXTID)
/
CREATE INDEX IDX_NATIONALPROJECT_EXTROOTID ON NATIONALPROJECT (EXTROOTID)
/
-- CREATE TRIGGER TR_NATIONALPROJECT_AD_500
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_AD
  AFTER DELETE
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_NATIONALPROJECT_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(34,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_AI_500
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_AI
  AFTER INSERT
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_NATIONALPROJECT_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 34) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_AU_500
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_AU
  AFTER UPDATE
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_NATIONALPROJECT_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (34, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=34) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_BI_0
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_BI
  BEFORE INSERT
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_NATIONALPROJECT_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_BI_500
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_BI
  BEFORE INSERT
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_NATIONALPROJECT_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_NATIONALPROJECT_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_BU_0
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_BU
  BEFORE UPDATE
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_NATIONALPROJECT_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_NATIONALPROJECT_BU_500
CREATE OR REPLACE TRIGGER TR_NATIONALPROJECT_BU_500
  BEFORE UPDATE
  ON NATIONALPROJECT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_NATIONALPROJECT_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
/* Privileges of users */
GRANT SELECT, INSERT, UPDATE, DELETE ON NATIONALPROJECT TO BUDGET_USERS
/
ALTER TABLE KCSR ADD (
  NATIONALPROJECT NUMBER(10),
    CHECK((NATIONALPROJECT<=2147483647)AND(NATIONALPROJECT>-2147483648))
)
/
ALTER TABLE KCSR ADD (
  CONSTRAINT FK_KCSR_NATIONALPROJECT FOREIGN KEY (NATIONALPROJECT) REFERENCES NATIONALPROJECT (ID)
)
/
CREATE INDEX FK_KCSR_NATIONALPROJECT ON KCSR(NATIONALPROJECT)
/
COMMIT WORK 
/

-- #########################################################
-- #########################################################
-- AlterRemoteClient.sql
-- #########################################################
-- #########################################################

/*     ,    ,
           */
-- CREATE TRIGGER tr_remoteclient_bu_25
CREATE OR REPLACE TRIGGER TR_REMOTECLIENT_BU
  BEFORE UPDATE
  ON REMOTECLIENT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_25 (TR_REMOTECLIENT_BU_25)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ClientID <> :old.ClientID) then
    update RemoteReadRight rrr
    set rrr.ClientID = :new.ClientID
    where rrr.RemoteClient = :new.ID;
  END IF;
  /*     ,    ,
             */
  if (:new.AllowedCopies is null or :new.AllowedCopies = 0) then
    :new.UsedCopies := 0;
  END IF;

END;
/
commit
/

-- #########################################################
-- #########################################################
-- update_permissions_rename_14.00.sql
-- #########################################################
-- #########################################################

/*   "   "  "  , " */
ALTER TRIGGER TR_PERMISSIONS_BU_500 DISABLE
/
commit work
/
update Permissions set
  Name = '  , '
where
  Upper(Name) = Upper('   ')
/
commit work
/
ALTER TRIGGER TR_PERMISSIONS_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_tr_SignCertificate_BU_200.sql
-- #########################################################
-- #########################################################

/*         */
-- CREATE TRIGGER SIGNCERTIFICATE_BU_200
CREATE OR REPLACE TRIGGER TR_SIGNCERTIFICATE_BU
  BEFORE UPDATE
  ON SIGNCERTIFICATE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_SignCert_BU_0)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  if (:new.IsEnabled is null) then 
    :new.IsEnabled := 1;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (SIGNCERTIFICATE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*       */
  if (:new.DocStateRef <> :old.DocStateRef) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
    values(:new.id, :old.DocStateRef, :new.DocStateRef);
  END IF;

END;
/
commit
/

-- #########################################################
-- #########################################################
-- Alter_tr_SignCertificate_BI_0.sql
-- #########################################################
-- #########################################################

INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_SIGNCERT_NOENDSTATE', -20371, '     ,         .')
/
commit work
/
-- ALTER TRIGGER TR_SIGNCERT_BI_0
CREATE OR REPLACE TRIGGER TR_SIGNCERTIFICATE_BI
  BEFORE INSERT
  ON SIGNCERTIFICATE
  FOR EACH ROW
DECLARE
  UseState$ NUMBER(10);
  AcceptDocStateRef$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_SignCert_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID is null) then 
    select g_shared.nextval into :new.ID from dual;
  END IF;
  if (:new.IsEnabled is null) then 
    :new.IsEnabled := 1;
  END IF;
  /*         ,   */
  if (:new.docstateref is null) then
    BEGIN
      select UseState     into UseState$ from DocumentTypes 
      where ID = 4701
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (UseState$ = 1) then
      BEGIN
        /*        */
        select id       into AcceptDocStateRef$ from state_docstates
        where DocTypeRef = 4701 and StateTypeRef = 2
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AcceptDocStateRef$ is null) then
        RaiseException('EX_SIGNCERT_NOENDSTATE');
      END IF;
      :new.docstateref := AcceptDocStateRef$;
      
    END IF;
  END IF;
  if (:new.operationtype is null) then 
    :new.operationtype := 0;

  END IF;

-- - - - - - - - - - - - -
-- BI_500 (tr_SignCert_bi_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
commit work
/


-- #########################################################
-- #########################################################
-- Add_SB_Common_AttachFiles.sql
-- #########################################################
-- #########################################################

ALTER TRIGGER TR_VARCHARCONST_BU_500 DISABLE
/
CREATE OR REPLACE procedure AddSBCommon
AS
  progindexID$ NUMBER(10);
BEGIN
  BEGIN
    select progindex into progindexID$ from VarcharConst where progindex = 1000 and constindex = 48 and ConstValue like '%SB_Common%' ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (progindexID$  is null) then
    update varcharconst set constvalue='SB_Common,' || constvalue
    where progindex = 1000 and constindex = 48;
      
  END IF;
END;
/
CALL AddSBCommon() 
/
drop procedure AddSBCommon
/
ALTER TRIGGER TR_VARCHARCONST_BU_500 ENABLE
/
commit work
/


-- #########################################################
-- #########################################################
-- alter_OrgAccounts_AComment_1024.sql
-- #########################################################
-- #########################################################

/*    ""     1024  */
-- ALTER TRIGGER TR_ORG_ACCOUNTS_BI
CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ACOMMENT,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ACOMMENT,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_ORG_ACCOUNTS_BU
CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ACOMMENT = new$ACOMMENT,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
ALTER TRIGGER TR_ORG_ACCOUNTS_BU_500 DISABLE
/
ALTER TABLE TB_ORG_ACCOUNTS ADD (
  TempACOMMENT VARCHAR2(1024)
)
/

CREATE OR REPLACE VIEW ORG_ACCOUNTS (
  ID,
  ORG_REF,
  BANK_REF,
  ACC,
  ACC_CLS,
  FINTYPE,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  CLOSED,
  ACCDEFAULT,
  BANKDEPNUMBER,
  FACIALCODE,
  SERVICE_ORG_REF,
  ACOMMENT,
  ISDEFAULT,
  RVERSION,
  SERVICE_ACC_REF,
  CLOSECODE,
  SERVICEACC,
  FACIALACC_CLS,
  DATEOPEN,
  DATECLOSE,
  EXTID,
  EXTOWNER,
  EXTSYNCDATE,
  TEMPACOMMENT)
AS
  SELECT
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ACOMMENT,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT
  FROM TB_ORG_ACCOUNTS
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_ID
  INSTEAD OF DELETE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  CNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORG_ACCOUNTS_BD)
-- Create 05.06.2007
-- - - - - - - - - - - - -

  select count(*) into CNT$
  from Org_Accounts where Service_Acc_Ref = :old.ID;
  
  if (CNT$ > 0) then
    RaiseException('ex_CantDelServiceAcc');
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORG_ACCOUNTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
   
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORG_ACCOUNTS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(21,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ACOMMENT,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ACOMMENT,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$TEMPACOMMENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ACOMMENT = new$ACOMMENT,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    TEMPACOMMENT = new$TEMPACOMMENT
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
update ORG_ACCOUNTS set
  TempACOMMENT = ACOMMENT
/
ALTER TABLE TB_ORG_ACCOUNTS DROP (ACOMMENT)
/

CREATE OR REPLACE VIEW ORG_ACCOUNTS (
  ID,
  ORG_REF,
  BANK_REF,
  ACC,
  ACC_CLS,
  FINTYPE,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  CLOSED,
  ACCDEFAULT,
  BANKDEPNUMBER,
  FACIALCODE,
  SERVICE_ORG_REF,
  ISDEFAULT,
  RVERSION,
  SERVICE_ACC_REF,
  CLOSECODE,
  SERVICEACC,
  FACIALACC_CLS,
  DATEOPEN,
  DATECLOSE,
  EXTID,
  EXTOWNER,
  EXTSYNCDATE,
  TEMPACOMMENT)
AS
  SELECT
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT
  FROM TB_ORG_ACCOUNTS
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_ID
  INSTEAD OF DELETE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  CNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORG_ACCOUNTS_BD)
-- Create 05.06.2007
-- - - - - - - - - - - - -

  select count(*) into CNT$
  from Org_Accounts where Service_Acc_Ref = :old.ID;
  
  if (CNT$ > 0) then
    RaiseException('ex_CantDelServiceAcc');
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORG_ACCOUNTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
   
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORG_ACCOUNTS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(21,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$TEMPACOMMENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    TEMPACOMMENT = new$TEMPACOMMENT
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
ALTER TABLE TB_ORG_ACCOUNTS ADD (
  ACOMMENT VARCHAR2(1024)
)
/

CREATE OR REPLACE VIEW ORG_ACCOUNTS (
  ID,
  ORG_REF,
  BANK_REF,
  ACC,
  ACC_CLS,
  FINTYPE,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  CLOSED,
  ACCDEFAULT,
  BANKDEPNUMBER,
  FACIALCODE,
  SERVICE_ORG_REF,
  ISDEFAULT,
  RVERSION,
  SERVICE_ACC_REF,
  CLOSECODE,
  SERVICEACC,
  FACIALACC_CLS,
  DATEOPEN,
  DATECLOSE,
  EXTID,
  EXTOWNER,
  EXTSYNCDATE,
  TEMPACOMMENT,
  ACOMMENT)
AS
  SELECT
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT,
    ACOMMENT
  FROM TB_ORG_ACCOUNTS
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_ID
  INSTEAD OF DELETE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  CNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORG_ACCOUNTS_BD)
-- Create 05.06.2007
-- - - - - - - - - - - - -

  select count(*) into CNT$
  from Org_Accounts where Service_Acc_Ref = :old.ID;
  
  if (CNT$ > 0) then
    RaiseException('ex_CantDelServiceAcc');
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORG_ACCOUNTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
   
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORG_ACCOUNTS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(21,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    TEMPACOMMENT,
    ACOMMENT
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$TEMPACOMMENT,
    new$ACOMMENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$TEMPACOMMENT ORG_ACCOUNTS.TEMPACOMMENT%TYPE := :NEW.TEMPACOMMENT;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    TEMPACOMMENT = new$TEMPACOMMENT,
    ACOMMENT = new$ACOMMENT
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
update ORG_ACCOUNTS set
  ACOMMENT = TempACOMMENT
/
ALTER TABLE TB_ORG_ACCOUNTS DROP (TempACOMMENT)
/

CREATE OR REPLACE VIEW ORG_ACCOUNTS (
  ID,
  ORG_REF,
  BANK_REF,
  ACC,
  ACC_CLS,
  FINTYPE,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  CLOSED,
  ACCDEFAULT,
  BANKDEPNUMBER,
  FACIALCODE,
  SERVICE_ORG_REF,
  ISDEFAULT,
  RVERSION,
  SERVICE_ACC_REF,
  CLOSECODE,
  SERVICEACC,
  FACIALACC_CLS,
  DATEOPEN,
  DATECLOSE,
  EXTID,
  EXTOWNER,
  EXTSYNCDATE,
  ACOMMENT)
AS
  SELECT
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    ACOMMENT
  FROM TB_ORG_ACCOUNTS
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_ID
  INSTEAD OF DELETE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  CNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORG_ACCOUNTS_BD)
-- Create 05.06.2007
-- - - - - - - - - - - - -

  select count(*) into CNT$
  from Org_Accounts where Service_Acc_Ref = :old.ID;
  
  if (CNT$ > 0) then
    RaiseException('ex_CantDelServiceAcc');
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORG_ACCOUNTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
   
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORG_ACCOUNTS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(21,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    ACOMMENT
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$ACOMMENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  NULL;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    ACOMMENT = new$ACOMMENT
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
ALTER TRIGGER TR_ORG_ACCOUNTS_BU_500 ENABLE
/
-- ALTER TRIGGER TR_ORG_ACCOUNTS_BI
CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
  vOrgType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$Org_Ref = 0) then 
    RaiseException('ex_CantAddUnknownOrgAcc');
  END IF;
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$ACC_CLS is null) then 
    new$ACC_CLS:= 0;
  END IF;
  if (new$AccDefault is null) then 
    new$AccDefault:= 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType:= 0;
  END IF;
  if ((new$AComment is null) or (new$AComment  is null)) then 
    new$AComment := new$Acc;
  END IF;
  if ((new$IsDefault is not Null) and (new$IsDefault <> 0)) then
    update ORG_ACCOUNTS set
    IsDefault = 0
    where ORG_REF = new$ORG_REF
    and IsDefault is not Null
    and IsDefault <> 0;
  END IF;
  if ((new$SERVICE_ORG_REF is null)and(new$SERVICE_ACC_REF is not null)) then
    BEGIN
      select
      oa.Org_Ref
      into
      new$SERVICE_ORG_REF    from
      org_accounts oa
      where
      (oa.id = new$SERVICE_ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*               */
  if (new$ServiceAcc is null) then
    BEGIN
      select SERVICETYPE into new$ServiceAcc from ACC_CLS where (id = new$ACC_CLS) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       NULL,   0() */
  if (new$ServiceAcc is null) then
    new$ServiceAcc := 0;
    if (new$SERVICE_ORG_REF is not null) then
      BEGIN
        select
        o.Org_Type
        into vOrgType$      from
        Organizations o
        where
        (o.id = new$SERVICE_ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /* 01.01.xx  -   */
      if ((vOrgType$  > 10099)and(vOrgType$  < 10200)) then
        new$ServiceAcc := 3;
             
      else
        /* 03.02.xx     -   */
        if ((vOrgType$  > 30199)and(vOrgType$  < 30300)) then
          new$ServiceAcc := 1;
               
        else
          /* 04.xx.xx  -   */
          if ((vOrgType$  > 39999)and(vOrgType$  < 50000)) then
            new$ServiceAcc := 1;
          END IF;
        END IF;   
      END IF; 
    END IF;
  END IF;
  /*      . .   .  ,   ,
       ,     .  */
  if ((new$Service_Acc_Ref is not null) and (new$ServiceAcc <> 0)) then
    BEGIN
      select
      Bank_Ref, Acc
      into new$Bank_Ref, new$FacialCode    from
      Org_Accounts
      where
      new$Service_Acc_Ref = Id
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    ACOMMENT
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$ACOMMENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_ORG_ACCOUNTS_BU
CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
  vOrgType$ NUMBER(10);
  vServiceAcc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$ACC_CLS is null) then 
    new$ACC_CLS:= 0;
  END IF;
  if (new$AccDefault is null) then 
    new$AccDefault:= 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType:= 0;
  END IF;
  if ((new$AComment is null) or (new$AComment  is null) 
  or (new$AComment = :old.AComment) and (:old.AComment = :old.Acc)) then
    new$AComment := new$Acc;
  END IF;
  if ((new$IsDefault is not Null) and (new$IsDefault <> 0)
  and ((:old.IsDefault is Null) or (:old.IsDefault = 0))) then
    update ORG_ACCOUNTS set
    IsDefault = 0
    where ORG_REF = new$ORG_REF
    and IsDefault is not Null
    and IsDefault <> 0;
  END IF;
  if ((new$SERVICE_ORG_REF is null)and(new$SERVICE_ACC_REF is not null)) then
    BEGIN
      select
      oa.Org_Ref
      into
      new$SERVICE_ORG_REF    from
      org_accounts oa
      where
      (oa.id = new$SERVICE_ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*               */
  if (new$ACC_CLS <> :old.ACC_CLS) then
    BEGIN
      select SERVICETYPE into vServiceAcc$ from ACC_CLS where (id = new$ACC_CLS) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*     ,    */
    if (vServiceAcc$ is not null) then
      new$ServiceAcc := vServiceAcc$;
     
    END IF;
  END IF;
  /*      ,       */
  if (:old.ServiceAcc is not null and new$ServiceAcc = 0 and :old.ServiceAcc <> new$ServiceAcc) then
    new$service_acc_ref := null;
    new$service_org_ref := null;
     
  END IF;
  /*       NULL,   0() */
  if (new$ServiceAcc is null) then
    new$ServiceAcc := 0;
    if (new$SERVICE_ORG_REF is not null) then
      BEGIN
        select
        o.Org_Type
        into vOrgType$      from
        Organizations o
        where
        (o.id = new$SERVICE_ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /* 01.01.xx  -   */
      if ((vOrgType$  > 10099)and(vOrgType$  < 10200)) then
        new$ServiceAcc := 3;
             
      else
        /* 03.02.xx     -   */
        if ((vOrgType$  > 30199)and(vOrgType$  < 30300)) then
          new$ServiceAcc := 1;
               
        else
          /* 04.xx.xx  -   */
          if ((vOrgType$  > 39999)and(vOrgType$  < 50000)) then
            new$ServiceAcc := 1;
          END IF;
        END IF;   
      END IF; 
    END IF;
  END IF;
  /*            */
  if (new$Acc <> :old.Acc) then
    update facialacc_cls set
    FACIALCODE = new$Acc
    where
    FCACCOUNT = new$id;
     
  END IF;
  /*      . .   .  ,   ,
       ,     .  */
  if ((new$Service_Acc_Ref is not null) and (new$ServiceAcc <> 0)
  and (new$Service_Acc_Ref <> :old.Service_Acc_Ref)) then
    BEGIN
      select
      Bank_Ref, Acc
      into new$Bank_Ref, new$FacialCode    from
      Org_Accounts
      where
      new$Service_Acc_Ref = Id
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*   */
  /*     ,        
       .  ,        */
  /*    ,          .  */
  if ((new$Bank_Ref <> :old.Bank_Ref) or (new$Acc <> :old.Acc)) then
    update Org_Accounts set
    Bank_Ref = new$Bank_Ref,
    FacialCode = new$Acc
    where
    (Service_Acc_Ref = new$ID) and
    (ID <> new$ID);
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    ACOMMENT = new$ACOMMENT
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- Add_Org_Type_Ora.sql
-- #########################################################
-- #########################################################


create or replace procedure AddOrgType(New_ID$ integer, NewName$ VarChar2)
as
  cnt$ Number(10);
begin
  select count(ID) into cnt$ from Org_Type where Name = NewName$;

  if cnt$ > 0 then
    Update Org_Type ev set
       ev.ID = New_ID$
    where (ev.Name = NewName$);
  else
    insert into Org_Type(ID, Name) values (New_ID$, NewName$);
  end if;  
end;
/

call AddOrgType(30200, '      ()')
/

drop procedure AddOrgType
/

commit work
/



-- #########################################################
-- #########################################################
-- Add_ConstForecast.sql
-- #########################################################
-- #########################################################

CALL AddIntConst(1005, 280, 1, '')
/
CALL AddIntConst(1006, 280, 2, '')
/
CALL AddIntConst(1005, 281, 1, '')
/
CALL AddIntConst(1006, 281, 2, '')
/
commit work
/


-- #########################################################
-- #########################################################
-- alter_MeasurementCls_add_NSI.sql
-- #########################################################
-- #########################################################

/*          ,
      Code */
ALTER TABLE MeasurementCls ADD (
  Extid VARCHAR2(50),/*        */
  ExtRootId VARCHAR2(50),/*   */
  StartDate DATE,/*    */
  DeleteDate DATE,/*    */
  Code VARCHAR2(20),/*  */
  SectionCode VARCHAR2(1)/*   */
)
/
commit work
/
ALTER TRIGGER TR_MEASUREMENTCLS_BU_500 DISABLE
/
commit work
/
update MeasurementCls set
  Code = id
/
update MeasurementCls set
  code='00' || code
where
  code like '_'
/
update MeasurementCls set
  code='0' || code
where
  code like '__'
/
commit work
/
ALTER TRIGGER TR_MEASUREMENTCLS_BU_500 ENABLE
/
commit work
/
-- CREATE TRIGGER tr_measurementcls_bi_0
CREATE OR REPLACE TRIGGER TR_MEASUREMENTCLS_BI
  BEFORE INSERT
  ON MEASUREMENTCLS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_measurementcls_bi_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  --   ,   
  if (:new.Code is null) then
    FormatClsStr(:new.ID, 3,:new.Code);
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_MEASUREMENTCLS_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
-- CREATE TRIGGER tr_measurementcls_bu_0
CREATE OR REPLACE TRIGGER TR_measurementcls_BU
  BEFORE UPDATE
  ON measurementcls
  FOR EACH ROW
DECLARE
  IsNumeric$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_measurementcls_bu_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id <> :old.id) then
    --    ,        
    IsNumericString(:new.Code,IsNumeric$);
    if ((:new.Code is null) or (:new.Code  is null) or ((IsNumeric$ = 1) and (:new.Code = :old.Code) and (:new.Code = :old.id))) then
      if (:new.id < 1000) then
        FormatClsStr(:new.ID, 3,:new.Code);
              
      else
        :new.Code := :new.ID;
          
      END IF;  
    END IF;
  END IF;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_Temp_Keys2.sql
-- #########################################################
-- #########################################################


-- <TRANS_IGNORE>

BEGIN
EXECUTE IMMEDIATE 'CREATE GLOBAL TEMPORARY TABLE Temp_Keys2 (ID Integer not null, Kind Integer not null) ON COMMIT PRESERVE ROWS';
EXECUTE IMMEDIATE 'CREATE INDEX IDX_Temp_Keys2_ID ON Temp_Keys2 (ID)';
END;
/

/* Privileges of users */
GRANT SELECT, INSERT, UPDATE, DELETE ON Temp_Keys2 TO BUDGET_USERS
/

CREATE or REPLACE PROCEDURE SetIdTempKeys2(AKind NUMBER, IDsList in VARCHAR2, Delim in VARCHAR2  )
IS  
  second_pos NUMBER := 0;
  first_pos number := 1;
  new_id number;
BEGIN 
  while (second_pos <= LENGTH(IDsList) - 1) loop
    second_pos := INSTR(IDsList, Delim, first_pos);
    if (second_pos = 0) then
      second_pos := LENGTH(IDsList) + 1;       
    end if;
    new_id := TO_NUMBER((SUBSTR(IDsList, first_pos, second_pos - first_pos)));
    INSERT /* + APPEND */ into temp_keys2(id, kind) values (new_id, AKind);
    first_pos := second_pos + 1;
  end loop;    
END;
/

GRANT EXECUTE ON SetIdTempKeys2 TO BUDGET_USERS
/

commit work
/



-- #########################################################
-- #########################################################
-- Del_Fields_PaymentSchedule.sql
-- #########################################################
-- #########################################################

/*    SummaYear1, SummaYear1Delta  PAYMENTSCHEDULE*/
-- CREATE TRIGGER tr_paymentschedule_bi
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
commit work
/
-- CREATE TRIGGER tr_paymentschedule_bu
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  M01$ NUMBER;
  M02$ NUMBER;
  M03$ NUMBER;
  M04$ NUMBER;
  M05$ NUMBER;
  M06$ NUMBER;
  M07$ NUMBER;
  M08$ NUMBER;
  M09$ NUMBER;
  M10$ NUMBER;
  M11$ NUMBER;
  M12$ NUMBER;
  Q1$ NUMBER;
  Q2$ NUMBER;
  Q3$ NUMBER;
  Q4$ NUMBER;
  S$ NUMBER;
  S1$ NUMBER;
  S2$ NUMBER;
  S3$ NUMBER;
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  S4$ NUMBER;
  SOther$ NUMBER;
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear1, SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M01$, M02$, M03$, M04$, M05$, M06$, M07$, M08$, M09$, M10$, M11$, M12$,
      Q1$, Q2$, Q3$, Q4$, S$, S1$, S2$, S3$, S4$, SOther$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M01$;
    new$Month02Delta := new$Month02 - M02$;
    new$Month03Delta := new$Month03 - M03$;
    new$Month04Delta := new$Month04 - M04$;
    new$Month05Delta := new$Month05 - M05$;
    new$Month06Delta := new$Month06 - M06$;
    new$Month07Delta := new$Month07 - M07$;
    new$Month08Delta := new$Month08 - M08$;
    new$Month09Delta := new$Month09 - M09$;
    new$Month10Delta := new$Month10 - M10$;
    new$Month11Delta := new$Month11 - M11$;
    new$Month12Delta := new$Month12 - M12$;
    new$Quarter1Delta := new$Quarter1 - Q1$;
    new$Quarter2Delta := new$Quarter2 - Q2$;
    new$Quarter3Delta := new$Quarter3 - Q3$;
    new$Quarter4Delta := new$Quarter4 - Q4$;
    new$SummaDelta := new$Summa - S$;
    new$SummaYear1Delta := new$SummaYear1 - S1$;
    new$SummaYear2Delta := new$SummaYear2 - S2$;
    new$SummaYear3Delta := new$SummaYear3 - S3$;
    new$SummaYear4Delta := new$SummaYear4 - S4$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear1Delta := new$SummaYear1;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
-- CREATE TRIGGER tr_paymentschedule_bi_100
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
commit work
/
-- CREATE TRIGGER tr_paymentschedule_bu_100
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR1 PAYMENTSCHEDULE.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
-- CREATE TRIGGER tr_paymentschedule_ad_500
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/
commit work
/
ALTER TABLE TB_PAYMENTSCHEDULE DROP (SUMMAYEAR1)
/

CREATE OR REPLACE VIEW PAYMENTSCHEDULE (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR1DELTA,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  FROM TB_PAYMENTSCHEDULE
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR1DELTA,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR1DELTA PAYMENTSCHEDULE.SUMMAYEAR1DELTA%TYPE := :NEW.SUMMAYEAR1DELTA;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR1DELTA = new$SUMMAYEAR1DELTA,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_PAYMENTSCHEDULE DROP (SUMMAYEAR1DELTA)
/

CREATE OR REPLACE VIEW PAYMENTSCHEDULE (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  FROM TB_PAYMENTSCHEDULE
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- UpdateRemoteDocData.sql
-- #########################################################
-- #########################################################

/* 
         RemoteDocument
          .
      .
*/
/*         ,  ,  */
CREATE OR REPLACE procedure UpdateRemoteDocument(ID$ NUMBER,Name$ VARCHAR2)
AS
  CNT$1 NUMBER(10);
BEGIN
  SELECT COUNT(ID ) INTO CNT$1
  from RemoteDocument where (ID = ID$) AND (ROWNUM = 1);
  if (not (CNT$1<> 0)) then
    insert into RemoteDocument(ID, Name) values (ID$, Name$);
      
  else
    update RemoteDocument set 
    Name = Name$ 
     
    where 
    ID = ID$;
  END IF;
END;
/
/* !!!      50  !!! */
CALL UpdateRemoteDocument(280 , '   ')
/
CALL UpdateRemoteDocument(281 , '   ')
/
CALL UpdateRemoteDocument(282 , ' ')
/
drop procedure UpdateRemoteDocument 
/
commit work
/





-- #########################################################
-- #########################################################
-- Create_IND_PE_SD_DN.sql
-- #########################################################
-- #########################################################


/* <TRANS_COMMAND>

create index IND_PAYDOCEXCHANGE_SENDDATE on paydocexchange (sendDate)
/
COMMIT WORK
/

*/
-- <TRANS_IGNORE>

DECLARE
  v_exists INTEGER;
BEGIN
  SELECT count(*)
  INTO v_exists
  FROM user_indexes
  WHERE INDEX_NAME = 'IND_PAYDOCEXCHANGE_SENDDATE';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE 'create index IND_PAYDOCEXCHANGE_SENDDATE on paydocexchange (sendDate)';
    EXECUTE IMMEDIATE 'create index IND_PAYDOCEXCHANGE_DOCNUMBER on paydocexchange (DOCNUMBER)';
    EXECUTE IMMEDIATE 'COMMIT WORK';
  END IF;
END;
/



-- #########################################################
-- #########################################################
-- Alter_TransfertCls_Triggers.sql
-- #########################################################
-- #########################################################

/*     "  ",   .        , 
          , , ,    . */
-- CREATE TRIGGER TR_TRANSFERTCLS_BI_200
CREATE OR REPLACE TRIGGER TR_TRANSFERTCLS_II
  INSTEAD OF INSERT
  ON TRANSFERTCLS
  FOR EACH ROW
DECLARE
  new$ID TRANSFERTCLS.ID%TYPE := :NEW.ID;
  new$REGIONCLS TRANSFERTCLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATERUSER TRANSFERTCLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TRANSFERTCLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER TRANSFERTCLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE TRANSFERTCLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$CODE TRANSFERTCLS.CODE%TYPE := :NEW.CODE;
  new$RECEIVEKVSR TRANSFERTCLS.RECEIVEKVSR%TYPE := :NEW.RECEIVEKVSR;
  new$RECEIVEKFSR TRANSFERTCLS.RECEIVEKFSR%TYPE := :NEW.RECEIVEKFSR;
  new$RECEIVEKVR TRANSFERTCLS.RECEIVEKVR%TYPE := :NEW.RECEIVEKVR;
  new$RECEIVEKD TRANSFERTCLS.RECEIVEKD%TYPE := :NEW.RECEIVEKD;
  new$TRANSFERKVSR TRANSFERTCLS.TRANSFERKVSR%TYPE := :NEW.TRANSFERKVSR;
  new$TRANSFERKFSR TRANSFERTCLS.TRANSFERKFSR%TYPE := :NEW.TRANSFERKFSR;
  new$TRANSFERKCSR TRANSFERTCLS.TRANSFERKCSR%TYPE := :NEW.TRANSFERKCSR;
  new$TRANSFERKVR TRANSFERTCLS.TRANSFERKVR%TYPE := :NEW.TRANSFERKVR;
  new$TRANSFERKESR TRANSFERTCLS.TRANSFERKESR%TYPE := :NEW.TRANSFERKESR;
  new$TRANSFERKDVALUE TRANSFERTCLS.TRANSFERKDVALUE%TYPE := :NEW.TRANSFERKDVALUE;
  new$TARGETMEANSSIGN TRANSFERTCLS.TARGETMEANSSIGN%TYPE := :NEW.TARGETMEANSSIGN;
  new$TARGETCLS TRANSFERTCLS.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STARTDATE TRANSFERTCLS.STARTDATE%TYPE := :NEW.STARTDATE;
  new$DELETEDATE TRANSFERTCLS.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NOTE TRANSFERTCLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME TRANSFERTCLS.NAME%TYPE := :NEW.NAME;
  new$BUDGETREF TRANSFERTCLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECEIVEKCSR TRANSFERTCLS.RECEIVEKCSR%TYPE := :NEW.RECEIVEKCSR;
  new$SOURCELEVEL TRANSFERTCLS.SOURCELEVEL%TYPE := :NEW.SOURCELEVEL;
  new$DESTLEVEL TRANSFERTCLS.DESTLEVEL%TYPE := :NEW.DESTLEVEL;
  new$TRANSFERTKIND TRANSFERTCLS.TRANSFERTKIND%TYPE := :NEW.TRANSFERTKIND;
  new$GRANTKIND TRANSFERTCLS.GRANTKIND%TYPE := :NEW.GRANTKIND;
  new$TRANSFERTYEAR TRANSFERTCLS.TRANSFERTYEAR%TYPE := :NEW.TRANSFERTYEAR;
  new$EXTID TRANSFERTCLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER TRANSFERTCLS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE TRANSFERTCLS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$FACT TRANSFERTCLS.FACT%TYPE := :NEW.FACT;
  new$EXTROOTID TRANSFERTCLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION TRANSFERTCLS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE TRANSFERTCLS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$RECEIVEKESR TRANSFERTCLS.RECEIVEKESR%TYPE := :NEW.RECEIVEKESR;
--
  CurrentDate$ NUMBER;
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TRANSFERTCLS_BI)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$ID from dual;
  END IF;

  if (new$BUDGETREF is null) then
    new$BUDGETREF := 0;
  END IF;
  if (new$RECEIVEKVSR is null) then
    new$RECEIVEKVSR := 0;
  END IF;
  if (new$RECEIVEKCSR is null) then
    new$RECEIVEKCSR := 0;
  END IF;
  if (new$RECEIVEKFSR is null) then
    new$RECEIVEKFSR := 0;
  END IF;
  if (new$RECEIVEKD is null) then
    new$RECEIVEKD := 0;
  END IF;
  if ((new$RECEIVEKVR is null) or (new$RECEIVEKVR  is null)) then
    new$RECEIVEKVR := '000';
  END IF;
  if ((new$RECEIVEKESR is null) or (new$RECEIVEKESR  is null)) then
    new$RECEIVEKESR := '000';
  END IF;
  if (new$TRANSFERKVSR is null) then
    new$TRANSFERKVSR := 0;
  END IF;
  if (new$TRANSFERKCSR is null) then
    new$TRANSFERKCSR := 0;
  END IF;
  if (new$TRANSFERKFSR is null) then
    new$TRANSFERKFSR := 0;
  END IF;
  if (new$TRANSFERKVR is null) then
    new$TRANSFERKVR := 0;
  END IF;
  if (new$TRANSFERKESR is null) then
    new$TRANSFERKESR := 0;
  END IF;
  if ((new$TRANSFERKDVALUE is null) or (new$TRANSFERKDVALUE  is null)) then
    new$TRANSFERKDVALUE := '00000000000000000000';
  END IF;
  if (new$TARGETMEANSSIGN is null) then
    new$TARGETMEANSSIGN := 1;
  END IF;
  if (new$REGIONCLS is null) then
    new$REGIONCLS := 0;
  END IF;
  if (new$FACT is null) then
    new$FACT := 0;
  END IF;
  if (new$SourceLevel is null) then
    new$SourceLevel := 0;
  END IF;
  if (new$GrantKind is null) then
    new$GrantKind := 0;
  END IF;
  if (new$GrantKind = 2) then /*   "" */
    new$DestLevel := 1; /*    */

  else
    /*   ""  " "   */
    if ((new$GrantKind = 1) or (new$DestLevel is null)) then
      new$DestLevel := 0; /*   */
    END IF;
  END IF;
  if (new$TransfertKind is null) then
    new$TransfertKind  := 0;
  END IF;
  if (new$TransfertYear is null) then
    CurDateToDouble(CurrentDate$);
    new$TransfertYear := CurrentDate$ / 10000;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_TRANSFERTCLS_BI_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(*) INTO CNT$1
  from TransfertCls t where
  (        (t.ID <> new$ID) and
  (t.CODE=new$CODE) and
  (t.TargetCls=new$TargetCls) and
  (t.RECEIVEKVSR=new$RECEIVEKVSR) and
  (t.RECEIVEKFSR=new$RECEIVEKFSR) and
  (t.RECEIVEKCSR=new$RECEIVEKCSR) and
  (t.RECEIVEKVR=new$RECEIVEKVR) and
  (t.RECEIVEKESR=new$RECEIVEKESR) and
  (t.RECEIVEKD=new$RECEIVEKD) and
  (t.TRANSFERKVSR=new$TRANSFERKVSR) and
  (t.TRANSFERKFSR=new$TRANSFERKFSR) and
  (t.TRANSFERKCSR=new$TRANSFERKCSR) and
  (t.TRANSFERKVR=new$TRANSFERKVR) and
  (t.TRANSFERKESR=new$TRANSFERKESR) and
  (t.TRANSFERKDVALUE=new$TRANSFERKDVALUE) and
  (t.TARGETMEANSSIGN=new$TARGETMEANSSIGN) and
  (t.REGIONCLS=new$REGIONCLS) and
  (t.DESTLEVEL=new$DESTLEVEL) and
  (t.BUDGETREF=new$BUDGETREF) and
  ((t.EXTID is null and new$EXTID is null) or (t.EXTID = new$EXTID)) and
  (t.FACT=new$FACT)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('EX_DUPLICATE_TRANSFERT');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TRANSFERTCLS_BI_500)
-- Create 24.09.2007
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TRANSFERTCLS (
    ID,
    REGIONCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    CODE,
    RECEIVEKVSR,
    RECEIVEKFSR,
    RECEIVEKVR,
    RECEIVEKD,
    TRANSFERKVSR,
    TRANSFERKFSR,
    TRANSFERKCSR,
    TRANSFERKVR,
    TRANSFERKESR,
    TRANSFERKDVALUE,
    TARGETMEANSSIGN,
    TARGETCLS,
    STARTDATE,
    DELETEDATE,
    NOTE,
    NAME,
    BUDGETREF,
    RECEIVEKCSR,
    SOURCELEVEL,
    DESTLEVEL,
    TRANSFERTKIND,
    GRANTKIND,
    TRANSFERTYEAR,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    FACT,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    RECEIVEKESR
  ) VALUES (
    new$ID,
    new$REGIONCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$CODE,
    new$RECEIVEKVSR,
    new$RECEIVEKFSR,
    new$RECEIVEKVR,
    new$RECEIVEKD,
    new$TRANSFERKVSR,
    new$TRANSFERKFSR,
    new$TRANSFERKCSR,
    new$TRANSFERKVR,
    new$TRANSFERKESR,
    new$TRANSFERKDVALUE,
    new$TARGETMEANSSIGN,
    new$TARGETCLS,
    new$STARTDATE,
    new$DELETEDATE,
    new$NOTE,
    new$NAME,
    new$BUDGETREF,
    new$RECEIVEKCSR,
    new$SOURCELEVEL,
    new$DESTLEVEL,
    new$TRANSFERTKIND,
    new$GRANTKIND,
    new$TRANSFERTYEAR,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$FACT,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$RECEIVEKESR);

-- - - - - - - - - - - - -
-- AI_500 (TR_TRANSFERTCLS_AI_500)
-- Create 04.10.2007
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 203) and (RecordId = new$ID);

END;
/
-- CREATE TRIGGER TR_TRANSFERTCLS_BU_200
CREATE OR REPLACE TRIGGER TR_TRANSFERTCLS_IU
  INSTEAD OF UPDATE
  ON TRANSFERTCLS
  FOR EACH ROW
DECLARE
  new$ID TRANSFERTCLS.ID%TYPE := :NEW.ID;
  new$REGIONCLS TRANSFERTCLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATERUSER TRANSFERTCLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TRANSFERTCLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER TRANSFERTCLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE TRANSFERTCLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$CODE TRANSFERTCLS.CODE%TYPE := :NEW.CODE;
  new$RECEIVEKVSR TRANSFERTCLS.RECEIVEKVSR%TYPE := :NEW.RECEIVEKVSR;
  new$RECEIVEKFSR TRANSFERTCLS.RECEIVEKFSR%TYPE := :NEW.RECEIVEKFSR;
  new$RECEIVEKVR TRANSFERTCLS.RECEIVEKVR%TYPE := :NEW.RECEIVEKVR;
  new$RECEIVEKD TRANSFERTCLS.RECEIVEKD%TYPE := :NEW.RECEIVEKD;
  new$TRANSFERKVSR TRANSFERTCLS.TRANSFERKVSR%TYPE := :NEW.TRANSFERKVSR;
  new$TRANSFERKFSR TRANSFERTCLS.TRANSFERKFSR%TYPE := :NEW.TRANSFERKFSR;
  new$TRANSFERKCSR TRANSFERTCLS.TRANSFERKCSR%TYPE := :NEW.TRANSFERKCSR;
  new$TRANSFERKVR TRANSFERTCLS.TRANSFERKVR%TYPE := :NEW.TRANSFERKVR;
  new$TRANSFERKESR TRANSFERTCLS.TRANSFERKESR%TYPE := :NEW.TRANSFERKESR;
  new$TRANSFERKDVALUE TRANSFERTCLS.TRANSFERKDVALUE%TYPE := :NEW.TRANSFERKDVALUE;
  new$TARGETMEANSSIGN TRANSFERTCLS.TARGETMEANSSIGN%TYPE := :NEW.TARGETMEANSSIGN;
  new$TARGETCLS TRANSFERTCLS.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STARTDATE TRANSFERTCLS.STARTDATE%TYPE := :NEW.STARTDATE;
  new$DELETEDATE TRANSFERTCLS.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NOTE TRANSFERTCLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME TRANSFERTCLS.NAME%TYPE := :NEW.NAME;
  new$BUDGETREF TRANSFERTCLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECEIVEKCSR TRANSFERTCLS.RECEIVEKCSR%TYPE := :NEW.RECEIVEKCSR;
  new$SOURCELEVEL TRANSFERTCLS.SOURCELEVEL%TYPE := :NEW.SOURCELEVEL;
  new$DESTLEVEL TRANSFERTCLS.DESTLEVEL%TYPE := :NEW.DESTLEVEL;
  new$TRANSFERTKIND TRANSFERTCLS.TRANSFERTKIND%TYPE := :NEW.TRANSFERTKIND;
  new$GRANTKIND TRANSFERTCLS.GRANTKIND%TYPE := :NEW.GRANTKIND;
  new$TRANSFERTYEAR TRANSFERTCLS.TRANSFERTYEAR%TYPE := :NEW.TRANSFERTYEAR;
  new$EXTID TRANSFERTCLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER TRANSFERTCLS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE TRANSFERTCLS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$FACT TRANSFERTCLS.FACT%TYPE := :NEW.FACT;
  new$EXTROOTID TRANSFERTCLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION TRANSFERTCLS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE TRANSFERTCLS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$RECEIVEKESR TRANSFERTCLS.RECEIVEKESR%TYPE := :NEW.RECEIVEKESR;
--
  CurrentDate$ NUMBER;
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TRANSFERTCLS_BU)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (new$BUDGETREF is null) then
    new$BUDGETREF := 0;
  END IF;
  if (new$RECEIVEKVSR is null) then
    new$RECEIVEKVSR := 0;
  END IF;
  if (new$RECEIVEKCSR is null) then
    new$RECEIVEKCSR := 0;
  END IF;
  if (new$RECEIVEKFSR is null) then
    new$RECEIVEKFSR := 0;
  END IF;
  if (new$RECEIVEKD is null) then
    new$RECEIVEKD := 0;
  END IF;
  if ((new$RECEIVEKVR is null) or (new$RECEIVEKVR  is null)) then
    new$RECEIVEKVR := '000';
  END IF;
  if ((new$RECEIVEKESR is null) or (new$RECEIVEKESR  is null)) then
    new$RECEIVEKESR := '000';
  END IF;
  if (new$TRANSFERKVSR is null) then
    new$TRANSFERKVSR := 0;
  END IF;
  if (new$TRANSFERKCSR is null) then
    new$TRANSFERKCSR := 0;
  END IF;
  if (new$TRANSFERKFSR is null) then
    new$TRANSFERKFSR := 0;
  END IF;
  if (new$TRANSFERKVR is null) then
    new$TRANSFERKVR := 0;
  END IF;
  if (new$TRANSFERKESR is null) then
    new$TRANSFERKESR := 0;
  END IF;
  if ((new$TRANSFERKDVALUE is null) or (new$TRANSFERKDVALUE  is null)) then
    new$TRANSFERKDVALUE := '00000000000000000000';
  END IF;
  if (new$TARGETMEANSSIGN is null) then
    new$TARGETMEANSSIGN := 1;
  END IF;
  if (new$REGIONCLS is null) then
    new$REGIONCLS := 0;
  END IF;
  if (new$FACT is null) then
    new$FACT := 0;
  END IF;
  if (new$SourceLevel is null) then
    new$SourceLevel := 0;
  END IF;
  if (new$GrantKind is null) then
    new$GrantKind := 0;
  END IF;
  if (new$GrantKind = 2) then /*   "" */
    new$DestLevel := 1; /*    */

  else
    /*   ""  " "   */
    if ((new$GrantKind = 1) or (new$DestLevel is null)) then
      new$DestLevel := 0; /*   */
    END IF;
  END IF;
  if (new$TransfertKind is null) then
    new$TransfertKind  := 0;
  END IF;
  if (new$TransfertYear is null) then
    CurDateToDouble(CurrentDate$);
    new$TransfertYear := CurrentDate$ / 10000;

  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_TRANSFERTCLS_BU_100)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  if ((new$id = 0) and (new$Code <> :old.Code)) then
    RaiseException('EX_CANTMODIFY_ZEROTRANFERTSCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TRANSFERTCLS_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(*) INTO CNT$1
  from TransfertCls t where
  (        (t.ID <> new$ID) and
  (t.CODE=new$CODE) and
  (t.TargetCls=new$TargetCls) and
  (t.RECEIVEKVSR=new$RECEIVEKVSR) and
  (t.RECEIVEKFSR=new$RECEIVEKFSR) and
  (t.RECEIVEKCSR=new$RECEIVEKCSR) and
  (t.RECEIVEKVR=new$RECEIVEKVR) and
  (t.RECEIVEKESR=new$RECEIVEKESR) and
  (t.RECEIVEKD=new$RECEIVEKD) and
  (t.TRANSFERKVSR=new$TRANSFERKVSR) and
  (t.TRANSFERKFSR=new$TRANSFERKFSR) and
  (t.TRANSFERKCSR=new$TRANSFERKCSR) and
  (t.TRANSFERKVR=new$TRANSFERKVR) and
  (t.TRANSFERKESR=new$TRANSFERKESR) and
  (t.TRANSFERKDVALUE=new$TRANSFERKDVALUE) and
  (t.TARGETMEANSSIGN=new$TARGETMEANSSIGN) and
  (t.REGIONCLS=new$REGIONCLS) and
  (t.DESTLEVEL=new$DESTLEVEL) and
  (t.BUDGETREF=new$BUDGETREF) and
  ((t.EXTID is null and new$EXTID is null) or (t.EXTID = new$EXTID)) and
  (t.FACT=new$FACT)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('EX_DUPLICATE_TRANSFERT');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TRANSFERTCLS SET
    ID = new$ID,
    REGIONCLS = new$REGIONCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    CODE = new$CODE,
    RECEIVEKVSR = new$RECEIVEKVSR,
    RECEIVEKFSR = new$RECEIVEKFSR,
    RECEIVEKVR = new$RECEIVEKVR,
    RECEIVEKD = new$RECEIVEKD,
    TRANSFERKVSR = new$TRANSFERKVSR,
    TRANSFERKFSR = new$TRANSFERKFSR,
    TRANSFERKCSR = new$TRANSFERKCSR,
    TRANSFERKVR = new$TRANSFERKVR,
    TRANSFERKESR = new$TRANSFERKESR,
    TRANSFERKDVALUE = new$TRANSFERKDVALUE,
    TARGETMEANSSIGN = new$TARGETMEANSSIGN,
    TARGETCLS = new$TARGETCLS,
    STARTDATE = new$STARTDATE,
    DELETEDATE = new$DELETEDATE,
    NOTE = new$NOTE,
    NAME = new$NAME,
    BUDGETREF = new$BUDGETREF,
    RECEIVEKCSR = new$RECEIVEKCSR,
    SOURCELEVEL = new$SOURCELEVEL,
    DESTLEVEL = new$DESTLEVEL,
    TRANSFERTKIND = new$TRANSFERTKIND,
    GRANTKIND = new$GRANTKIND,
    TRANSFERTYEAR = new$TRANSFERTYEAR,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    FACT = new$FACT,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    RECEIVEKESR = new$RECEIVEKESR
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_TRANSFERTCLS_AU_500)
-- Create 04.10.2007
-- - - - - - - - - - - - -

  if (new$Id <> :old.Id) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (203, :Old.Id, SYSDATE);
    delete from DelRecIndexes where (TableID = 203) and (RecordId = new$ID);
  end if;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_Banks_add_CBRName.sql
-- #########################################################
-- #########################################################

/*      " -" */
ALTER TABLE TB_Banks ADD (
  CBRName VARCHAR2(2000)/*  - */
)
/

CREATE OR REPLACE VIEW Banks (
  ID,
  MFO,
  COR,
  CLOSED,
  UER,
  UERREAL,
  PZN,
  DATECLOSE,
  UPDATEDATE,
  CREATEDATE,
  CREATERUSER,
  UPDATERUSER,
  CBRNAME)
AS
  SELECT
    ID,
    MFO,
    COR,
    CLOSED,
    UER,
    UERREAL,
    PZN,
    DATECLOSE,
    UPDATEDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATERUSER,
    CBRNAME
  FROM TB_Banks
/

CREATE OR REPLACE TRIGGER TR_BANKS_ID
  INSTEAD OF DELETE
  ON BANKS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BANKS_BD)
-- Last update 09.06.2008
-- - - - - - - - - - - - -

  delete from Org_Accounts where bank_ref = :old.id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BANKS
  WHERE ID = :OLD.ID;

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_BANKS_AD_500)
-- - - - - - - - - - - - -

 insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(20,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_BANKS_II
  INSTEAD OF INSERT
  ON BANKS
  FOR EACH ROW
DECLARE
  new$ID BANKS.ID%TYPE := :NEW.ID;
  new$MFO BANKS.MFO%TYPE := :NEW.MFO;
  new$COR BANKS.COR%TYPE := :NEW.COR;
  new$CLOSED BANKS.CLOSED%TYPE := :NEW.CLOSED;
  new$UER BANKS.UER%TYPE := :NEW.UER;
  new$UERREAL BANKS.UERREAL%TYPE := :NEW.UERREAL;
  new$PZN BANKS.PZN%TYPE := :NEW.PZN;
  new$DATECLOSE BANKS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$UPDATEDATE BANKS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$CREATEDATE BANKS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BANKS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER BANKS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CBRNAME BANKS.CBRNAME%TYPE := :NEW.CBRNAME;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_banks_bi)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*  */
  CHECK_UNIQUE_BANK(new$MFO, new$COR);
    
  if (new$dateclose is null) then
    new$closed := null;
      
  else
    new$closed := 1;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BANKS_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$createdate := SYSDATE;
  new$updatedate := new$createdate;
  new$createruser := user;
  new$updateruser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BANKS (
    ID,
    MFO,
    COR,
    CLOSED,
    UER,
    UERREAL,
    PZN,
    DATECLOSE,
    UPDATEDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATERUSER,
    CBRNAME
  ) VALUES (
    new$ID,
    new$MFO,
    new$COR,
    new$CLOSED,
    new$UER,
    new$UERREAL,
    new$PZN,
    new$DATECLOSE,
    new$UPDATEDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$CBRNAME);

-- - - - - - - - - - - - -
-- AI_500 (TR_BANKS_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 20) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BANKS_IU
  INSTEAD OF UPDATE
  ON BANKS
  FOR EACH ROW
DECLARE
  new$ID BANKS.ID%TYPE := :NEW.ID;
  new$MFO BANKS.MFO%TYPE := :NEW.MFO;
  new$COR BANKS.COR%TYPE := :NEW.COR;
  new$CLOSED BANKS.CLOSED%TYPE := :NEW.CLOSED;
  new$UER BANKS.UER%TYPE := :NEW.UER;
  new$UERREAL BANKS.UERREAL%TYPE := :NEW.UERREAL;
  new$PZN BANKS.PZN%TYPE := :NEW.PZN;
  new$DATECLOSE BANKS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$UPDATEDATE BANKS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$CREATEDATE BANKS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BANKS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER BANKS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CBRNAME BANKS.CBRNAME%TYPE := :NEW.CBRNAME;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_banks_bu)
-- Version 11.10.00.1
-- - - - - - - - - - - - -

  /*  ,       */
  if ((:old.mfo is null and new$mfo is not null)
  or (:old.mfo is not null and new$mfo is null)
  or (:old.cor is null and new$cor is not null)
  or (:old.cor is not null and new$cor is null)
  or (new$mfo <> :old.mfo)
  or (new$cor <> :old.cor))
  then
    CHECK_UNIQUE_BANK(new$MFO, new$COR);
  END IF;
    
  /*    */
  if (new$DateClose is not null) then
    new$Closed := 1;
    /*     */
    if (:old.DateClose is null) then
      update Org_Accounts set
      CloseCode = CloseCode + 1000,
      DateClose = new$DateClose
      where Bank_Ref = new$ID;
      
    END IF;
  END IF;
  /*    */
  if (new$DateClose is null) then
    new$Closed := null;
    /*      */
    if (:old.DateClose is not null) then
      update Org_Accounts set CloseCode = CloseCode - 1000 where Bank_Ref = new$ID;
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BANKS SET
    ID = new$ID,
    MFO = new$MFO,
    COR = new$COR,
    CLOSED = new$CLOSED,
    UER = new$UER,
    UERREAL = new$UERREAL,
    PZN = new$PZN,
    DATECLOSE = new$DATECLOSE,
    UPDATEDATE = new$UPDATEDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    CBRNAME = new$CBRNAME
  WHERE ID = :old.ID;

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_BANKS_AU)
-- Create 27.07.2007
-- - - - - - - - - - - - -

  /*    */
  if ((new$DateClose is not null) and (:old.DateClose is null)) then
   /*    */
   update Organizations set
     DateClose = new$DateClose
   where (ID = new$ID) and (DateClose is null);
  end if;

  /*    */
  if ((new$DateClose is null) and (:old.DateClose is not null)) then
   /*    */
    update Organizations set
      DateClose = null
    where (ID = new$ID) and (DateClose is not null);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_BANKS_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (20, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=20) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
ALTER TRIGGER TR_BANKS_BU_500 DISABLE
/
update Banks b set
  CBRName = (select o1.BugName from organizations o1 where (o1.id = b.id))
where
  030200 = (select o2.Org_Type from organizations o2 where (o2.id = b.id))
/
ALTER TRIGGER TR_BANKS_BU_500 ENABLE
/
ALTER TRIGGER TR_ORGANIZATIONS_BU_500 DISABLE
/
update Organizations set
  BugName = null
where
  Org_Type = 030200
/
ALTER TRIGGER TR_ORGANIZATIONS_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_KD_check_ZeroCodeBudget.sql
-- #########################################################
-- #########################################################

/*   
1.        -   
2.           
 */
INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_WRONGZEROCODEBUDGET', -20372, '       ')
/
commit work
/
-- CREATE TRIGGER tr_kd_bi_0
CREATE OR REPLACE TRIGGER TR_KD_II
  INSTEAD OF INSERT
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vKDLevel$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KD_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */     
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupKD1$, new$BudgetRef,new$KESR);
  END IF;
  /*      */    
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and ((new$kdvalue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;
  if ((new$kdvalue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KD_BI_500)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_KD (
    ID,
    REPCODE,
    CREATEDATE,
    UPDATEDATE,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    KDVALUE,
    REMOTEFLAG,
    UNIONFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    KD_LEVEL,
    STARTDATE,
    SHORTNAME,
    CREATERUSER,
    UPDATERUSER,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPKD
  ) VALUES (
    new$ID,
    new$REPCODE,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$KDVALUE,
    new$REMOTEFLAG,
    new$UNIONFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$KD_LEVEL,
    new$STARTDATE,
    new$SHORTNAME,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPKD);

-- - - - - - - - - - - - -
-- AI_100 (TR_KD_AI_100)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    if (not (CNT$1<> 0))
    then
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);

    END IF;
  else
    /*   = 0,         ,     */
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vKDLevel$ := new$KD_Level;
    vDeleteDate$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName$, vShortName$, vKDLevel$, vDeleteDate$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update kd kd1 set
    name = vName$,
    ShortName = vShortName$,
    kd_level = vKDLevel$,
    deletedate = vDeleteDate$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_KD_AI_500)
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 80)  and (RecordID = new$ID);

END;
/
-- CREATE TRIGGER tr_kd_bu_0
CREATE OR REPLACE TRIGGER TR_KD_IU
  INSTEAD OF UPDATE
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  vName1$ VARCHAR2(1024);
  vShortName1$ VARCHAR2(1024);
  vKDLevel1$ NUMBER(10);
  vDeleteDate1$ DATE;
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KD_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     */
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupKD1$, new$BudgetRef,new$KESR);
  END IF;
  /*      */
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and ((new$kdvalue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;
  if ((new$kdvalue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_KD SET
    ID = new$ID,
    REPCODE = new$REPCODE,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    KDVALUE = new$KDVALUE,
    REMOTEFLAG = new$REMOTEFLAG,
    UNIONFLAG = new$UNIONFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    KD_LEVEL = new$KD_LEVEL,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPKD = new$ANALYTICALGROUPKD
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AU_100 (TR_KD_AU_100)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    inner join analyticalgroupkd ag on (ag.id = kd1.analyticalgroupkd)
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (ag.code = (select ag1.code
    from analyticalgroupkd ag1
    where (ag1.id = new$AnalyticalGroupKD))) and
    (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);

    END IF;
  else
    /*   = 0,         ,     */
    vName1$ := new$Name;
    vShortName1$ := new$ShortName;
    vKDLevel1$ := new$KD_Level;
    vDeleteDate1$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName1$, vShortName1$, vKDLevel1$, vDeleteDate1$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update kd kd1 set
    name = vName1$,
    ShortName = vShortName1$,
    kd_level = vKDLevel1$,
    deletedate = vDeleteDate1$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_KD_AU_500)
-- Create 28.04.2005
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (80, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=80) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_IFS_fix_Direction.sql
-- #########################################################
-- #########################################################

/* >alter_KD_check_ZeroCodeBudget.sql *//*    .  ""     -
    ,  . :
1.        -   
2.           
*/
-- ALTER TRIGGER tr_innerfinsource_bi_0
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_II
  INSTEAD OF INSERT
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel$ NUMBER(10);
  sDirection$ NUMBER(10);
  AGIFS1$ VARCHAR2(20);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_INNERFINSOURCE_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction)
    into sIFSLevel$, sDirection$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel$ is not null) then
    new$IFS_Level := sIFSLevel$;
  END IF;
  if (sDirection$ is not null) then
    new$Direction := sDirection$;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupIFS1$, new$BudgetRef,new$KESR);
  END IF;

  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((sAnalyticalGroupIFS1$ between '300' and '399') or
    (sAnalyticalGroupIFS1$ between '500' and '599') or
    (sAnalyticalGroupIFS1$ between '800' and '899')) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := -1;
      
    END IF;
  END IF;
  BEGIN
      
    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
      
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
        
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
          
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */  
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
        ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */  
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */  
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
      
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
        
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
          
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
            
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
              
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                  
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
      
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
        
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
          
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
            
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
              
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                  
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  /*      */  
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
  if ((new$ID = 0) and ((new$FinSourceValue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;
  if ((new$FinSourceValue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_INNERFINSOURCE_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_INNERFINSOURCE (
    ID,
    CREATEDATE,
    UPDATEDATE,
    DIRECTION,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    FINSOURCEVALUE,
    UNIONFLAG,
    REMOTEFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    STARTDATE,
    SHORTNAME,
    CLSASPECT,
    CREATERUSER,
    UPDATERUSER,
    IFS_LEVEL,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPIFS
  ) VALUES (
    new$ID,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$DIRECTION,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$FINSOURCEVALUE,
    new$UNIONFLAG,
    new$REMOTEFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$STARTDATE,
    new$SHORTNAME,
    new$CLSASPECT,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$IFS_LEVEL,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPIFS);

-- - - - - - - - - - - - -
-- AI_100 (TR_INNERFINSOURCE_AI_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);

    END IF;
  else
    /*   = 0,         ,     */
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_INNERFINSOURCE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 145) and (RecordId = new$ID);

END;
/
-- ALTER TRIGGER tr_innerfinsource_bu_0
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_IU
  INSTEAD OF UPDATE
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  vName1$ VARCHAR2(1024);
  vShortName1$ VARCHAR2(1024);
  vIFSLevel1$ NUMBER(10);
  vDirection1$ NUMBER(10);
  vDeleteDate1$ DATE;
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode1$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel1$ NUMBER(10);
  sDirection1$ NUMBER(10);
  AGIFS1$ VARCHAR2(20);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_INNERFINSOURCE_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction) 
    into sIFSLevel1$, sDirection1$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel1$ is not null) then
    new$IFS_Level := sIFSLevel1$;
  END IF;
  if (sDirection1$ is not null) then
    new$Direction := sDirection1$;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupIFS1$, new$BudgetRef,new$KESR);
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((sAnalyticalGroupIFS1$ between '300' and '399') or
    (sAnalyticalGroupIFS1$ between '500' and '599') or
    (sAnalyticalGroupIFS1$ between '800' and '899')) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := -1;  
      
    END IF;
  END IF;
  BEGIN

    /*      */ 
    select Code into KVSRCode1$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode1$ = 0) then
    sKVSR1$ := '000';
      
  else
    if (KVSRCode1$ < 10) then
      sKVSR1$ := '00' || KVSRCode1$;
        
    else
      if (KVSRCode1$ < 100) then
        sKVSR1$ := '0' || KVSRCode1$;
          
      else
        sKVSR1$ := KVSRCode1$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */  
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
        ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */  
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */  
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
      
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
        
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
          
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
            
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
              
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                  
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
      
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
        
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
          
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
            
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
              
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                  
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  /*      */  
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
  if ((new$ID = 0) and ((new$FinSourceValue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;
  if ((new$FinSourceValue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_INNERFINSOURCE SET
    ID = new$ID,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    DIRECTION = new$DIRECTION,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    FINSOURCEVALUE = new$FINSOURCEVALUE,
    UNIONFLAG = new$UNIONFLAG,
    REMOTEFLAG = new$REMOTEFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CLSASPECT = new$CLSASPECT,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    IFS_LEVEL = new$IFS_LEVEL,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_INNERFINSOURCE_AU_100)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    inner join analyticalgroupifs ag on (ag.id = ifs1.analyticalgroupifs)
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ag.code = (select ag1.code
    from analyticalgroupifs ag1
    where (ag1.id = new$analyticalgroupifs))) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);

    END IF;
  else
    /*   = 0,         ,     */
    vName1$ := new$Name;
    vShortName1$ := new$ShortName;
    vIFSLevel1$ := new$IFS_Level;
    vDeleteDate1$ := new$DeleteDate;
    vDirection1$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName1$, vShortName1$, vIFSLevel1$, vDirection1$, vDeleteDate1$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName1$,
    ShortName = vShortName1$,
    IFS_level = vIFSLevel1$,
    Direction = vDirection1$,
    deletedate = vDeleteDate1$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_INNERFINSOURCE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (145, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=145) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_KD_disable_NSI_update.sql
-- #########################################################
-- #########################################################

/*   , .           ,     . */
-- ALTER TRIGGER tr_kd_ai_100
CREATE OR REPLACE TRIGGER TR_KD_II
  INSTEAD OF INSERT
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
  vName1$ VARCHAR2(1024);
  vShortName1$ VARCHAR2(1024);
  vKDLevel1$ NUMBER(10);
  vDeleteDate1$ DATE;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KD_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */     
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupKD1$, new$BudgetRef,new$KESR);
  END IF;
  /*      */    
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and ((new$kdvalue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;
  if ((new$kdvalue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KD_BI_500)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_KD (
    ID,
    REPCODE,
    CREATEDATE,
    UPDATEDATE,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    KDVALUE,
    REMOTEFLAG,
    UNIONFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    KD_LEVEL,
    STARTDATE,
    SHORTNAME,
    CREATERUSER,
    UPDATERUSER,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPKD
  ) VALUES (
    new$ID,
    new$REPCODE,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$KDVALUE,
    new$REMOTEFLAG,
    new$UNIONFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$KD_LEVEL,
    new$STARTDATE,
    new$SHORTNAME,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPKD);

-- - - - - - - - - - - - -
-- AI_100 (TR_KD_AI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    if (not (CNT$1<> 0))
    then  
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);
      
    END IF;
  else 
    /*   = 0,         ,     */    
    vName1$ := new$Name;
    vShortName1$ := new$ShortName;
    vKDLevel1$ := new$KD_Level;
    vDeleteDate1$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName1$, vShortName1$, vKDLevel1$, vDeleteDate1$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update kd kd1 set
    name = vName1$,
    ShortName = vShortName1$,
    kd_level = vKDLevel1$,
    deletedate = vDeleteDate1$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef) and
    (kd1.extId is null); /*      */
      
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_KD_AI_500)
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 80)  and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER tr_kd_au_100
CREATE OR REPLACE TRIGGER TR_KD_IU
  INSTEAD OF UPDATE
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vKDLevel$ NUMBER(10);
  vDeleteDate$ DATE;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KD_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     */
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupKD1$, new$BudgetRef,new$KESR);
  END IF;
  /*      */
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and ((new$kdvalue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;
  if ((new$kdvalue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_KD SET
    ID = new$ID,
    REPCODE = new$REPCODE,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    KDVALUE = new$KDVALUE,
    REMOTEFLAG = new$REMOTEFLAG,
    UNIONFLAG = new$UNIONFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    KD_LEVEL = new$KD_LEVEL,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPKD = new$ANALYTICALGROUPKD
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AU_100 (TR_KD_AU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    inner join analyticalgroupkd ag on (ag.id = kd1.analyticalgroupkd)
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (ag.code = (select ag1.code
    from analyticalgroupkd ag1
    where (ag1.id = new$AnalyticalGroupKD))) and
    (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);
      
    END IF;
  else
    /*   = 0,         ,     */    
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vKDLevel$ := new$KD_Level;
    vDeleteDate$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName$, vShortName$, vKDLevel$, vDeleteDate$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update kd kd1 set
    name = vName$,
    ShortName = vShortName$,
    kd_level = vKDLevel$,
    deletedate = vDeleteDate$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef) and
    (kd1.extId is null); /*      */
      
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_KD_AU_500)
-- Create 28.04.2005
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (80, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=80) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER tr_innerfinsource_ai_100
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_II
  INSTEAD OF INSERT
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel$ NUMBER(10);
  sDirection$ NUMBER(10);
  AGIFS1$ VARCHAR2(20);
  vName1$ VARCHAR2(1024);
  vShortName1$ VARCHAR2(1024);
  vIFSLevel1$ NUMBER(10);
  vDirection1$ NUMBER(10);
  vDeleteDate1$ DATE;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_INNERFINSOURCE_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction)
    into sIFSLevel$, sDirection$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel$ is not null) then
    new$IFS_Level := sIFSLevel$;
  END IF;
  if (sDirection$ is not null) then
    new$Direction := sDirection$;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupIFS1$, new$BudgetRef,new$KESR);
  END IF;

  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((sAnalyticalGroupIFS1$ between '300' and '399') or
    (sAnalyticalGroupIFS1$ between '500' and '599') or
    (sAnalyticalGroupIFS1$ between '800' and '899')) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := -1;
      
    END IF;
  END IF;
  BEGIN
      
    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
      
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
        
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
          
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */  
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
        ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */  
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */  
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
      
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
        
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
          
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
            
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
              
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                  
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
      
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
        
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
          
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
            
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
              
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                  
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  /*      */  
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
  if ((new$ID = 0) and ((new$FinSourceValue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;
  if ((new$FinSourceValue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_INNERFINSOURCE_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_INNERFINSOURCE (
    ID,
    CREATEDATE,
    UPDATEDATE,
    DIRECTION,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    FINSOURCEVALUE,
    UNIONFLAG,
    REMOTEFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    STARTDATE,
    SHORTNAME,
    CLSASPECT,
    CREATERUSER,
    UPDATERUSER,
    IFS_LEVEL,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPIFS
  ) VALUES (
    new$ID,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$DIRECTION,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$FINSOURCEVALUE,
    new$UNIONFLAG,
    new$REMOTEFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$STARTDATE,
    new$SHORTNAME,
    new$CLSASPECT,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$IFS_LEVEL,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPIFS);

-- - - - - - - - - - - - -
-- AI_100 (TR_INNERFINSOURCE_AI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName1$ := new$Name;
    vShortName1$ := new$ShortName;
    vIFSLevel1$ := new$IFS_Level;
    vDeleteDate1$ := new$DeleteDate;
    vDirection1$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName1$, vShortName1$, vIFSLevel1$, vDirection1$, vDeleteDate1$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName1$,
    ShortName = vShortName1$,
    IFS_level = vIFSLevel1$,
    Direction = vDirection1$,
    deletedate = vDeleteDate1$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef) and
    (ifs1.extId is null); /*      */
      
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_INNERFINSOURCE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 145) and (RecordId = new$ID);

END;
/
-- ALTER TRIGGER tr_innerfinsource_au_100
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_IU
  INSTEAD OF UPDATE
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode1$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel1$ NUMBER(10);
  sDirection1$ NUMBER(10);
  AGIFS1$ VARCHAR2(20);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_INNERFINSOURCE_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction) 
    into sIFSLevel1$, sDirection1$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel1$ is not null) then
    new$IFS_Level := sIFSLevel1$;
  END IF;
  if (sDirection1$ is not null) then
    new$Direction := sDirection1$;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    getkesr(sAnalyticalGroupIFS1$, new$BudgetRef,new$KESR);
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((sAnalyticalGroupIFS1$ between '300' and '399') or
    (sAnalyticalGroupIFS1$ between '500' and '599') or
    (sAnalyticalGroupIFS1$ between '800' and '899')) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (sAnalyticalGroupIFS1$ = AGIFS1$) then
      new$Direction := -1;  
      
    END IF;
  END IF;
  BEGIN

    /*      */ 
    select Code into KVSRCode1$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode1$ = 0) then
    sKVSR1$ := '000';
      
  else
    if (KVSRCode1$ < 10) then
      sKVSR1$ := '00' || KVSRCode1$;
        
    else
      if (KVSRCode1$ < 100) then
        sKVSR1$ := '0' || KVSRCode1$;
          
      else
        sKVSR1$ := KVSRCode1$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */  
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
        ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */  
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */  
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
      
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
        
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
          
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
            
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
              
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                  
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
      
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
        
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
          
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
            
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
              
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                  
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  /*      */  
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
  if ((new$ID = 0) and ((new$FinSourceValue <> '00000000000000000000') or (new$BudgetRef <> 0))) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;
  if ((new$FinSourceValue = '00000000000000000000') and (new$BudgetRef <> 0) and (new$DeleteDate is null)) then
    RaiseException('ex_WrongZeroCodeBudget');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_INNERFINSOURCE SET
    ID = new$ID,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    DIRECTION = new$DIRECTION,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    FINSOURCEVALUE = new$FINSOURCEVALUE,
    UNIONFLAG = new$UNIONFLAG,
    REMOTEFLAG = new$REMOTEFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CLSASPECT = new$CLSASPECT,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    IFS_LEVEL = new$IFS_LEVEL,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_INNERFINSOURCE_AU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    inner join analyticalgroupifs ag on (ag.id = ifs1.analyticalgroupifs)
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ag.code = (select ag1.code
    from analyticalgroupifs ag1
    where (ag1.id = new$analyticalgroupifs))) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef) and
    (ifs1.extId is null); /*      */
      
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_INNERFINSOURCE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (145, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=145) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_Orgs_BugName_size.sql
-- #########################################################
-- #########################################################

/*       " "  100  */
ALTER TABLE TB_ORGANIZATIONS MODIFY (BugName VARCHAR2(100))
/
commit work
/

-- #########################################################
-- #########################################################
-- Fix_1400.sql
-- #########################################################
-- #########################################################

/*    14.00 */
/*      13.00 (   ) */
drop procedure ImportRemoteDoc
/
COMMIT WORK 
/


-- #########################################################
-- #########################################################
-- alter_PlanDocType_AssignmentSource_NSI.sql
-- #########################################################
-- #########################################################

/*       " "  " " */
/* PlanDocType */
ALTER TABLE PlanDocType ADD (
  Code NUMBER(10),/*  */
    CHECK((Code<=2147483647)AND(Code>-2147483648)),
  BudgetRef NUMBER(10),/*  */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  ExtId VARCHAR2(50),/*        */
  ExtRootId VARCHAR2(50),/*   */
  StartDate DATE,/*    */
  DeleteDate DATE,/*    */
  CreaterUser VARCHAR2(30),/*  */
  UpdaterUser VARCHAR2(30)/*  */
)
/
ALTER TRIGGER TR_PLANDOCTYPE_BU_500 DISABLE
/
commit work
/
update PlanDocType set
  CODE = Id,
  BudgetRef = 0,
  CreaterUser = User,
  UpdaterUser = User
/
commit work
/
ALTER TRIGGER TR_PLANDOCTYPE_BU_500 ENABLE
/
ALTER TABLE PlanDocType ADD (
  CONSTRAINT FK_PlanDocType_BUDGETREF FOREIGN KEY (BUDGETREF) REFERENCES TB_BUDGETS_S (ID),
  CONSTRAINT UQ_PlanDocType_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/
CREATE INDEX FK_PlanDocType_BUDGETREF ON PlanDocType(BUDGETREF)
/
-- CREATE TRIGGER TR_PlanDocType_BI_0
CREATE OR REPLACE TRIGGER TR_PLANDOCTYPE_BI
  BEFORE INSERT
  ON PLANDOCTYPE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PlanDocType_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PLANDOCTYPE_BI_500)
-- - - - - - - - - - - - -

--     
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;

END;
/
-- CREATE TRIGGER TR_PlanDocType_BU_0
CREATE OR REPLACE TRIGGER TR_PlanDocType_BU
  BEFORE UPDATE
  ON PlanDocType
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PlanDocType_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- ALTER TRIGGER tr_plandoctype_bi_500
CREATE OR REPLACE TRIGGER TR_PLANDOCTYPE_BI
  BEFORE INSERT
  ON PLANDOCTYPE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PlanDocType_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PLANDOCTYPE_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER tr_plandoctype_bu_500
CREATE OR REPLACE TRIGGER TR_PLANDOCTYPE_BU_500
  BEFORE UPDATE
  ON PLANDOCTYPE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_PLANDOCTYPE_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.Updatedate := SYSDATE;
  :new.UpdaterUser := User;

END;
/
commit work
/
/* AssignmentSource */
ALTER TABLE AssignmentSource ADD (
  Code NUMBER(10),/*  */
    CHECK((Code<=2147483647)AND(Code>-2147483648)),
  BudgetRef NUMBER(10),/*  */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  ExtId VARCHAR2(50),/*        */
  ExtRootId VARCHAR2(50)/*   */
)
/
ALTER TRIGGER TR_ASSIGNMENTSOURCE_BU_500 DISABLE
/
commit work
/
update AssignmentSource set
  CODE = Id,
  BudgetRef = 0
/
commit work
/
ALTER TRIGGER TR_ASSIGNMENTSOURCE_BU_500 ENABLE
/
ALTER TABLE AssignmentSource ADD (
  CONSTRAINT FK_AssignSource_BUDGETREF FOREIGN KEY (BUDGETREF) REFERENCES TB_BUDGETS_S (ID),
  CONSTRAINT UQ_AssignSource_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/
CREATE INDEX FK_AssignSource_BUDGETREF ON AssignmentSource(BUDGETREF)
/
-- CREATE TRIGGER TR_AssignmentSource_BI_0
CREATE OR REPLACE TRIGGER TR_ASSIGNMENTSOURCE_BI
  BEFORE INSERT
  ON ASSIGNMENTSOURCE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AssignmentSource_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ASSIGNMENTSOURCE_BI_500)
-- Create 04.10.2007
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
-- CREATE TRIGGER TR_AssignmentSource_BU_0
CREATE OR REPLACE TRIGGER TR_AssignmentSource_BU
  BEFORE UPDATE
  ON AssignmentSource
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AssignmentSource_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
commit work
/
-- ALTER TRIGGER tr_budnotify_bi
CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
--
  UseFax$ NUMBER(10);
  PDTCode$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then 
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then 
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then 
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if (new$PlanDocType is not null) then
    BEGIN
      select
      pdt.Code
      into PDTCode$     from
      PlanDocType pdt
      where
      (pdt.ID = new$PlanDocType)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((PDTCode$ > 99)and(PDTCode$ < 200)) then
      new$AType := 0;
          
    else
      new$AType := 1;
      
    END IF;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  if (new$PROGINDEX is null) then 
    new$PROGINDEX := 32;
  END IF;
  if (new$BA_LBO_Flag is null) then 
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then 
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19,UseFax$);
    IF ((new$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      new$BidNumber:= new$ANumber;
    END IF;
    new$FaxDocCount:= 0;

  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER,
    STARTDATE,
    ENDDATE
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$ANUMBER,
    new$STARTDATE,
    new$ENDDATE);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/
-- ALTER TRIGGER tr_budnotify_bu
CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
--
  IsReject$ NUMBER(10);
  DetCount1$ NUMBER(10);
  PDTCode$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then 
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then 
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then 
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then 
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is not null) and (new$PlanDocType <> :old.PlanDocType)) then
    BEGIN
      select
      pdt.Code
      into PDTCode$     from
      PlanDocType pdt
      where
      (pdt.ID = new$PlanDocType)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((PDTCode$ > 99)and(PDTCode$ < 200)) then
      new$AType := 0;
          
    else
      new$AType := 1;
      
    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount1$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');        
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  if (new$PROGINDEX is null) then 
    new$PROGINDEX := 32;
  END IF;
  if (new$BA_LBO_Flag is null) then 
    new$BA_LBO_Flag := 0;  
  END IF;
  if (new$KPPeriod is null) then 
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    ANUMBER = new$ANUMBER,
    STARTDATE = new$STARTDATE,
    ENDDATE = new$ENDDATE
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
commit work
/
ALTER TABLE PlanDocType MODIFY(Code NOT NULL)
/
ALTER TABLE PlanDocType MODIFY(BudgetRef NOT NULL)
/
ALTER TABLE AssignmentSource MODIFY(Code NOT NULL)
/
ALTER TABLE AssignmentSource MODIFY(BudgetRef NOT NULL)
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_BUDGETDATA_BI_Ora.sql
-- #########################################################
-- #########################################################


create or replace TRIGGER TR_BUDGETDATA_BI
  BEFORE INSERT
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OrgRefByAcc1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  doubleUse1$ NUMBER(10);
  BALBOFlag1$ NUMBER(10);
  AllowDivideBA1$ NUMBER(10);
  StimateKind1$ NUMBER(10);
  AutoKvrCorr1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDGETDATA_BI)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  IF (:new.id IS NULL) THEN
    select g_shared.nextval into :new.id from dual;
  END IF;
  IF (:new.KFSR IS NULL) THEN
    :new.KFSR := 0;
  END IF;
  IF (:new.KVSR IS NULL) THEN
    :new.KVSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN
    :new.KVR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN
    :new.KCSR := 0;
  END IF;
  IF (:new.KESR IS NULL) THEN
    :new.KESR := 0;
  END IF;
  IF (:new.SubKESR IS NULL) THEN
    :new.SubKESR := 0;
  END IF;
  IF (:new.RegionCLS IS NULL) THEN
    :new.RegionCLS := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN
    :new.DirectionCls := 0;
  END IF;
  IF (:new.FundsSource IS NULL) THEN
    :new.FundsSource := 0;
  END IF;
  IF (:new.KD IS NULL) THEN
    :new.KD := 0;
  END IF;
  IF (:new.subkd IS NULL) THEN
    :new.subkd := 0;
  END IF;
  IF (:new.Fact IS NULL) THEN
    :new.Fact := 0;
  END IF;
  IF (:new.FacialAcc_Cls IS NULL) THEN
    :new.FacialAcc_Cls := 0;
  END IF;
  IF (:new.KVRCorr IS NULL) THEN
    :new.KVRCorr := 0;
  END IF;
  IF (:new.KESRCorr IS NULL) THEN
    :new.KESRCorr := 0;
  END IF;
  IF (:new.AssignmentKind IS NULL) THEN
    :new.AssignmentKind := 0;
  END IF;
  IF (:new.Quarter1 IS NULL) THEN
    :new.Quarter1 := 0;
  END IF;
  IF (:new.Quarter2 IS NULL) THEN
    :new.Quarter2 := 0;
  END IF;
  IF (:new.Quarter3 IS NULL) THEN
    :new.Quarter3 := 0;
  END IF;
  IF (:new.Quarter4 IS NULL) THEN
    :new.Quarter4 := 0;
  END IF;
  IF (:new.DayPlanSumma IS NULL) THEN
    :new.DayPlanSumma := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN
    :new.FinType := 0;
  END IF;
  IF (:new.MeansType IS NULL) THEN
    :new.MeansType := 0;
  END IF;
  IF (:new.DepartmentCls IS NULL) THEN
    :new.DepartmentCls := 0;
  END IF;
  /*   .      */
  IF (:new.IFS IS NULL) THEN
    :new.IFS := 0;
  END IF;
  IF (:new.BuhOperationCLS IS NULL)
  THEN
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
  BEGIN

    /*  .   */
    SELECT bn.BudgetRef      INTO :new.BudgetRef FROM BudNotify bn
    WHERE bn.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  IF (:new.Month01 IS NULL) THEN
    :new.Month01 := 0;
  END IF;
  IF (:new.Month02 IS NULL) THEN
    :new.Month02 := 0;
  END IF;
  IF (:new.Month03 IS NULL) THEN
    :new.Month03 := 0;
  END IF;
  IF (:new.Month04 IS NULL) THEN
    :new.Month04 := 0;
  END IF;
  IF (:new.Month05 IS NULL) THEN
    :new.Month05 := 0;
  END IF;
  IF (:new.Month06 IS NULL) THEN
    :new.Month06 := 0;
  END IF;
  IF (:new.Month07 IS NULL) THEN
    :new.Month07 := 0;
  END IF;
  IF (:new.Month08 IS NULL) THEN
    :new.Month08 := 0;
  END IF;
  IF (:new.Month09 IS NULL) THEN
    :new.Month09 := 0;
  END IF;
  IF (:new.Month10 IS NULL) THEN
    :new.Month10 := 0;
  END IF;
  IF (:new.Month11 IS NULL) THEN
    :new.Month11 := 0;
  END IF;
  IF (:new.Month12 IS NULL) THEN
    :new.Month12 := 0;
  END IF;
  IF (:new.SummaYear1 IS NULL) THEN
    :new.SummaYear1 := 0;
  END IF;
  IF (:new.SummaYear2 IS NULL) THEN
    :new.SummaYear2 := 0;
  END IF;
  IF (:new.SummaYear3 IS NULL) THEN
    :new.SummaYear3 := 0;
  END IF;
  IF (:new.SummaYear4 IS NULL) THEN
    :new.SummaYear4 := 0;
  END IF;
  IF (:new.SummaOtherYears IS NULL) THEN
    :new.SummaOtherYears := 0;
  END IF;
  BEGIN

    SELECT
    c.BA_LBO_FLAG
    INTO
    BALBOFlag1$  FROM
    BudNotify c
    WHERE
    c.id = :new.RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*   */
  IF (:new.ProgIndex = 262) THEN
    GetIntConst(32, 43,StimateKind1$);
    IF ((StimateKind1$  = 0) OR (StimateKind1$  IS NULL)) THEN
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

    ELSE
      IF (StimateKind1$  = 1) THEN
        :new.Quarter1 := :new.SummaYear1;

      ELSE
        :new.Quarter1 := :new.Month01 + :new.Month02 +:new.Month03;
        :new.Quarter2 := :new.Month04 + :new.Month05 +:new.Month06;
        :new.Quarter3 := :new.Month07 + :new.Month08 +:new.Month09;
        :new.Quarter4 := :new.Month10 + :new.Month11 +:new.Month12;
        :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

      END IF;
    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 260) THEN
    GetIntConst(32, 30,doubleUse1$);
    GetIntConst(32, 40,AllowDivideBA1$);
    IF ((doubleUse1$=1) AND ((BALBOFlag1$  <> 1) OR (AllowDivideBA1$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

    END IF;
  END IF;
  /* ()*/
  IF (:new.ProgIndex = 264) THEN
    GetIntConst(32, 34,doubleUse1$);
    GetIntConst(32, 40,AllowDivideBA1$);
    IF ((doubleUse1$=1) AND ((BALBOFlag1$  <> 1) OR (AllowDivideBA1$ = 1))) THEN  /*       ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 32) THEN
    GetIntConst(32, 31,doubleUse1$);
    GetIntConst(32, 40,AllowDivideBA1$);
    IF ((doubleUse1$=1) AND ((BALBOFlag1$  <> 1) OR (AllowDivideBA1$ = 1))) THEN  /*          ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

    END IF;
  END IF;
  /*  ()*/
  IF (:new.ProgIndex = 215) THEN
    GetIntConst(32, 35,doubleUse1$);
    GetIntConst(32, 40,AllowDivideBA1$);
    IF ((doubleUse1$=1) AND ((BALBOFlag1$  <> 1) OR (AllowDivideBA1$ = 1))) THEN  /*         ,     */
      :new.SummaYear1 := :new.Quarter1 + :new.Quarter2 + :new.Quarter3 + :new.Quarter4;

    END IF;
  END IF;
  /*
   IF ((NEW.TransfertOrg_Ref IS NULL) AND (NEW.REGIONCLS <> 0)) THEN
      SELECT Organizations FROM REGIONCLS
        WHERE NEW.REGIONCLS = ID
      INTO NEW.TransfertOrg_Ref;
  *//*    */
  IF ((:new.SenderRecordID is null) AND (:new.SenderID is null)) THEN
    GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
    :new.targetcls,:new.targetcls);
  END IF;
  
-- - - - - - - - - - - - -
-- BI_10 (tr_BudgetData_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (:new.SenderID is null) then
    :new.SenderIDKey := -1;

  else
    :new.SenderIDKey := :new.SenderID;
  END IF;

  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_BUDGETDATA_BI_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if (:new.ClsType is NULL) then
    BEGIN
      select
      bn.ClsType
      into
      CapClsType1$     from
      BudNotify bn
      where
      bn.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (CapClsType1$  = 3) then
      if (:new.IFS <> 0) then
        :new.ClsType := 1; /*       ClsType */

      else
        if (:new.KD <> 0) then
          :new.ClsType := 2; /* */

        else
          :new.ClsType := 0; /* */
        END IF;
      END IF;
    else
      :new.ClsType := CapClsType1$;

    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.IFS <> 0)or(:new.KD <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  if (((:new.ClsType = 1)and(:new.KD <> 0))or((:new.ClsType = 2)and(:new.IFS <> 0))) then
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1) AND (:new.ClsType <> 2)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;
  IF (:new.ACC_REF IS NOT NULL) THEN /*    / */
    BEGIN
      SELECT oa.ORG_REF
      INTO OrgRefByAcc1$     FROM ORG_ACCOUNTS oa
      WHERE (oa.ID = :new.ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (:new.FacialAcc_CLS = 0) then
      :new.Org_Ref := OrgRefByAcc1$;

    END IF;
  END IF;
  /*  \ ,       \    \,  \ */
  if (:new.FacialAcc_CLS <> 0) then
    BEGIN
      SELECT
      fac.ORG_REF
      INTO :new.Org_Ref     FROM
      FacialACC_CLS fac
      WHERE
      (fac.ID = :new.FacialAcc_CLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (OrgRefByAcc1$<>:new.Org_Ref) then
      :new.ACC_REF := null;

    END IF;
  END IF;
  if ((:new.ProgIndex in (252, 253))and(:new.FacialAcc_CLS = 0)) then
    BEGIN
      SELECT
      bn.FacialAccCLS
      INTO :new.FacialAcc_CLS     FROM
      BudNotify bn
      WHERE
      (bn.ID = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_BUDGETDATA_BI_200)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*       32-, 260-, 261-, 262-  , 263-, 268-  , 252-. */
  if (:new.ProgIndex in (32, 252, 260, 261, 262, 263, 268)) then
    /*     (32  ())
             :
           =0     ,
           =1  ,
           =2   0  .*//*     260 ()
             :
           =2   0  .*/
    GetIntConst(32, 25,AutoKvrCorr1$);
    if (:new.ProgIndex = 32) then /*  ()*/
      if (AutoKvrCorr1$  = 0) then
        :new.KvrCorr := :new.Kvr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KvrCorr := 0;
        END IF;
      END IF;
      /* KESR   */
      if (AutoKvrCorr1$  = 0) then
        :new.KesrCorr := :new.Kesr;

      else
        if (AutoKvrCorr1$  = 2) then
          :new.KesrCorr := 0;
        END IF;
      END IF;
    else
      if ((:new.ProgIndex = 260)and (AutoKvrCorr1$  = 2)) then  /* ()*/
        :new.KvrCorr := 0;
        --   ,    new.Kvr = 0;
        /* KESR   */

        :new.KesrCorr := 0;

      else
        :new.KvrCorr := :new.Kvr; /*         */
        /* KESR   */
        :new.KesrCorr := :new.Kesr;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDGETDATA_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

  Update BudNotify set
  DocChangeDate = :new.UpdateDate,
  RVersion = -1
  where id = :new.recordindex;

END;
/


-- #########################################################
-- #########################################################
-- Alter_FacialFinCaption_CodePurpose.sql
-- #########################################################
-- #########################################################

ALTER TABLE TB_facialfincaption ADD (
  CodePurpose NUMBER(10),
    CHECK((CodePurpose<=2147483647)AND(CodePurpose>-2147483648))
)
/

CREATE OR REPLACE VIEW facialfincaption (
  ID,
  DOCNUMBER,
  SOURCEDOCNUM,
  PAYDATE,
  ACCEPTDATE,
  DOCUMENTDATE,
  REESTRDATE,
  CREDIT,
  SOURCEACCOUNT,
  SOURCEFACIALACC_CLS,
  DESTACCOUNT,
  DESTFACIALACC_CLS,
  PROGINDEX,
  ARHIVEDOC,
  PAYSYMBOLCLS,
  PAYTYPECLS,
  NOTE,
  PERIOD,
  PAYPRIORITY,
  TYPEOPERATIONCLS,
  BUHPAYMENTCLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  RECORDINDEX,
  SENDERID,
  SENDERRECORDID,
  REESTR_REF,
  REJECT_CLS,
  CLIENTBANKNUMBER,
  CRYPTOSTATUS,
  TRUSTNUMBER,
  LINKEDDOCUMENT,
  BNKRECORDID,
  SUBPROGINDEX,
  DOCUMENTSTATE,
  USERSVISA,
  TREASUARYDOCSTATECLS,
  DEPARTMENTCLS,
  NDS,
  TAXNOTE,
  MANAGERBID,
  BIDNUMBER,
  GROUPID,
  GROUPSUMMA,
  DOCSTATEREF,
  LASTEXTRCHANGE,
  STIMATEID,
  INTEGRATEDDOCREF,
  REQUESTNUMBER,
  REQUESTDATE,
  RVERSION,
  FEDERALFUNDSREF,
  ELDOCREF,
  BUHOPERATIONCLS,
  CLSTYPE,
  OPERATIONDIRECTION,
  SOURCETYPE,
  DESTTYPE,
  CARDNUMBER,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  CASHIERPERSONALINFO,
  BIDDATE,
  CARDREF,
  SOURCESTOREDPAYMENTPROPS,
  DESTSTOREDPAYMENTPROPS,
  STOREDPAYMENTNOTE,
  DOCCHANGEDATE,
  UINCODE,
  DOCOSN,
  SIGNERS,
  DESTCLSTYPE,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  AUTOSANCTION,
  STOREDPAYMENTCONTENT,
  REJECTCAUSE,
  CODEPURPOSE)
AS
  SELECT
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE
  FROM TB_facialfincaption
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
--
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE,
    new$CODEPURPOSE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE,
    CODEPURPOSE = new$CODEPURPOSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_PaymentCodeType.sql
-- #########################################################
-- #########################################################

create table PaymentCodeType(
  id NUMBER(10) NOT NULL,
    CHECK((id<=2147483647)AND(id>-2147483648)),
  Code VARCHAR2(4) NOT NULL,/* */
  Name VARCHAR2(4000),/* */
  StartDate DATE,/*     */
  DeleteDate DATE,/*  */
  BUDGETREF NUMBER(10) NOT NULL,/* */
    CHECK((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)),
  ExtId VARCHAR2(50),/*  */
  ExtRootId VARCHAR2(50),/*   */
  Note VARCHAR2(1024),/* */
  EXTOWNER VARCHAR2(50),
  EXTSYNCDATE DATE,
  EXTVERSION VARCHAR2(50),
  EXTVERSIONDATE DATE,
  CreateDate DATE,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,
  UpdateDate DATE,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,
  constraint PaymentCodeType_PK_ID PRIMARY KEY (ID),
  constraint fk_PCType_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID)
)
/
CREATE INDEX fk_PCType_BudgetRef ON PaymentCodeType(BudgetRef)
/
CREATE INDEX IDX_PCType_EXTID ON PaymentCodeType (EXTID)
/
-- CREATE TRIGGER TR_PCType_AD_500
CREATE OR REPLACE TRIGGER TR_PaymentCodeType_AD
  AFTER DELETE
  ON PaymentCodeType
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_PCType_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98113,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_PCType_BI_0
CREATE OR REPLACE TRIGGER TR_PaymentCodeType_BI
  BEFORE INSERT
  ON PaymentCodeType
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PCType_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_PCType_BI_500
CREATE OR REPLACE TRIGGER TR_PaymentCodeType_BI
  BEFORE INSERT
  ON PaymentCodeType
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PCType_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PCType_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_PCType_BU_0
CREATE OR REPLACE TRIGGER TR_PaymentCodeType_BU
  BEFORE UPDATE
  ON PaymentCodeType
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PCType_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_PCType_BU_500
CREATE OR REPLACE TRIGGER TR_PCType_BU_500
  BEFORE UPDATE
  ON PAYMENTCODETYPE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_PCType_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on PaymentCodeType to BUDGET_USERS
/
commit work
/
CREATE OR REPLACE procedure AddPaymentCodeType(Code$ VARCHAR2,Name$ VARCHAR2)
AS
  CNT$1 NUMBER(10);
BEGIN
  SELECT COUNT(Id ) INTO CNT$1
  from PaymentCodeType where ((Code = Code$)) AND (ROWNUM = 1);
    
  if ((CNT$1<> 0)) then
    Update PaymentCodeType pct set
    pct.Name = Name$

    where (pct.Code = Code$);
        
  else
    insert into PaymentCodeType(Id, Code, Name) values (Code$, Code$, Name$);
  END IF;
END;
/
CALL AddPaymentCodeType('0301', '     ,          ') 
/
CALL AddPaymentCodeType('0302', '     ,          ') 
/
CALL AddPaymentCodeType('0401', '               ,               ,                 ,     ,        ,      ,                 ,  ,      ') 
/
CALL AddPaymentCodeType('0402', '                ,               ,                 ,     ,        ,      ,                 ,  ,      ') 
/
CALL AddPaymentCodeType('0403', '     ,             ,               ,                 ,     ,        ,      ,                 ,  ,      ') 
/
CALL AddPaymentCodeType('0404', '  ,          ,             ,               ,                 ,     ,        ,      ,                 ,  ,      ') 
/
CALL AddPaymentCodeType('0405', '     ,             ,               ,                 ,     ,        ,      ,                 ,  ,      ') 
/
CALL AddPaymentCodeType('0406', '      ,             ,               ,                 ,     ,        ,      ,                 ,  ,      
') 
/
CALL AddPaymentCodeType('0418', '              1941 - 1945 ') 
/
CALL AddPaymentCodeType('0428', '  ') 
/
CALL AddPaymentCodeType('0535', '      ') 
/
CALL AddPaymentCodeType('0303', '                 ,   ,           ') 
/
CALL AddPaymentCodeType('0502', '         -') 
/
CALL AddPaymentCodeType('0505', '          (, )') 
/
CALL AddPaymentCodeType('0513', '      ,         , , - ,    , ,  ') 
/
CALL AddPaymentCodeType('0514', '     , , - ') 
/
CALL AddPaymentCodeType('0515', ' ,           ()') 
/
CALL AddPaymentCodeType('0539', '              ,      ,  ') 
/
CALL AddPaymentCodeType('0548', '     ') 
/
CALL AddPaymentCodeType('0588', '   ') 
/
CALL AddPaymentCodeType('0437', '      " "') 
/
CALL AddPaymentCodeType('9978', '   ,                                (,      ,    )') 
/
CALL AddPaymentCodeType('9977', '                ()') 
/
drop procedure AddPaymentCodeType
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_PaymentSchedule_Cards.sql
-- #########################################################
-- #########################################################

ALTER TABLE TB_paymentschedule ADD (
  PaymentCodeType NUMBER(10),
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648))
)
/

CREATE OR REPLACE VIEW paymentschedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER,
  PAYMENTCODETYPE)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE
  FROM TB_paymentschedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER,
    new$PAYMENTCODETYPE);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_paymentschedule ADD (
  CONSTRAINT FK_PAYMENTSCHEDULE_Payment FOREIGN KEY (PaymentCodeType) REFERENCES PaymentCodeType(ID)
)
/
CREATE INDEX FK_PAYMENTSCHEDULE_Payment ON TB_paymentschedule(PaymentCodeType)
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_Dates_In_Cards_OutPayDoc_MerDoc.sql
-- #########################################################
-- #########################################################

/*        ,        */
-- drop trigger tr_cards_bu
DROP TRIGGER TR_CARDS_BU
/
-- drop trigger TR_CARDS_BD
DROP TRIGGER TR_CARDS_BD
/
ALTER TABLE Cards ADD (
  TempCardNumber VARCHAR2(50),
  TempFULLCARDNUMBER VARCHAR2(50)
)
/
commit work 
/
ALTER TRIGGER TR_CARDS_BU_500 DISABLE
/
update Cards set
  TempCardNumber = CardNumber,
  TempFULLCARDNUMBER = FULLCARDNUMBER
/
commit work 
/
ALTER TABLE Cards DROP (CardNumber)
/
ALTER TABLE Cards DROP (FULLCARDNUMBER)
/
commit work 
/
ALTER TABLE Cards ADD (
  DateBirth NUMBER,
  CardNumber VARCHAR2(50),
  FULLCARDNUMBER VARCHAR2(50)
)
/
commit work 
/
update Cards set
  CardNumber = TempCardNumber,
  FULLCARDNUMBER = TempFULLCARDNUMBER
/
commit work 
/
ALTER TABLE Cards DROP (TempCardNumber)
/
ALTER TABLE Cards DROP (TempFULLCARDNUMBER)
/
ALTER TRIGGER TR_CARDS_BU_500 ENABLE
/
commit work 
/
-- CREATE TRIGGER tr_cards_bu
CREATE OR REPLACE TRIGGER TR_cards_BU
  BEFORE UPDATE
  ON cards
  FOR EACH ROW
DECLARE
  REC_COUNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_cards_bu)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (UPPER(:new.CARDNUMBER) <> UPPER(:old.CARDNUMBER)) THEN
    select 
    count(ffc.id) 
    INTO REC_COUNT$       from 
    FacialFinCaption ffc 
    where (ffc.CardRef = :new.ID)
    ;
    IF (REC_COUNT$  <> 0) THEN
      RaiseException('EX_CANNOT_UPD_USEDCARD');    
    END IF;
  END IF;

END;
/
-- CREATE TRIGGER tr_cards_bd
CREATE OR REPLACE TRIGGER TR_cards_BD
  BEFORE DELETE
  ON cards
  FOR EACH ROW
DECLARE
  REC_COUNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (tr_cards_bd)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(ffc.CARDNUMBER)
  INTO REC_COUNT$   FROM FACIALFINCAPTION ffc
  WHERE (UPPER(ffc.CARDNUMBER) = UPPER(:old.CARDNUMBER))
  ;
  IF (REC_COUNT$  <> 0) THEN
    RaiseException('EX_CANNOT_DEL_USEDCARD');
  END IF;
  DELETE
  FROM CARDSDETAIL_FACC
  WHERE
  RECORDINDEX = :old.ID;
  DELETE
  FROM CARDSDETAIL_KESR
  WHERE
  RECORDINDEX = :old.ID;

END;
/
commit work 
/
ALTER TABLE ED_OutPayDoc ADD (
  Reserve1 VARCHAR2(25),
  Reserve2 VARCHAR2(25),
  Reserve3 VARCHAR2(50),
  DateDocOrder NUMBER
)
/
ALTER TABLE BANKEXCH_MERDOC ADD (
  DateDocOrder NUMBER
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_FacialFinCaption_AddDocOrder_AddDocType.sql
-- #########################################################
-- #########################################################

/* >Del_Table_FaxDocs.sql*//*      */
ALTER TABLE TB_facialfincaption ADD (
  DocOrderRef NUMBER(10),
    CHECK((DocOrderRef<=2147483647)AND(DocOrderRef>-2147483648)),
  DocType NUMBER(10),
    CHECK((DocType<=2147483647)AND(DocType>-2147483648))
)
/

CREATE OR REPLACE VIEW facialfincaption (
  ID,
  DOCNUMBER,
  SOURCEDOCNUM,
  PAYDATE,
  ACCEPTDATE,
  DOCUMENTDATE,
  REESTRDATE,
  CREDIT,
  SOURCEACCOUNT,
  SOURCEFACIALACC_CLS,
  DESTACCOUNT,
  DESTFACIALACC_CLS,
  PROGINDEX,
  ARHIVEDOC,
  PAYSYMBOLCLS,
  PAYTYPECLS,
  NOTE,
  PERIOD,
  PAYPRIORITY,
  TYPEOPERATIONCLS,
  BUHPAYMENTCLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  RECORDINDEX,
  SENDERID,
  SENDERRECORDID,
  REESTR_REF,
  REJECT_CLS,
  CLIENTBANKNUMBER,
  CRYPTOSTATUS,
  TRUSTNUMBER,
  LINKEDDOCUMENT,
  BNKRECORDID,
  SUBPROGINDEX,
  DOCUMENTSTATE,
  USERSVISA,
  TREASUARYDOCSTATECLS,
  DEPARTMENTCLS,
  NDS,
  TAXNOTE,
  MANAGERBID,
  BIDNUMBER,
  GROUPID,
  GROUPSUMMA,
  DOCSTATEREF,
  LASTEXTRCHANGE,
  STIMATEID,
  INTEGRATEDDOCREF,
  REQUESTNUMBER,
  REQUESTDATE,
  RVERSION,
  FEDERALFUNDSREF,
  ELDOCREF,
  BUHOPERATIONCLS,
  CLSTYPE,
  OPERATIONDIRECTION,
  SOURCETYPE,
  DESTTYPE,
  CARDNUMBER,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  CASHIERPERSONALINFO,
  BIDDATE,
  CARDREF,
  SOURCESTOREDPAYMENTPROPS,
  DESTSTOREDPAYMENTPROPS,
  STOREDPAYMENTNOTE,
  DOCCHANGEDATE,
  UINCODE,
  DOCOSN,
  SIGNERS,
  DESTCLSTYPE,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  AUTOSANCTION,
  STOREDPAYMENTCONTENT,
  REJECTCAUSE,
  CODEPURPOSE,
  DOCORDERREF,
  DOCTYPE)
AS
  SELECT
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE,
    DOCORDERREF,
    DOCTYPE
  FROM TB_facialfincaption
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
--
  reestrAccepted1$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CmpFacialAcc_Cls1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber1$); 
    if (DocNumber1$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber1$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls1$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls1$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls1$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE,
    DOCORDERREF,
    DOCTYPE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE,
    new$CODEPURPOSE,
    new$DOCORDERREF,
    new$DOCTYPE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE,
    CODEPURPOSE = new$CODEPURPOSE,
    DOCORDERREF = new$DOCORDERREF,
    DOCTYPE = new$DOCTYPE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
ALTER TABLE TB_facialfincaption ADD (
  CONSTRAINT FK_FFC_DOCORDERREF FOREIGN KEY (DocOrderRef) REFERENCES TB_FACIALFINCAPTION (ID),
  CONSTRAINT FK_FACIALFINCAPTION_DOCTYPE FOREIGN KEY (DocType) REFERENCES DOCTYPES (ID)
)
/
CREATE INDEX FK_FFC_DOCORDERREF ON TB_facialfincaption(DocOrderRef)
/
CREATE INDEX FK_FACIALFINCAPTION_DOCTYPE ON TB_facialfincaption(DocType)
/
-- ALTER TRIGGER TR_FACIALFINCAPTION_BI
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
--
  reestrAccepted1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
  DocNumber$ NUMBER(10);
  CmpFacialAcc_Cls$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE,
    DOCORDERREF,
    DOCTYPE
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE,
    new$CODEPURPOSE,
    new$DOCORDERREF,
    new$DOCTYPE);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_FACIALFINCAPTION_BU
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE,
    CODEPURPOSE = new$CODEPURPOSE,
    DOCORDERREF = new$DOCORDERREF,
    DOCTYPE = new$DOCTYPE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*          ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
ALTER TRIGGER TR_FACIALFINCAPTION_BU_500 DISABLE
/
update facialfincaption set DocType = 0
/
ALTER TRIGGER TR_FACIALFINCAPTION_BU_500 ENABLE
/
commit work
/



ALTER TABLE TB_facialfincaption MODIFY(DocType NOT NULL)
/

-- #########################################################
-- #########################################################
-- Alter_ED_Detail_CradFields.sql
-- #########################################################
-- #########################################################

ALTER TABLE ED_Detail ADD (
  CardNumber VARCHAR2(50),
  DateBirth NUMBER,
  PaymentCodeType NUMBER(10),
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648)),
  CodePurpose NUMBER(10),
    CHECK((CodePurpose<=2147483647)AND(CodePurpose>-2147483648)),
  LineNumber NUMBER(10),
    CHECK((LineNumber<=2147483647)AND(LineNumber>-2147483648)),
  AmountIspDoc VARCHAR2(255)
)
/
ALTER TABLE ED_Detail ADD (
  CONSTRAINT FK_ED_Detail_Payment FOREIGN KEY (PaymentCodeType) REFERENCES PaymentCodeType(ID)
)
/
CREATE INDEX FK_ED_Detail_Payment ON ED_Detail(PaymentCodeType)
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_FacialFinDetail_CardFields.sql
-- #########################################################
-- #########################################################

ALTER TABLE TB_facialfindetail ADD (
  Reject_cls NUMBER(10),/*    */
    CHECK((Reject_cls<=2147483647)AND(Reject_cls>-2147483648)),
  RejectCause VARCHAR2(1000),/*   () */
  CardNumber VARCHAR2(50),/*    */
  DateBirth NUMBER,/*      */
  PaymentCodeType NUMBER(10),/*       */
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648)),
  CodePurpose NUMBER(10),/*    (     ) */
    CHECK((CodePurpose<=2147483647)AND(CodePurpose>-2147483648)),
  LineNumber NUMBER(10),/*       */
    CHECK((LineNumber<=2147483647)AND(LineNumber>-2147483648)),
  AmountIspDoc VARCHAR2(255)/*    ,     (.. ,   ,     ) */
)
/

CREATE OR REPLACE VIEW facialfindetail (
  ID,
  SOURCEFACIALACC_CLS,
  SOURCEKVR,
  SOURCEKESR,
  DESTFACIALACC_CLS,
  DESTKVR,
  DESTKESR,
  BUDGETREF,
  CREDIT,
  PAYSYMBOLCLS,
  MEMORDERNUM,
  NOTE,
  PROGINDEX,
  RECORDINDEX,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SOURCEKVSR,
  SOURCEKCSR,
  SOURCEKFSR,
  SOURCESUBKESR,
  SOURCEFACT,
  SOURCEMEANSTYPE,
  SOURCEFINSOURCE,
  SOURCEFINTYPE,
  DESTKVSR,
  DESTKCSR,
  DESTKFSR,
  DESTSUBKESR,
  DESTFACT,
  DESTMEANSTYPE,
  DESTFINSOURCE,
  DESTFINTYPE,
  REQUESTSINDEX,
  SENDERID,
  SENDERRECORDID,
  PROMISE,
  SOURCEDOCTYPE,
  DESTDOCTYPE,
  SOURCEPROMISE,
  DESTPROMISE,
  RECORDINDEX2,
  SOURCEBUDGETPROMISE,
  DESTBUDGETPROMISE,
  SUBPROGINDEX,
  STIMATEID,
  RVERSION,
  SOURCEDIRECTIONCLS,
  DESTDIRECTIONCLS,
  SOURCEDOCBASE,
  DESTDOCBASE,
  SOURCEEXECDOC,
  DESTEXECDOC,
  BUHOPERATIONCLS,
  SOURCEIFS,
  DESTIFS,
  CLSTYPE,
  UNIONNOTIFYREF,
  ACCEPTDATE,
  SOURCEKD,
  DESTKD,
  SOURCEREGIONCLS,
  DESTREGIONCLS,
  DESTFUNDSSOURCE,
  SOURCEFUNDSSOURCE,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SOURCETRANSFERTCLS,
  DESTTRANSFERTCLS,
  DESTCLSTYPE,
  SOURCEASSIGNMENTKIND,
  DESTASSIGNMENTKIND,
  SOURCEEXECINNERNUMBER,
  DESTEXECINNERNUMBER,
  SOURCESUBSIDYCLS,
  DESTSUBSIDYCLS,
  SOURCEFAORG_TYPE,
  DESTFAORG_TYPE,
  SOURCEBUDALLOCATIONCLS,
  SOURCEPAYPROMISECLS,
  DESTBUDALLOCATIONCLS,
  DESTPAYPROMISECLS,
  SOURCEINVESTOBJECT,
  DESTINVESTOBJECT,
  TRANSFERTORG_REF,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  STOREDPAYMENTCONTENT,
  SOURCECONTRACTCOSTSCLS,
  DESTCONTRACTCOSTSCLS,
  SOURCETARGETCLS,
  DESTTARGETCLS,
  REJECT_CLS,
  REJECTCAUSE,
  CARDNUMBER,
  DATEBIRTH,
  PAYMENTCODETYPE,
  CODEPURPOSE,
  LINENUMBER,
  AMOUNTISPDOC)
AS
  SELECT
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC
  FROM TB_facialfindetail
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_ID
  INSTEAD OF DELETE
  ON FACIALFINDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_FACIALFINDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update facialfincaption set
  DocChangeDate = SYSDATE,
  RVersion=-1
  where id=:old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINDETAIL
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINDETAIL_AD_500)
-- Last update 27.08.2004
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes
              (TableID, RecordId, DeleteDate, ProgIndex, Summa)
       VALUES (22, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CapBuhOperationCLS$ NUMBER(10);
  CapClsType$ NUMBER(10);
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  i_fintype1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Last update 12.01.2009
-- - - - - - - - - - - - -

 /*  ,    */
   BEGIN

     select
       ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate,
       ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
     into new$BudgetRef, CapBuhOperationCls$, CapClsType$, CapAcceptDate$,
       new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause
     from
       FacialFinCaption ffc
     where
       ffc.id = new$RecordIndex;

   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       new$BudgetRef := NULL;
       CapBuhOperationCls$ := NULL;
       CapClsType$ := NULL;
       CapAcceptDate$ := NULL;
   END;

   /*      */
   if (new$BuhOperationCls is null) then new$BuhOperationCls := CapBuhOperationCls$; end if;

   /*      */
   if (new$ClsType is null) then new$ClsType := CapClsType$; end if;

   if (new$DestClsType is null) then new$DestClsType := new$ClsType; end if;

   /*      */
   if (new$AcceptDate is null) then new$AcceptDate := CapAcceptDate$; end if;

   /*      */
   if ((new$SourceFacialAcc_CLS is null) or (new$DestFacialAcc_CLS is null)) then
     BEGIN
       select SourceFacialAcc_CLS, DestFacialAcc_CLS
         into SourceFacialAcc_CLS$, DestFacialAcc_CLS$
       from FacialFinCaption
       where new$RecordIndex = id;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         SourceFacialAcc_CLS$ := NULL;
         DestFacialAcc_CLS$ := NULL;
     END;

     if (new$SourceFacialAcc_CLS is null) then new$SourceFacialAcc_CLS := SourceFacialAcc_CLS$; end if;
     if (new$DestFacialAcc_CLS is null) then new$DestFacialAcc_CLS := DestFacialAcc_CLS$; end if;
   end if;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);
  /*      */
  GetDocumentKESR(null, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(null, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
--
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Create 20.02.2006
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select c.AcceptDate into CapAcceptDate$
      from facialfincaption c
      where c.id = new$RecordIndex;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        CapAcceptDate$ := NULL;
    END;

    if ((new$AcceptDate = CapAcceptDate$) or (CapAcceptDate$ is null)) then
      new$AcceptDate := new$AcceptDate;
    else
      RaiseException('ex_wrongacceptdate');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS,
    REJECT_CLS = new$REJECT_CLS,
    REJECTCAUSE = new$REJECTCAUSE,
    CARDNUMBER = new$CARDNUMBER,
    DATEBIRTH = new$DATEBIRTH,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    CODEPURPOSE = new$CODEPURPOSE,
    LINENUMBER = new$LINENUMBER,
    AMOUNTISPDOC = new$AMOUNTISPDOC
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_facialfindetail ADD (
  constraint FK_FFDetail_Reject_cls foreign key (reject_cls) references rejectcls(id),
  CONSTRAINT FK_facialfindetail_Payment FOREIGN KEY (PaymentCodeType) REFERENCES PaymentCodeType(ID)
)
/
CREATE INDEX FK_FFDetail_Reject_cls ON TB_facialfindetail(reject_cls)
/
CREATE INDEX FK_facialfindetail_Payment ON TB_facialfindetail(PaymentCodeType)
/
commit work
/
-- ALTER TRIGGER TR_FACIALFINCAPTION_AU_300
CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE,
    CODEPURPOSE = new$CODEPURPOSE,
    DOCORDERREF = new$DOCORDERREF,
    DOCTYPE = new$DOCTYPE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ,  ,     ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    (RecordIndex = new$id) and (Reject_cls is null);
  END IF;
    
  if ((new$Reject_cls <> :old.Reject_cls)or((new$Reject_cls is not null)and(:old.Reject_cls is null))
  or((new$Reject_cls is null)and(:old.Reject_cls is not null))) then
    update facialfindetail set
    Reject_cls = new$Reject_cls,
    AcceptDate = null,
    RVersion = -1
    where
    RecordIndex = new$id;    
  END IF;
    
  if ((new$RejectCause <> :old.RejectCause)or((new$RejectCause is not null)and(:old.RejectCause is null))
  or((new$RejectCause is null)and(:old.RejectCause is not null))) then
    update facialfindetail set
    RejectCause = new$RejectCause,
    RVersion = -1
    where
    RecordIndex = new$id;      
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
      
    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
-- ALTER TRIGGER tr_FacialFinDetail_bi_100
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;
   
  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;  
  END IF;
     
  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;   
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then 
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then 
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;
     
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);
  /*      */
  GetDocumentKESR(null, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(null, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_FACIALFINDETAIL_BU_300
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select
      c.AcceptDate
      into
      CapAcceptDate1$     from
      facialfincaption c
      where
      (c.id = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (not ((new$AcceptDate = CapAcceptDate1$) or (CapAcceptDate1$  is null) or
    /*          (  )    */
    ((new$Progindex = 283) and (new$AcceptDate is null) and (new$Reject_CLS is not null)))) then
      RaiseException('ex_wrongacceptdate');  
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS,
    REJECT_CLS = new$REJECT_CLS,
    REJECTCAUSE = new$REJECTCAUSE,
    CARDNUMBER = new$CARDNUMBER,
    DATEBIRTH = new$DATEBIRTH,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    CODEPURPOSE = new$CODEPURPOSE,
    LINENUMBER = new$LINENUMBER,
    AMOUNTISPDOC = new$AMOUNTISPDOC
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 DISABLE
/
CREATE OR REPLACE PROCEDURE FacialFinDetailSetRejectCls
AS
BEGIN
  FOR REC$1 IN (SELECT fcc.Reject_cls AS CapReject_cls, fcc.RejectCause AS CapRejectCause, fcc.ID 
   AS CapID     FROM FacialFinCaption fcc
  where (fcc.Reject_cls is not null) or (fcc.RejectCause is not null)
  )
  LOOP
    UPDATE facialfindetail SET
    AcceptDate = null,
    Reject_cls = REC$1.CapReject_cls,
    RejectCause = REC$1.CapRejectCause

    WHERE
    RecordIndex = REC$1.CapID;
      
  END LOOP;
END;
/
COMMIT WORK 
/
CALL FacialFinDetailSetRejectCls()
/
DROP PROCEDURE FacialFinDetailSetRejectCls
/
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 ENABLE
/
COMMIT WORK 
/

-- #########################################################
-- #########################################################
-- Create_RegProjectResult.sql
-- #########################################################
-- #########################################################

/*   RegProjectResult-"  "*/
/*  "  " */
create table RegProjectResult (
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  CODE VARCHAR2(20) NOT NULL,/*  ,  -  . ,  -  . ,  -  1-3  */
  NAME VARCHAR2(2000) NOT NULL,/* */
  BUDGETREF NUMBER(10) NOT NULL,/* */
    CHECK((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)),
  ResultType NUMBER(10) NOT NULL,/*   (1-) @enum: */
    CHECK((ResultType<=2147483647)AND(ResultType>-2147483648)),
  ResultKind NUMBER(10) NOT NULL,/*   (1-3) @enum: */
    CHECK((ResultKind<=2147483647)AND(ResultKind>-2147483648)),
  NationalProject NUMBER(10),/*  ,  .   */
    CHECK((NationalProject<=2147483647)AND(NationalProject>-2147483648)),
  CREATEDATE DATE NOT NULL,
  UPDATEDATE DATE NOT NULL,
  CREATERUSER VARCHAR2(30) NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  DeleteDate DATE,
  StartDate DATE,
  EXTID VARCHAR2(50),
  EXTOWNER VARCHAR2(50),
  EXTSYNCDATE DATE,
  EXTROOTID VARCHAR2(50),
  EXTVERSION NUMBER(10),
    CHECK((EXTVERSION<=2147483647)AND(EXTVERSION>-2147483648)),
  EXTVERSIONDATE DATE,
  constraint UQ_RegProjectResult_EXTID unique (EXTID,CODE,BUDGETREF),
  constraint PK_RegProjectResult_ID primary key (ID),
  constraint FK_RegProjectResult_BUDGETREF foreign key (BUDGETREF) references TB_BUDGETS_S (ID),
  constraint FK_RegProjectResult_NP foreign key (NationalProject) references NationalProject (ID)
)
/
CREATE INDEX FK_RegProjectResult_BUDGETREF ON RegProjectResult(BUDGETREF)
/
CREATE INDEX FK_RegProjectResult_NP ON RegProjectResult(NationalProject)
/
create index IDX_RegProjectResult_EXTID on RegProjectResult(EXTID)
/
create index IDX_RegProjectResult_EXTROOTID ON RegProjectResult(EXTROOTID)
/
-- CREATE TRIGGER TR_RegProjectResult_BI_0
CREATE OR REPLACE TRIGGER TR_RegProjectResult_BI
  BEFORE INSERT
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_RegProjectResult_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;
  if (:new.ResultType is null) then
    :new.ResultType := 1;
  END IF;
  if (:new.ResultKind is null) then
    :new.ResultKind := 1;
  END IF;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_BI_500
CREATE OR REPLACE TRIGGER TR_RegProjectResult_BI
  BEFORE INSERT
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_RegProjectResult_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;
  if (:new.ResultType is null) then
    :new.ResultType := 1;
  END IF;
  if (:new.ResultKind is null) then
    :new.ResultKind := 1;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_RegProjectResult_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_AI_500
CREATE OR REPLACE TRIGGER TR_RegProjectResult_AI
  AFTER INSERT
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_RegProjectResult_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 35) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_RegProjectResult_BU_0
CREATE OR REPLACE TRIGGER TR_RegProjectResult_BU
  BEFORE UPDATE
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_RegProjectResult_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.ResultType is null) then
    :new.ResultType := 1;
  END IF;
  if (:new.ResultKind is null) then
    :new.ResultKind := 1;
  END IF;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_BU_500
CREATE OR REPLACE TRIGGER TR_RegProjectResult_BU_500
  BEFORE UPDATE
  ON REGPROJECTRESULT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_RegProjectResult_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_AU_500
CREATE OR REPLACE TRIGGER TR_RegProjectResult_AU
  AFTER UPDATE
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_RegProjectResult_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (35, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=35) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_AD_500
CREATE OR REPLACE TRIGGER TR_RegProjectResult_AD
  AFTER DELETE
  ON RegProjectResult
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_RegProjectResult_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(35,:old.ID,SYSDATE);

END;
/

/*        RegProjectResult*/
grant SELECT, INSERT, UPDATE, DELETE on RegProjectResult to BUDGET_USERS
/
commit work 
/
ALTER TABLE BudgetData ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_BD_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_BD_RegProjRes ON BudgetData(RegProjectResult)
/
ALTER TABLE TB_FacialFinDetail ADD (
  SourceRegProjectResult NUMBER(10),
    CHECK((SourceRegProjectResult<=2147483647)AND(SourceRegProjectResult>-2147483648)),
  DestRegProjectResult NUMBER(10),
    CHECK((DestRegProjectResult<=2147483647)AND(DestRegProjectResult>-2147483648)),
  constraint FK_FFD_SourRegProjRes foreign key (SourceRegProjectResult) references RegProjectResult(ID),
  constraint FK_FFD_DestRegProjRes foreign key (DestRegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_FFD_SourRegProjRes ON TB_FacialFinDetail(SourceRegProjectResult)
/
CREATE INDEX FK_FFD_DestRegProjRes ON TB_FacialFinDetail(DestRegProjectResult)
/

CREATE OR REPLACE VIEW FacialFinDetail (
  ID,
  SOURCEFACIALACC_CLS,
  SOURCEKVR,
  SOURCEKESR,
  DESTFACIALACC_CLS,
  DESTKVR,
  DESTKESR,
  BUDGETREF,
  CREDIT,
  PAYSYMBOLCLS,
  MEMORDERNUM,
  NOTE,
  PROGINDEX,
  RECORDINDEX,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SOURCEKVSR,
  SOURCEKCSR,
  SOURCEKFSR,
  SOURCESUBKESR,
  SOURCEFACT,
  SOURCEMEANSTYPE,
  SOURCEFINSOURCE,
  SOURCEFINTYPE,
  DESTKVSR,
  DESTKCSR,
  DESTKFSR,
  DESTSUBKESR,
  DESTFACT,
  DESTMEANSTYPE,
  DESTFINSOURCE,
  DESTFINTYPE,
  REQUESTSINDEX,
  SENDERID,
  SENDERRECORDID,
  PROMISE,
  SOURCEDOCTYPE,
  DESTDOCTYPE,
  SOURCEPROMISE,
  DESTPROMISE,
  RECORDINDEX2,
  SOURCEBUDGETPROMISE,
  DESTBUDGETPROMISE,
  SUBPROGINDEX,
  STIMATEID,
  RVERSION,
  SOURCEDIRECTIONCLS,
  DESTDIRECTIONCLS,
  SOURCEDOCBASE,
  DESTDOCBASE,
  SOURCEEXECDOC,
  DESTEXECDOC,
  BUHOPERATIONCLS,
  SOURCEIFS,
  DESTIFS,
  CLSTYPE,
  UNIONNOTIFYREF,
  ACCEPTDATE,
  SOURCEKD,
  DESTKD,
  SOURCEREGIONCLS,
  DESTREGIONCLS,
  DESTFUNDSSOURCE,
  SOURCEFUNDSSOURCE,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SOURCETRANSFERTCLS,
  DESTTRANSFERTCLS,
  DESTCLSTYPE,
  SOURCEASSIGNMENTKIND,
  DESTASSIGNMENTKIND,
  SOURCEEXECINNERNUMBER,
  DESTEXECINNERNUMBER,
  SOURCESUBSIDYCLS,
  DESTSUBSIDYCLS,
  SOURCEFAORG_TYPE,
  DESTFAORG_TYPE,
  SOURCEBUDALLOCATIONCLS,
  SOURCEPAYPROMISECLS,
  DESTBUDALLOCATIONCLS,
  DESTPAYPROMISECLS,
  SOURCEINVESTOBJECT,
  DESTINVESTOBJECT,
  TRANSFERTORG_REF,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  STOREDPAYMENTCONTENT,
  SOURCECONTRACTCOSTSCLS,
  DESTCONTRACTCOSTSCLS,
  SOURCETARGETCLS,
  DESTTARGETCLS,
  REJECT_CLS,
  REJECTCAUSE,
  CARDNUMBER,
  DATEBIRTH,
  PAYMENTCODETYPE,
  CODEPURPOSE,
  LINENUMBER,
  AMOUNTISPDOC,
  SOURCEREGPROJECTRESULT,
  DESTREGPROJECTRESULT)
AS
  SELECT
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT
  FROM TB_FacialFinDetail
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_ID
  INSTEAD OF DELETE
  ON FACIALFINDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_FACIALFINDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update facialfincaption set
  DocChangeDate = SYSDATE,
  RVersion=-1
  where id=:old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINDETAIL
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINDETAIL_AD_500)
-- Last update 27.08.2004
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes
              (TableID, RecordId, DeleteDate, ProgIndex, Summa)
       VALUES (22, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;
   
  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;  
  END IF;
     
  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;   
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then 
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then 
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;
     
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);
  /*      */
  GetDocumentKESR(null, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(null, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC,
    new$SOURCEREGPROJECTRESULT,
    new$DESTREGPROJECTRESULT);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select
      c.AcceptDate
      into
      CapAcceptDate1$     from
      facialfincaption c
      where
      (c.id = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (not ((new$AcceptDate = CapAcceptDate1$) or (CapAcceptDate1$  is null) or
    /*          (  )    */
    ((new$Progindex = 283) and (new$AcceptDate is null) and (new$Reject_CLS is not null)))) then
      RaiseException('ex_wrongacceptdate');  
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS,
    REJECT_CLS = new$REJECT_CLS,
    REJECTCAUSE = new$REJECTCAUSE,
    CARDNUMBER = new$CARDNUMBER,
    DATEBIRTH = new$DATEBIRTH,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    CODEPURPOSE = new$CODEPURPOSE,
    LINENUMBER = new$LINENUMBER,
    AMOUNTISPDOC = new$AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT = new$SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT = new$DESTREGPROJECTRESULT
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_PaymentSchedule ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_PS_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_PS_RegProjRes ON TB_PaymentSchedule(RegProjectResult)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER,
  PAYMENTCODETYPE,
  REGPROJECTRESULT)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER,
    new$PAYMENTCODETYPE,
    new$REGPROJECTRESULT);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    REGPROJECTRESULT = new$REGPROJECTRESULT
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TenderProduct ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_TENDERDET_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_TENDERDET_RegProjRes ON TenderProduct(RegProjectResult)
/
ALTER TABLE WritExecutionDetail ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_WREXECDET_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_WREXECDET_RegProjRes ON WritExecutionDetail(RegProjectResult)
/
ALTER TABLE TB_CorrectionDetail ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_CORRDET_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_CORRDET_RegProjRes ON TB_CorrectionDetail(RegProjectResult)
/

CREATE OR REPLACE VIEW CorrectionDetail (
  ID,
  PARENTID,
  BUDGETREF,
  SUMMA,
  CLSTYPE,
  FACIALACC_CLS,
  KVSR,
  KFSR,
  KCSR,
  KVR,
  KESR,
  DIRECTIONCLS,
  MEANSTYPE,
  FACT,
  REGIONCLS,
  FINSOURCE,
  FINTYPE,
  DOCTYPE,
  SUBKESR,
  FUNDSSOURCE,
  KD,
  IFS,
  BUHOPERATIONCLS,
  CHANGEACC_REF,
  CHANGEACC,
  CHANGEORGINN,
  CHANGEORGINN20,
  PROGINDEX,
  RECORDINDEX,
  DOCUMENTPROGINDEX,
  DOCUMENTRECORDINDEX,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SENDERID,
  SENDERRECORDID,
  RVERSION,
  CREATERUSER,
  CREATEDATE,
  UPDATERUSER,
  UPDATEDATE,
  NOTE,
  ISCLSCHANGED,
  PROMISE,
  BUDGETPROMISE,
  EXECDOC,
  OKATO,
  ADDOKATO,
  TRANSFERTCLS,
  ORIGINALCLSSUMMA,
  NOTECLS,
  OPERATIONTYPE,
  REVERSEFLAG,
  EXECINNERNUMBER,
  CLSFIELFCHANGED,
  FAORGTYPE,
  SUBSIDYCLS,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  NOTEQUALEX,
  OKTMO,
  UINCODE,
  INVESTOBJECT,
  CHANGEORGNAME,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  STOREDCONTENT,
  REGPROJECTRESULT)
AS
  SELECT
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT
  FROM TB_CorrectionDetail
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_ID
  INSTEAD OF DELETE
  ON CORRECTIONDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_CORRECTIONDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update CorrectionCaption set
  DocChangeDate = SYSDATE,
  RVersion = -1
  where id = :old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_CORRECTIONDETAIL
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_CORRECTIONDETAIL_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate, ProgIndex, SUMMA) values(5504,:old.ID,SYSDATE,:old.ProgIndex, :old.SUMMA);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  BEGIN

    /*  ,    */
    select
    CorCap.BudgetRef
    into new$BudgetRef   from
    correctioncaption CorCap
    where
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT,
    new$REGPROJECTRESULT);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_IU
  INSTEAD OF UPDATE
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CORRECTIONDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  /*     \*/
  IF ((new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType IS NULL)) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  ON (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);    
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_100 (tr_correctiondetail_bu_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$buhoperationcls <> :old.buhoperationcls) and (new$progindex = 316)) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_CORRECTIONDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_CORRECTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise )) and
    (new$BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /*  BudgetPromise    Promise=NULL,   Promise */
    if (new$Promise is null and ((new$BudgetPromise is not null and :old.BudgetPromise is null) or
    (new$BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;

    /*  BudgetPromise -   Promise */
    if ((new$BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      new$Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((new$Promise is null) and (:old.Promise is not null)) then
      new$BudgetPromise := null;
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_CORRECTIONDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null and (
    (:old.Promise is null or :old.Promise <> new$Promise) or
    (:old.ExecDoc is null or new$ExecDoc is null or :old.ExecDoc <> new$ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$ExecDoc is null or :old.ExecDoc is null or new$ExecDoc <> :old.ExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_CORRECTIONDETAIL_BU_700)
-- Create 13.08.2007
-- - - - - - - - - - - - -

 if (new$RVersion is null) then
   new$RVersion:=1;
 else
   if ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
     new$RVersion:=:Old.RVersion;
   else
     new$RVersion:=:Old.RVersion+1;
   end if;
 end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_CORRECTIONDETAIL SET
    ID = new$ID,
    PARENTID = new$PARENTID,
    BUDGETREF = new$BUDGETREF,
    SUMMA = new$SUMMA,
    CLSTYPE = new$CLSTYPE,
    FACIALACC_CLS = new$FACIALACC_CLS,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    MEANSTYPE = new$MEANSTYPE,
    FACT = new$FACT,
    REGIONCLS = new$REGIONCLS,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    DOCTYPE = new$DOCTYPE,
    SUBKESR = new$SUBKESR,
    FUNDSSOURCE = new$FUNDSSOURCE,
    KD = new$KD,
    IFS = new$IFS,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CHANGEACC_REF = new$CHANGEACC_REF,
    CHANGEACC = new$CHANGEACC,
    CHANGEORGINN = new$CHANGEORGINN,
    CHANGEORGINN20 = new$CHANGEORGINN20,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    DOCUMENTPROGINDEX = new$DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX = new$DOCUMENTRECORDINDEX,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    RVERSION = new$RVERSION,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    NOTE = new$NOTE,
    ISCLSCHANGED = new$ISCLSCHANGED,
    PROMISE = new$PROMISE,
    BUDGETPROMISE = new$BUDGETPROMISE,
    EXECDOC = new$EXECDOC,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    TRANSFERTCLS = new$TRANSFERTCLS,
    ORIGINALCLSSUMMA = new$ORIGINALCLSSUMMA,
    NOTECLS = new$NOTECLS,
    OPERATIONTYPE = new$OPERATIONTYPE,
    REVERSEFLAG = new$REVERSEFLAG,
    EXECINNERNUMBER = new$EXECINNERNUMBER,
    CLSFIELFCHANGED = new$CLSFIELFCHANGED,
    FAORGTYPE = new$FAORGTYPE,
    SUBSIDYCLS = new$SUBSIDYCLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    NOTEQUALEX = new$NOTEQUALEX,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    INVESTOBJECT = new$INVESTOBJECT,
    CHANGEORGNAME = new$CHANGEORGNAME,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    STOREDCONTENT = new$STOREDCONTENT,
    REGPROJECTRESULT = new$REGPROJECTRESULT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_CORRECTIONDETAIL_AU_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (5504, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=5504) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE ReplacementClsDetailInfo ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_REPCLSDETI_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_REPCLSDETI_RegProjRes ON ReplacementClsDetailInfo(RegProjectResult)
/
ALTER TABLE ReplacementClsDetail ADD (
  RegProjectResult NUMBER(10),
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  constraint FK_REPCLSDET_RegProjRes foreign key (RegProjectResult) references RegProjectResult(ID)
)
/
CREATE INDEX FK_REPCLSDET_RegProjRes ON ReplacementClsDetail(RegProjectResult)
/

commit work 
/

-- #########################################################
-- #########################################################
-- alter_OrgAccounts_Ext.sql
-- #########################################################
-- #########################################################

/*         */
ALTER TABLE TB_ORG_ACCOUNTS ADD (
  EXTROOTID VARCHAR2(50),
  EXTVERSION NUMBER(10),
    CHECK((EXTVERSION<=2147483647)AND(EXTVERSION>-2147483648)),
  EXTVERSIONDATE DATE
)
/

CREATE OR REPLACE VIEW ORG_ACCOUNTS (
  ID,
  ORG_REF,
  BANK_REF,
  ACC,
  ACC_CLS,
  FINTYPE,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  CLOSED,
  ACCDEFAULT,
  BANKDEPNUMBER,
  FACIALCODE,
  SERVICE_ORG_REF,
  ISDEFAULT,
  RVERSION,
  SERVICE_ACC_REF,
  CLOSECODE,
  SERVICEACC,
  FACIALACC_CLS,
  DATEOPEN,
  DATECLOSE,
  EXTID,
  EXTOWNER,
  EXTSYNCDATE,
  ACOMMENT,
  EXTROOTID,
  EXTVERSION,
  EXTVERSIONDATE)
AS
  SELECT
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    ACOMMENT,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE
  FROM TB_ORG_ACCOUNTS
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_ID
  INSTEAD OF DELETE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  CNT$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORG_ACCOUNTS_BD)
-- Create 05.06.2007
-- - - - - - - - - - - - -

  select count(*) into CNT$
  from Org_Accounts where Service_Acc_Ref = :old.ID;
  
  if (CNT$ > 0) then
    RaiseException('ex_CantDelServiceAcc');
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORG_ACCOUNTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
   
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORG_ACCOUNTS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

   insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(21,:old.ID,SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_II
  INSTEAD OF INSERT
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$EXTROOTID ORG_ACCOUNTS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION ORG_ACCOUNTS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE ORG_ACCOUNTS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
--
  ADate$ NUMBER;
  AClosed1$ NUMBER(10);
  vOrgType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ORG_ACCOUNTS_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$Org_Ref = 0) then 
    RaiseException('ex_CantAddUnknownOrgAcc');
  END IF;
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$ACC_CLS is null) then 
    new$ACC_CLS:= 0;
  END IF;
  if (new$AccDefault is null) then 
    new$AccDefault:= 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType:= 0;
  END IF;
  if ((new$AComment is null) or (new$AComment  is null)) then 
    new$AComment := new$Acc;
  END IF;
  if ((new$IsDefault is not Null) and (new$IsDefault <> 0)) then
    update ORG_ACCOUNTS set
    IsDefault = 0
    where ORG_REF = new$ORG_REF
    and IsDefault is not Null
    and IsDefault <> 0;
  END IF;
  if ((new$SERVICE_ORG_REF is null)and(new$SERVICE_ACC_REF is not null)) then
    BEGIN
      select
      oa.Org_Ref
      into
      new$SERVICE_ORG_REF    from
      org_accounts oa
      where
      (oa.id = new$SERVICE_ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*               */
  if (new$ServiceAcc is null) then
    BEGIN
      select SERVICETYPE into new$ServiceAcc from ACC_CLS where (id = new$ACC_CLS) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       NULL,   0() */
  if (new$ServiceAcc is null) then
    new$ServiceAcc := 0;
    if (new$SERVICE_ORG_REF is not null) then
      BEGIN
        select
        o.Org_Type
        into vOrgType$      from
        Organizations o
        where
        (o.id = new$SERVICE_ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /* 01.01.xx  -   */
      if ((vOrgType$  > 10099)and(vOrgType$  < 10200)) then
        new$ServiceAcc := 3;
             
      else
        /* 03.02.xx     -   */
        if ((vOrgType$  > 30199)and(vOrgType$  < 30300)) then
          new$ServiceAcc := 1;
               
        else
          /* 04.xx.xx  -   */
          if ((vOrgType$  > 39999)and(vOrgType$  < 50000)) then
            new$ServiceAcc := 1;
          END IF;
        END IF;   
      END IF; 
    END IF;
  END IF;
  /*      . .   .  ,   ,
       ,     .  */
  if ((new$Service_Acc_Ref is not null) and (new$ServiceAcc <> 0)) then
    BEGIN
      select
      Bank_Ref, Acc
      into new$Bank_Ref, new$FacialCode    from
      Org_Accounts
      where
      new$Service_Acc_Ref = Id
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_ORG_ACCOUNTS_BI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then 
    new$CloseCode := 0;
  END IF;
  /*     /,   -      */
  if (new$Org_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from organizations where Id = new$Org_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := 10; /*   */
      
    END IF;
  END IF;
  if (new$Bank_Ref is not null) then
    BEGIN
      select DateClose into ADate$ from Banks where Id = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 1000; /*   */
      
    END IF;
  END IF;
  if (new$Service_Acc_Ref is not null) then
    BEGIN
      select Closed, DateClose into AClosed1$, ADate$ from Org_Accounts where Id = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AClosed1$  is not null) then 
      new$Closed := 1;
      new$DateClose := ADate$;
      new$CloseCode := new$CloseCode + 100; /*    */
      
    END IF;  /*   facialacc_cls   -  -      / */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORG_ACCOUNTS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORG_ACCOUNTS (
    ID,
    ORG_REF,
    BANK_REF,
    ACC,
    ACC_CLS,
    FINTYPE,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    CLOSED,
    ACCDEFAULT,
    BANKDEPNUMBER,
    FACIALCODE,
    SERVICE_ORG_REF,
    ISDEFAULT,
    RVERSION,
    SERVICE_ACC_REF,
    CLOSECODE,
    SERVICEACC,
    FACIALACC_CLS,
    DATEOPEN,
    DATECLOSE,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    ACOMMENT,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE
  ) VALUES (
    new$ID,
    new$ORG_REF,
    new$BANK_REF,
    new$ACC,
    new$ACC_CLS,
    new$FINTYPE,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$CLOSED,
    new$ACCDEFAULT,
    new$BANKDEPNUMBER,
    new$FACIALCODE,
    new$SERVICE_ORG_REF,
    new$ISDEFAULT,
    new$RVERSION,
    new$SERVICE_ACC_REF,
    new$CLOSECODE,
    new$SERVICEACC,
    new$FACIALACC_CLS,
    new$DATEOPEN,
    new$DATECLOSE,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$ACOMMENT,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORG_ACCOUNTS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 21) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ORG_ACCOUNTS_IU
  INSTEAD OF UPDATE
  ON ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  new$ID ORG_ACCOUNTS.ID%TYPE := :NEW.ID;
  new$ORG_REF ORG_ACCOUNTS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$BANK_REF ORG_ACCOUNTS.BANK_REF%TYPE := :NEW.BANK_REF;
  new$ACC ORG_ACCOUNTS.ACC%TYPE := :NEW.ACC;
  new$ACC_CLS ORG_ACCOUNTS.ACC_CLS%TYPE := :NEW.ACC_CLS;
  new$FINTYPE ORG_ACCOUNTS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$CREATERUSER ORG_ACCOUNTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORG_ACCOUNTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORG_ACCOUNTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORG_ACCOUNTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CLOSED ORG_ACCOUNTS.CLOSED%TYPE := :NEW.CLOSED;
  new$ACCDEFAULT ORG_ACCOUNTS.ACCDEFAULT%TYPE := :NEW.ACCDEFAULT;
  new$BANKDEPNUMBER ORG_ACCOUNTS.BANKDEPNUMBER%TYPE := :NEW.BANKDEPNUMBER;
  new$FACIALCODE ORG_ACCOUNTS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$SERVICE_ORG_REF ORG_ACCOUNTS.SERVICE_ORG_REF%TYPE := :NEW.SERVICE_ORG_REF;
  new$ISDEFAULT ORG_ACCOUNTS.ISDEFAULT%TYPE := :NEW.ISDEFAULT;
  new$RVERSION ORG_ACCOUNTS.RVERSION%TYPE := :NEW.RVERSION;
  new$SERVICE_ACC_REF ORG_ACCOUNTS.SERVICE_ACC_REF%TYPE := :NEW.SERVICE_ACC_REF;
  new$CLOSECODE ORG_ACCOUNTS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$SERVICEACC ORG_ACCOUNTS.SERVICEACC%TYPE := :NEW.SERVICEACC;
  new$FACIALACC_CLS ORG_ACCOUNTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$DATEOPEN ORG_ACCOUNTS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$DATECLOSE ORG_ACCOUNTS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$EXTID ORG_ACCOUNTS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORG_ACCOUNTS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORG_ACCOUNTS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$ACOMMENT ORG_ACCOUNTS.ACOMMENT%TYPE := :NEW.ACOMMENT;
  new$EXTROOTID ORG_ACCOUNTS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION ORG_ACCOUNTS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE ORG_ACCOUNTS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
--
  ADate$ NUMBER;
  DiffCode1$ NUMBER(10);
  Code11$ NUMBER(10);
  Code21$ NUMBER(10);
  Code31$ NUMBER(10);
  Code41$ NUMBER(10);
  Code5$ NUMBER(10);
  AFlag1$ NUMBER(10);
  vOrgType2$ NUMBER(10);
  vOrgType$ NUMBER(10);
  vServiceAcc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORG_ACCOUNTS_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$ACC_CLS is null) then 
    new$ACC_CLS:= 0;
  END IF;
  if (new$AccDefault is null) then 
    new$AccDefault:= 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType:= 0;
  END IF;
  if ((new$AComment is null) or (new$AComment  is null) 
  or (new$AComment = :old.AComment) and (:old.AComment = :old.Acc)) then
    new$AComment := new$Acc;
  END IF;
  if ((new$IsDefault is not Null) and (new$IsDefault <> 0)
  and ((:old.IsDefault is Null) or (:old.IsDefault = 0))) then
    update ORG_ACCOUNTS set
    IsDefault = 0
    where ORG_REF = new$ORG_REF
    and IsDefault is not Null
    and IsDefault <> 0;
  END IF;
  if ((new$SERVICE_ORG_REF is null)and(new$SERVICE_ACC_REF is not null)) then
    BEGIN
      select
      oa.Org_Ref
      into
      new$SERVICE_ORG_REF    from
      org_accounts oa
      where
      (oa.id = new$SERVICE_ACC_REF)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*               */
  if (new$ACC_CLS <> :old.ACC_CLS) then
    BEGIN
      select SERVICETYPE into vServiceAcc$ from ACC_CLS where (id = new$ACC_CLS) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*     ,    */
    if (vServiceAcc$ is not null) then
      new$ServiceAcc := vServiceAcc$;
     
    END IF;
  END IF;
  /*      ,       */
  if (:old.ServiceAcc is not null and new$ServiceAcc = 0 and :old.ServiceAcc <> new$ServiceAcc) then
    new$service_acc_ref := null;
    new$service_org_ref := null;
     
  END IF;
  /*       NULL,   0() */
  if (new$ServiceAcc is null) then
    new$ServiceAcc := 0;
    if (new$SERVICE_ORG_REF is not null) then
      BEGIN
        select
        o.Org_Type
        into vOrgType$      from
        Organizations o
        where
        (o.id = new$SERVICE_ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /* 01.01.xx  -   */
      if ((vOrgType$  > 10099)and(vOrgType$  < 10200)) then
        new$ServiceAcc := 3;
             
      else
        /* 03.02.xx     -   */
        if ((vOrgType$  > 30199)and(vOrgType$  < 30300)) then
          new$ServiceAcc := 1;
               
        else
          /* 04.xx.xx  -   */
          if ((vOrgType$  > 39999)and(vOrgType$  < 50000)) then
            new$ServiceAcc := 1;
          END IF;
        END IF;   
      END IF; 
    END IF;
  END IF;
  /*            */
  if (new$Acc <> :old.Acc) then
    update facialacc_cls set
    FACIALCODE = new$Acc
    where
    FCACCOUNT = new$id;
     
  END IF;
  /*      . .   .  ,   ,
       ,     .  */
  if ((new$Service_Acc_Ref is not null) and (new$ServiceAcc <> 0)
  and (new$Service_Acc_Ref <> :old.Service_Acc_Ref)) then
    BEGIN
      select
      Bank_Ref, Acc
      into new$Bank_Ref, new$FacialCode    from
      Org_Accounts
      where
      new$Service_Acc_Ref = Id
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*   */
  /*     ,        
       .  ,        */
  /*    ,          .  */
  if ((new$Bank_Ref <> :old.Bank_Ref) or (new$Acc <> :old.Acc)) then
    update Org_Accounts set
    Bank_Ref = new$Bank_Ref,
    FacialCode = new$Acc
    where
    (Service_Acc_Ref = new$ID) and
    (ID <> new$ID);
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORG_ACCOUNTS_BU_100)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$CloseCode is null) then
    new$CloseCode := 0;
  END IF;
  CloseOrgCls_Div(:old.CloseCode,Code11$, Code21$, Code31$, Code41$, Code5$);

  /* ??         */

  /*   ,        ,      */
  if ((new$Bank_ref <> :old.Bank_ref) and (Code41$ = 1)) then
    BEGIN
      select DateClose into ADate$ from Banks where ID = new$Bank_ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (ADate$ is null) then
      Code41$ := 0; /*    ,       . . */
      new$CloseCode := :old.CloseCode - 1000;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;

  /*    ,       . . -   */
  if ((new$Service_Acc_ref <> :old.Service_Acc_Ref) and (Code31$ = 1)) then
    BEGIN
      select Closed, DateClose into AFlag1$, ADate$ from Org_Accounts where ID = new$Service_Acc_Ref ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (AFlag1$ is null) then
      Code31$ := 0;
      new$CloseCode := :old.CloseCode - 100;

    else
      if (new$DateClose > ADate$) then
        new$DateClose := ADate$;
      END IF;
    END IF;
  END IF;
  /* ??   facialacc_cls    */

  /*  /  ??     ??   AU   */
  if (((new$Closed is null) and not(:old.Closed is null)) or
  (not(new$Closed is null) and (:old.Closed is null)))
  then
    if (new$ORG_REF is not null and  new$facialacc_cls is not null)
    then
      BEGIN
        select o.Org_Type       into vOrgType2$ from Organizations o where (o.id = new$ORG_REF)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      / ??    */
      if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900))
      then
        if (new$Closed = 1)
        then
          /*    */
          if (new$DateClose is null) then
            CurDateToDouble(new$DateClose);
          END IF;

          update facialacc_cls set
          dateclose = new$DateClose,
          CloseCode = CloseCode + 10000
          where id = new$facialacc_cls;

        END IF;
        if (new$Closed is null)
        then
          /*    */
          update facialacc_cls set
          dateclose = null,
          CloseCode = CloseCode - 10000
          where id = new$facialacc_cls;

        END IF;
      END IF;
    END IF;
    if (new$Closed = 1) then
      new$CloseCode := 1;
    END IF;
    if (new$Closed is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /*  /   */
  if (new$CloseCode <> :old.CloseCode) then
    DiffCode1$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */

    /*   "" */
    if (DiffCode1$ = 1) then
      Code11$ := 1;
    END IF;
    if (DiffCode1$ = 10) then
      Code21$ := 1;
    END IF;
    if (DiffCode1$ = 100) then
      Code31$ := 1;
    END IF;
    if (DiffCode1$ = 1000) then
      Code41$ := 1;
    END IF;
    if (DiffCode1$ = 10000) then
      Code5$ := 1;
    END IF;
    if (DiffCode1$ = -1) then
      Code11$ := 0;
    END IF;
    if (DiffCode1$ = -10) then
      Code21$ := 0;
    END IF;
    if (DiffCode1$ = -100) then
      Code31$ := 0;
    END IF;
    if (DiffCode1$ = -1000) then
      Code41$ := 0;
    END IF;
    if (DiffCode1$ = -10000) then
      Code5$ := 0;
    END IF;
    new$CloseCode := Code11$ + Code21$*10 + Code31$*100 + Code41$*1000 + Code5$*10000;

    if (new$CloseCode = 0) then
      new$Closed := null;
      new$DateClose := null;

    else
      new$Closed := 1;
      if (new$DateClose is null) then
        CurDateToDouble(new$DateClose);
      END IF;
      /*     ??      -  - !*/
      if (new$DateClose >= :old.DateClose) then
        new$DateClose := :old.DateClose;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORG_ACCOUNTS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (New$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORG_ACCOUNTS SET
    ID = new$ID,
    ORG_REF = new$ORG_REF,
    BANK_REF = new$BANK_REF,
    ACC = new$ACC,
    ACC_CLS = new$ACC_CLS,
    FINTYPE = new$FINTYPE,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    CLOSED = new$CLOSED,
    ACCDEFAULT = new$ACCDEFAULT,
    BANKDEPNUMBER = new$BANKDEPNUMBER,
    FACIALCODE = new$FACIALCODE,
    SERVICE_ORG_REF = new$SERVICE_ORG_REF,
    ISDEFAULT = new$ISDEFAULT,
    RVERSION = new$RVERSION,
    SERVICE_ACC_REF = new$SERVICE_ACC_REF,
    CLOSECODE = new$CLOSECODE,
    SERVICEACC = new$SERVICEACC,
    FACIALACC_CLS = new$FACIALACC_CLS,
    DATEOPEN = new$DATEOPEN,
    DATECLOSE = new$DATECLOSE,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    ACOMMENT = new$ACOMMENT,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_0 (TR_ORG_ACCOUNTS_AU)
-- Version 10.00.00.2
-- - - - - - - - - - - - -

  /*     ,      "  ".    */
  if (new$CloseCode <> :old.CloseCode)
  then
    if (new$CloseCode = 0) then
      update Org_Accounts set
      CloseCode = CloseCode - 100,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    else
      update Org_Accounts set
      CloseCode = CloseCode + 100,
      DateClose = new$DateClose,
      RVersion = -1
      where Service_Acc_Ref = :old.ID;

    END IF;
  END IF;
  /*    FACIAL_CODE   */
  if (new$acc <> :old.acc) then
    update org_accounts t set
    t.facialcode = new$acc
    where
    t.service_acc_ref = new$id and t.service_org_ref = new$org_ref
    ;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORG_ACCOUNTS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (21, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=21) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- Create_CoFinancingLevel.sql
-- #########################################################
-- #########################################################

/*    CoFinancingLevel - " " */
/*   " " */
create table CoFinancingLevel(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  TARGETCLS NUMBER(10) NOT NULL,/*   */
    CHECK((TARGETCLS<=2147483647)AND(TARGETCLS>-2147483648)),
  BudgetLevel NUMBER(10) NOT NULL,/*   */
    CHECK((BudgetLevel<=2147483647)AND(BudgetLevel>-2147483648)),
  Percent VARCHAR2(20) NOT NULL,/*   */
  MeansType NUMBER(10),/*   */
    CHECK((MeansType<=2147483647)AND(MeansType>-2147483648)),
  KCSR NUMBER(10),/*  */
    CHECK((KCSR<=2147483647)AND(KCSR>-2147483648)),
  CommDirectionExpenceCls NUMBER(10),/*   */
    CHECK((CommDirectionExpenceCls<=2147483647)AND(CommDirectionExpenceCls>-2147483648)),
  TransfertCls NUMBER(10),/*    */
    CHECK((TransfertCls<=2147483647)AND(TransfertCls>-2147483648)),
  BUDGETREF NUMBER(10) NOT NULL,/* */
    CHECK((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)),
  OKTMO NUMBER(10),/*  */
    CHECK((OKTMO<=2147483647)AND(OKTMO>-2147483648)),
  StartDate DATE,/*     */
  DeleteDate DATE,/*   */
  ParentCoFinancingLevel NUMBER(10),/*   */
    CHECK((ParentCoFinancingLevel<=2147483647)AND(ParentCoFinancingLevel>-2147483648)),
  Note VARCHAR2(1000),/*  */
  STOREDCONTENT VARCHAR2(4000),/*   */
  EXTID VARCHAR2(50),/* UID      */
  EXTROOTID VARCHAR2(50),/*   */
  CREATEDATE DATE NOT NULL,
  UPDATEDATE DATE NOT NULL,
  CREATERUSER VARCHAR2(30) NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  constraint PK_CoFinancingLevel_ID primary key (ID),
  constraint FK_CoFinancingLevel_TARGETCLS foreign key (TARGETCLS) references TARGETCLS (ID),
  constraint FK_CoFinancingLevel_MEANSTYPE foreign key (MEANSTYPE) references MEANSTYPE (ID),
  constraint FK_CoFinancingLevel_KCSR foreign key (KCSR) references KCSR (ID),
  constraint FK_CoFinancingLevel_CDECls foreign key (CommDirectionExpenceCls) references CommDirectionExpenceCls (ID),
  constraint FK_CoFinancingLevel_TRNSFTCLS foreign key (TRANSFERTCLS) references TB_TRANSFERTCLS (ID),
  constraint FK_CoFinancingLevel_BUDGETREF foreign key (BUDGETREF) references TB_BUDGETS_S (ID),
  constraint FK_CoFinancingLevel_OKTMO foreign key (OKTMO) references OKTMO (ID),
  constraint FK_CoFinancingLevel_ParentCFL foreign key (ParentCoFinancingLevel) references CoFinancingLevel (ID)
)
/
CREATE INDEX FK_CoFinancingLevel_TARGETCLS ON CoFinancingLevel(TARGETCLS)
/
CREATE INDEX FK_CoFinancingLevel_MEANSTYPE ON CoFinancingLevel(MEANSTYPE)
/
CREATE INDEX FK_CoFinancingLevel_KCSR ON CoFinancingLevel(KCSR)
/
CREATE INDEX FK_CoFinancingLevel_CDECls ON CoFinancingLevel(CommDirectionExpenceCls)
/
CREATE INDEX FK_CoFinancingLevel_TRNSFTCLS ON CoFinancingLevel(TRANSFERTCLS)
/
CREATE INDEX FK_CoFinancingLevel_BUDGETREF ON CoFinancingLevel(BUDGETREF)
/
CREATE INDEX FK_CoFinancingLevel_OKTMO ON CoFinancingLevel(OKTMO)
/
CREATE INDEX FK_CoFinancingLevel_ParentCFL ON CoFinancingLevel(ParentCoFinancingLevel)
/
create index IDX_CoFinancingLevel_EXTID on CoFinancingLevel(EXTID)
/
create index IDX_CoFinancingLevel_EXTROOTID ON CoFinancingLevel(EXTROOTID)
/
-- CREATE TRIGGER TR_CoFinancingLevel_BI_0
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_BI
  BEFORE INSERT
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CoFinancingLevel_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.TARGETCLS is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetLevel is null) then
    :new.BudgetLevel := 0;
  END IF;
  if (:new.Percent is null) then
    :new.Percent := '0';
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_BI_500
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_BI
  BEFORE INSERT
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CoFinancingLevel_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.TARGETCLS is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetLevel is null) then
    :new.BudgetLevel := 0;
  END IF;
  if (:new.Percent is null) then
    :new.Percent := '0';
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CoFinancingLevel_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_AI_500
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_AI
  AFTER INSERT
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_CoFinancingLevel_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98114) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_BU_0
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_BU
  BEFORE UPDATE
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CoFinancingLevel_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.TARGETCLS is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetLevel is null) then
    :new.BudgetLevel := 0;
  END IF;
  if (:new.Percent is null) then
    :new.Percent := '0';
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_BU_500
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_BU_500
  BEFORE UPDATE
  ON COFINANCINGLEVEL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_CoFinancingLevel_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_AU_500
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_AU
  AFTER UPDATE
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_CoFinancingLevel_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98114, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98114) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_CoFinancingLevel_AD_500
CREATE OR REPLACE TRIGGER TR_CoFinancingLevel_AD
  AFTER DELETE
  ON CoFinancingLevel
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_CoFinancingLevel_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98114,:old.ID,SYSDATE);

END;
/

/*        CoFinancingLevel*/
grant SELECT, INSERT, UPDATE, DELETE on CoFinancingLevel to BUDGET_USERS
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_BudNotify_Add_BO_Ref.sql
-- #########################################################
-- #########################################################

ALTER TRIGGER TR_FACIALACC_CLS_BU_500 DISABLE
/
ALTER TABLE TB_FacialAcc_Cls ADD (
  isKS NUMBER(5) default 0/*    */,
    CHECK (isKS in (0,1))
)
/
ALTER TRIGGER TR_FACIALACC_CLS_BU_500 ENABLE
/

CREATE OR REPLACE VIEW FacialAcc_Cls (
  ID,
  CODE1,
  CODE2,
  CODE3,
  CODE4,
  KVSR,
  KCSR,
  KFSR,
  KVR,
  KESR,
  FINTYPE,
  ORG_REF,
  DATEOPEN,
  SERVICEACCOUNT,
  STATUSACCOUNT,
  HARACTERACCOUNT,
  REGIONCLS,
  CREATEDATE,
  UPDATEDATE,
  FACIALCODE,
  MEANSTYPE,
  GENERALORG_REF,
  DEPARTMENTCLS,
  RVERSION,
  CLOSEDOCNUMBER,
  HIGHERORG_REF,
  BUDGETREF,
  FCACCOUNT,
  CLOSECODE,
  DATECLOSE,
  CREATERUSER,
  UPDATERUSER,
  NOTE,
  NAME,
  ISRBS,
  ISPBS,
  ISBU,
  ISSEPARATEBU,
  ISPROXY,
  OPENDOCNUMBER,
  ISOMS,
  CHANGEDOCNUMBER,
  DATECHANGE,
  GENERALORGFACIALACC,
  GRANTEEORG_REF,
  PREVCLS,
  FACIALCODEEX,
  EXTID,
  EXTROOTID,
  CODE,
  ISKS)
AS
  SELECT
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE,
    ISKS
  FROM TB_FacialAcc_Cls
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_ID
  INSTEAD OF DELETE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (facialacc_cls_bd0)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(CONSTVALUE ) INTO CNT$1
  from INTCONST where ((CONSTVALUE = :old.id)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('EX_CANNOTDELETE_FACIAL_ACC');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALACC_CLS
  WHERE ID = :OLD.ID
       AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALACC_CLS_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
     VALUES (19, :OLD.ID, SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_II
  INSTEAD OF INSERT
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
  new$ISKS FACIALACC_CLS.ISKS%TYPE := :NEW.ISKS;
--
  OrgDateClose$ Number;
  id_org1$ NUMBER(10);
  id_reg1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALACC_CLS_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
  --   ,   
  if (new$Code is null) then
    FormatClsStr(new$ID, 9,new$Code);
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0;
  END IF;
  BEGIN

    --     
    select o.generalorg_ref
    into id_org1$   from organizations o
    where o.id = new$org_ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (id_org1$  is null) then 
    id_org1$ := new$org_ref;
  END IF;
  new$generalorg_ref := id_org1$;
  BEGIN

    --  /  -
    select o.RegionCLS
    into id_reg1$   from Organizations o
    where o.ID = new$Org_Ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  new$regioncls := id_reg1$;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALACC_CLS_BI_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

/*    -    */
   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALACC_CLS_BI_200)
-- Create 27.07.2007
-- - - - - - - - - - - - -

    if (new$Org_Ref is not null) then
      select DateClose into OrgDateClose$ from organizations where Id = new$Org_ref;
      if (OrgDateClose$ is not null) then
         if ((new$DateClose is null) or (new$DateClose > OrgDateClose$)) then
           new$DateClose := OrgDateClose$;
         end if;
         new$StatusAccount := 1;
         new$CloseCode := 10; /*   */
      end if;
    end if;

    if ((new$DateClose is not null) and (new$StatusAccount = 0)) then
      new$StatusAccount := 1;
      new$CloseCode := 1;
    end if;

    if (new$CloseCode is null) then new$CloseCode := 0; end if;

-- - - - - - - - - - - - -
-- BI_400 (TR_FACIALACC_CLS_BI_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALACC_CLS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALACC_CLS (
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE,
    ISKS
  ) VALUES (
    new$ID,
    new$CODE1,
    new$CODE2,
    new$CODE3,
    new$CODE4,
    new$KVSR,
    new$KCSR,
    new$KFSR,
    new$KVR,
    new$KESR,
    new$FINTYPE,
    new$ORG_REF,
    new$DATEOPEN,
    new$SERVICEACCOUNT,
    new$STATUSACCOUNT,
    new$HARACTERACCOUNT,
    new$REGIONCLS,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$FACIALCODE,
    new$MEANSTYPE,
    new$GENERALORG_REF,
    new$DEPARTMENTCLS,
    new$RVERSION,
    new$CLOSEDOCNUMBER,
    new$HIGHERORG_REF,
    new$BUDGETREF,
    new$FCACCOUNT,
    new$CLOSECODE,
    new$DATECLOSE,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$NOTE,
    new$NAME,
    new$ISRBS,
    new$ISPBS,
    new$ISBU,
    new$ISSEPARATEBU,
    new$ISPROXY,
    new$OPENDOCNUMBER,
    new$ISOMS,
    new$CHANGEDOCNUMBER,
    new$DATECHANGE,
    new$GENERALORGFACIALACC,
    new$GRANTEEORG_REF,
    new$PREVCLS,
    new$FACIALCODEEX,
    new$EXTID,
    new$EXTROOTID,
    new$CODE,
    new$ISKS);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALACC_CLS_AI_500)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 19) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_IU
  INSTEAD OF UPDATE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
  new$ISKS FACIALACC_CLS.ISKS%TYPE := :NEW.ISKS;
--
  id_org$ NUMBER(10);
  DiffCode$ NUMBER(10);
  Code1$ NUMBER(10);
  Code2$ NUMBER(10);
  Code51$ NUMBER(10);
  CodeX$ NUMBER(10);
  vOrgType1$ NUMBER(10);
  id_org2$ NUMBER(10);
  id_reg$ NUMBER(10);
  vOrgType2$ NUMBER(10);
  IsNumeric$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALACC_CLS_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> :old.id) then
    facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
    --    ,        
    IsNumericString(new$Code,IsNumeric$);
    if ((new$Code is null) or (new$Code  is null) or ((IsNumeric$ = 1) and (new$Code = :old.Code) and (new$Code = :old.id))) then
      FormatClsStr(new$ID, 9,new$Code);
      
    END IF;
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$regioncls is null) then 
    new$regioncls := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0; -- ,   select min (...)
  END IF;
  if ((new$org_ref <> :old.org_ref) and not(new$fcaccount is null)) then
    BEGIN
      select org_ref     into id_org2$ from org_accounts
      where id = new$fcaccount
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (id_org2$ <> new$org_ref) then 
      new$fcaccount := null;
      
    END IF;
  END IF;
  if (:old.Org_Ref <> new$Org_Ref) then 
    BEGIN
      --   --------------------------
      select o.RegionCLS
      into id_reg$        from Organizations o
      where o.ID = new$Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    --   -----------------
         
    new$regioncls := id_reg$;
    BEGIN
      --       /----
      select o.Org_Type
      into vOrgType2$      from Organizations o
      where o.ID = :old.Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900)) then
      update org_accounts
      set facialacc_cls = null
      where facialacc_cls = :old.id;
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_FACIALACC_CLS_BU_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALACC_CLS_BU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /* /  ??     ??   AU   */
  if ((((new$DateClose is not null) and (:old.DateClose is null)) or
  ((new$DateClose is null) and (:old.DateClose is not null)))
  and (new$CloseCode = :old.CloseCode))
  then
    BEGIN
      /*      /    .
                / ??    ?
          */
      select o.Org_Type     into vOrgType1$ from Organizations o where o.id = new$org_ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType1$  >= 10800)and(vOrgType1$  <= 10900)) then
      if (new$DateClose is not null or (new$statusaccount = 1 and :old.statusaccount=0))
      then
        update org_accounts set
        CloseCode = CloseCode + 10000,
        DateClose = new$DateClose
        where facialacc_cls = new$id;

      END IF;
      if (new$DateClose is null or (new$statusaccount = 0 and :old.statusaccount=1))
      then
        update org_accounts set
        CloseCode = CloseCode - 10000
        where facialacc_cls = new$id;

      END IF;
    END IF;
    if (new$DateClose is not null) then
      new$CloseCode := 1;
    END IF;
    if (new$DateClose is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /* /   (only      ) */
  if (new$CloseCode <> :old.CloseCode)
  then
    DiffCode$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */
    CloseOrgCls_Div(:old.CloseCode,Code1$, Code2$, CodeX$, CodeX$, Code51$);

    /*   "" */
    if (DiffCode$ = 1) then
      Code1$ := 1;
    END IF;
    if (DiffCode$ = 10) then
      Code2$ := 1;
    END IF;
    if (DiffCode$ = 10000) then
      Code51$ := 1;
    END IF;
    if (DiffCode$ = -1) then
      Code1$ := 0;
    END IF;
    if (DiffCode$ = -10) then
      Code2$ := 0;
    END IF;
    if (DiffCode$ = -10000) then
      Code51$ := 0;
    END IF;
    new$CloseCode := Code1$ + Code2$*10 + Code51$*10000;

    if (new$CloseCode <> 0) then
      new$StatusAccount := 1;
    END IF;

    /*     ??      -  - !*/
    if (((new$CloseCode <> 0) and (new$DateClose is null)) or (new$DateClose >= :old.DateClose)) then
      new$DateClose := :old.DateClose;

    else
      if (new$CloseCode = 0) then
        new$DateClose := null;
        if (new$StatusAccount <> 0) then
          new$StatusAccount := 0;

        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_FACIALACC_CLS_BU_400)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;

    else
      new$IsRBS := 0;

    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;

    else
      new$IsPBS := 0;

    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;

  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;

    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;

      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_550 (TR_FACIALACC_CLS_BU_550)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF ((new$GeneralOrg_ref IS NULL)or(new$Org_Ref <> :old.Org_Ref)) THEN
     select
       o.GeneralOrg_Ref
     into
       id_org$
     from
       Organizations o
     where
       o.id = new$Org_Ref;
      /*      */
     if (id_org$ is Null)
       then id_org$ := new$Org_Ref;
     end if;
     new$GeneralOrg_ref := id_org$;

   END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALACC_CLS_BU_700)
-- Create 19.09.2004
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (NEW$RVersion IS NULL) THEN
      NEW$RVersion := 1;
   ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      NEW$RVersion := :OLD.RVersion;
   ELSE
      NEW$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALACC_CLS SET
    ID = new$ID,
    CODE1 = new$CODE1,
    CODE2 = new$CODE2,
    CODE3 = new$CODE3,
    CODE4 = new$CODE4,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KFSR = new$KFSR,
    KVR = new$KVR,
    KESR = new$KESR,
    FINTYPE = new$FINTYPE,
    ORG_REF = new$ORG_REF,
    DATEOPEN = new$DATEOPEN,
    SERVICEACCOUNT = new$SERVICEACCOUNT,
    STATUSACCOUNT = new$STATUSACCOUNT,
    HARACTERACCOUNT = new$HARACTERACCOUNT,
    REGIONCLS = new$REGIONCLS,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    FACIALCODE = new$FACIALCODE,
    MEANSTYPE = new$MEANSTYPE,
    GENERALORG_REF = new$GENERALORG_REF,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    RVERSION = new$RVERSION,
    CLOSEDOCNUMBER = new$CLOSEDOCNUMBER,
    HIGHERORG_REF = new$HIGHERORG_REF,
    BUDGETREF = new$BUDGETREF,
    FCACCOUNT = new$FCACCOUNT,
    CLOSECODE = new$CLOSECODE,
    DATECLOSE = new$DATECLOSE,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    NOTE = new$NOTE,
    NAME = new$NAME,
    ISRBS = new$ISRBS,
    ISPBS = new$ISPBS,
    ISBU = new$ISBU,
    ISSEPARATEBU = new$ISSEPARATEBU,
    ISPROXY = new$ISPROXY,
    OPENDOCNUMBER = new$OPENDOCNUMBER,
    ISOMS = new$ISOMS,
    CHANGEDOCNUMBER = new$CHANGEDOCNUMBER,
    DATECHANGE = new$DATECHANGE,
    GENERALORGFACIALACC = new$GENERALORGFACIALACC,
    GRANTEEORG_REF = new$GRANTEEORG_REF,
    PREVCLS = new$PREVCLS,
    FACIALCODEEX = new$FACIALCODEEX,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    CODE = new$CODE,
    ISKS = new$ISKS
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALACC_CLS_AU_500)
-- Create 28.04.2005
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (19, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 19) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_FACIALACC_CLS_BI_400
CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_II
  INSTEAD OF INSERT
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
  new$ISKS FACIALACC_CLS.ISKS%TYPE := :NEW.ISKS;
--
  OrgDateClose$ Number;
  id_org1$ NUMBER(10);
  id_reg1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALACC_CLS_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
  --   ,   
  if (new$Code is null) then
    FormatClsStr(new$ID, 9,new$Code);
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0;
  END IF;
  BEGIN

    --     
    select o.generalorg_ref
    into id_org1$   from organizations o
    where o.id = new$org_ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (id_org1$  is null) then 
    id_org1$ := new$org_ref;
  END IF;
  new$generalorg_ref := id_org1$;
  BEGIN

    --  /  -
    select o.RegionCLS
    into id_reg1$   from Organizations o
    where o.ID = new$Org_Ref
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  new$regioncls := id_reg1$;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALACC_CLS_BI_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

/*    -    */
   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALACC_CLS_BI_200)
-- Create 27.07.2007
-- - - - - - - - - - - - -

    if (new$Org_Ref is not null) then
      select DateClose into OrgDateClose$ from organizations where Id = new$Org_ref;
      if (OrgDateClose$ is not null) then
         if ((new$DateClose is null) or (new$DateClose > OrgDateClose$)) then
           new$DateClose := OrgDateClose$;
         end if;
         new$StatusAccount := 1;
         new$CloseCode := 10; /*   */
      end if;
    end if;

    if ((new$DateClose is not null) and (new$StatusAccount = 0)) then
      new$StatusAccount := 1;
      new$CloseCode := 1;
    end if;

    if (new$CloseCode is null) then new$CloseCode := 0; end if;

-- - - - - - - - - - - - -
-- BI_400 (TR_FACIALACC_CLS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$IsKs is null) then 
    new$IsKs := 0;
  END IF;
  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;
          
    else
      new$IsRBS := 0;
      
    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;
          
    else
      new$IsPBS := 0;
      
    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;
      
  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;
          
    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;
              
      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALACC_CLS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALACC_CLS (
    ID,
    CODE1,
    CODE2,
    CODE3,
    CODE4,
    KVSR,
    KCSR,
    KFSR,
    KVR,
    KESR,
    FINTYPE,
    ORG_REF,
    DATEOPEN,
    SERVICEACCOUNT,
    STATUSACCOUNT,
    HARACTERACCOUNT,
    REGIONCLS,
    CREATEDATE,
    UPDATEDATE,
    FACIALCODE,
    MEANSTYPE,
    GENERALORG_REF,
    DEPARTMENTCLS,
    RVERSION,
    CLOSEDOCNUMBER,
    HIGHERORG_REF,
    BUDGETREF,
    FCACCOUNT,
    CLOSECODE,
    DATECLOSE,
    CREATERUSER,
    UPDATERUSER,
    NOTE,
    NAME,
    ISRBS,
    ISPBS,
    ISBU,
    ISSEPARATEBU,
    ISPROXY,
    OPENDOCNUMBER,
    ISOMS,
    CHANGEDOCNUMBER,
    DATECHANGE,
    GENERALORGFACIALACC,
    GRANTEEORG_REF,
    PREVCLS,
    FACIALCODEEX,
    EXTID,
    EXTROOTID,
    CODE,
    ISKS
  ) VALUES (
    new$ID,
    new$CODE1,
    new$CODE2,
    new$CODE3,
    new$CODE4,
    new$KVSR,
    new$KCSR,
    new$KFSR,
    new$KVR,
    new$KESR,
    new$FINTYPE,
    new$ORG_REF,
    new$DATEOPEN,
    new$SERVICEACCOUNT,
    new$STATUSACCOUNT,
    new$HARACTERACCOUNT,
    new$REGIONCLS,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$FACIALCODE,
    new$MEANSTYPE,
    new$GENERALORG_REF,
    new$DEPARTMENTCLS,
    new$RVERSION,
    new$CLOSEDOCNUMBER,
    new$HIGHERORG_REF,
    new$BUDGETREF,
    new$FCACCOUNT,
    new$CLOSECODE,
    new$DATECLOSE,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$NOTE,
    new$NAME,
    new$ISRBS,
    new$ISPBS,
    new$ISBU,
    new$ISSEPARATEBU,
    new$ISPROXY,
    new$OPENDOCNUMBER,
    new$ISOMS,
    new$CHANGEDOCNUMBER,
    new$DATECHANGE,
    new$GENERALORGFACIALACC,
    new$GRANTEEORG_REF,
    new$PREVCLS,
    new$FACIALCODEEX,
    new$EXTID,
    new$EXTROOTID,
    new$CODE,
    new$ISKS);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALACC_CLS_AI_500)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 19) AND (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_FACIALACC_CLS_BU_400
CREATE OR REPLACE TRIGGER TR_FACIALACC_CLS_IU
  INSTEAD OF UPDATE
  ON FACIALACC_CLS
  FOR EACH ROW
DECLARE
  new$ID FACIALACC_CLS.ID%TYPE := :NEW.ID;
  new$CODE1 FACIALACC_CLS.CODE1%TYPE := :NEW.CODE1;
  new$CODE2 FACIALACC_CLS.CODE2%TYPE := :NEW.CODE2;
  new$CODE3 FACIALACC_CLS.CODE3%TYPE := :NEW.CODE3;
  new$CODE4 FACIALACC_CLS.CODE4%TYPE := :NEW.CODE4;
  new$KVSR FACIALACC_CLS.KVSR%TYPE := :NEW.KVSR;
  new$KCSR FACIALACC_CLS.KCSR%TYPE := :NEW.KCSR;
  new$KFSR FACIALACC_CLS.KFSR%TYPE := :NEW.KFSR;
  new$KVR FACIALACC_CLS.KVR%TYPE := :NEW.KVR;
  new$KESR FACIALACC_CLS.KESR%TYPE := :NEW.KESR;
  new$FINTYPE FACIALACC_CLS.FINTYPE%TYPE := :NEW.FINTYPE;
  new$ORG_REF FACIALACC_CLS.ORG_REF%TYPE := :NEW.ORG_REF;
  new$DATEOPEN FACIALACC_CLS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$SERVICEACCOUNT FACIALACC_CLS.SERVICEACCOUNT%TYPE := :NEW.SERVICEACCOUNT;
  new$STATUSACCOUNT FACIALACC_CLS.STATUSACCOUNT%TYPE := :NEW.STATUSACCOUNT;
  new$HARACTERACCOUNT FACIALACC_CLS.HARACTERACCOUNT%TYPE := :NEW.HARACTERACCOUNT;
  new$REGIONCLS FACIALACC_CLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATEDATE FACIALACC_CLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALACC_CLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$FACIALCODE FACIALACC_CLS.FACIALCODE%TYPE := :NEW.FACIALCODE;
  new$MEANSTYPE FACIALACC_CLS.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$GENERALORG_REF FACIALACC_CLS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$DEPARTMENTCLS FACIALACC_CLS.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$RVERSION FACIALACC_CLS.RVERSION%TYPE := :NEW.RVERSION;
  new$CLOSEDOCNUMBER FACIALACC_CLS.CLOSEDOCNUMBER%TYPE := :NEW.CLOSEDOCNUMBER;
  new$HIGHERORG_REF FACIALACC_CLS.HIGHERORG_REF%TYPE := :NEW.HIGHERORG_REF;
  new$BUDGETREF FACIALACC_CLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FCACCOUNT FACIALACC_CLS.FCACCOUNT%TYPE := :NEW.FCACCOUNT;
  new$CLOSECODE FACIALACC_CLS.CLOSECODE%TYPE := :NEW.CLOSECODE;
  new$DATECLOSE FACIALACC_CLS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$CREATERUSER FACIALACC_CLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER FACIALACC_CLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE FACIALACC_CLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME FACIALACC_CLS.NAME%TYPE := :NEW.NAME;
  new$ISRBS FACIALACC_CLS.ISRBS%TYPE := :NEW.ISRBS;
  new$ISPBS FACIALACC_CLS.ISPBS%TYPE := :NEW.ISPBS;
  new$ISBU FACIALACC_CLS.ISBU%TYPE := :NEW.ISBU;
  new$ISSEPARATEBU FACIALACC_CLS.ISSEPARATEBU%TYPE := :NEW.ISSEPARATEBU;
  new$ISPROXY FACIALACC_CLS.ISPROXY%TYPE := :NEW.ISPROXY;
  new$OPENDOCNUMBER FACIALACC_CLS.OPENDOCNUMBER%TYPE := :NEW.OPENDOCNUMBER;
  new$ISOMS FACIALACC_CLS.ISOMS%TYPE := :NEW.ISOMS;
  new$CHANGEDOCNUMBER FACIALACC_CLS.CHANGEDOCNUMBER%TYPE := :NEW.CHANGEDOCNUMBER;
  new$DATECHANGE FACIALACC_CLS.DATECHANGE%TYPE := :NEW.DATECHANGE;
  new$GENERALORGFACIALACC FACIALACC_CLS.GENERALORGFACIALACC%TYPE := :NEW.GENERALORGFACIALACC;
  new$GRANTEEORG_REF FACIALACC_CLS.GRANTEEORG_REF%TYPE := :NEW.GRANTEEORG_REF;
  new$PREVCLS FACIALACC_CLS.PREVCLS%TYPE := :NEW.PREVCLS;
  new$FACIALCODEEX FACIALACC_CLS.FACIALCODEEX%TYPE := :NEW.FACIALCODEEX;
  new$EXTID FACIALACC_CLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID FACIALACC_CLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$CODE FACIALACC_CLS.CODE%TYPE := :NEW.CODE;
  new$ISKS FACIALACC_CLS.ISKS%TYPE := :NEW.ISKS;
--
  id_org$ NUMBER(10);
  DiffCode$ NUMBER(10);
  Code1$ NUMBER(10);
  Code2$ NUMBER(10);
  Code51$ NUMBER(10);
  CodeX$ NUMBER(10);
  vOrgType1$ NUMBER(10);
  id_org2$ NUMBER(10);
  id_reg$ NUMBER(10);
  vOrgType2$ NUMBER(10);
  IsNumeric$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALACC_CLS_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> :old.id) then
    facialacc_clsdiv(new$id,new$code1,new$code2,new$code3,new$code4);
    --    ,        
    IsNumericString(new$Code,IsNumeric$);
    if ((new$Code is null) or (new$Code  is null) or ((IsNumeric$ = 1) and (new$Code = :old.Code) and (new$Code = :old.id))) then
      FormatClsStr(new$ID, 9,new$Code);
      
    END IF;
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$kcsr is null) then 
    new$kcsr := 0;
  END IF;
  if (new$kfsr is null) then 
    new$kfsr := 0;
  END IF;
  if (new$kvr is null) then 
    new$kvr := 0;
  END IF;
  if (new$kesr is null) then 
    new$kesr := 0;
  END IF;
  if (new$fintype is null) then 
    new$fintype := 0;
  END IF;
  if (new$regioncls is null) then 
    new$regioncls := 0;
  END IF;
  if (new$meanstype is null) then 
    new$meanstype := 0;
  END IF;
  if (new$haracteraccount is null) then 
    new$haracteraccount := 0;
  END IF;
  if (new$org_ref is null) then 
    new$org_ref := 0; -- ,   select min (...)
  END IF;
  if ((new$org_ref <> :old.org_ref) and not(new$fcaccount is null)) then
    BEGIN
      select org_ref     into id_org2$ from org_accounts
      where id = new$fcaccount
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (id_org2$ <> new$org_ref) then 
      new$fcaccount := null;
      
    END IF;
  END IF;
  if (:old.Org_Ref <> new$Org_Ref) then 
    BEGIN
      --   --------------------------
      select o.RegionCLS
      into id_reg$        from Organizations o
      where o.ID = new$Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    --   -----------------
         
    new$regioncls := id_reg$;
    BEGIN
      --       /----
      select o.Org_Type
      into vOrgType2$      from Organizations o
      where o.ID = :old.Org_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType2$  >= 10800)and(vOrgType2$  <= 10900)) then
      update org_accounts
      set facialacc_cls = null
      where facialacc_cls = :old.id;
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_FACIALACC_CLS_BU_100)
-- Create 01.12.2005
-- - - - - - - - - - - - -

   IF (    (   (new$ID = 0)
            OR (new$serviceaccount = 0)
            OR (new$serviceaccount IS NULL)
           )
       AND (new$budgetref IS NULL)
      ) THEN
      new$budgetRef := 0;
   END IF;

   IF (    (new$ID <> 0)
       AND (new$serviceaccount = 1)
       AND ((new$budgetref IS NULL) OR (new$budgetref = 0))
      ) THEN
      getintconst (-1, 3, new$budgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALACC_CLS_BU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /* /  ??     ??   AU   */
  if ((((new$DateClose is not null) and (:old.DateClose is null)) or
  ((new$DateClose is null) and (:old.DateClose is not null)))
  and (new$CloseCode = :old.CloseCode))
  then
    BEGIN
      /*      /    .
                / ??    ?
          */
      select o.Org_Type     into vOrgType1$ from Organizations o where o.id = new$org_ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((vOrgType1$  >= 10800)and(vOrgType1$  <= 10900)) then
      if (new$DateClose is not null or (new$statusaccount = 1 and :old.statusaccount=0))
      then
        update org_accounts set
        CloseCode = CloseCode + 10000,
        DateClose = new$DateClose
        where facialacc_cls = new$id;

      END IF;
      if (new$DateClose is null or (new$statusaccount = 0 and :old.statusaccount=1))
      then
        update org_accounts set
        CloseCode = CloseCode - 10000
        where facialacc_cls = new$id;

      END IF;
    END IF;
    if (new$DateClose is not null) then
      new$CloseCode := 1;
    END IF;
    if (new$DateClose is null) then
      new$CloseCode := 0;

    END IF;
  END IF;

  /* /   (only      ) */
  if (new$CloseCode <> :old.CloseCode)
  then
    DiffCode$ := new$CloseCode - :old.CloseCode; /* >0 -  , <0 -  */
    CloseOrgCls_Div(:old.CloseCode,Code1$, Code2$, CodeX$, CodeX$, Code51$);

    /*   "" */
    if (DiffCode$ = 1) then
      Code1$ := 1;
    END IF;
    if (DiffCode$ = 10) then
      Code2$ := 1;
    END IF;
    if (DiffCode$ = 10000) then
      Code51$ := 1;
    END IF;
    if (DiffCode$ = -1) then
      Code1$ := 0;
    END IF;
    if (DiffCode$ = -10) then
      Code2$ := 0;
    END IF;
    if (DiffCode$ = -10000) then
      Code51$ := 0;
    END IF;
    new$CloseCode := Code1$ + Code2$*10 + Code51$*10000;

    if (new$CloseCode <> 0) then
      new$StatusAccount := 1;
    END IF;

    /*     ??      -  - !*/
    if (((new$CloseCode <> 0) and (new$DateClose is null)) or (new$DateClose >= :old.DateClose)) then
      new$DateClose := :old.DateClose;

    else
      if (new$CloseCode = 0) then
        new$DateClose := null;
        if (new$StatusAccount <> 0) then
          new$StatusAccount := 0;

        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_FACIALACC_CLS_BU_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$IsKs is null) then 
    new$IsKs := 0;
  END IF;
  if (new$IsRBS is null) then
    if (new$HaracterAccount in (1, 2)) then
      new$IsRBS := 1;
          
    else
      new$IsRBS := 0;
      
    END IF;
  END IF;
  if (new$IsPBS is null) then
    if (new$HaracterAccount in (0, 2)) then
      new$IsPBS := 1;
          
    else
      new$IsPBS := 0;
      
    END IF;
  END IF;
  if (new$IsBU is null) then
    new$IsBU := 0;
  END IF;
  if (new$IsOMS is null) then
    new$IsOMS := 0;
  END IF;
  if (new$IsSeparateBU is null) then
    new$IsSeparateBU := 0;
  END IF;
  if (new$IsProxy is null) then
    new$IsProxy := 0;
  END IF;
  if ((new$IsRBS + new$IsPBS + new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) = 0) then
    new$HaracterAccount := 3;
      
  else
    if ((new$IsBU + new$IsOMS + new$IsSeparateBU + new$IsProxy) > 0) then
      new$HaracterAccount := 0;
          
    else
      if (new$IsRBS = 1) then
        new$HaracterAccount := new$IsRBS + new$IsPBS;
              
      else
        new$HaracterAccount := 0;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_550 (TR_FACIALACC_CLS_BU_550)
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF ((new$GeneralOrg_ref IS NULL)or(new$Org_Ref <> :old.Org_Ref)) THEN
     select
       o.GeneralOrg_Ref
     into
       id_org$
     from
       Organizations o
     where
       o.id = new$Org_Ref;
      /*      */
     if (id_org$ is Null)
       then id_org$ := new$Org_Ref;
     end if;
     new$GeneralOrg_ref := id_org$;

   END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALACC_CLS_BU_700)
-- Create 19.09.2004
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (NEW$RVersion IS NULL) THEN
      NEW$RVersion := 1;
   ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      NEW$RVersion := :OLD.RVersion;
   ELSE
      NEW$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALACC_CLS SET
    ID = new$ID,
    CODE1 = new$CODE1,
    CODE2 = new$CODE2,
    CODE3 = new$CODE3,
    CODE4 = new$CODE4,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KFSR = new$KFSR,
    KVR = new$KVR,
    KESR = new$KESR,
    FINTYPE = new$FINTYPE,
    ORG_REF = new$ORG_REF,
    DATEOPEN = new$DATEOPEN,
    SERVICEACCOUNT = new$SERVICEACCOUNT,
    STATUSACCOUNT = new$STATUSACCOUNT,
    HARACTERACCOUNT = new$HARACTERACCOUNT,
    REGIONCLS = new$REGIONCLS,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    FACIALCODE = new$FACIALCODE,
    MEANSTYPE = new$MEANSTYPE,
    GENERALORG_REF = new$GENERALORG_REF,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    RVERSION = new$RVERSION,
    CLOSEDOCNUMBER = new$CLOSEDOCNUMBER,
    HIGHERORG_REF = new$HIGHERORG_REF,
    BUDGETREF = new$BUDGETREF,
    FCACCOUNT = new$FCACCOUNT,
    CLOSECODE = new$CLOSECODE,
    DATECLOSE = new$DATECLOSE,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    NOTE = new$NOTE,
    NAME = new$NAME,
    ISRBS = new$ISRBS,
    ISPBS = new$ISPBS,
    ISBU = new$ISBU,
    ISSEPARATEBU = new$ISSEPARATEBU,
    ISPROXY = new$ISPROXY,
    OPENDOCNUMBER = new$OPENDOCNUMBER,
    ISOMS = new$ISOMS,
    CHANGEDOCNUMBER = new$CHANGEDOCNUMBER,
    DATECHANGE = new$DATECHANGE,
    GENERALORGFACIALACC = new$GENERALORGFACIALACC,
    GRANTEEORG_REF = new$GRANTEEORG_REF,
    PREVCLS = new$PREVCLS,
    FACIALCODEEX = new$FACIALCODEEX,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    CODE = new$CODE,
    ISKS = new$ISKS
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALACC_CLS_AU_500)
-- Create 28.04.2005
-- Last update 15.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (19, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 19) AND (RecordId = new$ID);
   END IF;

END;
/

commit work
/
ALTER TRIGGER TR_AGREEMENTS_BU_500 DISABLE
/
ALTER TABLE TB_Agreements ADD (
  isKS NUMBER(5) default 0,/*    */
    CHECK (isKS in (0,1)),
  rootDoc NUMBER(10),/*     */
    CHECK((rootDoc<=2147483647)AND(rootDoc>-2147483648)),
  constraint FK_AGREEMENTS_BOREF foreign key(rootDoc) references TB_Agreements(ID)
)
/
ALTER TRIGGER TR_AGREEMENTS_BU_500 ENABLE
/
CREATE INDEX FK_AGREEMENTS_BOREF ON TB_Agreements(rootDoc)
/

CREATE OR REPLACE VIEW Agreements (
  ID,
  SUMMA,
  AGREEMENTDATE,
  AGREEMENTENDDATE,
  EXECUTER_REF,
  CLIENT_REF,
  FACIALACC_CLS,
  AGREEMENTTYPE,
  ACCEPTED,
  ACCEPTDATE,
  CARDADVANCEPERCENT,
  CARDADVANCE,
  CLOSEDOC,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  LASTADJUSTMENT,
  LASTACCEPTED,
  FACT,
  REGION,
  CLOSEDATE,
  DELIVERYRULES,
  AGREEMENTSUMMA,
  AGREEMENTFINSUMMA,
  ADJUSTMENTREF,
  REESTRNUMBER,
  PAYMENTDATE,
  AGREEMENTCARDADVANCE,
  FINCARDADVANCE,
  STATEORDERREF,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  AGREEMENTBEGINDATE,
  PROTOCOLNUMBER,
  PROTOCOLDATE,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXPORTDATE,
  FSORGAN,
  FSBUDGETNAME,
  FSOFFBUDGET,
  RNYEAR,
  RNNUMBER,
  RNDATE,
  PROTOCOLNOTICE,
  PROTOCOLRESULTDATE,
  PROTOCOLDOCTYPE,
  PROTOCOLSALETYPE,
  NOTIFYDATE,
  EXECUTERACCREF,
  DOCBASEDATE,
  DOCBASENOTIFYDATE,
  DOCBASETEXT,
  DOCBASETYPE,
  DOCBASESUMMA,
  UNKNOWNAMOUNT,
  PROTOCOLREASON,
  DOCNUMBER,
  ADJUSTMENTDOCNUMBER,
  OLDDOCNUMBER,
  LOTMAXSUM,
  CLIENT_INN,
  CLIENT_INN20,
  CLIENT_NAME,
  EXECUTER_INN,
  EXECUTER_INN20,
  EXECUTER_NAME,
  EXECUTER_STATUS,
  EXECUTER_COUNTRY,
  EXECUTER_ADDRESS,
  EXECUTER_PHONE,
  REALID,
  ADJUSTMENTNUMBER,
  INNERNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REESTRVERSION,
  DOCTYPE,
  RNCLIENTID,
  INFONUMBER,
  STATEORDERINNERNUMBER,
  PROGINDEX,
  NOTE,
  REESTRRECORDNUMBER,
  EXECUTERSTOREDPROPS,
  AUTOSANCTION,
  PURCHASECODE,
  DOCUMENTNUMBER,
  REJECTCAUSE,
  TENDERREF,
  TENDERINNERNUMBER,
  STOREDCONTENT,
  PURPORTDOC,
  TREASURYSUPPORTID,
  ISKS,
  ROOTDOC)
AS
  SELECT
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC,
    TREASURYSUPPORTID,
    ISKS,
    ROOTDOC
  FROM TB_Agreements
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;

  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
  new$ISKS AGREEMENTS.ISKS%TYPE := :NEW.ISKS;
  new$ROOTDOC AGREEMENTS.ROOTDOC%TYPE := :NEW.ROOTDOC;
--
  CountAcc$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;

  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*       */
    select count(ID) 
    into Tmp1$         from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp1$ = 0) then 
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    BEGIN
      select DocNumber 
      into new$AdjustmentDocNumber         from Agreements
      where ID=new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) or (new$rnYear is not null) or (new$rnNumber is not null)) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC,
    TREASURYSUPPORTID,
    ISKS,
    ROOTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC,
    new$TREASURYSUPPORTID,
    new$ISKS,
    new$ROOTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
  new$ISKS AGREEMENTS.ISKS%TYPE := :NEW.ISKS;
  new$ROOTDOC AGREEMENTS.ROOTDOC%TYPE := :NEW.ROOTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  DetCount$ NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID is not null) and (:old.rnClientID is null or new$rnClientID <> :old.rnClientID)) or
  ((new$rnYear is not null) and (:old.rnYear is null or new$rnYear <> :old.rnYear)) or
  ((new$rnNumber is not null) and (:old.rnNumber is null or new$rnNumber <> :old.rnNumber))) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    PURPORTDOC = new$PURPORTDOC,
    TREASURYSUPPORTID = new$TREASURYSUPPORTID,
    ISKS = new$ISKS,
    ROOTDOC = new$ROOTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER tr_agreements_bi
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
  new$ISKS AGREEMENTS.ISKS%TYPE := :NEW.ISKS;
  new$ROOTDOC AGREEMENTS.ROOTDOC%TYPE := :NEW.ROOTDOC;
--
  CountAcc$ NUMBER(10);
  Tmp1$ NUMBER(10);
  PreviousInner1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   14.00*/
  /*    -*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$IsKs is null) then 
    new$isks := 0;
  END IF;
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerNumber 
        into PreviousInner1$       from Agreements
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerNumber 
        into PreviousInner1$       from Agreements
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner1$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerNumber := PreviousInner1$;
      
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*       */
    select count(ID) 
    into Tmp1$         from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp1$ = 0) then 
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    BEGIN
      select DocNumber 
      into new$AdjustmentDocNumber         from Agreements
      where ID=new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) or (new$rnYear is not null) or (new$rnNumber is not null)) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT,
    PURPORTDOC,
    TREASURYSUPPORTID,
    ISKS,
    ROOTDOC
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT,
    new$PURPORTDOC,
    new$TREASURYSUPPORTID,
    new$ISKS,
    new$ROOTDOC);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_BU
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$TREASURYSUPPORTID AGREEMENTS.TREASURYSUPPORTID%TYPE := :NEW.TREASURYSUPPORTID;
  new$ISKS AGREEMENTS.ISKS%TYPE := :NEW.ISKS;
  new$ROOTDOC AGREEMENTS.ROOTDOC%TYPE := :NEW.ROOTDOC;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  DetCount1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   14.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;    
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  if (new$IsKs is null) then 
    new$isks := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount1$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount1$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.10.00.2
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$Accepted = 1) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Agreements
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*  ,     LastAccepted*/
  if ((:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1)) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID is not null) and (:old.rnClientID is null or new$rnClientID <> :old.rnClientID)) or
  ((new$rnYear is not null) and (:old.rnYear is null or new$rnYear <> :old.rnYear)) or
  ((new$rnNumber is not null) and (:old.rnNumber is null or new$rnNumber <> :old.rnNumber))) then
    RaiseException('ex_UsedOldFieldRNUM');
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT,
    PURPORTDOC = new$PURPORTDOC,
    TREASURYSUPPORTID = new$TREASURYSUPPORTID,
    ISKS = new$ISKS,
    ROOTDOC = new$ROOTDOC
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*     ,       */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 DISABLE
/
ALTER TABLE TB_BudNotify ADD (
  rootDoc NUMBER(10),/*    */
    CHECK((rootDoc<=2147483647)AND(rootDoc>-2147483648)),
  InnerNumber NUMBER(10),/*   */
    CHECK((InnerNumber<=2147483647)AND(InnerNumber>-2147483648)),
  AdjustmentNumber NUMBER(10),/*   */
    CHECK((AdjustmentNumber<=2147483647)AND(AdjustmentNumber>-2147483648)),
  AdjustmentRef NUMBER(10),/*      */
    CHECK((AdjustmentRef<=2147483647)AND(AdjustmentRef>-2147483648)),
  SummaYear1 NUMBER(15,2) default 0,
  SummaYear2 NUMBER(15,2) default 0,
  SummaYear3 NUMBER(15,2) default 0,
  SummaYear4 NUMBER(15,2) default 0,
  SummaOtherYears NUMBER(15,2) default 0
)
/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 ENABLE
/

CREATE OR REPLACE VIEW BudNotify (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  ANUMBER,
  STARTDATE,
  ENDDATE,
  ROOTDOC,
  INNERNUMBER,
  ADJUSTMENTNUMBER,
  ADJUSTMENTREF,
  SUMMAYEAR1,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR4,
  SUMMAOTHERYEARS)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER,
    STARTDATE,
    ENDDATE,
    ROOTDOC,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    ADJUSTMENTREF,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR4,
    SUMMAOTHERYEARS
  FROM TB_BudNotify
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
  new$ROOTDOC BUDNOTIFY.ROOTDOC%TYPE := :NEW.ROOTDOC;
  new$INNERNUMBER BUDNOTIFY.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER BUDNOTIFY.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ADJUSTMENTREF BUDNOTIFY.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAYEAR1 BUDNOTIFY.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 BUDNOTIFY.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 BUDNOTIFY.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR4 BUDNOTIFY.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS BUDNOTIFY.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
--
  UseFax$ NUMBER(10);
  PDTCode$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then 
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then 
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then 
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if (new$PlanDocType is not null) then
    BEGIN
      select
      pdt.Code
      into PDTCode$     from
      PlanDocType pdt
      where
      (pdt.ID = new$PlanDocType)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((PDTCode$ > 99)and(PDTCode$ < 200)) then
      new$AType := 0;
          
    else
      new$AType := 1;
      
    END IF;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  if (new$PROGINDEX is null) then 
    new$PROGINDEX := 32;
  END IF;
  if (new$BA_LBO_Flag is null) then 
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then 
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19,UseFax$);
    IF ((new$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      new$BidNumber:= new$ANumber;
    END IF;
    new$FaxDocCount:= 0;

  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER,
    STARTDATE,
    ENDDATE,
    ROOTDOC,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    ADJUSTMENTREF,
    SUMMAYEAR1,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR4,
    SUMMAOTHERYEARS
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$ANUMBER,
    new$STARTDATE,
    new$ENDDATE,
    new$ROOTDOC,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$ADJUSTMENTREF,
    new$SUMMAYEAR1,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
  new$ROOTDOC BUDNOTIFY.ROOTDOC%TYPE := :NEW.ROOTDOC;
  new$INNERNUMBER BUDNOTIFY.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER BUDNOTIFY.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ADJUSTMENTREF BUDNOTIFY.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAYEAR1 BUDNOTIFY.SUMMAYEAR1%TYPE := :NEW.SUMMAYEAR1;
  new$SUMMAYEAR2 BUDNOTIFY.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 BUDNOTIFY.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR4 BUDNOTIFY.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS BUDNOTIFY.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
--
  IsReject$ NUMBER(10);
  DetCount1$ NUMBER(10);
  PDTCode$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then 
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then 
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then 
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then 
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is not null) and (new$PlanDocType <> :old.PlanDocType)) then
    BEGIN
      select
      pdt.Code
      into PDTCode$     from
      PlanDocType pdt
      where
      (pdt.ID = new$PlanDocType)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((PDTCode$ > 99)and(PDTCode$ < 200)) then
      new$AType := 0;
          
    else
      new$AType := 1;
      
    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount1$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');        
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  if (new$PROGINDEX is null) then 
    new$PROGINDEX := 32;
  END IF;
  if (new$BA_LBO_Flag is null) then 
    new$BA_LBO_Flag := 0;  
  END IF;
  if (new$KPPeriod is null) then 
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    ANUMBER = new$ANUMBER,
    STARTDATE = new$STARTDATE,
    ENDDATE = new$ENDDATE,
    ROOTDOC = new$ROOTDOC,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAYEAR1 = new$SUMMAYEAR1,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
ALTER TABLE TB_BudNotify ADD (
  constraint CHECK_BudNotify_CLSNUMBER unique (InnerNumber, AdjustmentNumber),
  constraint FK_BudNotify_BOREF foreign key(rootDoc) references TB_Agreements(ID)
)
/
CREATE INDEX FK_BudNotify_BOREF ON TB_BudNotify(rootDoc)
/
ALTER TABLE TB_FacialFinCaption ADD (
  DestTargetCls NUMBER(10),
    CHECK((DestTargetCls<=2147483647)AND(DestTargetCls>-2147483648))
)
/

CREATE OR REPLACE VIEW FacialFinCaption (
  ID,
  DOCNUMBER,
  SOURCEDOCNUM,
  PAYDATE,
  ACCEPTDATE,
  DOCUMENTDATE,
  REESTRDATE,
  CREDIT,
  SOURCEACCOUNT,
  SOURCEFACIALACC_CLS,
  DESTACCOUNT,
  DESTFACIALACC_CLS,
  PROGINDEX,
  ARHIVEDOC,
  PAYSYMBOLCLS,
  PAYTYPECLS,
  NOTE,
  PERIOD,
  PAYPRIORITY,
  TYPEOPERATIONCLS,
  BUHPAYMENTCLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  RECORDINDEX,
  SENDERID,
  SENDERRECORDID,
  REESTR_REF,
  REJECT_CLS,
  CLIENTBANKNUMBER,
  CRYPTOSTATUS,
  TRUSTNUMBER,
  LINKEDDOCUMENT,
  BNKRECORDID,
  SUBPROGINDEX,
  DOCUMENTSTATE,
  USERSVISA,
  TREASUARYDOCSTATECLS,
  DEPARTMENTCLS,
  NDS,
  TAXNOTE,
  MANAGERBID,
  BIDNUMBER,
  GROUPID,
  GROUPSUMMA,
  DOCSTATEREF,
  LASTEXTRCHANGE,
  STIMATEID,
  INTEGRATEDDOCREF,
  REQUESTNUMBER,
  REQUESTDATE,
  RVERSION,
  FEDERALFUNDSREF,
  ELDOCREF,
  BUHOPERATIONCLS,
  CLSTYPE,
  OPERATIONDIRECTION,
  SOURCETYPE,
  DESTTYPE,
  CARDNUMBER,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  CASHIERPERSONALINFO,
  BIDDATE,
  CARDREF,
  SOURCESTOREDPAYMENTPROPS,
  DESTSTOREDPAYMENTPROPS,
  STOREDPAYMENTNOTE,
  DOCCHANGEDATE,
  UINCODE,
  DOCOSN,
  SIGNERS,
  DESTCLSTYPE,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  AUTOSANCTION,
  STOREDPAYMENTCONTENT,
  REJECTCAUSE,
  CODEPURPOSE,
  DOCORDERREF,
  DOCTYPE,
  DESTTARGETCLS)
AS
  SELECT
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE,
    DOCORDERREF,
    DOCTYPE,
    DESTTARGETCLS
  FROM TB_FacialFinCaption
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_ID
  INSTEAD OF DELETE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  reestrAccepted1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_FACIALFINCAPTION_BD)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

 /*       */
  DELETE FROM FacialFinDetail
        WHERE (RecordIndex = :OLD.ID);

-- - - - - - - - - - - - -
-- BD_5 (TR_FACIALFINCAPTION_BD_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((:old.progIndex = 63) or (:old.progIndex = 64) or
  (:old.progIndex = 68) or (:old.progIndex = 70))
  and (:old.REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = :old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrDelete');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BD_6 (TR_FACIALFINCAPTION_BD_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('ex_CannotChangeSended');
  else
    delete from PayDocExchange where paydocref = :old.id;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_70 (TR_FACIALFINCAPTION_AD_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

--   /     
  IF (:OLD.SubProgIndex = 416) THEN
    UPDATE Guarantee
       SET SubRecordIndex = NULL,
           SubProgIndex = 0
     WHERE SubRecordIndex = :OLD.ID;
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_FACIALFINCAPTION_AD_200)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory
    where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINCAPTION_AD_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex, Summa)
    VALUES (23, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_II
  INSTEAD OF INSERT
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DESTTARGETCLS FACIALFINCAPTION.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  reestrAccepted1$ NUMBER(10);
  PIndex$ NUMBER(10);
  pdt1$ NUMBER(10);
  pdt$ NUMBER(10);
  DocNumber$ NUMBER(10);
  CmpFacialAcc_Cls$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINCAPTION_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$OperationDirection = 0) then
    new$SourceType := 1;
    new$DestType := 1;
     
  else
    if (new$OperationDirection = 1) then
      new$SourceType := 1;
      new$DestType := -1;
         
    else
      if (new$OperationDirection = 2) then
        new$SourceType := -1;
        new$DestType := 1;
             
      else
        new$SourceType := -1;
        new$DestType := -1;
             
      END IF;
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
           
    else 
      new$DepartmentCls:= DocNumber$;
       
    END IF;
  END IF;
   
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    PIndex$ := new$ProgIndex;
    if (PIndex$=60) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    .*/
    END IF;
    if (PIndex$=61) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*       */
    END IF;
    if (PIndex$=62) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    */
    END IF;
    if (PIndex$=63) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*     */
    END IF;
    if (PIndex$=64) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=65) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*  , */
    END IF;
    if (PIndex$=66) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   ,  - */
    END IF;
    if (PIndex$=67) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*    */
    END IF;
    if (PIndex$=68) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*   \ */
    END IF;
    if (PIndex$=69) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=70) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   \ */
    END IF;
    if (PIndex$=71) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*    \ */
    END IF;
    if (PIndex$=73) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*   */
    END IF;
    if (PIndex$=75) then 
      CmpFacialAcc_Cls$ := new$DestFacialAcc_CLS;           /*  */
    END IF;
    if (PIndex$=76) then 
      CmpFacialAcc_Cls$ := new$SourceFacialAcc_CLS;         /*  */
    END IF;
    BEGIN

      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = CmpFacialAcc_Cls$

      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null )) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_1 (TR_FACIALFINCAPTION_BI_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_FACIALFINCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (((new$progIndex = 63) or (new$progIndex = 64) or
  (new$progIndex = 68) or (new$progIndex = 70))
  and (new$REESTR_REF is not null)) then
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id = new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrInsert');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinCaption_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_16 (TR_FACIALFINCAPTION_BI_16)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      .    FacialFinCaption
             */
   IF (new$Reestr_ref IS NULL) THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_FACIALFINCAPTION_BI_430)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt$ := 304;
    END IF;
    IF (new$BidNumber IS NULL) THEN
      new$BidNumber:= new$DocNumber;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINCAPTION_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINCAPTION (
    ID,
    DOCNUMBER,
    SOURCEDOCNUM,
    PAYDATE,
    ACCEPTDATE,
    DOCUMENTDATE,
    REESTRDATE,
    CREDIT,
    SOURCEACCOUNT,
    SOURCEFACIALACC_CLS,
    DESTACCOUNT,
    DESTFACIALACC_CLS,
    PROGINDEX,
    ARHIVEDOC,
    PAYSYMBOLCLS,
    PAYTYPECLS,
    NOTE,
    PERIOD,
    PAYPRIORITY,
    TYPEOPERATIONCLS,
    BUHPAYMENTCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    RECORDINDEX,
    SENDERID,
    SENDERRECORDID,
    REESTR_REF,
    REJECT_CLS,
    CLIENTBANKNUMBER,
    CRYPTOSTATUS,
    TRUSTNUMBER,
    LINKEDDOCUMENT,
    BNKRECORDID,
    SUBPROGINDEX,
    DOCUMENTSTATE,
    USERSVISA,
    TREASUARYDOCSTATECLS,
    DEPARTMENTCLS,
    NDS,
    TAXNOTE,
    MANAGERBID,
    BIDNUMBER,
    GROUPID,
    GROUPSUMMA,
    DOCSTATEREF,
    LASTEXTRCHANGE,
    STIMATEID,
    INTEGRATEDDOCREF,
    REQUESTNUMBER,
    REQUESTDATE,
    RVERSION,
    FEDERALFUNDSREF,
    ELDOCREF,
    BUHOPERATIONCLS,
    CLSTYPE,
    OPERATIONDIRECTION,
    SOURCETYPE,
    DESTTYPE,
    CARDNUMBER,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO,
    BIDDATE,
    CARDREF,
    SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE,
    DOCCHANGEDATE,
    UINCODE,
    DOCOSN,
    SIGNERS,
    DESTCLSTYPE,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    AUTOSANCTION,
    STOREDPAYMENTCONTENT,
    REJECTCAUSE,
    CODEPURPOSE,
    DOCORDERREF,
    DOCTYPE,
    DESTTARGETCLS
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$SOURCEDOCNUM,
    new$PAYDATE,
    new$ACCEPTDATE,
    new$DOCUMENTDATE,
    new$REESTRDATE,
    new$CREDIT,
    new$SOURCEACCOUNT,
    new$SOURCEFACIALACC_CLS,
    new$DESTACCOUNT,
    new$DESTFACIALACC_CLS,
    new$PROGINDEX,
    new$ARHIVEDOC,
    new$PAYSYMBOLCLS,
    new$PAYTYPECLS,
    new$NOTE,
    new$PERIOD,
    new$PAYPRIORITY,
    new$TYPEOPERATIONCLS,
    new$BUHPAYMENTCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$RECORDINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REESTR_REF,
    new$REJECT_CLS,
    new$CLIENTBANKNUMBER,
    new$CRYPTOSTATUS,
    new$TRUSTNUMBER,
    new$LINKEDDOCUMENT,
    new$BNKRECORDID,
    new$SUBPROGINDEX,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$TREASUARYDOCSTATECLS,
    new$DEPARTMENTCLS,
    new$NDS,
    new$TAXNOTE,
    new$MANAGERBID,
    new$BIDNUMBER,
    new$GROUPID,
    new$GROUPSUMMA,
    new$DOCSTATEREF,
    new$LASTEXTRCHANGE,
    new$STIMATEID,
    new$INTEGRATEDDOCREF,
    new$REQUESTNUMBER,
    new$REQUESTDATE,
    new$RVERSION,
    new$FEDERALFUNDSREF,
    new$ELDOCREF,
    new$BUHOPERATIONCLS,
    new$CLSTYPE,
    new$OPERATIONDIRECTION,
    new$SOURCETYPE,
    new$DESTTYPE,
    new$CARDNUMBER,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$CASHIERPERSONALINFO,
    new$BIDDATE,
    new$CARDREF,
    new$SOURCESTOREDPAYMENTPROPS,
    new$DESTSTOREDPAYMENTPROPS,
    new$STOREDPAYMENTNOTE,
    new$DOCCHANGEDATE,
    new$UINCODE,
    new$DOCOSN,
    new$SIGNERS,
    new$DESTCLSTYPE,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$AUTOSANCTION,
    new$STOREDPAYMENTCONTENT,
    new$REJECTCAUSE,
    new$CODEPURPOSE,
    new$DOCORDERREF,
    new$DOCTYPE,
    new$DESTTARGETCLS);

-- - - - - - - - - - - - -
-- AI_430 (TR_FACIALFINCAPTION_AI_430)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    IF (new$progindex = 63) THEN 
      pdt1$ := 302;
    END IF;
    IF (new$progindex = 66) THEN 
      pdt1$ := 301;
    END IF;
    IF (new$progindex = 64) THEN 
      pdt1$ := 304;
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINCAPTION_AI_500)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
     WHERE (TableID = 23) AND (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINCAPTION_IU
  INSTEAD OF UPDATE
  ON FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  new$ID FACIALFINCAPTION.ID%TYPE := :NEW.ID;
  new$DOCNUMBER FACIALFINCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SOURCEDOCNUM FACIALFINCAPTION.SOURCEDOCNUM%TYPE := :NEW.SOURCEDOCNUM;
  new$PAYDATE FACIALFINCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
  new$ACCEPTDATE FACIALFINCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCUMENTDATE FACIALFINCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$REESTRDATE FACIALFINCAPTION.REESTRDATE%TYPE := :NEW.REESTRDATE;
  new$CREDIT FACIALFINCAPTION.CREDIT%TYPE := :NEW.CREDIT;
  new$SOURCEACCOUNT FACIALFINCAPTION.SOURCEACCOUNT%TYPE := :NEW.SOURCEACCOUNT;
  new$SOURCEFACIALACC_CLS FACIALFINCAPTION.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$DESTACCOUNT FACIALFINCAPTION.DESTACCOUNT%TYPE := :NEW.DESTACCOUNT;
  new$DESTFACIALACC_CLS FACIALFINCAPTION.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$PROGINDEX FACIALFINCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$ARHIVEDOC FACIALFINCAPTION.ARHIVEDOC%TYPE := :NEW.ARHIVEDOC;
  new$PAYSYMBOLCLS FACIALFINCAPTION.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$PAYTYPECLS FACIALFINCAPTION.PAYTYPECLS%TYPE := :NEW.PAYTYPECLS;
  new$NOTE FACIALFINCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$PERIOD FACIALFINCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$PAYPRIORITY FACIALFINCAPTION.PAYPRIORITY%TYPE := :NEW.PAYPRIORITY;
  new$TYPEOPERATIONCLS FACIALFINCAPTION.TYPEOPERATIONCLS%TYPE := :NEW.TYPEOPERATIONCLS;
  new$BUHPAYMENTCLS FACIALFINCAPTION.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$CREATERUSER FACIALFINCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF FACIALFINCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECORDINDEX FACIALFINCAPTION.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$SENDERID FACIALFINCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REESTR_REF FACIALFINCAPTION.REESTR_REF%TYPE := :NEW.REESTR_REF;
  new$REJECT_CLS FACIALFINCAPTION.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$CLIENTBANKNUMBER FACIALFINCAPTION.CLIENTBANKNUMBER%TYPE := :NEW.CLIENTBANKNUMBER;
  new$CRYPTOSTATUS FACIALFINCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$TRUSTNUMBER FACIALFINCAPTION.TRUSTNUMBER%TYPE := :NEW.TRUSTNUMBER;
  new$LINKEDDOCUMENT FACIALFINCAPTION.LINKEDDOCUMENT%TYPE := :NEW.LINKEDDOCUMENT;
  new$BNKRECORDID FACIALFINCAPTION.BNKRECORDID%TYPE := :NEW.BNKRECORDID;
  new$SUBPROGINDEX FACIALFINCAPTION.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$DOCUMENTSTATE FACIALFINCAPTION.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA FACIALFINCAPTION.USERSVISA%TYPE := :NEW.USERSVISA;
  new$TREASUARYDOCSTATECLS FACIALFINCAPTION.TREASUARYDOCSTATECLS%TYPE := :NEW.TREASUARYDOCSTATECLS;
  new$DEPARTMENTCLS FACIALFINCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$NDS FACIALFINCAPTION.NDS%TYPE := :NEW.NDS;
  new$TAXNOTE FACIALFINCAPTION.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$MANAGERBID FACIALFINCAPTION.MANAGERBID%TYPE := :NEW.MANAGERBID;
  new$BIDNUMBER FACIALFINCAPTION.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$GROUPID FACIALFINCAPTION.GROUPID%TYPE := :NEW.GROUPID;
  new$GROUPSUMMA FACIALFINCAPTION.GROUPSUMMA%TYPE := :NEW.GROUPSUMMA;
  new$DOCSTATEREF FACIALFINCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$LASTEXTRCHANGE FACIALFINCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$STIMATEID FACIALFINCAPTION.STIMATEID%TYPE := :NEW.STIMATEID;
  new$INTEGRATEDDOCREF FACIALFINCAPTION.INTEGRATEDDOCREF%TYPE := :NEW.INTEGRATEDDOCREF;
  new$REQUESTNUMBER FACIALFINCAPTION.REQUESTNUMBER%TYPE := :NEW.REQUESTNUMBER;
  new$REQUESTDATE FACIALFINCAPTION.REQUESTDATE%TYPE := :NEW.REQUESTDATE;
  new$RVERSION FACIALFINCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$FEDERALFUNDSREF FACIALFINCAPTION.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$ELDOCREF FACIALFINCAPTION.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$BUHOPERATIONCLS FACIALFINCAPTION.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CLSTYPE FACIALFINCAPTION.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$OPERATIONDIRECTION FACIALFINCAPTION.OPERATIONDIRECTION%TYPE := :NEW.OPERATIONDIRECTION;
  new$SOURCETYPE FACIALFINCAPTION.SOURCETYPE%TYPE := :NEW.SOURCETYPE;
  new$DESTTYPE FACIALFINCAPTION.DESTTYPE%TYPE := :NEW.DESTTYPE;
  new$CARDNUMBER FACIALFINCAPTION.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$ISBLOCKED FACIALFINCAPTION.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINCAPTION.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINCAPTION.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINCAPTION.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$CASHIERPERSONALINFO FACIALFINCAPTION.CASHIERPERSONALINFO%TYPE := :NEW.CASHIERPERSONALINFO;
  new$BIDDATE FACIALFINCAPTION.BIDDATE%TYPE := :NEW.BIDDATE;
  new$CARDREF FACIALFINCAPTION.CARDREF%TYPE := :NEW.CARDREF;
  new$SOURCESTOREDPAYMENTPROPS FACIALFINCAPTION.SOURCESTOREDPAYMENTPROPS%TYPE := :NEW.SOURCESTOREDPAYMENTPROPS;
  new$DESTSTOREDPAYMENTPROPS FACIALFINCAPTION.DESTSTOREDPAYMENTPROPS%TYPE := :NEW.DESTSTOREDPAYMENTPROPS;
  new$STOREDPAYMENTNOTE FACIALFINCAPTION.STOREDPAYMENTNOTE%TYPE := :NEW.STOREDPAYMENTNOTE;
  new$DOCCHANGEDATE FACIALFINCAPTION.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$UINCODE FACIALFINCAPTION.UINCODE%TYPE := :NEW.UINCODE;
  new$DOCOSN FACIALFINCAPTION.DOCOSN%TYPE := :NEW.DOCOSN;
  new$SIGNERS FACIALFINCAPTION.SIGNERS%TYPE := :NEW.SIGNERS;
  new$DESTCLSTYPE FACIALFINCAPTION.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SENDERIDKEY FACIALFINCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$AUTOSANCTION FACIALFINCAPTION.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$STOREDPAYMENTCONTENT FACIALFINCAPTION.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$REJECTCAUSE FACIALFINCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CODEPURPOSE FACIALFINCAPTION.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$DOCORDERREF FACIALFINCAPTION.DOCORDERREF%TYPE := :NEW.DOCORDERREF;
  new$DOCTYPE FACIALFINCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DESTTARGETCLS FACIALFINCAPTION.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CNT$1 NUMBER(10);
  reestrAccepted1$ NUMBER(10);
  IsReject1$ NUMBER(10);
  Dummy$ NUMBER(10);
  ParentAcceptDate$ NUMBER;
  ParentReject_CLS$ NUMBER(10);
  ParentRejectCause$ VARCHAR2(255);
  ParentTREASUARYDOCSTATECLS$ NUMBER(10);
  ParentDOCSTATEREF$ NUMBER(10);
  ParentSOURCEACCOUNT$ NUMBER(10);
  ParentDESTACCOUNT$ NUMBER(10);
  ParentREESTR_REF$ NUMBER(10);
  DocNumber$ NUMBER(10);
  DetCount$ NUMBER(10);
  SourcePromiseAccepted$ NUMBER(10);
  DestPromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINCAPTION_BU)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  if (new$SenderID is not null) then 
    if (new$BidNumber is null) then
      new$BidNumber:= new$DocNumber;
      
    END IF;
  END IF;
  if (new$credit is null)then 
    new$credit:= 0;
  END IF;
  if (new$ArhiveDoc is null) then 
    new$ArhiveDoc:= 0;
  END IF;
  if (new$PayTypeCls is null) then 
    new$PayTypeCls:= 0;
  END IF;
  if (new$BuhPaymentCls is null) then 
    new$BuhPaymentCls:= 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$ClsType is null) then 
    new$ClsType := 0;
  END IF;
  if (new$DestClsType is null) then 
    new$DestClsType := new$ClsType;
  END IF;
  if (new$SourceFacialAcc_CLS is null) then 
    new$SourceFacialAcc_CLS:= 0;
  END IF;
  if (new$DestFacialAcc_CLS is null) then 
    new$DestFacialAcc_CLS:= 0;
  END IF;
  if (new$OperationDirection is null) then 
    new$OperationDirection := 0;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$OperationDirection <> :old.OperationDirection) then
    if (new$OperationDirection = 0) then
      new$SourceType := 1;
      new$DestType := 1;
          
    else
      if (new$OperationDirection = 1) then
        new$SourceType := 1;
        new$DestType := -1;
              
      else
        if (new$OperationDirection = 2) then
          new$SourceType := -1;
          new$DestType := 1;
                  
        else
          new$SourceType := -1;
          new$DestType := -1;
                  
        END IF;
      END IF;  
    END IF;
  END IF;
  if (new$DepartmentCls is null) then
    GetIntConst(30, 20,DocNumber$); 
    if (DocNumber$ is null) then 
      new$DepartmentCls:= 0;
          
    else 
      new$DepartmentCls:= DocNumber$;
      
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from FacialFinDetail where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_Cls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_1 (TR_FACIALFINCAPTION_BU_1)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --   -     
   IF (new$GroupID IS NULL) THEN new$GroupID := new$ID; END IF;
   IF (new$GroupSumma IS NULL) THEN new$GroupSumma := 0; END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_FACIALFINCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (not (    ((new$progindex = 63) or (new$progindex = 64) or (new$progindex = 68) or (new$progindex = 70))
  and (   (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001))
  or (new$sourcefacialacc_cls <> :old.sourcefacialacc_cls)
  or (
  ((new$sourceaccount is null) and (:old.sourceaccount is not null)) or
  ((new$sourceaccount is not null) and (:old.sourceaccount is null)) or
  ((new$sourceaccount <> :old.sourceaccount ) and (:old.sourceaccount is not null) and (new$sourceaccount is not null))
  )
  or (
  ((new$destaccount is null) and (:old.destaccount is not null)) or
  ((new$destaccount is not null) and (:old.destaccount is null)) or
  ((new$destaccount <> :old.destaccount ) and (:old.destaccount is not null) and (new$destaccount is not null))
  )
  or (    (:old.reestr_ref is null)
  and (new$reestr_ref is not null)
  )
  or (    (:old.reestr_ref is not null)
  and (new$reestr_ref is null)
  )
  or (:old.reestr_ref <> new$reestr_ref)
  )
  )
  )
  then /*      NULL */
    reestrAccepted1$ := 0;  /*   IB 4.2 */

  else
    BEGIN
      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=new$REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
    BEGIN

      select accepted     into reestrAccepted1$ from
      FacialFinReestr
      where
      id=:old.REESTR_REF
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (reestrAccepted1$ = 1) then
      RaiseException('ex_AcceptedReestrUpdate');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_6 (TR_FACIALFINCAPTION_BU_6)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (:old.ProgIndex in(63,68,70)) then /*    */
    SELECT COUNT(id ) INTO CNT$1
    from paydocexchange where ((paydocref=:old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      if(/* (new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
      (new$SOURCEDOCNUM<>:old.SOURCEDOCNUM) or ((new$SOURCEDOCNUM is NULL)and(not :old.SOURCEDOCNUM is NULL)) or ((:old.SOURCEDOCNUM is NULL)and(not new$SOURCEDOCNUM is NULL)) or
      (new$PAYDATE<>:old.PAYDATE) or ((new$PAYDATE is NULL)and(not :old.PAYDATE is NULL)) or ((:old.PAYDATE is NULL)and(not new$PAYDATE is NULL))or
      /* (new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
      (new$REESTRDATE<>:old.REESTRDATE) or ((new$REESTRDATE is NULL)and(not :old.REESTRDATE is NULL)) or ((:old.REESTRDATE is NULL)and(not new$REESTRDATE is NULL))or
      (((new$credit - :old.credit)>0.001)or((new$credit - :old.credit)<-0.001)) or
      (new$SOURCEACCOUNT<>:old.SOURCEACCOUNT) or
      (new$DESTACCOUNT<>:old.DESTACCOUNT) or
      (new$PAYTYPECLS<>:old.PAYTYPECLS) or
      (new$NOTE<>:old.NOTE) or  ((new$NOTE is NULL)and(not :old.NOTE is NULL)) or ((:old.NOTE is NULL)and(not new$NOTE is NULL))or
      (new$PAYPRIORITY<>:old.PAYPRIORITY) or ((new$PAYPRIORITY is NULL)and(not :old.PAYPRIORITY is NULL)) or ((:old.PAYPRIORITY is NULL)and(not new$PAYPRIORITY is NULL))or
      (new$REESTR_REF<>:old.REESTR_REF) or ((new$REESTR_REF is NULL)and(not :old.REESTR_REF is NULL)) or ((:old.REESTR_REF is NULL)and(not new$REESTR_REF is NULL))or
      (new$NDS<>:old.NDS) or ((new$NDS is NULL)and(not :old.NDS is NULL)) or ((:old.NDS is NULL)and(not new$NDS is NULL))or
      (new$TAXNOTE<>:old.TAXNOTE) or ((new$TAXNOTE is NULL)and(not :old.TAXNOTE is NULL)) or ((:old.TAXNOTE is NULL)and(not new$TAXNOTE is NULL)) )then
        RaiseException('ex_CannotChangeSended');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_FACIALFINCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$IntegratedDocRef is not null) then
    /*           ,       */
    /*    */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      new$AcceptDate := :old.AcceptDate;

    Else
      BEGIN
        select
        fc.AcceptDate, fc.Reject_CLS, fc.RejectCause, fc.TREASUARYDOCSTATECLS, fc.DOCSTATEREF,
        fc.REESTR_REF,fc.SOURCEACCOUNT, fc.DESTACCOUNT
        into
        ParentAcceptDate$, ParentReject_CLS$, ParentRejectCause$, ParentTREASUARYDOCSTATECLS$,
        ParentDOCSTATEREF$,ParentREESTR_REF$,ParentSOURCEACCOUNT$,ParentDESTACCOUNT$       from
        FacialFinCaption fc
        where
        (fc.id = new$IntegratedDocRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (((new$AcceptDate = ParentAcceptDate$)or((new$AcceptDate is null)and(ParentAcceptDate$ is null)))
      and((new$Reject_CLS = ParentReject_CLS$)or((new$Reject_CLS is null)and(ParentReject_CLS$ is null)))
      and((new$RejectCause = ParentRejectCause$)or((new$RejectCause is null)and(ParentRejectCause$ is null)))
      and((new$TREASUARYDOCSTATECLS = ParentTREASUARYDOCSTATECLS$)or((new$TREASUARYDOCSTATECLS is null)and(ParentTREASUARYDOCSTATECLS$ is null)))
      and((new$DOCSTATEREF = ParentDOCSTATEREF$)or((new$DOCSTATEREF is null)and(ParentDOCSTATEREF$ is null)))
      and((new$REESTR_REF = ParentREESTR_REF$)or((new$REESTR_REF is NULL)and(ParentREESTR_REF$ is NULL)))
      and(new$SOURCEACCOUNT = ParentSOURCEACCOUNT$)
      and(new$DESTACCOUNT = ParentDESTACCOUNT$)
      ) then
        new$AcceptDate := ParentAcceptDate$;

      Else
        RaiseException('EX_CANNOTUPDATECHILDDOC');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_32 (TR_FACIALFINCAPTION_BU_32)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$Reestr_ref IS NULL)    /*    select ,  */
                              THEN
      new$SourceDocNum := '';
      new$ReestrDate := NULL;
   ELSIF (    (new$Reestr_ref = :OLD.Reestr_ref)
          AND (new$SourceDocNum = :OLD.SourceDocNum)
          AND (new$ReestrDate = :OLD.ReestrDate)
         ) THEN
/*          */
      NULL;
   ELSE
      BEGIN
         SELECT ffr.ReestrNumber, ffr.ReestrDate
           INTO new$SourceDocNum, new$ReestrDate
           FROM FacialFinReestr ffr
          WHERE ffr.ID = new$Reestr_ref;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            new$SourceDocNum := NULL;
            new$ReestrDate := NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BU_60 (T_FACIALFINCAPTION_BU_60)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF ((new$progindex = 60) AND (new$Credit <> :OLD.Credit)) THEN
      UPDATE FacialFinDetail
         SET Credit = new$Credit
       WHERE (RecordIndex = new$ID);
   END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_FACIALFINCAPTION_BU_70)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   --         
   IF (new$SubProgIndex = 416) THEN
      UPDATE Guarantee
         SET AcceptDate = new$AcceptDate
       WHERE SubRecordIndex = new$ID;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (T_FACIALFINCAPTION_BU_100)
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*   ,    */
   IF (    (   (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS)
            OR (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS)
           )
       AND ((new$SubProgIndex <> 1) OR (new$SubProgIndex IS NULL))
      ) THEN
      FOR R$ IN (SELECT ID, SourceFacialAcc_CLS, DestFacialAcc_CLS
                   FROM FacialFinDetail
                  WHERE RecordIndex = new$ID) LOOP
         IF (NOT (new$SourceFacialAcc_CLS = 0)) THEN
            SourceFacialAcc_CLS$ := new$SourceFacialAcc_CLS;
         ELSE
            SourceFacialAcc_CLS$ := R$.SourceFacialAcc_CLS;
         END IF;

         IF (NOT (new$DestFacialAcc_CLS = 0)) THEN
            DestFacialAcc_CLS$ := new$DestFacialAcc_CLS;
         ELSE
            DestFacialAcc_CLS$ := R$.DestFacialAcc_CLS;
         END IF;

         IF (:OLD.SourceFacialAcc_CLS <> new$SourceFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET SourceFacialAcc_CLS = SourceFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;

         IF (:OLD.DestFacialAcc_CLS <> new$DestFacialAcc_CLS) THEN
            UPDATE FacialFinDetail
               SET DestFacialAcc_CLS = DestFacialAcc_CLS$,
                   RVersion = -1
             WHERE (ID = R$.ID);
         END IF;
      END LOOP;
   END IF;

   /*    / , 
           .*/
  IF (((NEW$IsBlocked <> :OLD.IsBlocked) OR
      ((NEW$IsBlocked IS NULL) AND (:OLD.IsBlocked IS NOT NULL)) OR
      ((NEW$IsBlocked IS NOT NULL) AND (:OLD.IsBlocked IS NULL))
     ) OR
     ((NEW$BlockedCause <> :OLD.BlockedCause) OR
      ((NEW$BlockedCause IS NULL) AND (:OLD.BlockedCause IS NOT NULL)) OR
      ((NEW$BlockedCause IS NOT NULL) AND (:OLD.BlockedCause IS NULL))
     ) OR
     ((NEW$UnBlockedDate <> :OLD.UnBlockedDate) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedDate IS NOT NULL)) OR
      ((NEW$UnBlockedDate IS NOT NULL) AND (:OLD.UnBlockedDate IS NULL))
     ) OR
     ((NEW$UnBlockedCause <> :OLD.UnBlockedCause) OR
      ((NEW$UnBlockedDate IS NULL) AND (:OLD.UnBlockedCause IS NOT NULL)) OR
      ((NEW$UnBlockedCause IS NOT NULL) AND (:OLD.UnBlockedCause IS NULL))
     )) THEN
     UPDATE FacialFinDetail ffd
     SET ffd.IsBlocked = NEW$IsBlocked, ffd.BlockedCause = NEW$BlockedCause,
         ffd.UnBlockedDate = NEW$UnBlockedDate, ffd.UnBlockedCause = NEW$UnBlockedCause
     WHERE ffd.recordindex = NEW$ID;
  end if;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINCAPTION_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$reject_cls is null and :old.reject_cls is not null) then
    /*   ,        */
    FOR REC$1 IN (      select SourcePromise AS SourcePromise, SourceBudgetPromise AS SourceBudgetPromise, DestPromise AS DestPromise, DestBudgetPromise
     AS DestBudgetPromise       from FacialFinDetail
    where RecordIndex = new$id
    )
    LOOP
      if ((REC$1.SourcePromise is not null) or (REC$1.SourceBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into SourcePromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.SourcePromise  and InnerPromiseNum = REC$1.SourceBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      if ((REC$1.DestPromise is not null) or (REC$1.DestBudgetPromise is not null)) then
        BEGIN
          /*     */
          select Accepted         into DestPromiseAccepted$ from PaymentSchedule
          where ANumber = REC$1.DestPromise  and InnerPromiseNum = REC$1.DestBudgetPromise

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
          
      /*        */
      if (((REC$1.SourceBudgetPromise is not null) or (REC$1.DestBudgetPromise is not null))
      and ((SourcePromiseAccepted$ <> 1) or (DestPromiseAccepted$ <> 1)))
      then
        RaiseException('Ex_BP_Rejected');    
      END IF;
    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINCAPTION_BU_210)
-- Create 27.08.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   /*      */
   IF (new$DOCSTATEREF <> :OLD.DOCSTATEREF) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DOCSTATEREF, new$DOCSTATEREF
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (T_FACIALFINCAPTION_BU_300)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  IsReject1$ := -1;
  if ((:old.Reject_CLS is null)and(new$Reject_CLS is not null)) then
    IsReject1$ := 1;

  else
    if ((:old.Reject_CLS is not null)and(new$Reject_CLS is null)) then
      IsReject1$ := 0;
    END IF;
  END IF;
  if (IsReject1$  <> -1) then
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID = new$ID;
    update LinkRecords set
    IsRejected = IsReject1$

    where
    ChildID in (select d.id from FacialFinDetail d where d.RecordIndex = new$id);

  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINCAPTION_BU_700)
-- Create 17.09.2004
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINCAPTION SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    SOURCEDOCNUM = new$SOURCEDOCNUM,
    PAYDATE = new$PAYDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    REESTRDATE = new$REESTRDATE,
    CREDIT = new$CREDIT,
    SOURCEACCOUNT = new$SOURCEACCOUNT,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    DESTACCOUNT = new$DESTACCOUNT,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    PROGINDEX = new$PROGINDEX,
    ARHIVEDOC = new$ARHIVEDOC,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    PAYTYPECLS = new$PAYTYPECLS,
    NOTE = new$NOTE,
    PERIOD = new$PERIOD,
    PAYPRIORITY = new$PAYPRIORITY,
    TYPEOPERATIONCLS = new$TYPEOPERATIONCLS,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    RECORDINDEX = new$RECORDINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REESTR_REF = new$REESTR_REF,
    REJECT_CLS = new$REJECT_CLS,
    CLIENTBANKNUMBER = new$CLIENTBANKNUMBER,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    TRUSTNUMBER = new$TRUSTNUMBER,
    LINKEDDOCUMENT = new$LINKEDDOCUMENT,
    BNKRECORDID = new$BNKRECORDID,
    SUBPROGINDEX = new$SUBPROGINDEX,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    NDS = new$NDS,
    TAXNOTE = new$TAXNOTE,
    MANAGERBID = new$MANAGERBID,
    BIDNUMBER = new$BIDNUMBER,
    GROUPID = new$GROUPID,
    GROUPSUMMA = new$GROUPSUMMA,
    DOCSTATEREF = new$DOCSTATEREF,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    STIMATEID = new$STIMATEID,
    INTEGRATEDDOCREF = new$INTEGRATEDDOCREF,
    REQUESTNUMBER = new$REQUESTNUMBER,
    REQUESTDATE = new$REQUESTDATE,
    RVERSION = new$RVERSION,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    ELDOCREF = new$ELDOCREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CLSTYPE = new$CLSTYPE,
    OPERATIONDIRECTION = new$OPERATIONDIRECTION,
    SOURCETYPE = new$SOURCETYPE,
    DESTTYPE = new$DESTTYPE,
    CARDNUMBER = new$CARDNUMBER,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    CASHIERPERSONALINFO = new$CASHIERPERSONALINFO,
    BIDDATE = new$BIDDATE,
    CARDREF = new$CARDREF,
    SOURCESTOREDPAYMENTPROPS = new$SOURCESTOREDPAYMENTPROPS,
    DESTSTOREDPAYMENTPROPS = new$DESTSTOREDPAYMENTPROPS,
    STOREDPAYMENTNOTE = new$STOREDPAYMENTNOTE,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    UINCODE = new$UINCODE,
    DOCOSN = new$DOCOSN,
    SIGNERS = new$SIGNERS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    AUTOSANCTION = new$AUTOSANCTION,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    REJECTCAUSE = new$REJECTCAUSE,
    CODEPURPOSE = new$CODEPURPOSE,
    DOCORDERREF = new$DOCORDERREF,
    DOCTYPE = new$DOCTYPE,
    DESTTARGETCLS = new$DESTTARGETCLS
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_FACIALFINCAPTION_AU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 72) then /*   */
    if (((new$AcceptDate = :old.AcceptDate)or((new$AcceptDate is null)and(:old.AcceptDate is null)))
    and((new$Reject_CLS = :old.Reject_CLS)or((new$Reject_CLS is null)and(:old.Reject_CLS is null)))
    and((new$RejectCause = :old.RejectCause)or((new$RejectCause is null)and(:old.RejectCause is null)))
    and((new$TREASUARYDOCSTATECLS = :old.TREASUARYDOCSTATECLS)or((new$TREASUARYDOCSTATECLS is null)and(:old.TREASUARYDOCSTATECLS is null)))
    and((new$DOCSTATEREF = :old.DOCSTATEREF)or((new$DOCSTATEREF is null)and(:old.DOCSTATEREF is null)))
    and((new$REESTR_REF = :old.REESTR_REF)or((new$REESTR_REF is NULL)and(:old.REESTR_REF is NULL)))
    and(new$SOURCEACCOUNT = :old.SOURCEACCOUNT)
    and(new$DESTACCOUNT = :old.DESTACCOUNT)
    ) then
      Dummy$ := 0;

    Else
      /*    ,      */
      update FacialFinCaption set
      AcceptDate = new$AcceptDate,
      Reject_CLS = new$Reject_CLS,
      RejectCause = new$RejectCause,
      TREASUARYDOCSTATECLS = new$TREASUARYDOCSTATECLS,
      DOCSTATEREF = new$DOCSTATEREF,
      REESTR_REF = new$REESTR_REF,
      SOURCEACCOUNT = new$SOURCEACCOUNT,
      DESTACCOUNT = new$DESTACCOUNT
      where
      IntegratedDocRef = new$id;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_300 (TR_FACIALFINCAPTION_AU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ,  ,     ,      */
  if ((new$AcceptDate <> :old.AcceptDate)or((new$AcceptDate is not null)and(:old.AcceptDate is null))
  or((new$AcceptDate is null)and(:old.AcceptDate is not null))) then
    update facialfindetail set
    AcceptDate = new$AcceptDate,
    RVersion = -1
    where
    (RecordIndex = new$id) and (Reject_cls is null);
  END IF;
    
  if ((new$Reject_cls <> :old.Reject_cls)or((new$Reject_cls is not null)and(:old.Reject_cls is null))
  or((new$Reject_cls is null)and(:old.Reject_cls is not null))) then
    update facialfindetail set
    Reject_cls = new$Reject_cls,
    AcceptDate = null,
    RVersion = -1
    where
    RecordIndex = new$id;    
  END IF;
    
  if ((new$RejectCause <> :old.RejectCause)or((new$RejectCause is not null)and(:old.RejectCause is null))
  or((new$RejectCause is null)and(:old.RejectCause is not null))) then
    update facialfindetail set
    RejectCause = new$RejectCause,
    RVersion = -1
    where
    RecordIndex = new$id;      
  END IF;
  if (new$BuhOperationCLS <> :old.BuhOperationCLS)  then
    update facialfindetail set
    BuhOperationCLS = new$BuhOperationCLS,
    RVersion = -1
    where
    RecordIndex = new$id;
  END IF;
  if ((new$ClsType <> :old.ClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceIFS = 0,
      DestIFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update facialfindetail set
      SourceKD = 0,
      DestKD = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update facialfindetail set
      SourceIFS = 0,
      DestIFS = 0,
      SourceKVSR = 0,
      SourceKFSR = 0,
      SourceKCSR = 0,
      SourceKVR = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
      
    END IF;
  END IF;
  if ((new$DestClsType <> :old.DestClsType)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$DestClsType = 0) then
      update facialfindetail set
      DestKD = 0,
      DestIFS = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 1) then
      update facialfindetail set
      DestKD = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
    END IF;
    if (new$DestClsType = 2) then
      update facialfindetail set
      DestIFS = 0,
      DestKVSR = 0,
      DestKFSR = 0,
      DestKCSR = 0,
      DestKVR = 0,
      DestClsType = new$DestClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(DestClsType=:old.DestClsType);
      
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 20.05.2005
-- - - - - - - - - - - - -

   IF (:NEW.ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (23, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
        WHERE (TableID = 23) AND (RecordId = :NEW.ID);
   END IF;

END;
/
commit work
/
ALTER TABLE TB_FacialAcc_Cls MODIFY(isKS NOT NULL)
/
ALTER TABLE TB_Agreements MODIFY(isKS NOT NULL)
/

-- #########################################################
-- #########################################################
-- Create_ClsKaznMaintenance.sql
-- #########################################################
-- #########################################################

/*    .*/
create table IncomeTargetFunds(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  Name VARCHAR2(1000) NOT NULL,/* */
  Code VARCHAR2(50) NOT NULL,/*     */
  BudgetRef NUMBER(10) NOT NULL,/* ,       */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  StartDate DATE,/*      */
  DeleteDate DATE,/*      */
  Note VARCHAR2(1000),/*  */
  ExtID VARCHAR2(50),/* UID     ,  GUID */
  ExtRootID VARCHAR2(50),/*   */
  ExtOwner VARCHAR2(50),/*   */
  ExtSyncDate DATE,/* ,  ,   */
  ExtVersion NUMBER(10),/*     */
    CHECK((ExtVersion<=2147483647)AND(ExtVersion>-2147483648)),
  ExtVersionDate DATE,/*     */
  CreateDate DATE NOT NULL,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,/*  */
  UpdateDate DATE NOT NULL,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,/*  */
  constraint ClsIncTargFINSour_PK_ID PRIMARY KEY (ID),
  constraint fk_ClsIncTargFINSour_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID)
)
/
CREATE INDEX fk_ClsIncTargFINSour_BudgetRef ON IncomeTargetFunds(BudgetRef)
/

CREATE INDEX IDX_ClsIncTargFINSour_EXTID ON IncomeTargetFunds (EXTID)
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_AD_500
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_AD
  AFTER DELETE
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_ClsIncTargFINSour_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98115,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_AI_500
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_AI
  AFTER INSERT
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_ClsIncTargFINSour_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98115) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_AU_500
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_AU
  AFTER UPDATE
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_ClsIncTargFINSour_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98115, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98115) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_BI_0
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_BI
  BEFORE INSERT
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsIncTargFINSour_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_BI_500
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_BI
  BEFORE INSERT
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsIncTargFINSour_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsIncTargFINSour_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_BU_0
CREATE OR REPLACE TRIGGER TR_IncomeTargetFunds_BU
  BEFORE UPDATE
  ON IncomeTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsIncTargFINSour_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsIncTargFINSour_BU_500
CREATE OR REPLACE TRIGGER TR_ClsIncTargFINSour_BU_500
  BEFORE UPDATE
  ON INCOMETARGETFUNDS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ClsIncTargFINSour_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on IncomeTargetFunds to BUDGET_USERS
/
commit work
/
/*    .*/
create table PayTargetFunds(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  Name VARCHAR2(1000) NOT NULL,/* */
  Code VARCHAR2(50) NOT NULL,/*    . */
  BudgetRef NUMBER(10) NOT NULL,/* ,       */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  StartDate DATE,/*      */
  DeleteDate DATE,/*      */
  Note VARCHAR2(1000),/*  */
  ExtID VARCHAR2(50),/* UID     ,  GUID */
  ExtRootID VARCHAR2(50),/*   */
  ExtOwner VARCHAR2(50),/*   */
  ExtSyncDate DATE,/* ,  ,   */
  ExtVersion NUMBER(10),/*     */
    CHECK((ExtVersion<=2147483647)AND(ExtVersion>-2147483648)),
  ExtVersionDate DATE,/*     */
  CreateDate DATE NOT NULL,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,/*  */
  UpdateDate DATE NOT NULL,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,/*  */
  constraint ClsDirecTargFunds_PK_ID PRIMARY KEY (ID),
  constraint fk_ClsDirecTargFunds_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID)
)
/
CREATE INDEX fk_ClsDirecTargFunds_BudgetRef ON PayTargetFunds(BudgetRef)
/
-- CREATE TRIGGER TR_PayTargetFunds_AD_500
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_AD
  AFTER DELETE
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_PayTargetFunds_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98116,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_AI_500
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_AI
  AFTER INSERT
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_PayTargetFunds_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98116) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_AU_500
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_AU
  AFTER UPDATE
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_PayTargetFunds_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98116, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98116) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_BI_0
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_BI
  BEFORE INSERT
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PayTargetFunds_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_BI_500
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_BI
  BEFORE INSERT
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PayTargetFunds_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PayTargetFunds_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_BU_0
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_BU
  BEFORE UPDATE
  ON PayTargetFunds
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PayTargetFunds_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_PayTargetFunds_BU_500
CREATE OR REPLACE TRIGGER TR_PayTargetFunds_BU_500
  BEFORE UPDATE
  ON PAYTARGETFUNDS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_PayTargetFunds_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on PayTargetFunds to BUDGET_USERS
/

commit work
/

/*      .*/
create table AnalyticalPartition(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  Code VARCHAR2(50) NOT NULL,/*    */
  Name VARCHAR2(1024) NOT NULL,/*  */
  FacialAcc_CLS NUMBER(10) NOT NULL,/*   */
    CHECK((FacialAcc_CLS<=2147483647)AND(FacialAcc_CLS>-2147483648)),
  rootDoc NUMBER(10),/*    */
    CHECK((rootDoc<=2147483647)AND(rootDoc>-2147483648)),
  BudgetRef NUMBER(10) NOT NULL,/* ,       */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  StartDate DATE,/*      */
  DeleteDate DATE,/*      */
  Note VARCHAR2(1000),/*  */
  ExtID VARCHAR2(50),/* UID     ,  GUID */
  ExtRootID VARCHAR2(50),/*   */
  ExtOwner VARCHAR2(50),/*   */
  ExtSyncDate DATE,/* ,  ,   */
  ExtVersion NUMBER(10),/*     */
    CHECK((ExtVersion<=2147483647)AND(ExtVersion>-2147483648)),
  ExtVersionDate DATE,/*     */
  CreateDate DATE NOT NULL,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,/*  */
  UpdateDate DATE NOT NULL,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,/*  */
  constraint AnalyticFacialCode_PK_ID PRIMARY KEY (ID),
  constraint fk_AFacialCode_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID)
)
/
CREATE INDEX fk_AFacialCode_BudgetRef ON AnalyticalPartition(BudgetRef)
/
-- CREATE TRIGGER TR_AnalyticalPartition_AD_500
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_AD
  AFTER DELETE
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_AnalyticalPartition_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98117,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_AI_500
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_AI
  AFTER INSERT
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_AnalyticalPartition_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98117) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_AU_500
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_AU
  AFTER UPDATE
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_AnalyticalPartition_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98117, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98117) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_BI_0
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_BI
  BEFORE INSERT
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AnalyticalPartition_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_BI_500
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_BI
  BEFORE INSERT
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AnalyticalPartition_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AnalyticalPartition_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_BU_0
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_BU
  BEFORE UPDATE
  ON AnalyticalPartition
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AnalyticalPartition_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_AnalyticalPartition_BU_500
CREATE OR REPLACE TRIGGER TR_AnalyticalPartition_BU_500
  BEFORE UPDATE
  ON ANALYTICALPARTITION
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_AnalyticalPartition_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on AnalyticalPartition to BUDGET_USERS
/
commit work
/
/*      */
ALTER TABLE BudgetData ADD (
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_BD_DestIncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_BD_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_BD_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_BD_DestIncTarFS ON BudgetData(IncomeTargetFunds)
/
CREATE INDEX FK_BD_DirectTarFunds ON BudgetData(PayTargetFunds)
/
CREATE INDEX FK_BD_AnalyticFC ON BudgetData(AnalyticalPartition)
/
ALTER TABLE TB_FacialFinDetail ADD (
  SourceIncomeTargetFunds NUMBER(10),
    CHECK((SourceIncomeTargetFunds<=2147483647)AND(SourceIncomeTargetFunds>-2147483648)),
  DestIncomeTargetFunds NUMBER(10),
    CHECK((DestIncomeTargetFunds<=2147483647)AND(DestIncomeTargetFunds>-2147483648)),
  SourcePayTargetFunds NUMBER(10),
    CHECK((SourcePayTargetFunds<=2147483647)AND(SourcePayTargetFunds>-2147483648)),
  DestPayTargetFunds NUMBER(10),
    CHECK((DestPayTargetFunds<=2147483647)AND(DestPayTargetFunds>-2147483648)),
  SourceAnalyticalPartition NUMBER(10),
    CHECK((SourceAnalyticalPartition<=2147483647)AND(SourceAnalyticalPartition>-2147483648)),
  DestAnalyticalPartition NUMBER(10),
    CHECK((DestAnalyticalPartition<=2147483647)AND(DestAnalyticalPartition>-2147483648)),
  constraint FK_FFD_SourIncTarFS foreign key (SourceIncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_FFD_DestIncTarFS foreign key (DestIncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_FFD_SourDirectTarFunds foreign key (SourcePayTargetFunds) references PayTargetFunds(ID),
  constraint FK_FFD_DestDirectTarFunds foreign key (DestPayTargetFunds) references PayTargetFunds(ID),
  constraint FK_FFD_SourAnalyticFC foreign key (SourceAnalyticalPartition) references AnalyticalPartition(ID),
  constraint FK_FFD_DestAnalyticFC foreign key (DestAnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_FFD_SourIncTarFS ON TB_FacialFinDetail(SourceIncomeTargetFunds)
/
CREATE INDEX FK_FFD_DestIncTarFS ON TB_FacialFinDetail(DestIncomeTargetFunds)
/
CREATE INDEX FK_FFD_SourDirectTarFunds ON TB_FacialFinDetail(SourcePayTargetFunds)
/
CREATE INDEX FK_FFD_DestDirectTarFunds ON TB_FacialFinDetail(DestPayTargetFunds)
/
CREATE INDEX FK_FFD_SourAnalyticFC ON TB_FacialFinDetail(SourceAnalyticalPartition)
/
CREATE INDEX FK_FFD_DestAnalyticFC ON TB_FacialFinDetail(DestAnalyticalPartition)
/

CREATE OR REPLACE VIEW FacialFinDetail (
  ID,
  SOURCEFACIALACC_CLS,
  SOURCEKVR,
  SOURCEKESR,
  DESTFACIALACC_CLS,
  DESTKVR,
  DESTKESR,
  BUDGETREF,
  CREDIT,
  PAYSYMBOLCLS,
  MEMORDERNUM,
  NOTE,
  PROGINDEX,
  RECORDINDEX,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SOURCEKVSR,
  SOURCEKCSR,
  SOURCEKFSR,
  SOURCESUBKESR,
  SOURCEFACT,
  SOURCEMEANSTYPE,
  SOURCEFINSOURCE,
  SOURCEFINTYPE,
  DESTKVSR,
  DESTKCSR,
  DESTKFSR,
  DESTSUBKESR,
  DESTFACT,
  DESTMEANSTYPE,
  DESTFINSOURCE,
  DESTFINTYPE,
  REQUESTSINDEX,
  SENDERID,
  SENDERRECORDID,
  PROMISE,
  SOURCEDOCTYPE,
  DESTDOCTYPE,
  SOURCEPROMISE,
  DESTPROMISE,
  RECORDINDEX2,
  SOURCEBUDGETPROMISE,
  DESTBUDGETPROMISE,
  SUBPROGINDEX,
  STIMATEID,
  RVERSION,
  SOURCEDIRECTIONCLS,
  DESTDIRECTIONCLS,
  SOURCEDOCBASE,
  DESTDOCBASE,
  SOURCEEXECDOC,
  DESTEXECDOC,
  BUHOPERATIONCLS,
  SOURCEIFS,
  DESTIFS,
  CLSTYPE,
  UNIONNOTIFYREF,
  ACCEPTDATE,
  SOURCEKD,
  DESTKD,
  SOURCEREGIONCLS,
  DESTREGIONCLS,
  DESTFUNDSSOURCE,
  SOURCEFUNDSSOURCE,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SOURCETRANSFERTCLS,
  DESTTRANSFERTCLS,
  DESTCLSTYPE,
  SOURCEASSIGNMENTKIND,
  DESTASSIGNMENTKIND,
  SOURCEEXECINNERNUMBER,
  DESTEXECINNERNUMBER,
  SOURCESUBSIDYCLS,
  DESTSUBSIDYCLS,
  SOURCEFAORG_TYPE,
  DESTFAORG_TYPE,
  SOURCEBUDALLOCATIONCLS,
  SOURCEPAYPROMISECLS,
  DESTBUDALLOCATIONCLS,
  DESTPAYPROMISECLS,
  SOURCEINVESTOBJECT,
  DESTINVESTOBJECT,
  TRANSFERTORG_REF,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  STOREDPAYMENTCONTENT,
  SOURCECONTRACTCOSTSCLS,
  DESTCONTRACTCOSTSCLS,
  SOURCETARGETCLS,
  DESTTARGETCLS,
  REJECT_CLS,
  REJECTCAUSE,
  CARDNUMBER,
  DATEBIRTH,
  PAYMENTCODETYPE,
  CODEPURPOSE,
  LINENUMBER,
  AMOUNTISPDOC,
  SOURCEREGPROJECTRESULT,
  DESTREGPROJECTRESULT,
  SOURCEINCOMETARGETFUNDS,
  DESTINCOMETARGETFUNDS,
  SOURCEPAYTARGETFUNDS,
  DESTPAYTARGETFUNDS,
  SOURCEANALYTICALPARTITION,
  DESTANALYTICALPARTITION)
AS
  SELECT
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION
  FROM TB_FacialFinDetail
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_ID
  INSTEAD OF DELETE
  ON FACIALFINDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_FACIALFINDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update facialfincaption set
  DocChangeDate = SYSDATE,
  RVersion=-1
  where id=:old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_FACIALFINDETAIL
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_FACIALFINDETAIL_AD_500)
-- Last update 27.08.2004
-- - - - - - - - - - - - -

  INSERT INTO DelRecIndexes
              (TableID, RecordId, DeleteDate, ProgIndex, Summa)
       VALUES (22, :OLD.ID, SYSDATE, :OLD.ProgIndex, :OLD.Credit);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;
   
  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;  
  END IF;
     
  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;   
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then 
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then 
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;
     
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);
  /*      */
  GetDocumentKESR(null, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(null, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC,
    new$SOURCEREGPROJECTRESULT,
    new$DESTREGPROJECTRESULT,
    new$SOURCEINCOMETARGETFUNDS,
    new$DESTINCOMETARGETFUNDS,
    new$SOURCEPAYTARGETFUNDS,
    new$DESTPAYTARGETFUNDS,
    new$SOURCEANALYTICALPARTITION,
    new$DESTANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  i_fintype1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select
      c.AcceptDate
      into
      CapAcceptDate1$     from
      facialfincaption c
      where
      (c.id = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (not ((new$AcceptDate = CapAcceptDate1$) or (CapAcceptDate1$  is null) or
    /*          (  )    */
    ((new$Progindex = 283) and (new$AcceptDate is null) and (new$Reject_CLS is not null)))) then
      RaiseException('ex_wrongacceptdate');  
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS,
    REJECT_CLS = new$REJECT_CLS,
    REJECTCAUSE = new$REJECTCAUSE,
    CARDNUMBER = new$CARDNUMBER,
    DATEBIRTH = new$DATEBIRTH,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    CODEPURPOSE = new$CODEPURPOSE,
    LINENUMBER = new$LINENUMBER,
    AMOUNTISPDOC = new$AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT = new$SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT = new$DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS = new$SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS = new$DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS = new$SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS = new$DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION = new$SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION = new$DESTANALYTICALPARTITION
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_Incomes32 ADD (
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_INC_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_INC_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_INC_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_INC_IncTarFS ON TB_Incomes32(IncomeTargetFunds)
/
CREATE INDEX FK_INC_DirectTarFunds ON TB_Incomes32(PayTargetFunds)
/
CREATE INDEX FK_INC_AnalyticFC ON TB_Incomes32(AnalyticalPartition)
/

CREATE OR REPLACE VIEW Incomes32 (
  ID,
  DOCNUMBER,
  DOCCOUNT,
  IDATE,
  DEBIT,
  CREDIT,
  DOCTYPE,
  INN,
  ORG_REF,
  ACCOUNTINDEX,
  KD,
  SUBKD,
  REGIONCLS,
  GOSNI,
  INCACCOUNT,
  PROGINDEX,
  RECORDINDEX,
  BUDGETREF,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  NOTE,
  RECORDINDEX2,
  ELNUM,
  NOTEEX,
  BUHPAYMENTCLS,
  ACCOUNTREF,
  ELPACKETNUM,
  FACIALACC_CLS,
  NDS,
  MEANSTYPE,
  RECORDDATE,
  TOTALREF,
  REQUESTSINDEX,
  KVSR,
  TAXNOTE,
  DOCNUM,
  REALPAYERORG_REF,
  DOCDATE,
  DOCBASE,
  FACT,
  RVERSION,
  KFSR,
  KESR,
  KVR,
  KCSR,
  SUMCOMPLETE,
  ELDOCREF,
  REQUESTSINDEX2,
  FEDERALFUNDSREF,
  BUHOPERATIONCLS,
  IFS,
  IFS_CORR,
  CLSTYPE,
  NDSNOTE,
  DOGNUM,
  SENDERID,
  SENDERRECORDID,
  OKATO,
  ADDOKATO,
  REJECTCLS,
  FUNDSSOURCE,
  DIRECTIONCLS,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  STIMATEID,
  TRANSFERTCLS,
  SUBSIDYCLS,
  FAORGTYPE,
  OKTMO,
  UINCODE,
  FINTYPE,
  INVESTOBJECT,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  REJECTCAUSE,
  STOREDCONTENT,
  INCOMETARGETFUNDS,
  PAYTARGETFUNDS,
  ANALYTICALPARTITION)
AS
  SELECT
    ID,
    DOCNUMBER,
    DOCCOUNT,
    IDATE,
    DEBIT,
    CREDIT,
    DOCTYPE,
    INN,
    ORG_REF,
    ACCOUNTINDEX,
    KD,
    SUBKD,
    REGIONCLS,
    GOSNI,
    INCACCOUNT,
    PROGINDEX,
    RECORDINDEX,
    BUDGETREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    NOTE,
    RECORDINDEX2,
    ELNUM,
    NOTEEX,
    BUHPAYMENTCLS,
    ACCOUNTREF,
    ELPACKETNUM,
    FACIALACC_CLS,
    NDS,
    MEANSTYPE,
    RECORDDATE,
    TOTALREF,
    REQUESTSINDEX,
    KVSR,
    TAXNOTE,
    DOCNUM,
    REALPAYERORG_REF,
    DOCDATE,
    DOCBASE,
    FACT,
    RVERSION,
    KFSR,
    KESR,
    KVR,
    KCSR,
    SUMCOMPLETE,
    ELDOCREF,
    REQUESTSINDEX2,
    FEDERALFUNDSREF,
    BUHOPERATIONCLS,
    IFS,
    IFS_CORR,
    CLSTYPE,
    NDSNOTE,
    DOGNUM,
    SENDERID,
    SENDERRECORDID,
    OKATO,
    ADDOKATO,
    REJECTCLS,
    FUNDSSOURCE,
    DIRECTIONCLS,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    STIMATEID,
    TRANSFERTCLS,
    SUBSIDYCLS,
    FAORGTYPE,
    OKTMO,
    UINCODE,
    FINTYPE,
    INVESTOBJECT,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    REJECTCAUSE,
    STOREDCONTENT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  FROM TB_Incomes32
/

CREATE OR REPLACE TRIGGER TR_INCOMES32_ID
  INSTEAD OF DELETE
  ON INCOMES32
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_10 (TR_INCOMES32_BD10)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

  delete
  from CurrencyIncomes
  where (id = :old.id);

-- - - - - - - - - - - - -
-- BD_20 (T_INCOMES32_BD_20)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

  /*    */
  if (:old.DocType between 1010 and 1019) then
    delete from PayDoc32
    where
      (ProgIndex = :old.ProgIndex)
    and
     (RecordIndex = :old.id);
  end if;

-- - - - - - - - - - - - -
-- BD_500 (TR_INCOMES32_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update QuotesTitle set
  DocChangeDate = SYSDATE,
  RVersion = -1
  where id = :old.recordindex;

-- - - - - - - - - - - - -
-- BD_600 (TR_INCOMES32_BD_600)
-- Last update 14.10.2009
-- - - - - - - - - - - - -

    --    
    if (:old.ProgIndex = 41) then
        delete
            from Incomes32
        where
           (ProgIndex=42)and
           (RecordIndex=:old.id);
    end if;

    --  (  )
    if (:old.ProgIndex = 42) then
        delete
            from Incomes32
        where
            (ProgIndex=43)and
            (RecordIndex=:old.id);
    end if;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_INCOMES32
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_500 (TR_INCOMES32_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (161, :old.ID, SYSDATE, :old.ProgIndex, :old.DEBIT + :old.CREDIT);

END;
/

CREATE OR REPLACE TRIGGER TR_INCOMES32_II
  INSTEAD OF INSERT
  ON INCOMES32
  FOR EACH ROW
DECLARE
  new$ID INCOMES32.ID%TYPE := :NEW.ID;
  new$DOCNUMBER INCOMES32.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$DOCCOUNT INCOMES32.DOCCOUNT%TYPE := :NEW.DOCCOUNT;
  new$IDATE INCOMES32.IDATE%TYPE := :NEW.IDATE;
  new$DEBIT INCOMES32.DEBIT%TYPE := :NEW.DEBIT;
  new$CREDIT INCOMES32.CREDIT%TYPE := :NEW.CREDIT;
  new$DOCTYPE INCOMES32.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$INN INCOMES32.INN%TYPE := :NEW.INN;
  new$ORG_REF INCOMES32.ORG_REF%TYPE := :NEW.ORG_REF;
  new$ACCOUNTINDEX INCOMES32.ACCOUNTINDEX%TYPE := :NEW.ACCOUNTINDEX;
  new$KD INCOMES32.KD%TYPE := :NEW.KD;
  new$SUBKD INCOMES32.SUBKD%TYPE := :NEW.SUBKD;
  new$REGIONCLS INCOMES32.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$GOSNI INCOMES32.GOSNI%TYPE := :NEW.GOSNI;
  new$INCACCOUNT INCOMES32.INCACCOUNT%TYPE := :NEW.INCACCOUNT;
  new$PROGINDEX INCOMES32.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX INCOMES32.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$BUDGETREF INCOMES32.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREATERUSER INCOMES32.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE INCOMES32.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INCOMES32.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER INCOMES32.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE INCOMES32.NOTE%TYPE := :NEW.NOTE;
  new$RECORDINDEX2 INCOMES32.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$ELNUM INCOMES32.ELNUM%TYPE := :NEW.ELNUM;
  new$NOTEEX INCOMES32.NOTEEX%TYPE := :NEW.NOTEEX;
  new$BUHPAYMENTCLS INCOMES32.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$ACCOUNTREF INCOMES32.ACCOUNTREF%TYPE := :NEW.ACCOUNTREF;
  new$ELPACKETNUM INCOMES32.ELPACKETNUM%TYPE := :NEW.ELPACKETNUM;
  new$FACIALACC_CLS INCOMES32.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$NDS INCOMES32.NDS%TYPE := :NEW.NDS;
  new$MEANSTYPE INCOMES32.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$RECORDDATE INCOMES32.RECORDDATE%TYPE := :NEW.RECORDDATE;
  new$TOTALREF INCOMES32.TOTALREF%TYPE := :NEW.TOTALREF;
  new$REQUESTSINDEX INCOMES32.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$KVSR INCOMES32.KVSR%TYPE := :NEW.KVSR;
  new$TAXNOTE INCOMES32.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$DOCNUM INCOMES32.DOCNUM%TYPE := :NEW.DOCNUM;
  new$REALPAYERORG_REF INCOMES32.REALPAYERORG_REF%TYPE := :NEW.REALPAYERORG_REF;
  new$DOCDATE INCOMES32.DOCDATE%TYPE := :NEW.DOCDATE;
  new$DOCBASE INCOMES32.DOCBASE%TYPE := :NEW.DOCBASE;
  new$FACT INCOMES32.FACT%TYPE := :NEW.FACT;
  new$RVERSION INCOMES32.RVERSION%TYPE := :NEW.RVERSION;
  new$KFSR INCOMES32.KFSR%TYPE := :NEW.KFSR;
  new$KESR INCOMES32.KESR%TYPE := :NEW.KESR;
  new$KVR INCOMES32.KVR%TYPE := :NEW.KVR;
  new$KCSR INCOMES32.KCSR%TYPE := :NEW.KCSR;
  new$SUMCOMPLETE INCOMES32.SUMCOMPLETE%TYPE := :NEW.SUMCOMPLETE;
  new$ELDOCREF INCOMES32.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$REQUESTSINDEX2 INCOMES32.REQUESTSINDEX2%TYPE := :NEW.REQUESTSINDEX2;
  new$FEDERALFUNDSREF INCOMES32.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$BUHOPERATIONCLS INCOMES32.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$IFS INCOMES32.IFS%TYPE := :NEW.IFS;
  new$IFS_CORR INCOMES32.IFS_CORR%TYPE := :NEW.IFS_CORR;
  new$CLSTYPE INCOMES32.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$NDSNOTE INCOMES32.NDSNOTE%TYPE := :NEW.NDSNOTE;
  new$DOGNUM INCOMES32.DOGNUM%TYPE := :NEW.DOGNUM;
  new$SENDERID INCOMES32.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID INCOMES32.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$OKATO INCOMES32.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO INCOMES32.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$REJECTCLS INCOMES32.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$FUNDSSOURCE INCOMES32.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$DIRECTIONCLS INCOMES32.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$ISBLOCKED INCOMES32.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE INCOMES32.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE INCOMES32.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE INCOMES32.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$STIMATEID INCOMES32.STIMATEID%TYPE := :NEW.STIMATEID;
  new$TRANSFERTCLS INCOMES32.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SUBSIDYCLS INCOMES32.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$FAORGTYPE INCOMES32.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$OKTMO INCOMES32.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE INCOMES32.UINCODE%TYPE := :NEW.UINCODE;
  new$FINTYPE INCOMES32.FINTYPE%TYPE := :NEW.FINTYPE;
  new$INVESTOBJECT INCOMES32.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CONTRACTCOSTSCLS INCOMES32.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS INCOMES32.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$REJECTCAUSE INCOMES32.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$STOREDCONTENT INCOMES32.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$INCOMETARGETFUNDS INCOMES32.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS INCOMES32.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION INCOMES32.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CapProgIndex NUMBER(10);
  CapAcceptDate NUMBER;
  CapReestrNumber VARCHAR2(20);
  CapDocNumber VARCHAR2(20);
  unkKD$ VARCHAR2(20);
  newKD$ VARCHAR2(20);
  Kd_Master NUMBER(10);
  idKD$ NUMBER(10);
  unkVKD$ VARCHAR2(20);
  val_DocCount$ NUMBER(10);
  val_DocType$ NUMBER(10);
  val_Org_Ref$ NUMBER(10);
  val_AccountIndex$ NUMBER(10);
  val_SubKD$ NUMBER(10);
  val_RegionCLS$ NUMBER(10);
  val_GosNI$ NUMBER(10);
  val_IncAccount$ NUMBER(10);
  val_BudgetRef$ NUMBER(10);
  val_MEANSTYPE$ NUMBER(10);
  val_FACIALACC_CLS$ NUMBER(10);
  val_TransfertCls$ NUMBER(10);
  CapAcceptDate$ NUMBER;
  CapReestrNumber$ VARCHAR2(20);
  CapProgIndex1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_INCOMES32_BI)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN
    select g_shared.nextval into new$id from dual;
  END IF;
  /*   */
  IF (new$FACIALACC_CLS IS NULL) THEN
    new$FACIALACC_CLS := 0;
  END IF;
  IF (new$Gosni IS NULL) THEN
    new$Gosni := 0;
  END IF;
  IF (new$Fact IS NULL) THEN
    new$Fact := 0;
  END IF;
  IF (new$DocBase IS NULL) THEN
    new$DocBase := 0;
  END IF;
  /* 3 -    */
  IF (new$KD IS NULL) THEN
    new$KD := 0;
  END IF;
  IF (new$ProgIndex IS NULL) THEN
    new$ProgIndex := 3;
  END IF;
  IF (new$MeansType IS NULL) THEN
    new$MeansType := 0;
  END IF;
  IF (new$Debit IS NULL) THEN
    new$Debit := 0;
  END IF;
  IF (new$Credit IS NULL) THEN
    new$Credit := 0;
  END IF;
  IF (new$Org_Ref IS NULL) THEN
    new$Org_Ref := 0;
  END IF;
  IF (new$AccountIndex IS NULL) THEN
    new$AccountIndex := 0;
  END IF;
  IF (new$DocType IS NULL) THEN
    new$DocType := 0;
  END IF;
  IF (new$SubKD IS NULL) THEN
    new$SubKD := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN
    new$RegionCLS := 0;
  END IF;
  IF (new$DocCount IS NULL) THEN
    new$DocCount := 1;
  END IF;
  IF (new$BuhPaymentCLS IS NULL) THEN
    new$BuhPaymentCLS := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN
    new$KFSR := 0;
  END IF;
  IF (new$KESR IS NULL) THEN
    new$KESR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN
    new$KCSR := 0;
  END IF;
  IF (new$OKATO IS NULL) THEN
    new$OKATO := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN
    new$FundsSource := 0;
  END IF;
  IF (new$DirectionCLS IS NULL) THEN
    new$DirectionCLS := 0;
  END IF;
  IF (new$FinType is null) then
    new$FinType := 0;
  END IF;
  IF (new$Debit * new$Credit <> 0) THEN
    RaiseException('ex_FailDebetCretitValue');
  END IF;
  /*   .        */
  IF (new$IFS IS NULL) THEN
    new$IFS := 0;
  END IF;
  IF (new$IFS_CORR IS NULL) THEN
    new$Ifs_Corr := 0;
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;

  /*  ,    */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0)) THEN
    BEGIN
      SELECT qt.BudgetRef      INTO new$BudgetRef FROM QuotesTitle qt
      WHERE qt.Id = new$RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    0,     */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0)) THEN
    BEGIN
      SELECT fa.BudgetRef      INTO new$BudgetRef FROM FacialAcc_Cls fa
      WHERE fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    0,    */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0))
  THEN
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;

  IF (new$ProgIndex = 45)
  THEN
    IF (new$IncAccount IS NULL) THEN
      GetDefDFAccRefForBudget(new$BudgetRef,new$IncAccount);
    END IF;
    BEGIN

      /*     */
      SELECT qt.ProgIndex, qt.AcceptDate, qt.IncAccount, qt.ReestrNumber
      INTO CapProgIndex1$, CapAcceptDate$, new$IncAccount, CapReestrNumber$       FROM QuotesTitle qt
      WHERE
      (qt.ID = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*           / */
    /*  /   after insert */
    IF (CapProgIndex1$ <> 145) THEN
      new$iDate := CapAcceptDate$;
    END IF;
    IF ((CapProgIndex1$ = 145)AND (NOT ((CapAcceptDate$ IS NOT NULL) AND (new$DocType BETWEEN 1010 AND 1019) AND ((new$Debit>0)OR (new$Credit<0)))) )
    THEN
      new$Idate := CapAcceptDate$;
    END IF;
    /*   -    () */
    IF ((CapProgIndex1$ = 45) AND (CapAcceptDate$ IS NOT NULL) AND (CapReestrNumber$ IS NOT NULL))
    THEN
      /*        , *//*    */

      new$FederalFundsRef := new$ID;
      /* if-then */
    END IF;/* if-then*/
  END IF;
  BEGIN
    /*     \*/
    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);

-- - - - - - - - - - - - -
-- BI_5 (TR_INCOMES_BI_5)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

   IF ((new$DocNum IS NULL) AND NOT (new$DocNumber IS NULL)) THEN
      new$DocNum := CAST (new$DocNumber AS VARCHAR2);
   END IF;

-- - - - - - - - - - - - -
-- BI_9 (TR_INCOMES32_BI_VZ)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

   IF (new$ProgIndex = 9) THEN
      /*   */
      GetIntConst (9, 1, new$IncAccount);

      BEGIN
        /*      */
        SELECT ACCEPTDATE, BUDGETREF
          INTO new$IDate, new$BudgetRef
          FROM VZ_OFFSET
         WHERE ID = new$RecordIndex;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
   END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_INCOMES32_BI_0)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

   BEGIN
      SELECT Inn
        INTO new$Inn
        FROM Organizations o
       WHERE (o.ID = new$Org_Ref);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
   END;

/*  .    ,    */
   IF ((new$budgetref IS NULL) OR (new$budgetref = 0)) THEN
      BEGIN
         SELECT c.BudgetRef
           INTO new$budgetref
           FROM QuotesTitle c
          WHERE c.ID = NEW$RecordIndex;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
   END IF;

   /*  .  ,     */
   IF ((new$budgetref IS NULL) OR (new$budgetref = 0)) THEN
      BEGIN
         SELECT fa.BudgetRef
           INTO new$budgetref
           FROM FacialAcc_Cls fa
          WHERE fa.ID = NEW$FacialAcc_Cls;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
   END IF;

   /*  ,    */
   IF ((new$budgetref IS NULL) OR (new$budgetref = 0)) THEN
      GetIntConst (-1, 3, new$budgetref);
   END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_INCOMES32_BI_30)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$DocDate is null) and (new$ProgIndex=45)) then
    BEGIN
      select q.BuildDate
      into
      new$DocDate        from QuotesTitle q
      where q.id = new$RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if ((new$DocDate is null) and (new$IDATE is not null)) then
    new$DocDate := new$IDATE;
  END IF;
  if ((new$DOCDATE is not null)) then
    new$RecordDate := new$DOCDATE;
  END IF;
  /*         */
  if ((new$IDate is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_70 (TR_INCOMES32_BI_70)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

   /*     */
   BEGIN
      SELECT ProgIndex, AcceptDate, ReestrNumber
        INTO CapProgIndex, CapAcceptDate, CapReestrNumber
        FROM QuotesTitle qt
       WHERE (qt.ID = new$RecordIndex);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
   END;

   /*   -    () */
   IF (CapProgIndex = 45) THEN
      IF ((CapAcceptDate IS NOT NULL) AND (CapReestrNumber IS NOT NULL)) THEN
         /*        ,
               */
         new$FederalFundsRef := new$ID;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_INCOMES32_BI_100)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 42)
  then
    /*    */
    GetVarCharConst(3,0,unkKD$);
    /*     */
    GetVarCharConst(3,11,unkVKD$);
    BEGIN

      select KDValue   into newKD$ from kd where Id=new$kd
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if ((not (newKD$  like unkKD$)) and
    (not (newKD$  like unkVKD$))) then
      /*   (    
            ) ,  
         ,   */

      /*       */
      if (new$Debit <> 0) then
        RaiseException('ex_UnknownRedirect');
      END IF;
      BEGIN

        /*      */
        select KD,DocCount,DocType,
        Org_Ref,AccountIndex,SubKD,RegionCLS,GosNI,
        IncAccount, BudgetRef, MEANSTYPE,FACIALACC_CLS,
        TransfertCls
        into
        idKD$,
        val_DocCount$,
        val_DocType$,
        val_Org_Ref$,
        val_AccountIndex$,
        val_SubKD$,
        val_RegionCLS$,
        val_GosNI$,
        val_IncAccount$,
        val_BudgetRef$,
        val_MEANSTYPE$  ,
        val_FACIALACC_CLS$,
        val_TransfertCls$         from incomes32 where id=new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;

      if (not idKD$ is null) then
        insert into
        /* KD=   (      )
              Debit=0
              redit=-new.credit
              ProgIndex=43
              RecordIndex=new.id
              id    Incomes32*/
        Incomes32(CreaterUser, DocNum,DocCount, iDate, DOCDATE, Debit, Credit, DocType,
        Org_Ref, AccountIndex, KD, SubKD, RegionCLS, GosNI, ProgIndex,
        RecordIndex, IncAccount, BudgetRef, Note, MEANSTYPE, FACIALACC_CLS, TransfertCls)
        Values(new$CreaterUser, new$DocNum, val_DocCount$, new$iDate, new$DOCDATE, 0, -new$Credit, val_DocType$,
        val_Org_Ref$, val_AccountIndex$, idKD$, val_SubKD$, val_RegionCLS$, val_GosNI$,
        43,new$Id, val_IncAccount$, val_BudgetRef$, new$Note,val_MEANSTYPE$,val_FACIALACC_CLS$,val_TransfertCls$);

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_INCOMES32_BI_110)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

   IF ((new$ClsType IS NULL) AND (new$IFS <> 0) AND (new$ProgIndex <> 44)) THEN
      new$ClsType := 1;       /*       ClsType */
   ELSIF (new$ClsType IS NULL) THEN
      new$ClsType := 2;                                /*  -  */
   END IF;

   IF ((new$ClsType = 1) AND (new$KD <> 0)) THEN
      /*   */
      RaiseEXCEPTION ('EX_WRONGBUDCLS');
   END IF;

   IF ((new$ClsType = 2) AND (new$IFS <> 0) AND (new$ProgIndex <> 44)) THEN
      /*   */
      RaiseEXCEPTION ('EX_WRONGBUDCLS');
   END IF;

   IF ((new$ClsType <> 1) AND (new$ClsType <> 2)) THEN
      /*   */
      RaiseEXCEPTION ('EX_WRONGBUDCLSTYPE');
   END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_INCOMES32_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update QuotesTitle set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_INCOMES32 (
    ID,
    DOCNUMBER,
    DOCCOUNT,
    IDATE,
    DEBIT,
    CREDIT,
    DOCTYPE,
    INN,
    ORG_REF,
    ACCOUNTINDEX,
    KD,
    SUBKD,
    REGIONCLS,
    GOSNI,
    INCACCOUNT,
    PROGINDEX,
    RECORDINDEX,
    BUDGETREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    NOTE,
    RECORDINDEX2,
    ELNUM,
    NOTEEX,
    BUHPAYMENTCLS,
    ACCOUNTREF,
    ELPACKETNUM,
    FACIALACC_CLS,
    NDS,
    MEANSTYPE,
    RECORDDATE,
    TOTALREF,
    REQUESTSINDEX,
    KVSR,
    TAXNOTE,
    DOCNUM,
    REALPAYERORG_REF,
    DOCDATE,
    DOCBASE,
    FACT,
    RVERSION,
    KFSR,
    KESR,
    KVR,
    KCSR,
    SUMCOMPLETE,
    ELDOCREF,
    REQUESTSINDEX2,
    FEDERALFUNDSREF,
    BUHOPERATIONCLS,
    IFS,
    IFS_CORR,
    CLSTYPE,
    NDSNOTE,
    DOGNUM,
    SENDERID,
    SENDERRECORDID,
    OKATO,
    ADDOKATO,
    REJECTCLS,
    FUNDSSOURCE,
    DIRECTIONCLS,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    STIMATEID,
    TRANSFERTCLS,
    SUBSIDYCLS,
    FAORGTYPE,
    OKTMO,
    UINCODE,
    FINTYPE,
    INVESTOBJECT,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    REJECTCAUSE,
    STOREDCONTENT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$DOCNUMBER,
    new$DOCCOUNT,
    new$IDATE,
    new$DEBIT,
    new$CREDIT,
    new$DOCTYPE,
    new$INN,
    new$ORG_REF,
    new$ACCOUNTINDEX,
    new$KD,
    new$SUBKD,
    new$REGIONCLS,
    new$GOSNI,
    new$INCACCOUNT,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$BUDGETREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$NOTE,
    new$RECORDINDEX2,
    new$ELNUM,
    new$NOTEEX,
    new$BUHPAYMENTCLS,
    new$ACCOUNTREF,
    new$ELPACKETNUM,
    new$FACIALACC_CLS,
    new$NDS,
    new$MEANSTYPE,
    new$RECORDDATE,
    new$TOTALREF,
    new$REQUESTSINDEX,
    new$KVSR,
    new$TAXNOTE,
    new$DOCNUM,
    new$REALPAYERORG_REF,
    new$DOCDATE,
    new$DOCBASE,
    new$FACT,
    new$RVERSION,
    new$KFSR,
    new$KESR,
    new$KVR,
    new$KCSR,
    new$SUMCOMPLETE,
    new$ELDOCREF,
    new$REQUESTSINDEX2,
    new$FEDERALFUNDSREF,
    new$BUHOPERATIONCLS,
    new$IFS,
    new$IFS_CORR,
    new$CLSTYPE,
    new$NDSNOTE,
    new$DOGNUM,
    new$SENDERID,
    new$SENDERRECORDID,
    new$OKATO,
    new$ADDOKATO,
    new$REJECTCLS,
    new$FUNDSSOURCE,
    new$DIRECTIONCLS,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$STIMATEID,
    new$TRANSFERTCLS,
    new$SUBSIDYCLS,
    new$FAORGTYPE,
    new$OKTMO,
    new$UINCODE,
    new$FINTYPE,
    new$INVESTOBJECT,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$REJECTCAUSE,
    new$STOREDCONTENT,
    new$INCOMETARGETFUNDS,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_20 (T_INCOMES32_AI_20)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

   --     
   if (new$ProgIndex <> 42) then
     BEGIN
       SELECT ProgIndex, DocNumber, AcceptDate
        INTO CapProgIndex, CapDocNumber, CapAcceptDate
        FROM QuotesTitle qt
       WHERE (qt.ID = new$RecordIndex);
     EXCEPTION
       WHEN NO_DATA_FOUND THEN NULL;
     END;
   end if;

   --   - ,  
   IF ((CapProgIndex = 145) or (new$ProgIndex=42)) THEN

      If ((new$ProgIndex=42) and (new$DocType between 1010 and 1019) and
         (new$Debit>0) and (new$DOCDATE is not null))
      then
        BEGIN
          select kd into Kd_Master
    From Incomes32 inc
          where inc.id = new$RecordIndex;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;

        if (Kd_Master = new$Kd) then
          CapAcceptDate := new$DOCDATE;
          CapProgIndex  := new$ProgIndex;
          CapDocNumber  := new$DocNum;
        end if;
      end if; --       (         )

      --             
      IF ((CapAcceptDate IS NOT NULL) AND (new$DocType BETWEEN 1010 AND 1019) AND ((new$Debit > 0) OR (new$Credit < 0))) THEN
         --    ( RealPayerOrg_Ref(PayDoc32)=new$RealPayerOrg_Ref(Incomes32))
         INSERT INTO PayDoc32
            (BudgetRef, AccountRef, PayerAttrRef, InputDate,
             Credit, TextNote, ProgIndex, RecordIndex, SourceDocNumber, TaxNote, RealPayerOrg_Ref, FACIALACC_CLS)
         VALUES (new$BudgetRef, new$AccountRef, new$IncAccount, CapAcceptDate,
             (new$Debit - new$Credit), new$Note, new$ProgIndex, new$id, CapDocNumber, new$TaxNote,
             new$RealPayerOrg_Ref,new$FACIALACC_CLS);
      -- (new$Debit - new$Credit) --- ..      ,    ,
      --             
      END IF;

   END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_INCOMES32_AI_500)
-- Create 15.09.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 161) AND (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_INCOMES32_IU
  INSTEAD OF UPDATE
  ON INCOMES32
  FOR EACH ROW
DECLARE
  new$ID INCOMES32.ID%TYPE := :NEW.ID;
  new$DOCNUMBER INCOMES32.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$DOCCOUNT INCOMES32.DOCCOUNT%TYPE := :NEW.DOCCOUNT;
  new$IDATE INCOMES32.IDATE%TYPE := :NEW.IDATE;
  new$DEBIT INCOMES32.DEBIT%TYPE := :NEW.DEBIT;
  new$CREDIT INCOMES32.CREDIT%TYPE := :NEW.CREDIT;
  new$DOCTYPE INCOMES32.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$INN INCOMES32.INN%TYPE := :NEW.INN;
  new$ORG_REF INCOMES32.ORG_REF%TYPE := :NEW.ORG_REF;
  new$ACCOUNTINDEX INCOMES32.ACCOUNTINDEX%TYPE := :NEW.ACCOUNTINDEX;
  new$KD INCOMES32.KD%TYPE := :NEW.KD;
  new$SUBKD INCOMES32.SUBKD%TYPE := :NEW.SUBKD;
  new$REGIONCLS INCOMES32.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$GOSNI INCOMES32.GOSNI%TYPE := :NEW.GOSNI;
  new$INCACCOUNT INCOMES32.INCACCOUNT%TYPE := :NEW.INCACCOUNT;
  new$PROGINDEX INCOMES32.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX INCOMES32.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$BUDGETREF INCOMES32.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREATERUSER INCOMES32.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE INCOMES32.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INCOMES32.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER INCOMES32.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$NOTE INCOMES32.NOTE%TYPE := :NEW.NOTE;
  new$RECORDINDEX2 INCOMES32.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$ELNUM INCOMES32.ELNUM%TYPE := :NEW.ELNUM;
  new$NOTEEX INCOMES32.NOTEEX%TYPE := :NEW.NOTEEX;
  new$BUHPAYMENTCLS INCOMES32.BUHPAYMENTCLS%TYPE := :NEW.BUHPAYMENTCLS;
  new$ACCOUNTREF INCOMES32.ACCOUNTREF%TYPE := :NEW.ACCOUNTREF;
  new$ELPACKETNUM INCOMES32.ELPACKETNUM%TYPE := :NEW.ELPACKETNUM;
  new$FACIALACC_CLS INCOMES32.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$NDS INCOMES32.NDS%TYPE := :NEW.NDS;
  new$MEANSTYPE INCOMES32.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$RECORDDATE INCOMES32.RECORDDATE%TYPE := :NEW.RECORDDATE;
  new$TOTALREF INCOMES32.TOTALREF%TYPE := :NEW.TOTALREF;
  new$REQUESTSINDEX INCOMES32.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$KVSR INCOMES32.KVSR%TYPE := :NEW.KVSR;
  new$TAXNOTE INCOMES32.TAXNOTE%TYPE := :NEW.TAXNOTE;
  new$DOCNUM INCOMES32.DOCNUM%TYPE := :NEW.DOCNUM;
  new$REALPAYERORG_REF INCOMES32.REALPAYERORG_REF%TYPE := :NEW.REALPAYERORG_REF;
  new$DOCDATE INCOMES32.DOCDATE%TYPE := :NEW.DOCDATE;
  new$DOCBASE INCOMES32.DOCBASE%TYPE := :NEW.DOCBASE;
  new$FACT INCOMES32.FACT%TYPE := :NEW.FACT;
  new$RVERSION INCOMES32.RVERSION%TYPE := :NEW.RVERSION;
  new$KFSR INCOMES32.KFSR%TYPE := :NEW.KFSR;
  new$KESR INCOMES32.KESR%TYPE := :NEW.KESR;
  new$KVR INCOMES32.KVR%TYPE := :NEW.KVR;
  new$KCSR INCOMES32.KCSR%TYPE := :NEW.KCSR;
  new$SUMCOMPLETE INCOMES32.SUMCOMPLETE%TYPE := :NEW.SUMCOMPLETE;
  new$ELDOCREF INCOMES32.ELDOCREF%TYPE := :NEW.ELDOCREF;
  new$REQUESTSINDEX2 INCOMES32.REQUESTSINDEX2%TYPE := :NEW.REQUESTSINDEX2;
  new$FEDERALFUNDSREF INCOMES32.FEDERALFUNDSREF%TYPE := :NEW.FEDERALFUNDSREF;
  new$BUHOPERATIONCLS INCOMES32.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$IFS INCOMES32.IFS%TYPE := :NEW.IFS;
  new$IFS_CORR INCOMES32.IFS_CORR%TYPE := :NEW.IFS_CORR;
  new$CLSTYPE INCOMES32.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$NDSNOTE INCOMES32.NDSNOTE%TYPE := :NEW.NDSNOTE;
  new$DOGNUM INCOMES32.DOGNUM%TYPE := :NEW.DOGNUM;
  new$SENDERID INCOMES32.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID INCOMES32.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$OKATO INCOMES32.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO INCOMES32.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$REJECTCLS INCOMES32.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$FUNDSSOURCE INCOMES32.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$DIRECTIONCLS INCOMES32.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$ISBLOCKED INCOMES32.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE INCOMES32.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE INCOMES32.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE INCOMES32.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$STIMATEID INCOMES32.STIMATEID%TYPE := :NEW.STIMATEID;
  new$TRANSFERTCLS INCOMES32.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SUBSIDYCLS INCOMES32.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$FAORGTYPE INCOMES32.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$OKTMO INCOMES32.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE INCOMES32.UINCODE%TYPE := :NEW.UINCODE;
  new$FINTYPE INCOMES32.FINTYPE%TYPE := :NEW.FINTYPE;
  new$INVESTOBJECT INCOMES32.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CONTRACTCOSTSCLS INCOMES32.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS INCOMES32.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$REJECTCAUSE INCOMES32.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$STOREDCONTENT INCOMES32.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$INCOMETARGETFUNDS INCOMES32.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS INCOMES32.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION INCOMES32.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  unkKD$ VARCHAR2(20);
  unkVKD$ VARCHAR2(20);
  newKD$ VARCHAR2(20);
  oldKD$ VARCHAR2(20);
  CapProgIndex NUMBER(10);
  CapAcceptDate NUMBER;
  CapReestrNumber VARCHAR2(20);
  IsReject$ NUMBER(10);
  CapProgIndex$ NUMBER(10);
  CapDocNumber$ VARCHAR2(20);
  CapAcceptDate$ NUMBER;
  PayDocCount$ NUMBER(10);
  ConstPayQueue$ NUMBER(10);
  ConstSendBy$ NUMBER(10);
  Divided$ NUMBER(10);
  Kd_Master$ NUMBER(10);
  Date_Pd$ NUMBER(10);
  DocNumber1$ NUMBER(10);
  CapReestrNumber$ VARCHAR2(20);
  CNT$1 NUMBER(10);
  idKD1$ NUMBER(10);
  val_DocCount1$ NUMBER(10);
  val_DocType1$ NUMBER(10);
  val_Org_Ref1$ NUMBER(10);
  val_AccountIndex1$ NUMBER(10);
  val_SubKD1$ NUMBER(10);
  val_RegionCLS1$ NUMBER(10);
  val_GosNI1$ NUMBER(10);
  val_IncAccount1$ NUMBER(10);
  val_BudgetRef1$ NUMBER(10);
  val_MEANSTYPE1$ NUMBER(10);
  val_FACIALACC_CLS1$ NUMBER(10);
  val_TransfertCls1$ NUMBER(10);
  val_ID431$ NUMBER(10);
  CapProgIndex2$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_INCOMES32_BU)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  IF (new$Fact IS NULL) THEN
    new$Fact := 0;
  END IF;
  IF (new$DocBase IS NULL) THEN
    new$DocBase := 0;
  END IF;
  IF (new$Gosni IS NULL) THEN
    new$Gosni := 0;
  END IF;
  /* 3 -    */
  IF (new$ProgIndex IS NULL) THEN
    new$ProgIndex := 3;
  END IF;
  IF (new$KD IS NULL) THEN
    new$KD := 0;
  END IF;
  /*   */
  IF (new$FACIALACC_CLS IS NULL) THEN
    new$FACIALACC_CLS := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN
    new$MeansType := 0;
  END IF;
  IF (new$Debit IS NULL) THEN
    new$Debit := 0;
  END IF;
  IF (new$Credit IS NULL) THEN
    new$Credit := 0;
  END IF;
  IF (new$Org_Ref IS NULL) THEN
    new$Org_Ref := 0;
  END IF;
  IF (new$AccountIndex IS NULL) THEN
    new$AccountIndex := 0;
  END IF;
  IF (new$DocType IS NULL) THEN
    new$DocType := 0;
  END IF;
  IF (new$SubKD IS NULL) THEN
    new$SubKD := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN
    new$RegionCLS := 0;
  END IF;
  IF (new$DocCount IS NULL) THEN
    new$DocCount := 1;
  END IF;
  IF (new$BuhPaymentCLS IS NULL) THEN
    new$BuhPaymentCLS := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN
    new$KFSR := 0;
  END IF;
  IF (new$KESR IS NULL) THEN
    new$KESR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN
    new$KCSR := 0;
  END IF;
  IF (new$OKATO IS NULL) THEN
    new$OKATO := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN
    new$FundsSource := 0;
  END IF;
  IF (new$DirectionCLS IS NULL) THEN
    new$DirectionCLS := 0;
  END IF;
  IF (new$FinType is null) then
    new$FinType := 0;
  END IF;
  IF (new$Debit * new$Credit <> 0) THEN
    RaiseException('ex_FailDebetCretitValue');
  END IF;
  /*   .        */
  IF (new$IFS_CORR IS NULL) THEN
    new$Ifs_Corr := 0;
  END IF;
  IF (new$IFS IS NULL) THEN
    new$Ifs := 0;
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  BEGIN

    /*     */
    /*   after   ,*/
    /*      */
    SELECT ProgIndex, AcceptDate, ReestrNumber
    INTO CapProgIndex2$, CapAcceptDate$, CapReestrNumber$   FROM QuotesTitle qt
    WHERE
    (qt.ID = new$RecordIndex)
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*             
           (  , , ) */
  /*   -    () */
  IF (CapProgIndex2$ = 45)
  THEN
    IF ((CapAcceptDate$ IS NOT NULL) AND (CapReestrNumber$ IS NOT NULL))
    THEN
      /*        ,
                     */
      new$FederalFundsRef := new$ID;
      /* if-then*/
    ELSE
      new$FederalFundsRef := NULL;
      /* if-else*/
    END IF;/* if (CapProgIndex=45) */
  END IF;
  /*     */
  IF (new$BudgetRef <> :old.BudgetRef) THEN
    IF ( NOT((new$BudgetRef IS NULL) AND (:old.BudgetRef IS NULL)) ) THEN
      IF ((new$Progindex = 45) OR (new$Progindex = 42)) THEN
        RaiseException('Ex_CantModufyBudget');
      END IF;
      IF (new$Progindex = 41) THEN
        SELECT COUNT(inc.id ) INTO CNT$1
        FROM incomes32 inc WHERE (inc.recordindex = new$ID) AND (ROWNUM = 1);
        IF ((CNT$1<> 0)) THEN
          RaiseException('Ex_CantModufyBudget');
        END IF;
      END IF;
    END IF;
  END IF;
  /*     \*/
  IF ( (new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType is null) OR
  ((new$IDate is not null) AND ((:old.IDate is null) OR (new$IDate <> :old.IDate))) ) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);

-- - - - - - - - - - - - -
-- BU_5 (TR_INCOMES_BU_5)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

   IF ((new$DocNum IS NULL) AND NOT (new$DocNumber IS NULL)) THEN
      new$DocNum := CAST (new$DocNumber AS VARCHAR2);
   END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_INCOMES32_BU_0)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

  BEGIN
    SELECT Inn
     INTO new$Inn
     FROM Organizations o
    WHERE (o.ID = new$Org_Ref);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;

-- - - - - - - - - - - - -
-- BU_20 (T_INCOMES32_BU_20)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*      */
  IF (new$ProgIndex <> 42) THEN
    BEGIN
      SELECT ProgIndex, DocNumber, AcceptDate
      INTO CapProgIndex$, CapDocNumber$, CapAcceptDate$     FROM QuotesTitle qt
      WHERE
      (qt.ID = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*   -  ,   */
  IF ( (CapProgIndex$ = 145) OR (new$ProgIndex = 42 ) )
  THEN
    IF ( (new$ProgIndex=42) AND (new$DocType BETWEEN 1010 AND 1019) AND
    (new$Debit>0) AND (new$DOCDATE IS NOT NULL))
    THEN
      BEGIN
        SELECT kd            INTO Kd_Master$ FROM Incomes32 inc
        WHERE inc.id = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      IF (Kd_Master$ = new$Kd) THEN
        CapAcceptDate$ := new$DOCDATE;
        CapProgIndex$  := new$ProgIndex;
        CapDocNumber$  := new$DocNum;
        /*  */
      END IF;/*       (         )*/
    END IF;
    IF ((CapAcceptDate$ IS NOT NULL) AND (new$DocType BETWEEN 1010 AND 1019) AND ((new$Debit>0) OR (new$Credit<0)))
    THEN

      /*      */
      /* /      Incomes32, ..      ,     */

      /*     /   */
      SELECT COUNT(ID), COUNT(IsDivide), MAX(ANumber), MAX(ACCEPTDATE) /*  ,      */
      INTO PayDocCount$, Divided$, DocNumber1$, Date_Pd$             FROM PayDoc32 pd
      WHERE
      (pd.ProgIndex IN (45,42)) AND (pd.RecordIndex = new$ID)
      ;
      /*            ,  .*/
      /* IF (((NEW.Progindex = 42) AND (DocNumber IS NOT NULL)) AND
                      ((OLD.IDATE = Date_PD) or (OLD.IDATE is null and Date_PD is null))
                     ) THEN
                    EXCEPTION EX_CANNOTUPDATENUMBER;*/


      IF ((new$Progindex = 42) AND (DocNumber1$ IS NOT NULL))
      then
        if ((new$DocType <> :old.DocType )
        or (new$Debit <> :old.Debit )
        or (new$Credit <> :old.Credit)
        or (new$org_ref <> :old.org_ref)
        or ((new$note <> :old.note) or (new$note is not null and :old.note is null))
        or ((new$DOCDate <> :old.DOCDate) or (new$DOCDate is not null and :old.DOCDate is null))
        )
        then
          RaiseException('EX_CANNOTUPDATENUMBER');
        END IF;
      END IF;



      /*           */
      IF (PayDocCount$ = 0)
      THEN
        /*       */
        GetIntConst(11, 2,ConstPayQueue$);
        /*       */
        GetIntConst(11, 1,ConstSendBy$);

        /*    */
        INSERT INTO PayDoc32
        (BudgetRef,AccountRef, PayerAttrRef, InputDate, SendBy, PayQueue,
        Credit, TextNote, ProgIndex, RecordIndex, SourceDocNumber, TaxNote, RealPayerOrg_Ref,FACIALACC_CLS)
        VALUES
        (new$BudgetRef,new$AccountRef, new$IncAccount, CapAcceptDate$, ConstSendBy$, ConstPayQueue$,
        new$Debit - new$Credit, new$Note, new$ProgIndex, new$id, CapDocNumber$, new$TaxNote, new$RealPayerOrg_Ref,new$FACIALACC_CLS);
        /* (new.Debit - new.Credit) --- ..      ,    ,
                                     */

        /* if-then */
      ELSE
        /*     */
        IF (((new$AccountRef = :old.AccountRef) OR
        ((new$AccountRef IS NULL) AND (:old.AccountRef IS NULL)))
        AND (new$IncAccount = :old.IncAccount)
        AND (new$BudgetRef = :old.BudgetRef)
        AND ((new$Note = :old.Note) OR
        ((new$Note IS NULL) AND (:old.Note IS NULL)))
        AND ((new$RealPayerOrg_Ref = :old.RealPayerOrg_Ref) OR
        ((new$RealPayerOrg_Ref IS NULL) AND (:old.RealPayerOrg_Ref IS NULL)))
        AND ((new$TaxNote = :old.TaxNote) OR
        ((new$TaxNote IS NULL) AND (:old.TaxNote IS NULL)))
        )  THEN
          new$AccountRef := new$AccountRef;

        ELSE

          UPDATE PayDoc32 pd
          SET
          pd.AccountRef = new$AccountRef,
          pd.PayerAttrRef = new$IncAccount,
          pd.AcceptorAttrRef = new$AccountRef,
          pd.TextNote = new$Note,
          pd.TaxNote = new$TaxNote,
          pd.BudgetRef = new$BudgetRef,
          pd.RealPayerOrg_Ref = new$RealPayerOrg_Ref,
          pd.InputDate = CapAcceptDate$,
          pd.SourceDocNumber = CapDocNumber$,
          pd.FACIALACC_CLS = new$FACIALACC_CLS
          WHERE
          (pd.RecordIndex = :old.id) AND (pd.ProgIndex = :old.ProgIndex);

        END IF;
        IF (((new$Debit-:old.Debit)>0.001) OR ((new$Debit-:old.Debit)<-0.001)
        OR ((new$Credit-:old.Credit)>0.001) OR ((new$Credit-:old.Credit)<-0.001))
        THEN
          IF (Divided$ > 0)
          THEN
            /*  ,      */
            RaiseException('EX_CANNOTUPDATEDIVIDEDPAYDOC');
          ELSE
            UPDATE PayDoc32 pd
            SET
            pd.Credit = new$Debit - new$Credit
            WHERE
            (pd.RecordIndex = :old.id) AND (pd.ProgIndex = :old.ProgIndex);

          END IF;/* if-then*/
        END IF;/* if-else*/
      END IF;
      /*     / */
      /*   :     ,     */
      /*  ,     */
      SELECT MAX(pd.AcceptDate)
      INTO Date_Pd$           FROM PayDoc32 pd
      WHERE (pd.RecordIndex = :old.id) AND (pd.ProgIndex = :old.ProgIndex)
      ;
      new$Idate := Date_Pd$;
      /* if-then*/
    ELSE
      /*       
                          -
                    . */
      DELETE FROM PayDoc32 pd
      WHERE
      (pd.ProgIndex = new$ProgIndex)
      AND (pd.RecordIndex = new$id);
      /* if-else*/
    END IF;/* if (CapProgIndex=145)or (new.ProgIndex=42) */
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_INCOMES32_BU_30)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$DocDate is null) and (new$ProgIndex=45)) then
    BEGIN
      select q.BuildDate
      into
      new$DocDate        from QuotesTitle q
      where q.id = new$RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if ((new$DocDate is null) and (new$IDATE is not null)) then
    new$DocDate := new$IDATE;
  END IF;
  if ((new$DOCDATE is not null)) then
    new$RecordDate := new$DOCDATE;
  END IF;
  /*         */
  if ((new$IDate is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_70 (TR_INCOMES32_BU_70)
-- Last update 29.11.2011
-- - - - - - - - - - - - -

   /*     */
   BEGIN
      SELECT ProgIndex, AcceptDate, ReestrNumber
        INTO CapProgIndex, CapAcceptDate, CapReestrNumber
        FROM QuotesTitle qt
       WHERE (qt.ID = new$RecordIndex);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
   END;

   /*   -    () */
   IF (CapProgIndex = 45) THEN
      IF ((CapAcceptDate IS NOT NULL) AND (CapReestrNumber IS NOT NULL)) THEN
         /*        ,
            */
         new$FederalFundsRef := new$ID;
      ELSE
         new$FederalFundsRef := NULL;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_INCOMES32_BU_100)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 42)
  then
    /*    */
    GetVarCharConst(3,0,unkKD$);
    /*     */
    GetVarCharConst(3,11,unkVKD$);
    BEGIN

      select KDValue   into newKD$ from kd where Id=new$kd
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    BEGIN
      select KDValue   into oldKD$ from kd where Id=:old.kd
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    BEGIN

      /*     */
      select KD,DocCount,DocType, Org_Ref, AccountIndex, SubKD, RegionCLS, GosNI,
      IncAccount, BudgetRef, MEANSTYPE,FACIALACC_CLS,TransfertCls
      into
      idKD1$,
      val_DocCount1$,
      val_DocType1$,
      val_Org_Ref1$,
      val_AccountIndex1$,
      val_SubKD1$,
      val_RegionCLS1$,
      val_GosNI1$,
      val_IncAccount1$,
      val_BudgetRef1$,
      val_MEANSTYPE1$  ,
      val_FACIALACC_CLS1$,
      val_TransfertCls1$         from incomes32 where id=new$RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (not idKD1$ is null) then
      if(((newKD$ like unkKD$)or(newKD$ like unkVKD$))and
      (not(oldKD$ like unkKD$))and(not(oldKD$ like unkVKD$)))then
        /*   ,    */
        delete
        from Incomes32
        where
        (ProgIndex=43)and
        (RecordIndex=:old.id);
      END IF;
      if((not(newKD$ like unkKD$))and(not(newKD$ like unkVKD$))and
      (new$Debit<>0))
      /*       */
      then
        RaiseException('ex_UnknownRedirect');
      END IF;
      if((not(newKD$ like unkKD$))and(not(newKD$ like unkVKD$))and
      ((oldKD$ like unkKD$)or(oldKD$ like unkVKD$)))then
        /*   ,   ,   */
        insert into
        Incomes32( CreaterUser, DocNum, DocCount, iDate, DOCDATE, Debit, Credit, DocType,
        Org_Ref, AccountIndex, KD, SubKD, RegionCLS, GosNI, ProgIndex,
        RecordIndex, IncAccount, BudgetRef, Note, MEANSTYPE, FACIALACC_CLS,TransfertCls)
        Values( new$CreaterUser, new$DocNum,val_DocCount1$, new$iDATE, new$DOCDATE, 0, -new$Credit,
        val_DocType1$, val_Org_Ref1$, val_AccountIndex1$, idKD1$, val_SubKD1$,
        val_RegionCLS1$, val_GosNI1$, 43, new$Id, val_IncAccount1$, val_BudgetRef1$,
        new$Note, val_MEANSTYPE1$, val_FACIALACC_CLS1$, val_TransfertCls1$);
      END IF;
      if((not(newKD$ like unkKD$))and(not(oldKD$ like unkKD$))
      and(not(newKD$ like unkVKD$))and(not(oldKD$ like unkVKD$)))then
        /*      ,   */
        update Incomes32
        set
        DocNum = new$DocNum,
        DocCount = val_DocCount1$,
        iDate = new$iDate,
        DOCDATE = new$DOCDATE,
        Debit = 0,
        Credit = -new$Credit,
        DocType = val_DocType1$,
        Org_Ref = val_Org_Ref1$,
        AccountIndex = val_AccountIndex1$,
        KD = idKD1$,
        SubKD = val_SubKD1$,
        RegionCLS = val_RegionCLS1$,
        GosNI = val_GosNI1$,
        ProgIndex = 43,
        RecordIndex = new$Id,
        IncAccount = val_IncAccount1$,
        BudgetRef = val_BudgetRef1$,
        Note = new$Note,
        MEANSTYPE = val_MEANSTYPE1$,
        FACIALACC_CLS = val_FACIALACC_CLS1$,
        TransfertCls = val_TransfertCls1$,
        RVersion = -1
        where
        (ProgIndex=43)and
        (RecordIndex=:old.id);

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_105 (TR_INCOMES32_BU_105)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$ProgIndex = 41)    /*   () */
  then
    /*    */
    GetVarCharConst(3,0,unkKD$);
    /*     */
    GetVarCharConst(3,11,unkVKD$);
    /*       */
    FOR REC$1 IN (SELECT inc.id
     AS val_ID42    FROM Incomes32 inc
    LEFT OUTER JOIN KD ON (kd.id =  inc.kd)
    WHERE (inc.ProgIndex =  42) and
    (inc.RecordIndex =  new$id) and
    (inc.debit = 0) and
    (not(kd.kdvalue like unkKD$)) and
    (not(kd.kdvalue like unkVKD$))
    )
    LOOP
      BEGIN
        /*       */
        select inc.id
        into val_ID431$         FROM Incomes32 inc
        WHERE (inc.ProgIndex =  43) and
        (inc.RecordIndex =  REC$1.val_ID42)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;

      /*     ,   Credit, ProgIndex, RecordIndex */
      update Incomes32
      set
      DocNum = new$DocNum,
      DocCount = new$DocCount,
      DOCDATE = new$DOCDATE,
      Debit = 0,
      DocType = new$DocType,
      Org_Ref = new$Org_Ref,
      AccountIndex = new$AccountIndex,
      KD = new$Kd,
      SubKD = new$SubKD,
      RegionCLS = new$RegionCLS,
      GosNI = new$GosNI,
      IncAccount = new$IncAccount,
      BudgetRef = new$BudgetRef,
      Note = new$Note,
      MEANSTYPE = new$MEANSTYPE,
      FACIALACC_CLS = new$FACIALACC_CLS,
      FACT = new$FACT,
      TransfertCls = new$TransfertCls,
      DirectionCls = new$DirectionCls,
      rversion = -1
      where id = val_ID431$;


    END LOOP;
  END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_INCOMES32_BU_110)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

   IF ((new$ClsType IS NULL) AND (new$IFS <> 0) AND (new$ProgIndex <> 44)) THEN
      new$ClsType := 1;       --       ClsType
   ELSIF (new$ClsType IS NULL) THEN
      new$ClsType := 2;                                --  - 
   END IF;

   IF ((new$ClsType = 1) AND (new$KD <> 0)) THEN
      --  
      RaiseEXCEPTION ('EX_WRONGBUDCLS');
   END IF;

   IF ((new$ClsType = 2) AND (new$IFS <> 0) AND (new$ProgIndex <> 44)) THEN
      --  
      RaiseEXCEPTION ('EX_WRONGBUDCLS');
   END IF;

   IF ((new$ClsType <> 1) AND (new$ClsType <> 2)) THEN
      --   
      RaiseEXCEPTION ('EX_WRONGBUDCLSTYPE');
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_INCOMES32_BU_300)
-- Create 24.06.2010
-- Last update 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from incomes32 d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_INCOMES32_BU_700)
-- Last update 23.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_INCOMES32 SET
    ID = new$ID,
    DOCNUMBER = new$DOCNUMBER,
    DOCCOUNT = new$DOCCOUNT,
    IDATE = new$IDATE,
    DEBIT = new$DEBIT,
    CREDIT = new$CREDIT,
    DOCTYPE = new$DOCTYPE,
    INN = new$INN,
    ORG_REF = new$ORG_REF,
    ACCOUNTINDEX = new$ACCOUNTINDEX,
    KD = new$KD,
    SUBKD = new$SUBKD,
    REGIONCLS = new$REGIONCLS,
    GOSNI = new$GOSNI,
    INCACCOUNT = new$INCACCOUNT,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    BUDGETREF = new$BUDGETREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    NOTE = new$NOTE,
    RECORDINDEX2 = new$RECORDINDEX2,
    ELNUM = new$ELNUM,
    NOTEEX = new$NOTEEX,
    BUHPAYMENTCLS = new$BUHPAYMENTCLS,
    ACCOUNTREF = new$ACCOUNTREF,
    ELPACKETNUM = new$ELPACKETNUM,
    FACIALACC_CLS = new$FACIALACC_CLS,
    NDS = new$NDS,
    MEANSTYPE = new$MEANSTYPE,
    RECORDDATE = new$RECORDDATE,
    TOTALREF = new$TOTALREF,
    REQUESTSINDEX = new$REQUESTSINDEX,
    KVSR = new$KVSR,
    TAXNOTE = new$TAXNOTE,
    DOCNUM = new$DOCNUM,
    REALPAYERORG_REF = new$REALPAYERORG_REF,
    DOCDATE = new$DOCDATE,
    DOCBASE = new$DOCBASE,
    FACT = new$FACT,
    RVERSION = new$RVERSION,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVR = new$KVR,
    KCSR = new$KCSR,
    SUMCOMPLETE = new$SUMCOMPLETE,
    ELDOCREF = new$ELDOCREF,
    REQUESTSINDEX2 = new$REQUESTSINDEX2,
    FEDERALFUNDSREF = new$FEDERALFUNDSREF,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    IFS = new$IFS,
    IFS_CORR = new$IFS_CORR,
    CLSTYPE = new$CLSTYPE,
    NDSNOTE = new$NDSNOTE,
    DOGNUM = new$DOGNUM,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    REJECTCLS = new$REJECTCLS,
    FUNDSSOURCE = new$FUNDSSOURCE,
    DIRECTIONCLS = new$DIRECTIONCLS,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    STIMATEID = new$STIMATEID,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    FAORGTYPE = new$FAORGTYPE,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    FINTYPE = new$FINTYPE,
    INVESTOBJECT = new$INVESTOBJECT,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    REJECTCAUSE = new$REJECTCAUSE,
    STOREDCONTENT = new$STOREDCONTENT,
    INCOMETARGETFUNDS = new$INCOMETARGETFUNDS,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    ANALYTICALPARTITION = new$ANALYTICALPARTITION
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion OR RVersion IS NULL AND :OLD.RVersion IS NULL);

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_INCOMES32_AU_500)
-- Create 15.09.2005
-- - - - - - - - - - - - -

   IF (NEW$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
        VALUES (161, :OLD.ID, SYSDATE);
      DELETE FROM DelRecIndexes
        WHERE (TableID = 161) AND (RecordId = NEW$ID);
   END IF;

END;
/
ALTER TABLE WritExecutionDetail ADD (
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_WREXECDET_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_WREXECDET_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_WREXECDET_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_WREXECDET_IncTarFS ON WritExecutionDetail(IncomeTargetFunds)
/
CREATE INDEX FK_WREXECDET_DirectTarFunds ON WritExecutionDetail(PayTargetFunds)
/
CREATE INDEX FK_WREXECDET_AnalyticFC ON WritExecutionDetail(AnalyticalPartition)
/
ALTER TABLE TB_CorrectionDetail ADD (
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_CORRDET_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_CORRDET_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_CORRDET_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_CORRDET_IncTarFS ON TB_CorrectionDetail(IncomeTargetFunds)
/
CREATE INDEX FK_CORRDET_DirectTarFunds ON TB_CorrectionDetail(PayTargetFunds)
/
CREATE INDEX FK_CORRDET_AnalyticFC ON TB_CorrectionDetail(AnalyticalPartition)
/

CREATE OR REPLACE VIEW CorrectionDetail (
  ID,
  PARENTID,
  BUDGETREF,
  SUMMA,
  CLSTYPE,
  FACIALACC_CLS,
  KVSR,
  KFSR,
  KCSR,
  KVR,
  KESR,
  DIRECTIONCLS,
  MEANSTYPE,
  FACT,
  REGIONCLS,
  FINSOURCE,
  FINTYPE,
  DOCTYPE,
  SUBKESR,
  FUNDSSOURCE,
  KD,
  IFS,
  BUHOPERATIONCLS,
  CHANGEACC_REF,
  CHANGEACC,
  CHANGEORGINN,
  CHANGEORGINN20,
  PROGINDEX,
  RECORDINDEX,
  DOCUMENTPROGINDEX,
  DOCUMENTRECORDINDEX,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SENDERID,
  SENDERRECORDID,
  RVERSION,
  CREATERUSER,
  CREATEDATE,
  UPDATERUSER,
  UPDATEDATE,
  NOTE,
  ISCLSCHANGED,
  PROMISE,
  BUDGETPROMISE,
  EXECDOC,
  OKATO,
  ADDOKATO,
  TRANSFERTCLS,
  ORIGINALCLSSUMMA,
  NOTECLS,
  OPERATIONTYPE,
  REVERSEFLAG,
  EXECINNERNUMBER,
  CLSFIELFCHANGED,
  FAORGTYPE,
  SUBSIDYCLS,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  NOTEQUALEX,
  OKTMO,
  UINCODE,
  INVESTOBJECT,
  CHANGEORGNAME,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  STOREDCONTENT,
  REGPROJECTRESULT,
  INCOMETARGETFUNDS,
  PAYTARGETFUNDS,
  ANALYTICALPARTITION)
AS
  SELECT
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  FROM TB_CorrectionDetail
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_ID
  INSTEAD OF DELETE
  ON CORRECTIONDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_CORRECTIONDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update CorrectionCaption set
  DocChangeDate = SYSDATE,
  RVersion = -1
  where id = :old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_CORRECTIONDETAIL
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_CORRECTIONDETAIL_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate, ProgIndex, SUMMA) values(5504,:old.ID,SYSDATE,:old.ProgIndex, :old.SUMMA);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$INCOMETARGETFUNDS CORRECTIONDETAIL.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS CORRECTIONDETAIL.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION CORRECTIONDETAIL.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  BEGIN

    /*  ,    */
    select
    CorCap.BudgetRef
    into new$BudgetRef   from
    correctioncaption CorCap
    where
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT,
    new$REGPROJECTRESULT,
    new$INCOMETARGETFUNDS,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_IU
  INSTEAD OF UPDATE
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$INCOMETARGETFUNDS CORRECTIONDETAIL.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS CORRECTIONDETAIL.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION CORRECTIONDETAIL.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CORRECTIONDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  /*     \*/
  IF ((new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType IS NULL)) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  ON (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);    
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_100 (tr_correctiondetail_bu_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$buhoperationcls <> :old.buhoperationcls) and (new$progindex = 316)) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_CORRECTIONDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_CORRECTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise )) and
    (new$BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /*  BudgetPromise    Promise=NULL,   Promise */
    if (new$Promise is null and ((new$BudgetPromise is not null and :old.BudgetPromise is null) or
    (new$BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;

    /*  BudgetPromise -   Promise */
    if ((new$BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      new$Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((new$Promise is null) and (:old.Promise is not null)) then
      new$BudgetPromise := null;
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_CORRECTIONDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null and (
    (:old.Promise is null or :old.Promise <> new$Promise) or
    (:old.ExecDoc is null or new$ExecDoc is null or :old.ExecDoc <> new$ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$ExecDoc is null or :old.ExecDoc is null or new$ExecDoc <> :old.ExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_CORRECTIONDETAIL_BU_700)
-- Create 13.08.2007
-- - - - - - - - - - - - -

 if (new$RVersion is null) then
   new$RVersion:=1;
 else
   if ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
     new$RVersion:=:Old.RVersion;
   else
     new$RVersion:=:Old.RVersion+1;
   end if;
 end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_CORRECTIONDETAIL SET
    ID = new$ID,
    PARENTID = new$PARENTID,
    BUDGETREF = new$BUDGETREF,
    SUMMA = new$SUMMA,
    CLSTYPE = new$CLSTYPE,
    FACIALACC_CLS = new$FACIALACC_CLS,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    MEANSTYPE = new$MEANSTYPE,
    FACT = new$FACT,
    REGIONCLS = new$REGIONCLS,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    DOCTYPE = new$DOCTYPE,
    SUBKESR = new$SUBKESR,
    FUNDSSOURCE = new$FUNDSSOURCE,
    KD = new$KD,
    IFS = new$IFS,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CHANGEACC_REF = new$CHANGEACC_REF,
    CHANGEACC = new$CHANGEACC,
    CHANGEORGINN = new$CHANGEORGINN,
    CHANGEORGINN20 = new$CHANGEORGINN20,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    DOCUMENTPROGINDEX = new$DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX = new$DOCUMENTRECORDINDEX,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    RVERSION = new$RVERSION,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    NOTE = new$NOTE,
    ISCLSCHANGED = new$ISCLSCHANGED,
    PROMISE = new$PROMISE,
    BUDGETPROMISE = new$BUDGETPROMISE,
    EXECDOC = new$EXECDOC,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    TRANSFERTCLS = new$TRANSFERTCLS,
    ORIGINALCLSSUMMA = new$ORIGINALCLSSUMMA,
    NOTECLS = new$NOTECLS,
    OPERATIONTYPE = new$OPERATIONTYPE,
    REVERSEFLAG = new$REVERSEFLAG,
    EXECINNERNUMBER = new$EXECINNERNUMBER,
    CLSFIELFCHANGED = new$CLSFIELFCHANGED,
    FAORGTYPE = new$FAORGTYPE,
    SUBSIDYCLS = new$SUBSIDYCLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    NOTEQUALEX = new$NOTEQUALEX,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    INVESTOBJECT = new$INVESTOBJECT,
    CHANGEORGNAME = new$CHANGEORGNAME,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    STOREDCONTENT = new$STOREDCONTENT,
    REGPROJECTRESULT = new$REGPROJECTRESULT,
    INCOMETARGETFUNDS = new$INCOMETARGETFUNDS,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    ANALYTICALPARTITION = new$ANALYTICALPARTITION
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_CORRECTIONDETAIL_AU_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (5504, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=5504) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE AutoSanctionData ADD (
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_ASDATA_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID),
  constraint FK_ASDATA_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_ASDATA_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_ASDATA_IncTarFS ON AutoSanctionData(IncomeTargetFunds)
/
CREATE INDEX FK_ASDATA_DirectTarFunds ON AutoSanctionData(PayTargetFunds)
/
CREATE INDEX FK_ASDATA_AnalyticFC ON AutoSanctionData(AnalyticalPartition)
/
commit work
/
ALTER TABLE TB_PaymentSchedule ADD (
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_PS_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_PS_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_PS_DirectTarFunds ON TB_PaymentSchedule(PayTargetFunds)
/
CREATE INDEX FK_PS_AnalyticFC ON TB_PaymentSchedule(AnalyticalPartition)
/

CREATE OR REPLACE VIEW PaymentSchedule (
  ID,
  ANUMBER,
  PARENTNUMBER,
  KFSR,
  KESR,
  KVSR,
  KCSR,
  KVR,
  MONTH01,
  MONTH02,
  MONTH03,
  MONTH04,
  MONTH05,
  MONTH06,
  MONTH07,
  MONTH08,
  MONTH09,
  MONTH10,
  MONTH11,
  MONTH12,
  SUMMA,
  REGION,
  SUBKESR,
  MEANSTYPE,
  FINSOURCE,
  FINTYPE,
  FACT,
  FACIALACC_CLS,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  ACCEPTDATE,
  LASTADJUSTMENT,
  ACCEPTED,
  LASTACCEPTED,
  PROMISETYPE,
  ADJUSTMENTREF,
  SUMMAPREVIOUSYEAR,
  SUMMAFINPREVIOUSYEAR,
  QUARTER1,
  QUARTER2,
  QUARTER3,
  QUARTER4,
  RECORDINDEX,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DIRECTIONCLS,
  RVERSION,
  BUHOPERATIONCLS,
  MONTH01DELTA,
  MONTH02DELTA,
  MONTH03DELTA,
  MONTH04DELTA,
  MONTH05DELTA,
  MONTH06DELTA,
  MONTH07DELTA,
  MONTH08DELTA,
  MONTH09DELTA,
  MONTH10DELTA,
  MONTH11DELTA,
  MONTH12DELTA,
  QUARTER1DELTA,
  QUARTER2DELTA,
  QUARTER3DELTA,
  QUARTER4DELTA,
  SUMMADELTA,
  NOTE,
  FINYEAR,
  SUMMAYEAR2,
  SUMMAYEAR3,
  SUMMAYEAR2DELTA,
  SUMMAYEAR3DELTA,
  ASSIGNMENTKIND,
  TRANSFERTCLS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXECUTIONREF,
  INNERPROMISENUM,
  ADJUSTMENTNUMBER,
  PROMISENUMBER,
  SUBSIDYCLS,
  AGREEMENTREF,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  PROGINDEX,
  INVESTOBJECT,
  SUMMAYEAR4,
  SUMMAOTHERYEARS,
  SUMMAYEAR4DELTA,
  SUMMAOTHERYEARSDELTA,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  OLDNUMBER,
  PAYMENTCODETYPE,
  REGPROJECTRESULT,
  PAYTARGETFUNDS,
  ANALYTICALPARTITION)
AS
  SELECT
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  FROM TB_PaymentSchedule
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_ID
  INSTEAD OF DELETE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  SummInMonths$ NUMBER(15,2);
  cnt1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_PAYMENTSCHEDULE_BD)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  select count(ID) into cnt1$ from PaymentSchedule where (AdjustmentRef = :old.ID) ;
  if (cnt1$ > 0) then
    RaiseException('EX_Agr_CantDelAdjustmented');
  END IF;

  select count(ID)
  into cnt1$   from FacialFinDetail
  where (SourceBudgetPromise = :old.InnerPromiseNum and SourcePromise=:old.ANumber)
  or (DestBudgetPromise = :old.InnerPromiseNum and DestPromise=:old.ANumber)
  ;
  if (cnt1$ > 0) then
    RaiseException('ex_CantDeleteAgreement');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_PAYMENTSCHEDULE
  WHERE Id = :old.id;

-- - - - - - - - - - - - -
-- AD_10 (TR_PAYMENTSCHEDULE_AD_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update PaymentSchedule set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_500 (TR_PAYMENTSCHEDULE_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SummInMonths$ := :old.Month01+:old.Month02+:old.Month03+:old.Month04+:old.Month05+
  :old.Month06+:old.Month07+:old.Month08+:old.Month09+:old.Month10+:old.Month11+:old.Month12;
  if ((SummInMonths$  < 0.005) and (SummInMonths$  > -0.005)) then
    SummInMonths$ := :old.Summa;
  END IF;
  insert into DelRecIndexes(TableID, RecordID, DeleteDate, ProgIndex, SUMMA) values (113, :old.ID, SYSDATE, :old.ProgIndex, SummInMonths$);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$PAYTARGETFUNDS PAYMENTSCHEDULE.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION PAYMENTSCHEDULE.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*   13.10.01*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    if (new$ProgIndex in (304,314,317,318)) then
      BEGIN
        select a.BudgetRef       into new$BudgetRef from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          select e.BudgetRef
          into new$BudgetRef       from ExecutionDocumentsCaption e
          where e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := null;
      
  else
    /*      , ..     */
    if (new$Accepted = 0) then
      BEGIN
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        /*          */
        select
        InnerPromiseNum, ANumber 
        into PreviousInner$, AdjDocNum$       from Paymentschedule
        where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (PreviousInner$ is null) then
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$ANumber is not null) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls);     
  /*   */
  GetDocumentKESR(null, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER,
    new$PAYMENTCODETYPE,
    new$REGPROJECTRESULT,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$PAYTARGETFUNDS PAYMENTSCHEDULE.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION PAYMENTSCHEDULE.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then 
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then 
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then 
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then 
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then 
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then 
    new$AssignmentKind := 0;
  END IF;
   
  if (new$DirectionCls is null) then 
    new$DirectionCls := 0;
  END IF;
   
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then 
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then 
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then 
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then 
    GetIntConst(60, 15,new$BuhOperationCLS); 
  END IF;
  if (new$Month01 is null) then 
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then 
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then 
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then 
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then 
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then 
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then 
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then 
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then 
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then 
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then 
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then 
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then 
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then 
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then 
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then 
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then 
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then 
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then 
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then 
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then 
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then 
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then 
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then 
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then 
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then 
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then 
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then 
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then 
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then 
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then 
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then 
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then 
    new$SummaDelta := 0; 
  END IF;
  if (new$SummaPreviousYear is null) then 
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then 
    new$SummaFinPreviousYear := 0;
  END IF;
   
  if (new$SummaYear2 is null) then 
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then 
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then 
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then 
    new$SummaOtherYears := 0;
  END IF;
   
  if (new$SummaYear2Delta is null) then 
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then 
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then 
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then 
    new$SummaOtherYearsDelta := 0;
  END IF;
   
  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls); 
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */  
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;
        
  else /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');    
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0) 
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');    
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    REGPROJECTRESULT = new$REGPROJECTRESULT,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    ANALYTICALPARTITION = new$ANALYTICALPARTITION
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TenderProduct ADD (
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  constraint FK_TENDERDET_DirectTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_TENDERDET_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID)
)
/
CREATE INDEX FK_TENDERDET_DirectTarFunds ON TenderProduct(PayTargetFunds)
/
CREATE INDEX FK_TENDERDET_AnalyticFC ON TenderProduct(AnalyticalPartition)
/
ALTER TABLE ReplacementClsDetailInfo ADD (
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  constraint FK_REPCLSDETI_DirTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_REPCLSDETI_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID),
  constraint FK_REPCLSDETI_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID)
)
/
CREATE INDEX FK_REPCLSDETI_DirTarFunds ON ReplacementClsDetailInfo(PayTargetFunds)
/
CREATE INDEX FK_REPCLSDETI_AnalyticFC ON ReplacementClsDetailInfo(AnalyticalPartition)
/
CREATE INDEX FK_REPCLSDETI_IncTarFS ON ReplacementClsDetailInfo(IncomeTargetFunds)
/
ALTER TABLE ReplacementClsDetail ADD (
  PayTargetFunds NUMBER(10),
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  AnalyticalPartition NUMBER(10),
    CHECK((AnalyticalPartition<=2147483647)AND(AnalyticalPartition>-2147483648)),
  IncomeTargetFunds NUMBER(10),
    CHECK((IncomeTargetFunds<=2147483647)AND(IncomeTargetFunds>-2147483648)),
  constraint FK_REPCLSDET_DirTarFunds foreign key (PayTargetFunds) references PayTargetFunds(ID),
  constraint FK_REPCLSDET_AnalyticFC foreign key (AnalyticalPartition) references AnalyticalPartition(ID),
  constraint FK_REPCLSDET_IncTarFS foreign key (IncomeTargetFunds) references IncomeTargetFunds(ID)
)
/
CREATE INDEX FK_REPCLSDET_DirTarFunds ON ReplacementClsDetail(PayTargetFunds)
/
CREATE INDEX FK_REPCLSDET_AnalyticFC ON ReplacementClsDetail(AnalyticalPartition)
/
CREATE INDEX FK_REPCLSDET_IncTarFS ON ReplacementClsDetail(IncomeTargetFunds)
/

commit work
/

-- #########################################################
-- #########################################################
-- Alter_InvetsObject.sql
-- #########################################################
-- #########################################################

ALTER TABLE InvestObject ADD (
  PowerUnitCode VARCHAR2(255),/*    */
  DeveloperCode VARCHAR2(8),/*     */
  CustomerCode VARCHAR2(8),/*     */
  OwningOrgCode VARCHAR2(8),/*  -   */
  BudgetCode VARCHAR2(255),/*    ,    */
  BudgetOKTMO NUMBER(10),/*  ,    */
    CHECK((BudgetOKTMO<=2147483647)AND(BudgetOKTMO>-2147483648)),
  EstimateDocExist NUMBER(10),/*  - */
    CHECK((EstimateDocExist<=2147483647)AND(EstimateDocExist>-2147483648)),
  CostUnitCode VARCHAR2(255),/*   */
  CoFinancing NUMBER(10),/*   */
    CHECK((CoFinancing<=2147483647)AND(CoFinancing>-2147483648)),
  StoredContent VARCHAR2(2000),/*  */
  constraint FK_INVESTOBJECT_BUDGETOKTMO foreign key (BudgetOKTMO) references OKTMO(ID)
)
/
CREATE INDEX FK_INVESTOBJECT_BUDGETOKTMO ON InvestObject(BudgetOKTMO)
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_ClsCorrespondence.sql
-- #########################################################
-- #########################################################

/*   . .*/
create table ClsCorr(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  Name VARCHAR2(255),/*    */
  Code VARCHAR2(20),/*     */
  ExtCode VARCHAR2(1024),/*      */
  BudgetRef NUMBER(10) NOT NULL,/* ,       */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  StartDate DATE,/*      */
  DeleteDate DATE,/*      */
  Note VARCHAR2(255),/*  */
  ExtID VARCHAR2(50),/* UID     ,  GUID */
  ExtRootID VARCHAR2(50),/*   */
  CreateDate DATE,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,
  UpdateDate DATE,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,
  constraint ClsCorr_PK_ID PRIMARY KEY (ID),
  constraint fk_ClsCorr_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID)
)
/
CREATE INDEX fk_ClsCorr_BudgetRef ON ClsCorr(BudgetRef)
/

CREATE INDEX IDX_ClsCorr_EXTID ON ClsCorr (EXTID)
/
-- CREATE TRIGGER TR_ClsCorr_AD_500
CREATE OR REPLACE TRIGGER TR_ClsCorr_AD
  AFTER DELETE
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_ClsCorr_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98111,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_ClsCorr_AI_500
CREATE OR REPLACE TRIGGER TR_ClsCorr_AI
  AFTER INSERT
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_ClsCorr_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98111) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_ClsCorr_AU_500
CREATE OR REPLACE TRIGGER TR_ClsCorr_AU
  AFTER UPDATE
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_ClsCorr_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98111, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98111) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorr_BI_0
CREATE OR REPLACE TRIGGER TR_ClsCorr_BI
  BEFORE INSERT
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorr_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorr_BI_500
CREATE OR REPLACE TRIGGER TR_ClsCorr_BI
  BEFORE INSERT
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorr_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsCorr_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_ClsCorr_BU_0
CREATE OR REPLACE TRIGGER TR_ClsCorr_BU
  BEFORE UPDATE
  ON ClsCorr
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsCorr_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorr_BU_500
CREATE OR REPLACE TRIGGER TR_ClsCorr_BU_500
  BEFORE UPDATE
  ON CLSCORR
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ClsCorr_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on ClsCorr to BUDGET_USERS
/
commit work
/
/*   .  .*/
create table ClsCorrColumns(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  RecordIndex NUMBER(10),
    CHECK((RecordIndex<=2147483647)AND(RecordIndex>-2147483648)),
  ClsOrder NUMBER(10),/*       */
    CHECK((ClsOrder<=2147483647)AND(ClsOrder>-2147483648)),
  ClsName VARCHAR2(1024),/*   */
  ClsType NUMBER(10),/*     */
    CHECK((ClsType<=2147483647)AND(ClsType>-2147483648)),
  CreateDate DATE,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,
  UpdateDate DATE,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,
  constraint ClsCorrColumns_PK_ID PRIMARY KEY (ID),
  constraint FK_ClsCorrColumns_RecordIndex foreign key (RecordIndex) references ClsCorr (Id)
)
/
CREATE INDEX FK_ClsCorrColumns_RecordIndex ON ClsCorrColumns(RecordIndex)
/
-- CREATE TRIGGER TR_ClsCorrColumns_AD_500
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_AD
  AFTER DELETE
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_ClsCorrColumns_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98118,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_AI_500
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_AI
  AFTER INSERT
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_ClsCorrColumns_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98118) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_AU_500
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_AU
  AFTER UPDATE
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_ClsCorrColumns_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98118, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98118) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_BI_0
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_BI
  BEFORE INSERT
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrColumns_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_BI_500
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_BI
  BEFORE INSERT
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrColumns_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsCorrColumns_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_BU_0
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_BU
  BEFORE UPDATE
  ON ClsCorrColumns
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsCorrColumns_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrColumns_BU_500
CREATE OR REPLACE TRIGGER TR_ClsCorrColumns_BU_500
  BEFORE UPDATE
  ON CLSCORRCOLUMNS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ClsCorrColumns_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on ClsCorrColumns to BUDGET_USERS
/

commit work
/

/*   . .*/
create table ClsCorrValues(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  RecordIndex NUMBER(10),
    CHECK((RecordIndex<=2147483647)AND(RecordIndex>-2147483648)),
  KVSR NUMBER(10),/*   */
    CHECK((KVSR<=2147483647)AND(KVSR>-2147483648)),
  KFSR NUMBER(10),/* ,  */
    CHECK((KFSR<=2147483647)AND(KFSR>-2147483648)),
  KCSR NUMBER(10),/*    */
    CHECK((KCSR<=2147483647)AND(KCSR>-2147483648)),
  KVR NUMBER(10),/*   */
    CHECK((KVR<=2147483647)AND(KVR>-2147483648)),
  KESR NUMBER(10),/*  */
    CHECK((KESR<=2147483647)AND(KESR>-2147483648)),
  SubKESR NUMBER(10),/*  */
    CHECK((SubKESR<=2147483647)AND(SubKESR>-2147483648)),
  DirectionCls NUMBER(10),/*  */
    CHECK((DirectionCls<=2147483647)AND(DirectionCls>-2147483648)),
  Variant NUMBER(10),/*  */
    CHECK((Variant<=2147483647)AND(Variant>-2147483648)),
  Fact NUMBER(10),/*  */
    CHECK((Fact<=2147483647)AND(Fact>-2147483648)),
  PayPromiseCls NUMBER(10),/*    */
    CHECK((PayPromiseCls<=2147483647)AND(PayPromiseCls>-2147483648)),
  BudAllocationCls NUMBER(10),/*   */
    CHECK((BudAllocationCls<=2147483647)AND(BudAllocationCls>-2147483648)),
  ContractCostsCls NUMBER(10),/*     */
    CHECK((ContractCostsCls<=2147483647)AND(ContractCostsCls>-2147483648)),
  InvestObject NUMBER(10),/*  */
    CHECK((InvestObject<=2147483647)AND(InvestObject>-2147483648)),
  FinType NUMBER(10),/*    */
    CHECK((FinType<=2147483647)AND(FinType>-2147483648)),
  MeansType NUMBER(10),/*   */
    CHECK((MeansType<=2147483647)AND(MeansType>-2147483648)),
  TargetCls NUMBER(10),/*   */
    CHECK((TargetCls<=2147483647)AND(TargetCls>-2147483648)),
  RegionCls NUMBER(10),/*   */
    CHECK((RegionCls<=2147483647)AND(RegionCls>-2147483648)),
  SubsidyCls NUMBER(10),/*   */
    CHECK((SubsidyCls<=2147483647)AND(SubsidyCls>-2147483648)),
  TransfertCls NUMBER(10),/*    */
    CHECK((TransfertCls<=2147483647)AND(TransfertCls>-2147483648)),
  PlanDocType NUMBER(10),/*   */
    CHECK((PlanDocType<=2147483647)AND(PlanDocType>-2147483648)),
  AssignmentSource NUMBER(10),/*   */
    CHECK((AssignmentSource<=2147483647)AND(AssignmentSource>-2147483648)),
  AssignmentKind NUMBER(10),/*   */
    CHECK((AssignmentKind<=2147483647)AND(AssignmentKind>-2147483648)),
  KD NUMBER(10),/*   */
    CHECK((KD<=2147483647)AND(KD>-2147483648)),
  AnalyticalGroupIFS NUMBER(10),/*        */
    CHECK((AnalyticalGroupIFS<=2147483647)AND(AnalyticalGroupIFS>-2147483648)),
  AnalyticalGroupKD NUMBER(10),/*     */
    CHECK((AnalyticalGroupKD<=2147483647)AND(AnalyticalGroupKD>-2147483648)),
  ProgramCode NUMBER(10),/*    */
    CHECK((ProgramCode<=2147483647)AND(ProgramCode>-2147483648)),
  InnerFinSource NUMBER(10),/*     */
    CHECK((InnerFinSource<=2147483647)AND(InnerFinSource>-2147483648)),
  ReestrType NUMBER(10),/*   */
    CHECK((ReestrType<=2147483647)AND(ReestrType>-2147483648)),
  OKTMO NUMBER(10),/*  */
    CHECK((OKTMO<=2147483647)AND(OKTMO>-2147483648)),
  DocBase NUMBER(10),/*  */
    CHECK((DocBase<=2147483647)AND(DocBase>-2147483648)),
  FundsSource NUMBER(10),/*    */
    CHECK((FundsSource<=2147483647)AND(FundsSource>-2147483648)),
  FinSource NUMBER(10),/*   */
    CHECK((FinSource<=2147483647)AND(FinSource>-2147483648)),
  DocType NUMBER(10),/*   */
    CHECK((DocType<=2147483647)AND(DocType>-2147483648)),
  CommDirectionExpenceCls NUMBER(10),/*   */
    CHECK((CommDirectionExpenceCls<=2147483647)AND(CommDirectionExpenceCls>-2147483648)),
  PayTargetFunds NUMBER(10),/*     */
    CHECK((PayTargetFunds<=2147483647)AND(PayTargetFunds>-2147483648)),
  PayDestination NUMBER(10),/*   */
    CHECK((PayDestination<=2147483647)AND(PayDestination>-2147483648)),
  FacialAcc_CLS NUMBER(10),/*   */
    CHECK((FacialAcc_CLS<=2147483647)AND(FacialAcc_CLS>-2147483648)),
  RegProjectResult NUMBER(10),/*   */
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648)),
  NationalProject NUMBER(10),/*  */
    CHECK((NationalProject<=2147483647)AND(NationalProject>-2147483648)),
  PaymentCodeType NUMBER(10),/*    */
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648)),
  LinkRecord NUMBER(10),/*    */
    CHECK((LinkRecord<=2147483647)AND(LinkRecord>-2147483648)),
  AttachTo NUMBER(10),/*   */
    CHECK((AttachTo<=2147483647)AND(AttachTo>-2147483648)),
  StoredContent NUMBER(10),/*   */
    CHECK((StoredContent<=2147483647)AND(StoredContent>-2147483648)),
  BudgetRef NUMBER(10) NOT NULL,/* ,       */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  Note VARCHAR2(255),/*  */
  ExtID VARCHAR2(50),/* UID     ,  GUID */
  ExtRootID VARCHAR2(50),/*   */
  StartDate DATE,/*      */
  DeleteDate DATE,/*      */
  CreateDate DATE,/*  */
  CREATERUSER VARCHAR2(30) NOT NULL,
  UpdateDate DATE,/*  */
  UPDATERUSER VARCHAR2(30) NOT NULL,
  constraint ClsCorrValues_PK_ID PRIMARY KEY (ID),
  constraint FK_ClsCorrValues_RecIndex foreign key (RecordIndex) references ClsCorr (Id),
  CONSTRAINT FK_ClsCorrValues_FACC FOREIGN KEY (FACIALACC_CLS) REFERENCES TB_FACIALACC_CLS (ID),
  CONSTRAINT FK_ClsCorrValues_FACT FOREIGN KEY (FACT) REFERENCES FACT (ID),
  CONSTRAINT FK_ClsCorrValues_FINSOURCE FOREIGN KEY (FINSOURCE) REFERENCES NOTIFYTYPES (ID),
  CONSTRAINT FK_ClsCorrValues_FINTYPE FOREIGN KEY (FINTYPE) REFERENCES FINTYPE (ID),
  CONSTRAINT FK_ClsCorrValues_KCSR FOREIGN KEY (KCSR) REFERENCES KCSR (ID),
  CONSTRAINT FK_ClsCorrValues_KESR FOREIGN KEY (KESR) REFERENCES KESR (ID),
  CONSTRAINT FK_ClsCorrValues_KFSR FOREIGN KEY (KFSR) REFERENCES KFSR (ID),
  CONSTRAINT FK_ClsCorrValues_KVR FOREIGN KEY (KVR) REFERENCES KVR (ID),
  CONSTRAINT FK_ClsCorrValues_KVSR FOREIGN KEY (KVSR) REFERENCES KVSR (ID),
  CONSTRAINT FK_ClsCorrValues_MEANSTYPE FOREIGN KEY (MEANSTYPE) REFERENCES MEANSTYPE (ID),
  constraint FK_ClsCorrValues_TRNSFRCLS foreign key (TransfertCls) references TB_transfertcls (ID),
  CONSTRAINT FK_ClsCorrValues_DirectCLS FOREIGN KEY (DIRECTIONCLS) REFERENCES DIRECTIONCLS (ID),
  CONSTRAINT FK_ClsCorrValues_SUBKESR FOREIGN KEY (SUBKESR) REFERENCES KESRSUBCODE (ID),
  constraint FK_ClsCorrValues_AK foreign key (AssignmentKind) references AssignmentKind(id),
  constraint FK_ClsCorrValues_BudgetRef foreign key (BudgetRef) references TB_Budgets_s(ID),
  constraint FK_ClsCorrValues_SubsidyCls foreign key (SubsidyCls) references SubsidyCls (ID),
  constraint FK_ClsCorrValues_Variant foreign key (Variant) references VariantCls (ID),
  constraint FK_ClsCorrValues_RegionCls foreign key (RegionCls) references RegionCls (ID),
  constraint FK_ClsCorrValues_PDType foreign key (PlanDocType) references PlanDocType (ID),
  constraint FK_ClsCorrValues_AS foreign key (AssignmentSource) references AssignmentSource (ID),
  constraint FK_ClsCorrValues_KD foreign key (KD) references TB_KD (ID),
  constraint FK_ClsCorrValues_AG_IFS foreign key (AnalyticalGroupIFS) references AnalyticalGroupIFS (ID),
  constraint FK_ClsCorrValues_AG_KD foreign key (AnalyticalGroupKD) references AnalyticalGroupKD (ID),
  constraint FK_ClsCorrValues_PC foreign key (ProgramCode) references ProgramCode (ID),
  constraint FK_ClsCorrValues_IFS foreign key (InnerFinSource) references TB_InnerFinSource (ID),
  constraint FK_ClsCorrValues_ReestrType foreign key (ReestrType) references ReestrType (ID),
  constraint FK_ClsCorrValues_OKTMO foreign key (OKTMO) references OKTMO (ID),
  constraint FK_ClsCorrValues_DocBase foreign key (DocBase) references DocBase (ID),
  constraint FK_ClsCorrValues_FS foreign key (FundsSource) references FundsSource (ID),
  constraint FK_ClsCorrValues_DocType foreign key (DocType) references DocTypes (ID),
  constraint FK_ClsCorrValues_PTF foreign key (PayTargetFunds) references PayTargetFunds (ID),
  constraint FK_ClsCorrValues_RPR foreign key (RegProjectResult) references RegProjectResult (ID),
  constraint FK_ClsCorrValues_NP foreign key (NationalProject) references NationalProject (ID),
  constraint FK_ClsCorrValues_BA_CLS foreign key (BUDALLOCATIONCLS) references BUDALLOCATIONCLS (ID),
  constraint FK_ClsCorrValues_P_PROM_CLS foreign key (PAYPROMISECLS) references PAYPROMISECLS (ID),
  constraint FK_ClsCorrValues_InvObject foreign key (InvestObject) references InvestObject(ID),
  constraint FK_ClsCorrValues_KRKS foreign key (ContractCostsCls) references ContractCostsCls(ID),
  constraint FK_ClsCorrValues_PaymentCT foreign key (PaymentCodeType) references PaymentCodeType(ID),
  constraint FK_ClsCorrValues_TargCls foreign key (TargetCls) references TargetCls(ID)
)
/
CREATE INDEX FK_ClsCorrValues_RecIndex ON ClsCorrValues(RecordIndex)
/
CREATE INDEX FK_ClsCorrValues_FACC ON ClsCorrValues(FACIALACC_CLS)
/
CREATE INDEX FK_ClsCorrValues_FACT ON ClsCorrValues(FACT)
/
CREATE INDEX FK_ClsCorrValues_FINSOURCE ON ClsCorrValues(FINSOURCE)
/
CREATE INDEX FK_ClsCorrValues_FINTYPE ON ClsCorrValues(FINTYPE)
/
CREATE INDEX FK_ClsCorrValues_KCSR ON ClsCorrValues(KCSR)
/
CREATE INDEX FK_ClsCorrValues_KESR ON ClsCorrValues(KESR)
/
CREATE INDEX FK_ClsCorrValues_KFSR ON ClsCorrValues(KFSR)
/
CREATE INDEX FK_ClsCorrValues_KVR ON ClsCorrValues(KVR)
/
CREATE INDEX FK_ClsCorrValues_KVSR ON ClsCorrValues(KVSR)
/
CREATE INDEX FK_ClsCorrValues_MEANSTYPE ON ClsCorrValues(MEANSTYPE)
/
CREATE INDEX FK_ClsCorrValues_TRNSFRCLS ON ClsCorrValues(TransfertCls)
/
CREATE INDEX FK_ClsCorrValues_DirectCLS ON ClsCorrValues(DIRECTIONCLS)
/
CREATE INDEX FK_ClsCorrValues_SUBKESR ON ClsCorrValues(SUBKESR)
/
CREATE INDEX FK_ClsCorrValues_AK ON ClsCorrValues(AssignmentKind)
/
CREATE INDEX FK_ClsCorrValues_BudgetRef ON ClsCorrValues(BudgetRef)
/
CREATE INDEX FK_ClsCorrValues_SubsidyCls ON ClsCorrValues(SubsidyCls)
/
CREATE INDEX FK_ClsCorrValues_Variant ON ClsCorrValues(Variant)
/
CREATE INDEX FK_ClsCorrValues_RegionCls ON ClsCorrValues(RegionCls)
/
CREATE INDEX FK_ClsCorrValues_PDType ON ClsCorrValues(PlanDocType)
/
CREATE INDEX FK_ClsCorrValues_AS ON ClsCorrValues(AssignmentSource)
/
CREATE INDEX FK_ClsCorrValues_KD ON ClsCorrValues(KD)
/
CREATE INDEX FK_ClsCorrValues_AG_IFS ON ClsCorrValues(AnalyticalGroupIFS)
/
CREATE INDEX FK_ClsCorrValues_AG_KD ON ClsCorrValues(AnalyticalGroupKD)
/
CREATE INDEX FK_ClsCorrValues_PC ON ClsCorrValues(ProgramCode)
/
CREATE INDEX FK_ClsCorrValues_IFS ON ClsCorrValues(InnerFinSource)
/
CREATE INDEX FK_ClsCorrValues_ReestrType ON ClsCorrValues(ReestrType)
/
CREATE INDEX FK_ClsCorrValues_OKTMO ON ClsCorrValues(OKTMO)
/
CREATE INDEX FK_ClsCorrValues_DocBase ON ClsCorrValues(DocBase)
/
CREATE INDEX FK_ClsCorrValues_FS ON ClsCorrValues(FundsSource)
/
CREATE INDEX FK_ClsCorrValues_DocType ON ClsCorrValues(DocType)
/
CREATE INDEX FK_ClsCorrValues_PTF ON ClsCorrValues(PayTargetFunds)
/
CREATE INDEX FK_ClsCorrValues_RPR ON ClsCorrValues(RegProjectResult)
/
CREATE INDEX FK_ClsCorrValues_NP ON ClsCorrValues(NationalProject)
/
CREATE INDEX FK_ClsCorrValues_BA_CLS ON ClsCorrValues(BUDALLOCATIONCLS)
/
CREATE INDEX FK_ClsCorrValues_P_PROM_CLS ON ClsCorrValues(PAYPROMISECLS)
/
CREATE INDEX FK_ClsCorrValues_InvObject ON ClsCorrValues(InvestObject)
/
CREATE INDEX FK_ClsCorrValues_KRKS ON ClsCorrValues(ContractCostsCls)
/
CREATE INDEX FK_ClsCorrValues_PaymentCT ON ClsCorrValues(PaymentCodeType)
/
CREATE INDEX FK_ClsCorrValues_TargCls ON ClsCorrValues(TargetCls)
/
-- CREATE TRIGGER TR_ClsCorrValues_AD_500
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_AD
  AFTER DELETE
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (TR_ClsCorrValues_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98112,:old.ID,SYSDATE);

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_AI_500
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_AI
  AFTER INSERT
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (TR_ClsCorrValues_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98112) and (RecordId = :new.ID);

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_AU_500
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_AU
  AFTER UPDATE
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (TR_ClsCorrValues_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98112, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98112) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_BI_0
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BI
  BEFORE INSERT
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrValues_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_BI_500
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BI
  BEFORE INSERT
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrValues_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsCorrValues_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_BU_0
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BU
  BEFORE UPDATE
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsCorrValues_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
-- CREATE TRIGGER TR_ClsCorrValues_BU_500
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BU_500
  BEFORE UPDATE
  ON CLSCORRVALUES
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ClsCorrValues_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on ClsCorrValues to BUDGET_USERS
/
commit work
/

-- #########################################################
-- #########################################################
-- alter_TargetCls_Note.sql
-- #########################################################
-- #########################################################

/*      " "  */
ALTER TABLE targetcls ADD (
  Note VARCHAR2(1000)/*  */
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Create_Index_UQClsCorr.sql
-- #########################################################
-- #########################################################

ALTER TABLE CLSCORR ADD (
  CONSTRAINT UQ_CLSCORR UNIQUE (CODE,BUDGETREF,EXTID)
)
/
COMMIT WORK 
/

-- #########################################################
-- #########################################################
-- Create_TR_CLSCORRVALUES_BI_100.sql
-- #########################################################
-- #########################################################

-- CREATE TRIGGER TR_CLSCORRVALUES_BI_100
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BI
  BEFORE INSERT
  ON ClsCorrValues
  FOR EACH ROW
DECLARE
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrValues_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_CLSCORRVALUES_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(ID ) INTO CNT$1
  from CLSCORRVALUES
  where
  (        ((ANALYTICALGROUPIFS = :new.ANALYTICALGROUPIFS) or ((ANALYTICALGROUPIFS is null) and (:new.ANALYTICALGROUPIFS is null))) and
  ((ANALYTICALGROUPKD = :new.ANALYTICALGROUPKD) or ((ANALYTICALGROUPKD is null) and (:new.ANALYTICALGROUPKD is null))) and
  ((ASSIGNMENTKIND = :new.ASSIGNMENTKIND) or ((ASSIGNMENTKIND is null) and (:new.ASSIGNMENTKIND is null))) and
  ((ASSIGNMENTSOURCE = :new.ASSIGNMENTSOURCE) or ((ASSIGNMENTSOURCE is null) and (:new.ASSIGNMENTSOURCE is null))) and
  ((ATTACHTO = :new.ATTACHTO) or ((ATTACHTO is null) and (:new.ATTACHTO is null))) and
  ((BUDALLOCATIONCLS = :new.BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (:new.BUDALLOCATIONCLS is null))) and
  (BUDGETREF = :new.BUDGETREF) and
  ((COMMDIRECTIONEXPENCECLS = :new.COMMDIRECTIONEXPENCECLS) or ((COMMDIRECTIONEXPENCECLS is null) and (:new.COMMDIRECTIONEXPENCECLS is null))) and
  ((PayTargetFunds = :new.PayTargetFunds) or ((PayTargetFunds is null) and (:new.PayTargetFunds is null))) and
  ((CONTRACTCOSTSCLS = :new.CONTRACTCOSTSCLS) or ((CONTRACTCOSTSCLS is null) and (:new.CONTRACTCOSTSCLS is null))) and
  ((DIRECTIONCLS = :new.DIRECTIONCLS) or ((DIRECTIONCLS is null) and (:new.DIRECTIONCLS is null))) and
  ((DOCBASE = :new.DOCBASE) or ((DOCBASE is null) and (:new.DOCBASE is null))) and
  ((DOCTYPE = :new.DOCTYPE) or ((DOCTYPE is null) and (:new.DOCTYPE is null))) and
  ((FACIALACC_CLS = :new.FACIALACC_CLS) or ((FACIALACC_CLS is null) and (:new.FACIALACC_CLS is null))) and
  ((FACT = :new.FACT) or ((FACT is null) and (:new.FACT is null))) and
  ((FINSOURCE = :new.FINSOURCE) or ((FINSOURCE is null) and (:new.FINSOURCE is null))) and
  ((FINTYPE = :new.FINTYPE) or ((FINTYPE is null) and (:new.FINTYPE is null))) and
  ((FUNDSSOURCE = :new.FUNDSSOURCE) or ((FUNDSSOURCE is null) and (:new.FUNDSSOURCE is null))) and
  ((INNERFINSOURCE = :new.INNERFINSOURCE) or ((INNERFINSOURCE is null) and (:new.INNERFINSOURCE is null))) and
  ((INVESTOBJECT = :new.INVESTOBJECT) or ((INVESTOBJECT is null) and (:new.INVESTOBJECT is null))) and
  ((KCSR = :new.KCSR) or ((KCSR is null) and (:new.KCSR is null))) and
  ((KD = :new.KD) or ((KD is null) and (:new.KD is null))) and
  ((KESR = :new.KESR) or ((KESR is null) and (:new.KESR is null))) and
  ((KFSR = :new.KFSR) or ((KFSR is null) and (:new.KFSR is null))) and
  ((KVR = :new.KVR) or ((KVR is null) and (:new.KVR is null))) and
  ((KVSR = :new.KVSR) or ((KVSR is null) and (:new.KVSR is null))) and
  ((MEANSTYPE = :new.MEANSTYPE) or ((MEANSTYPE is null) and (:new.MEANSTYPE is null))) and
  ((REGPROJECTRESULT = :new.REGPROJECTRESULT) or ((REGPROJECTRESULT is null) and (:new.REGPROJECTRESULT is null))) and
  ((NATIONALPROJECT = :new.NATIONALPROJECT) or ((NATIONALPROJECT is null) and (:new.NATIONALPROJECT is null))) and
  ((OKTMO = :new.OKTMO) or ((OKTMO is null) and (:new.OKTMO is null))) and
  ((PAYDESTINATION = :new.PAYDESTINATION) or ((PAYDESTINATION is null) and (:new.PAYDESTINATION is null))) and
  ((PAYPROMISECLS = :new.PAYPROMISECLS) or ((PAYPROMISECLS is null) and (:new.PAYPROMISECLS is null))) and
  ((PLANDOCTYPE = :new.PLANDOCTYPE) or ((PLANDOCTYPE is null) and (:new.PLANDOCTYPE is null))) and
  ((PROGRAMCODE = :new.PROGRAMCODE) or ((PROGRAMCODE is null) and (:new.PROGRAMCODE is null))) and
  ((REESTRTYPE = :new.REESTRTYPE) or ((REESTRTYPE is null) and (:new.REESTRTYPE is null))) and
  ((REGIONCLS = :new.REGIONCLS) or ((REGIONCLS is null) and (:new.REGIONCLS is null))) and
  ((SUBKESR = :new.SUBKESR) or ((SUBKESR is null) and (:new.SUBKESR is null))) and
  ((SUBSIDYCLS = :new.SUBSIDYCLS) or ((SUBSIDYCLS is null) and (:new.SUBSIDYCLS is null))) and
  ((TARGETCLS = :new.TARGETCLS) or ((TARGETCLS is null) and (:new.TARGETCLS is null))) and
  ((TRANSFERTCLS = :new.TRANSFERTCLS) or ((TRANSFERTCLS is null) and (:new.TRANSFERTCLS is null))) and
  ((VARIANT = :new.VARIANT) or ((VARIANT is null) and (:new.VARIANT is null))) and
  (RECORDINDEX = :new.RECORDINDEX)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsCorrValues_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
COMMIT WORK 
/

-- #########################################################
-- #########################################################
-- Create_TR_CLSCORRVALUES_BU_100.sql
-- #########################################################
-- #########################################################

-- CREATE TRIGGER TR_CLSCORRVALUES_BU_100
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BU
  BEFORE UPDATE
  ON ClsCorrValues
  FOR EACH ROW
DECLARE
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsCorrValues_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_CLSCORRVALUES_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(ID ) INTO CNT$1
  from CLSCORRVALUES
  where
  (        ((ANALYTICALGROUPIFS = :new.ANALYTICALGROUPIFS) or ((ANALYTICALGROUPIFS is null) and (:new.ANALYTICALGROUPIFS is null))) and
  ((ANALYTICALGROUPKD = :new.ANALYTICALGROUPKD) or ((ANALYTICALGROUPKD is null) and (:new.ANALYTICALGROUPKD is null))) and
  ((ASSIGNMENTKIND = :new.ASSIGNMENTKIND) or ((ASSIGNMENTKIND is null) and (:new.ASSIGNMENTKIND is null))) and
  ((ASSIGNMENTSOURCE = :new.ASSIGNMENTSOURCE) or ((ASSIGNMENTSOURCE is null) and (:new.ASSIGNMENTSOURCE is null))) and
  ((ATTACHTO = :new.ATTACHTO) or ((ATTACHTO is null) and (:new.ATTACHTO is null))) and
  ((BUDALLOCATIONCLS = :new.BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (:new.BUDALLOCATIONCLS is null))) and
  (BUDGETREF = :new.BUDGETREF) and
  ((COMMDIRECTIONEXPENCECLS = :new.COMMDIRECTIONEXPENCECLS) or ((COMMDIRECTIONEXPENCECLS is null) and (:new.COMMDIRECTIONEXPENCECLS is null))) and
  ((PayTargetFunds = :new.PayTargetFunds) or ((PayTargetFunds is null) and (:new.PayTargetFunds is null))) and
  ((CONTRACTCOSTSCLS = :new.CONTRACTCOSTSCLS) or ((CONTRACTCOSTSCLS is null) and (:new.CONTRACTCOSTSCLS is null))) and
  ((DIRECTIONCLS = :new.DIRECTIONCLS) or ((DIRECTIONCLS is null) and (:new.DIRECTIONCLS is null))) and
  ((DOCBASE = :new.DOCBASE) or ((DOCBASE is null) and (:new.DOCBASE is null))) and
  ((DOCTYPE = :new.DOCTYPE) or ((DOCTYPE is null) and (:new.DOCTYPE is null))) and
  ((FACIALACC_CLS = :new.FACIALACC_CLS) or ((FACIALACC_CLS is null) and (:new.FACIALACC_CLS is null))) and
  ((FACT = :new.FACT) or ((FACT is null) and (:new.FACT is null))) and
  ((FINSOURCE = :new.FINSOURCE) or ((FINSOURCE is null) and (:new.FINSOURCE is null))) and
  ((FINTYPE = :new.FINTYPE) or ((FINTYPE is null) and (:new.FINTYPE is null))) and
  ((FUNDSSOURCE = :new.FUNDSSOURCE) or ((FUNDSSOURCE is null) and (:new.FUNDSSOURCE is null))) and
  ((INNERFINSOURCE = :new.INNERFINSOURCE) or ((INNERFINSOURCE is null) and (:new.INNERFINSOURCE is null))) and
  ((INVESTOBJECT = :new.INVESTOBJECT) or ((INVESTOBJECT is null) and (:new.INVESTOBJECT is null))) and
  ((KCSR = :new.KCSR) or ((KCSR is null) and (:new.KCSR is null))) and
  ((KD = :new.KD) or ((KD is null) and (:new.KD is null))) and
  ((KESR = :new.KESR) or ((KESR is null) and (:new.KESR is null))) and
  ((KFSR = :new.KFSR) or ((KFSR is null) and (:new.KFSR is null))) and
  ((KVR = :new.KVR) or ((KVR is null) and (:new.KVR is null))) and
  ((KVSR = :new.KVSR) or ((KVSR is null) and (:new.KVSR is null))) and
  ((MEANSTYPE = :new.MEANSTYPE) or ((MEANSTYPE is null) and (:new.MEANSTYPE is null))) and
  ((REGPROJECTRESULT = :new.REGPROJECTRESULT) or ((REGPROJECTRESULT is null) and (:new.REGPROJECTRESULT is null))) and
  ((NATIONALPROJECT = :new.NATIONALPROJECT) or ((NATIONALPROJECT is null) and (:new.NATIONALPROJECT is null))) and
  ((OKTMO = :new.OKTMO) or ((OKTMO is null) and (:new.OKTMO is null))) and
  ((PAYDESTINATION = :new.PAYDESTINATION) or ((PAYDESTINATION is null) and (:new.PAYDESTINATION is null))) and
  ((PAYPROMISECLS = :new.PAYPROMISECLS) or ((PAYPROMISECLS is null) and (:new.PAYPROMISECLS is null))) and
  ((PLANDOCTYPE = :new.PLANDOCTYPE) or ((PLANDOCTYPE is null) and (:new.PLANDOCTYPE is null))) and
  ((PROGRAMCODE = :new.PROGRAMCODE) or ((PROGRAMCODE is null) and (:new.PROGRAMCODE is null))) and
  ((REESTRTYPE = :new.REESTRTYPE) or ((REESTRTYPE is null) and (:new.REESTRTYPE is null))) and
  ((REGIONCLS = :new.REGIONCLS) or ((REGIONCLS is null) and (:new.REGIONCLS is null))) and
  ((SUBKESR = :new.SUBKESR) or ((SUBKESR is null) and (:new.SUBKESR is null))) and
  ((SUBSIDYCLS = :new.SUBSIDYCLS) or ((SUBSIDYCLS is null) and (:new.SUBSIDYCLS is null))) and
  ((TARGETCLS = :new.TARGETCLS) or ((TARGETCLS is null) and (:new.TARGETCLS is null))) and
  ((TRANSFERTCLS = :new.TRANSFERTCLS) or ((TRANSFERTCLS is null) and (:new.TRANSFERTCLS is null))) and
  ((VARIANT = :new.VARIANT) or ((VARIANT is null) and (:new.VARIANT is null))) and
  (RECORDINDEX = :new.RECORDINDEX) and
  (ID <> :old.ID)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

END;
/
COMMIT WORK 
/

-- #########################################################
-- #########################################################
-- Add_QueryOrder_To_PayDocExch.sql
-- #########################################################
-- #########################################################

/*     QueryOrder   PAYDOCEXCHANGE
     
  0,       0 */
ALTER TABLE PAYDOCEXCHANGE ADD (
  QUERYORDER NUMBER(10),
    CHECK((QUERYORDER<=2147483647)AND(QUERYORDER>-2147483648))
)
/
ALTER TABLE PAYDOCEXCHANGE DROP CONSTRAINT IND_PAYDOCEXCH_PAYDOCREF DROP INDEX
/
ALTER TABLE PAYDOCEXCHANGE ADD (
  CONSTRAINT IND_PAYDOCEXCH_PAYDOCREF UNIQUE (PAYDOCREF, CODEFORMAT, QUERYORDER)
)
/
-- CREATE TRIGGER tr_paydocexchange_bi
CREATE OR REPLACE TRIGGER TR_PAYDOCEXCHANGE_BI
  BEFORE INSERT
  ON PAYDOCEXCHANGE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYDOCEXCHANGE_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null)     then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.status is null) then 
    :new.status := 0;
  END IF;
  if (:new.reestrnumber  is null) then 
    :new.reestrnumber := null;
  END IF;
  if (:new.QUERYORDER is null) then 
    :new.QUERYORDER := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYDOCEXCHANGE_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
-- CREATE TRIGGER tr_paydocexchange_bu
CREATE OR REPLACE TRIGGER TR_PAYDOCEXCHANGE_BU
  BEFORE UPDATE
  ON PAYDOCEXCHANGE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYDOCEXCHANGE_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.status is null) then 
    :new.status := 0;
  END IF;
  if (:new.reestrnumber  is null) then 
    :new.reestrnumber := null;
  END IF;
  if (:new.QUERYORDER is null) then 
    :new.QUERYORDER := 0;
  END IF;

END;
/
ALTER TRIGGER TR_PAYDOCEXCHANGE_BU_500 DISABLE
/
update PAYDOCEXCHANGE set
  QUERYORDER = 0
/
ALTER TRIGGER TR_PAYDOCEXCHANGE_BU_500 ENABLE
/
commit work
/


ALTER TABLE PAYDOCEXCHANGE MODIFY(QUERYORDER NOT NULL)
/

-- #########################################################
-- #########################################################
-- Alter_Country_size150.sql
-- #########################################################
-- #########################################################


alter trigger TR_ORGANIZATIONS_IU DISABLE
/

alter table TB_Organizations modify (Country varchar2(150))
/

alter table TB_Agreements modify(Executer_Country varchar2(150))
/

alter table Suppliers modify (Country varchar2(150))
/

alter trigger TR_ORGANIZATIONS_IU ENABLE
/  

commit work
/




-- #########################################################
-- #########################################################
-- Create_ED_OUT_FACIALACC.sql
-- #########################################################
-- #########################################################

/*        */
CREATE TABLE ED_OUT_FACIALACC(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  ELDOCREF NUMBER(10),
    CHECK((ELDOCREF<=2147483647)AND(ELDOCREF>-2147483648)),
  SendTimestamp DATE,
  LogPath VARCHAR2(255),
  PROCNOTE VARCHAR2(4000),
  STOREDPAYMENTCONTENT VARCHAR2(4000),
  FACode VARCHAR2(20),
  FAOpenDate NUMBER,
  FACloseDate NUMBER,
  FAOrgName VARCHAR2(1000),
  FAOrgINN VARCHAR2(10),
  FAOrgKPP VARCHAR2(10),
  FAOrgOGRN VARCHAR2(20),
  FACode_Old VARCHAR2(20),
  FAUpdateDate NUMBER,
  IdDoc VARCHAR2(36),/*  .   */
  KND VARCHAR2(10),
  MessageNumber NUMBER(10),
    CHECK((MessageNumber<=2147483647)AND(MessageNumber>-2147483648)),
  MessageDate NUMBER,
  MessageType VARCHAR2(1),/*   */
  MessageFlag VARCHAR2(1),/*   */
  OrgType VARCHAR2(1),/*   */
  ServiceOrgExecPost VARCHAR2(100),/*   ,     */
  ServiceOrgExecFIO VARCHAR2(100),/*   ,     */
  ServiceOrgTel VARCHAR2(20),
  IdDocCancelled VARCHAR2(36),/*    */
  ServiceOrgINN VARCHAR2(10),
  ServiceOrgKPP VARCHAR2(10),
  ServiceOrgCode VARCHAR2(4),/*   ,      */
  ServiceOrgName VARCHAR2(1000),
  ExtProcDate NUMBER,
  ExtProcCode VARCHAR2(1),
  ExtProcErrCode VARCHAR2(2),
  ExtProcErrElemCode VARCHAR2(50),
  CREATERUSER VARCHAR2(30) NOT NULL,
  CREATEDATE DATE NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  UPDATEDATE DATE NOT NULL,
  constraint PK_OUT_FACIALACC PRIMARY KEY (ID)
)
/
ALTER TABLE ED_OUT_FACIALACC ADD (
  CONSTRAINT FK_ED_OUT_FA_ELDOCREF FOREIGN KEY (ELDOCREF) REFERENCES PAYDOCEXCHANGE (ID)
)
/
CREATE INDEX FK_ED_OUT_FA_ELDOCREF ON ED_OUT_FACIALACC(ELDOCREF)
/
-- CREATE TRIGGER TR_ED_OUT_FACIALACC_BI
CREATE OR REPLACE TRIGGER TR_ED_OUT_FACIALACC_BI
  BEFORE INSERT
  ON ED_OUT_FACIALACC
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ED_OUT_FACIALACC_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_ED_OUT_FACIALACC_BI_500
CREATE OR REPLACE TRIGGER TR_ED_OUT_FACIALACC_BI
  BEFORE INSERT
  ON ED_OUT_FACIALACC
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ED_OUT_FACIALACC_BI)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ED_OUT_FACIALACC_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_ED_OUT_FACIALACC_BU_500
CREATE OR REPLACE TRIGGER TR_ED_OUT_FACIALACC_BU_500
  BEFORE UPDATE
  ON ED_OUT_FACIALACC
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ED_OUT_FACIALACC_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdaterUser := user;
  :new.UpdateDate := SYSDATE;

END;
/
GRANT SELECT, INSERT, UPDATE, DELETE ON ED_OUT_FACIALACC TO BUDGET_USERS
/
commit work
/



-- #########################################################
-- #########################################################
-- AlterTrigger_TR_CORRECTIONDETAIL_BI.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_CORRECTIONDETAIL_BI
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$INCOMETARGETFUNDS CORRECTIONDETAIL.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS CORRECTIONDETAIL.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION CORRECTIONDETAIL.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  BEGIN

    /*  ,    */
    SELECT
    CorCap.BudgetRef
    INTO new$BudgetRef   FROM
    correctioncaption CorCap
    WHERE
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  if ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, new$transfertcls, NULL, new$meanstype,
    new$targetcls,new$targetcls); 
  END IF;
  /*   */
  GetDocumentKESR(NULL, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT,
    new$REGPROJECTRESULT,
    new$INCOMETARGETFUNDS,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_FACIALFINDETAIL_BI_110.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_FACIALFINDETAIL_BI_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
  i_fintype$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;
   
  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;  
  END IF;
     
  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;   
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then 
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then 
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;
     
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  IF (new$progindex=76) THEN
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex IN (66, 67, 76)) AND (new$DestPromise IS NOT NULL) AND
        (new$SourcePromise = new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex IN (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
   
  /*       */
  IF ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, new$sourcetransfertcls, NULL, new$sourcemeanstype,
    new$sourcetargetcls,new$sourcetargetcls);
    GETTARGETCLS(NULL, new$desttransfertcls, NULL, new$destmeanstype,
    new$desttargetcls,new$desttargetcls);
     
  END IF;
  /*      */
  GetDocumentKESR(NULL, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(NULL, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC,
    new$SOURCEREGPROJECTRESULT,
    new$DESTREGPROJECTRESULT,
    new$SOURCEINCOMETARGETFUNDS,
    new$DESTINCOMETARGETFUNDS,
    new$SOURCEPAYTARGETFUNDS,
    new$DESTPAYTARGETFUNDS,
    new$SOURCEANALYTICALPARTITION,
    new$DESTANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_LIMITFINDETAIL_BI.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_LIMITFINDETAIL_BI
CREATE OR REPLACE TRIGGER TR_LIMITFINDETAIL_BI
  BEFORE INSERT
  ON LIMITFINDETAIL
  FOR EACH ROW
DECLARE
  DFAcc$ NUMBER(10);
  SFacialAcc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_LIMITFINDETAIL_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*  (   ) */
  IF ((:new.ProgIndex = 56) AND ((:new.DFAccount IS NULL) OR (:new.SourceFacialAcc IS NULL))) THEN
    BEGIN
      SELECT
      DFAccount, SourceFacialAcc
      INTO
      DFAcc$, SFacialAcc$     FROM
      RequestFinCaption
      WHERE
      (id = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (:new.DFAccount IS NULL) THEN 
      :new.DFAccount := DFAcc$;
    END IF;
    IF (:new.SourceFacialAcc IS NULL) THEN 
      :new.SourceFacialAcc := SFacialAcc$;
      
    END IF;
  END IF;
  /*     */
  IF ((:new.ProgIndex = 57) AND ((:new.DFAccount IS NULL) OR (:new.SourceFacialAcc IS NULL))) THEN
    BEGIN
      SELECT
      DFAccount, SourceFacialAcc
      INTO
      DFAcc$, SFacialAcc$     FROM
      LimitNotifyCaption
      WHERE
      (id = :new.RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (:new.DFAccount IS NULL) THEN 
      :new.DFAccount := DFAcc$;
    END IF;
    IF (:new.SourceFacialAcc IS NULL) THEN 
      :new.SourceFacialAcc := SFacialAcc$;
      
    END IF;
  END IF;
  BEGIN
    /*        , */
    SELECT
    AcceptDate
    INTO
    :new.AcceptDate   FROM
    LimitNotifyCaption
    WHERE
    (id = :new.RecordIndex)
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /* 1 - ., 2 - ., 3 -  . */
  IF (:new.RequestFlag IS NULL) THEN 
    :new.RequestFlag := 3;
  END IF;
  IF (:new.Summa IS NULL) THEN 
    :new.Summa := 0;
  END IF;
  IF (:new.AcceptSumma IS NULL) THEN 
    :new.AcceptSumma := 0;
  END IF;
      
  IF (:new.AcceptDate IS not NULL)
  THEN 
    IF((:new.RequestFlag = 3) AND (:new.AcceptSumma = 0)) THEN 
      :new.AcceptSumma := :new.Summa;
    END IF;
    IF(:new.RequestFlag = 3) THEN 
      :new.RequestFlag := 2; 
     
    END IF;
  END IF;
   
  IF (:new.id IS NULL) THEN 
    select g_shared.nextval into :new.id from dual;
  END IF;
  IF (:new.KVSR IS NULL) THEN 
    :new.KVSR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN 
    :new.KCSR := 0;
  END IF;
  IF (:new.KFSR IS NULL) THEN 
    :new.KFSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN 
    :new.KVR := 0;
  END IF;
  IF (:new.SubKESR IS NULL) THEN 
    :new.SubKESR := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN 
    :new.DirectionCls := 0;
  END IF;
  /*     */
  IF (:new.FundsSource IS NULL) THEN 
    :new.FundsSource := 0;
  END IF;
  IF (:new.FacialAcc IS NULL) THEN 
    :new.FacialAcc := 0;
  END IF;
  IF (:new.RegionCLS IS NULL) THEN
    BEGIN
      SELECT fac.RegionCLS       INTO :new.regioncls FROM facialacc_cls fac
      WHERE fac.id = :new.facialacc
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF (:new.FinSource IS NULL) THEN 
    :new.FinSource := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN 
    :new.FinType := 0;
  END IF;
  IF (:new.Fact IS NULL) THEN  
    :new.Fact := 0;
  END IF;
  IF (:new.DocTypes IS NULL) THEN 
    :new.DocTypes := 0;
  END IF;
  IF (:new.MeansType IS NULL) THEN 
    :new.MeansType := 0;
  END IF;
  IF (:new.SourceFacialAcc IS NULL) THEN 
    :new.SourceFacialAcc := 0;
  END IF;
  /*   .     */
  IF (:new.IFS IS NULL) THEN 
    :new.IFS := 0;
  END IF;
  IF (:new.BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,:new.BuhOperationCLS);
  END IF;
    
  /*  .    ,    */
  IF ((:new.BudgetRef IS NULL) OR (:new.BudgetRef = 0)) THEN
    BEGIN
      SELECT lim.BudgetRef         INTO :new.BudgetRef FROM LimitFinCaption lim
      WHERE lim.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,     */
  IF ((:new.BudgetRef IS NULL) OR (:new.BudgetRef = 0)) THEN
    BEGIN
      SELECT fa.BudgetRef       INTO :new.BudgetRef FROM FacialAcc_Cls fa
      WHERE fa.Id = :new.FacialAcc
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*  ,    */
  IF ((:new.BudgetRef IS NULL) OR (:new.BudgetRef = 0))
  THEN 
    GetIntConst(-1, 3,:new.BudgetRef);
  END IF;
    
  /*    */
  IF ((:new.SENDERRECORDID IS NULL) AND (:new.SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, :new.transfertcls, NULL, :new.meanstype,
    :new.targetcls,:new.targetcls); 
  END IF;
  /*   */
  GetDocumentKESR(NULL, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_100 (TR_LIMITFINDETAIL_BI_100)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((:new.ClsType is NULL) and (:new.IFS <> 0)) then
    :new.ClsType := 1; /*       ClsType */

  else
    if (:new.ClsType is null) then
      :new.ClsType := 0; /*  -  */
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND (:new.IFS <> 0)) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType = 1) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_LIMITFINDETAIL_BI_500)
-- Last update 29.06.2005
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_PAYMENTSCHEDULE_BI.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql, alter_ps_tr_parentnumber.sql, Del_Fields_PaymentSchedule.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BI
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$PAYTARGETFUNDS PAYMENTSCHEDULE.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION PAYMENTSCHEDULE.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.4
-- - - - - - - - - - - - -

  /*   13.10.01*/
  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$Accepted IS NULL) THEN 
    new$Accepted := 1;
  END IF;
  IF (new$PromiseType IS NULL) THEN 
    new$PromiseType := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$SubKESR IS NULL) THEN 
    new$SubKESR := 0;
  END IF;
  IF (new$AssignmentKind IS NULL) THEN 
    new$AssignmentKind := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$Region IS NULL) THEN 
    new$Region := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$FinSource IS NULL) THEN 
    new$FinSource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$BuhOperationCLS IS NULL) THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  IF (new$Month01 IS NULL) THEN 
    new$Month01 := 0;
  END IF;
  IF (new$Month02 IS NULL) THEN 
    new$Month02 := 0;
  END IF;
  IF (new$Month03 IS NULL) THEN 
    new$Month03 := 0;
  END IF;
  IF (new$Month04 IS NULL) THEN 
    new$Month04 := 0;
  END IF;
  IF (new$Month05 IS NULL) THEN 
    new$Month05 := 0;
  END IF;
  IF (new$Month06 IS NULL) THEN 
    new$Month06 := 0;
  END IF;
  IF (new$Month07 IS NULL) THEN 
    new$Month07 := 0;
  END IF;
  IF (new$Month08 IS NULL) THEN 
    new$Month08 := 0;
  END IF;
  IF (new$Month09 IS NULL) THEN 
    new$Month09 := 0;
  END IF;
  IF (new$Month10 IS NULL) THEN 
    new$Month10 := 0;
  END IF;
  IF (new$Month11 IS NULL) THEN 
    new$Month11 := 0;
  END IF;
  IF (new$Month12 IS NULL) THEN 
    new$Month12 := 0;
  END IF;
  IF (new$Quarter1 IS NULL) THEN 
    new$Quarter1 := 0;
  END IF;
  IF (new$Quarter2 IS NULL) THEN 
    new$Quarter2 := 0;
  END IF;
  IF (new$Quarter3 IS NULL) THEN 
    new$Quarter3 := 0;
  END IF;
  IF (new$Quarter4 IS NULL) THEN 
    new$Quarter4 := 0;
  END IF;
  IF (new$Summa IS NULL) THEN 
    new$Summa := 0;
  END IF;
  IF (new$Month01Delta IS NULL) THEN 
    new$Month01Delta := 0;
  END IF;
  IF (new$Month02Delta IS NULL) THEN 
    new$Month02Delta := 0;
  END IF;
  IF (new$Month03Delta IS NULL) THEN 
    new$Month03Delta := 0;
  END IF;
  IF (new$Month04Delta IS NULL) THEN 
    new$Month04Delta := 0;
  END IF;
  IF (new$Month05Delta IS NULL) THEN 
    new$Month05Delta := 0;
  END IF;
  IF (new$Month06Delta IS NULL) THEN 
    new$Month06Delta := 0;
  END IF;
  IF (new$Month07Delta IS NULL) THEN 
    new$Month07Delta := 0;
  END IF;
  IF (new$Month08Delta IS NULL) THEN 
    new$Month08Delta := 0;
  END IF;
  IF (new$Month09Delta IS NULL) THEN 
    new$Month09Delta := 0;
  END IF;
  IF (new$Month10Delta IS NULL) THEN 
    new$Month10Delta := 0;
  END IF;
  IF (new$Month11Delta IS NULL) THEN 
    new$Month11Delta := 0;
  END IF;
  IF (new$Month12Delta IS NULL) THEN 
    new$Month12Delta := 0;
  END IF;
  IF (new$Quarter1Delta IS NULL) THEN 
    new$Quarter1Delta := 0;
  END IF;
  IF (new$Quarter2Delta IS NULL) THEN 
    new$Quarter2Delta := 0;
  END IF;
  IF (new$Quarter3Delta IS NULL) THEN 
    new$Quarter3Delta := 0;
  END IF;
  IF (new$Quarter4Delta IS NULL) THEN 
    new$Quarter4Delta := 0;
  END IF;
  IF (new$SummaDelta IS NULL) THEN 
    new$SummaDelta := 0;
  END IF;
  IF (new$SummaPreviousYear IS NULL) THEN 
    new$SummaPreviousYear := 0;
  END IF;
  IF (new$SummaFinPreviousYear IS NULL) THEN 
    new$SummaFinPreviousYear := 0;
  END IF;
  IF (new$SummaYear2 IS NULL) THEN 
    new$SummaYear2 := 0;
  END IF;
  IF (new$SummaYear3 IS NULL) THEN 
    new$SummaYear3 := 0;
  END IF;
  IF (new$SummaYear4 IS NULL) THEN 
    new$SummaYear4 := 0;
  END IF;
  IF (new$SummaOtherYears IS NULL) THEN 
    new$SummaOtherYears := 0;
  END IF;
  IF (new$SummaYear2Delta IS NULL) THEN 
    new$SummaYear2Delta := 0;
  END IF;
  IF (new$SummaYear3Delta IS NULL) THEN 
    new$SummaYear3Delta := 0;
  END IF;
  IF (new$SummaYear4Delta IS NULL) THEN 
    new$SummaYear4Delta := 0;
  END IF;
  IF (new$SummaOtherYearsDelta IS NULL) THEN 
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  IF (new$ProgIndex = 304 AND new$RecordIndex IS NOT NULL) THEN
    SELECT COUNT(*) INTO CNT$1
    FROM AgreementSteps s WHERE (s.Id = new$RecordIndex AND s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    IF (NOT (CNT$1<> 0)) THEN
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0)) THEN
    IF (new$ProgIndex IN (304,314,317,318)) THEN
      BEGIN
        SELECT a.BudgetRef       INTO new$BudgetRef FROM Agreements a
        WHERE a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    ELSE 
      IF (new$ProgIndex = 308) THEN
        BEGIN
          SELECT e.BudgetRef
          INTO new$BudgetRef       FROM ExecutionDocumentsCaption e
          WHERE e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;
        
  /*    ,     ,      */
  IF (new$AdjustmentRef IS NULL) THEN
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := NULL;
      
  ELSE
    /*      , ..     */
    IF (new$Accepted = 0) THEN
      BEGIN
        SELECT
        InnerPromiseNum, ANumber 
        INTO PreviousInner$, AdjDocNum$       FROM Paymentschedule
        WHERE ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    ELSE
      BEGIN
        /*          */
        SELECT
        InnerPromiseNum, ANumber 
        INTO PreviousInner$, AdjDocNum$       FROM Paymentschedule
        WHERE ID = new$AdjustmentRef AND LastAccepted = 1 AND LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      IF (PreviousInner$ IS NULL) THEN
        RaiseException('EX_NotFindInnerNumber');    
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;
      
  END IF;
  /*    ,    */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0))
  THEN 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  IF (new$ANumber IS NOT NULL) THEN
    SELECT COUNT(                    id
    ) INTO CNT$2
    FROM
    PaymentSchedule ps
    WHERE
    (                    (ps.ANumber = new$ANumber)
    AND
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    IF ((CNT$2<> 0)) THEN
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
        
  /*    */
  IF ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, new$transfertcls, NULL, new$meanstype,
    new$targetcls,new$targetcls);     
  END IF;
  /*   */
  GetDocumentKESR(NULL, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/
     
  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;
      
  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule 
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */    
    if (Tmp$ = 0) then 
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then 
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');        
      END IF;
    else 
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');        
        END IF;
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select 
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa, 
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$, 
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from 
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
          
    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;        
        
  else    /*        */  
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;        
        
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER,
    new$PAYMENTCODETYPE,
    new$REGPROJECTRESULT,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_TENDERPRODUCT_BI.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_TENDERPRODUCT_BI
CREATE OR REPLACE TRIGGER TR_TENDERPRODUCT_BI
  BEFORE INSERT
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  PosNumber$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERPRODUCT_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (:new.id IS NULL) THEN 
    select g_shared.nextval into :new.id from dual;
  END IF;
  IF (:new.SubKESR IS NULL) THEN 
    :new.SubKESR := 0;
  END IF;
  IF (:new.KFSR IS NULL) THEN 
    :new.KFSR := 0;
  END IF;
  IF (:new.KVSR IS NULL) THEN 
    :new.KVSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN 
    :new.KVR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN 
    :new.KCSR := 0;
  END IF;
  IF (:new.FinSourceCls IS NULL) THEN 
    :new.FinSourceCls := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN 
    :new.FinType := 0;
  END IF;
  IF (:new.TenderObjectCls IS NULL) THEN 
    :new.TenderObjectCls := 0;
  END IF;
  IF (:new.FactCls IS NULL) THEN 
    :new.FactCls := 0;
  END IF;
  IF (:new.OKATO IS NULL) THEN 
    :new.OKATO := 0;
  END IF;
  IF (:new.MeansTypeCls IS NULL) THEN 
    :new.MeansTypeCls := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN 
    :new.DirectionCls := 0;
  END IF;
  IF (:new.AcceptPrice IS NULL) THEN 
    :new.AcceptPrice := 0;
  END IF;
  IF (:new.PriceVAT IS NULL) THEN 
    :new.PriceVAT := 0;
  END IF;
  IF (:new.AcceptAmount IS NULL) THEN 
    :new.AcceptAmount := 0;
  END IF;
  IF (:new.AcceptMonth01 IS NULL) THEN 
    :new.AcceptMonth01 := 0;
  END IF;
  IF (:new.AcceptMonth02 IS NULL) THEN 
    :new.AcceptMonth02 := 0;
  END IF;
  IF (:new.AcceptMonth03 IS NULL) THEN 
    :new.AcceptMonth03 := 0;
  END IF;
  IF (:new.AcceptMonth04 IS NULL) THEN 
    :new.AcceptMonth04 := 0;
  END IF;
  IF (:new.AcceptMonth05 IS NULL) THEN 
    :new.AcceptMonth05 := 0;
  END IF;
  IF (:new.AcceptMonth06 IS NULL) THEN 
    :new.AcceptMonth06 := 0;
  END IF;
  IF (:new.AcceptMonth07 IS NULL) THEN 
    :new.AcceptMonth07 := 0;
  END IF;
  IF (:new.AcceptMonth08 IS NULL) THEN 
    :new.AcceptMonth08 := 0;
  END IF;
  IF (:new.AcceptMonth09 IS NULL) THEN 
    :new.AcceptMonth09 := 0;
  END IF;
  IF (:new.AcceptMonth10 IS NULL) THEN 
    :new.AcceptMonth10 := 0;
  END IF;
  IF (:new.AcceptMonth11 IS NULL) THEN 
    :new.AcceptMonth11 := 0;
  END IF;
  IF (:new.AcceptMonth12 IS NULL) THEN 
    :new.AcceptMonth12 := 0;
  END IF;
  IF (:new.AcceptQuarter1 IS NULL) THEN 
    :new.AcceptQuarter1 := 0;
  END IF;
  IF (:new.AcceptQuarter2 IS NULL) THEN 
    :new.AcceptQuarter2 := 0;
  END IF;
  IF (:new.AcceptQuarter3 IS NULL) THEN 
    :new.AcceptQuarter3 := 0;
  END IF;
  IF (:new.AcceptQuarter4 IS NULL) THEN 
    :new.AcceptQuarter4 := 0;
  END IF;
  IF (:new.AcceptSumma IS NULL) THEN 
    :new.AcceptSumma := 0;
  END IF;
  IF (:new.DeliverySpec IS NULL) THEN 
    :new.DeliverySpec := 0;
  END IF;
  IF (:new.DeliveryPeriod IS NULL) THEN 
    :new.DeliveryPeriod := 0;
  END IF;
  IF (:new.DeliveryAmount IS NULL) THEN 
    :new.DeliveryAmount := 0;
  END IF;
  IF (:new.VatPercent IS NULL) THEN 
    :new.VatPercent := 0;
  END IF;
  IF (:new.AcceptVatSumma IS NULL) THEN 
    :new.AcceptVatSumma := 0;
  END IF;
  IF (:new.AcceptCost IS NULL) THEN 
    :new.AcceptCost := 0;
  END IF;
  IF (:new.AcceptTotalSumma IS NULL) THEN 
    :new.AcceptTotalSumma := 0;
  END IF;
  IF (:new.Equivalent IS NULL) THEN 
    :new.Equivalent := 0;
  END IF;
  IF (:new.SummaYear2 IS NULL) THEN 
    :new.SummaYear2 := 0;
  END IF;
  IF (:new.SummaYear3 IS NULL) THEN 
    :new.SummaYear3 := 0;
  END IF;
  IF (:new.SummaOtherYears IS NULL) THEN 
    :new.SummaOtherYears := 0;
  END IF;
      
  /*    */
  IF ((:new.SENDERRECORDID IS NULL) AND (:new.SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, :new.transfertcls, NULL, :new.MEANSTYPECLS,
    :new.targetcls,:new.targetcls); 
  END IF;
  /*   */
  GetDocumentKESR(NULL, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_TENDERPRODUCT_BI_1)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   1.0*/
  :new.AcceptQuarter1 := :new.AcceptMonth01 + :new.AcceptMonth02 + :new.AcceptMonth03;
  :new.AcceptQuarter2 := :new.AcceptMonth04 + :new.AcceptMonth05 + :new.AcceptMonth06;
  :new.AcceptQuarter3 := :new.AcceptMonth07 + :new.AcceptMonth08 + :new.AcceptMonth09;
  :new.AcceptQuarter4 := :new.AcceptMonth10 + :new.AcceptMonth11 + :new.AcceptMonth12;
  :new.AcceptSumma := :new.AcceptQuarter1 + :new.AcceptQuarter2 + :new.AcceptQuarter3 + :new.AcceptQuarter4;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERPRODUCT_BI_10)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

    /*   1.2 */
   IF (:NEW.FacialAccCls IS NULL) THEN :NEW.FacialAccCls := 0; END IF;

   /*  .  ,     */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      BEGIN
         SELECT fa.BudgetRef
           INTO :NEW.BudgetRef
           FROM FacialAcc_Cls fa
          WHERE fa.ID = :NEW.FacialAccCls;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            :NEW.BudgetRef := NULL;
      END;
   END IF;

   /*  ,    */
   IF ((:NEW.BudgetRef IS NULL) OR (:NEW.BudgetRef = 0)) THEN
      GetIntConst (-1, 3, :NEW.BudgetRef);
   END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_TENDERPRODUCT_BI_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (:new.PositionNumber is null) then
    select Max(PositionNumber)     INTO PosNumber$ from TenderProduct
    where (RecordIndex = :new.RecordIndex) and (ProgIndex = :new.ProgIndex)
    ;
    if (PosNumber$ is null) then
      PosNumber$ := 0;
    END IF;
    :new.PositionNumber := PosNumber$ + 1;

  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERPRODUCT_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then
    :new.senderIdKey := -1;

  else
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;

  else
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_410 (TR_TENDERPRODUCT_BI_410)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  FOR REC$1 IN (SELECT tl.ID  AS lotref FROM TenderLot tl WHERE (tl.ID = :new.LotRef) AND (tl.RecordIndex = :new.RecordIndex)   )
  LOOP
    if (not ((REC$1.lotref  = :new.LotRef) or (:new.lotref is null))) then
      RaiseException('EX_TEN_UNKNOWNLOT');
    END IF;
  END LOOP;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERPRODUCT_BI_500)
-- Last update 18.04.2006
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger_TR_WRITEXECUTIONDETAIL_BI.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql *//*       ,   SenderRecordId  SenderID  (  ).  59797*/
-- CREATE TRIGGER TR_WRITEXECUTIONDETAIL_BI
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONDETAIL_BI
  BEFORE INSERT
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  ScheduleRef$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_WRITEXECUTIONDETAIL_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (:new.id IS NULL) THEN 
    select g_shared.nextval into :new.id from dual;
  END IF;
  IF (:new.BudgetRef IS NULL) THEN
    BEGIN
      SELECT 
      writ_c.BudgetRef 
      INTO :new.BudgetRef     FROM 
      WritExecutionCaption writ_c
      WHERE 
      writ_c.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
    
  IF (:new.Progindex IS NULL) THEN 
    :new.Progindex := 556;  
  END IF;
  IF (:new.FacialAcc_Cls IS NULL) THEN 
    :new.FacialAcc_Cls := 0;
  END IF;
  IF (:new.KVSR IS NULL) THEN 
    :new.KVSR := 0;
  END IF;
  IF (:new.KFSR IS NULL) THEN 
    :new.KFSR := 0;
  END IF;
  IF (:new.KVR IS NULL) THEN 
    :new.KVR := 0;
  END IF;
  IF (:new.KCSR IS NULL) THEN 
    :new.KCSR := 0;
  END IF;
  IF (:new.MeansType IS NULL) THEN 
    :new.MeansType := 0;
  END IF;
  IF (:new.Fact IS NULL) THEN 
    :new.Fact := 0;
  END IF;
  IF (:new.DirectionCls IS NULL) THEN 
    :new.DirectionCls := 0;
  END IF;
  IF (:new.RegionCLS IS NULL) THEN 
    :new.RegionCLS := 0;
  END IF;
  IF (:new.Finsource IS NULL) THEN 
    :new.Finsource := 0;
  END IF;
  IF (:new.FinType IS NULL) THEN 
    :new.FinType := 0;
  END IF;
  IF (:new.DocType IS NULL) THEN 
    :new.DocType := 0;
  END IF;
  IF (:new.SubKesr IS NULL) THEN 
    :new.SubKesr := 0;
  END IF;
    
  IF (:new.Month01 IS NULL) THEN  
    :new.Month01 := 0;
  END IF;
  IF (:new.Month02 IS NULL) THEN  
    :new.Month02 := 0;
  END IF;
  IF (:new.Month03 IS NULL) THEN  
    :new.Month03 := 0;
  END IF;
  IF (:new.Month04 IS NULL) THEN  
    :new.Month04 := 0;
  END IF;
  IF (:new.Month05 IS NULL) THEN  
    :new.Month05 := 0;
  END IF;
  IF (:new.Month06 IS NULL) THEN  
    :new.Month06 := 0;
  END IF;
  IF (:new.Month07 IS NULL) THEN  
    :new.Month07 := 0;
  END IF;
  IF (:new.Month08 IS NULL) THEN  
    :new.Month08 := 0;
  END IF;
  IF (:new.Month09 IS NULL) THEN  
    :new.Month09 := 0;
  END IF;
  IF (:new.Month10 IS NULL) THEN  
    :new.Month10 := 0;
  END IF;
  IF (:new.Month11 IS NULL) THEN  
    :new.Month11 := 0;
  END IF;
  IF (:new.Month12 IS NULL) THEN  
    :new.Month12 := 0;
  END IF;
    
  IF (:new.Quarter1 IS NULL) THEN  
    :new.Quarter1 := 0;
  END IF;
  IF (:new.Quarter2 IS NULL) THEN  
    :new.Quarter2 := 0;
  END IF;
  IF (:new.Quarter3 IS NULL) THEN  
    :new.Quarter3 := 0;
  END IF;
  IF (:new.Quarter4 IS NULL) THEN  
    :new.Quarter4 := 0;
  END IF;
    
  IF (:new.WritExecutionSumma IS NULL) THEN 
    :new.WritExecutionSumma := 0; 
  END IF;
  IF ((NOT :new.PROMISE IS NULL) AND (NOT :new.BUDGETPROMISE IS NULL)) THEN
    BEGIN
      SELECT ps.id     INTO ScheduleRef$ FROM PaymentSchedule ps
      WHERE (ps.InnerPromiseNum = :new.BUDGETPROMISE) AND
      (ps.ANumber = :new.PROMISE)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF (ScheduleRef$ <> 0) THEN
    :new.PScheduleRef := ScheduleRef$;
      
  ELSE
    :new.PScheduleRef := NULL;
  END IF;
       
  /*    */
  IF ((:new.SENDERRECORDID IS NULL) AND (:new.SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, :new.transfertcls, NULL, :new.meanstype,
    :new.targetcls,:new.targetcls); 
  END IF;
  /*   */
  GetDocumentKESR(NULL, :new.SubKESR, :new.KESR, :new.BudgetRef,:new.KESR);

-- - - - - - - - - - - - -
-- BI_110 (TR_WritExecutionDetail_BI_110)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  if (:new.KD is NULL) then
    :new.KD := 0;
  END IF;
  if (:new.IFS is NULL) then
    :new.IFS := 0;
  END IF;

  if (:new.ClsType is NULL) then
    if (:new.KD <> 0) then
      :new.ClsType := 2; /*       ClsType */

    else
      if (:new.IFS <> 0) then
        :new.ClsType := 1;

      else
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.KD <> 0) or (:new.ifs <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 2) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_WRITEXECUTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (:new.Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = :new.PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((:new.Promise is not null) and (:new.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = :new.Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        :new.BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((:new.BudgetPromise is not null) and (:new.Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = :new.BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      :new.Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (:new.BudgetPromise is not null and :new.Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_WRITEXECUTIONDETAIL_BI_210)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (:new.Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = :new.Promise and ps.InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_WRITEXECUTIONDETAIL_BI_500)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- AlterTrigger03_24SourceTarget.sql
-- #########################################################
-- #########################################################

/* >alter_SubKESR_add_KESR.sql, AlterTrigger_TR_FACIALFINDETAIL_BI_110.sql *//*   03.24.      /  .   .      2958443*/
-- CREATE TRIGGER TR_FACIALFINDETAIL_BI_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
  i_fintype$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;
   
  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;  
  END IF;
     
  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;   
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then 
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then 
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;
     
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.00.00.3
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  IF (new$progindex=76) THEN
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex IN (66, 67, 76)) AND (new$DestPromise IS NOT NULL) AND
        (new$SourcePromise = new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex IN (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
   
  /*       */
  IF ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    IF (new$ProgIndex <> 76) THEN /*  03.24   .    */
      GETTARGETCLS(NULL, new$sourcetransfertcls, NULL, new$sourcemeanstype,
      new$sourcetargetcls,new$sourcetargetcls);
    END IF;
    GETTARGETCLS(NULL, new$desttransfertcls, NULL, new$destmeanstype,
    new$desttargetcls,new$desttargetcls);
    IF (new$ProgIndex = 76) THEN
      new$SourceTargetCls := new$DestTargetCls;
     
    END IF;
  END IF;
  /*      */
  GetDocumentKESR(NULL, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(NULL, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC,
    new$SOURCEREGPROJECTRESULT,
    new$DESTREGPROJECTRESULT,
    new$SOURCEINCOMETARGETFUNDS,
    new$DESTINCOMETARGETFUNDS,
    new$SOURCEPAYTARGETFUNDS,
    new$DESTPAYTARGETFUNDS,
    new$SOURCEANALYTICALPARTITION,
    new$DESTANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER tr_FacialFinDetail_bu_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex1$ NUMBER(10);
  ExecID1$ NUMBER(10);
  ExecInnerNumber1$ NUMBER(10);
  ExecRegType1$ NUMBER(10);
  ExecAgrInnerNum1$ NUMBER(10);
  AgrInnerNumber1$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  i_fintype$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype$  ;
     
  END IF;
  IF (new$DestFintype IS NULL) THEN 
    IF (i_fintype$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  /*      */
  IF (new$progindex = 283) THEN
    /*          */
    IF ((new$ACCEPTDATE IS NOT NULL) AND (:old.REJECT_CLS IS NULL) AND (new$REJECT_CLS IS NOT NULL)) THEN
      new$ACCEPTDATE := null; 
    END IF;
    /*              */
    IF ((:old.REJECT_CLS IS NOT NULL) AND (new$REJECT_CLS IS NULL)) THEN
      BEGIN
        select AcceptDate
        into new$ACCEPTDATE      from facialfincaption
        where (id = new$RecordIndex)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END; 
    END IF;
  END IF;
   
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
   
  /*       */
  IF (new$ProgIndex <> 76) THEN /*  03.24   .    */
    GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
    new$Sourcetargetcls,new$Sourcetargetcls);
  END IF;
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);     
  IF (new$ProgIndex = 76) THEN
    new$SourceTargetCls := new$DestTargetCls;
  END IF;
  /*      */
  GetDocumentKESR(:old.SourceSubKESR, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(:old.DestSubKESR, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;

    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;

    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;

    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;

    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;

    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$SourceExecDoc := ExecID1$;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$SourceExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex1$, ExecID1$, ExecInnerNumber1$, AgrInnerNumber1$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex1$ = 308) then
        new$DestExecDoc := ExecID1$;
        new$DestExecInnerNumber := ExecInnerNumber1$;
              
      else 
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType1$, ExecAgrInnerNum1$, ExecInnerNumber1$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType1$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum1$ <> AgrInnerNumber1$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */        
          new$DestExecInnerNumber := ExecInnerNumber1$;
                
        END IF;    
      END IF;/*       ,   ,  */
    else 
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber1$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber1$;
            
      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$sourceexecinnernumber is not null or :old.sourceexecinnernumber is not null) then
        new$sourceexecinnernumber := null;
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted1$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted1$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');    
      END IF;/*         */
    else 
      if (new$destexecinnernumber is not null or :old.destexecinnernumber is not null) then
        new$destexecinnernumber := null;
      END IF;  
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select
      c.AcceptDate
      into
      CapAcceptDate1$     from
      facialfincaption c
      where
      (c.id = new$RecordIndex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (not ((new$AcceptDate = CapAcceptDate1$) or (CapAcceptDate1$  is null) or
    /*          (  )    */
    ((new$Progindex = 283) and (new$AcceptDate is null) and (new$Reject_CLS is not null)))) then
      RaiseException('ex_wrongacceptdate');  
    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS,
    REJECT_CLS = new$REJECT_CLS,
    REJECTCAUSE = new$REJECTCAUSE,
    CARDNUMBER = new$CARDNUMBER,
    DATEBIRTH = new$DATEBIRTH,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    CODEPURPOSE = new$CODEPURPOSE,
    LINENUMBER = new$LINENUMBER,
    AMOUNTISPDOC = new$AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT = new$SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT = new$DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS = new$SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS = new$DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS = new$SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS = new$DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION = new$SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION = new$DESTANALYTICALPARTITION
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 DISABLE
/
update FacialFinDetail set
  SourceTargetCls = DestTargetCls
where
  ProgIndex = 76 and
  ((SourceTargetCls <> DestTargetCls) or
   (SourceTargetCls is null and DestTargetCls is not null) or
   (SourceTargetCls is not null and DestTargetcls is null)
  )
/
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 ENABLE
/

COMMIT WORK
/

-- #########################################################
-- #########################################################
-- ClsCorrValues
-- #########################################################
-- #########################################################


DROP TRIGGER TR_ClsCorrValues_AD
/
DROP TRIGGER TR_ClsCorrValues_AI
/
DROP TRIGGER TR_ClsCorrValues_AU
/
DROP TRIGGER TR_ClsCorrValues_BI
/
DROP TRIGGER TR_ClsCorrValues_BU
/
DROP TRIGGER TR_ClsCorrValues_BU_500
/

RENAME ClsCorrValues TO TB_ClsCorrValues
/
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_BU_500
  BEFORE UPDATE
  ON TB_ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_ClsCorrValues_BU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.UpdateDate := SYSDATE;
  :new.UpdaterUser := user;

END;
/

CREATE OR REPLACE VIEW ClsCorrValues (
  ID,
  RECORDINDEX,
  KVSR,
  KFSR,
  KCSR,
  KVR,
  KESR,
  SUBKESR,
  DIRECTIONCLS,
  VARIANT,
  FACT,
  PAYPROMISECLS,
  BUDALLOCATIONCLS,
  CONTRACTCOSTSCLS,
  INVESTOBJECT,
  FINTYPE,
  MEANSTYPE,
  TARGETCLS,
  REGIONCLS,
  SUBSIDYCLS,
  TRANSFERTCLS,
  PLANDOCTYPE,
  ASSIGNMENTSOURCE,
  ASSIGNMENTKIND,
  KD,
  ANALYTICALGROUPIFS,
  ANALYTICALGROUPKD,
  PROGRAMCODE,
  INNERFINSOURCE,
  REESTRTYPE,
  OKTMO,
  DOCBASE,
  FUNDSSOURCE,
  FINSOURCE,
  DOCTYPE,
  COMMDIRECTIONEXPENCECLS,
  PAYTARGETFUNDS,
  PAYDESTINATION,
  FACIALACC_CLS,
  REGPROJECTRESULT,
  NATIONALPROJECT,
  PAYMENTCODETYPE,
  LINKRECORD,
  ATTACHTO,
  STOREDCONTENT,
  BUDGETREF,
  NOTE,
  EXTID,
  EXTROOTID,
  STARTDATE,
  DELETEDATE,
  CREATEDATE,
  CREATERUSER,
  UPDATEDATE,
  UPDATERUSER)
AS
  SELECT
    ID,
    RECORDINDEX,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    DIRECTIONCLS,
    VARIANT,
    FACT,
    PAYPROMISECLS,
    BUDALLOCATIONCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT,
    FINTYPE,
    MEANSTYPE,
    TARGETCLS,
    REGIONCLS,
    SUBSIDYCLS,
    TRANSFERTCLS,
    PLANDOCTYPE,
    ASSIGNMENTSOURCE,
    ASSIGNMENTKIND,
    KD,
    ANALYTICALGROUPIFS,
    ANALYTICALGROUPKD,
    PROGRAMCODE,
    INNERFINSOURCE,
    REESTRTYPE,
    OKTMO,
    DOCBASE,
    FUNDSSOURCE,
    FINSOURCE,
    DOCTYPE,
    COMMDIRECTIONEXPENCECLS,
    PAYTARGETFUNDS,
    PAYDESTINATION,
    FACIALACC_CLS,
    REGPROJECTRESULT,
    NATIONALPROJECT,
    PAYMENTCODETYPE,
    LINKRECORD,
    ATTACHTO,
    STOREDCONTENT,
    BUDGETREF,
    NOTE,
    EXTID,
    EXTROOTID,
    STARTDATE,
    DELETEDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER
  FROM TB_ClsCorrValues
/

GRANT SELECT, INSERT, UPDATE, DELETE ON ClsCorrValues TO BUDGET_USERS
/
CREATE OR REPLACE TRIGGER TR_ClsCorrValues_II
  INSTEAD OF INSERT
  ON ClsCorrValues
  FOR EACH ROW
DECLARE
  new$ID ClsCorrValues.ID%TYPE := :NEW.ID;
  new$RECORDINDEX ClsCorrValues.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$KVSR ClsCorrValues.KVSR%TYPE := :NEW.KVSR;
  new$KFSR ClsCorrValues.KFSR%TYPE := :NEW.KFSR;
  new$KCSR ClsCorrValues.KCSR%TYPE := :NEW.KCSR;
  new$KVR ClsCorrValues.KVR%TYPE := :NEW.KVR;
  new$KESR ClsCorrValues.KESR%TYPE := :NEW.KESR;
  new$SUBKESR ClsCorrValues.SUBKESR%TYPE := :NEW.SUBKESR;
  new$DIRECTIONCLS ClsCorrValues.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$VARIANT ClsCorrValues.VARIANT%TYPE := :NEW.VARIANT;
  new$FACT ClsCorrValues.FACT%TYPE := :NEW.FACT;
  new$PAYPROMISECLS ClsCorrValues.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$BUDALLOCATIONCLS ClsCorrValues.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$CONTRACTCOSTSCLS ClsCorrValues.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT ClsCorrValues.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$FINTYPE ClsCorrValues.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE ClsCorrValues.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$TARGETCLS ClsCorrValues.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$REGIONCLS ClsCorrValues.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$SUBSIDYCLS ClsCorrValues.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$TRANSFERTCLS ClsCorrValues.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$PLANDOCTYPE ClsCorrValues.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$ASSIGNMENTSOURCE ClsCorrValues.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$ASSIGNMENTKIND ClsCorrValues.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$KD ClsCorrValues.KD%TYPE := :NEW.KD;
  new$ANALYTICALGROUPIFS ClsCorrValues.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
  new$ANALYTICALGROUPKD ClsCorrValues.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
  new$PROGRAMCODE ClsCorrValues.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$INNERFINSOURCE ClsCorrValues.INNERFINSOURCE%TYPE := :NEW.INNERFINSOURCE;
  new$REESTRTYPE ClsCorrValues.REESTRTYPE%TYPE := :NEW.REESTRTYPE;
  new$OKTMO ClsCorrValues.OKTMO%TYPE := :NEW.OKTMO;
  new$DOCBASE ClsCorrValues.DOCBASE%TYPE := :NEW.DOCBASE;
  new$FUNDSSOURCE ClsCorrValues.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$FINSOURCE ClsCorrValues.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$DOCTYPE ClsCorrValues.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$COMMDIRECTIONEXPENCECLS ClsCorrValues.COMMDIRECTIONEXPENCECLS%TYPE := :NEW.COMMDIRECTIONEXPENCECLS;
  new$PAYTARGETFUNDS ClsCorrValues.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$PAYDESTINATION ClsCorrValues.PAYDESTINATION%TYPE := :NEW.PAYDESTINATION;
  new$FACIALACC_CLS ClsCorrValues.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$REGPROJECTRESULT ClsCorrValues.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$NATIONALPROJECT ClsCorrValues.NATIONALPROJECT%TYPE := :NEW.NATIONALPROJECT;
  new$PAYMENTCODETYPE ClsCorrValues.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$LINKRECORD ClsCorrValues.LINKRECORD%TYPE := :NEW.LINKRECORD;
  new$ATTACHTO ClsCorrValues.ATTACHTO%TYPE := :NEW.ATTACHTO;
  new$STOREDCONTENT ClsCorrValues.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$BUDGETREF ClsCorrValues.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$NOTE ClsCorrValues.NOTE%TYPE := :NEW.NOTE;
  new$EXTID ClsCorrValues.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID ClsCorrValues.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$STARTDATE ClsCorrValues.STARTDATE%TYPE := :NEW.STARTDATE;
  new$DELETEDATE ClsCorrValues.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$CREATEDATE ClsCorrValues.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER ClsCorrValues.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE ClsCorrValues.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ClsCorrValues.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
--
  CNT$1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ClsCorrValues_BI_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_CLSCORRVALUES_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(ID ) INTO CNT$1$
  from CLSCORRVALUES
  where
  (        ((ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS) or ((ANALYTICALGROUPIFS is null) and (new$ANALYTICALGROUPIFS is null))) and
  ((ANALYTICALGROUPKD = new$ANALYTICALGROUPKD) or ((ANALYTICALGROUPKD is null) and (new$ANALYTICALGROUPKD is null))) and
  ((ASSIGNMENTKIND = new$ASSIGNMENTKIND) or ((ASSIGNMENTKIND is null) and (new$ASSIGNMENTKIND is null))) and
  ((ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE) or ((ASSIGNMENTSOURCE is null) and (new$ASSIGNMENTSOURCE is null))) and
  ((ATTACHTO = new$ATTACHTO) or ((ATTACHTO is null) and (new$ATTACHTO is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  (BUDGETREF = new$BUDGETREF) and
  ((COMMDIRECTIONEXPENCECLS = new$COMMDIRECTIONEXPENCECLS) or ((COMMDIRECTIONEXPENCECLS is null) and (new$COMMDIRECTIONEXPENCECLS is null))) and
  ((PayTargetFunds = new$PayTargetFunds) or ((PayTargetFunds is null) and (new$PayTargetFunds is null))) and
  ((CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS) or ((CONTRACTCOSTSCLS is null) and (new$CONTRACTCOSTSCLS is null))) and
  ((DIRECTIONCLS = new$DIRECTIONCLS) or ((DIRECTIONCLS is null) and (new$DIRECTIONCLS is null))) and
  ((DOCBASE = new$DOCBASE) or ((DOCBASE is null) and (new$DOCBASE is null))) and
  ((DOCTYPE = new$DOCTYPE) or ((DOCTYPE is null) and (new$DOCTYPE is null))) and
  ((FACIALACC_CLS = new$FACIALACC_CLS) or ((FACIALACC_CLS is null) and (new$FACIALACC_CLS is null))) and
  ((FACT = new$FACT) or ((FACT is null) and (new$FACT is null))) and
  ((FINSOURCE = new$FINSOURCE) or ((FINSOURCE is null) and (new$FINSOURCE is null))) and
  ((FINTYPE = new$FINTYPE) or ((FINTYPE is null) and (new$FINTYPE is null))) and
  ((FUNDSSOURCE = new$FUNDSSOURCE) or ((FUNDSSOURCE is null) and (new$FUNDSSOURCE is null))) and
  ((INNERFINSOURCE = new$INNERFINSOURCE) or ((INNERFINSOURCE is null) and (new$INNERFINSOURCE is null))) and
  ((INVESTOBJECT = new$INVESTOBJECT) or ((INVESTOBJECT is null) and (new$INVESTOBJECT is null))) and
  ((KCSR = new$KCSR) or ((KCSR is null) and (new$KCSR is null))) and
  ((KD = new$KD) or ((KD is null) and (new$KD is null))) and
  ((KESR = new$KESR) or ((KESR is null) and (new$KESR is null))) and
  ((KFSR = new$KFSR) or ((KFSR is null) and (new$KFSR is null))) and
  ((KVR = new$KVR) or ((KVR is null) and (new$KVR is null))) and
  ((KVSR = new$KVSR) or ((KVSR is null) and (new$KVSR is null))) and
  ((MEANSTYPE = new$MEANSTYPE) or ((MEANSTYPE is null) and (new$MEANSTYPE is null))) and
  ((REGPROJECTRESULT = new$REGPROJECTRESULT) or ((REGPROJECTRESULT is null) and (new$REGPROJECTRESULT is null))) and
  ((NATIONALPROJECT = new$NATIONALPROJECT) or ((NATIONALPROJECT is null) and (new$NATIONALPROJECT is null))) and
  ((OKTMO = new$OKTMO) or ((OKTMO is null) and (new$OKTMO is null))) and
  ((PAYDESTINATION = new$PAYDESTINATION) or ((PAYDESTINATION is null) and (new$PAYDESTINATION is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((PLANDOCTYPE = new$PLANDOCTYPE) or ((PLANDOCTYPE is null) and (new$PLANDOCTYPE is null))) and
  ((PROGRAMCODE = new$PROGRAMCODE) or ((PROGRAMCODE is null) and (new$PROGRAMCODE is null))) and
  ((REESTRTYPE = new$REESTRTYPE) or ((REESTRTYPE is null) and (new$REESTRTYPE is null))) and
  ((REGIONCLS = new$REGIONCLS) or ((REGIONCLS is null) and (new$REGIONCLS is null))) and
  ((SUBKESR = new$SUBKESR) or ((SUBKESR is null) and (new$SUBKESR is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((VARIANT = new$VARIANT) or ((VARIANT is null) and (new$VARIANT is null))) and
  (RECORDINDEX = new$RECORDINDEX)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1$<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ClsCorrValues_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ClsCorrValues (
    ID,
    RECORDINDEX,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    DIRECTIONCLS,
    VARIANT,
    FACT,
    PAYPROMISECLS,
    BUDALLOCATIONCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT,
    FINTYPE,
    MEANSTYPE,
    TARGETCLS,
    REGIONCLS,
    SUBSIDYCLS,
    TRANSFERTCLS,
    PLANDOCTYPE,
    ASSIGNMENTSOURCE,
    ASSIGNMENTKIND,
    KD,
    ANALYTICALGROUPIFS,
    ANALYTICALGROUPKD,
    PROGRAMCODE,
    INNERFINSOURCE,
    REESTRTYPE,
    OKTMO,
    DOCBASE,
    FUNDSSOURCE,
    FINSOURCE,
    DOCTYPE,
    COMMDIRECTIONEXPENCECLS,
    PAYTARGETFUNDS,
    PAYDESTINATION,
    FACIALACC_CLS,
    REGPROJECTRESULT,
    NATIONALPROJECT,
    PAYMENTCODETYPE,
    LINKRECORD,
    ATTACHTO,
    STOREDCONTENT,
    BUDGETREF,
    NOTE,
    EXTID,
    EXTROOTID,
    STARTDATE,
    DELETEDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER
  ) VALUES (
    new$ID,
    new$RECORDINDEX,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$DIRECTIONCLS,
    new$VARIANT,
    new$FACT,
    new$PAYPROMISECLS,
    new$BUDALLOCATIONCLS,
    new$CONTRACTCOSTSCLS,
    new$INVESTOBJECT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$TARGETCLS,
    new$REGIONCLS,
    new$SUBSIDYCLS,
    new$TRANSFERTCLS,
    new$PLANDOCTYPE,
    new$ASSIGNMENTSOURCE,
    new$ASSIGNMENTKIND,
    new$KD,
    new$ANALYTICALGROUPIFS,
    new$ANALYTICALGROUPKD,
    new$PROGRAMCODE,
    new$INNERFINSOURCE,
    new$REESTRTYPE,
    new$OKTMO,
    new$DOCBASE,
    new$FUNDSSOURCE,
    new$FINSOURCE,
    new$DOCTYPE,
    new$COMMDIRECTIONEXPENCECLS,
    new$PAYTARGETFUNDS,
    new$PAYDESTINATION,
    new$FACIALACC_CLS,
    new$REGPROJECTRESULT,
    new$NATIONALPROJECT,
    new$PAYMENTCODETYPE,
    new$LINKRECORD,
    new$ATTACHTO,
    new$STOREDCONTENT,
    new$BUDGETREF,
    new$NOTE,
    new$EXTID,
    new$EXTROOTID,
    new$STARTDATE,
    new$DELETEDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER);

-- - - - - - - - - - - - -
-- AI_500 (TR_ClsCorrValues_AI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 98112) and (RecordId = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_ClsCorrValues_IU
  INSTEAD OF UPDATE
  ON ClsCorrValues
  FOR EACH ROW
DECLARE
  new$ID ClsCorrValues.ID%TYPE := :NEW.ID;
  new$RECORDINDEX ClsCorrValues.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$KVSR ClsCorrValues.KVSR%TYPE := :NEW.KVSR;
  new$KFSR ClsCorrValues.KFSR%TYPE := :NEW.KFSR;
  new$KCSR ClsCorrValues.KCSR%TYPE := :NEW.KCSR;
  new$KVR ClsCorrValues.KVR%TYPE := :NEW.KVR;
  new$KESR ClsCorrValues.KESR%TYPE := :NEW.KESR;
  new$SUBKESR ClsCorrValues.SUBKESR%TYPE := :NEW.SUBKESR;
  new$DIRECTIONCLS ClsCorrValues.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$VARIANT ClsCorrValues.VARIANT%TYPE := :NEW.VARIANT;
  new$FACT ClsCorrValues.FACT%TYPE := :NEW.FACT;
  new$PAYPROMISECLS ClsCorrValues.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$BUDALLOCATIONCLS ClsCorrValues.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$CONTRACTCOSTSCLS ClsCorrValues.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT ClsCorrValues.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$FINTYPE ClsCorrValues.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE ClsCorrValues.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$TARGETCLS ClsCorrValues.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$REGIONCLS ClsCorrValues.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$SUBSIDYCLS ClsCorrValues.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$TRANSFERTCLS ClsCorrValues.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$PLANDOCTYPE ClsCorrValues.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$ASSIGNMENTSOURCE ClsCorrValues.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$ASSIGNMENTKIND ClsCorrValues.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$KD ClsCorrValues.KD%TYPE := :NEW.KD;
  new$ANALYTICALGROUPIFS ClsCorrValues.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
  new$ANALYTICALGROUPKD ClsCorrValues.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
  new$PROGRAMCODE ClsCorrValues.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$INNERFINSOURCE ClsCorrValues.INNERFINSOURCE%TYPE := :NEW.INNERFINSOURCE;
  new$REESTRTYPE ClsCorrValues.REESTRTYPE%TYPE := :NEW.REESTRTYPE;
  new$OKTMO ClsCorrValues.OKTMO%TYPE := :NEW.OKTMO;
  new$DOCBASE ClsCorrValues.DOCBASE%TYPE := :NEW.DOCBASE;
  new$FUNDSSOURCE ClsCorrValues.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$FINSOURCE ClsCorrValues.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$DOCTYPE ClsCorrValues.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$COMMDIRECTIONEXPENCECLS ClsCorrValues.COMMDIRECTIONEXPENCECLS%TYPE := :NEW.COMMDIRECTIONEXPENCECLS;
  new$PAYTARGETFUNDS ClsCorrValues.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$PAYDESTINATION ClsCorrValues.PAYDESTINATION%TYPE := :NEW.PAYDESTINATION;
  new$FACIALACC_CLS ClsCorrValues.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$REGPROJECTRESULT ClsCorrValues.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$NATIONALPROJECT ClsCorrValues.NATIONALPROJECT%TYPE := :NEW.NATIONALPROJECT;
  new$PAYMENTCODETYPE ClsCorrValues.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$LINKRECORD ClsCorrValues.LINKRECORD%TYPE := :NEW.LINKRECORD;
  new$ATTACHTO ClsCorrValues.ATTACHTO%TYPE := :NEW.ATTACHTO;
  new$STOREDCONTENT ClsCorrValues.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$BUDGETREF ClsCorrValues.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$NOTE ClsCorrValues.NOTE%TYPE := :NEW.NOTE;
  new$EXTID ClsCorrValues.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID ClsCorrValues.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$STARTDATE ClsCorrValues.STARTDATE%TYPE := :NEW.STARTDATE;
  new$DELETEDATE ClsCorrValues.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$CREATEDATE ClsCorrValues.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER ClsCorrValues.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE ClsCorrValues.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ClsCorrValues.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
--
  CNT$1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ClsCorrValues_BU_0)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_CLSCORRVALUES_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(ID ) INTO CNT$1$
  from CLSCORRVALUES
  where
  (        ((ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS) or ((ANALYTICALGROUPIFS is null) and (new$ANALYTICALGROUPIFS is null))) and
  ((ANALYTICALGROUPKD = new$ANALYTICALGROUPKD) or ((ANALYTICALGROUPKD is null) and (new$ANALYTICALGROUPKD is null))) and
  ((ASSIGNMENTKIND = new$ASSIGNMENTKIND) or ((ASSIGNMENTKIND is null) and (new$ASSIGNMENTKIND is null))) and
  ((ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE) or ((ASSIGNMENTSOURCE is null) and (new$ASSIGNMENTSOURCE is null))) and
  ((ATTACHTO = new$ATTACHTO) or ((ATTACHTO is null) and (new$ATTACHTO is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  (BUDGETREF = new$BUDGETREF) and
  ((COMMDIRECTIONEXPENCECLS = new$COMMDIRECTIONEXPENCECLS) or ((COMMDIRECTIONEXPENCECLS is null) and (new$COMMDIRECTIONEXPENCECLS is null))) and
  ((PayTargetFunds = new$PayTargetFunds) or ((PayTargetFunds is null) and (new$PayTargetFunds is null))) and
  ((CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS) or ((CONTRACTCOSTSCLS is null) and (new$CONTRACTCOSTSCLS is null))) and
  ((DIRECTIONCLS = new$DIRECTIONCLS) or ((DIRECTIONCLS is null) and (new$DIRECTIONCLS is null))) and
  ((DOCBASE = new$DOCBASE) or ((DOCBASE is null) and (new$DOCBASE is null))) and
  ((DOCTYPE = new$DOCTYPE) or ((DOCTYPE is null) and (new$DOCTYPE is null))) and
  ((FACIALACC_CLS = new$FACIALACC_CLS) or ((FACIALACC_CLS is null) and (new$FACIALACC_CLS is null))) and
  ((FACT = new$FACT) or ((FACT is null) and (new$FACT is null))) and
  ((FINSOURCE = new$FINSOURCE) or ((FINSOURCE is null) and (new$FINSOURCE is null))) and
  ((FINTYPE = new$FINTYPE) or ((FINTYPE is null) and (new$FINTYPE is null))) and
  ((FUNDSSOURCE = new$FUNDSSOURCE) or ((FUNDSSOURCE is null) and (new$FUNDSSOURCE is null))) and
  ((INNERFINSOURCE = new$INNERFINSOURCE) or ((INNERFINSOURCE is null) and (new$INNERFINSOURCE is null))) and
  ((INVESTOBJECT = new$INVESTOBJECT) or ((INVESTOBJECT is null) and (new$INVESTOBJECT is null))) and
  ((KCSR = new$KCSR) or ((KCSR is null) and (new$KCSR is null))) and
  ((KD = new$KD) or ((KD is null) and (new$KD is null))) and
  ((KESR = new$KESR) or ((KESR is null) and (new$KESR is null))) and
  ((KFSR = new$KFSR) or ((KFSR is null) and (new$KFSR is null))) and
  ((KVR = new$KVR) or ((KVR is null) and (new$KVR is null))) and
  ((KVSR = new$KVSR) or ((KVSR is null) and (new$KVSR is null))) and
  ((MEANSTYPE = new$MEANSTYPE) or ((MEANSTYPE is null) and (new$MEANSTYPE is null))) and
  ((REGPROJECTRESULT = new$REGPROJECTRESULT) or ((REGPROJECTRESULT is null) and (new$REGPROJECTRESULT is null))) and
  ((NATIONALPROJECT = new$NATIONALPROJECT) or ((NATIONALPROJECT is null) and (new$NATIONALPROJECT is null))) and
  ((OKTMO = new$OKTMO) or ((OKTMO is null) and (new$OKTMO is null))) and
  ((PAYDESTINATION = new$PAYDESTINATION) or ((PAYDESTINATION is null) and (new$PAYDESTINATION is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((PLANDOCTYPE = new$PLANDOCTYPE) or ((PLANDOCTYPE is null) and (new$PLANDOCTYPE is null))) and
  ((PROGRAMCODE = new$PROGRAMCODE) or ((PROGRAMCODE is null) and (new$PROGRAMCODE is null))) and
  ((REESTRTYPE = new$REESTRTYPE) or ((REESTRTYPE is null) and (new$REESTRTYPE is null))) and
  ((REGIONCLS = new$REGIONCLS) or ((REGIONCLS is null) and (new$REGIONCLS is null))) and
  ((SUBKESR = new$SUBKESR) or ((SUBKESR is null) and (new$SUBKESR is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((VARIANT = new$VARIANT) or ((VARIANT is null) and (new$VARIANT is null))) and
  (RECORDINDEX = new$RECORDINDEX) and
  (ID <> :old.ID)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1$<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ClsCorrValues SET
    ID = new$ID,
    RECORDINDEX = new$RECORDINDEX,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    VARIANT = new$VARIANT,
    FACT = new$FACT,
    PAYPROMISECLS = new$PAYPROMISECLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    INVESTOBJECT = new$INVESTOBJECT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    TARGETCLS = new$TARGETCLS,
    REGIONCLS = new$REGIONCLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    TRANSFERTCLS = new$TRANSFERTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    KD = new$KD,
    ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS,
    ANALYTICALGROUPKD = new$ANALYTICALGROUPKD,
    PROGRAMCODE = new$PROGRAMCODE,
    INNERFINSOURCE = new$INNERFINSOURCE,
    REESTRTYPE = new$REESTRTYPE,
    OKTMO = new$OKTMO,
    DOCBASE = new$DOCBASE,
    FUNDSSOURCE = new$FUNDSSOURCE,
    FINSOURCE = new$FINSOURCE,
    DOCTYPE = new$DOCTYPE,
    COMMDIRECTIONEXPENCECLS = new$COMMDIRECTIONEXPENCECLS,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    PAYDESTINATION = new$PAYDESTINATION,
    FACIALACC_CLS = new$FACIALACC_CLS,
    REGPROJECTRESULT = new$REGPROJECTRESULT,
    NATIONALPROJECT = new$NATIONALPROJECT,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    LINKRECORD = new$LINKRECORD,
    ATTACHTO = new$ATTACHTO,
    STOREDCONTENT = new$STOREDCONTENT,
    BUDGETREF = new$BUDGETREF,
    NOTE = new$NOTE,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    STARTDATE = new$STARTDATE,
    DELETEDATE = new$DELETEDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_ClsCorrValues_AU_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (98112, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=98112) and (RecordId=new$ID);
      
  END IF;

END;
/

CREATE OR REPLACE TRIGGER TR_ClsCorrValues_ID
  INSTEAD OF DELETE
  ON ClsCorrValues
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ClsCorrValues
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_ClsCorrValues_AD_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(98112,:old.ID,SYSDATE);

END;
/

COMMIT WORK
/

-- #########################################################
-- #########################################################
-- Add_Purpose_Bankexch_Ls_Kb.sql
-- #########################################################
-- #########################################################

/*    Purpose ( )   Bankexch_Ls_Kb*/
ALTER TABLE Bankexch_Ls_Kb ADD (
  Purpose VARCHAR2(2000)
)
/
commit work 
/



-- #########################################################
-- #########################################################
-- Alter_OOS_ContrFin_and_SubsidyCls.sql
-- #########################################################
-- #########################################################

/*    InvestObject (       ),
 Note (  ), StoredContent ( )   OOS_CONTRACT_FINANCES,  
  SubsidyType ( ), SubsidyTypeResult (   ), ResultType (  ) 
 StoredContent ( )   SubsidyCls */
ALTER TABLE OOS_CONTRACT_FINANCES ADD (
  InvestObject VARCHAR2(50),/*         */
  NOTE VARCHAR2(255),/* .   */
  STOREDCONTENT VARCHAR2(4000)/*   */
)
/
ALTER TABLE SubsidyCls ADD (
  SubsidyType NUMBER(10),/*   */
    CHECK((SubsidyType<=2147483647)AND(SubsidyType>-2147483648)),
  SubsidyTypeResult VARCHAR2(255),/*     */
  ResultType VARCHAR2(2000),/*    */
  STOREDCONTENT VARCHAR2(4000)/*   */
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Add_Fields_CorrDet_RepClsDet.sql
-- #########################################################
-- #########################################################

ALTER TABLE TB_CorrectionDetail ADD (
  PaymentCodeType NUMBER(10),
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648))
)
/

CREATE OR REPLACE VIEW CorrectionDetail (
  ID,
  PARENTID,
  BUDGETREF,
  SUMMA,
  CLSTYPE,
  FACIALACC_CLS,
  KVSR,
  KFSR,
  KCSR,
  KVR,
  KESR,
  DIRECTIONCLS,
  MEANSTYPE,
  FACT,
  REGIONCLS,
  FINSOURCE,
  FINTYPE,
  DOCTYPE,
  SUBKESR,
  FUNDSSOURCE,
  KD,
  IFS,
  BUHOPERATIONCLS,
  CHANGEACC_REF,
  CHANGEACC,
  CHANGEORGINN,
  CHANGEORGINN20,
  PROGINDEX,
  RECORDINDEX,
  DOCUMENTPROGINDEX,
  DOCUMENTRECORDINDEX,
  ISBLOCKED,
  BLOCKEDCAUSE,
  UNBLOCKEDDATE,
  UNBLOCKEDCAUSE,
  SENDERID,
  SENDERRECORDID,
  RVERSION,
  CREATERUSER,
  CREATEDATE,
  UPDATERUSER,
  UPDATEDATE,
  NOTE,
  ISCLSCHANGED,
  PROMISE,
  BUDGETPROMISE,
  EXECDOC,
  OKATO,
  ADDOKATO,
  TRANSFERTCLS,
  ORIGINALCLSSUMMA,
  NOTECLS,
  OPERATIONTYPE,
  REVERSEFLAG,
  EXECINNERNUMBER,
  CLSFIELFCHANGED,
  FAORGTYPE,
  SUBSIDYCLS,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  NOTEQUALEX,
  OKTMO,
  UINCODE,
  INVESTOBJECT,
  CHANGEORGNAME,
  CONTRACTCOSTSCLS,
  TARGETCLS,
  STOREDCONTENT,
  REGPROJECTRESULT,
  INCOMETARGETFUNDS,
  PAYTARGETFUNDS,
  ANALYTICALPARTITION,
  PAYMENTCODETYPE)
AS
  SELECT
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION,
    PAYMENTCODETYPE
  FROM TB_CorrectionDetail
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_ID
  INSTEAD OF DELETE
  ON CORRECTIONDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_500 (TR_CORRECTIONDETAIL_BD_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  Update CorrectionCaption set
  DocChangeDate = SYSDATE,
  RVersion = -1
  where id = :old.recordindex;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_CORRECTIONDETAIL
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_CORRECTIONDETAIL_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate, ProgIndex, SUMMA) values(5504,:old.ID,SYSDATE,:old.ProgIndex, :old.SUMMA);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$INCOMETARGETFUNDS CORRECTIONDETAIL.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS CORRECTIONDETAIL.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION CORRECTIONDETAIL.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
  new$PAYMENTCODETYPE CORRECTIONDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  BEGIN

    /*  ,    */
    SELECT
    CorCap.BudgetRef
    INTO new$BudgetRef   FROM
    correctioncaption CorCap
    WHERE
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  if ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, new$transfertcls, NULL, new$meanstype,
    new$targetcls,new$targetcls); 
  END IF;
  /*   */
  GetDocumentKESR(NULL, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT,
    REGPROJECTRESULT,
    INCOMETARGETFUNDS,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION,
    PAYMENTCODETYPE
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT,
    new$REGPROJECTRESULT,
    new$INCOMETARGETFUNDS,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION,
    new$PAYMENTCODETYPE);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_IU
  INSTEAD OF UPDATE
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$REGPROJECTRESULT CORRECTIONDETAIL.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$INCOMETARGETFUNDS CORRECTIONDETAIL.INCOMETARGETFUNDS%TYPE := :NEW.INCOMETARGETFUNDS;
  new$PAYTARGETFUNDS CORRECTIONDETAIL.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION CORRECTIONDETAIL.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
  new$PAYMENTCODETYPE CORRECTIONDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
  vOperationTypeS$ NUMBER(10);
  vOperationTypeD$ NUMBER(10);
  vOperationType$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CORRECTIONDETAIL_BU)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS$, vOperationTypeD$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType$ := vOperationTypeS$;
          
    ELSE 
      vOperationType$ := vOperationTypeD$;
    END IF;
    new$OperationType := vOperationType$;
      
  END IF;
  /*     \*/
  IF ((new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType IS NULL)) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  ON (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);    
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_100 (tr_correctiondetail_bu_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$buhoperationcls <> :old.buhoperationcls) and (new$progindex = 316)) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_CORRECTIONDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_CORRECTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise )) and
    (new$BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum1$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;

    /*  BudgetPromise    Promise=NULL,   Promise */
    if (new$Promise is null and ((new$BudgetPromise is not null and :old.BudgetPromise is null) or
    (new$BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select
        ANumber
        into BPInnerNum1$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;

    END IF;

    /*  BudgetPromise -   Promise */
    if ((new$BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      new$Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((new$Promise is null) and (:old.Promise is not null)) then
      new$BudgetPromise := null;
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_CORRECTIONDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null and (
    (:old.Promise is null or :old.Promise <> new$Promise) or
    (:old.ExecDoc is null or new$ExecDoc is null or :old.ExecDoc <> new$ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$ExecDoc is null or :old.ExecDoc is null or new$ExecDoc <> :old.ExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_CORRECTIONDETAIL_BU_700)
-- Create 13.08.2007
-- - - - - - - - - - - - -

 if (new$RVersion is null) then
   new$RVersion:=1;
 else
   if ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
     new$RVersion:=:Old.RVersion;
   else
     new$RVersion:=:Old.RVersion+1;
   end if;
 end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_CORRECTIONDETAIL SET
    ID = new$ID,
    PARENTID = new$PARENTID,
    BUDGETREF = new$BUDGETREF,
    SUMMA = new$SUMMA,
    CLSTYPE = new$CLSTYPE,
    FACIALACC_CLS = new$FACIALACC_CLS,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    MEANSTYPE = new$MEANSTYPE,
    FACT = new$FACT,
    REGIONCLS = new$REGIONCLS,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    DOCTYPE = new$DOCTYPE,
    SUBKESR = new$SUBKESR,
    FUNDSSOURCE = new$FUNDSSOURCE,
    KD = new$KD,
    IFS = new$IFS,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CHANGEACC_REF = new$CHANGEACC_REF,
    CHANGEACC = new$CHANGEACC,
    CHANGEORGINN = new$CHANGEORGINN,
    CHANGEORGINN20 = new$CHANGEORGINN20,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    DOCUMENTPROGINDEX = new$DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX = new$DOCUMENTRECORDINDEX,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    RVERSION = new$RVERSION,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    NOTE = new$NOTE,
    ISCLSCHANGED = new$ISCLSCHANGED,
    PROMISE = new$PROMISE,
    BUDGETPROMISE = new$BUDGETPROMISE,
    EXECDOC = new$EXECDOC,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    TRANSFERTCLS = new$TRANSFERTCLS,
    ORIGINALCLSSUMMA = new$ORIGINALCLSSUMMA,
    NOTECLS = new$NOTECLS,
    OPERATIONTYPE = new$OPERATIONTYPE,
    REVERSEFLAG = new$REVERSEFLAG,
    EXECINNERNUMBER = new$EXECINNERNUMBER,
    CLSFIELFCHANGED = new$CLSFIELFCHANGED,
    FAORGTYPE = new$FAORGTYPE,
    SUBSIDYCLS = new$SUBSIDYCLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    NOTEQUALEX = new$NOTEQUALEX,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    INVESTOBJECT = new$INVESTOBJECT,
    CHANGEORGNAME = new$CHANGEORGNAME,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    STOREDCONTENT = new$STOREDCONTENT,
    REGPROJECTRESULT = new$REGPROJECTRESULT,
    INCOMETARGETFUNDS = new$INCOMETARGETFUNDS,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    ANALYTICALPARTITION = new$ANALYTICALPARTITION,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_CORRECTIONDETAIL_AU_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (5504, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=5504) and (RecordId=new$ID);
  end if;

END;
/
ALTER TABLE TB_CorrectionDetail ADD (
  CONSTRAINT FK_CORRDET_Payment FOREIGN KEY (PaymentCodeType) REFERENCES PaymentCodeType(ID)
)
/
CREATE INDEX FK_CORRDET_Payment ON TB_CorrectionDetail(PaymentCodeType)
/
ALTER TABLE ReplacementClsDetailInfo ADD (
  PaymentCodeType NUMBER(10),
    CHECK((PaymentCodeType<=2147483647)AND(PaymentCodeType>-2147483648))
)
/
ALTER TABLE ReplacementClsDetailInfo ADD (
  CONSTRAINT FK_REPCLSDET_Payment FOREIGN KEY (PaymentCodeType) REFERENCES PaymentCodeType(ID)
)
/
CREATE INDEX FK_REPCLSDET_Payment ON ReplacementClsDetailInfo(PaymentCodeType)
/
commit work
/

-- #########################################################
-- #########################################################
-- InsertDocTypes.sql
-- #########################################################
-- #########################################################

insert into RemoteDocument
  (ID, Name)
values
  (283, '   ')
/
commit work
/

-- #########################################################
-- #########################################################
-- update_InterfacesBuhOP.sql
-- #########################################################
-- #########################################################

/*   .  03.25*/
ALTER TRIGGER TR_INTERFACESBUHOP_BU_500 DISABLE
/
update InterfacesBuhOP
set DetailNumber = 1
where (InterfaceCLS = 325) and ((BuhOperationCLS = 0) or (BuhOperationCLS = 99999))
/
delete from InterfacesBuhOP
where (InterfaceCLS = 325) and (BuhOperationCLS = 601)
/
ALTER TRIGGER TR_INTERFACESBUHOP_BU_500 ENABLE
/
commit work 
/

-- #########################################################
-- #########################################################
-- UpdDocFields_14.00.00_Ora.sql
-- #########################################################
-- #########################################################


--  : 130000 - 140000.     30.08.2021 14:26:49.
CREATE OR REPLACE PROCEDURE ImportDocType (
   ID_               NUMBER,
   PROGINDEX_        NUMBER,
   NAME_             VARCHAR2,
   USESTATE_         NUMBER,
   DBTABLE_          VARCHAR2,
   NEEDEDS_          NUMBER,
   LOCKMASK_         NUMBER,
   DEFAULTACTIONMACROSNAME_ VARCHAR2,
   DOCUMENTKIND_     NUMBER,
   SHORTNAME_         VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentTypes
    WHERE (ID = ID_);

  IF (IDExists$ = 0) THEN
     INSERT INTO DocumentTypes
                 (ID, PROGINDEX, NAME, USESTATE, DBTABLE, NEEDEDS, LOCKMASK, DEFAULTACTIONMACROSNAME, DOCUMENTKIND, SHORTNAME)
          VALUES (ID_, PROGINDEX_, NAME_, USESTATE_, DBTABLE_, NEEDEDS_, LOCKMASK_, DEFAULTACTIONMACROSNAME_, DOCUMENTKIND_, SHORTNAME_);
  else
      Update documenttypes set
        Name=Name_,
		    DBTABLE=DBTABLE_,
        LockMask=LockMask_,
        DEFAULTACTIONMACROSNAME=DEFAULTACTIONMACROSNAME_,
        DOCUMENTKIND=DOCUMENTKIND_,
        SHORTNAME=SHORTNAME_,
	      PROGINDEX=PROGINDEX_
      where (id=ID_)
        and (
          (Name<>Name_) or
          ((LockMask is null) and (LockMask_ is not null)) or
          ((LockMask is not null) and (LockMask_ is null)) or
          ((LockMask is not null) and (LockMask_ is not null) and (LockMask <> LockMask_)) or
          (DEFAULTACTIONMACROSNAME is null) or
          (DOCUMENTKIND<>DOCUMENTKIND_) or 
          (SHORTNAME is null) or 
          (SHORTNAME<>SHORTNAME_) or
          (PROGINDEX <> PROGINDEX_) or 
          ((DBTABLE is null) and (DBTABLE_ is not null)) or
          ((DBTABLE is not null) and (DBTABLE_ is null)) or
          ((DBTABLE is not null) and (DBTABLE_ is not null) and (DBTABLE <> DBTABLE_))
        );
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE UPDATEINTERFACES (
  CLS_   NUMBER,
  NOTE_  VARCHAR2,
  GUID_  VARCHAR2,
  PARAM_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT (ID)
   INTO IDEXISTS$
   FROM INTERFACES
  WHERE (GUID=GUID_);
  
  IF (IDExists$ = 0)  THEN
    INSERT INTO INTERFACES
      (CLS,NOTE,GUID,PARAM)
    VALUES
      (CLS_,NOTE_,GUID_,PARAM_);
  ELSE
    IF ((PARAM_ ='')OR(PARAM_ IS NULL)) THEN 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    ELSE 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND (PARAM=PARAM_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    END IF;
  END IF;
END;
/

--   
CALL ImportDocType(0, 0, ' ', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(101, 223, '   ', 0, ' ', 0,-1,'',10200,'') ;

CALL ImportDocType(200, 0, '  ()', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(201, 32, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(203, 261, '  ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(204, 262, ' , ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(205, 263, '', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL ImportDocType(206, 268, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'__') ;

CALL ImportDocType(207, 272, '  ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(209, 274, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(209, ' ', '{DA309359-EF6B-4D29-AC0D-309040B5CDB6}', '') ;

CALL ImportDocType(210, 252, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(210, ' ', '{2EF0F811-E21F-4ADB-BC7E-A3A9B16059A4}', '') ;

CALL ImportDocType(211, 275, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(211, ' ', '{AE8281A0-BE7F-4F3A-90BD-A7831E8D842F}', '') ;

CALL ImportDocType(212, 276, '  , ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(212, '  , ', '{B743C24B-6E28-4C9C-B3CA-16AC6E529D07}', '') ;

CALL ImportDocType(213, 277, '     ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(213, '     ', '{88C29844-D7AE-41B0-A693-9785E7B791B0}', '') ;

CALL ImportDocType(216, 280, '   ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL ImportDocType(217, 281, '   ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL ImportDocType(218, 282, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(218, ' ', '{1E3FC33F-6353-490C-B794-6FF98BBCD41F}', '') ;

CALL ImportDocType(300, 0, '  ', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(301, 66, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(302, 63, '  \', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(303, 65, ' ()', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(304, 64, '  ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(305, 61, '  \', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(307, 0, ' ', 0, 'FacialFinReestr', 0,-1,'_',10100,'') ;

CALL ImportDocType(308, 67, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(308, ' ', '{B50F2C63-9CF4-42C3-8062-E355EABD53E4}', '') ;

CALL ImportDocType(322, 73, '  ', 0, 'FacialFinCaption', 0,-1,'_',10200,'') ;

CALL ImportDocType(323, 75, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(324, 76, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(325, 283, '   ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(325, '   ', '{594D6AF0-9A00-4380-B4FE-9C18C45B2B70}', '') ;

CALL ImportDocType(801, 57, ' ', 0, 'LimitNotifyCaption[RVERSION=RVERSION-1]', 0,34,'_',10100,'_') ;

CALL ImportDocType(903, 45, '  ', 0, 'QuotesTitle', 0,-1,'',10100,'_') ;

CALL ImportDocType(1601, 224, ' ', 0, 'Promise_Caption', 0,-1,'_',10100,'') ;

CALL ImportDocType(1805, 0, '  ', 0, '', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1805, '  ', '{FE9F8D41-C23F-11D5-B571-0050BF2079BC}', '') ;

CALL ImportDocType(1810, 0, '  ', 0, ' ', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1810, '  ', '{EF52F7D8-C963-492E-8012-F94BD6E4197E}', '') ;

CALL ImportDocType(1819, 0, '  -  2020   ', 0, 'OOS_CONTRACT', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1819, '  -  2020   ', '{95E88D33-7335-4272-AFB7-FEB8EB4FDE32}', '') ;

CALL ImportDocType(1820, 0, '  -  2020 ', 0, 'OOS_CONTRACT', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1820, '  -  2020 ', '{DD1E0269-F97E-45A0-BF08-AB5696B158E5}', '') ;

CALL ImportDocType(1821, 0, '    ', 0, 'PayDocExchange', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1821, '    ', '{8BD77688-893C-421E-BF64-C39D4145BDB3}', '') ;

CALL ImportDocType(1824, 0, '   ', 0, 'PayDocExchange ', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1824, '   ', '{FA8F91B3-8E66-4E06-8400-EF4C07CA439E}', '') ;

CALL ImportDocType(1825, 0, '    	', 0, 'PayDocExchange ', 0,-1,'',10200,'	') ;

CALL UpdateInterfaces(1825, '    	', '{698B68B7-A731-4FCF-A36D-19A77365DF41}', '') ;

CALL ImportDocType(1900, 0, '  ()', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(1901, 264, ' ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1902, 215, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1903, 265, '  ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1906, 271, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'__') ;

CALL ImportDocType(2501, 305, ' ', 0, 'Agreements', 0,-65537,'',10100,'') ;

CALL ImportDocType(2502, 304, ' ', 0, 'Agreements', 0,-65537,'',10100,'') ;

CALL ImportDocType(2503, 308, '  ', 0, 'ExecutionDocumentsCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(2504, 314, ' ', 0, 'Agreements', 0,-65537,'',10100,'') ;

CALL ImportDocType(2801, 0, '      ', 0, ' ', 0,-1,'',10200,'') ;

CALL ImportDocType(2802, 0, '  ', 0, ' ', 0,-1,'',10200,'') ;

CALL ImportDocType(3001, 230, '   ', 0, 'TenderCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(3002, 0, '', 0, 'TenderResultCaption', 0,0,'',3,'') ;

CALL ImportDocType(3003, 234, ' ', 0, 'TenderResultCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(3004, 0, ' ', 0, 'TenderProposal', 0,0,'',3,' ') ;

CALL ImportDocType(3005, 240, '   223-', 0, 'TenderCaption', 0,127,'',10100,'') ;

CALL ImportDocType(3006, 241, '    223-', 0, 'TenderCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(3010, 242, '- ', 0, 'TenderCaption', 0,-1,'',10100,'') ;

CALL ImportDocType(3011, 243, ' - ', 0, 'TenderCaption', 0,-1,'',10100,'') ;

CALL ImportDocType(3610, 550, '  ', 0, 'UTypedFormsCaption', 0,-1,'',10100,'5') ;

CALL ImportDocType(3701, 235, ' ', 0, 'TenderObjects', 0,-65537,'',10100,'') ;

CALL ImportDocType(3901, 0, '. ', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(4401, 251, ' ', 0, 'UnionNotifyCaption', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(4401, ' ', '{AB6937F7-A672-461D-A94C-808F4DCA4D71}', '') ;

CALL ImportDocType(4403, 254, ' ,', 0, 'UnionNotifyCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(4701, 0, ' ', 0, 'SIGNCERTIFICATE', 0,-1,'',10100,' ') ;

CALL UpdateInterfaces(4701, ' ', '{BA49C180-7730-468A-81A3-A9DF8AEB8966}', '') ;

CALL ImportDocType(4801, 528, ' ', 0, 'GeneralDocuments', 0,-1,'_',10100,'') ;

CALL ImportDocType(4901, 525, '   ', 0, 'DataPacket', 0,-1,'_',10100,'') ;

CALL ImportDocType(4902, 526, ' ', 0, '', 0,-1,'',10200,'') ;

CALL ImportDocType(4903, 527, ' ', 0, 'DataPacket', 0,-1,'_',10100,'') ;

CALL ImportDocType(5101, 0, '  ', 0, 'StoredAttributesCaption', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(5101, '  ', '{12614FA4-D546-4C45-8946-43813CED6EBF}', '') ;

CALL ImportDocType(5201, 556, ' / ', 0, 'WritExecutionCaption', 0,-1,'',10100,'') ;

CALL UpdateInterfaces(5201, ' / ', '{623EE404-09D9-4069-9115-27974DB69AD1}', '') ;

CALL ImportDocType(5301, 0, '   ', 0, '', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(5301, '   ', '{FF462FFC-4DA8-4A24-B2BA-0B6478238E00}', '') ;

CALL ImportDocType(5302, 0, ' ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(5302, ' ', '{A4B37143-4DD8-4BFF-9E80-ADF04718ED02}', '') ;

CALL ImportDocType(5303, 0, '   Web-', 0, '', 0,0,'',3,'') ;

CALL UpdateInterfaces(5303, '   Web-', '{E212ED5E-7AA3-4D6C-A124-547EDFA04D0A}', '') ;

CALL ImportDocType(5304, 0, '   ', 0, '', 0,0,'',3,'') ;

CALL UpdateInterfaces(5304, '   ', '{98E55E99-2055-4653-AB8D-A85913DDBF8A}', '') ;

CALL ImportDocType(5305, 0, '  c', 0, '', 0,0,'',3,'') ;

CALL UpdateInterfaces(5305, '  c', '{0C4B375D-F354-4967-9F8C-3AD9F72DA866}', '') ;

CALL ImportDocType(5306, 0, ' c  ', 0, '', 0,0,'',3,'') ;

CALL UpdateInterfaces(5306, ' c  ', '{5607E299-3CF3-4E11-AB66-FDCE93A1B540}', '') ;

CALL ImportDocType(5401, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(5401, '  ', '{664FA50A-3858-47D0-BBB4-CEF206EFCA63}', '') ;

CALL ImportDocType(5402, 0, '   ', 0, 'EPBSExportLogCaption', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(5402, '   ', '{FFEDC65A-7FF7-45F0-81B6-84896D6B3D15}', '') ;

CALL ImportDocType(5502, 313, '   ', 0, 'CorrectionCaption', 0,-1,'',10100,'_') ;

CALL ImportDocType(5601, 0, ' ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(5601, ' ', '{3EEE1CE2-1E53-47B3-BAA9-7E09642024EB}', '') ;

CALL ImportDocType(9709, 0, '   ', 0, 'TargetCls', 0,0,'',20100,'') ;

CALL ImportDocType(9710, 0, '', 0, 'NATIONALPROJECT', 0,0,'',20100,'') ;

CALL ImportDocType(9711, 0, '  ', 0, 'RegProjectResult', 0,0,'',20100,'') ;

CALL ImportDocType(9712, 0, '   ', 0, 'IncomeTargetFunds', 0,0,'',20100,'') ;

CALL ImportDocType(9713, 0, '   ', 0, 'PayTargetFunds', 0,0,'',20100,'') ;

CALL ImportDocType(9714, 0, '     ', 0, 'AnalyticalPartition', 0,0,'',20100,'') ;

CALL ImportDocType(9716, 0, '  ', 0, 'PaymentCodeType', 0,0,'',20100,'') ;

CALL ImportDocType(9802, 0, '', 0, 'kfsr', 0,0,'',20200,'') ;

CALL ImportDocType(9803, 0, ' ', 0, 'KVSR', 0,0,'',20100,'') ;

CALL ImportDocType(9804, 0, '', 0, 'KVR', 0,0,'',20100,'') ;

CALL ImportDocType(9805, 0, '', 0, 'KCSR', 0,0,'',20100,'') ;

CALL ImportDocType(9808, 0, '', 0, 'KESRSubCode', 0,0,'',20100,'') ;

CALL ImportDocType(9816, 0, ' ', 0, 'MeansCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9817, 0, '', 0, 'REFCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9818, 0, '', 0, 'CURRENCYCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9820, 0, '  ()', 0, 'ORG_CLS', 0,0,'',20200,'') ;

CALL ImportDocType(9821, 0, '  ', 0, 'ACC_CLS', 0,0,'',20200,'') ;

CALL ImportDocType(9822, 0, ' ', 0, 'GroupInf_CLS', 0,0,'',20200,'') ;

CALL ImportDocType(9823, 0, '', 0, 'GOSNI', 0,0,'',20200,'') ;

CALL ImportDocType(9826, 0, ' ', 0, 'BUDGETACCOUNTS', 0,0,'',20200,'') ;

CALL ImportDocType(9827, 0, '  ', 0, 'FinType', 0,0,'',20200,'') ;

CALL ImportDocType(9828, 0, '', 0, 'FACT', 0,0,'',20100,'') ;

CALL ImportDocType(9829, 0, '- ', 0, 'DocBase', 0,0,'',20200,'') ;

CALL ImportDocType(9834, 0, ' ', 0, 'ReportType', 0,0,'',20200,'') ;

CALL ImportDocType(9835, 0, '  (  )', 0, 'BUDGETTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9841, 0, ' ', 0, 'FACIALACC_CLS', 0,0,'',20200,'') ;

CALL ImportDocType(9842, 0, '2', 0, 'OKVED2', 0,0,'',20200,'2') ;

CALL ImportDocType(9843, 0, ' ', 0, 'PAYTYPECLS', 0,0,'',20200,'') ;

CALL ImportDocType(9844, 0, '  ', 0, 'Org_AccDefaults', 0,0,'',20200,'') ;

CALL ImportDocType(9845, 0, ' ', 0, 'PAYSYMBOLCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9846, 0, ' ()', 0, 'BUHPAYMENTCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9847, 0, ' ', 0, 'TYPEOPERATIONCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9848, 0, ' ', 0, 'PAYDESTINATIONCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9849, 0, ' ', 0, 'MEANSTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9850, 0, ' ', 0, 'RejectCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9851, 0, ' ', 0, 'Error', 0,0,'',20200,'') ;

CALL ImportDocType(9852, 0, '   ', 0, 'InnerFinSource', 0,0,'',20100,'') ;

CALL ImportDocType(9853, 0, ' ', 0, 'REESTRTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9854, 0, '', 0, 'INVESTOBJECT', 0,0,'',20100,'') ;

CALL ImportDocType(9857, 0, ' ', 0, 'LOANTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9858, 0, ' ', 0, 'DEBTTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9859, 0, '', 0, 'DepartmentCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9860, 0, ' ', 0, 'MEASUREMENTCLS', 0,0,'',20200,'') ;

CALL ImportDocType(9861, 0, ' ', 0, 'TenderObjects', 0,0,'',20200,'') ;

CALL ImportDocType(9862, 0, '', 0, 'OKATO', 0,0,'',20200,'') ;

CALL ImportDocType(9863, 0, ' ', 0, 'COLLATERALTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9864, 0, ' ', 0, 'PlanDocType', 0,0,'',20200,'') ;

CALL ImportDocType(9865, 0, ' ', 0, 'BuhAccPlan', 0,0,'',20100,'') ;

CALL ImportDocType(9867, 0, '2', 0, 'OKPD2', 0,0,'',20200,'2') ;

CALL ImportDocType(9868, 0, '    ', 0, 'KESR', 0,0,'',20100,'') ;

CALL ImportDocType(9869, 0, '', 0, 'DirectionCLS', 0,0,'',20100,'') ;

CALL ImportDocType(9870, 0, '  ', 0, 'ProgramCode', 0,0,'',20200,'') ;

CALL ImportDocType(9871, 0, ' ', 0, 'BuhOperationCls', 0,0,'',20200,'') ;

CALL ImportDocType(9872, 0, '', 0, 'BalanceCls', 0,0,'',20200,'') ;

CALL ImportDocType(9878, 0, '', 0, 'budgets_s', 0,0,'',20200,'') ;

CALL ImportDocType(9879, 0, ' ', 0, 'TargetCls', 0,0,'',20100,'') ;

CALL ImportDocType(9880, 0, '  ', 0, 'FundsSource', 0,0,'',20200,'') ;

CALL ImportDocType(9881, 0, '', 0, 'OKFS', 0,0,'',20200,'') ;

CALL ImportDocType(9882, 0, '', 0, 'OKOPF', 0,0,'',20200,'') ;

CALL ImportDocType(9883, 0, ' ', 0, 'Org_Type', 0,0,'',20200,'') ;

CALL ImportDocType(9884, 0, '  ', 0, 'TransfertCLS', 0,0,'',20100,'') ;

CALL ImportDocType(9885, 0, ' ', 0, 'AssignmentKind', 0,0,'',20200,'') ;

CALL ImportDocType(9886, 0, ' ', 0, 'AssignmentSource', 0,0,'',20200,'') ;

CALL ImportDocType(9887, 0, '', 0, 'VariantCls', 0,0,'',20200,'') ;

CALL ImportDocType(9888, 0, '  ', 0, 'OKP', 0,0,'',20200,'') ;

CALL ImportDocType(9889, 0, ' ', 0, 'SubsidyCls', 0,0,'',20100,'') ;

CALL ImportDocType(9890, 0, ' ', 0, 'BudAllocationCls', 0,0,'',20100,'') ;

CALL ImportDocType(9891, 0, '  ', 0, 'PayPromiseCls', 0,0,'',20100,'') ;

CALL ImportDocType(9892, 0, '   ()', 0, 'ARCHIVEDOCTYPE', 0,0,'',20100,'') ;

CALL ImportDocType(9894, 0, '    ', 0, 'COMMDIRECTIONEXPENCECLS', 0,0,'',20100,'') ;

CALL ImportDocType(9895, 0, '', 0, 'OKTMO', 0,0,'',20100,'') ;

CALL ImportDocType(9897, 0, '', 0, 'ContractCostsCls', 0,0,'',20100,'') ;

CALL ImportDocType(9898, 0, ' ', 0, 'PURCHASETYPE ', 0,0,'',20100,'') ;

CALL ImportDocType(9899, 0, ' ', 0, 'DBUsers', 0,0,'',20100,'') ;

CALL ImportDocType(9903, 0, ' ', 0, 'ORGANIZATIONS', 0,-1,'',10100,'_') ;

CALL ImportDocType(9904, 560, '  ', 0, 'CONTACTPERSONS', 0,0,'',10200,' ') ;

CALL ImportDocType(9905, 0, ' ', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(9908, 0, ' ', 0, '', 0,0,'',10200,'_') ;

CALL ImportDocType(9912, 0, ' ', 0, ' ', 0,-1,'',10200,'') ;

CALL ImportDocType(9913, 0, '', 0, '', 0,0,'',10200,'') ;

CALL ImportDocType(9914, 0, '  ', 0, '', 0,-1,'',10200,'') ;

CALL ImportDocType(9915, 0, '  ', 0, 'UnLockDates', 0,-1,'',10100,'') ;

CALL ImportDocType(9916, 0, ' ', 0, '', 0,0,'',10300,'') ;

CALL ImportDocType(9917, 0, ' ', 0, '', 0,0,'',10300,'') ;

CALL ImportDocType(9918, 0, '', 0, '', 0,0,'',10200,'') ;

CALL ImportDocType(9919, 0, ' ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9919, ' ', '{88FA05A2-02A0-11D2-B26C-008048E689F8}', '') ;

CALL ImportDocType(9920, 0, '   ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9920, '   ', '{2F5EDB5F-CC69-4F04-9C91-B457D92C75AC}', '') ;

CALL ImportDocType(9921, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9921, '  ', '{61875F0C-17AA-44F1-80F0-B689371AFBDF}', '') ;

CALL ImportDocType(9922, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9922, '  ', '{C9277BAB-1206-41DD-966D-5D86A9E75AB8}', '') ;

CALL ImportDocType(9923, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9923, '  ', '{82245B63-9A83-41F5-8541-A77AAD1B6EAA}', '') ;

CALL ImportDocType(9924, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9924, '  ', '{4C71385E-A42A-43D1-AEBB-807B3C86E76B}', '') ;

CALL ImportDocType(9925, 0, '  ', 0, 'Cards', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9925, '  ', '{992D6D69-0DA8-490F-8F88-EA0EB3C78CF3}', '') ;

CALL ImportDocType(9926, 0, '   ', 0, 'WritNotifyCls ', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9926, '   ', '{89CAEE9C-9516-4EE2-8A4B-CB0BFA9165AB}', '') ;

CALL ImportDocType(9927, 0, '  ', 0, 'RemoteClient', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9927, '  ', '{60EFBA81-B436-11D6-8CA4-000021DDD8CD}', '') ;

CALL ImportDocType(9928, 0, '   ', 0, 'ClsCorrespondents', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9928, '   ', '{C1FAE5FE-7817-4D46-858B-ACFA478BA485}', '') ;

CALL ImportDocType(9929, 0, '    ', 0, 'BudStruct', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9929, '    ', '{B95FC8BB-D031-4122-B714-B6F41ACFA610}', '') ;

CALL ImportDocType(9930, 0, '   ', 0, 'AutoSanctionData', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9930, '   ', '{23B8DC44-93C1-48C2-B2EB-DCAF31C23929}', '') ;

CALL ImportDocType(9931, 0, '   ', 0, 'ClsCorrespondents', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9931, '   ', '{DCD828A5-5C9F-4446-ACA2-85F6B3BE0FD6}', '') ;

CALL ImportDocType(9932, 0, '  /  ', 0, 'BudStrLink', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9932, '  /  ', '{9B39F873-9C5A-4856-A0B5-FDCFE2E8115A}', '') ;

CALL ImportDocType(9933, 0, '  ', 0, 'ClsCorr', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9933, '  ', '{CC5088E4-F586-433A-A7D7-72FA82B68C39}', '') ;

CALL ImportDocType(9934, 0, '  ', 0, 'ClsCorr', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9934, '  ', '{F8400531-E7F1-42A4-BF35-FAAE44EB7ED6}', '') ;

DROP PROCEDURE ImportDocType
/

DROP PROCEDURE UPDATEINTERFACES
/



CREATE OR REPLACE PROCEDURE SELECTIONS_IMPORT(
  ID_ NUMBER,
  KIND_ NUMBER,
  NAME_ VARCHAR2,
  NOTE_ VARCHAR2,
  READONLY_ NUMBER,
  USEINDOC_ NUMBER,
  TABLENAME_ VARCHAR2,
  ALIAS_ VARCHAR2,
  TABLECODE_ NUMBER,
  NEEDGROUPONDB_ NUMBER,
  NEEDDISTINCT_ NUMBER,
  MASTER_ NUMBER,
  DISCRIMVALUE_ VARCHAR2,
  AVAILABLEINDEREF_ NUMBER,
  CACHETYPE_ NUMBER,
  FULLORMODINSREFRTIME_ NUMBER,
  DELETEREFRTIME_ NUMBER,
  FINDTIMEREFRESH_ NUMBER,
  ANNOTATION_ VARCHAR2,
  DEREFNAME_ VARCHAR2,
  GroupID_ NUMBER,
  IsLogged_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONS SET
      KIND = KIND_,
      NAME = NAME_,
      NOTE = NOTE_,
      READONLY = READONLY_,
      USEINDOC = USEINDOC_,
      TABLENAME = TABLENAME_,
      ALIAS = ALIAS_,
      TABLECODE = TABLECODE_,    
      NEEDGROUPONDB = NEEDGROUPONDB_,
      NEEDDISTINCT = NEEDDISTINCT_,
      MASTER = MASTER_,
      DISCRIMVALUE = DISCRIMVALUE_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,         
      CACHETYPE = CACHETYPE_,   
      FULLORMODINSREFRTIME = FULLORMODINSREFRTIME_,   
      DELETEREFRTIME = DELETEREFRTIME_,   
      FINDTIMEREFRESH = FINDTIMEREFRESH_,   
      ANNOTATION = ANNOTATION_,   
      DEREFNAME = DEREFNAME_,     
      GroupID = GroupID_, 
      IsLogged = IsLogged_  
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONS
      (ID, KIND, NAME, NOTE, READONLY, USEINDOC, TABLENAME, ALIAS, TABLECODE, NEEDGROUPONDB, NEEDDISTINCT, MASTER, DISCRIMVALUE,
      AVAILABLEINDEREF, CACHETYPE, FULLORMODINSREFRTIME, DELETEREFRTIME, FINDTIMEREFRESH, ANNOTATION, DEREFNAME, GroupID, IsLogged)
    VALUES
      (ID_, KIND_, NAME_, NOTE_, READONLY_, USEINDOC_, TABLENAME_, ALIAS_, TABLECODE_, NEEDGROUPONDB_, NEEDDISTINCT_, MASTER_, DISCRIMVALUE_,
      AVAILABLEINDEREF_, CACHETYPE_, FULLORMODINSREFRTIME_, DELETEREFRTIME_, FINDTIMEREFRESH_, ANNOTATION_, DEREFNAME_, GroupID_, IsLogged_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  ALIAS_ VARCHAR2,
  JOINORDER_ NUMBER,
  JOINTYPE_ NUMBER,
  RELATIONTYPE_ NUMBER,
  JOINCONDITION_ VARCHAR2,
  DONTUSETABLELIMITS_ NUMBER,
  LIMITNAMESLIST_ VARCHAR2,
  QueryGroup_ NUMBER  
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONSDETAIL
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONSDETAIL SET
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      ALIAS = ALIAS_,
      JOINORDER = JOINORDER_,
      JOINTYPE = JOINTYPE_,
      RELATIONTYPE = RELATIONTYPE_,
      JOINCONDITION = JOINCONDITION_,
      DONTUSETABLELIMITS = DONTUSETABLELIMITS_,
      LIMITNAMESLIST = LIMITNAMESLIST_,
      QueryGroup = QueryGroup_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONSDETAIL
      (ID, SELECTIONREF, TABLEREF, ALIAS, JOINORDER, JOINTYPE, RELATIONTYPE, JOINCONDITION, DONTUSETABLELIMITS, LIMITNAMESLIST, QueryGroup)
    VALUES
      (ID_, SELECTIONREF_, TABLEREF_, ALIAS_, JOINORDER_, JOINTYPE_, RELATIONTYPE_, JOINCONDITION_, DONTUSETABLELIMITS_, LIMITNAMESLIST_, QueryGroup_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_IMPORT(
  ID_ NUMBER,
  FIELDKIND_ NUMBER,
  DESCRIPTIONLEVEL_ NUMBER,
  ANCESTORREF_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  FIELDNAME_ VARCHAR2,
  DATATYPE_ NUMBER,
  SUBDATATYPE_ NUMBER,
  FIELDSIZE_ NUMBER,
  DISPLAYLABEL_ VARCHAR2,
  NOTE_ VARCHAR2,
  DEFAULTWIDTH_ NUMBER,
  EDITMASK_ VARCHAR2,
  DISPLAYFORMAT_ VARCHAR2,
  EDITFORMAT_ VARCHAR2,
  CANTEDIT_ NUMBER,
  NOVISUALIZE_ NUMBER,
  ENUMSREF_ NUMBER,
  REQUIRED_ NUMBER,
  FOREIGNKEY_ NUMBER,
  ONDELACTION_ NUMBER,
  PRIMARYKEY_ NUMBER,
  ISRVERSION_ NUMBER,
  LIMITPARAMNAMES_ VARCHAR2,
  FOLLOWORDER_ NUMBER,
  SORTDIRECTION_ NUMBER,
  SORTORDER_ NUMBER,
  AGRFUNCTION_ NUMBER,
  FLAGFIELDNAME_ NUMBER,
  FLAGDISPLAYLABEL_ NUMBER,
  FLAGNOTE_ NUMBER,
  FLAGDEFAULTWIDTH_ NUMBER,
  FLAGCANTEDIT_ NUMBER,
  FLAGNOVISUALIZE_ NUMBER,
  FLAGREQUIRED_ NUMBER,
  FLAGLIMITPARAMNAMES_ NUMBER,
  FLAGAGRFUNCTION_ NUMBER,
  ISTIMESTAMPFIELD_ NUMBER,
  ISBUDGET_ NUMBER,
  AVAILABLEINDEREF_ NUMBER,
  ANNOTATION_ VARCHAR2,
  ALIAS_ VARCHAR2,
  DEREFNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM FIELDSINFO
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE FIELDSINFO SET
      FIELDKIND = FIELDKIND_,
      DESCRIPTIONLEVEL = DESCRIPTIONLEVEL_,
      ANCESTORREF = ANCESTORREF_,
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      FIELDNAME = FIELDNAME_,
      DATATYPE = DATATYPE_,
      SUBDATATYPE = SUBDATATYPE_,
      FIELDSIZE = FIELDSIZE_,
      DISPLAYLABEL = DISPLAYLABEL_,
      NOTE = NOTE_,
      DEFAULTWIDTH = DEFAULTWIDTH_,
      EDITMASK = EDITMASK_,
      DISPLAYFORMAT = DISPLAYFORMAT_,
      EDITFORMAT = EDITFORMAT_,
      CANTEDIT = CANTEDIT_,
      NOVISUALIZE = NOVISUALIZE_,
      ENUMSREF = ENUMSREF_,
      REQUIRED = REQUIRED_,
      FOREIGNKEY = FOREIGNKEY_,
      ONDELACTION = ONDELACTION_,
      PRIMARYKEY = PRIMARYKEY_,
      ISRVERSION = ISRVERSION_,
      LIMITPARAMNAMES = LIMITPARAMNAMES_,
      FOLLOWORDER = FOLLOWORDER_,
      SORTDIRECTION = SORTDIRECTION_,
      SORTORDER = SORTORDER_,
      AGRFUNCTION = AGRFUNCTION_,
      FLAGFIELDNAME = FLAGFIELDNAME_,
      FLAGDISPLAYLABEL = FLAGDISPLAYLABEL_,
      FLAGNOTE = FLAGNOTE_,
      FLAGDEFAULTWIDTH = FLAGDEFAULTWIDTH_,
      FLAGCANTEDIT = FLAGCANTEDIT_,
      FLAGNOVISUALIZE = FLAGNOVISUALIZE_,
      FLAGREQUIRED = FLAGREQUIRED_,
      FLAGLIMITPARAMNAMES = FLAGLIMITPARAMNAMES_,
      FLAGAGRFUNCTION = FLAGAGRFUNCTION_,
      ISTIMESTAMPFIELD = ISTIMESTAMPFIELD_,
      ISBUDGET = ISBUDGET_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,
      ANNOTATION = ANNOTATION_,
      ALIAS = ALIAS_,
      DEREFNAME = DEREFNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO FIELDSINFO
      (ID, FIELDKIND, DESCRIPTIONLEVEL, ANCESTORREF, SELECTIONREF, TABLEREF, FIELDNAME, DATATYPE, SUBDATATYPE,
       FIELDSIZE, DISPLAYLABEL, NOTE, DEFAULTWIDTH, EDITMASK, DISPLAYFORMAT, EDITFORMAT, CANTEDIT, NOVISUALIZE,
       ENUMSREF, REQUIRED, FOREIGNKEY, ONDELACTION, PRIMARYKEY, ISRVERSION, LIMITPARAMNAMES,
       FOLLOWORDER, SORTDIRECTION, SORTORDER, AGRFUNCTION, FLAGFIELDNAME, FLAGDISPLAYLABEL, FLAGNOTE,
       FLAGDEFAULTWIDTH, FLAGCANTEDIT, FLAGNOVISUALIZE, FLAGREQUIRED, FLAGLIMITPARAMNAMES, FLAGAGRFUNCTION,
       ISTIMESTAMPFIELD, ISBUDGET, AVAILABLEINDEREF, ANNOTATION, ALIAS, DEREFNAME)
    VALUES
      (ID_, FIELDKIND_, DESCRIPTIONLEVEL_, ANCESTORREF_, SELECTIONREF_, TABLEREF_, FIELDNAME_, DATATYPE_, SUBDATATYPE_,
       FIELDSIZE_, DISPLAYLABEL_, NOTE_, DEFAULTWIDTH_, EDITMASK_, DISPLAYFORMAT_, EDITFORMAT_, CANTEDIT_, NOVISUALIZE_,
       ENUMSREF_, REQUIRED_, FOREIGNKEY_, ONDELACTION_, PRIMARYKEY_, ISRVERSION_, LIMITPARAMNAMES_,
       FOLLOWORDER_, SORTDIRECTION_, SORTORDER_, AGRFUNCTION_, FLAGFIELDNAME_, FLAGDISPLAYLABEL_, FLAGNOTE_,
       FLAGDEFAULTWIDTH_, FLAGCANTEDIT_, FLAGNOVISUALIZE_, FLAGREQUIRED_, FLAGLIMITPARAMNAMES_, FLAGAGRFUNCTION_,
       ISTIMESTAMPFIELD_, ISBUDGET_, AVAILABLEINDEREF_, ANNOTATION_, ALIAS_, DEREFNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  EVENTCODE_ NUMBER,
  SCRIPTNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONEVENTS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONEVENTS SET
      SELECTIONREF = SELECTIONREF_,
      EVENTCODE = EVENTCODE_,
      SCRIPTNAME = SCRIPTNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONEVENTS
      (ID, SELECTIONREF, EVENTCODE, SCRIPTNAME)
    VALUES
      (ID_, SELECTIONREF_, EVENTCODE_, SCRIPTNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_DELETE(
  ID_ NUMBER
) IS
BEGIN
  UPDATE DOCUMENTFIELDS SET
    FIELDINFOREF = NULL
  WHERE FIELDINFOREF = ID_;
  DELETE FROM FIELDSINFO FI
  WHERE FI.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONSDETAIL SLD
  WHERE SLD.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONEVENTS SE
  WHERE SE.ID = ID_;
END;
/

-- 
CALL FIELDSINFO_DELETE(16873) ;

CALL FIELDSINFO_DELETE(16874) ;

CALL FIELDSINFO_DELETE(16875) ;

CALL FIELDSINFO_DELETE(20555) ;

CALL FIELDSINFO_DELETE(20556) ;

CALL FIELDSINFO_DELETE(20557) ;

CALL FIELDSINFO_DELETE(20558) ;

CALL FIELDSINFO_DELETE(20559) ;

CALL FIELDSINFO_DELETE(20560) ;

CALL FIELDSINFO_DELETE(20562) ;

CALL FIELDSINFO_DELETE(20563) ;

CALL FIELDSINFO_DELETE(20564) ;

CALL FIELDSINFO_DELETE(20565) ;

CALL FIELDSINFO_DELETE(20566) ;

CALL FIELDSINFO_DELETE(20567) ;

CALL FIELDSINFO_DELETE(20568) ;

CALL FIELDSINFO_DELETE(20569) ;

CALL FIELDSINFO_DELETE(20570) ;

CALL FIELDSINFO_DELETE(20571) ;

CALL FIELDSINFO_DELETE(20572) ;

CALL FIELDSINFO_DELETE(20573) ;

CALL FIELDSINFO_DELETE(20574) ;

CALL FIELDSINFO_DELETE(20575) ;

CALL FIELDSINFO_DELETE(20576) ;

CALL FIELDSINFO_DELETE(20577) ;

CALL FIELDSINFO_DELETE(20579) ;

CALL FIELDSINFO_DELETE(20580) ;

CALL FIELDSINFO_DELETE(20581) ;

CALL FIELDSINFO_DELETE(20582) ;

CALL FIELDSINFO_DELETE(20583) ;

CALL FIELDSINFO_DELETE(20584) ;

CALL FIELDSINFO_DELETE(20585) ;

CALL FIELDSINFO_DELETE(20586) ;

CALL FIELDSINFO_DELETE(20587) ;

CALL FIELDSINFO_DELETE(20588) ;

CALL FIELDSINFO_DELETE(20589) ;

CALL FIELDSINFO_DELETE(20590) ;

CALL FIELDSINFO_DELETE(20702) ;

CALL FIELDSINFO_DELETE(20719) ;

CALL FIELDSINFO_DELETE(20721) ;

CALL FIELDSINFO_DELETE(44462) ;

CALL FIELDSINFO_DELETE(44463) ;

CALL FIELDSINFO_DELETE(44464) ;

CALL FIELDSINFO_DELETE(45102) ;

CALL FIELDSINFO_DELETE(45361) ;

CALL FIELDSINFO_DELETE(45362) ;

CALL FIELDSINFO_DELETE(45386) ;

CALL FIELDSINFO_DELETE(45523) ;

CALL FIELDSINFO_DELETE(46346) ;

CALL FIELDSINFO_DELETE(46469) ;

CALL FIELDSINFO_DELETE(46470) ;

CALL FIELDSINFO_DELETE(46471) ;

CALL FIELDSINFO_DELETE(46472) ;

CALL FIELDSINFO_DELETE(46473) ;

CALL FIELDSINFO_DELETE(46474) ;

CALL FIELDSINFO_DELETE(46475) ;

CALL FIELDSINFO_DELETE(46476) ;

CALL FIELDSINFO_DELETE(46477) ;

CALL FIELDSINFO_DELETE(46478) ;

CALL FIELDSINFO_DELETE(46481) ;

CALL FIELDSINFO_DELETE(46688) ;

CALL FIELDSINFO_DELETE(46690) ;

CALL FIELDSINFO_DELETE(46696) ;

CALL FIELDSINFO_DELETE(46702) ;

CALL SELECTIONSDETAIL_DELETE(45369) ;

CALL SELECTIONSDETAIL_DELETE(47102) ;

CALL SELECTIONS_DELETE(20554) ;

CALL SELECTIONS_DELETE(20561) ;

CALL SELECTIONS_DELETE(20578) ;

CALL SELECTIONS_DELETE(46468) ;

CALL SELECTIONS_IMPORT(20428, 1, 'TREASUARYDOCSTATE', '.    ', 0, 0, 'TREASUARYDOCSTATE', 'TREASUARYDOCSTATE', 0, 0, 0, 1, '', 0, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(44587, 1, 'TARGETCLSDETAIL', '  ()', 0, 0, 'TARGETCLSDETAIL', 'TargetClsDetail', 33, 0, 0, 2, '', 1, 1, 3600, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(20868, 1, 'STATE_OPENFIELDS', ',      ', 0, 0, 'STATE_OPENFIELDS', 'St_OF', 93, 0, 0, 2, '', 1, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(21876, 1, 'STATE_JUMPCONTROL', '     ', 0, 0, 'STATE_JUMPCONTROL', 'St_JC', 97, 0, 0, 2, '', 1, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(22727, 1, 'SUPDOCTYPECLS', '  ', 0, 0, 'SUPDOCTYPECLS', 'SupDTCls', 198, 0, 0, 2, '', 0, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(30656, 1, 'SIGNLOG', '.   ', 0, 0, 'SIGNLOG', 'SIGNLOG', 0, 0, 0, 2, '', 1, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(30657, 1, 'SIGNPARAMS', '.   ', 0, 0, 'SIGNPARAMS', 'SIGNPARAMS', 0, 0, 0, 2, '', 1, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(35045, 1, 'SIGNCERTIFICATE', ' ', 0, 0, 'SIGNCERTIFICATE', 'SIGNCERTIFICATE', 0, 0, 0, 2, '', 1, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(35046, 1, 'SIGNDOCUMENTSGROUP', '  ', 0, 0, 'SIGNDOCUMENTSGROUP', 'SIGNDOCUMENTSGROUP', 0, 0, 0, 2, '', 1, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(35047, 1, 'SIGNDOCUMENTSGROUPDETAIL', '  . ', 0, 0, 'SIGNDOCUMENTSGROUPDETAIL', 'SIGNDOCUMENTSGROUPDETAIL', 0, 0, 0, 2, '', 1, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(35357, 1, 'CLSCORRESPONDENTS', '', 0, 0, 'CLSCORRESPONDENTS', 'CLSCORRESPONDENTS', 0, 0, 0, 2, '', 1, 1, 3600, -1, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(43723, 1, 'SUPPLIERS', '  ', 0, 0, 'SUPPLIERS', 'sup', 118, 0, 0, 2, '', 0, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(44230, 1, 'EPBSEXPORTLOGCAPTION', '    ', 0, 0, 'EPBSEXPORTLOGCAPTION', 'EPBSExportLogCaption', 0, 0, 0, 1, '', 0, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(44232, 1, 'EPBSEXPORTLOGDETAIL', '    ', 0, 0, 'EPBSEXPORTLOGDETAIL', 'EPBSExportLogDetail', 0, 0, 0, 1, '', 0, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(45096, 2, '___', 'C   ,   ', 0, 0, '', '', 0, 0, 0, 1, '', 1, 1, 600, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(45358, 2, '_', '', 0, 0, '', '', 0, 0, 0, 2, '', 1, 1, 600, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(45699, 1, 'NATIONALPROJECT', '', 0, 0, 'NATIONALPROJECT', 'NationalProject', 34, 0, 0, 2, '', 1, 1, 1800, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(46331, 1, 'CLSCORR', '   ', 0, 0, 'CLSCORR', 'CLSCORR', 0, 0, 0, 2, '', 1, 1, 3600, -1, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(46343, 1, 'CLSCORRCOLUMNS', '   ', 0, 0, 'CLSCORRCOLUMNS', 'CLSCORRCOLUMNS', 0, 0, 0, 2, '', 1, 1, 3600, -1, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(46482, 1, 'CLSCORRVALUES', '   ', 0, 0, 'CLSCORRVALUES', 'CLSCORRVALUES', 0, 0, 0, 2, '', 1, 1, 3600, -1, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(46677, 1, 'REGPROJECTRESULT', '  ', 0, 0, 'REGPROJECTRESULT', 'RegProjectResult', 35, 0, 0, 2, '', 1, 1, 1800, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(47085, 2, '_', ' ', 0, 0, '', '', 0, 1, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(47443, 1, 'INCOMETARGETFUNDS', '   ', 0, 0, 'INCOMETARGETFUNDS', 'IncomeTargetFunds', 98115, 0, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(47491, 1, 'PAYTARGETFUNDS', '   ', 0, 0, 'PAYTARGETFUNDS', 'PayTargetFunds', 98116, 0, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(47492, 1, 'ANALYTICALPARTITION', '     ', 0, 0, 'ANALYTICALPARTITION', 'AnalyticalPartition', 98117, 0, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(47493, 1, 'PAYMENTCODETYPE', '  ', 0, 0, 'PAYMENTCODETYPE', 'PaymentCodeType', 98113, 0, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

CALL SELECTIONSDETAIL_IMPORT(45101, 45096, 16700, 'Single', 0, 0, 1, '', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(45359, 45358, 35357, 'CLSCORRESPONDENTS', 0, 0, 1, '', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47086, 47085, 46482, 'ClsCV', 0, 0, 1, '', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47087, 47085, 16857, 'Kcsr', 1, 2, 1, 'Kcsr.ID=ClsCV.KCSR', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47088, 47085, 16851, 'Kvsr', 2, 2, 1, 'Kvsr.ID=ClsCV.KVSR', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47089, 47085, 16864, 'Kvr', 3, 2, 1, 'Kvr.ID=ClsCV.KVR', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47090, 47085, 16871, 'Kesr', 4, 2, 1, 'Kesr.ID=ClsCV.KESR', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47091, 47085, 16915, 'SubKesr', 5, 2, 1, 'SubKesr.ID=CLSCV.SUBKESR', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47092, 47085, 21555, 'DirectionCls', 6, 2, 1, 'DirectionCls.ID=ClsCV.DIRECTIONCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47093, 47085, 16964, 'Fact', 7, 2, 1, 'Fact.ID=ClsCV.FACT', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47094, 47085, 27815, 'PayPrCls', 8, 2, 1, 'PayPrCls.ID=ClsCV.PAYPROMISECLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47097, 47085, 27814, 'BudAllocCls', 9, 2, 1, 'BudAllocCls.ID=ClsCV.BUDALLOCATIONCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47098, 47085, 40457, 'KRCS', 10, 2, 1, 'KRCS.ID=ClsCV.CONTRACTCOSTSCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47100, 47085, 38203, 'InvObj', 11, 2, 1, 'InvObj.ID=ClsCV.INVESTOBJECT', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47101, 47085, 16955, 'FinType', 12, 2, 1, 'FinType.ID=ClsCV.FINTYPE', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47103, 47085, 22385, 'TargetCls', 14, 2, 1, 'TargetCls.ID=ClsCV.TARGETCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47104, 47085, 26536, 'SubsidyCls', 15, 2, 1, 'SubsidyCls.ID=ClsCV.SUBSIDYCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47105, 47085, 22773, 'TranferCls', 16, 2, 1, 'TranferCls.ID=ClsCV.TRANSFERTCLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47106, 47085, 20686, 'PDT', 17, 2, 1, 'PDT.ID=ClsCV.PLANDOCTYPE', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47107, 47085, 22983, 'AsigSour', 18, 2, 1, 'AsigSour.ID=ClsCV.ASSIGNMENTSOURCE', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47108, 47085, 16824, 'KD', 19, 2, 1, 'KD.ID=ClsCV.KD', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47109, 47085, 38917, 'AGI', 20, 2, 1, 'AGI.ID=ClsCV.ANALYTICALGROUPIFS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47110, 47085, 38906, 'AGK', 21, 2, 1, 'AGK.ID=ClsCV.ANALYTICALGROUPKD', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47111, 47085, 17043, 'IFS', 22, 2, 1, 'IFS.ID=ClsCV.INNERFINSOURCE', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47112, 47085, 32820, 'Oktmo', 23, 2, 1, 'Oktmo.ID=ClsCV.OKTMO', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47113, 47085, 16973, 'DocBase', 24, 2, 1, 'DocBase.ID=CLSCV.DOCBASE', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47114, 47085, 32786, 'CDE', 25, 2, 1, 'CDE.ID=ClsCV.COMMDIRECTIONEXPENCECLS', 0, '', 0) ;

CALL SELECTIONSDETAIL_IMPORT(47115, 47085, 45699, 'NP', 26, 2, 1, 'NP.ID=ClsCV.NATIONALPROJECT', 0, '', 0) ;

-- BUDGETS_S
CALL FIELDSINFO_IMPORT(44396, 0, 1, null, 16803, null, 'OKTMO', 3, 0, 0, '', '', 15, '', '', '', 0, 0, null, 0, 32820, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KD
CALL FIELDSINFO_IMPORT(16836, 0, 1, null, 16824, null, 'KDVALUE', 1, 0, 20, ' ', '  ', 31, '999.9.99.99.999.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KCSR
CALL FIELDSINFO_IMPORT(45713, 0, 1, null, 16857, null, 'NATIONALPROJECT', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, 45699, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KESR
CALL FIELDSINFO_IMPORT(16872, 0, 1, null, 16871, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16877, 0, 1, null, 16871, null, 'CONTROLCODE', 1, 0, 20, ' ', '', 11, '9.9.99.9.9', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43607, 0, 1, null, 16871, null, 'CODE', 1, 0, 20, '', '', 6, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43608, 0, 1, null, 16871, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KESRSUBCODE
CALL FIELDSINFO_IMPORT(16916, 0, 1, null, 16915, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43610, 0, 1, null, 16915, null, 'CODE', 1, 0, 20, '', '', 6, '>aaa.aa.aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43611, 0, 1, null, 16915, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- FACT
CALL FIELDSINFO_IMPORT(45389, 0, 1, null, 16964, null, 'EXTROOTID', 1, 0, 50, '  ', '', 30, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- DOCBASE
CALL FIELDSINFO_IMPORT(16974, 0, 1, null, 16973, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16982, 0, 1, null, 16973, null, 'DOCUMENTBASENUM', 1, 0, 100, ' ', ' ', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- INNERFINSOURCE
CALL FIELDSINFO_IMPORT(17055, 0, 1, null, 17043, null, 'FINSOURCEVALUE', 1, 0, 20, ' .  .  ', '       ', 31, '999.99.99.99.99.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BANKS
CALL FIELDSINFO_IMPORT(46304, 0, 1, null, 17099, null, 'CBRNAME', 1, 0, 2000, ' -', '', 100, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- FACIALACC_CLS
CALL FIELDSINFO_IMPORT(26618, 0, 1, null, 17129, null, 'ISBU', 3, 0, 0, '/ ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26619, 0, 1, null, 17129, null, 'ISPBS', 3, 0, 0, ' ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26620, 0, 1, null, 17129, null, 'ISPROXY', 3, 0, 0, '   ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26621, 0, 1, null, 17129, null, 'ISRBS', 3, 0, 0, ' ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26622, 0, 1, null, 17129, null, 'ISSEPARATEBU', 3, 0, 0, '  ,    ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27841, 0, 1, null, 17129, null, 'ISOMS', 3, 0, 0, ' ( )', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(30897, 0, 1, null, 17129, null, 'GRANTEEORG_REF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, 16642, 0, 0, 0, '', 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- MEANSTYPE
CALL FIELDSINFO_IMPORT(17319, 0, 1, null, 17311, null, 'ACTIVITYKIND', 1, 0, 1, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(29925, 0, 1, null, 17311, null, 'ACTIVITYTYPE', 1, 0, 1, '', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44584, 0, 1, null, 17311, null, 'MEANSSOURCE', 3, 0, 2, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDGETDATA
CALL FIELDSINFO_IMPORT(17410, 0, 1, null, 17408, null, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 4, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17415, 0, 1, null, 17408, null, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17430, 0, 1, null, 17408, null, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26542, 0, 1, null, 17408, null, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 59, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(25268, 0, 1, null, 17408, null, 'DAYPLAN', 6, 0, 0, ' ', '', 13, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45495, 0, 1, null, 17408, null, 'INVESTOBJECT', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45497, 0, 1, null, 17408, null, 'SENDERRECORDIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45494, 0, 1, null, 17408, null, 'KESRCORR', 3, 0, 0, ' ', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 73, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45498, 0, 1, null, 17408, null, 'SENDERIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45499, 0, 1, null, 17408, null, 'CONTRACTCOSTSCLS', 3, 0, 0, '', '', 11, '9.9.9', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45501, 0, 1, null, 17408, null, 'TOTALSUMMA', 6, 0, 0, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 74, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45502, 0, 1, null, 17408, null, 'SUBSIDYSUMMA', 6, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 59, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45503, 0, 1, null, 17408, null, 'HIGHERBUDCLS', 1, 0, 0, '  ', '  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45504, 0, 1, null, 17408, null, 'FACIALCODEHIGHERGRBS', 1, 0, 0, ' /  ', ' /  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45505, 0, 1, null, 17408, null, 'STOREDCONTENT', 1, 0, 2000, '.  ', '.  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDNOTIFY
CALL FIELDSINFO_IMPORT(17467, 0, 1, null, 17463, null, 'DOCNUMBER', 1, 0, 100, ' -', ' -', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17472, 0, 1, null, 17463, null, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17477, 0, 1, null, 17463, null, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17480, 0, 1, null, 17463, null, 'UPDATERUSER', 1, 0, 30, '  ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17492, 0, 1, null, 17463, null, 'DOCSTATEREF', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 0, 20836, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17496, 0, 1, null, 17463, null, 'BIDNUMBER', 1, 0, 50, ' ', ' ', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17497, 0, 1, null, 17463, null, 'FAXDOCCOUNT', 3, 0, 0, '    ', '    ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17498, 0, 1, null, 17463, null, 'ATYPE', 3, 0, 0, ' ', ' . 0-, 1-.', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17499, 0, 1, null, 17463, null, 'ANUMBER', 1, 0, 50, ' ', ' ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17500, 0, 1, null, 17463, null, 'PLANKIND', 3, 0, 0, '  (, )', '  (, )', 11, '', '', '', 0, 0, null, 1, 22954, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17502, 0, 1, null, 17463, null, 'BA_LBO_FLAG', 3, 0, 0, ' _', '        (0- , Δ, 1- , 2- Δ)', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45496, 0, 1, null, 17463, null, 'SENDERIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(36043, 0, 1, null, 17463, null, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45500, 0, 1, null, 17463, null, 'STOREDCONTENT', 1, 0, 4000, '.  ', '.  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45509, 0, 1, null, 17463, null, 'SENDERRECORDIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45513, 0, 1, null, 17463, null, 'SIGNERS', 1, 0, 1000, '', ' ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45515, 0, 1, null, 17463, null, 'EXTID', 1, 0, 50, 'UID     ,  GUID ', 'UID     ,  GUID ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 53, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45516, 0, 1, null, 17463, null, 'EXTROOTID', 1, 0, 50, ' ', ' ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 54, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45517, 0, 1, null, 17463, null, 'DATABLOCKFLAG', 3, 0, 0, ' ', ' ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45518, 0, 1, null, 17463, null, 'STARTDATE', 11, 0, 0, '  ', '  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45519, 0, 1, null, 17463, null, 'ENDDATE', 11, 0, 0, '  ', '  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- FACIALFINDETAIL
CALL FIELDSINFO_IMPORT(18872, 0, 1, null, 18864, null, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 4, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18876, 0, 1, null, 18864, null, 'NOTE', 1, 0, 1024, ' ()', '   ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18882, 0, 1, null, 18864, null, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18907, 0, 1, null, 18864, null, 'RECORDINDEX2', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18923, 0, 1, null, 18864, null, 'UNIONNOTIFYREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, 21709, 0, 0, 0, '', 59, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18931, 0, 1, null, 18864, null, 'ISBLOCKED', 3, 0, 0, ' ', '     (=1)', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 67, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26623, 0, 1, null, 18864, null, 'DESTEXECINNERNUMBER', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26624, 0, 1, null, 18864, null, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26625, 0, 1, null, 18864, null, 'SOURCEEXECINNERNUMBER', 3, 0, 0, '   ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(26626, 0, 1, null, 18864, null, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27701, 0, 1, null, 18864, null, 'DESTFAORG_TYPE', 3, 0, 0, '\ -', '', 11, '', '', '', 0, 0, null, 1, 22818, 0, 0, 0, '', 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27702, 0, 1, null, 18864, null, 'SOURCEFAORG_TYPE', 3, 0, 0, '\ -', '', 11, '', '', '', 0, 0, null, 1, 22818, 0, 0, 0, '', 81, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(25178, 0, 1, null, 18864, null, 'DESTASSIGNMENTKIND', 3, 0, 0, '  ', ' ', 9, '99.99.99', '', '', 0, 0, null, 1, 22976, 0, 0, 0, '', 73, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(25179, 0, 1, null, 18864, null, 'DESTCLSTYPE', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(25180, 0, 1, null, 18864, null, 'SOURCEASSIGNMENTKIND', 3, 0, 0, '  ', '', 9, '99.99.99', '', '', 0, 0, null, 1, 22976, 0, 0, 0, '', 75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45529, 0, 1, null, 18864, null, 'SOURCEINVESTOBJECT', 3, 0, 0, '  ', '  ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45530, 0, 1, null, 18864, null, 'DESTINVESTOBJECT', 3, 0, 0, '  ', '  ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45531, 0, 1, null, 18864, null, 'SENDERIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45532, 0, 1, null, 18864, null, 'SENDERRECORDIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45533, 0, 1, null, 18864, null, 'DESTCONTRACTCOSTSCLS', 3, 0, 0, ' ', '', 11, '9.9.9', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45534, 0, 1, null, 18864, null, 'STOREDPAYMENTCONTENT', 1, 0, 2000, '.  ', '.  ', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45535, 0, 1, null, 18864, null, 'SOURCECONTRACTCOSTSCLS', 3, 0, 0, ' ', '', 11, '9.9.9', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- FACIALFINCAPTION
CALL FIELDSINFO_IMPORT(18951, 0, 1, null, 18947, null, 'PAYDATE', 6, 0, 0, ' ', ' ', 11, '99/99/9999', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18955, 0, 1, null, 18947, null, 'CREDIT', 6, 0, 0, ' ', '  ', 13, '', ',0.00', '0.00', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18974, 0, 1, null, 18947, null, 'CLIENTBANKNUMBER', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18978, 0, 1, null, 18947, null, 'BNKRECORDID', 3, 0, 0, 'Id    ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18979, 0, 1, null, 18947, null, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18982, 0, 1, null, 18947, null, 'UPDATERUSER', 1, 0, 30, '  ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18983, 0, 1, null, 18947, null, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18993, 0, 1, null, 18947, null, 'BIDNUMBER', 1, 0, 50, ' ', ' ', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18994, 0, 1, null, 18947, null, 'GROUPID', 3, 0, 0, 'Id ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18995, 0, 1, null, 18947, null, 'GROUPSUMMA', 6, 0, 0, '  ', '', 13, '', '', '0.00', 0, 0, null, 1, null, 0, 0, 0, '', 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(18996, 0, 1, null, 18947, null, 'DOCSTATEREF', 3, 0, 0, ' ', ' ', 11, '', '00.00.00', '', 0, 0, null, 0, null, 0, 0, 0, '', 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19001, 0, 1, null, 18947, null, 'REQUESTNUMBER', 1, 0, 50, '  ', '   ', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 54, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19002, 0, 1, null, 18947, null, 'REQUESTDATE', 6, 0, 0, '  ', '   ', 13, '99/99/9999', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19006, 0, 1, null, 18947, null, 'ELDOCREF', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 0, 19295, 0, 0, 0, '', 59, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19007, 0, 1, null, 18947, null, 'BUHOPERATIONCLS', 3, 0, 0, '   ', '   70  ', 11, '', '', '', 0, 0, null, 1, 21634, 0, 0, 0, '', 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19009, 0, 1, null, 18947, null, 'OPERATIONDIRECTION', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19010, 0, 1, null, 18947, null, 'SOURCETYPE', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19011, 0, 1, null, 18947, null, 'DESTTYPE', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(19012, 0, 1, null, 18947, null, 'ISBLOCKED', 3, 0, 0, ' ', '     (=1)', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 65, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(24730, 0, 1, null, 18947, null, 'BIDDATE', 6, 0, 0, ' ', '', 11, '99/99/9999', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 69, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(24731, 0, 1, null, 18947, null, 'CASHIERPERSONALINFO', 1, 0, 512, ' ', ' ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(31656, 0, 1, null, 18947, null, 'CARDREF', 3, 0, 0, '  ', '   ', 11, '', '', '', 0, 0, null, 0, 18937, 0, 0, 0, '', 71, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(31657, 0, 1, null, 18947, null, 'DESTSTOREDPAYMENTPROPS', 1, 0, 2000, '(  )', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(31658, 0, 1, null, 18947, null, 'SOURCESTOREDPAYMENTPROPS', 1, 0, 2000, '(  )', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 73, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(31659, 0, 1, null, 18947, null, 'STOREDPAYMENTNOTE', 1, 0, 4000, ' (  )', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(35367, 0, 1, null, 18947, null, 'UINCODE', 1, 0, 20, '', '  ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 85, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45426, 0, 1, null, 18947, null, 'STOREDPAYMENTCONTENT', 1, 0, 4000, '.  ', '.  ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 89, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45525, 0, 1, null, 18947, null, 'SENDERIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45526, 0, 1, null, 18947, null, 'SENDERRECORDIDKEY', 3, 0, 0, '   ()', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45527, 0, 1, null, 18947, null, 'DOCOSN', 1, 0, 2000, '-', '-', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 90, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BANKEXCH_MERDOC
CALL FIELDSINFO_IMPORT(45948, 0, 1, null, 19295, null, 'CODEPURPOSE', 1, 0, 50, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- EXECUTIONDOCUMENTSCAPTION
CALL FIELDSINFO_IMPORT(43489, 0, 1, null, 19736, null, 'AUTOPAYTYPE', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44569, 0, 1, null, 19736, null, 'AUTOSANCTION', 3, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45406, 0, 1, null, 19736, null, 'MONEYPROMISENUMBER', 1, 0, 50, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- AGREEMENTS
CALL FIELDSINFO_IMPORT(43484, 0, 1, null, 19795, null, 'EXECUTERSTOREDPROPS', 1, 0, 2000, ' ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43490, 0, 1, null, 19795, null, 'AUTOPAYTYPE', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43491, 0, 1, null, 19795, null, 'AUTOPAYMONTH', 3, 0, 0, '    ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 106, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43492, 0, 1, null, 19795, null, 'AUTOPAYDAY', 3, 0, 0, '   / ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- REMOTECLIENT
CALL FIELDSINFO_IMPORT(45536, 0, 1, null, 20054, null, 'OWNCOPIES', 3, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20058, 0, 1, null, 20054, null, 'ORGANIZATION', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16642, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20067, 0, 1, null, 20054, null, 'REMOTECLIENTTYPE', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 0, 20638, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20069, 0, 1, null, 20054, null, 'BLOCKLIST', 1, 0, 255, ' ', '', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20070, 0, 1, null, 20054, null, 'LINKSPEED', 3, 0, 0, '  . ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(24958, 0, 1, null, 20054, null, 'CERTEXPIRATIONDAYS', 3, 0, 0, '      ()', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(24959, 0, 1, null, 20054, null, 'CERTOWNERNAMES', 1, 0, 255, '...  ', '', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27627, 0, 1, null, 20054, null, 'PACKETBLOCKLIST', 1, 0, 255, '  ', '', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27862, 0, 1, null, 20054, null, 'ALLOWEDCOPIES', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27863, 0, 1, null, 20054, null, 'ISEXECUTIONUSED', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(27864, 0, 1, null, 20054, null, 'USEDCOPIES', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(31712, 0, 1, null, 20054, null, 'CERTEXPIRATIONDATE', 6, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45537, 0, 1, null, 20054, null, 'TRANSFERTCOPIES', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- REMOTEREADRIGHT
CALL FIELDSINFO_IMPORT(20205, 0, 1, null, 20201, null, 'CLIENTID', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20206, 0, 1, null, 20201, null, 'FACIALACCCLSUP', 3, 0, 0, '       9', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- PLANDOCTYPE
CALL FIELDSINFO_IMPORT(20687, 0, 1, null, 20686, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46130, 0, 1, null, 20686, null, 'CODE', 3, 0, 0, '', '', 11, '9.99', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46131, 0, 1, null, 20686, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46132, 0, 1, null, 20686, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46133, 0, 1, null, 20686, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46134, 0, 1, null, 20686, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46135, 0, 1, null, 20686, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TENDEROBJECTS
CALL FIELDSINFO_IMPORT(20714, 0, 1, null, 20694, null, 'FACIALACCCLS', 3, 0, 0, ' (. ) ', '', 13, '999.99.999.9', '', '', 0, 0, null, 1, 17129, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- DUALRIGHTS
CALL FIELDSINFO_IMPORT(20879, 0, 1, null, 20877, null, 'USERREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(20881, 0, 1, null, 20877, null, 'RIGHTREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 20756, 1, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDSTRUCTRIGHTS
CALL FIELDSINFO_IMPORT(21485, 0, 1, null, 21480, null, 'KFSR', 3, 0, 0, '', '', 11, '99.99', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21489, 0, 1, null, 21480, null, 'KESR', 1, 0, 20, '', '', 11, '9.9.9', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21490, 0, 1, null, 21480, null, 'SUBKESR', 1, 0, 20, ' ', '', 11, '999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21502, 0, 1, null, 21480, null, 'KESRUP', 1, 0, 20, '', '', 11, '9.9.9', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21503, 0, 1, null, 21480, null, 'SUBKESRUP', 1, 0, 20, '. ', '', 11, '999.99.99', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- ED_OUTPAYDOC
CALL FIELDSINFO_IMPORT(45935, 0, 1, null, 22334, null, 'CODEPURPOSE', 1, 0, 50, '  ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 66, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TARGETCLS
CALL FIELDSINFO_IMPORT(44257, 0, 1, null, 22385, null, 'TRANSFERKVSR', 1, 0, 20, '   ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(22387, 0, 1, null, 22385, null, 'NAME', 1, 0, 2000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(22390, 0, 1, null, 22385, null, 'STRCODE', 1, 0, 50, ' ', '', 20, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44258, 0, 1, null, 22385, null, 'TRANSFERKFSR', 1, 0, 20, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44259, 0, 1, null, 22385, null, 'TRANSFERKCSR', 1, 0, 20, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44260, 0, 1, null, 22385, null, 'TRANSFERKVR', 1, 0, 20, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44615, 0, 1, null, 22385, null, 'CREATERUSER', 1, 0, 30, '()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44616, 0, 1, null, 22385, null, 'UPDATERUSER', 1, 0, 30, '()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44617, 0, 1, null, 22385, null, 'BUDGETREF', 3, 0, 0, '()', '', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44618, 0, 1, null, 22385, null, 'SHORTNAME', 1, 0, 255, ' ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44619, 0, 1, null, 22385, null, 'RECEIVEKDVALUE', 1, 0, 20, '  ', '', 20, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44620, 0, 1, null, 22385, null, 'TRANSFERTKIND', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44621, 0, 1, null, 22385, null, 'INVESTOBJECT', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44622, 0, 1, null, 22385, null, 'TRANSFERBUDGETREF', 3, 0, 0, '()', '', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44623, 0, 1, null, 22385, null, 'LOWERBUDGETKD', 1, 0, 20, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44624, 0, 1, null, 22385, null, 'PARENTTARGETCLS', 3, 0, 0, '  (   )', '  (   )', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44625, 0, 1, null, 22385, null, 'EXPORTINFK', 3, 0, 0, '   ', '', 10, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44626, 0, 1, null, 22385, null, 'OVERCOFINANCING', 3, 0, 0, ' (   )', ' (   )', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44627, 0, 1, null, 22385, null, 'BUDGETLEVEL', 3, 0, 0, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44628, 0, 1, null, 22385, null, 'ISTRANSFERT', 3, 0, 0, ' ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44629, 0, 1, null, 22385, null, 'ISCOFINANCING', 3, 0, 0, '', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- LINKRECORDS
CALL FIELDSINFO_IMPORT(22531, 0, 1, null, 22529, null, 'LINKTYPEREF', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 1, 22428, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(22532, 0, 1, null, 22529, null, 'PARENTID', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 1, 22513, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(22533, 0, 1, null, 22529, null, 'CHILDID', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 1, 22513, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(24916, 0, 1, null, 22529, null, 'ISREJECTED', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TRANSFERTCLS
CALL FIELDSINFO_IMPORT(43561, 0, 1, null, 22773, null, 'FACT', 3, 0, 0, '', '', 9, '', '', '', 0, 0, null, 1, 16964, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- ASSIGNMENTSOURCE
CALL FIELDSINFO_IMPORT(22984, 0, 1, null, 22983, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46136, 0, 1, null, 22983, null, 'CODE', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46137, 0, 1, null, 22983, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDALLOCATIONCLS
CALL FIELDSINFO_IMPORT(43451, 0, 1, null, 27814, null, 'ASSIGNMENTKIND', 3, 0, 10, ' ', '', 10, '', '', '', 0, 0, null, 1, 22976, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- INVESTOBJECT
CALL FIELDSINFO_IMPORT(38204, 0, 1, null, 38203, null, 'ID', 3, 0, 0, '', '', 0, '', '', '', 0, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(38205, 0, 1, null, 38203, null, 'CODE', 1, 0, 50, '', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(38206, 0, 1, null, 38203, null, 'SUBCODE', 1, 0, 50, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(38207, 0, 1, null, 38203, null, 'BUDGETFINSOURCEOBJECTCODE', 1, 0, 50, '   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(38210, 0, 1, null, 38203, null, 'OWNERLEVEL', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44429, 0, 1, null, 38203, null, 'INVESTDIRECTION', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44430, 0, 1, null, 38203, null, 'PROVIDINGPURPOSE', 15, 0, 10000, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44431, 0, 1, null, 38203, null, 'APOWER', 1, 0, 255, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44432, 0, 1, null, 38203, null, 'DEVELOPERNAME', 1, 0, 2000, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44433, 0, 1, null, 38203, null, 'DEVELOPSTARTDATE', 3, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44434, 0, 1, null, 38203, null, 'DEVELOPENDDATE', 3, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44435, 0, 1, null, 38203, null, 'DEVELOPCOST', 6, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44436, 0, 1, null, 38203, null, 'TOTALCOST', 6, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44437, 0, 1, null, 38203, null, 'COORDINATES', 1, 0, 255, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44438, 0, 1, null, 38203, null, 'REGISTRYAGREEMENTNUMBER', 1, 0, 20, '   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46697, 0, 1, null, 38203, null, 'POWERUNITCODE', 1, 0, 255, '   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46698, 0, 1, null, 38203, null, 'DEVELOPERCODE', 1, 0, 8, '    ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46699, 0, 1, null, 38203, null, 'CUSTOMERCODE', 1, 0, 8, '    ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46700, 0, 1, null, 38203, null, 'OWNINGORGCODE', 1, 0, 8, ' -   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46701, 0, 1, null, 38203, null, 'BUDGETCODE', 1, 0, 255, '   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46703, 0, 1, null, 38203, null, 'ESTIMATEDOCEXIST', 3, 0, 0, ' - ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46704, 0, 1, null, 38203, null, 'COSTUNITCODE', 1, 0, 255, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 53, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46705, 0, 1, null, 38203, null, 'COFINANCING', 3, 0, 0, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 54, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46706, 0, 1, null, 38203, null, 'STOREDCONTENT', 1, 0, 2000, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- ANALYTICALGROUPKD
CALL FIELDSINFO_IMPORT(38908, 0, 1, null, 38906, null, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- ANALYTICALGROUPIFS
CALL FIELDSINFO_IMPORT(38919, 0, 1, null, 38917, null, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- AUTOSANCTIONDATA
CALL FIELDSINFO_IMPORT(44405, 0, 1, null, 39170, null, 'FINTYPE', 3, 0, 0, ' ', '  ', 5, '9.99', '', '', 0, 0, null, 0, 16955, 0, 0, 0, '', 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44406, 0, 1, null, 39170, null, 'DIRECTIONCLS', 3, 0, 0, '', '   ', 4, '999', '000', '000', 0, 0, null, 0, 21555, 0, 0, 0, '', 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44407, 0, 1, null, 39170, null, 'FACT', 3, 0, 0, '', ' ', 9, '99.99.99', '', '', 0, 0, null, 0, 16964, 0, 0, 0, '', 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44408, 0, 1, null, 39170, null, 'REGIONCLS', 3, 0, 0, '', ' ', 9, '99.99.99', '', '', 0, 0, null, 0, 16688, 0, 0, 0, '', 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44409, 0, 1, null, 39170, null, 'SUBKESR', 3, 0, 0, '', '   ', 10, '9.9.9', '', '', 0, 0, null, 0, 16915, 0, 0, 0, '', 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44410, 0, 1, null, 39170, null, 'SUBSIDYCLS', 3, 0, 0, '  ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44411, 0, 1, null, 39170, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44412, 0, 1, null, 39170, null, 'TRANSFERTCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22773, 0, 0, 0, '', 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44422, 0, 1, null, 39170, null, 'CONTRACTCOSTSCLS', 3, 0, 0, '', '', 9, '', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44423, 0, 1, null, 39170, null, 'INVESTOBJECT', 3, 0, 0, '', '', 0, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44425, 0, 1, null, 39170, null, 'STOREDCONTENT', 1, 0, 0, '.  ', '', 4000, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44450, 0, 1, null, 39170, null, 'DOCTYPECLS', 3, 0, 0, '  ()', '', 10, '', '', '', 0, 0, null, 0, 16814, 0, 0, 0, '', 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TARGETCLSDETAIL
CALL FIELDSINFO_IMPORT(44588, 0, 1, null, 44587, null, 'TRANSFERKCSR', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, 16857, 0, 0, 0, '', 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44602, 0, 1, null, 44587, null, 'REGIONCLS', 3, 0, 0, ' ', ' ', 9, '99.99.99', '', '', 0, 0, null, 1, 16688, 0, 0, 0, '', 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44590, 0, 1, null, 44587, null, 'KESR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44591, 0, 1, null, 44587, null, 'TRANSFERKFSR', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, 16844, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44592, 0, 1, null, 44587, null, 'TRANSFERKVR', 3, 0, 0, '  ', '', 11, '', '', '', 0, 0, null, 1, 16864, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44593, 0, 1, null, 44587, null, 'TRANSFERKVSR', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 1, 16851, 0, 0, 0, '', 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44594, 0, 1, null, 44587, null, 'TARGETCLS', 3, 0, 0, '     ', '     ', 11, '', '', '', 2, 0, null, 1, 22385, 1, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44595, 0, 1, null, 44587, null, 'MEANSTYPE', 3, 0, 0, ' ', '  ', 9, '99.99.99', '', '', 0, 0, null, 1, 17311, 0, 0, 0, '', 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44596, 0, 1, null, 44587, null, 'INVESTOBJECT', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44597, 0, 1, null, 44587, null, 'FACT', 3, 0, 0, '', ' ', 9, '99.99.99', '', '', 0, 0, null, 1, 16964, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44598, 0, 1, null, 44587, null, 'FINTYPE', 3, 0, 0, ' ', '  ', 5, '9.99', '', '', 0, 0, null, 1, 16955, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44599, 0, 1, null, 44587, null, 'SUBKESR', 3, 0, 0, '', '', 10, '9.9.9', '', '', 0, 0, null, 1, 16915, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44600, 0, 1, null, 44587, null, 'OKTMO', 3, 0, 0, '', '', 15, '', '', '', 0, 0, null, 0, 32820, 0, 0, 0, '', 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44603, 0, 1, null, 44587, null, 'ASSIGNMENTKIND', 3, 0, 0, ' ', ' ', 9, '99.99.99', '', '', 0, 0, null, 1, 22976, 0, 0, 0, '', 73, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44604, 0, 1, null, 44587, null, 'BUDALLOCATIONCLS', 3, 0, 0, '  ', '  ', 9, '9999.999', '', '', 0, 0, null, 0, 27814, 0, 0, 0, '', 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44605, 0, 1, null, 44587, null, 'DIRECTIONCLS', 3, 0, 0, '', '   ', 4, '999', '', '', 0, 0, null, 1, 21555, 0, 0, 0, '', 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44606, 0, 1, null, 44587, null, 'PAYPROMISECLS', 3, 0, 0, '  ', '  ', 13, '999.999.99.9', '', '', 0, 0, null, 0, 27815, 0, 0, 0, '', 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44607, 0, 1, null, 44587, null, 'SUBSIDYCLS', 3, 0, 0, ' ', ' ', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44608, 0, 1, null, 44587, null, 'FUNDSSOURCE', 3, 0, 0, ' ', '  ', 11, '999.999.99', '', '', 0, 0, null, 1, 22632, 0, 0, 0, '', 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44609, 0, 1, null, 44587, null, 'CONTRACTCOSTSCLS', 3, 0, 0, '', '', 11, '9.9.9', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44610, 0, 1, null, 44587, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44611, 0, 1, null, 44587, null, 'CREATERUSER', 1, 0, 30, '()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44612, 0, 1, null, 44587, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44613, 0, 1, null, 44587, null, 'UPDATERUSER', 1, 0, 30, '()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44614, 0, 1, null, 44587, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44745, 0, 1, null, 44587, null, 'STARTDATE', 11, 0, 0, '   ', '   ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44746, 0, 1, null, 44587, null, 'DELETEDATE', 11, 0, 0, ' ', ' ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44747, 0, 1, null, 44587, null, 'EXTID', 1, 0, 50, '', '', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44748, 0, 1, null, 44587, null, 'EXTOWNER', 1, 0, 50, '  ', '  ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44749, 0, 1, null, 44587, null, 'EXTSYNCDATE', 11, 0, 0, ',  ,  ', ',  ,  ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44750, 0, 1, null, 44587, null, 'EXTROOTID', 1, 0, 50, ' ', ' ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44751, 0, 1, null, 44587, null, 'EXTVERSION', 3, 0, 0, '   ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44752, 0, 1, null, 44587, null, 'EXTVERSIONDATE', 11, 0, 0, '   ', '   ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- NATIONALPROJECT
CALL FIELDSINFO_IMPORT(45700, 0, 1, null, 45699, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45701, 0, 1, null, 45699, null, 'NAME', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45702, 0, 1, null, 45699, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45703, 0, 1, null, 45699, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45704, 0, 1, null, 45699, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45705, 0, 1, null, 45699, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45706, 0, 1, null, 45699, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45707, 0, 1, null, 45699, null, 'CODE', 1, 0, 2, '', '', 10, '>aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45708, 0, 1, null, 45699, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45709, 0, 1, null, 45699, null, 'SHORTNAME', 1, 0, 1024, ' ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45710, 0, 1, null, 45699, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45711, 0, 1, null, 45699, null, 'NAMEMAINEVENT', 1, 0, 1024, '     ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(45712, 0, 1, null, 45699, null, 'PARENTPROJECT', 3, 0, 0, '     ', '', 11, '', '', '', 0, 0, null, 0, 45699, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CLSCORR
CALL FIELDSINFO_IMPORT(46332, 0, 1, null, 46331, null, 'ID', 3, 0, 0, ' ', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46334, 0, 1, null, 46331, null, 'CODE', 1, 0, 20, '   ', '', 30, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46333, 0, 1, null, 46331, null, 'NAME', 1, 0, 255, '  ', '', 30, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46335, 0, 1, null, 46331, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46336, 0, 1, null, 46331, null, 'STARTDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46337, 0, 1, null, 46331, null, 'DELETEDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46339, 0, 1, null, 46331, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46340, 0, 1, null, 46331, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46338, 0, 1, null, 46331, null, 'NOTE', 1, 0, 255, '', '', 30, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46341, 0, 1, null, 46331, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46342, 0, 1, null, 46331, null, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CLSCORRCOLUMNS
CALL FIELDSINFO_IMPORT(46344, 0, 1, null, 46343, null, 'ID', 3, 0, 0, ' ', '   ', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46345, 0, 1, null, 46343, null, 'RECORDINDEX', 3, 0, 0, '  ', '', 11, '', '', '', 2, 0, null, 1, 46331, 1, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46348, 0, 1, null, 46343, null, 'CLSTYPE', 3, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46347, 0, 1, null, 46343, null, 'CLSNAME', 1, 0, 1024, ' ', '', 30, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46349, 0, 1, null, 46343, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46350, 0, 1, null, 46343, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46351, 0, 1, null, 46343, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46352, 0, 1, null, 46343, null, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CLSCORRVALUES
CALL FIELDSINFO_IMPORT(46483, 0, 1, null, 46482, null, 'ID', 3, 0, 0, ' ', '   ', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46484, 0, 1, null, 46482, null, 'RECORDINDEX', 3, 0, 0, ' ', '  ', 11, '', '', '', 2, 0, null, 1, 46331, 1, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46485, 0, 1, null, 46482, null, 'KCSR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16857, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46486, 0, 1, null, 46482, null, 'KVSR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16851, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46487, 0, 1, null, 46482, null, 'KFSR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16844, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46488, 0, 1, null, 46482, null, 'KVR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16864, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46489, 0, 1, null, 46482, null, 'KESR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16871, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46490, 0, 1, null, 46482, null, 'SUBKESR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16915, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46491, 0, 1, null, 46482, null, 'DIRECTIONCLS', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 21555, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46492, 0, 1, null, 46482, null, 'VARIANT', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 23059, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46493, 0, 1, null, 46482, null, 'FACT', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16964, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46494, 0, 1, null, 46482, null, 'PAYPROMISECLS', 3, 0, 0, '  ', '    ', 11, '', '', '', 0, 0, null, 0, 27815, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46495, 0, 1, null, 46482, null, 'BUDALLOCATIONCLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 27814, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46496, 0, 1, null, 46482, null, 'CONTRACTCOSTSCLS', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 40457, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46497, 0, 1, null, 46482, null, 'INVESTOBJECT', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 38203, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46498, 0, 1, null, 46482, null, 'FINTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16955, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46499, 0, 1, null, 46482, null, 'MEANSTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 17311, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46500, 0, 1, null, 46482, null, 'TARGETCLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46501, 0, 1, null, 46482, null, 'REGIONCLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16688, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46502, 0, 1, null, 46482, null, 'SUBSIDYCLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46503, 0, 1, null, 46482, null, 'TRANSFERTCLS', 3, 0, 0, '  ', '    ', 11, '', '', '', 0, 0, null, 0, 22773, 0, 0, 0, '', 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46504, 0, 1, null, 46482, null, 'PLANDOCTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 20686, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46505, 0, 1, null, 46482, null, 'ASSIGNMENTSOURCE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 22983, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46506, 0, 1, null, 46482, null, 'ASSIGNMENTKIND', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 22976, 0, 0, 0, '', 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46507, 0, 1, null, 46482, null, 'KD', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16824, 0, 0, 0, '', 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46508, 0, 1, null, 46482, null, 'ANALYTICALGROUPIFS', 3, 0, 0, '', '      ', 11, '', '', '', 0, 0, null, 0, 38917, 0, 0, 0, '', 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46509, 0, 1, null, 46482, null, 'ANALYTICALGROUPKD', 3, 0, 0, '', '   ', 11, '', '', '', 0, 0, null, 0, 38906, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46510, 0, 1, null, 46482, null, 'PROGRAMCODE', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 21560, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46511, 0, 1, null, 46482, null, 'INNERFINSOURCE', 3, 0, 0, '   ', '    ', 11, '', '', '', 0, 0, null, 0, 17043, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46512, 0, 1, null, 46482, null, 'REESTRTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 19705, 0, 0, 0, '', 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46513, 0, 1, null, 46482, null, 'OKTMO', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 32820, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46514, 0, 1, null, 46482, null, 'DOCBASE', 3, 0, 0, '  ', '  -', 11, '', '', '', 0, 0, null, 0, 16973, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46515, 0, 1, null, 46482, null, 'FUNDSSOURCE', 3, 0, 0, ' ', '  ', 11, '', '', '', 0, 0, null, 0, 22632, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46516, 0, 1, null, 46482, null, 'FINSOURCE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16983, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46517, 0, 1, null, 46482, null, 'DOCTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16814, 0, 0, 0, '', 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46518, 0, 1, null, 46482, null, 'COMMDIRECTIONEXPENCECLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46519, 0, 1, null, 46482, null, 'PAYDESTINATION', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46520, 0, 1, null, 46482, null, 'FACIALACC_CLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 17129, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46521, 0, 1, null, 46482, null, 'NATIONALPROJECT', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 45699, 0, 0, 0, '', 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46522, 0, 1, null, 46482, null, 'BUDGETREF', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46523, 0, 1, null, 46482, null, 'STARTDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46524, 0, 1, null, 46482, null, 'DELETEDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46525, 0, 1, null, 46482, null, 'NOTE', 1, 0, 255, '', '', 30, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46526, 0, 1, null, 46482, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46527, 0, 1, null, 46482, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46528, 0, 1, null, 46482, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46529, 0, 1, null, 46482, null, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- REGPROJECTRESULT
CALL FIELDSINFO_IMPORT(46679, 0, 1, null, 46677, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46680, 0, 1, null, 46677, null, 'NAME', 1, 0, 2000, '', '', 60, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46681, 0, 1, null, 46677, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46682, 0, 1, null, 46677, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46683, 0, 1, null, 46677, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46684, 0, 1, null, 46677, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46685, 0, 1, null, 46677, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46686, 0, 1, null, 46677, null, 'CODE', 1, 0, 7, '', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46687, 0, 1, null, 46677, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46689, 0, 1, null, 46677, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46691, 0, 1, null, 46677, null, 'NATIONALPROJECT', 3, 0, 0, '. ', '', 11, '', '', '', 0, 0, null, 0, 45699, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46692, 0, 1, null, 46677, null, 'RESULTTYPE', 3, 0, 0, ' ', '', 30, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(46693, 0, 1, null, 46677, null, 'RESULTKIND', 3, 0, 0, ' ', '', 30, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- INCOMETARGETFUNDS
CALL FIELDSINFO_IMPORT(47444, 0, 1, null, 47443, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47445, 0, 1, null, 47443, null, 'NAME', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47446, 0, 1, null, 47443, null, 'CODE', 1, 0, 50, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47447, 0, 1, null, 47443, null, 'BUDGETREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47448, 0, 1, null, 47443, null, 'STARTDATE', 11, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47449, 0, 1, null, 47443, null, 'DELETEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47450, 0, 1, null, 47443, null, 'NOTE', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47451, 0, 1, null, 47443, null, 'EXTID', 1, 0, 50, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47452, 0, 1, null, 47443, null, 'EXTROOTID', 1, 0, 50, '  ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47453, 0, 1, null, 47443, null, 'EXTOWNER', 1, 0, 50, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47454, 0, 1, null, 47443, null, 'EXTSYNCDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47455, 0, 1, null, 47443, null, 'EXTVERSION', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47456, 0, 1, null, 47443, null, 'EXTVERSIONDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47457, 0, 1, null, 47443, null, 'CREATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47458, 0, 1, null, 47443, null, 'CREATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47459, 0, 1, null, 47443, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47460, 0, 1, null, 47443, null, 'UPDATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- PAYTARGETFUNDS
CALL FIELDSINFO_IMPORT(47494, 0, 1, null, 47491, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47495, 0, 1, null, 47491, null, 'NAME', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47496, 0, 1, null, 47491, null, 'CODE', 1, 0, 50, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47497, 0, 1, null, 47491, null, 'BUDGETREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47498, 0, 1, null, 47491, null, 'STARTDATE', 11, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47499, 0, 1, null, 47491, null, 'DELETEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47500, 0, 1, null, 47491, null, 'NOTE', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47501, 0, 1, null, 47491, null, 'EXTID', 1, 0, 50, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47502, 0, 1, null, 47491, null, 'EXTROOTID', 1, 0, 50, '  ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47503, 0, 1, null, 47491, null, 'EXTOWNER', 1, 0, 50, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47504, 0, 1, null, 47491, null, 'EXTSYNCDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47505, 0, 1, null, 47491, null, 'EXTVERSION', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47506, 0, 1, null, 47491, null, 'EXTVERSIONDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47507, 0, 1, null, 47491, null, 'CREATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47508, 0, 1, null, 47491, null, 'CREATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47509, 0, 1, null, 47491, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47510, 0, 1, null, 47491, null, 'UPDATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- ANALYTICALPARTITION
CALL FIELDSINFO_IMPORT(47511, 0, 1, null, 47492, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47512, 0, 1, null, 47492, null, 'NAME', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47513, 0, 1, null, 47492, null, 'CODE', 1, 0, 50, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47514, 0, 1, null, 47492, null, 'BUDGETREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47515, 0, 1, null, 47492, null, 'STARTDATE', 11, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47516, 0, 1, null, 47492, null, 'DELETEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47517, 0, 1, null, 47492, null, 'NOTE', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47518, 0, 1, null, 47492, null, 'EXTID', 1, 0, 50, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47519, 0, 1, null, 47492, null, 'EXTROOTID', 1, 0, 50, '  ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47520, 0, 1, null, 47492, null, 'EXTOWNER', 1, 0, 50, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47521, 0, 1, null, 47492, null, 'EXTSYNCDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47522, 0, 1, null, 47492, null, 'EXTVERSION', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47523, 0, 1, null, 47492, null, 'EXTVERSIONDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47524, 0, 1, null, 47492, null, 'CREATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47525, 0, 1, null, 47492, null, 'CREATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47526, 0, 1, null, 47492, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47527, 0, 1, null, 47492, null, 'UPDATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47545, 0, 1, null, 47492, null, 'FACIALACC_CLS', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47546, 0, 1, null, 47492, null, 'ROOTDOC', 3, 0, 0, '-', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- PAYMENTCODETYPE
CALL FIELDSINFO_IMPORT(47528, 0, 1, null, 47493, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47529, 0, 1, null, 47493, null, 'NAME', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47530, 0, 1, null, 47493, null, 'CODE', 1, 0, 50, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47531, 0, 1, null, 47493, null, 'BUDGETREF', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47532, 0, 1, null, 47493, null, 'STARTDATE', 11, 0, 0, '   ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47533, 0, 1, null, 47493, null, 'DELETEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47534, 0, 1, null, 47493, null, 'NOTE', 1, 0, 1000, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47535, 0, 1, null, 47493, null, 'EXTID', 1, 0, 50, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47536, 0, 1, null, 47493, null, 'EXTROOTID', 1, 0, 50, '  ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47537, 0, 1, null, 47493, null, 'EXTOWNER', 1, 0, 50, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47538, 0, 1, null, 47493, null, 'EXTSYNCDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47539, 0, 1, null, 47493, null, 'EXTVERSION', 3, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47540, 0, 1, null, 47493, null, 'EXTVERSIONDATE', 11, 0, 0, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47541, 0, 1, null, 47493, null, 'CREATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47542, 0, 1, null, 47493, null, 'CREATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47543, 0, 1, null, 47493, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(47544, 0, 1, null, 47493, null, 'UPDATERUSER', 1, 0, 30, '', '', 11, '', '', '', 1, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CLS_302
CALL FIELDSINFO_IMPORT(32743, 0, 2, 18979, 32867, 32868, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(32870, 0, 2, 18983, 32867, 32868, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(32886, 0, 2, 26626, 32867, 32869, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(45427, 0, 2, 45426, 32867, 32868, 'STOREDPAYMENTCONTENT', 1, 0, 4000, '.  ', '.  ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'STOREDPAYMENTCONTENT', '') ;

-- CLS_304
CALL FIELDSINFO_IMPORT(34404, 0, 2, 18979, 34400, 34401, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34405, 0, 2, 18983, 34400, 34401, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34420, 0, 2, 26626, 34400, 34402, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_305
CALL FIELDSINFO_IMPORT(34428, 0, 2, 18983, 34424, 34426, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34444, 0, 2, 26624, 34424, 34427, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34447, 0, 2, 18979, 34424, 34426, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(45428, 0, 2, 45426, 34424, 34426, 'STOREDPAYMENTCONTENT', 1, 0, 4000, '.  ', '.  ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'STOREDPAYMENTCONTENT', '') ;

-- CLS_303
CALL FIELDSINFO_IMPORT(34452, 0, 2, 18979, 34448, 34450, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34467, 0, 2, 26624, 34448, 34451, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34469, 0, 2, 18983, 34448, 34450, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

-- CLS_306
CALL FIELDSINFO_IMPORT(34475, 0, 2, 18983, 34471, 34473, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34476, 0, 2, 18979, 34471, 34473, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34492, 0, 2, 26624, 34471, 34474, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_312
CALL FIELDSINFO_IMPORT(34498, 0, 2, 18983, 34494, 34496, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34499, 0, 2, 18979, 34494, 34496, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34515, 0, 2, 26624, 34494, 34497, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_311
CALL FIELDSINFO_IMPORT(34521, 0, 2, 18983, 34517, 34519, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34522, 0, 2, 18979, 34517, 34519, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34537, 0, 2, 26626, 34517, 34520, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_314
CALL FIELDSINFO_IMPORT(34543, 0, 2, 18983, 34539, 34541, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34544, 0, 2, 18979, 34539, 34541, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34560, 0, 2, 26626, 34539, 34542, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_315
CALL FIELDSINFO_IMPORT(34566, 0, 2, 18983, 34562, 34564, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34567, 0, 2, 18979, 34562, 34564, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34582, 0, 2, 26624, 34562, 34565, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_322
CALL FIELDSINFO_IMPORT(34592, 0, 2, 18983, 34588, 34590, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34593, 0, 2, 18979, 34588, 34590, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34608, 0, 2, 26626, 34588, 34591, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(45429, 0, 2, 45426, 34588, 34590, 'STOREDPAYMENTCONTENT', 1, 0, 4000, '.  ', '.  ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'STOREDPAYMENTCONTENT', '') ;

-- CLS_323
CALL FIELDSINFO_IMPORT(34614, 0, 2, 18983, 34610, 34612, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34615, 0, 2, 18979, 34610, 34612, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(34619, 0, 2, 19007, 34610, 34612, 'BUHOPERATIONCLS', 3, 0, 0, '   ', '   70  ', 11, '', '', '', 0, 0, null, 1, 21634, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUHOPERATIONCLS', '') ;

-- CLS_201
CALL FIELDSINFO_IMPORT(34638, 0, 2, 17415, 34631, 34633, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34643, 0, 2, 26542, 34631, 34633, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34645, 0, 2, 17472, 34631, 34632, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34646, 0, 2, 17477, 34631, 34632, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36048, 0, 2, 36043, 34631, 34632, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_202
CALL FIELDSINFO_IMPORT(34670, 0, 2, 17415, 34650, 34653, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34675, 0, 2, 26542, 34650, 34653, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34677, 0, 2, 17472, 34650, 34652, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34678, 0, 2, 17477, 34650, 34652, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36049, 0, 2, 36043, 34650, 34652, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_203
CALL FIELDSINFO_IMPORT(34727, 0, 2, 17415, 34718, 34721, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34732, 0, 2, 26542, 34718, 34721, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34734, 0, 2, 17472, 34718, 34720, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34735, 0, 2, 17477, 34718, 34720, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36051, 0, 2, 36043, 34718, 34720, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_204
CALL FIELDSINFO_IMPORT(34748, 0, 2, 17415, 34738, 34741, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34753, 0, 2, 26542, 34738, 34741, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34755, 0, 2, 17472, 34738, 34740, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34756, 0, 2, 17477, 34738, 34740, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36053, 0, 2, 36043, 34738, 34740, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_205
CALL FIELDSINFO_IMPORT(34768, 0, 2, 17415, 34759, 34762, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34774, 0, 2, 17472, 34759, 34761, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34775, 0, 2, 17477, 34759, 34761, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36055, 0, 2, 36043, 34759, 34761, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 22, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

CALL FIELDSINFO_IMPORT(38648, 0, 2, 26542, 34759, 34762, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_206
CALL FIELDSINFO_IMPORT(34788, 0, 2, 17415, 34779, 34782, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34793, 0, 2, 26542, 34779, 34782, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34795, 0, 2, 17472, 34779, 34781, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34796, 0, 2, 17477, 34779, 34781, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36057, 0, 2, 36043, 34779, 34781, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_207
CALL FIELDSINFO_IMPORT(34809, 0, 2, 17415, 34799, 34802, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34814, 0, 2, 26542, 34799, 34802, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34816, 0, 2, 17472, 34799, 34801, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34817, 0, 2, 17477, 34799, 34801, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36059, 0, 2, 36043, 34799, 34801, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_208
CALL FIELDSINFO_IMPORT(34829, 0, 2, 17415, 34820, 34823, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(34834, 0, 2, 26542, 34820, 34823, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(34836, 0, 2, 17472, 34820, 34822, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(34837, 0, 2, 17477, 34820, 34822, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(36061, 0, 2, 36043, 34820, 34822, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_210
CALL FIELDSINFO_IMPORT(37758, 0, 2, 17415, 37748, 37752, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(37763, 0, 2, 26542, 37748, 37752, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(37764, 0, 2, 17472, 37748, 37751, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(37765, 0, 2, 17477, 37748, 37751, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(37773, 0, 2, 36043, 37748, 37751, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

-- CLS_308
CALL FIELDSINFO_IMPORT(38713, 0, 2, 18979, 38701, 38710, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(38714, 0, 2, 18983, 38701, 38710, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(38722, 0, 2, 26626, 38701, 38711, 'SOURCESUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SOURCESUBSIDYCLS', '') ;

-- CLS_324
CALL FIELDSINFO_IMPORT(38769, 0, 2, 18983, 38766, 38767, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(38770, 0, 2, 19007, 38766, 38767, 'BUHOPERATIONCLS', 3, 0, 0, '   ', '   70  ', 11, '', '', '', 0, 0, null, 1, 21634, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUHOPERATIONCLS', '') ;

CALL FIELDSINFO_IMPORT(38771, 0, 2, 18979, 38766, 38767, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(38788, 0, 2, 26624, 38766, 38768, 'DESTSUBSIDYCLS', 3, 0, 0, '   ()', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(45228, 0, 2, 18901, 38766, 34591, 'DESTFINSOURCE', 3, 0, 0, ' ', ' ', 4, '999', '', '', 0, 0, null, 1, 16983, 0, 0, 0, '', 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'DESTFINSOURCE', '') ;

-- CLS_209
CALL FIELDSINFO_IMPORT(38795, 0, 2, 17472, 38791, 38792, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(38797, 0, 2, 17477, 38791, 38792, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(38799, 0, 2, 36043, 38791, 38792, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

CALL FIELDSINFO_IMPORT(38806, 0, 2, 17415, 38791, 38794, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(38814, 0, 2, 26542, 38791, 38794, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- CLS_212
CALL FIELDSINFO_IMPORT(38843, 0, 2, 26542, 38818, 38822, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(38823, 0, 2, 17472, 38818, 34632, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(38825, 0, 2, 17477, 38818, 34632, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(38827, 0, 2, 36043, 38818, 34632, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

CALL FIELDSINFO_IMPORT(38835, 0, 2, 17415, 38818, 34633, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

-- CLS_211
CALL FIELDSINFO_IMPORT(38849, 0, 2, 17472, 38846, 34632, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(38851, 0, 2, 17477, 38846, 34632, 'CREATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(38853, 0, 2, 36043, 38846, 34632, 'DOCCHANGEDATE', 11, 0, 0, '   ', ' ,  ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 24, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, '', 'DOCCHANGEDATE', '') ;

CALL FIELDSINFO_IMPORT(38861, 0, 2, 17415, 38846, 34633, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(38869, 0, 2, 26542, 38846, 38848, 'SUBSIDYCLS', 3, 0, 0, ' ', '', 12, '', '', '', 0, 0, null, 0, 26536, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

-- ___
CALL FIELDSINFO_IMPORT(45097, 0, 2, 16701, 45096, 45101, 'ID', 1, 0, 20, '', '', 20, '', '', '', 1, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'KCSR', 'KCSR') ;

CALL FIELDSINFO_IMPORT(45098, 1, 2, null, 45096, null, 'KVR', 1, 0, 20, '', '', 20, '', '', '', 1, 0, null, 0, null, 0, 1, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'KVR', 'KVR') ;

CALL FIELDSINFO_IMPORT(45099, 1, 2, null, 45096, null, 'PAYPROMISECLS', 1, 0, 20, '', '', 20, '', '', '', 1, 0, null, 0, null, 0, 1, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 'PAYPROMISECLS', 'PayPromiseCls') ;

-- _
CALL FIELDSINFO_IMPORT(45372, 0, 2, 35361, 45358, 45359, 'ID', 3, 0, 0, ' ', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ID', '') ;

CALL FIELDSINFO_IMPORT(45374, 0, 2, 35359, 45358, 45359, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CREATEDATE', '') ;

CALL FIELDSINFO_IMPORT(45376, 0, 2, 35360, 45358, 45359, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CREATERUSER', '') ;

CALL FIELDSINFO_IMPORT(45377, 0, 2, 35362, 45358, 45359, 'KESR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 4, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(45378, 0, 2, 35363, 45358, 45359, 'KVR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16864, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 4, '', 'KVR', '') ;

CALL FIELDSINFO_IMPORT(45379, 0, 2, 35364, 45358, 45359, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', 'UPDATEDATE', '') ;

CALL FIELDSINFO_IMPORT(45380, 0, 2, 35365, 45358, 45359, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'UPDATERUSER', '') ;

CALL FIELDSINFO_IMPORT(45381, 0, 2, 39250, 45358, 45359, 'KFSR', 3, 0, 0, '', '', 0, '', '', '', 0, 0, null, 1, 16844, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KFSR', '') ;

CALL FIELDSINFO_IMPORT(45382, 0, 2, 39251, 45358, 45359, 'CORRTYPE', 3, 0, 0, ' ', '', 0, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CORRTYPE', '') ;

CALL FIELDSINFO_IMPORT(45383, 0, 2, 39252, 45358, 45359, 'CORRBEL', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CORRBEL', '') ;

CALL FIELDSINFO_IMPORT(45384, 1, 2, null, 45358, null, 'KVRCODE', 1, 0, 3, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KVRCODE', '') ;

CALL FIELDSINFO_IMPORT(45385, 1, 2, null, 45358, null, 'KESRCODE', 1, 0, 3, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESRCODE', '') ;

-- _
CALL FIELDSINFO_IMPORT(47117, 0, 2, 46483, 47085, 47086, 'ID', 3, 0, 0, ' ', '   ', 11, '', '', '', 2, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ID', '') ;

CALL FIELDSINFO_IMPORT(47118, 0, 2, 46484, 47085, 47086, 'RECORDINDEX', 3, 0, 0, ' ', '  ', 11, '', '', '', 2, 0, null, 1, 46331, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'RECORDINDEX', '') ;

CALL FIELDSINFO_IMPORT(47119, 0, 2, 25462, 47085, 47087, 'CODE', 1, 0, 20, '', '', 10, '>aa.a.aaaa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KCSR', '') ;

CALL FIELDSINFO_IMPORT(47120, 0, 2, 25472, 47085, 47088, 'CODE', 3, 0, 0, '', '', 4, '999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KVSR', '') ;

CALL FIELDSINFO_IMPORT(47121, 0, 2, 46487, 47085, 47086, 'KFSR', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 16844, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KFSR', '') ;

CALL FIELDSINFO_IMPORT(47122, 0, 2, 25467, 47085, 47089, 'CODE', 1, 0, 20, '', '', 6, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KVR', '') ;

CALL FIELDSINFO_IMPORT(47123, 0, 2, 43607, 47085, 47090, 'CODE', 1, 0, 20, '', '', 6, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(47124, 0, 2, 43610, 47085, 47091, 'CODE', 1, 0, 20, '', '', 6, '>aaa.aa.aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBKESR', '') ;

CALL FIELDSINFO_IMPORT(47125, 0, 2, 36861, 47085, 47092, 'CODE', 1, 0, 20, '', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'DIRECTIONCLS', '') ;

CALL FIELDSINFO_IMPORT(47126, 0, 2, 46492, 47085, 47086, 'VARIANT', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 23059, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'VARIANT', '') ;

CALL FIELDSINFO_IMPORT(47127, 0, 2, 36863, 47085, 47093, 'CODE', 1, 0, 20, '', '', 20, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FACT', '') ;

CALL FIELDSINFO_IMPORT(47128, 0, 2, 27849, 47085, 47094, 'CODE', 1, 0, 20, '', '', 12, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'PAYPROMISECLS', '') ;

CALL FIELDSINFO_IMPORT(47129, 0, 2, 27825, 47085, 47097, 'CODE', 1, 0, 20, '', '', 8, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDALLOCATIONCLS', '') ;

CALL FIELDSINFO_IMPORT(47130, 0, 2, 40459, 47085, 47098, 'CODE', 1, 0, 20, '', '', 0, '999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CONTRACTCOSTSCLS', '') ;

CALL FIELDSINFO_IMPORT(47131, 0, 2, 38205, 47085, 47100, 'CODE', 1, 0, 50, '', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'INVESTOBJECT', '') ;

CALL FIELDSINFO_IMPORT(47132, 0, 2, 36853, 47085, 47101, 'CODE', 1, 0, 20, '', '', 6, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FINTYPE', '') ;

CALL FIELDSINFO_IMPORT(47133, 0, 2, 46499, 47085, 47086, 'MEANSTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 17311, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'MEANSTYPE', '') ;

CALL FIELDSINFO_IMPORT(47134, 0, 2, 22390, 47085, 47103, 'STRCODE', 1, 0, 50, ' ', '', 20, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TARGETCLS', '') ;

CALL FIELDSINFO_IMPORT(47135, 0, 2, 46501, 47085, 47086, 'REGIONCLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16688, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'REGIONCLS', '') ;

CALL FIELDSINFO_IMPORT(47136, 0, 2, 26641, 47085, 47104, 'CODE', 1, 0, 20, ' ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'SUBSIDYCLS', '') ;

CALL FIELDSINFO_IMPORT(47137, 0, 2, 25326, 47085, 47105, 'CODE', 3, 0, 0, '', '', 12, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TRANSFERTCLS', '') ;

CALL FIELDSINFO_IMPORT(47138, 0, 2, 46504, 47085, 47086, 'PLANDOCTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 20686, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'PLANDOCTYPE', '') ;

CALL FIELDSINFO_IMPORT(47139, 0, 2, 46136, 47085, 47107, 'CODE', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ASSIGNMENTSOURCE', '') ;

CALL FIELDSINFO_IMPORT(47140, 0, 2, 46506, 47085, 47086, 'ASSIGNMENTKIND', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 22976, 0, 0, 0, '', 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ASSIGNMENTKIND', '') ;

CALL FIELDSINFO_IMPORT(47141, 0, 2, 16836, 47085, 47108, 'KDVALUE', 1, 0, 20, ' ', '  ', 31, '999.9.99.99.999.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KD', '') ;

CALL FIELDSINFO_IMPORT(47142, 0, 2, 38919, 47085, 47109, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ANALYTICALGROUPIFS', '') ;

CALL FIELDSINFO_IMPORT(47143, 0, 2, 38908, 47085, 47110, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ANALYTICALGROUPKD', '') ;

CALL FIELDSINFO_IMPORT(47144, 0, 2, 46510, 47085, 47086, 'PROGRAMCODE', 3, 0, 0, '', '  ', 11, '', '', '', 0, 0, null, 0, 21560, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'PROGRAMCODE', '') ;

CALL FIELDSINFO_IMPORT(47145, 0, 2, 17055, 47085, 47111, 'FINSOURCEVALUE', 1, 0, 20, ' .  .  ', '       ', 31, '999.99.99.99.99.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FINSOURCEVALUE', '') ;

CALL FIELDSINFO_IMPORT(47146, 0, 2, 46512, 47085, 47086, 'REESTRTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 19705, 0, 0, 0, '', 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'REESTRTYPE', '') ;

CALL FIELDSINFO_IMPORT(47147, 0, 2, 32822, 47085, 47112, 'CODE', 1, 0, 20, '', '', 14, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'OKTMO', '') ;

CALL FIELDSINFO_IMPORT(47148, 0, 2, 36865, 47085, 47113, 'CODE', 1, 0, 20, '', '', 20, '>aa.aa.aaa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'DOCBASE', '') ;

CALL FIELDSINFO_IMPORT(47149, 0, 2, 46515, 47085, 47086, 'FUNDSSOURCE', 3, 0, 0, ' ', '  ', 11, '', '', '', 0, 0, null, 0, 22632, 0, 0, 0, '', 33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FUNDSSOURCE', '') ;

CALL FIELDSINFO_IMPORT(47150, 0, 2, 46516, 47085, 47086, 'FINSOURCE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16983, 0, 0, 0, '', 34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FINSOURCE', '') ;

CALL FIELDSINFO_IMPORT(47151, 0, 2, 46517, 47085, 47086, 'DOCTYPE', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 16814, 0, 0, 0, '', 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'DOCTYPE', '') ;

CALL FIELDSINFO_IMPORT(47152, 0, 2, 32790, 47085, 47114, 'CODE', 1, 0, 10, '', '', 10, '9999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'COMMDIRECTIONEXPENCECLS', '') ;

CALL FIELDSINFO_IMPORT(47153, 0, 2, 46519, 47085, 47086, 'PAYDESTINATION', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'PAYDESTINATION', '') ;

CALL FIELDSINFO_IMPORT(47154, 0, 2, 46520, 47085, 47086, 'FACIALACC_CLS', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 0, 17129, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'FACIALACC_CLS', '') ;

CALL FIELDSINFO_IMPORT(47155, 0, 2, 45707, 47085, 47115, 'CODE', 1, 0, 2, '', '', 10, '>aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'NATIONALPROJECT', '') ;

CALL FIELDSINFO_IMPORT(47156, 0, 2, 46522, 47085, 47086, 'BUDGETREF', 3, 0, 0, ' ', '   ', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'BUDGETREF', '') ;

CALL FIELDSINFO_IMPORT(47157, 0, 2, 46523, 47085, 47086, 'STARTDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'STARTDATE', '') ;

CALL FIELDSINFO_IMPORT(47158, 0, 2, 46524, 47085, 47086, 'DELETEDATE', 11, 0, 0, '  ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'DELETEDATE', '') ;

CALL FIELDSINFO_IMPORT(47159, 0, 2, 46525, 47085, 47086, 'NOTE', 1, 0, 255, '', '', 30, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'NOTE', '') ;

CALL FIELDSINFO_IMPORT(47160, 0, 2, 46526, 47085, 47086, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CREATEDATE', '') ;

CALL FIELDSINFO_IMPORT(47161, 0, 2, 46528, 47085, 47086, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'UPDATEDATE', '') ;

--  
CALL SELECTIONEVENTS_IMPORT(45096, 45096, 3, '') ;

CALL SELECTIONEVENTS_IMPORT(45358, 45358, 3, '') ;

DROP PROCEDURE SELECTIONS_IMPORT
/

DROP PROCEDURE SELECTIONSDETAIL_IMPORT
/

DROP PROCEDURE FIELDSINFO_IMPORT
/

DROP PROCEDURE SELECTIONEVENTS_IMPORT
/

DROP PROCEDURE FIELDSINFO_DELETE
/

DROP PROCEDURE SELECTIONSDETAIL_DELETE
/

DROP PROCEDURE SELECTIONS_DELETE
/

DROP PROCEDURE SELECTIONEVENTS_DELETE
/

CREATE OR REPLACE PROCEDURE ImportDocCLS (
   ID_                 NUMBER,
   DOCTYPE_            NUMBER,
   DOCTYPENOTE_        VARCHAR2,
   TABLENAME_          VARCHAR2,
   TABLENAMEURM_       VARCHAR2,
   PRIMARYKEYNAME_     VARCHAR2,
   PRIMARYKEYNAMEURM_  VARCHAR2,
   LINKFIELDNAME_      VARCHAR2,
   LINKFIELDNAMEURM_   VARCHAR2,
   CLSTYPE_            NUMBER,
   SELECTIONREFBUDGET_ NUMBER,
   SELECTIONREFURM_    NUMBER,
   PROGINDEX_          NUMBER
) IS IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
   INTO IDExists$
   FROM DOCUMENTCLS
   WHERE (ID = ID_);

   IF (IDExists$ = 0) THEN
   INSERT INTO DOCUMENTCLS
   (ID, DOCTYPE, DOCTYPENOTE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM, LINKFIELDNAME, LINKFIELDNAMEURM, CLSTYPE, 
     SELECTIONREFBUDGET, SELECTIONREFURM, PROGINDEX)
   VALUES (ID_, DOCTYPE_, DOCTYPENOTE_, TABLENAME_, TABLENAMEURM_, PRIMARYKEYNAME_, PRIMARYKEYNAMEURM_, LINKFIELDNAME_, LINKFIELDNAMEURM_, CLSTYPE_, 
     SELECTIONREFBUDGET_, SELECTIONREFURM_, PROGINDEX_);
   ELSE
   UPDATE DOCUMENTCLS 
   SET
     DOCTYPENOTE = DOCTYPENOTE_,
     TABLENAME = TABLENAME_,
     TABLENAMEURM = TABLENAMEURM_,
     PRIMARYKEYNAME = PRIMARYKEYNAME_,
     PRIMARYKEYNAMEURM = PRIMARYKEYNAMEURM_,
     LINKFIELDNAME = LINKFIELDNAME_,
     LINKFIELDNAMEURM = LINKFIELDNAMEURM_,
     CLSTYPE = CLSTYPE_,
     SELECTIONREFBUDGET = SELECTIONREFBUDGET_,
     SELECTIONREFURM = SELECTIONREFURM_,
     PROGINDEX = PROGINDEX_
   WHERE  
    (ID = ID_)
    AND NOT (
            (
                    ((DOCTYPENOTE IS NOT NULL AND DOCTYPENOTE_ IS NOT NULL) AND
                       (UPPER (DOCTYPENOTE) = UPPER (DOCTYPENOTE_))
                    )
                    OR (DOCTYPENOTE IS NULL AND DOCTYPENOTE_ IS NULL)
                )    
        AND (UPPER (TABLENAME) = UPPER (TABLENAME_))    
        AND (
                    ((TABLENAMEURM IS NOT NULL AND TABLENAMEURM_ IS NOT NULL) AND
                       (UPPER (TABLENAMEURM) = UPPER (TABLENAMEURM_))
                    )
                    OR (TABLENAMEURM IS NULL AND TABLENAMEURM_ IS NULL)
                )    
        AND (UPPER (PRIMARYKEYNAME) = UPPER (PRIMARYKEYNAME_))
        AND (
                    ((PRIMARYKEYNAMEURM IS NOT NULL AND PRIMARYKEYNAMEURM_ IS NOT NULL) AND
                       (UPPER (PRIMARYKEYNAMEURM) = UPPER (PRIMARYKEYNAMEURM_))
                    )
                    OR (PRIMARYKEYNAMEURM IS NULL AND PRIMARYKEYNAMEURM_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAME IS NOT NULL AND LINKFIELDNAME_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAME) = UPPER (LINKFIELDNAME_))
                    )
                    OR (LINKFIELDNAME IS NULL AND LINKFIELDNAME_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAMEURM IS NOT NULL AND LINKFIELDNAMEURM_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAMEURM) = UPPER (LINKFIELDNAMEURM_))
                    )
                    OR (LINKFIELDNAMEURM IS NULL AND LINKFIELDNAMEURM_ IS NULL)
                )    
        AND (
                    ((CLSTYPE IS NOT NULL AND CLSTYPE_ IS NOT NULL) AND
                       (UPPER (CLSTYPE) = UPPER (CLSTYPE_))
                    )
                    OR (CLSTYPE IS NULL AND CLSTYPE_ IS NULL)
                ) 
        AND (
                    ((PROGINDEX IS NOT NULL AND PROGINDEX_ IS NOT NULL) AND
                       (PROGINDEX = PROGINDEX_)
                    )
                    OR (PROGINDEX IS NULL AND PROGINDEX_ IS NULL)
                )   
            );
   
   END IF;
END;
/

--   
CALL ImportDocCLS(10100, 101, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10101, 101, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10102, 101, ' ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10103, 101, ' ', 'DEBT', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10104, 101, ' %  ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10105, 101, ' ', 'INCOMES32', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20100, 201, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(20101, 201, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(30100, 301, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30101, 301, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30200, 302, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30201, 302, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30300, 303, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30301, 303, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30400, 304, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30401, 304, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30500, 305, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30501, 305, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30600, 306, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30601, 306, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30700, 307, '', 'FACIALFINREESTR', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(31100, 311, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31101, 311, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31200, 312, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31201, 312, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31400, 314, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31401, 314, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31500, 315, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(31501, 315, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(992500, 9925, '', 'Cards', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992501, 9925, ' ', 'CARDSDETAIL_FACC', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(490300, 4903, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 527) ;

CALL ImportDocCLS(32200, 322, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32201, 322, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32300, 323, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32301, 323, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32400, 324, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(32401, 324, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(40100, 401, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 130) ;

CALL ImportDocCLS(40101, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 131) ;

CALL ImportDocCLS(40102, 401, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 137) ;

CALL ImportDocCLS(40103, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 132) ;

CALL ImportDocCLS(40104, 401, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 134) ;

CALL ImportDocCLS(40105, 401, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 138) ;

CALL ImportDocCLS(40106, 401, ' %', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 133) ;

CALL ImportDocCLS(40107, 401, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40108, 401, '. ', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40109, 401, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 340) ;

CALL ImportDocCLS(40110, 401, '.', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 341) ;

CALL ImportDocCLS(40111, 401, '', 'LOANCREDITCONTRACTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 342) ;

CALL ImportDocCLS(50100, 501, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 120) ;

CALL ImportDocCLS(50101, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 121) ;

CALL ImportDocCLS(50102, 501, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 127) ;

CALL ImportDocCLS(50103, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 122) ;

CALL ImportDocCLS(50104, 501, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 124) ;

CALL ImportDocCLS(50105, 501, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 128) ;

CALL ImportDocCLS(50106, 501, ' %', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 123) ;

CALL ImportDocCLS(50107, 501, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(50108, 501, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 321) ;

CALL ImportDocCLS(70100, 701, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70101, 701, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70200, 702, '', 'PAYDOC32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70201, 702, '', 'PAYDOC32', ' ', 'ID', ' ', 'PARENTINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70300, 703, '', 'FINDOCDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, 36) ;

CALL ImportDocCLS(80100, 801, '', 'LIMITNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80101, 801, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 57) ;

CALL ImportDocCLS(80200, 802, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80300, 803, '', 'REQUESTFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80301, 803, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80400, 804, '', 'LIMITFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90100, 901, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 145) ;

CALL ImportDocCLS(90101, 901, '', 'INCOMES32', ' ', 'ID', ' ', 'RecordIndex', ' ', 0, null, null, 0) ;

CALL ImportDocCLS(90300, 903, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90301, 903, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90500, 905, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 44) ;

CALL ImportDocCLS(90600, 906, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 41) ;

CALL ImportDocCLS(90601, 906, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 42) ;

CALL ImportDocCLS(120100, 1201, '', 'BUH_JOURNAL', ' ', 'ID', ' ', '', ' ', 0, null, null, 309) ;

CALL ImportDocCLS(150100, 1501, '', 'ORGOPERAT', ' ', 'ID', ' ', '', ' ', 0, null, null, 35) ;

CALL ImportDocCLS(160100, 1601, '', 'PROMISE_CAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(160101, 1601, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', 'TITLE_REF', ' ', 0, null, null, 345) ;

CALL ImportDocCLS(160200, 1602, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(170100, 1701, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 222) ;

CALL ImportDocCLS(170200, 1702, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 221) ;

CALL ImportDocCLS(170201, 1702, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(190100, 1901, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(190101, 1901, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(220100, 2201, '', 'BUDNOTIFY', 'BUDNOTIFY', 'ID', ' ', '', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(220101, 2201, '', 'BUDGETDATA', 'BUDGETDATA', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(280100, 2801, '', 'ACCSOPERTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(280101, 2801, '', 'PAYDOC32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 16) ;

CALL ImportDocCLS(280200, 2802, '', 'DFACCOUNTOPERATION', ' ', 'ID', ' ', '', ' ', 0, null, null, 50) ;

CALL ImportDocCLS(440100, 4401, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(440101, 4401, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(0, 0, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991304, 9913, ' ', 'STATICLINKS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(440300, 4403, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(440301, 4403, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(989500, 9895, ' ', 'OKTMO', 'OKTMO', 'id', 'id', '', '', 95, null, null, null) ;

CALL ImportDocCLS(990300, 9903, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990301, 9903, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990302, 9903, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990500, 9905, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90200, 902, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 38) ;

CALL ImportDocCLS(20701, 207, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(90700, 907, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181200, 1812, '', 'ED_CorrectionCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181000, 1810, '', 'ED_OUTPAYDOC', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20700, 207, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(181001, 1810, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992700, 9927, '', 'REMOTECLIENT', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550100, 5501, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(20801, 208, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(30701, 307, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', 'REESTR_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21100, 211, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 275) ;

CALL ImportDocCLS(490100, 4901, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 525) ;

CALL ImportDocCLS(992701, 9927, '  ', 'REMOTEREADRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(550101, 5501, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(490301, 4903, '', 'ARCHIVEOPLOG', ' ', 'ID', ' ', 'DATAPACKETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(390100, 3901, '', 'DELOIN', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21101, 211, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(992300, 9923, '', 'SIGNSCHEMECAPTION', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181201, 1812, '', 'ED_CorrectionDetail', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(550200, 5502, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(20800, 208, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(550201, 5502, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(90000, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992301, 9923, '', 'SIGNSCHEMEDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991600, 9916, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992200, 9922, '', 'ARCHIVEDOCTYPE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(90001, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(390101, 3901, '', 'DELOEXEC', ' ', 'ID', ' ', 'DOCID', ' ', 0, null, null, null) ;

CALL ImportDocCLS(180700, 1807, '', 'PayDocExchange', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21102, 211, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(991700, 9917, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991200, 9912, '', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181600, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30800, 308, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250100, 2501, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 305) ;

CALL ImportDocCLS(21200, 212, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 276) ;

CALL ImportDocCLS(250101, 2501, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(30801, 308, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250200, 2502, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 304) ;

CALL ImportDocCLS(250201, 2502, ' ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(988900, 9889, ' ', 'SubsidyCls', ' ', 'id', ' ', '', '', 89, null, null, null) ;

CALL ImportDocCLS(250202, 2502, '  ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(988700, 9887, ' ', 'VariantCls', ' ', 'ID', ' ', '', '', 87, null, null, null) ;

CALL ImportDocCLS(520100, 5201, '', 'WritExecutionCaption', 'WritExecutionCaption', 'id', 'id', '', '', 0, null, null, 555) ;

CALL ImportDocCLS(990800, 9908, '', 'DocumentTypes', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(250300, 2503, '', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21201, 212, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(250301, 2503, '', 'EXECUTIONDOCUMENTSDETAIL', 'EXECUTIONDOCUMENTSDETAIL', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(180500, 1805, '', 'BANKEXCH_MERDOC', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20201, 202, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20301, 203, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20401, 204, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20501, 205, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20601, 206, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190201, 1902, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190301, 1903, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(20000, 200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190601, 1906, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(20200, 202, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20300, 203, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20400, 204, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20500, 205, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20600, 206, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190200, 1902, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190300, 1903, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(180501, 1805, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(190600, 1906, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(988400, 9884, ' ', 'TransfertCLS', ' ', 'ID', ' ', '', '', 84, null, null, null) ;

CALL ImportDocCLS(988800, 9888, ' ', 'OKP', ' ', 'ID', ' ', '', '', 88, null, null, null) ;

CALL ImportDocCLS(989900, 9899, ' ', 'DBUsers', ' ', 'ID', ' ', '', '', 201, null, null, null) ;

CALL ImportDocCLS(990801, 9908, ' ', 'DOCUMENTFIELDS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(361000, 3610, '', 'UTYPEDFORMSCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 550) ;

CALL ImportDocCLS(987200, 9872, ' ', 'BalanceCls', ' ', 'ID', ' ', '', '', 72, null, null, null) ;

CALL ImportDocCLS(984600, 9846, ' ', 'BUHPAYMENTCLS', ' ', 'ID', ' ', '', '', 46, null, null, null) ;

CALL ImportDocCLS(981800, 9818, ' ', 'CURRENCYCLS', ' ', 'ID', ' ', '', '', 18, null, null, null) ;

CALL ImportDocCLS(988500, 9885, ' ', 'AssignmentKind', ' ', 'ID', ' ', '', '', 85, null, null, null) ;

CALL ImportDocCLS(983500, 9835, ' ', 'BUDGETTYPE', ' ', 'ID', ' ', '', '', 35, null, null, null) ;

CALL ImportDocCLS(985800, 9858, ' ', 'DEBTTYPE', ' ', 'ID', ' ', '', '', 58, null, null, null) ;

CALL ImportDocCLS(988600, 9886, ' ', 'AssignmentSource', ' ', 'ID', ' ', ' ', ' ', 86, null, null, null) ;

CALL ImportDocCLS(988300, 9883, ' ', 'Org_Type', ' ', 'ID', ' ', '', '', 83, null, null, null) ;

CALL ImportDocCLS(986400, 9864, ' ', 'PlanDocType', ' ', 'ID', ' ', '', '', 64, null, null, null) ;

CALL ImportDocCLS(985700, 9857, ' ', 'LOANTYPE', ' ', 'ID', ' ', '', '', 57, null, null, null) ;

CALL ImportDocCLS(984300, 9843, ' ', 'PAYTYPECLS', ' ', 'ID', ' ', '', '', 43, null, null, null) ;

CALL ImportDocCLS(982300, 9823, ' ', 'GOSNI', ' ', 'ID', ' ', '', '', 23, null, null, null) ;

CALL ImportDocCLS(982200, 9822, ' ', 'GroupInf_CLS', ' ', 'ID', ' ', '', '', 22, null, null, null) ;

CALL ImportDocCLS(982900, 9829, ' ', 'DocBase', ' ', 'ID', ' ', '', '', 29, null, null, null) ;

CALL ImportDocCLS(981100, 9811, ' ', 'DocTypes', ' ', 'ID', ' ', '', '', 11, null, null, null) ;

CALL ImportDocCLS(986000, 9860, ' ', 'MEASUREMENTCLS', ' ', 'ID', ' ', '', '', 60, null, null, null) ;

CALL ImportDocCLS(988000, 9880, ' ', 'FundsSource', ' ', 'ID', ' ', '', '', 80, null, null, null) ;

CALL ImportDocCLS(985200, 9852, ' ', 'InnerFinSource', ' ', 'ID', ' ', '', '', 52, null, null, null) ;

CALL ImportDocCLS(981300, 9813, ' ', 'NOTIFYTYPES', ' ', 'ID', ' ', '', '', 13, null, null, null) ;

CALL ImportDocCLS(984500, 9845, ' ', 'PAYSYMBOLCLS', ' ', 'ID', ' ', '', '', 45, null, null, null) ;

CALL ImportDocCLS(980400, 9804, ' ', 'KVR', ' ', 'ID', ' ', '', '', 4, null, null, null) ;

CALL ImportDocCLS(980300, 9803, ' ', 'KVSR', ' ', 'ID', ' ', '', '', 3, null, null, null) ;

CALL ImportDocCLS(980900, 9809, ' ', 'KD', ' ', 'ID', ' ', '', '', 9, null, null, null) ;

CALL ImportDocCLS(984700, 9847, ' ', 'TYPEOPERATIONCLS', ' ', 'ID', ' ', '', '', 47, null, null, null) ;

CALL ImportDocCLS(986800, 9868, ' ', 'KESR', ' ', 'ID', ' ', '', '', 68, null, null, null) ;

CALL ImportDocCLS(987900, 9879, ' ', 'TargetCls', ' ', 'ID', ' ', '', '', 79, null, null, null) ;

CALL ImportDocCLS(985100, 9851, ' ', 'Error', ' ', 'ID', ' ', '', '', 51, null, null, null) ;

CALL ImportDocCLS(982100, 9821, ' ', 'ACC_CLS', ' ', 'ID', ' ', '', '', 21, null, null, null) ;

CALL ImportDocCLS(981400, 9814, ' ', 'KSHK', ' ', 'ID', ' ', '', '', 14, null, null, null) ;

CALL ImportDocCLS(980200, 9802, ' ', 'kfsr', ' ', 'ID', ' ', '', '', 2, null, null, null) ;

CALL ImportDocCLS(980500, 9805, ' ', 'KCSR', ' ', 'ID', ' ', '', '', 5, null, null, null) ;

CALL ImportDocCLS(984100, 9841, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', '', '', 41, null, null, null) ;

CALL ImportDocCLS(981500, 9815, ' ', 'VALUECLS', ' ', 'ID', ' ', '', '', 15, null, null, null) ;

CALL ImportDocCLS(982800, 9828, ' ', 'FACT', ' ', 'ID', ' ', '', '', 28, null, null, null) ;

CALL ImportDocCLS(984800, 9848, ' ', 'PAYDESTINATIONCLS', ' ', 'ID', ' ', '', '', 48, null, null, null) ;

CALL ImportDocCLS(986900, 9869, ' ', 'DirectionCLS', ' ', 'ID', ' ', '', '', 69, null, null, null) ;

CALL ImportDocCLS(986200, 9862, ' ', 'OKATO', ' ', 'ID', ' ', '', '', 62, null, null, null) ;

CALL ImportDocCLS(988200, 9882, ' ', 'OKOPF', ' ', 'ID', ' ', '', '', 82, null, null, null) ;

CALL ImportDocCLS(988100, 9881, ' ', 'OKFS', ' ', 'ID', ' ', '', '', 81, null, null, null) ;

CALL ImportDocCLS(981600, 9816, ' ', 'MeansCLS', ' ', 'ID', ' ', '', '', 16, null, null, null) ;

CALL ImportDocCLS(985900, 9859, ' ', 'DepartmentCLS', ' ', 'ID', ' ', '', '', 59, null, null, null) ;

CALL ImportDocCLS(986500, 9865, ' ', 'BuhAccPlan', ' ', 'ID', ' ', '', '', 65, null, null, null) ;

CALL ImportDocCLS(986100, 9861, ' ', 'TenderObjects', ' ', 'ID', ' ', '', '', 61, null, null, null) ;

CALL ImportDocCLS(985000, 9850, ' ', 'RejectCLS', ' ', 'ID', ' ', '', '', 50, null, null, null) ;

CALL ImportDocCLS(987000, 9870, ' ', 'ProgramCode', ' ', 'ID', ' ', '', '', 70, null, null, null) ;

CALL ImportDocCLS(981200, 9812, ' ', 'RegionCLS', ' ', 'ID', ' ', '', '', 12, null, null, null) ;

CALL ImportDocCLS(982600, 9826, ' ', 'BUDGETACCOUNTS', ' ', 'ID', ' ', '', '', 26, null, null, null) ;

CALL ImportDocCLS(981700, 9817, ' ', 'REFCLS', ' ', 'ID', ' ', '', '', 17, null, null, null) ;

CALL ImportDocCLS(981000, 9810, ' ', 'SubKD', ' ', 'ID', ' ', '', '', 10, null, null, null) ;

CALL ImportDocCLS(980600, 9806, ' ', 'SUBKCSR', ' ', 'ID', ' ', '', '', 6, null, null, null) ;

CALL ImportDocCLS(980800, 9808, ' ', 'KESRSubCode', ' ', 'ID', ' ', '', '', 8, null, null, null) ;

CALL ImportDocCLS(986300, 9863, ' ', 'COLLATERALTYPE', ' ', 'ID', ' ', '', '', 63, null, null, null) ;

CALL ImportDocCLS(982000, 9820, ' ', 'ORG_CLS', ' ', 'ID', ' ', '', '', 20, null, null, null) ;

CALL ImportDocCLS(983400, 9834, ' ', 'ReportType', ' ', 'ID', ' ', '', '', 34, null, null, null) ;

CALL ImportDocCLS(985300, 9853, ' ', 'REESTRTYPE', ' ', 'ID', ' ', '', '', 53, null, null, null) ;

CALL ImportDocCLS(984900, 9849, ' ', 'MEANSTYPE', ' ', 'ID', ' ', '', '', 49, null, null, null) ;

CALL ImportDocCLS(982700, 9827, ' ', 'FinType', ' ', 'ID', ' ', '', '', 27, null, null, null) ;

CALL ImportDocCLS(984400, 9844, ' ', 'Org_AccDefaults', ' ', 'ID', ' ', '', '', 44, null, null, null) ;

CALL ImportDocCLS(960100, 9601, ' ', 'ORGANIZATIONS', ' ', 'ID', ' ', '', '', 1000, null, null, null) ;

CALL ImportDocCLS(960200, 9602, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 1001, null, null, null) ;

CALL ImportDocCLS(960400, 9604, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', '', 1003, null, null, null) ;

CALL ImportDocCLS(960300, 9603, ' ', 'BANKS', ' ', 'ID', ' ', '', '', 1002, null, null, null) ;

CALL ImportDocCLS(987100, 9871, ' ', 'BuhOperationCls', ' ', 'Id', ' ', '', '', 71, null, null, null) ;

CALL ImportDocCLS(987800, 9878, ' ', 'budgets_s', ' ', 'id', ' ', '', '', 78, null, null, null) ;

CALL ImportDocCLS(991400, 9914, '', 'DATAPACKETTYPES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991401, 9914, '', 'DATAPACKETCONTENT', ' ', 'ID', ' ', 'DATAPACKETTYPE', '', 0, null, null, null) ;

CALL ImportDocCLS(991500, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991501, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', 'ID', '', 0, null, null, null) ;

CALL ImportDocCLS(20001, 200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(30000, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30001, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190000, 1900, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190001, 1900, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(220000, 2200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(220001, 2200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991300, 9913, '', 'INTERFACES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991301, 9913, '', 'Permissions', ' ', 'ID', ' ', 'INTERFACEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(991302, 9913, '', 'LinkType', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991303, 9913, ' ', ' ', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(490200, 4902, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 526) ;

CALL ImportDocCLS(250400, 2504, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', '', 0, null, null, 314) ;

CALL ImportDocCLS(300100, 3001, '', 'TenderCaption', ' ', 'ID', ' ', '', '', 0, null, null, 230) ;

CALL ImportDocCLS(250401, 2504, '  ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(250402, 2504, '   ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(250403, 2504, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(300600, 3006, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 241) ;

CALL ImportDocCLS(250102, 2501, '  . ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(70202, 702, '', 'PAYDOCEXCHANGE', ' ', 'ID', ' ', 'PAYDOCREF', '', 0, null, null, null) ;

CALL ImportDocCLS(170101, 1701, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20900, 209, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 274) ;

CALL ImportDocCLS(300601, 3006, '  ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 241) ;

CALL ImportDocCLS(300602, 3006, '   ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300300, 3003, '', 'TenderResultCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(300101, 3001, ' ', 'TenderProduct', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 230) ;

CALL ImportDocCLS(300102, 3001, ' ', 'TenderLot', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300103, 3001, '   ', 'TENDERSOURCEORG', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300104, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300105, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300106, 3001, ' ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300107, 3001, '   ', 'TENDERSUPPLEMENTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300108, 3001, ',  ', 'TENDERSUPDOCUMENT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(370100, 3701, '', 'TenderObjects', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(520101, 5201, '', 'WritExecutionDetail', 'WritExecutionDetail', 'id', 'id', 'RecordIndex', '', 0, null, null, 556) ;

CALL ImportDocCLS(20901, 209, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(21000, 210, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 252) ;

CALL ImportDocCLS(21001, 210, ', ', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 252) ;

CALL ImportDocCLS(21002, 210, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 253) ;

CALL ImportDocCLS(991800, 9918, '', 'USERGENERATOR', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991801, 9918, '', 'USERGENERATORFIELDS', ' ', 'ID', ' ', 'GENREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992702, 9927, '   ', 'REMOTEINPUTRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(21202, 212, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(990802, 9908, ' ', 'STATE_DOCSTATES', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990803, 9908, '', 'STATE_JUMPS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990804, 9908, '', 'STATE_ACTIONS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992703, 9927, '   ', 'REMOTECLIENTACCOUNT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992000, 9920, '', 'BUHOPERATIONCLS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992001, 9920, '', 'BUHACCCORR', ' ', 'ID', ' ', 'BUHOPERATIONCLS', '', 0, null, null, null) ;

CALL ImportDocCLS(992100, 9921, '', 'BUDGETS_S', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992101, 9921, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992102, 9921, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(989000, 9890, ' ', 'BudAllocationCls', ' ', 'id', ' ', '', '', 90, null, null, null) ;

CALL ImportDocCLS(989100, 9891, ' ', 'PayPromiseCls', ' ', 'id', ' ', '', '', 91, null, null, null) ;

CALL ImportDocCLS(550300, 5503, '', 'ReplacementClsCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550301, 5503, '   ', 'ReplacementClsDetail', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(550302, 5503, ' ', 'ReplacementClsDetailInfo', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(250302, 2503, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'EXECUTIONREF', '', 0, null, null, 308) ;

CALL ImportDocCLS(181400, 1814, '', 'BANKEXCH_LS_KB', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(180900, 1809, '', 'BANKEXCH_SUBSTITUTION', 'BANKEXCH_SUBSTITUTION', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181500, 1815, '', 'BANKEXCH_KO_SALDO', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992900, 9929, '', 'BudStruct', 'BudStruct', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992201, 9922, '', 'ARCHIVEDOCPARAMS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(992400, 9924, '', 'SIGNS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(480101, 4801, '', 'GeneralDocsDetail', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992502, 9925, '', 'CARDSDETAIL_KESR', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(250203, 2502, ' ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 304) ;

CALL ImportDocCLS(250404, 2504, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', '', 0, null, null, 318) ;

CALL ImportDocCLS(520102, 5201, '2', 'WritExecutionNotify', 'WritExecutionNotify', 'id', 'id', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(989200, 9892, ' ', 'ArchiveDocType', ' ', 'id', ' ', '', '', 92, null, null, null) ;

CALL ImportDocCLS(480100, 4801, '', 'GeneralDocuments', ' ', 'ID', ' ', '', '', 0, null, null, 528) ;

CALL ImportDocCLS(992600, 9926, '', 'WritNotifyCls', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992601, 9926, '', 'WRITNOTIFYCLSDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992602, 9926, ' ', 'WritNotifyClsPart', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(31600, 316, '', 'ManagerBid', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20902, 209, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(992704, 9927, '  + /', 'DUALRIGHTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992705, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992706, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(990400, 9904, '', 'CONTACTPERSONS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181601, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992707, 9927, '', 'SIGNCERTIFICATE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992708, 9927, '  ', 'SIGNDOCUMENTSGROUP', ' ', 'ID', ' ', 'CLIENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(510100, 5101, '', 'StoredAttributesCaption', 'StoredAttributesCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(510101, 5101, '', 'StoredAttributesDetail', 'StoredAttributesDetail', 'id', 'id', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250405, 2504, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(993000, 9930, '', 'AUTOSANCTIONDATA', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301000, 3010, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 242) ;

CALL ImportDocCLS(970200, 9702, ' ', 'AnalyticalGroupIFS', 'AnalyticalGroupIFS', 'ID', 'ID', '', '', 102, null, null, null) ;

CALL ImportDocCLS(970100, 9701, ' ', 'AnalyticalGroupKD', 'AnalyticalGroupKD', 'ID', 'ID', '', '', 101, null, null, null) ;

CALL ImportDocCLS(181800, 1818, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301100, 3011, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 243) ;

CALL ImportDocCLS(301101, 3011, ' ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 243) ;

CALL ImportDocCLS(300500, 3005, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 240) ;

CALL ImportDocCLS(181801, 1818, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181802, 1818, '', 'OOS_CONTRACT_PRODUCTS', 'OOS_CONTRACT_PRODUCTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181803, 1818, '', 'OOS_CONTRACTPROCEDURE', 'OOS_CONTRACTPROCEDURE', 'ID', 'ID', 'RegNum', 'RegNum', 0, null, null, null) ;

CALL ImportDocCLS(989700, 9897, ' ', 'ContractCostsCls', 'ContractCostsCls', 'id', 'id', '', '', 97, null, null, null) ;

CALL ImportDocCLS(960101, 9601, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(989800, 9898, ' ', 'PURCHASETYPE ', 'PURCHASETYPE ', 'id', 'id', '', '', 98, null, null, null) ;

CALL ImportDocCLS(21300, 213, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 277) ;

CALL ImportDocCLS(21301, 213, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 277) ;

CALL ImportDocCLS(21400, 214, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 278) ;

CALL ImportDocCLS(21401, 214, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 278) ;

CALL ImportDocCLS(993200, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993201, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21500, 215, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 279) ;

CALL ImportDocCLS(21501, 215, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 279) ;

CALL ImportDocCLS(250204, 2502, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(181900, 1819, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181901, 1819, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(182000, 1820, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(182001, 1820, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181804, 1818, '', 'OOS_ATTACHMENTS', 'OOS_ATTACHMENTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250406, 2504, '', 'Suppliers', 'Suppliers', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(540200, 5402, '', 'EPBSExportLogCaption', 'EPBSExportLogCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(540201, 5402, '', 'EPBSExportLogDetail', 'EPBSExportLogDetail', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(970900, 9709, ' ', 'TargetCls', ' ', 'ID', ' ', '', '', 109, null, null, null) ;

CALL ImportDocCLS(985400, 9854, ' ', 'InvestObject', ' ', 'ID', ' ', '', '', 54, null, null, null) ;

CALL ImportDocCLS(182100, 1821, '', 'PayDocExchange', 'PayDocExchange', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(470100, 4701, '', 'SignCertificate', 'SignCertificate', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971000, 9710, ' ', 'NATIONALPROJECT', 'NATIONALPROJECT', 'ID', 'ID', '', '', 110, null, null, null) ;

CALL ImportDocCLS(21600, 216, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 280) ;

CALL ImportDocCLS(21601, 216, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 280) ;

CALL ImportDocCLS(21700, 217, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 281) ;

CALL ImportDocCLS(21701, 217, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) ;

CALL ImportDocCLS(21702, 217, '2', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) ;

CALL ImportDocCLS(993300, 9933, '', 'ClsCorr', 'ClsCorr', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993301, 9933, '', 'ClsCorrColumns', 'ClsCorrColumns', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993400, 9934, '', 'ClsCorr', 'ClsCorr', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993401, 9934, '', 'ClsCorrValues', 'ClsCorrValues', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971100, 9711, ' ', 'RegProjectResult', 'RegProjectResult', 'ID', 'ID', '', '', 111, null, null, null) ;

CALL ImportDocCLS(21800, 218, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 282) ;

CALL ImportDocCLS(21801, 218, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 282) ;

CALL ImportDocCLS(32500, 325, '', 'FACIALFINCAPTION', 'FACIALFINCAPTION', 'ID', 'ID', '', '', 0, null, null, 283) ;

CALL ImportDocCLS(32501, 325, '', 'FACIALFINDETAIL', 'FACIALFINDETAIL', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, 283) ;

CALL ImportDocCLS(182400, 1824, '', 'PayDocExchange ', 'PayDocExchange ', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(182401, 1824, '', 'ED_OUT_FACIALACC', 'ED_OUT_FACIALACC', 'ID', 'ID', 'ELDOCREF', '', 0, null, null, null) ;

CALL ImportDocCLS(182500, 1825, '', 'PayDocExchange', 'PayDocExchange', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971300, 9713, ' ', 'PayTargetFunds', 'PayTargetFunds', 'ID', 'ID', '', '', 113, null, null, null) ;

CALL ImportDocCLS(971200, 9712, ' ', 'IncomeTargetFunds', 'IncomeTargetFunds', 'ID', 'ID', '', '', 112, null, null, null) ;

CALL ImportDocCLS(971400, 9714, ' ', 'AnalyticalPartition', 'AnalyticalPartition', 'ID', 'ID', '', '', 114, null, null, null) ;

CALL ImportDocCLS(971600, 9716, ' ', 'PaymentCodeType', 'PaymentCodeType', 'ID', 'ID', '', '', 116, null, null, null) ;

DROP PROCEDURE ImportDocCLS
/

COMMIT WORK
/


CREATE OR REPLACE PROCEDURE ImportField (
   ID_                NUMBER,
   NAME_              VARCHAR2,
   ITFFIELDNAME_      VARCHAR2,
   NOTE_              VARCHAR2,
   TEMPLATEFIELD_     VARCHAR2,
   ISBUDGET_          NUMBER,
   DOCTYPEREF_        NUMBER,
   DETAILNUMBER_      NUMBER,
   ONLYREAD_          NUMBER,
   ReportFieldName_   VARCHAR2,
   KIND_	      NUMBER,
   FIELDINFOREF_      NUMBER,
   CONTAINERREF_      NUMBER, 
   ATTRFIELDKIND_     NUMBER,
   ATTRIBUTENAME_     VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentFields
    WHERE (ID = ID_);

   IF (IDExists$ <> 0) THEN
      UPDATE DocumentFields
         SET NAME = NAME_,
             ITFFIELDNAME = ITFFIELDNAME_,
             NOTE = NOTE_,
             TEMPLATEFIELD = TEMPLATEFIELD_,
             ISBUDGET = ISBUDGET_,
             DOCTYPEREF = DOCTYPEREF_,
             DETAILNUMBER = DETAILNUMBER_,
             ONLYREAD = ONLYREAD_,
             ReportFieldName = ReportFieldName_,
			       FIELDINFOREF = FIELDINFOREF_, 
             CONTAINERREF = CONTAINERREF_, 
             ATTRFIELDKIND = ATTRFIELDKIND_,
             ATTRIBUTENAME = ATTRIBUTENAME_
       WHERE (ID = ID_)
         AND NOT (
                      (
                          (
                           (NAME IS NOT NULL AND NAME_ IS NOT NULL) AND
                           (UPPER (NAME) = UPPER (NAME_))
                          )
                       OR (NAME IS NULL AND NAME_ IS NULL)
                      )

                  AND (
                          (
                           (ITFFIELDNAME_ IS NOT NULL AND ITFFIELDNAME IS NOT NULL) AND
                           (UPPER (ITFFIELDNAME_) = UPPER (ITFFIELDNAME))
                          )
                       OR (ITFFIELDNAME_ IS NULL AND ITFFIELDNAME IS NULL)
                      )
                      
                  AND (
                          (
                           (NOTE IS NOT NULL AND NOTE_ IS NOT NULL) AND
                           (UPPER (NOTE) = UPPER (NOTE_))
                          )
                       OR (NOTE IS NULL AND NOTE_ IS NULL)
                      )
                  AND (UPPER (TEMPLATEFIELD) = UPPER (TEMPLATEFIELD_))
                  AND (
                          (
                           (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                           (ISBUDGET = ISBUDGET_)
                          )
                       OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                      )
                  AND (
                          (
                           (FIELDINFOREF IS NOT NULL AND FIELDINFOREF_ IS NOT NULL) AND
                           (FIELDINFOREF = FIELDINFOREF_)
                          )
                       OR (FIELDINFOREF IS NULL AND FIELDINFOREF_ IS NULL)
                      )
                  AND (
                          (
                           (CONTAINERREF IS NOT NULL AND CONTAINERREF_ IS NOT NULL) AND
                           (CONTAINERREF = CONTAINERREF_)
                          )
                       OR (CONTAINERREF IS NULL AND CONTAINERREF_ IS NULL)
                      )   
                  AND (
                          (
                           (ATTRFIELDKIND IS NOT NULL AND ATTRFIELDKIND_ IS NOT NULL) AND
                           (ATTRFIELDKIND = ATTRFIELDKIND_)
                          )
                       OR (ATTRFIELDKIND IS NULL AND ATTRFIELDKIND_ IS NULL)
                      )
                  AND (
                          (
                           (ATTRIBUTENAME_ IS NOT NULL AND ATTRIBUTENAME IS NOT NULL) AND
                           (UPPER (ATTRIBUTENAME_) = UPPER (ATTRIBUTENAME))
                          )
                       OR (ATTRIBUTENAME_ IS NULL AND ATTRIBUTENAME IS NULL)
                      )
                  AND (DOCTYPEREF = DOCTYPEREF_)
                  AND (DETAILNUMBER = DETAILNUMBER_)
                  AND (ONLYREAD = ONLYREAD_)
                  AND (
                          (
                           (ReportFieldName IS NOT NULL AND ReportFieldName_ IS NOT NULL) AND
                           (UPPER (ReportFieldName) = UPPER (ReportFieldName_))
                          )
                       OR (ReportFieldName IS NULL AND ReportFieldName_ IS NULL)
                      )
                 );
   ELSE
      INSERT INTO DocumentFields
                  (ID, NAME, ITFFIELDNAME, NOTE, TEMPLATEFIELD,
                   ISBUDGET, DOCTYPEREF, DETAILNUMBER, ONLYREAD, ReportFieldName, FIELDINFOREF, CONTAINERREF, ATTRFIELDKIND, ATTRIBUTENAME
                  )
           VALUES (ID_, NAME_, ITFFIELDNAME_, NOTE_, TEMPLATEFIELD_,
                   ISBUDGET_, DOCTYPEREF_, DETAILNUMBER_, ONLYREAD_, ReportFieldName_, FIELDINFOREF_, CONTAINERREF_, ATTRFIELDKIND_, ATTRIBUTENAME_
                  );
   END IF;

   FOR tab_rec IN (
                   SELECT ID
                     FROM DocumentFields
                    WHERE (ID <> ID_)
                      AND (DOCTYPEREF = DOCTYPEREF_)
                      AND (
                              (
                               (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                               (ISBUDGET = ISBUDGET_)
                              )
                           OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                          )
                      AND (DETAILNUMBER = DETAILNUMBER_)
              AND ( /*      ,       ,       */
                            (
                             ((ITFFIELDNAME_ IS NULL)or(ITFFIELDNAME_=' '))
                 and not((TEMPLATEFIELD_ IS NULL)or(TEMPLATEFIELD_=' '))
                 and(TEMPLATEFIELD is NOT null) and (UPPER(TEMPLATEFIELD)=UPPER(TEMPLATEFIELD_))
                            )
                    or (
                        not ((ITFFIELDNAME_ IS NULL) or (ITFFIELDNAME_=' '))
                                and (ITFFIELDNAME IS NOT NULL) and (UPPER(ITFFIELDNAME)=UPPER(ITFFIELDNAME_)))
                            )
                       )
   LOOP
      UPDATE State_OpenFields
         SET DOCFIELDREF = ID_
       WHERE (DOCFIELDREF = tab_rec.ID);

      UPDATE DOCLOCKFIELDS
         SET FIELDREF = ID_
       WHERE (FIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET PARENTFIELDREF = ID_
      WHERE (PARENTFIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET CHILDFIELDREF = ID_
      WHERE (CHILDFIELDREF = tab_rec.ID);

      DELETE FROM DocumentFields
            WHERE (ID = tab_rec.ID);
   END LOOP;
END;
/

CREATE OR REPLACE PROCEDURE DeleteFields (ID$ NUMBER) IS
BEGIN
  DELETE FROM State_OpenFields
  WHERE (docfieldref = ID$);
  DELETE FROM DOCLOCKFIELDS
  WHERE (fieldref = ID$);

  DELETE FROM STATE_JUMPCONTROL
  WHERE STATICLINKREF IN(SELECT ID FROM staticlinks
                           WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$));
  DELETE FROM staticlinks
  WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$);
  
  DELETE FROM DOCUMENTTEMPLATEFIELDS
  WHERE (FIELDS=ID$);

  DELETE FROM STOREDATTRIBUTESDETAIL
  WHERE (ATTRIBUTEFIELD = ID$) or (CONTAINERFIELD = ID$);  

  DELETE FROM DocumentFields
  WHERE (id = ID$);
END;
/

CREATE OR REPLACE PROCEDURE INSERTCONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER,
  NOTE_          VARCHAR2,
  VARCHARVALUE_  VARCHAR2,
  DOUBLEVALUE_   NUMBER,
  INTVALUE_      INTEGER,
  EDITDOCCODE_   INTEGER
) IS
  IDEXISTS$ NUMBER;
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM IntConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO INTCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,INTVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE INTCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 8) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM VarcharConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO VARCHARCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,VARCHARVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE VARCHARCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 5) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM RealConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO REALCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,DOUBLEVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE REALCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;   
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DELETECONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER
) IS
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    UPDATE IntConst
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
  IF (CONSTTYPE_ = 8) THEN
    UPDATE VARCHARCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_); 
  END IF;
  IF (CONSTTYPE_ = 5) THEN
    UPDATE REALCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
END;
/

--       
ALTER TRIGGER TR_INTCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 DISABLE
/

--     
CALL DeleteFields(20101040) ;

CALL DeleteFields(20201011) ;

CALL DeleteFields(20301046) ;

CALL DeleteFields(20401011) ;

CALL DeleteFields(20400156) ;

CALL DeleteFields(20511120) ;

CALL DeleteFields(20501105) ;

CALL DeleteFields(20511121) ;

CALL DeleteFields(20501106) ;

CALL DeleteFields(20510120) ;

CALL DeleteFields(20500121) ;

CALL DeleteFields(20511122) ;

CALL DeleteFields(20501123) ;

CALL DeleteFields(20601041) ;

CALL DeleteFields(20701195) ;

CALL DeleteFields(20801117) ;

CALL DeleteFields(20901017) ;

CALL DeleteFields(20901027) ;

CALL DeleteFields(21011074) ;

CALL DeleteFields(21101014) ;

CALL DeleteFields(21111019) ;

CALL DeleteFields(21211019) ;

CALL DeleteFields(21201014) ;

CALL DeleteFields(21300031) ;

CALL DeleteFields(21301008) ;

CALL DeleteFields(21600001) ;

CALL DeleteFields(21601002) ;

CALL DeleteFields(21600003) ;

CALL DeleteFields(21600004) ;

CALL DeleteFields(21600005) ;

CALL DeleteFields(21600006) ;

CALL DeleteFields(21600007) ;

CALL DeleteFields(21600008) ;

CALL DeleteFields(21600009) ;

CALL DeleteFields(21600010) ;

CALL DeleteFields(21600011) ;

CALL DeleteFields(21600012) ;

CALL DeleteFields(30110045) ;

CALL DeleteFields(30200041) ;

CALL DeleteFields(30201070) ;

CALL DeleteFields(30210039) ;

CALL DeleteFields(30210050) ;

CALL DeleteFields(30211042) ;

CALL DeleteFields(30200210) ;

CALL DeleteFields(30201178) ;

CALL DeleteFields(30510044) ;

CALL DeleteFields(30500175) ;

CALL DeleteFields(30501180) ;

CALL DeleteFields(30500192) ;

CALL DeleteFields(30801262) ;

CALL DeleteFields(32200003) ;

CALL DeleteFields(32200004) ;

CALL DeleteFields(32201086) ;

CALL DeleteFields(32401114) ;

CALL DeleteFields(32401129) ;

CALL DeleteFields(32401163) ;

CALL DeleteFields(32401261) ;

CALL DeleteFields(80100052) ;

CALL DeleteFields(80101053) ;

CALL DeleteFields(190101105) ;

CALL DeleteFields(250310070) ;

CALL DeleteFields(250415001) ;

CALL DeleteFields(250415002) ;

CALL DeleteFields(250410031) ;

CALL DeleteFields(250415003) ;

CALL DeleteFields(250415004) ;

CALL DeleteFields(250415005) ;

CALL DeleteFields(250415006) ;

CALL DeleteFields(250415007) ;

CALL DeleteFields(250415008) ;

CALL DeleteFields(250415009) ;

CALL DeleteFields(250415011) ;

CALL DeleteFields(250415012) ;

CALL DeleteFields(250415013) ;

CALL DeleteFields(250415014) ;

CALL DeleteFields(250415015) ;

CALL DeleteFields(250410117) ;

CALL DeleteFields(250410118) ;

CALL DeleteFields(250410119) ;

CALL DeleteFields(250415157) ;

CALL DeleteFields(300111019) ;

CALL DeleteFields(300116002) ;

CALL DeleteFields(370110006) ;

CALL DeleteFields(370110007) ;

CALL DeleteFields(370110012) ;

CALL DeleteFields(370110020) ;

CALL DeleteFields(370110023) ;

CALL DeleteFields(370110021) ;

CALL DeleteFields(370110026) ;

CALL DeleteFields(520110035) ;

CALL DeleteFields(550110124) ;

CALL DeleteFields(550100120) ;

CALL DeleteFields(550200049) ;

CALL DeleteFields(550210150) ;

CALL DeleteFields(550200147) ;

CALL DeleteFields(985410042) ;

CALL DeleteFields(985410043) ;

CALL DeleteFields(985410044) ;

CALL DeleteFields(985410047) ;

CALL DeleteFields(985410053) ;

CALL DeleteFields(986110010) ;

CALL DeleteFields(986110012) ;

CALL DeleteFields(986110028) ;

CALL DeleteFields(986110032) ;

CALL DeleteFields(986110039) ;

CALL DeleteFields(987910029) ;

CALL DeleteFields(987910030) ;

CALL DeleteFields(993311014) ;

--  , (1)
CALL ImportField(10007, '', '{("")}', ' ', ' ', 1, 0, 0, 0, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(10111008, '', 'KVSR', '', ' ', 1, 101, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10111009, '()', 'KFSR', '', ' ', 1, 101, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10111010, '', 'KCSR', '', ' ', 1, 101, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10111011, '', 'KVR', '', ' ', 1, 101, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10111012, '', 'KESR', '', ' ', 1, 101, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10111019, '', 'SUBKESR', '', ' ', 1, 101, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10111044, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10111181, '()', 'KCSRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10111182, '()', 'KVRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10111183, '()', 'KVSRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10111223, '()', 'KESRCODE', '()', ' ', 1, 101, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10111226, '()', 'SUBKESRCode', '()', ' ', 1, 101, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10112049, '', 'KESR', '', ' ', 1, 101, 2, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10112050, '()', 'KFSR', '', ' ', 1, 101, 2, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10112051, '', 'KCSR', '', ' ', 1, 101, 2, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10112052, '', 'KVSR', '', ' ', 1, 101, 2, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10112053, '', 'KVR', '', ' ', 1, 101, 2, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10112054, '', 'SUBKESR', '', ' ', 1, 101, 2, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10112078, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 2, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10112214, '()', 'KCSRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10112215, '()', 'KVRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10112216, '()', 'KVSRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10112224, '()', 'KESRCODE', '()', ' ', 1, 101, 2, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10112227, '()', 'SUBKESRCode', '()', ' ', 1, 101, 2, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10113107, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 3, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(10114111, '', 'KESR', '', ' ', 1, 101, 4, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10114112, '', 'KFSR', '', ' ', 1, 101, 4, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10114113, '', 'KCSR', '', ' ', 1, 101, 4, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10114114, '', 'KVSR', '', ' ', 1, 101, 4, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10114115, '', 'KVR', '', ' ', 1, 101, 4, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10114116, '', 'SUBKESR', '', ' ', 1, 101, 4, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10114136, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 4, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10114216, '', 'KCSRCode', '', ' ', 1, 101, 4, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10114217, '', 'KVRCode', '', ' ', 1, 101, 4, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10114218, '', 'KVSRCode', '', ' ', 1, 101, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10114225, '()', 'KESRCODE', '()', ' ', 1, 101, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10114228, '()', 'SUBKESRCode', '()', ' ', 1, 101, 4, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10115156, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 5, 0, '', 0, 17720, 0, 0, '') ;

--   (), (0)
CALL ImportField(20000001, ' ', '{("")}', ' () ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000002, '  ', '{("")}', '   ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000003, '  ()', '{("")}', '  ()', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000004, '  ', '{("")}', '  ( )', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000005, '()', '{("")}', ' ', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000006, ' ', '{("")}', ' ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000007, '', '{("")}', ' ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000008, '   ', '{("")}', '     ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000009, '    ', '{("")}', '    ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000011, ' ', '{("")}', ' ', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000012, ' ', '{("")}', '   ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000013, ' ', '{("")}', ' ', ' ', 0, 200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20000014, ' ()', '{("")}', ' ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000015, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000016, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000017, '  ()', 'CREATEDATE', '  ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000018, '  ()', 'ProgIndex', '  ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20000019, '  ()', '{("")}', '  ()', ' ', 0, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001008, ' ', '{("")}', '   ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001010, ' ', '{("")}', ' ', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001011, '   ()', '{("")}', '   ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001012, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001013, '  ', '{("")}', '  ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001014, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001015, '  ()', '{("")}', '  ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001016, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001017, '  ()', '{("")}', '  ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001018, '', '{("")}', ' ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001019, '', '{("")}', ' ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001020, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001021, '', '{("")}', ' ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001022, '', '{("")}', ' ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001023, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001024, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001025, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001026, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001027, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001028, ' ', '{("")}', '- ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001029, '', '{("")}', '  . .', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001030, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001031, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001032, ' ()', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001033, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001035, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001036, '', '{("")}', ' ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001037, '   ', '{("")}', '   ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001038, '   ', '{("")}', '   ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001039, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001040, '   ', '{("")}', '   ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001041, '  ', '{("")}', '  ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001042, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001043, ' ', '{("")}', '  ()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001044, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001045, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001046, '  ()', 'CREATEDATE', '  ()', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001047, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001049, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001050, '', '{("")}', ' ()', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001051, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001052, '()', '{("")}', '()', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001053, '', '{("")}', '', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001054, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001055, ' .  ()', '{("")}', '  ', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001056, '  ', '{("")}', ' . ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001057, ' ()', '{("")}', '', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001058, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001059, ' ', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001060, '  ()', '{("")}', '', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001061, '  ', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001062, '   ()', '{("")}', '', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001063, '', '{("")}', '', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20001064, '', '{("")}', '', ' ', 0, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20001065, ' ', '{("")}', ' ', ' ', 0, 200, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(20010019, '  ()', 'ProgIndex', '  ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010020, '  ()', '{("")}', '  ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011016, ' ', '{("")}', ' ', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011018, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011019, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011020, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011021, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011022, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011023, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011024, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011025, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011050, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011051, '', '{("")}', ' ()', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011052, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011053, '()', '{("")}', '()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011054, '', '{("")}', '', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011055, ' ', '{("")}', ' ', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011056, ' . ', '{("")}', '  ', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011057, ' .  ()', '{("")}', '  ', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011058, ' ()', '{("")}', '', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011059, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011060, ' ', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011061, '  ', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011062, '  ', '{("")}', '', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011063, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011064, '', '{("")}', '', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

--    (), (0)
CALL ImportField(20100001, ' ', 'Dat', ' ', 'Dat', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100002, ' ', 'Id', ' ', 'Id', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100003, '    ', 'FUId', '    ', 'FUId', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100004, ' ', 'DocDat', ' ', 'DocDat', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100005, '', 'Note', '', 'Note', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100006, ' ', 'Note1', ' ', 'Note1', 0, 201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20100007, ' ', 'Note2', ' ', 'Note2', 0, 201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20100008, ' ', 'NotifyType', ' ', 'NotifyType', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100009, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 201, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20100010, '', 'Variant', '', 'Variant', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100011, '', 'Number', '', 'Number', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100012, ' ', 'DocNumber', ' ', 'DocNumber', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100013, ' ', 'DateInput', ' ', 'DateInput', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100014, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100015, ' ', 'RejectCls', ' ', 'RejectCls', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100016, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100017, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 201, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20100018, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100019, ' ', 'OrgName', ' ', 'DestOrgName', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100020, ' ()', 'DocBaseParent', ' ()', ' ', 0, 201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20100021, '', 'DocStateName', '', 'DocStateName', 0, 201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20100022, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100023, ' ', 'IsVised', ' ', 'IsVised', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100024, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100025, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100026, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100027, '  ', ' ', '  ', 'LastExtrChange', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100028, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100029, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20100071, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 201, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20100081, '  , ', 'Ba_Lbo_Flag', '  , ', 'Ba_Lbo_flag', 0, 201, 0, 0, '_', 0, null, 0, 0, '') ;

CALL ImportField(20100088, '', 'BudgetRef', '', 'BudgetRef', 0, 201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20100095, '< >', 'KPPeriod', '', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100096, '< >', 'ClsType', '', 'ClsType', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100097, '< >', 'FacialCode', '', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100110, '< >', 'ProgIndex', '', 'ProgIndex', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100189, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 201, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20100190, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20100191, '()', 'CREATERUSER', '()', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100192, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100193, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100194, '  ()', 'CREATEDATE', '  ()', ' ', 0, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20100211, ' /', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 201, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20100212, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 201, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20100213, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 201, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20101001, ' ', 'Id', '* ', 'Id', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101002, '    ', 'FUId', '    ', 'FUId', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101003, '', 'Kvsr', '', 'DestKvsrKey', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101004, '', 'Kvr', '', 'DestKvrKey', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101005, '', 'Kfsr', '', 'DestKfsr', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101006, '', 'Kesr', '', 'DestKesrKey', 0, 201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20101007, '', 'Kcsr', '', 'DestKcsrKey', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101008, '', 'SubKesr', '', 'DestSubKesrKey', 0, 201, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20101009, '', 'RegionCls', '', 'RegionCls', 0, 201, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20101010, '', 'FactCode', '', 'DestFactCls', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101011, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101012, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101013, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101014, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101015, '', 'Month01', '', 'Month01', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101016, '', 'Month02', '', 'Month02', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101017, '', 'Month03', '', 'Month03', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101018, '', 'Month04', '', 'Month04', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101019, '', 'Month05', '', 'Month05', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101020, '', 'Month06', '', 'Month06', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101021, '', 'Month07', '', 'Month07', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101022, '', 'Month08', '', 'Month08', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101023, '', 'Month09', '', 'Month09', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101024, '', 'Month10', '', 'Month10', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101025, '', 'Month11', '', 'Month11', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101026, '', 'Month12', '', 'Month12', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101027, '1', 'Quarter1', '1', 'Quarter1', 0, 201, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(20101028, '2', 'Quarter2', '2', 'Quarter2', 0, 201, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(20101029, '3', 'Quarter3', '3', 'Quarter3', 0, 201, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(20101030, '4', 'Quarter4', '4', 'Quarter4', 0, 201, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(20101031, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101032, '()', 'INN', '', 'DestOrgInn', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101033, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101034, '()', 'INN20', '', 'DestOrgKpp', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101035, '()', 'NAME', '', 'DestOrgNAME', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101036, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101037, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101038, '', 'NOTE', '', 'NOTE', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101039, '', 'Acc', '', 'DestAccountName', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101041, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101042, '  ', 'FINTYPECODE', ' . ', 'DestFINTYPECls', 0, 201, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20101043, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101044, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101058, '', 'OrgParent', '', ' ', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101060, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101061, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101062, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101063, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101070, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101082, '  ', 'CurQuarter', '', ' ', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101083, '1-  ', 'CurMonth1', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101084, '2-  ', 'CurMonth2', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101085, '3-  ', 'CurMonth3', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101089, '', 'BudgetRef', '', 'BUDGETREF', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101090, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101091, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101092, '()', 'KCSRCode', '', 'DestKcsr', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101093, '()', 'KVRCode', '', 'DestKvr', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101094, '()', 'KVSRCode', '', 'DestKvsr', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101096, ' ()', 'TransfertOrg_Name', ' ()', ' ', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101097, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101098, '< >', 'KDCode', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101099, '< >', 'SubKD', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101100, '< >', 'IFSCode', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101101, '< >', 'IFS', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101102, '< >', 'KD', '', 'KD', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101103, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 201, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20101104, '< >', 'OnYearIncome', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101105, '< >', 'OnYearCharges', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101106, '< >', 'On3Year', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101107, '< >', 'On3YearIncome', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101108, '< >', 'On3YearCharges', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101109, '< >', 'FundsSource', '', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101111, ' ()', 'Org_Ref', '  . .', 'Org_Ref_Det', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101112, ' ', 'ClsType', '', 'ClsType', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101113, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101114, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101115, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101116, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101117, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101118, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101186, ' .  ()', 'FINTYPE', '  ', 'DestFinTypeClsKey', 0, 201, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20101187, ' ()', 'Fact', '', 'DestFactClsKey', 0, 201, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20101188, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 0, 201, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20101189, '', 'InvestObject', '', 'InvestObjectKey', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101190, '', 'InvestObjectCode', '', 'InvestObject', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101191, ' () ', 'KVRCORR', ' () ', 'KVRCORRKey', 0, 201, 1, 1, '', 0, 17461, 0, 1, '') ;

CALL ImportField(20101192, ' ()', 'KVRCORRCode', ' ()', 'KVRCORR', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101193, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20101194, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20101196, '  ', 'SUMMAYEAR4', '  ', 'SUMMAYEAR4', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101197, ' ', 'SUMMAOTHERYEARS', ' ', 'SUMMAOTHERYEARS', 0, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20101198, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 201, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20101199, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 201, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20101200, '()', 'CREATERUSER', '()', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101201, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101202, '  ()', 'CREATEDATE', '  ()', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101203, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101206, '()', 'KESRCODE', '()', 'DestKesr', 0, 201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20101208, '()', 'SubKesrCode', '()', 'DestSubKesr', 0, 201, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20101209, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20101212, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 201, 1, 0, '', 0, 26617, 0, 0, '') ;

--    (), (1)
CALL ImportField(20110018, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 201, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20110069, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 201, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20110074, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 201, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(20110091, ' /', 'FacialCodeEx', ' /', 'FacialAccClsFacialCodeEx', 1, 201, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20110092, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 201, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20110093, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 201, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20111004, '', 'Kvsr', '', 'DestKvsrKey', 1, 201, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20111005, '', 'Kvr', '', 'DestKvrKey', 1, 201, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20111006, '()', 'Kfsr', '', 'DestKfsr', 1, 201, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20111007, '', 'Kesr', '', 'DestKesrKey', 1, 201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20111008, '', 'KCSR', '', 'DestKcsrKey', 1, 201, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20111009, '', 'SubKesr', '', 'DestSubKesrKey', 1, 201, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20111050, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 201, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20111064, ' () ', 'KVRCORR', ' () ', 'KVRCORRKey', 1, 201, 1, 1, '', 0, 17461, 0, 1, '') ;

CALL ImportField(20111084, '', 'KCSRCode', '()', 'DestKcsr', 1, 201, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20111085, '()', 'KVRCode', '()', 'DestKvr', 1, 201, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20111086, '()', 'KVSRCode', '()', 'DestKvsr', 1, 201, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20111092, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 201, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20111094, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 201, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20111193, ' ()', 'KVRCORRCode', ' ()', 'KVRCORR', 1, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20111205, '()', 'KESRCODE', '()', 'DestKesr', 1, 201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20111207, '()', 'SubKesrCode', '()', 'DestSubKesr', 1, 201, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20111210, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 201, 1, 0, '', 0, 26617, 0, 0, '') ;

--    (), +(2)
CALL ImportField(20110094, '  -', '', '  -', 'DestOrgShortName', 2, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20110095, '  - ', '', '  - ', 'TransfertOrgShortName', 2, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111214, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20111215, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 201, 1, 1, '', 0, null, 0, 0, '') ;

--  (), (0)
CALL ImportField(20200015, ' ', 'Dat', ' ', 'Dat', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200016, ' ', 'Id', ' ', 'Id', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200017, '    ', 'FUId', '    ', 'FUId', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200018, ' ', 'DocDat', ' ', 'DocDat', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200019, '', 'Note', '', 'Note', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200020, ' ', 'Note1', ' ', 'Note1', 0, 202, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20200021, ' ', 'Note2', ' ', 'Note2', 0, 202, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20200022, ' ', 'NotifyType', ' ', 'NotifyType', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200023, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 202, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20200024, '', 'Variant', '', 'Variant', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200025, '', 'Number', '', 'Number', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200026, ' ', 'DocNumber', ' ', 'DocNumber', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200027, ' ', 'DateInput', ' ', 'DateInput', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200028, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200029, ' ', 'RejectCls', ' ', 'RejectCls', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200030, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200031, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 202, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20200032, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200033, ' ', 'OrgName', ' ', 'DestOrgName', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200034, ' ()', 'DocBaseParent', ' ()', ' ', 0, 202, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20200035, '', 'DocStateName', '', 'DocStateName', 0, 202, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20200036, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200037, ' ', 'IsVised', ' ', 'IsVised', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200038, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200039, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200040, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200041, '  ', ' ', '  ', 'LastExtrChange', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200043, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 202, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20200080, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 202, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20200089, '  , ', 'Ba_Lbo_Flag', '  , ', 'Ba_Lbo_Flag', 0, 202, 0, 0, '_', 0, null, 0, 0, '') ;

CALL ImportField(20200094, '  (.)', 'ClsType', '', 'ClsType', 0, 202, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20200096, '', 'BUDGETREF', '', 'BudgetRef', 0, 202, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20200109, '  ()', 'ProgIndex', '', 'ProgIndex', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200120, '/ ', 'FacialCode', '', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200121, '< >', 'KPPeriod', '', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200131, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 202, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20200132, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 202, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20200133, '()', 'CREATERUSER', '()', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200134, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200135, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200136, '  ()', 'CREATEDATE', '  ()', ' ', 0, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20200156, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 202, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20200157, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 202, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20200158, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 202, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20201001, '4', 'Quarter4', '4', 'Quarter4', 0, 202, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(20201002, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201003, '( )', 'INN', '( )', 'DestOrgInn', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201004, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201005, '( )', 'INN20', '( )', 'DestOrgKpp', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201006, '( )', 'NAME', '( )', 'DestOrgNAME', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201007, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201008, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201009, '', 'NOTE', '', 'NOTE', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201010, '', 'Acc', '', 'DestAccountName', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201012, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201013, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 202, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20201014, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201044, ' ', 'Id', '* ', 'Id', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201045, '    ', 'FUId', '    ', 'FUId', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201046, '', 'Kvsr', '()', 'DestKvsrKey', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201047, '', 'Kvr', '()', 'DestKvrKey', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201048, '', 'Kfsr', '', 'DestKfsr', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201049, '', 'Kesr', '', 'DestKesrKey', 0, 202, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20201050, '', 'KCSR', '()', 'DestKcsrKey', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201051, '', 'SubKESR', '', 'DestSubKesrKey', 0, 202, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20201052, ' ', 'RegionCls', ' ', 'RegionCls', 0, 202, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20201053, '', 'FactCode', '', 'DestFactCls', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201054, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201055, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201056, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201057, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201058, '', 'Month01', '', 'Month01', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201059, '', 'Month02', '', 'Month02', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201060, '', 'Month03', '', 'Month03', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201061, '', 'Month04', '', 'Month04', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201062, '', 'Month05', '', 'Month05', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201063, '', 'Month06', '', 'Month06', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201064, '', 'Month07', '', 'Month07', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201065, '', 'Month08', '', 'Month08', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201066, '', 'Month09', '', 'Month09', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201067, '', 'Month10', '', 'Month10', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201068, '', 'Month11', '', 'Month11', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201069, '', 'Month12', '', 'Month12', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201070, '1', 'Quarter1', '1', 'Quarter1', 0, 202, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(20201071, '2', 'Quarter2', '2', 'Quarter2', 0, 202, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(20201072, '3', 'Quarter3', '3', 'Quarter3', 0, 202, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(20201073, ' ', 'OrgParent', ' ', ' ', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201074, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201075, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 202, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20201076, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 202, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20201077, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 202, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20201078, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201079, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201090, '  ', 'CurQuarter', '', ' ', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201091, '1-  ', 'CurMonth1', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201092, '2-  ', 'CurMonth2', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201093, '3-  ', 'CurMonth3', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201097, '', 'BUDGETREF', '', 'BUDGETREF', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201098, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201099, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201100, '()', 'KCSRCode', '', 'DestKcsr', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201101, '()', 'KVRCode', '', 'DestKvr', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201102, '()', 'KVSRCode', '', 'DestKvsr', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201103, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 202, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20201104, '  (.)', 'ClsType', ' ', 'ClsType', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201108, '  ()', 'Org_Ref', '', 'Org_Ref_Det', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201109, '< >', 'KDCode', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201110, '< >', 'SubKD', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201111, '< >', 'IFSCode', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201112, '< >', 'IFS', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201113, '< >', 'KD', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201114, '< >', 'OnYearIncome', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201115, '< >', 'OnYearCharges', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201116, '< >', 'On3Year', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201117, '< >', 'On3YearIncome', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201118, '< >', 'FundsSource', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201119, '< >', 'On3YearCharges', '', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201122, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201123, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201124, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201125, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201126, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201127, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201128, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 202, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20201129, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 202, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20201130, '()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 202, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20201131, '', 'InvestObjectCode', '', 'InvestObject', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201132, '', 'InvestObject', '', 'InvestObjectKey', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201133, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20201134, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201135, '  ', 'SUMMAYEAR4', '  ', 'SUMMAYEAR4', 0, 202, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20201136, ' ', 'SUMMAOTHERYEARS', ' ', 'SUMMAOTHERYEARS', 0, 202, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20201137, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 202, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20201138, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 202, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20201139, '()', 'CREATERUSER', '()', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201140, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201141, '  ()', 'CREATEDATE', '  ()', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201142, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20201147, ' ()', 'TransfertOrg_Name', ' ()', 'TransfertOrgName', 0, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20201148, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 0, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20201151, '()', 'KESRCODE', '()', 'DestKesr', 0, 202, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20201153, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 202, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20201155, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 202, 1, 0, '', 0, 26617, 0, 0, '') ;

--  (), (1)
CALL ImportField(20210002, ' ', 'OrgName', ' ', 'DestOrgName', 1, 202, 0, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(20210012, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 202, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20210013, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 202, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20210017, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 202, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(20210099, ' /', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 202, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20210100, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 202, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20210101, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 202, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20211009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 202, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20211021, '', 'KVR', '()', 'DestKvrKey', 1, 202, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20211022, '', 'KVSR', '()', 'DestKvsrKey', 1, 202, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20211030, '()', 'KFSR', '()', 'DestKfsr', 1, 202, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20211031, '', 'KCSR', '()', 'DestKcsrKey', 1, 202, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20211032, '', 'KESR', '', 'DestKesrKey', 1, 202, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20211067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 202, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20211092, '()', 'KCSRCode', '()', 'DestKcsr', 1, 202, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20211093, '()', 'KVRCode', '()', 'DestKvr', 1, 202, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20211094, '()', 'KVSRCode', '()', 'DestKvsr', 1, 202, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20211100, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 202, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20211102, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 202, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20211143, ' ()', 'TransfertOrg_INN', ' ()', 'TransfertOrgINN', 1, 202, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(20211144, ' ()', 'TransfertOrg_INN20', ' ()', 'TransfertOrgKPP', 1, 202, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(20211145, ' ()', 'TransfertOrg_Name', ' ()', 'TransfertOrgName', 1, 202, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20211146, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 1, 202, 1, 1, '', 0, 29463, 0, 1, '') ;

CALL ImportField(20211149, ' ()', 'TransfertOrg_CalcName', ' () ( )', ' ', 1, 202, 1, 0, '', 1, null, 0, 0, '') ;

CALL ImportField(20211150, '()', 'KESRCODE', '()', 'DestKesr', 1, 202, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20211152, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 202, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20211154, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 202, 1, 0, '', 0, 26617, 0, 0, '') ;

--  (), +(2)
CALL ImportField(20211159, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 202, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20211160, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 202, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (0)
CALL ImportField(20300015, ' ', 'Dat', ' ', 'Dat', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300016, ' ', 'Id', ' ', 'Id', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300017, '    ', 'FUId', '    ', 'FUId', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300018, ' ', 'DocDat', ' ', 'DocDat', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300019, '', 'Note', '', 'Note', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300020, ' ', 'Note1', ' ', 'Note1', 0, 203, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20300021, ' ', 'Note2', ' ', 'Note2', 0, 203, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20300022, ' ', 'NotifyType', ' ', 'NotifyType', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300023, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 203, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20300024, '', 'Variant', '', 'Variant', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300026, ' ', 'DocNumber', ' ', 'DocNumber', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300027, ' ', 'DateInput', ' ', 'DateInput', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300029, ' ', 'RejectCls', ' ', 'RejectCls', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300031, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 203, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20300032, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300034, ' ()', 'DocBaseParent', ' ()', ' ', 0, 203, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20300035, '', 'DocStateName', '', 'DocStateName', 0, 203, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20300036, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300037, ' ', 'IsVised', ' ', 'IsVised', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300038, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300039, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300040, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300043, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 203, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20300079, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 203, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20300080, '', 'KPPERIOD', '', 'KPPERIOD', 0, 203, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20300108, '', 'Number', '', 'Number', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300113, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300116, ' ', 'OrgName', ' ', 'DestOrgName', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300118, '', 'BUDGETREF', '', 'BudgetRef', 0, 203, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20300119, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300120, '  (.)', 'ClsType', '', 'ClsType', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300121, '/ ', 'FacialCode', '', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300123, '< >', 'ProgIndex', '', 'ProgIndex', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300124, '  ()', 'OrgRef', '', 'DestOrgRef', 0, 203, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20300149, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 203, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20300150, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 203, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20300151, '()', 'CREATERUSER', '()', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300152, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300153, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300154, '  ()', 'CREATEDATE', '  ()', ' ', 0, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20300164, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 203, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20300165, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 203, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20300166, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 203, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20301001, '4', 'Quarter4', '4', 'Quarter4', 0, 203, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(20301002, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301009, '', 'NOTE', '', 'NOTE', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301014, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301044, ' ', 'Id', '* ', 'Id', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301045, '    ', 'FUId', '    ', 'FUId', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301052, ' ', 'RegionCls', ' ', 'RegionCls', 0, 203, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20301056, '   .', 'Acc_ref', '   .', 'DestAccount', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301057, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301058, '', 'Month01', '', 'Month01', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301059, '', 'Month02', '', 'Month02', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301060, '', 'Month03', '', 'Month03', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301061, '', 'Month04', '', 'Month04', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301062, '', 'Month05', '', 'Month05', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301063, '', 'Month06', '', 'Month06', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301064, '', 'Month07', '', 'Month07', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301065, '', 'Month08', '', 'Month08', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301066, '', 'Month09', '', 'Month09', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301067, '', 'Month10', '', 'Month10', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301068, '', 'Month11', '', 'Month11', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301069, '', 'Month12', '', 'Month12', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301070, '1', 'Quarter1', '1', 'Quarter1', 0, 203, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(20301071, '2', 'Quarter2', '2', 'Quarter2', 0, 203, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(20301072, '3', 'Quarter3', '3', 'Quarter3', 0, 203, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(20301073, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301074, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301075, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301076, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301077, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301078, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301081, '  ', 'CurQuarter', '', ' ', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301082, '1-  ', 'CurMonth1', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301083, '2-  ', 'CurMonth2', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301084, '3-  ', 'CurMonth3', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301085, '', 'Kfsr', '', 'DestKfsr', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301086, '', 'Kesr', '', 'DestKesrKey', 0, 203, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20301087, '', 'KCSR', '()', 'DestKcsrKey', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301088, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301089, '', 'Kvsr', '()', 'DestKvsrKey', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301090, '', 'Kvr', '()', 'DestKvrKey', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301091, '', 'SubKESR', '', 'DestSubKesrKey', 0, 203, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20301092, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301093, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 203, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20301094, '', 'FactCode', '', 'DestFactCls', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301095, '', 'Acc', '', 'DestAccountName', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301096, '( )', 'INN', '( )', 'DestOrgInn', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301097, '( )', 'INN20', '( )', 'DestOrgKpp', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301098, '( )', 'NAME', '( )', 'DestOrgNAME', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301099, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301100, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301117, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301119, '', 'BUDGETREF', '', 'BUDGETREF', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301120, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301121, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301122, '()', 'KCSRCode', '', 'DestKcsr', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301123, '()', 'KVRCode', '', 'DestKvr', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301124, '()', 'KVSRCode', '', 'DestKvsr', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301125, '< >', 'SubKD', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301126, '< >', 'IFSCode', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301127, '< >', 'IFS', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301128, '< >', 'KD', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301129, ' ', 'OrgParent', ' ', ' ', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301130, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 203, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20301131, '< >', 'OnYearIncome', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301132, '< >', 'OnYearCharges', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301133, '< >', 'On3Year', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301134, '< >', 'On3YearIncome', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301135, '< >', 'On3YearCharges', '', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301137, '  (.)', 'ClsType', '', 'ClsType', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301138, '< >', 'KDCode', '', ' ', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301139, '', 'Org_Ref', '', 'Org_Ref_Det', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301140, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301141, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301142, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301143, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301144, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301145, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301146, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 203, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20301147, ' .  ()', 'FINTYPE', '   ()', 'DestFINTYPEClsKey', 0, 203, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20301148, '()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 203, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20301149, '', 'InvestObjectCode', '', 'InvestObject', 0, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20301150, '', 'InvestObject', '', 'InvestObjectKey', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301151, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20301152, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20301153, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 203, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20301154, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 203, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20301155, '()', 'CREATERUSER', '()', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301156, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301157, '  ()', 'CREATEDATE', '  ()', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301158, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20301160, '()', 'KESRCODE', '()', 'DestKesr', 0, 203, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20301162, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 203, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20301165, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 203, 1, 0, '', 0, 26617, 0, 0, '') ;

--   (), (1)
CALL ImportField(20310002, ' ', 'OrgName', ' ', 'DestOrgName', 1, 203, 0, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(20310012, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 203, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20310013, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 203, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20310017, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 203, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(20310069, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 203, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20310081, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 203, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20310163, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 203, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20310164, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 203, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20310165, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 203, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20311009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 203, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20311021, '', 'KVR', '()', 'DestKvrKey', 1, 203, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20311022, '', 'KVSR', '()', 'DestKvsrKey', 1, 203, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20311030, '()', 'KFSR', '()', 'DestKfsr', 1, 203, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20311031, '', 'KCSR', '()', 'DestKcsrKey', 1, 203, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20311032, '', 'KESR', '', 'DestKesrKey', 1, 203, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20311067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 203, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20311083, '()', 'KCSRCode', '()', 'DestKcsr', 1, 203, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20311084, '()', 'KVRCode', '()', 'DestKvr', 1, 203, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20311085, '()', 'KVSRCode', '()', 'DestKvsr', 1, 203, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20311088, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 203, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20311089, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 203, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20311093, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 203, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20311159, '()', 'KESRCODE', '()', 'DestKesr', 1, 203, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20311161, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 203, 1, 0, '', 0, 43610, 0, 1, '') ;

--   (), +(2)
CALL ImportField(20311167, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 203, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20311168, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 203, 1, 1, '', 0, null, 0, 0, '') ;

--  , , (0)
CALL ImportField(20400015, ' ', 'Dat', ' ', 'Dat', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400016, ' ', 'Id', ' ', 'Id', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400017, '    ', 'FUId', '    ', 'FUId', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400018, ' ', 'DocDat', ' ', 'DocDat', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400019, '', 'Note', '', 'Note', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400020, ' ', 'Note1', ' ', 'Note1', 0, 204, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20400021, ' ', 'Note2', ' ', 'Note2', 0, 204, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20400022, ' ', 'NotifyType', ' ', 'NotifyType', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400023, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 204, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20400024, '', 'Variant', '', 'Variant', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400025, '', 'Number', '', 'Number', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400026, ' ', 'DocNumber', ' ', 'DocNumber', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400027, ' ', 'DateInput', ' ', 'DateInput', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400028, ' ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400029, ' ', 'RejectCls', ' ', 'RejectCls', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400030, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400031, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 204, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20400032, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400033, ' ', 'OrgName', '', 'DestOrgName', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400034, ' ()', 'DocBaseParent', ' ()', ' ', 0, 204, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20400035, '', 'DocStateName', '', 'DocStateName', 0, 204, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20400036, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400037, ' ', 'IsVised', ' ', 'IsVised', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400038, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400039, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400040, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400041, '  ', ' ', '  ', 'LastExtrChange', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400043, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 204, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20400079, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 204, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20400085, '', 'BUDGETREF', '', 'BudgetRef', 0, 204, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20400086, '/ ', 'FacialCode', '', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400090, '  (.)', 'ProgIndex', '', 'ProgIndex', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400091, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400092, '< >', 'KPPeriod', '', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400093, '  (.)', 'ClsType', '', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400136, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 204, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20400137, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 204, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20400138, '()', 'CREATERUSER', '()', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400139, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400140, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400141, '  ()', 'CREATEDATE', '  ()', ' ', 0, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20400144, ' /', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 204, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20400157, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 204, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20400158, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 204, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20401001, '4', 'Quarter4', '4', 'Quarter4', 0, 204, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(20401002, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401003, '()', 'INN', '()', 'DestOrgInn', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401004, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401005, '()', 'INN20', '()', 'DestOrgKpp', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401006, '()', 'NAME', '()', 'DestOrgNAME', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401007, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401008, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401009, '', 'NOTE', '', 'NOTE', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401010, '', 'Acc', '', 'DestAccountName', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401012, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401013, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 204, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(20401014, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401044, ' ', 'Id', '* ', 'Id', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401045, '    ', 'FUId', '    ', 'FUId', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401046, '', 'Kvsr', '()', 'DestKvsrKey', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401047, '', 'Kvr', '()', 'DestKvrKey', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401048, '', 'Kfsr', '', 'DestKfsr', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401049, '', 'Kesr', '', 'DestKesrKey', 0, 204, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20401050, '', 'KCSR', '()', 'DestKcsrKey', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401051, '', 'SubKESR', '', 'DestSubKesrKey', 0, 204, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20401052, ' ', 'RegionCls', ' ', 'RegionCls', 0, 204, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20401053, '', 'FactCode', '', 'DestFactCls', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401054, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401055, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401056, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401057, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401058, '', 'Month01', '', 'Month01', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401059, '', 'Month02', '', 'Month02', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401060, '', 'Month03', '', 'Month03', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401061, '', 'Month04', '', 'Month04', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401062, '', 'Month05', '', 'Month05', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401063, '', 'Month06', '', 'Month06', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401064, '', 'Month07', '', 'Month07', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401065, '', 'Month08', '', 'Month08', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401066, '', 'Month09', '', 'Month09', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401067, '', 'Month10', '', 'Month10', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401068, '', 'Month11', '', 'Month11', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401069, '', 'Month12', '', 'Month12', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401070, '1', 'Quarter1', '1', 'Quarter1', 0, 204, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(20401071, '2', 'Quarter2', '2', 'Quarter2', 0, 204, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(20401072, '3', 'Quarter3', '3', 'Quarter3', 0, 204, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(20401073, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401074, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401075, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401076, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401077, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401078, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401084, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401086, '', 'BUDGETREF', '', 'BUDGETREF', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401087, '< >', 'CurQuarter', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401088, '< >', 'CurMonth1', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401089, '< >', 'CurMonth2', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401104, '  ()', 'TransfertCls', '   ()', 'TransfertCls', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401105, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401106, '()', 'KCSRCode', '', 'DestKcsr', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401107, '()', 'KVRCode', '', 'DestKvr', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401108, '()', 'KVSRCode', '', 'DestKvsr', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401109, '. ', 'SUBKD', '. ', 'SubKd', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401110, ' ()', 'KD', '', 'KD', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401111, '', 'KDCode', '', 'KDValue', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401113, ' .  . . ()', 'IFS', ' ', 'IFS', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401114, ' .  . .', 'IFSCode', ' .  . .', 'IFS_FinSourceValue', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401115, '', 'OrgParent', '', ' ', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401116, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 204, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20401117, '< >', 'CurMonth3', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401118, '  ', 'OnYearIncome', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401119, '  ', 'OnYearCharges', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401120, '  3 ', 'On3Year', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401121, '  3 ', 'On3YearIncome', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401122, '  3 ', 'On3YearCharges', '', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401123, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401124, '  (.)', 'ClsType', '', 'ClsType', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401125, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401126, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401127, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401128, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401129, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401130, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401131, '  ', 'SubsidyClsOld', '', ' ', 0, 204, 1, 1, '', 0, 27836, 0, 0, '') ;

CALL ImportField(20401132, '  ', 'SubsidyClsOldCode', '', ' ', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401133, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 204, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20401134, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 204, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20401135, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 204, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20401137, '', 'InvestObjectCode', '', 'InvestObject', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401138, '', 'InvestObject', '', 'InvestObjectKey', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401139, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20401140, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20401141, ' ', 'SUMMAOTHERYEARS', ' ', 'SUMMAOTHERYEARS', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401142, '  ', 'SUMMAYEAR4', '  ', 'SUMMAYEAR4', 0, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20401143, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 204, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20401145, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 204, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20401146, '()', 'CREATERUSER', '()', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401147, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401148, '  ()', 'CREATEDATE', '  ()', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401149, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20401150, '()', 'KESRCODE', '()', 'DestKesr', 0, 204, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20401153, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 204, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20401155, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 204, 1, 0, '', 0, 26617, 0, 0, '') ;

--  , , (1)
CALL ImportField(20410012, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 204, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20410013, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 204, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20410017, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 204, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(20410069, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 204, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20410086, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 204, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20410107, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 204, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20410108, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 204, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20410109, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 204, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20411009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 204, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20411021, '', 'KVR', '()', 'DestKvrKey', 1, 204, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20411022, '', 'KVSR', '()', 'DestKvsrKey', 1, 204, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20411030, '()', 'KFSR', '()', 'DestKfsr', 1, 204, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20411031, '', 'KCSR', '()', 'DestKcsrKey', 1, 204, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20411032, '', 'KESR', '', 'DestKesrKey', 1, 204, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20411067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 204, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20411071, ' . ', 'FINTYPECODE', '  ', 'DestFINTYPECls', 1, 204, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(20411095, '()', 'KCSRCode', '()', 'DestKcsr', 1, 204, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20411099, '()', 'KVRCode', '()', 'DestKvr', 1, 204, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20411100, '()', 'KVSRCode', '()', 'DestKvsr', 1, 204, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20411108, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 204, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20411111, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 204, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20411115, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 204, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20411116, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 1, 204, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20411151, '()', 'KESRCODE', '()', 'DestKesr', 1, 204, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20411152, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 204, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20411154, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 204, 1, 0, '', 0, 26617, 0, 0, '') ;

--  , , +(2)
CALL ImportField(20411159, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 204, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20411160, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 204, 1, 1, '', 0, null, 0, 0, '') ;

-- , (0)
CALL ImportField(20500001, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 205, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20500002, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500003, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500005, '  ()', 'CREATEDATE', '  ()', ' ', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500006, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500007, ' ', 'IsVised', ' ', 'IsVised', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20500008, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501096, '', 'InvestObjectCode', '', 'InvestObject', 0, 205, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20501097, '', 'InvestObject', '', 'InvestObjectKey', 0, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501098, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 205, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20501099, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 205, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20501100, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 205, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20501101, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501102, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501103, '  ()', 'CREATEDATE', '  ()', ' ', 0, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501104, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20501120, ' ', 'BudAllocationClsCode', '  ()', 'BudAllocationClsCode', 0, 205, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20501121, ' ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 0, 205, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20501122, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 205, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20501123, '()', 'KVRCode', ' ()', 'DestKvr', 0, 205, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20501124, '', 'KVR', ' ()', 'DestKvrKey', 0, 205, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20501125, ' . ', 'FINTYPECode', '   ()', 'DestFINTYPECls', 0, 205, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(20501126, ' .  ()', 'FINTYPE', '   ()', 'DestFINTYPEClsKey', 0, 205, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20501127, '  ', 'PayPromiseClsCode', '   ()', 'PayPromiseClsCode', 0, 205, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20501128, '  ', 'PayPromiseCls', '   ()', 'PayPromiseCls', 0, 205, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20501129, ' ', 'TargetClsCode', '  ()', 'TargetCls', 0, 205, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20501130, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 205, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20501131, '()', 'KVSRCode', ' ()', 'DestKvsr', 0, 205, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20501132, '', 'KVSR', ' ()', 'DestKvsrKey', 0, 205, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20501133, '()', 'KESRCODE', ' ()', 'DestKesr', 0, 205, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20501134, '', 'KESR', ' ()', 'DestKesrKey', 0, 205, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20501135, '', 'FACTCODE', ' ()', 'DestFactCls', 0, 205, 1, 0, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20501136, ' ()', 'FACT', ' ()', 'DestFactClsKey', 0, 205, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20501137, '', 'DirectionCLSCode', ' ()', 'DestDirectionCLS', 0, 205, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20501138, ' ()', 'DirectionCLS', ' ()', 'DestDirectionCLSKey', 0, 205, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20501139, ' ', 'REGIONCLS', '', 'RegionCls', 0, 205, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(20501140, '()', 'KFSR', '()', 'DestKfsr', 0, 205, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20501141, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 205, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20501142, '', 'SUBKESR', '', 'DestSubKesrKey', 0, 205, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20501143, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 205, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20501144, '()', 'KCSRCode', ' ()', 'DestKcsr', 0, 205, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20501145, '', 'KCSR', ' ()', 'DestKcsrKey', 0, 205, 1, 1, '', 0, 17413, 0, 1, '') ;

-- , (1)
CALL ImportField(20510013, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 205, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20510014, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 205, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20510121, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 205, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20510122, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 205, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20511007, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 205, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20511022, '', 'KVR', '()', 'DestKvrKey', 1, 205, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20511023, '', 'KVSR', '()', 'DestKvsrKey', 1, 205, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20511031, '()', 'KFSR', '()', 'DestKfsr', 1, 205, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20511032, '', 'KCSR', '()', 'DestKcsrKey', 1, 205, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20511033, '', 'KESR', '', 'DestKesrKey', 1, 205, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20511034, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 205, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20511037, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 205, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20511065, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 205, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20511090, '()', 'KCSRCode', '()', 'DestKcsr', 1, 205, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20511092, '()', 'KVRCode', '()', 'DestKvr', 1, 205, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20511093, '()', 'KVSRCode', '()', 'DestKvsr', 1, 205, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20511096, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 205, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20511098, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 205, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20511102, ' ()', 'DirectionCLS', ' ()', 'DestDirectionCLSKey', 1, 205, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20511103, ' ()', 'FACT', '', 'DestFactClsKey', 1, 205, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20511118, '()', 'KESRCODE', '()', 'DestKesr', 1, 205, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20511119, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 205, 1, 0, '', 0, 43610, 0, 1, '') ;

-- , +(2)
CALL ImportField(20511146, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 205, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20511147, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 205, 1, 1, '', 0, null, 0, 0, '') ;

--    (), (0)
CALL ImportField(20600001, ' ', 'Dat', ' ', 'Dat', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600002, ' ', 'Id', ' ', 'Id', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600003, '    ', 'FUId', '    ', 'FUId', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600004, ' ', 'DocDat', ' ', 'DocDat', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600005, '', 'Note', '', 'Note', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600006, ' ', 'Note1', ' ', 'Note1', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600007, ' ', 'Note2', ' ', 'Note2', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600008, ' ', 'NotifyType', ' ', 'NotifyType', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600009, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 206, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20600010, '', 'Variant', '', 'Variant', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600011, '', 'Number', '', 'Number', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600012, ' ', 'DocNumber', ' ', 'DocNumber', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600013, ' ', 'DateInput', ' ', 'DateInput', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600014, ' ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600015, ' ', 'RejectCls', ' ', 'RejectCls', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600016, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600017, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 206, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20600018, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600019, ' ', 'OrgName', ' ', 'DestOrgName', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600020, ' ()', 'DocBaseParent', ' ()', ' ', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600021, '', 'DocStateName', '', 'DocStateName', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600022, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600023, ' ', 'IsVised', ' ', 'IsVised', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600024, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600025, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600026, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600027, '  ', ' ', '  ', 'LastExtrChange', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600028, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600029, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 206, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20600030, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 206, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20600088, '', 'KPPERIOD', '', 'KPPERIOD', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600093, '', 'BUDGETREF', '', 'BudgetRef', 0, 206, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20600094, '  (.)', 'ClsType', '', 'ClsType', 0, 206, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20600095, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600096, '/ ', 'FacialCode', '', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600109, '  ()', 'ProgIndex', '', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600189, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 206, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20600190, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 206, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20600191, '()', 'CREATERUSER', '()', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600192, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600193, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600194, '  ()', 'CREATEDATE', '  ()', ' ', 0, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20600204, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 206, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20600205, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 206, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20600206, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 206, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20601031, '4', 'Quarter4', '4', 'Quarter4', 0, 206, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(20601032, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601033, '()', 'INN', '()', 'DestOrgInn', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601034, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601035, '()', 'INN20', '()', 'DestOrgKpp', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601036, '()', 'NAME', '()', 'DestOrgNAME', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601037, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601039, '', 'NOTE', '', 'NOTE', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601040, '', 'Acc', '', 'DestAccountName', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601042, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601043, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 206, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20601044, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601045, ' ', 'Id', '* ', 'Id', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601046, '    ', 'FUId', '    ', 'FUId', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601047, '', 'Kvsr', '()', 'DestKvsrKey', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601048, '', 'Kvr', '()', 'DestKvrKey', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601049, '', 'Kfsr', '', 'DestKfsr', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601050, '', 'Kesr', '', 'DestKesrKey', 0, 206, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20601051, '', 'KCSR', '()', 'DestKcsrKey', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601052, '', 'SubKESR', '', 'DestSubKesrKey', 0, 206, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20601053, ' ', 'RegionCls', ' ', 'RegionCls', 0, 206, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20601054, '', 'FactCode', '', 'DestFactCls', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601055, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601056, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601057, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601058, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601059, '', 'Month01', '', 'Month01', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601060, '', 'Month02', '', 'Month02', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601061, '', 'Month03', '', 'Month03', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601062, '', 'Month04', '', 'Month04', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601063, '', 'Month05', '', 'Month05', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601064, '', 'Month06', '', 'Month06', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601065, '', 'Month07', '', 'Month07', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601066, '', 'Month08', '', 'Month08', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601067, '', 'Month09', '', 'Month09', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601068, '', 'Month10', '', 'Month10', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601069, '', 'Month11', '', 'Month11', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601070, '', 'Month12', '', 'Month12', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601071, '1', 'Quarter1', '1', 'Quarter1', 0, 206, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(20601072, '2', 'Quarter2', '2', 'Quarter2', 0, 206, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(20601073, '3', 'Quarter3', '3', 'Quarter3', 0, 206, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(20601074, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601075, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601076, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601077, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601078, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601079, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601089, '  ', 'CurQuarter', '', ' ', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601090, '1-  ', 'CurMonth1', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601091, '2-  ', 'CurMonth2', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601092, '3-  ', 'CurMonth3', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601094, '', 'BUDGETREF', '', 'BUDGETREF', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601095, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601096, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601097, '()', 'KCSRCode', '', 'DestKcsr', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601098, '()', 'KVRCode', '', 'DestKvr', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601099, '()', 'KVSRCode', '', 'DestKvsr', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601102, '', 'OrgParent', '', ' ', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601103, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 206, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20601104, '  (.)', 'ClsType', ' ', 'ClsType', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601108, '', 'Org_Ref', '', 'Org_Ref_Det', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601109, '< >', 'KDCode', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601110, '< >', 'SubKD', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601111, '< >', 'IFSCode', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601112, '< >', 'IFS', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601113, '< >', 'KD', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601114, '< >', 'OnYearIncome', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601115, '< >', 'OnYearCharges', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601116, '< >', 'On3Year', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601117, '< >', 'On3YearIncome', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601118, '< >', 'FundsSource', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601119, '< >', 'On3YearCharges', '', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601120, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601121, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601122, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601123, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601124, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601125, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601126, ' ()', 'TransfertOrg_Name', '', ' ', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601127, ' ()', 'TransfertOrg_Ref', '', 'TransfertOrg_Ref', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601186, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 206, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20601187, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 206, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20601188, '', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 206, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20601189, '', 'InvestObjectCode', '', 'InvestObject', 0, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20601190, '', 'InvestObject', '', 'InvestObjectKey', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601191, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20601192, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20601193, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 206, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20601194, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 206, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20601195, '()', 'CREATERUSER', '()', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601196, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601197, '  ()', 'CREATEDATE', '  ()', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601198, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20601200, '()', 'KESRCODE', '()', 'DestKesr', 0, 206, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20601202, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 206, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20601205, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 206, 1, 0, '', 0, 26617, 0, 0, '') ;

--    (), (1)
CALL ImportField(20610013, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 206, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20610014, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 206, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20610203, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 206, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20610204, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 206, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20610205, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 206, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20611010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 206, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20611022, '', 'KVR', '()', 'DestKvrKey', 1, 206, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20611023, '', 'KVSR', '()', 'DestKvsrKey', 1, 206, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20611031, '()', 'KFSR', '()', 'DestKfsr', 1, 206, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20611032, '', 'KCSR', '()', 'DestKcsrKey', 1, 206, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20611033, '', 'KESR', '', 'DestKesrKey', 1, 206, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20611068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 206, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20611091, '()', 'KCSRCode', '()', 'DestKcsr', 1, 206, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20611092, '()', 'KVRCode', '()', 'DestKvr', 1, 206, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20611093, '()', 'KVSRCode', '()', 'DestKvsr', 1, 206, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20611098, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 206, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20611099, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 206, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20611101, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 206, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20611199, '()', 'KESRCODE', '()', 'DestKesr', 1, 206, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20611201, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 206, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), +(2)
CALL ImportField(20611207, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 206, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20611208, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 206, 1, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(20700077, ' ', 'Dat', ' ', 'Dat', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700078, ' ', 'Id', ' ', 'Id', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700079, '    ', 'FUId', '    ', 'FUId', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700080, ' ', 'DocDat', ' ', 'DocDat', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700081, '', 'Note', '', 'Note', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700082, ' ', 'Note1', ' ', 'Note1', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700083, ' ', 'Note2', ' ', 'Note2', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700084, ' ', 'NotifyType', ' ', 'NotifyType', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700085, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 207, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20700086, '', 'Variant', '', 'Variant', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700087, '', 'Number', '', 'Number', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700088, ' ', 'DocNumber', ' ', 'DocNumber', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700089, ' ', 'DateInput', ' ', 'DateInput', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700090, ' ()', 'ORGREF', ' ()', 'DestOrgRef', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700091, ' ', 'RejectCls', ' ', 'RejectCls', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700092, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700093, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 207, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20700094, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700095, ' ', 'OrgName', ' ', 'DestOrgName', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700096, ' ()', 'DocBaseParent', ' ()', ' ', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700097, '', 'DocStateName', '', 'DocStateName', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700098, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700099, ' ', 'IsVised', ' ', 'IsVised', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700100, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700101, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700102, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700103, '  ', ' ', '  ', 'LastExtrChange', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700104, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700105, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 207, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20700106, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 207, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20700123, '< >', 'ProgIndex', '', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700158, '', 'KPPERIOD', '', 'KPPERIOD', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700160, '', 'BUDGETREF', '', 'BudgetRef', 0, 207, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20700162, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700163, '  (.)', 'ClsType', '', 'ClsType', 0, 207, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20700165, '/c ', 'FacialCode', '', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700209, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 207, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20700210, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 207, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20700211, '()', 'CREATERUSER', '()', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700212, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700213, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700214, '  ()', 'CREATEDATE', '  ()', ' ', 0, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20700227, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 207, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20700228, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 207, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20700229, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 207, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20701089, '< >', 'CurMonth2', '', ' ', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701107, '4', 'Quarter4', '4', 'Quarter4', 0, 207, 1, 0, '', 0, null, 0, 1, '4') ;

CALL ImportField(20701108, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701109, '()', 'INN', '()', 'DestOrgInn', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701110, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701111, '()', 'INN20', '()', 'DestOrgKpp', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701112, '()', 'NAME', '()', 'DestOrgNAME', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701113, '', 'DirectionCLSCODE', '', 'DestDirectionCLS', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701115, '', 'NOTE', '', 'NOTE', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701116, '', 'Acc', '', 'DestAccountName', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701117, ' ', 'ClsType', ' ', 'ClsType', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701118, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701119, ' . ', 'FINTYPECODE', '  ', 'DestFINTYPECls', 0, 207, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20701120, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701121, ' ', 'Id', '* ', 'Id', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701122, '    ', 'FUId', '    ', 'FUId', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701123, '', 'KVSR', '()', 'DestKvsrKey', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701124, '', 'KVR', '()', 'DestKvrKey', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701125, '', 'KFSR', '', 'DestKfsr', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701126, '', 'KESR', '', 'DestKesrKey', 0, 207, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20701127, '', 'KCSR', '()', 'DestKcsrKey', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701128, '', 'SUBKESR', '', 'DestSubKesrKey', 0, 207, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20701129, ' ', 'RegionCls', ' ', 'RegionCls', 0, 207, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20701130, '', 'FACTCODE', '', 'DestFactCls', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701131, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701132, '  ', 'FACIALCODE', '  ', 'DestFacialAccClsFacialCode', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701133, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701134, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701135, '', 'Month01', '', 'Month01', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701136, '', 'Month02', '', 'Month02', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701137, '', 'Month03', '', 'Month03', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701138, '', 'Month04', '', 'Month04', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701139, '', 'Month05', '', 'Month05', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701140, '', 'Month06', '', 'Month06', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701141, '', 'Month07', '', 'Month07', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701142, '', 'Month08', '', 'Month08', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701143, '', 'Month09', '', 'Month09', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701144, '', 'Month10', '', 'Month10', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701145, '', 'Month11', '', 'Month11', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701146, '', 'Month12', '', 'Month12', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701147, '1', 'Quarter1', '1', 'Quarter1', 0, 207, 1, 0, '', 0, null, 0, 1, '1') ;

CALL ImportField(20701148, '2', 'Quarter2', '2', 'Quarter2', 0, 207, 1, 0, '', 0, null, 0, 1, '2') ;

CALL ImportField(20701149, '3', 'Quarter3', '3', 'Quarter3', 0, 207, 1, 0, '', 0, null, 0, 1, '3') ;

CALL ImportField(20701150, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701151, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701152, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701153, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701154, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701155, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701159, '  ', 'CurMonth1', '', ' ', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701161, '', 'BUDGETREF', '', 'BUDGETREF', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701167, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701168, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701169, '()', 'KCSRCode', '', 'DestKcsr', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701170, '()', 'KVRCode', '', 'DestKvr', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701171, '()', 'KVSRCode', '', 'DestKvsr', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701172, '< >', 'KDCode', '', 'KDValue', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701173, '< >', 'SubKD', '', 'SUBKD', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701180, ' .  . . ()', 'IFS', ' ', 'IFS', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701183, ' .  . .', 'IFSCode', ' .  . .', 'IFS_FinSourceValue', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701184, '', 'OrgParent', '', ' ', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701185, '< >', 'KD', '', 'KD', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701186, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 207, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20701187, '< >', 'OnYearIncome', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701188, '< >', 'On3Year', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701189, '< >', 'On3YearCharges', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701190, '< >', 'On3YearIncome', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701192, '< >', 'OnYearCharges', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701193, '', 'Org_Ref', '', 'Org_Ref_Det', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701196, '< >', 'CurQuarter', '', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701197, '< >', 'CurMonth3', '', ' ', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701198, '< >', 'FundsSource', '', 'FUNDSSOURCE', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701199, '  ', 'StimateID', '  ', 'StimateID', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701200, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701201, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701202, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701203, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701204, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701205, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701206, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 207, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20701207, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 207, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20701208, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 207, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20701210, '', 'InvestObjectCode', '', 'InvestObject', 0, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20701211, '', 'InvestObject', '', 'InvestObjectKey', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701212, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20701213, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20701214, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 207, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20701215, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 207, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20701216, '()', 'CREATERUSER', '()', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701217, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701218, '  ()', 'CREATEDATE', '  ()', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701219, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701221, '()', 'KESRCODE', '()', 'DestKesr', 0, 207, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20701223, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 207, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20701224, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20701226, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 207, 1, 0, '', 0, 26617, 0, 0, '') ;

--   , (1)
CALL ImportField(20710013, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 207, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20710014, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 207, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20710175, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 207, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20710176, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 207, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20710177, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 207, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20711010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 207, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20711022, '', 'KVR', '()', 'DestKvrKey', 1, 207, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20711023, '', 'KVSR', '()', 'DestKvsrKey', 1, 207, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20711031, '()', 'KFSR', '()', 'DestKfsr', 1, 207, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20711032, '', 'KCSR', '()', 'DestKcsrKey', 1, 207, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20711033, '', 'KESR', '', 'DestKesrKey', 1, 207, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20711068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 207, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20711163, '()', 'KCSRCode', '()', 'DestKcsr', 1, 207, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20711164, '()', 'KVRCode', '()', 'DestKvr', 1, 207, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20711165, '()', 'KVSRCode', '()', 'DestKvsr', 1, 207, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20711176, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 207, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20711180, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 207, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20711220, '()', 'KESRCODE', '()', 'DestKesr', 1, 207, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20711222, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 207, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20711225, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 207, 1, 0, '', 0, 26617, 0, 0, '') ;

--   , +(2)
CALL ImportField(20711230, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 207, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20711231, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 207, 1, 1, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(20800077, ' ', 'Dat', ' ', 'Dat', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800078, ' ', 'Id', ' ', 'Id', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800079, '    ', 'FUId', '    ', 'FUId', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800080, ' ', 'DocDat', ' ', 'DocDat', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800081, '', 'Note', '', 'Note', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800082, ' ', 'Note1', ' ', 'Note1', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800083, ' ', 'Note2', ' ', 'Note2', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800084, ' ', 'NotifyType', ' ', 'NotifyType', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800085, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 208, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(20800086, '', 'Variant', '', 'Variant', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800087, '', 'Number', '', 'Number', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800088, ' ', 'DocNumber', ' ', 'DocNumber', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800089, ' ', 'DateInput', ' ', 'DateInput', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800090, ' ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800091, ' ', 'RejectCls', ' ', 'RejectCls', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800092, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800093, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 208, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20800094, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800095, ' ', 'OrgName', ' ', 'DestOrgName', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800096, ' ()', 'DocBaseParent', ' ()', ' ', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800097, '', 'DocStateName', '', 'DocStateName', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800098, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800099, ' ', 'IsVised', ' ', 'IsVised', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800100, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800101, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800102, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800103, '  ', ' ', '  ', 'LastExtrChange', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800104, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800105, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 208, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20800106, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 208, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(20800123, '< >', 'ProgIndex', '', 'ProgIndex', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800158, '', 'KPPERIOD', '', 'KPPERIOD', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800160, '', 'BUDGETREF', '', 'BudgetRef', 0, 208, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20800162, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800163, '  (.)', 'ClsType', '', 'ClsType', 0, 208, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20800165, '/c ', 'FacialCode', '', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800211, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 208, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20800212, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 208, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20800213, '()', 'CREATERUSER', '()', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800214, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800215, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800216, '  ()', 'CREATEDATE', '  ()', ' ', 0, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20800228, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 208, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20800229, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 208, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20800230, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 208, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20801089, '< >', 'CurMonth2', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801107, '4', 'Quarter4', '4', 'Quarter4', 0, 208, 1, 0, '', 0, null, 0, 1, '4') ;

CALL ImportField(20801108, ' ', 'ONYEAR', ' ', 'ONYEAR', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801109, '()', 'INN', '()', 'DestOrgInn', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801110, ' ', ' ', ' ', 'IFS_DescriptionCode', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801111, '()', 'INN20', '()', 'DestOrgKpp', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801112, '()', 'NAME', '()', 'DestOrgNAME', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801113, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801115, '', 'NOTE', '', 'NOTE', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801116, '', 'Acc', '', 'DestAccountName', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801118, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801119, ' . ', 'FINTYPECODE', '  ', 'DestFINTYPECls', 0, 208, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20801120, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801121, ' ', 'Id', '* ', 'Id', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801122, '    ', 'FUId', '    ', 'FUId', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801123, '', 'Kvsr', '()', 'DestKvsrKey', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801124, '', 'Kvr', '()', 'DestKvrKey', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801125, '', 'Kfsr', '', 'DestKfsr', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801126, '', 'Kesr', '', 'DestKesrKey', 0, 208, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20801127, '', 'KCSR', '()', 'DestKcsrKey', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801128, '', 'SubKESR', '', 'DestSubKesrKey', 0, 208, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20801129, ' ', 'RegionCls', ' ', 'RegionCls', 0, 208, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20801130, '', 'FACTCODE', '', 'DestFactCls', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801131, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801132, '  ', 'FACIALCODE', '  ', 'DestFacialAccClsFacialCode', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801133, '   .', 'Acc_Ref', '   .', 'DestAccount', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801134, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801135, '', 'Month01', '', 'Month01', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801136, '', 'Month02', '', 'Month02', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801137, '', 'Month03', '', 'Month03', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801138, '', 'Month04', '', 'Month04', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801139, '', 'Month05', '', 'Month05', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801140, '', 'Month06', '', 'Month06', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801141, '', 'Month07', '', 'Month07', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801142, '', 'Month08', '', 'Month08', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801143, '', 'Month09', '', 'Month09', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801144, '', 'Month10', '', 'Month10', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801145, '', 'Month11', '', 'Month11', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801146, '', 'Month12', '', 'Month12', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801147, '1', 'Quarter1', '1', 'Quarter1', 0, 208, 1, 0, '', 0, null, 0, 1, '1') ;

CALL ImportField(20801148, '2', 'Quarter2', '2', 'Quarter2', 0, 208, 1, 0, '', 0, null, 0, 1, '2') ;

CALL ImportField(20801149, '3', 'Quarter3', '3', 'Quarter3', 0, 208, 1, 0, '', 0, null, 0, 1, '3') ;

CALL ImportField(20801150, ' ()', 'TreeOwner0', ' ()', 'TreeOwner0', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801151, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801152, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801153, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801154, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801155, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801159, '  ', 'CurMonth1', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801161, '', 'BUDGETREF', '', 'BUDGETREF', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801170, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801171, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801172, '()', 'KCSRCode', '', 'DestKcsr', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801173, '()', 'KVRCode', '', 'DestKvr', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801174, '()', 'KVSRCode', '', 'DestKvsr', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801175, '< >', 'KDCode', '', 'KDValue', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801176, '< >', 'SubKD', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801180, ' .  . . ()', 'IFS', ' ', 'IFS', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801183, ' .  . .', 'IFSCode', ' .  . .', 'IFS_FinSourceValue', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801184, '', 'OrgParent', '', ' ', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801185, '< >', 'KD', '', 'KD', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801186, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 208, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20801187, '< >', 'OnYearIncome', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801188, '< >', 'On3Year', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801189, '< >', 'On3YearCharges', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801190, '< >', 'On3YearIncome', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801192, '< >', 'OnYearCharges', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801193, '', 'Org_Ref', '', 'Org_Ref_Det', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801195, '  (.)', 'ClsType', ' ', 'ClsType', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801196, '< >', 'CurMonth3', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801197, '< >', 'CurQuarter', '', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801198, '< >', 'FundsSource', '', 'FUNDSSOURCE', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801199, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801200, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801201, '  ', 'StimateID', '  ', 'StimateID', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801202, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801203, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801204, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801205, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801206, ' ()', 'TransfertOrg_Ref', ' ()', 'TransfertOrg_Ref', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801207, ' ()', 'TransfertOrg_Name', ' ()', ' ', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801208, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 208, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20801209, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 208, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20801210, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 208, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20801212, '', 'InvestObjectCode', '', 'InvestObject', 0, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20801213, '', 'InvestObject', '', 'InvestObjectKey', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801214, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20801215, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20801216, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 208, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20801217, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 208, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20801218, '()', 'CREATERUSER', '()', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801219, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801220, '  ()', 'CREATEDATE', '  ()', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801221, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801223, '()', 'KESRCODE', '()', 'DestKesr', 0, 208, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20801225, '()', 'SUBKESRCode', '()', 'DestSubKesr', 0, 208, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20801226, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20801229, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 208, 1, 0, '', 0, 26617, 0, 0, '') ;

--    , (1)
CALL ImportField(20810013, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 208, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20810014, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 208, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20810158, ' ', 'ClsType', ' ', 'ClsType', 1, 208, 0, 0, '', 0, 24698, 0, 0, '') ;

CALL ImportField(20810227, ' /', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 208, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20810228, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 208, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20810229, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 208, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20811010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 208, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20811022, '', 'KVR', '()', 'DestKvrKey', 1, 208, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20811023, '', 'KVSR', '()', 'DestKvsrKey', 1, 208, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20811031, '()', 'KFSR', '()', 'DestKfsr', 1, 208, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20811032, '', 'KCSR', '()', 'DestKcsrKey', 1, 208, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20811033, '', 'KESR', '', 'DestKesrKey', 1, 208, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20811068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 208, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20811166, '()', 'KCSRCode', '()', 'DestKcsr', 1, 208, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20811167, '()', 'KVRCode', '()', 'DestKvr', 1, 208, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20811168, '()', 'KVSRCode', '()', 'DestKvsr', 1, 208, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20811173, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 208, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20811174, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 208, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20811176, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 208, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20811222, '()', 'KESRCODE', '()', 'DestKesr', 1, 208, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20811224, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 208, 1, 0, '', 0, 43610, 0, 1, '') ;

--    , +(2)
CALL ImportField(20811231, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 208, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20811232, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 208, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(20900001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 209, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20900002, '', 'BUDGETREF', '', 'BudgetRef', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900003, ' ', 'ClsType', ' ', 'ClsType', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900005, ' ', 'DAT', ' ', 'Dat', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900006, ' ', 'DateInput', ' ', 'DateInput', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900007, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 209, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(20900008, ' ()', 'DocBaseParent', ' ()', ' ', 0, 209, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20900009, ' ', 'DOCDAT', ' ', 'DocDat', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900010, ' ', 'DOCNUMBER', ' ', 'DocNumber', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900011, '', 'DocStateRef', '', 'DocStateRef', 0, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20900012, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900013, ' ', 'ID', ' ', 'ID', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900014, '', 'KPPERIOD', '', 'KPPeriod', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900015, '()', 'NOTE', '()', 'note', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900016, ' ', 'NOTE1', ' ', 'note1 ', 0, 209, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20900017, ' ()', 'NOTE2', ' ()', 'note2 ', 0, 209, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20900018, '', 'NOTIFYTYPE', '', 'NotifyType', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900019, '', 'Number', '', 'Number', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900020, ' ', 'OrgName', ' ', 'DestOrgName', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900021, ' ', 'ORGREF', ' ', 'DestOrgRef', 0, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20900022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 209, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20900023, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20900024, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900025, '  ', 'REJECTCLS', '  ', 'RejectCls', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900026, '', 'Variant', '', 'Variant', 0, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20900027, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 209, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20900028, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 209, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20900029, '()', 'CREATERUSER', '()', ' ', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900030, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900031, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900032, '  ()', 'CREATEDATE', '  ()', ' ', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900033, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900034, ' ', 'IsVised', ' ', 'IsVised', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900035, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20900157, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 209, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20900158, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 209, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20900159, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 209, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20901001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901004, '', 'DayPlan', '', 'DayPlan', 0, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20901005, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 0, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20901006, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 209, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20901007, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901008, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901009, '', 'FACT', '()', 'DestFactClsKey', 0, 209, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20901010, ' .  ()', 'FINTYPE', '  ', 'DestFinTypeClsKey', 0, 209, 1, 1, ',', 0, 17425, 0, 1, '') ;

CALL ImportField(20901011, ' .  . .', 'IFSCode', ' ()', 'IFS_FinSourceValue', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901012, ' .  . . ()', 'IFS', '()', 'IFS', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901014, '()', 'INN', '()', 'DestOrgInn', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901015, '()', 'INN20', '()', 'DestOrgKPP', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901016, '()', 'KCSRCode', '()', 'DestKcsr', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901018, '()', 'KFSR', '()', 'DestKfsr', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901019, '()', 'KVRCode', '()', 'DestKvr', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901020, '()', 'KVSRCode', '()', 'DestKvsr', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901021, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901022, '()', 'NAME', '()', 'DestOrgNAME', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901023, '', 'NOTE', '', 'Note', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901025, ' ', 'REGIONCLS', ' ', 'RegionCLS', 0, 209, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(20901028, '', 'TreeOwner0', '', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901031, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901032, ' ', 'ClsType', ' ', 'ClsType', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901033, '', 'OrgParent', ' ', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901041, ' ', 'Id', '* ', 'Id', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901134, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901140, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 0, 209, 1, 1, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20901141, '', 'FACTCODE', '', 'DestFactCls', 0, 209, 1, 1, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20901142, ' . ', 'FINTYPECode', '  ', 'DestFinTypeCls', 0, 209, 1, 1, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(20901143, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 209, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20901144, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 209, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20901145, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 209, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20901146, '()', 'CREATERUSER', '()', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901147, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901148, '  ()', 'CREATEDATE', '  ()', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901149, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901155, '()', 'KESRCODE', '()', 'DestKesr', 0, 209, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20901156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 209, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20901158, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 209, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20901162, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20901163, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20901165, '', 'InvestObjectCode', '', 'InvestObject', 0, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20901166, ' ', 'SubsidyClsCode', ' ', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20901167, '  ()', 'SubsidyCls', '  ()', ' ', 0, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20902001, ' ', 'ASSIGNMENTKIND', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902006, '()', 'DirectionCLS', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902007, ' ', 'FACIALACC_CLS', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902008, '/ ', 'FACIALCODE', '/ ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902009, ' ()', 'FACT', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902010, ' .  ()', 'FINTYPE', '  ', ' ', 0, 209, 2, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(20902011, ' .  . .', 'IFSCode', ' ()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902012, ' .  . . ()', 'IFS', '()', ' ', 0, 209, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20902014, '()', 'INN', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902015, '()', 'INN20', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902016, '()', 'KCSRCode', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902017, '', 'KESR', ' ()', 'DestKesrKey', 0, 209, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20902018, '()', 'KFSR', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902019, '()', 'KVRCode', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902020, '()', 'KVSRCode', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902021, ' ', 'MeansType', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902022, '()', 'NAME', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902023, '', 'NOTE', '', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902025, ' ', 'REGIONCLS', ' ', ' ', 0, 209, 2, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(20902027, '', 'SUBKESR', '()', 'DestSubkesrKey', 0, 209, 2, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(20902028, '', 'TreeOwner0', '', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902031, '  ', 'TransfertClsCode', '  ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902032, ' ', 'ClsType', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902033, '  ', 'RecordCount', '  ', ' ', 0, 209, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20902034, '', 'OrgParent', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902035, '   ()', 'TransfertCls', '   ()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902036, '  ()', 'SubsidyCls', '  ()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902037, '', 'KCSR', ' ()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902038, '', 'KVR', ' ()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902039, '', 'KVSR', ' ()', 'DestKvsrKey', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902040, ' ', 'SubsidyClsCode', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902041, '  ()', 'BudAllocationCls', '  ()', 'BudAllocationCls', 0, 209, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(20902042, '()', 'DirectionCLSCode', '()', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902043, '', 'FACTCODE', '', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902044, ' . ', 'FINTYPECode', '  ', ' ', 0, 209, 2, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(20902137, '   ', 'PayPromiseCls', '   ()', 'PayPromiseCls', 0, 209, 2, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20902139, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 0, 209, 2, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20902143, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 0, 209, 2, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20902144, ' ', 'TargetClsCode', ' ', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902145, ' ', 'TargetCls', '  ()', ' ', 0, 209, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20902155, '()', 'KESRCODE', '()', 'DestKesr', 0, 209, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20902156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 209, 2, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(20902161, '', 'ContractCostsClsCode', '', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20902164, '', 'InvestObjectCode', '', ' ', 0, 209, 2, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(20910001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 209, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(20910022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 209, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(20910157, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 209, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20910158, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 209, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20910159, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 209, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20911016, '()', 'KCSRCode', '()', 'DestKcsr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911017, '', 'KESR', ' ()', 'DestKesrKey', 1, 209, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20911018, '()', 'KFSR', '()', 'DestKfsr', 1, 209, 1, 1, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20911019, '()', 'KVRCode', '()', 'DestKvr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911020, '()', 'KVSRCode', '()', 'DestKvsr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911027, '', 'SUBKESR', '()', 'DestSubkesrKey', 1, 209, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20911138, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 209, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20911139, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 209, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20911148, '', 'KVR', '()', 'DestKvrKey', 1, 209, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20911149, '', 'KVSR', '()', 'DestKvsrKey', 1, 209, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20911150, '', 'KCSR', '()', 'DestKcsrKey', 1, 209, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20911155, '()', 'KESRCODE', '()', 'DestKesr', 1, 209, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20911156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 209, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20911158, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 209, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(20911159, ' ', 'SubsidyClsCode', ' ', ' ', 1, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20911160, '  ()', 'SubsidyCls', '  ()', ' ', 1, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20912016, '()', 'KCSRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912017, '', 'KESR', ' ()', 'DestKesrKey', 1, 209, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20912018, '()', 'KFSR', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912019, '()', 'KVRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912020, '()', 'KVSRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912027, '', 'SUBKESR', '()', 'DestSubkesrKey', 1, 209, 2, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(20912037, '', 'KCSR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912038, '', 'KVR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912039, '', 'KVSR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912044, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 209, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(20912045, ' ', 'BudAllocationClsCode', ' ', ' ', 1, 209, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(20912155, '()', 'KESRCODE', '()', 'DestKesr', 1, 209, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20912156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 209, 2, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(20912159, '', 'ContractCostsClsCode', '', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912160, '', 'InvestObjectCode', '', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(20910160, '  -', '', '  -', 'DestOrgShortName', 2, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20911168, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 209, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20911169, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 209, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(21000001, '', 'ANUMBER', '', 'Number', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000002, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 210, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(21000003, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 0, 210, 0, 0, '_', 0, null, 0, 0, '') ;

CALL ImportField(21000004, '', 'BUDGETREF', '', 'BudgetRef', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000005, ' ', 'ClsType', ' ', ' ', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000006, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000007, ' ', 'DAT', ' ', 'Dat', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000008, '   ', 'DATE_UTV_PP', '   ', 'DATE_UTV_PP', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000009, ' ', 'DateInput', ' ', 'DateInput', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000010, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 210, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(21000011, ' ', 'DOCDAT', ' ', 'DocDat', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000012, ' ', 'DOCNUMBER', ' ', 'DocNumber', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000013, '', 'DocStateRef', '', 'DocStateRef', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000014, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 210, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21000015, ' ', 'ID', ' ', 'Id', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000016, '', 'KPPERIOD', '', 'KPPeriod', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000017, ' ', 'NOTE', ' ', 'note', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000018, ' ', 'NOTE1', ' ', 'note1', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000019, ' ', 'NOTE2', ' ', 'note2', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000020, '', 'NOTIFYTYPE', '', 'NotifyType', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000021, ' ', 'OrgName', ' ', ' ', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000022, ' ', 'ORGREF', ' ', 'DestOrgRef', 0, 210, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21000023, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 210, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(21000024, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000025, '  ', 'REJECTCLS', '  ', 'RejectCls', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000026, '', 'Variant', '', 'Variant', 0, 210, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21000027, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 210, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21000028, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000029, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000030, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000031, '  ()', 'CREATEDATE', '  ()', ' ', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000034, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000035, ' ', 'IsVised', ' ', 'IsVised', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000036, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21000073, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 210, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21000074, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 210, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21000075, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 210, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21001001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001002, '', 'BUDGETREF', '', 'BUDGETREF', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001004, ' ', 'ClsType', ' ', 'ClsType', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001005, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 210, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21001006, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001007, '/ ', 'FACIALCODE', '/ ', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001008, '', 'FACT', '', 'DestFactClsKey', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001009, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 210, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(21001010, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001011, ' ', 'ID', ' ', 'Id', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001012, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001013, '()', 'IFSAGCode', '()', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001014, '()', 'IFS_KVSRCode', '()', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001015, '', 'KCSR', '', 'DestKcsrKey', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001016, '()', 'KCSRCode', '()', 'DestKcsr', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001017, '', 'KESR', '', 'DestKesrKey', 0, 210, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21001018, ' ()', 'KESRCORR', ' ()', ' ', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001019, '()', 'KFSR', '()', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001020, '', 'KVR', '', 'DestKvrKey', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001021, '()', 'KVRCode', '()', 'DestKvr', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001022, '', 'KVSR', '', 'DestKvsrKey', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001023, '()', 'KVSRCode', '()', 'DestKvsr', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001024, ' ', 'MeansType', ' ', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001025, '', 'NOTE', '', 'Note', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001026, ' ', 'RECORDINDEX', ' ', ' ', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001027, ' ', 'REGIONCLS', ' ', ' ', 0, 210, 1, 0, ',,', 0, 17417, 0, 1, '') ;

CALL ImportField(21001028, '  ', 'RegionCls_name', '  ', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001029, '', 'SUBKESR', '', 'DestSubkesrKey', 0, 210, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21001030, ' ', 'SUMMAYEAR1', ' ', 'SummaYear1', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001031, '  ', 'SUMMAYEAR2', '  ', 'SummaYear2', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001032, '  ', 'SUMMAYEAR3', '  ', 'SummaYear3', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001033, '', 'TreeOwner0', '', ' ', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001034, ' ', 'IFS', ' ', 'IFS', 0, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21001035, '  ', 'TransfertCls', '  ', 'TransfertCls', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001036, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001047, ' ', 'IFSCode', '', 'IFS_FinSourceValue', 0, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21001054, ' ', 'SubsidyCls', ' ()', 'SubsidyCls', 0, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21001056, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21001058, '', 'FACTCODE', '', 'DestFactCls', 0, 210, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21001059, '  ', 'SUMMAYEAR4', '  ', 'SUMMAYEAR4', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001060, ' ', 'SUMMAOTHERYEARS', ' ', 'SUMMAOTHERYEARS', 0, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21001061, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 210, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21001062, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 210, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21001063, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 210, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21001064, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001065, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001066, '  ()', 'CREATEDATE', '  ()', ' ', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001067, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21001068, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21001069, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21001071, '()', 'KESRCODE', '()', 'DestKesr', 0, 210, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21001072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 210, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21001073, '', 'InvestObject', '', 'InvestObjectKey', 0, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21001074, '', 'InvestObjectCode', '', 'InvestObject', 0, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21001077, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 0, 210, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21001079, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 0, 210, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21001081, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 0, 210, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21001083, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 210, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21001085, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 0, 210, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21001087, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 210, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(21002001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002002, '', 'BUDGETREF', '', 'BUDGETREF', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002004, ' ', 'ClsType', ' ', 'ClsType', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002005, '', 'CurMonth1', '', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002006, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 210, 2, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21002007, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002008, '/ ', 'FACIALCODE', '/ ', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002009, '', 'FACT', '', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002010, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 210, 2, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(21002011, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002012, ' ', 'ID', ' ', 'Id', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002013, '', 'KCSR', '', 'DestKcsrKey', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002014, '()', 'KCSRCode', '()', 'DestKcsr', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002015, '', 'KESR', '', 'DestKesrKey', 0, 210, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21002016, ' ()', 'KESRCORR', ' ()', 'KESRCORR', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002017, '()', 'KFSR', '()', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002018, '', 'KVR', '', 'DestKvrKey', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002019, '()', 'KVRCode', '()', 'DestKvr', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002020, '', 'KVSR', '', 'DestKvsrKey', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002021, '()', 'KVSRCode', '()', 'DestKvsr', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002022, ' ', 'MeansType', ' ', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002023, '', 'Month01', '', 'Month01', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002024, '', 'Month02', '', 'Month02', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002025, '', 'Month03', '', 'Month03', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002026, '', 'Month04', '', 'Month04', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002027, '', 'Month05', '', 'Month05', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002028, '', 'Month06', '', 'Month06', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002029, '', 'Month07', '', 'Month07', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002030, '', 'Month08', '', 'Month08', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002031, '', 'Month09', '', 'Month09', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002032, '', 'Month10', '', 'Month10', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002033, '', 'Month11', '', 'Month11', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002034, '', 'Month12', '', 'Month12', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002035, '', 'NOTE', '', 'Note', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002036, ' 1', 'QUARTER1', ' 1', 'QUARTER1', 0, 210, 2, 1, '1', 0, null, 0, 0, '') ;

CALL ImportField(21002037, ' 2', 'QUARTER2', ' 2', 'QUARTER2', 0, 210, 2, 1, '2', 0, null, 0, 0, '') ;

CALL ImportField(21002038, ' 3', 'QUARTER3', ' 3', 'QUARTER3', 0, 210, 2, 1, '3', 0, null, 0, 0, '') ;

CALL ImportField(21002039, ' 4', 'QUARTER4', ' 4', 'QUARTER4', 0, 210, 2, 1, '4', 0, null, 0, 0, '') ;

CALL ImportField(21002040, ' ', 'RECORDINDEX', ' ', ' ', 0, 210, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21002041, ' ', 'REGIONCLS', ' ', ' ', 0, 210, 2, 0, ',,', 0, 17417, 0, 1, '') ;

CALL ImportField(21002042, '  ', 'RegionCls_name', '  ', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002043, '', 'SUBKESR', '', 'DestSubkesrKey', 0, 210, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21002044, '', 'TreeOwner1', '', ' ', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002045, '  ', 'TransfertCls', '  ', 'TransfertCls', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002046, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002055, ' ', 'SubsidyCls', ' ()', 'SubsidyCls', 0, 210, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21002057, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 210, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21002059, '', 'FACTCODE', '', 'DestFactCls', 0, 210, 2, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21002060, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 210, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21002061, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 210, 2, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21002062, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 210, 2, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21002068, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 210, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21002069, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 210, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21002070, ' ', 'IFSCode', '', 'IFS_FinSourceValue', 0, 210, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21002071, '()', 'KESRCODE', '()', 'DestKesr', 0, 210, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21002072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 210, 2, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21002074, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 210, 2, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21002075, '', 'InvestObject', '', 'InvestObjectKey', 0, 210, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21002076, '', 'InvestObjectCode', '', 'InvestObject', 0, 210, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21002078, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 0, 210, 2, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21002080, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 0, 210, 2, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21002082, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 0, 210, 2, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21002084, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 210, 2, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21002086, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 0, 210, 2, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21002088, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 210, 2, 0, '', 0, 27849, 0, 1, '') ;

--  , (1)
CALL ImportField(21010002, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 210, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21010023, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 210, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21010073, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 210, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21010074, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 210, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21010075, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 210, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21011003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 210, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21011015, '', 'KCSR', '', 'DestKcsrKey', 1, 210, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(21011016, '()', 'KCSRCode', '()', 'DestKcsr', 1, 210, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(21011017, '', 'KESR', '', 'DestKesrKey', 1, 210, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21011019, '()', 'KFSR', '()', 'DestKfsr', 1, 210, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(21011020, '', 'KVR', '', 'DestKvrKey', 1, 210, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(21011021, '()', 'KVRCode', '()', 'DestKvr', 1, 210, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(21011022, '', 'KVSR', '', 'DestKvsrKey', 1, 210, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(21011023, '()', 'KVSRCode', '()', 'DestKvsr', 1, 210, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21011029, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 210, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21011040, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 210, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21011041, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 210, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21011044, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 210, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21011071, '()', 'KESRCODE', '()', 'DestKesr', 1, 210, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21011072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 210, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21012003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 210, 2, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21012013, '', 'KCSR', '', 'DestKcsrKey', 1, 210, 2, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(21012014, '()', 'KCSRCode', '()', 'DestKcsr', 1, 210, 2, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(21012015, '', 'KESR', '', 'DestKesrKey', 1, 210, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21012017, '()', 'KFSR', '()', 'DestKfsr', 1, 210, 2, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(21012018, '', 'KVR', '', 'DestKvrKey', 1, 210, 2, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(21012019, '()', 'KVRCode', '()', 'DestKvr', 1, 210, 2, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(21012020, '', 'KVSR', '', 'DestKvsrKey', 1, 210, 2, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(21012021, '()', 'KVSRCode', '()', 'DestKvsr', 1, 210, 2, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21012043, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 210, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21012054, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 210, 2, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21012055, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 210, 2, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21012059, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 210, 2, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21012071, '()', 'KESRCODE', '()', 'DestKesr', 1, 210, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21012072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 210, 2, 0, '', 0, 43610, 0, 1, '') ;

--  , +(2)
CALL ImportField(21010089, '  -', '', '  -', 'DestOrgShortName', 2, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011090, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 210, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21011091, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 210, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(21100001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 211, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21100002, '', 'BUDGETREF', '', 'BudgetRef', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100003, ' ', 'ClsType', ' ', 'ClsType', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100004, ' ', 'DAT', ' ', 'Dat', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100005, ' ', 'DateInput', ' ', 'DateInput', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100006, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 211, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(21100007, ' ()', 'DocBaseParent', ' ()', ' ', 0, 211, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21100008, ' ', 'DOCDAT', ' ', 'DocDat', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100009, ' ', 'DOCNUMBER', ' ', 'DocNumber', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100010, '', 'DocStateRef', '', 'DocStateRef', 0, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21100011, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100012, ' ', 'ID', ' ', 'ID', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100013, '', 'KPPERIOD', '', 'KPPeriod', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100014, '()', 'NOTE', '()', 'note', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100015, ' ', 'NOTE1', ' ', 'note1 ', 0, 211, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21100016, ' ()', 'NOTE2', ' ()', 'note2 ', 0, 211, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21100017, '', 'NOTIFYTYPE', '', 'NotifyType', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100018, '', 'Number', '', 'Number', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100019, ' ', 'OrgName', ' ', 'DestOrgName', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100020, ' ', 'ORGREF', ' ', 'DestOrgRef', 0, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21100021, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 211, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21100022, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21100023, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100024, '  ', 'REJECTCLS', '  ', 'RejectCls', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100025, '', 'Variant', '', 'Variant', 0, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21100049, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 211, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21100050, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 211, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21100051, '()', 'CREATERUSER', '()', ' ', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100052, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100053, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100054, '  ()', 'CREATEDATE', '  ()', ' ', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100055, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100056, ' ', 'IsVised', ' ', 'IsVised', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100057, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21100072, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 211, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21100073, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 211, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21100074, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 211, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21101001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101002, '', 'DayPlan', '', 'DayPlan', 0, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21101003, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 0, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21101004, '()', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101005, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101006, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101007, '', 'FACTCODE', '', 'DestFactCls', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101008, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 0, 211, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21101009, ' .  . .', 'IFSCode', ' ()', 'IFS_FinSourceValue', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101010, ' .  . . ()', 'IFS', '()', 'IFS', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101011, '()', 'INN', '()', 'DestOrgInn', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101012, '()', 'INN20', '()', 'DestOrgKPP', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101013, '()', 'KCSRCode', '()', 'DestKcsr', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101015, '()', 'KFSR', '()', 'DestKfsr', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101016, '()', 'KVRCode', '()', 'DestKvr', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101017, '()', 'KVSRCode', '()', 'DestKvsr', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101018, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101019, '()', 'NAME', '()', 'DestOrgNAME', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101020, '', 'NOTE', '', 'Note', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101021, ' ', 'REGIONCLS', ' ', 'RegionCLS', 0, 211, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(21101022, '', 'SUBKESR', '', 'DestSubkesrKey', 0, 211, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21101023, '', 'TreeOwner0', '', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101024, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101025, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101026, ' ', 'ClsType', ' ', 'ClsType', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101027, ' ', 'Id', '* ', 'Id', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101028, '', 'OrgParent', ' ', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101029, '< >', 'KD', '', 'KD', 0, 211, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21101030, '< >', 'KDCode', '', 'KDValue', 0, 211, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21101042, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101044, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 211, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(21101046, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21101049, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21101050, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 211, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21101051, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 211, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21101052, '()', 'CREATERUSER', '()', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101053, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101054, '  ()', 'CREATEDATE', '  ()', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101055, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21101057, '()', 'KESRCODE', '()', 'DestKesr', 0, 211, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21101061, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 211, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21101065, ' ', 'SubsidyClsCode', ' ', ' ', 0, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21101074, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 211, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21102001, '  ', 'RecordCount', '  ', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21102002, '()', 'DirectionCLSCODE', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102003, ' ', 'FACIALACC_CLS', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102004, '/ ', 'FACIALCODE', '/ ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102005, '', 'FACTCODE', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102006, ' . ', 'FINTYPECODE', '  ', ' ', 0, 211, 2, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(21102007, ' .  . .', 'IFSCode', ' ()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102008, ' .  . . ()', 'IFS', '()', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21102009, '()', 'INN', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102010, '()', 'INN20', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102011, '()', 'KCSRCode', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102012, '', 'KESR', ' ()', 'DestKesrKey', 0, 211, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21102013, '()', 'KFSR', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102014, '()', 'KVRCode', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102015, '()', 'KVSRCode', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102016, ' ', 'MeansType', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102017, '()', 'NAME', '()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102018, '', 'NOTE', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102019, ' ', 'REGIONCLS', ' ', ' ', 0, 211, 2, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(21102020, '', 'SUBKESR', '', 'DestSubkesrKey', 0, 211, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21102021, '', 'TreeOwner0', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102022, '  ', 'TransfertClsCode', '  ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102023, ' ', 'ClsType', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102024, ' ', 'ASSIGNMENTKIND', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102025, '', 'OrgParent', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102026, '   ()', 'TransfertCls', '   ()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102027, '  ()', 'SubsidyCls', '  ()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102028, '', 'KCSR', ' ()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102029, '', 'KVR', ' ()', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102030, '', 'KVSR', ' ()', 'DestKvsrKey', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102031, ' ', 'SubsidyClsCode', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102043, ' ()', 'FACT', '()', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21102045, ' .  ()', 'FINTYPE', '  ', ' ', 0, 211, 2, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(21102047, ' ()', 'DirectionCLS', '()', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21102048, '', 'ContractCostsCls', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102049, '', 'ContractCostsClsCode', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102050, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 211, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21102051, ' ', 'TargetClsCode', ' ', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102052, ' ', 'TargetCls', '  ()', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21102056, '()', 'KESRCODE', '()', 'DestKesr', 0, 211, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21102060, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 211, 2, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21102070, ' ', 'KDCode', ' ', 'KDValue', 0, 211, 2, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(21102083, ' ', 'BudAllocationClsCode', ' ', ' ', 0, 211, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(21102084, '  ()', 'BudAllocationCls', '  ()', ' ', 0, 211, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21102085, '  ', 'PayPromiseClsCode', '  ', ' ', 0, 211, 2, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(21102086, '   ', 'PayPromiseCls', '   ()', ' ', 0, 211, 2, 1, '', 0, 27835, 0, 0, '') ;

CALL ImportField(21102087, '', 'InvestObjectCode', '', ' ', 0, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21102088, '', 'InvestObject', '', ' ', 0, 211, 2, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(21110001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 211, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21110020, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 211, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21110073, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 211, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21110074, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 211, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21110075, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 211, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21111018, '()', 'KCSRCode', '()', 'DestKcsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111020, '()', 'KFSR', '()', 'DestKfsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111021, '()', 'KVRCode', '()', 'DestKvr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111022, '()', 'KVSRCode', '()', 'DestKvsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111029, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 211, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21111042, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 211, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21111043, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 211, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21111059, '()', 'KESRCODE', '()', 'DestKesr', 1, 211, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21111063, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 211, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21111064, ' ', 'SubsidyClsCode', ' ', ' ', 1, 211, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(21111075, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 211, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21111079, '', 'InvestObjectCode', '', 'InvestObject', 1, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21111081, '', 'InvestObject', '', 'InvestObjectKey', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21112015, '()', 'KCSRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112016, '', 'KESR', ' ()', 'DestKesrKey', 1, 211, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21112017, '()', 'KFSR', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112018, '()', 'KVRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112019, '()', 'KVSRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112026, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 211, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21112030, '', 'KVR', ' ()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112031, '', 'KVSR', ' ()', 'DestKvsrKey', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112032, '', 'KCSR', ' ()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112033, ' ', 'SubsidyClsCode', ' ', ' ', 1, 211, 2, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(21112037, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 211, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21112058, '()', 'KESRCODE', '()', 'DestKesr', 1, 211, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21112062, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 211, 2, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21112065, '', 'KD', '', 'KD', 1, 211, 2, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21112066, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 211, 2, 0, '', 0, 38908, 0, 1, '') ;

CALL ImportField(21112067, ' ()', 'KDKVSRCode', ' ()', 'KDKVSRCode', 1, 211, 2, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21112068, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 211, 2, 0, '', 0, 16834, 0, 1, '') ;

CALL ImportField(21112069, '.  ', 'SubKD', '.  ', 'SUBKD', 1, 211, 2, 1, '', 0, 25271, 0, 0, '') ;

CALL ImportField(21112070, ' ', 'KDValue', ' ', 'KDValue', 1, 211, 2, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21112071, ' ()', 'DescriptionCode', ' ()', 'DescriptionCode', 1, 211, 2, 0, '', 0, 16831, 0, 1, '') ;

CALL ImportField(21112076, ' ', 'BudAllocationClsCode', ' ', ' ', 1, 211, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(21112077, '  ', 'PayPromiseClsCode', '  ', ' ', 1, 211, 2, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(21112078, '   ', 'PayPromiseCls', '   ()', ' ', 1, 211, 2, 1, '', 0, 27835, 0, 0, '') ;

CALL ImportField(21112080, '', 'InvestObjectCode', '', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112082, '', 'InvestObject', '', ' ', 1, 211, 2, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(21111089, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 211, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21111090, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 211, 1, 1, '', 0, null, 0, 0, '') ;

--   , , (0)
CALL ImportField(21200001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 212, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21200002, '', 'BUDGETREF', '', 'BudgetRef', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200003, ' ', 'ClsType', ' ', 'ClsType', 0, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21200004, ' ', 'DAT', ' ', 'Dat', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200005, ' ', 'DateInput', ' ', 'DateInput', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200006, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 212, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(21200007, ' ()', 'DocBaseParent', ' ()', ' ', 0, 212, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21200008, ' ', 'DOCDAT', ' ', 'DocDat', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200009, ' ', 'DOCNUMBER', ' ', 'DocNumber', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200010, '', 'DocStateRef', '', 'DocStateRef', 0, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21200011, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200012, ' ', 'ID', ' ', 'ID', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200013, '', 'KPPERIOD', '', 'KPPeriod', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200014, '()', 'NOTE', '()', 'note', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200015, ' ', 'NOTE1', ' ', 'note1 ', 0, 212, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21200016, ' ()', 'NOTE2', ' ()', 'note2 ', 0, 212, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21200017, '', 'NOTIFYTYPE', '', 'NotifyType', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200018, '', 'Number', '', 'Number', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200019, ' ', 'OrgName', ' ', 'DestOrgName', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200020, ' ', 'ORGREF', ' ', 'DestOrgRef', 0, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21200021, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 212, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21200022, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21200023, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200024, '  ', 'REJECTCLS', '  ', 'RejectCls', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200025, '', 'Variant', '', 'Variant', 0, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21200049, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 212, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21200050, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 212, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21200051, '()', 'CREATERUSER', '()', ' ', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200052, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200053, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200054, '  ()', 'CREATEDATE', '  ()', ' ', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200055, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200056, ' ', 'IsVised', ' ', 'IsVised', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200057, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21200065, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 212, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21200066, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 212, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21200067, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 212, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21201001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201002, '', 'DayPlan', '', 'DayPlan', 0, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21201003, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 0, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21201004, '()', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201005, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201006, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201007, '', 'FACTCODE', '', 'DestFactCls', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201008, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 0, 212, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21201009, ' .  . .', 'IFSCode', ' ()', 'IFS_FinSourceValue', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201010, ' .  . . ()', 'IFS', '()', 'IFS', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201011, '()', 'INN', '()', 'DestOrgInn', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201012, '()', 'INN20', '()', 'DestOrgKPP', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201013, '()', 'KCSRCode', '()', 'DestKcsr', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201015, '()', 'KFSR', '()', 'DestKfsr', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201016, '()', 'KVRCode', '()', 'DestKvr', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201017, '()', 'KVSRCode', '()', 'DestKvsr', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201018, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201019, '()', 'NAME', '()', 'DestOrgNAME', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201020, '', 'NOTE', '', 'Note', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201021, ' ', 'REGIONCLS', ' ', 'RegionCLS', 0, 212, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(21201022, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 0, 212, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21201023, '', 'TreeOwner0', '', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201024, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201025, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201026, ' ', 'ClsType', ' ', 'ClsType', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201027, ' ', 'Id', '* ', 'Id', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201028, '', 'OrgParent', ' ', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201029, '< >', 'KD', '', 'KD', 0, 212, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21201030, '< >', 'KDCode', '', 'KDValue', 0, 212, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21201031, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201043, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201045, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 212, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(21201047, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21201050, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21201051, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 212, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21201052, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 212, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21201053, '()', 'CREATERUSER', '()', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201054, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201055, '  ()', 'CREATEDATE', '  ()', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201056, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21201060, '()', 'KESRCODE', '()', 'DestKesr', 0, 212, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21201064, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 212, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21201067, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 212, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21202001, '  ', 'RecordCount', '  ', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202002, '()', 'DirectionCLSCODE', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202003, ' ', 'FACIALACC_CLS', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202004, '/ ', 'FACIALCODE', '/ ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202005, '', 'FACTCODE', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202006, ' . ', 'FINTYPECODE', '  ', ' ', 0, 212, 2, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(21202007, ' .  . .', 'IFSCode', ' ()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202008, ' .  . . ()', 'IFS', '()', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202009, '()', 'INN', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202010, '()', 'INN20', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202011, '()', 'KCSRCode', '()', 'DestKcsr', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202012, '', 'KESR', ' ()', 'DestKesrKey', 0, 212, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21202013, '()', 'KFSR', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202014, '()', 'KVRCode', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202015, '()', 'KVSRCode', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202016, ' ', 'MeansType', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202017, '()', 'NAME', '()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202018, '', 'NOTE', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202019, ' ', 'REGIONCLS', ' ', ' ', 0, 212, 2, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(21202020, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 0, 212, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21202021, '', 'TreeOwner0', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202022, '  ', 'TransfertClsCode', '  ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202023, ' ', 'ClsType', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202024, ' ', 'ASSIGNMENTKIND', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202025, '', 'OrgParent', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202026, '   ()', 'TransfertCls', '   ()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202027, '  ()', 'SubsidyCls', '  ()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202028, '', 'KCSR', ' ()', 'DestKcsrKey', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202029, '', 'KVR', ' ()', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202030, '', 'KVSR', ' ()', 'DestKvsrKey', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202031, ' ', 'SubsidyClsCode', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202032, ' ()', 'Org_Ref', ' ()', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202044, ' ()', 'FACT', '()', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202046, ' .  ()', 'FINTYPE', '  ', ' ', 0, 212, 2, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(21202048, ' ()', 'DirectionCLS', '()', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202049, '', 'ContractCostsCls', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202050, '', 'ContractCostsClsCode', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202051, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 212, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21202052, ' ', 'TargetClsCode', ' ', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202053, ' ', 'TargetCls', '  ()', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21202059, '()', 'KESRCODE', '()', 'DestKesr', 0, 212, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21202063, '()', 'SUBKESRCode', '()', 'DestSubkesr', 0, 212, 2, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21202069, ' ', 'BudAllocationClsCode', ' ', ' ', 0, 212, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(21202070, '  ()', 'BudAllocationCls', '  ()', ' ', 0, 212, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21202071, '  ', 'PayPromiseClsCode', '  ', ' ', 0, 212, 2, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(21202072, '   ', 'PayPromiseCls', '   ()', ' ', 0, 212, 2, 1, '', 0, 27835, 0, 0, '') ;

CALL ImportField(21202073, '', 'InvestObjectCode', '', ' ', 0, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21202074, '', 'InvestObject', '', ' ', 0, 212, 2, 1, '', 0, null, 0, 0, '') ;

--   , , (1)
CALL ImportField(21210001, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 212, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21210020, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 212, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21210066, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 212, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21210067, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 212, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21210068, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 212, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21211018, '()', 'KCSRCode', '()', 'DestKcsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211020, '()', 'KFSR', '()', 'DestKfsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211021, '()', 'KVRCode', '()', 'DestKvr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211022, '()', 'KVSRCode', '()', 'DestKvsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211029, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 1, 212, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21211043, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 212, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21211044, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 212, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21211058, '()', 'KESRCODE', '()', 'DestKesr', 1, 212, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21211062, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 212, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21211065, '', 'InvestObjectCode', '', 'InvestObject', 1, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21211067, '', 'InvestObject', '', 'InvestObjectKey', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211068, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 212, 1, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21212015, '()', 'KCSRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212016, '', 'KESR', ' ()', 'DestKesrKey', 1, 212, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21212017, '()', 'KFSR', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212018, '()', 'KVRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212019, '()', 'KVSRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212026, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 1, 212, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21212030, '', 'KVR', ' ()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212031, '', 'KVSR', ' ()', 'DestKvsrKey', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212032, '', 'KCSR', ' ()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212038, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 212, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21212057, '()', 'KESRCODE', '()', 'DestKesr', 1, 212, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21212061, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 212, 2, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21212062, ' ', 'BudAllocationClsCode', ' ', ' ', 1, 212, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(21212063, '  ', 'PayPromiseClsCode', '  ', ' ', 1, 212, 2, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(21212064, '   ', 'PayPromiseCls', '   ()', ' ', 1, 212, 2, 1, '', 0, 27835, 0, 0, '') ;

CALL ImportField(21212066, '', 'InvestObjectCode', '', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212068, '', 'InvestObject', '', ' ', 1, 212, 2, 1, '', 0, null, 0, 0, '') ;

--   , , +(2)
CALL ImportField(21211075, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 212, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21211076, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21211077, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 212, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21211078, '   ()', 'PayTargetFunds', '   ', ' ', 2, 212, 1, 1, '', 0, null, 0, 0, '') ;

--      , (0)
CALL ImportField(21300001, '()', 'CREATERUSER', '()', ' ', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300006, ' ', 'Dat', ' ', 'Dat', 0, 213, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21300007, ' ', 'Id', ' ', 'Id', 0, 213, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21300008, ' ', 'DocDat', ' ', 'DocDat', 0, 213, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21300009, '()', 'Note', '', 'Note', 0, 213, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21300010, ' ', 'Note1', ' ', 'Note1', 0, 213, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21300011, ' ()', 'Note2', ' ', 'Note2', 0, 213, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21300012, '', 'NotifyType', ' ', 'NotifyType', 0, 213, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21300013, '', 'BudgetRef', '', 'BudgetRef', 0, 213, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21300014, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 213, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21300015, '', 'Variant', '', 'Variant', 0, 213, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21300016, '', 'Number', '', 'Number', 0, 213, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21300017, ' ', 'DocNumber', ' ', 'DocNumber', 0, 213, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21300018, ' ', 'DateInput', ' ', 'DateInput', 0, 213, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21300019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 213, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21300020, '  ', 'RejectCls', ' ', 'RejectCls', 0, 213, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21300021, '  ()', 'RejectCause', ' ()', 'RejectCause', 0, 213, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21300022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 213, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21300023, ' ', 'CryptoStatus', '', 'CryptoStatus', 0, 213, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21300024, '', 'DocStateRef', ' ', 'DocStateRef', 0, 213, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21300025, ' ()', 'DocBaseParent', ' ()', ' ', 0, 213, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21300026, '  ', 'SenderId', '  ', 'SenderId', 0, 213, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21300027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 213, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21300028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 0, 213, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21300029, ' ', 'ProgIndex', 'ProgIndex', ' ', 0, 213, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21300030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 213, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21300032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 0, 213, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21300051, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300052, ' ', 'IsVised', ' ', 'IsVised', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300053, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21300056, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 213, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21300057, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 213, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21301001, '()', 'CREATERUSER', '()', ' ', 0, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21301002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21301003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21301004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21301006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 213, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21301007, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 213, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21301009, ' ', 'ClsType', ' ', 'ClsType', 0, 213, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21301010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 213, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21301011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 213, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21301012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 0, 213, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21301013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 213, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21301014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 213, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21301015, '', 'TreeOwner0', ' ()', ' ', 0, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21301016, ' 4', 'Quarter4', '4', 'Quarter4', 0, 213, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21301017, ' 3', 'Quarter3', '3', 'Quarter3', 0, 213, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21301018, ' 2', 'Quarter2', '2', 'Quarter2', 0, 213, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21301019, ' 1', 'Quarter1', '1', 'Quarter1', 0, 213, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21301020, '', 'Month12', '', 'Month12', 0, 213, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21301021, '', 'Month11', '', 'Month11', 0, 213, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21301022, '', 'Month10', '', 'Month10', 0, 213, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21301023, '', 'Month09', '', 'Month09', 0, 213, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21301024, '', 'Month08', '', 'Month08', 0, 213, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21301025, '', 'Month07', '', 'Month07', 0, 213, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21301026, '', 'Month06', '', 'Month06', 0, 213, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21301027, '', 'Month05', '', 'Month05', 0, 213, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21301028, '', 'Month04', '', 'Month04', 0, 213, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21301029, '', 'Month03', '', 'Month03', 0, 213, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21301030, '', 'Month02', '', 'Month02', 0, 213, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21301031, '', 'Month01', '', 'Month01', 0, 213, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21301032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 0, 213, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21301033, '  ', 'SenderId', '  ', 'SenderId', 0, 213, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21301034, ' ', 'RecordIndex', '  ', 'RecordIndex', 0, 213, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21301035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 213, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21301036, ' ', 'RegionCls', '', 'RegionCls', 0, 213, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21301037, '', 'BudgetRef', '', 'BUDGETREF', 0, 213, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21301038, '    ', ' ', '*    ', 'FUId', 0, 213, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21301039, ' ', 'Id', ' ', 'Id', 0, 213, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21301040, ' ', 'KDCode', ' ', 'KDValue', 0, 213, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21301041, '  ()', 'KD', '  ()', 'KD', 0, 213, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21301042, ' ', 'SubsidySumma', ' ', ' ', 0, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21301043, '   ', 'TotalSumma', '   ', ' ', 0, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21301044, '  ', 'HigherBudCls', '  ', ' ', 0, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21301045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 0, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21301046, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 213, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21301058, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 213, 1, 0, '', 0, 26617, 0, 0, '') ;

--      , (1)
CALL ImportField(21310022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 213, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21310057, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 213, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21310058, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 213, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21311014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 213, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21311046, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 213, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21311059, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 213, 1, 0, '', 0, 26617, 0, 0, '') ;

--      , +(2)
CALL ImportField(21310031, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 213, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21310048, '    ()', 'TotalSumma', '    ()', 'TotalSummaCpt', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21310049, '  ()', 'SubsidySumma', '  ()', 'SubsidySummaCpt', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21310050, ' ', 'AgreementLevel', ' ', 'AgreementLevel', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21311008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 213, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21311047, ' ', 'Percent', ' ', 'Percent', 2, 213, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21311051, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 2, 213, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(21311052, '()', 'INN', '()', 'DestOrgInn', 2, 213, 1, 0, '', 0, 16645, 0, 0, '') ;

CALL ImportField(21311053, '()', 'INN20', '()', 'DestOrgKpp', 2, 213, 1, 0, '', 0, 16653, 0, 0, '') ;

CALL ImportField(21311054, '()', 'NAME', '()', 'DestOrgNAME', 2, 213, 1, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(21311055, '', 'OrgNameAndAcc', '', ' ', 2, 213, 1, 0, '', 0, null, 0, 0, '') ;

--   14 /, (0)
CALL ImportField(21400001, '()', 'CREATERUSER', '()', ' ', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400006, ' ', 'Dat', ' ', 'Dat', 0, 214, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21400007, ' ', 'Id', ' ', 'Id', 0, 214, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21400008, ' ', 'DocDat', ' ', 'DocDat', 0, 214, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21400009, '()', 'Note', '', 'Note', 0, 214, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21400010, ' ', 'Note1', ' ', 'Note1', 0, 214, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21400011, ' ()', 'Note2', ' ', 'Note2', 0, 214, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21400012, '', 'NotifyType', ' ', 'NotifyType', 0, 214, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21400013, '', 'BudgetRef', '', 'BudgetRef', 0, 214, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21400014, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 214, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21400015, '', 'Variant', '', 'Variant', 0, 214, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21400016, '', 'Number', '', 'Number', 0, 214, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21400017, ' ', 'DocNumber', ' ', 'DocNumber', 0, 214, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21400018, ' ', 'DateInput', ' ', 'DateInput', 0, 214, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21400019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 214, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21400020, '  ', 'RejectCls', ' ', 'RejectCls', 0, 214, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21400021, '  ()', 'RejectCause', ' ()', 'RejectCause', 0, 214, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21400022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 214, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21400023, ' ', 'CryptoStatus', '', 'CryptoStatus', 0, 214, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21400024, '', 'DocStateRef', ' ', 'DocStateRef', 0, 214, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21400025, ' ()', 'DocBaseParent', ' ()', ' ', 0, 214, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21400026, '  ', 'SenderId', '  ', 'SenderId', 0, 214, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21400027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 214, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21400028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 0, 214, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21400029, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 0, 214, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21400030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 214, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21400031, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 214, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21400032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 0, 214, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21400033, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400034, ' ', 'IsVised', ' ', 'IsVised', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400035, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21400047, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 214, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21400048, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 214, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21401001, '()', 'CREATERUSER', '()', ' ', 0, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21401002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21401003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21401004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21401006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 214, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21401007, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 214, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21401008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 214, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21401009, ' ', 'ClsType', ' ', 'ClsType', 0, 214, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21401010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 214, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21401011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 214, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21401012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 0, 214, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21401013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 214, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21401014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 214, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21401015, '', 'TreeOwner0', ' ()', ' ', 0, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21401016, ' 4', 'Quarter4', '4', 'Quarter4', 0, 214, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21401017, ' 3', 'Quarter3', '3', 'Quarter3', 0, 214, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21401018, ' 2', 'Quarter2', '2', 'Quarter2', 0, 214, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21401019, ' 1', 'Quarter1', '1', 'Quarter1', 0, 214, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21401020, '', 'Month12', '', 'Month12', 0, 214, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21401021, '', 'Month11', '', 'Month11', 0, 214, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21401022, '', 'Month10', '', 'Month10', 0, 214, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21401023, '', 'Month09', '', 'Month09', 0, 214, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21401024, '', 'Month08', '', 'Month08', 0, 214, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21401025, '', 'Month07', '', 'Month07', 0, 214, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21401026, '', 'Month06', '', 'Month06', 0, 214, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21401027, '', 'Month05', '', 'Month05', 0, 214, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21401028, '', 'Month04', '', 'Month04', 0, 214, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21401029, '', 'Month03', '', 'Month03', 0, 214, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21401030, '', 'Month02', '', 'Month02', 0, 214, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21401031, '', 'Month01', '', 'Month01', 0, 214, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21401032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 0, 214, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21401033, '  ', 'SenderId', '  ', 'SenderId', 0, 214, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21401034, ' ', 'RecordIndex', '  ', 'RecordIndex', 0, 214, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21401035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 214, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21401036, ' ', 'RegionCls', '', 'RegionCls', 0, 214, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21401037, '', 'BudgetRef', '', 'BUDGETREF', 0, 214, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21401038, '    ', ' ', '*    ', 'FUId', 0, 214, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21401039, ' ', 'Id', ' ', 'Id', 0, 214, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21401040, ' ', 'KDCode', ' ', 'KDValue', 0, 214, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21401041, '  ()', 'KD', '  ()', 'KD', 0, 214, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21401042, ' ', 'SubsidySumma', ' ', ' ', 0, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21401043, '   ', 'TotalSumma', '   ', ' ', 0, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21401044, '  ', 'HigherBudCls', '  ', ' ', 0, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21401045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 0, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21401048, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 214, 1, 0, '', 0, 26617, 0, 0, '') ;

--   14 /, (1)
CALL ImportField(21410022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 214, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21410029, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 214, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21410047, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 214, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21410048, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 214, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21411014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 214, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21411048, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 214, 1, 0, '', 0, 26617, 0, 0, '') ;

--   14 /, +(2)
CALL ImportField(21411046, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 214, 1, 1, '', 0, null, 0, 1, '') ;

--   14 /, (0)
CALL ImportField(21500001, '()', 'CREATERUSER', '()', ' ', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500006, ' ', 'Dat', ' ', 'Dat', 0, 215, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21500007, ' ', 'Id', ' ', 'Id', 0, 215, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21500008, ' ', 'DocDat', ' ', 'DocDat', 0, 215, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21500009, '()', 'Note', '', 'Note', 0, 215, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21500010, ' ', 'Note1', ' ', 'Note1', 0, 215, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21500011, ' ()', 'Note2', ' ', 'Note2', 0, 215, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21500012, '', 'NotifyType', ' ', 'NotifyType', 0, 215, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21500013, '', 'BudgetRef', '', 'BudgetRef', 0, 215, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21500014, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 215, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21500015, '', 'Variant', '', 'Variant', 0, 215, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21500016, '', 'Number', '', 'Number', 0, 215, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21500017, ' ', 'DocNumber', ' ', 'DocNumber', 0, 215, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21500018, ' ', 'DateInput', ' ', 'DateInput', 0, 215, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21500019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 0, 215, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21500020, '  ', 'RejectCls', ' ', 'RejectCls', 0, 215, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21500021, '  ()', 'RejectCause', ' ()', 'RejectCause', 0, 215, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21500022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 215, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21500023, ' ', 'CryptoStatus', '', 'CryptoStatus', 0, 215, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21500024, '', 'DocStateRef', ' ', 'DocStateRef', 0, 215, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21500025, ' ()', 'DocBaseParent', ' ()', ' ', 0, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21500026, '  ', 'SenderId', '  ', 'SenderId', 0, 215, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21500027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 215, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21500028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 0, 215, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21500029, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 0, 215, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21500030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 215, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21500031, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 215, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21500032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 0, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21500046, '   ', 'StartDate', '   ', ' ', 0, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21500047, '  ', 'EndDate', '  ', ' ', 0, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21500048, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500049, ' ', 'IsVised', ' ', 'IsVised', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500050, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21500051, ' / ', 'FacialAccClsEx', ' / ', 'FacialAccClsFacialCodeEx', 0, 215, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21500052, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 215, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21501001, '()', 'CREATERUSER', '()', ' ', 0, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21501002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21501003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21501004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21501006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 215, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21501007, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 215, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21501008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 215, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21501009, ' ', 'ClsType', ' ', 'ClsType', 0, 215, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21501010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 215, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21501011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 215, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21501012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 0, 215, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21501013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 215, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21501014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 215, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21501015, '', 'TreeOwner0', ' ()', ' ', 0, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21501016, ' 4', 'Quarter4', '4', 'Quarter4', 0, 215, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21501017, ' 3', 'Quarter3', '3', 'Quarter3', 0, 215, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21501018, ' 2', 'Quarter2', '2', 'Quarter2', 0, 215, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21501019, ' 1', 'Quarter1', '1', 'Quarter1', 0, 215, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21501020, '', 'Month12', '', 'Month12', 0, 215, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21501021, '', 'Month11', '', 'Month11', 0, 215, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21501022, '', 'Month10', '', 'Month10', 0, 215, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21501023, '', 'Month09', '', 'Month09', 0, 215, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21501024, '', 'Month08', '', 'Month08', 0, 215, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21501025, '', 'Month07', '', 'Month07', 0, 215, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21501026, '', 'Month06', '', 'Month06', 0, 215, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21501027, '', 'Month05', '', 'Month05', 0, 215, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21501028, '', 'Month04', '', 'Month04', 0, 215, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21501029, '', 'Month03', '', 'Month03', 0, 215, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21501030, '', 'Month02', '', 'Month02', 0, 215, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21501031, '', 'Month01', '', 'Month01', 0, 215, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21501032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 0, 215, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21501033, '  ', 'SenderId', '  ', 'SenderId', 0, 215, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21501034, ' ', 'RecordIndex', '  ', 'RecordIndex', 0, 215, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21501035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 215, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21501036, ' ', 'RegionCls', '', 'RegionCls', 0, 215, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21501037, '', 'BudgetRef', '', 'BUDGETREF', 0, 215, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21501038, '    ', ' ', '*    ', 'FUId', 0, 215, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21501039, ' ', 'Id', ' ', 'Id', 0, 215, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21501040, ' ', 'KDCode', ' ', 'KDValue', 0, 215, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21501041, '  ()', 'KD', '  ()', 'KD', 0, 215, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21501042, ' ', 'SubsidySumma', ' ', ' ', 0, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21501043, '   ', 'TotalSumma', '   ', ' ', 0, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21501044, '  ', 'HigherBudCls', '  ', ' ', 0, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21501045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 0, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21501052, ' / ', 'FacialAcc_ClsEx', ' / ', 'DestFacialAccClsFacialCodeEx', 0, 215, 1, 0, '', 0, 26617, 0, 0, '') ;

--   14 /, (1)
CALL ImportField(21510022, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 215, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(21510029, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 215, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21510046, '   ', 'StartDate', '   ', ' ', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21510047, '  ', 'EndDate', '  ', ' ', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21510051, ' / ', 'FacialCodeEx', ' / ', 'FacialAccClsFacialCodeEx', 1, 215, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21510052, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 215, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21511014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 215, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21511052, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 1, 215, 1, 0, '', 0, 26617, 0, 0, '') ;

--   14 /, +(2)
CALL ImportField(21511048, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 215, 1, 1, '', 0, null, 0, 1, '') ;

--    , (0)
CALL ImportField(21600054, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21600055, ' ', 'IsVised', ' ', 'IsVised', 0, 216, 0, 1, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(21610001, '()', 'CREATERUSER', '()', 'CREATERUSER_Cpt', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610003, '  ()', 'CREATEDATE', '  ()', ' ', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610004, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610005, ' ', 'Id', ' ', 'Id', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610006, ' ', 'Note1', ' ', 'Note1', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610007, '', 'BudgetRef', '', 'BudgetRef', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610008, '', 'Variant', '', 'Variant', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610009, '', 'Number', '', 'Number', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610010, ' ', 'DateInput', ' ', 'DateInput', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610011, '  ()', 'OrgRef', '  ()', 'DestOrgRef', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610012, '  ', 'RejectCls', '  ', 'RejectCls', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610013, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610014, ' ', 'CryptoStatus', ' ', 'CryptoStatus', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610015, '', 'DocStateRef', '', 'DocStateRef', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610016, '  ', 'SenderId', '  ', 'SenderId', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610017, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610018, '  ', 'SenderRecordID', '  ', 'SenderRecordID', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610019, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 216, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21610056, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 2, 216, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(21610057, ' ', 'Dat', ' ', 'Dat', 2, 216, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21610058, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 216, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21610059, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 2, 216, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21611002, '()', 'CREATERUSER', '()', 'CREATERUSER_Det', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611020, ' ', 'ClsType', ' ', 'ClsType', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611021, ' ', 'SUMMAYEAR1', ' ', 'SUMMAYEAR1', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611022, '', 'TreeOwner0', ' ()', ' ', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611023, ' 1', 'Quarter1', ' 1', 'Quarter1', 2, 216, 1, 0, '1', 0, null, 0, 0, '') ;

CALL ImportField(21611024, ' 2', 'Quarter2', ' 2', 'Quarter2', 2, 216, 1, 0, '2', 0, null, 0, 0, '') ;

CALL ImportField(21611025, ' 3', 'Quarter3', ' 3', 'Quarter3', 2, 216, 1, 0, '3', 0, null, 0, 0, '') ;

CALL ImportField(21611026, ' 4', 'Quarter4', ' 4', 'Quarter4', 2, 216, 1, 0, '4', 0, null, 0, 0, '') ;

CALL ImportField(21611027, '', 'Month01', '', 'Month01', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611028, '', 'Month02', '', 'Month02', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611029, '', 'Month03', '', 'Month03', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611030, '', 'Month04', '', 'Month04', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611031, '', 'Month05', '', 'Month05', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611032, '', 'Month06', '', 'Month06', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611033, '', 'Month07', '', 'Month07', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611034, '', 'Month08', '', 'Month08', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611035, '', 'Month09', '', 'Month09', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611036, '', 'Month10', '', 'Month10', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611037, '', 'Month11', '', 'Month11', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611038, '', 'Month12', '', 'Month12', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611039, '  ', 'SenderRecordId', '  ', 'SenderRecordId', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611040, '  ', 'SenderId', '  ', 'SenderId', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611041, ' ', 'RecordIndex', ' ', 'RecordIndex', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611042, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611043, '', 'KVSR', '()', 'DestKvsrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611044, '()', 'KVSRCode', '()', 'DestKvsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611045, '()', 'KFSR', '()', 'DestKfsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611046, '', 'KVR', '()', 'DestKvrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611047, '()', 'KVRCode', '()', 'DestKvr', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611048, '', 'KCSR', '()', 'DestKcsrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611049, '()', 'KCSRCode', '()', 'DestKcsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611050, '', 'Org_Ref', '', 'Org_Ref_Det', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611051, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 2, 216, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21611052, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611053, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611057, '', 'KD', '', 'KD', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611058, ' .  . . ()', 'IFS', ' ', 'IFS', 2, 216, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21611059, '', 'Note', '', 'Note', 2, 216, 1, 1, '', 0, 17431, 0, 0, '') ;

CALL ImportField(21611060, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 216, 1, 0, '', 0, null, 0, 2, '') ;

--    , (0)
CALL ImportField(21700018, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21700019, ' ', 'IsVised', ' ', 'IsVised', 0, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21700020, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21701036, ' .  . .', 'IFSCode', ' ()', 'IFS_FinSourceValue', 0, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21701037, '()', 'INN', '()', 'DestOrgInn', 0, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21701038, '()', 'INN20', '()', 'DestOrgKPP', 0, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21701052, '()', 'NAME', '()', 'DestOrgNAME', 0, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21701053, '', 'OrgParent', ' ', ' ', 0, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21702063, ' .  . .', 'IFSCode', ' ()', ' ', 0, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21702080, '', 'OrgParent', ' ', ' ', 0, 217, 2, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(21711032, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711033, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711034, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711035, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711039, '()', 'INN', '()', 'DestFacialAccClsOrgINN', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711040, '()', 'INN20', '()', 'DestFacialAccClsOrgKPP', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711043, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711044, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711045, ' ', 'KDValue', ' ', 'KDValue', 1, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711054, '()', 'NAME', '()', 'DestFacialAccClsOrgName', 1, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711055, '', 'OrgNameAndAcc', '', ' ', 1, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712060, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712061, '()', 'IFS_KVSRCode', '()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712062, '()', 'IFSAGCode', '()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712069, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712070, ' ()', 'KDKVSRCode', ' ()', 'KDKVSRCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712071, ' ', 'KDValue', ' ', 'KDValue', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712079, '', 'OrgNameAndAcc', '', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712081, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(21710001, '  ()', 'CREATEDATE', '  ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710002, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710003, '', 'BudgetRef', '', 'BudgetRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710004, ' ', 'ClsType', ' ', ' ', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710005, ' ', 'Dat', ' ', 'Dat', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710006, ' ', 'DateInput', ' ', 'DateInput', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710007, '', 'DocStateRef', ' ', 'DocStateRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710008, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710009, ' ', 'ID', ' ', 'ID', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710010, ' ', 'Note1', ' ', 'Note1', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710011, ' ', 'Number', ' ', 'Number', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710012, ' ', 'OrgRef', ' ', 'DestOrgRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710013, ' ', 'OrgName', ' ', 'DestOrgName', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710014, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710015, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710016, '  ', 'RejectCls', '  ', 'RejectCls', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710017, '', 'Variant', '', 'Variant', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710021, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710022, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21710023, '', 'KPPeriod', '', 'KPPeriod', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710024, '  ', 'SenderId', '  ', 'SenderId', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710025, '  ', 'SenderRecordID', '  ', 'SenderRecordID', 2, 217, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21710082, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 2, 217, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(21710083, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 217, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21710084, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 2, 217, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21711026, ' ', 'ClsType', ' ', 'ClsType', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711027, '', 'DayPlan', '', 'DayPlan', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711028, '', 'DayPlanSumma', '', 'DayPlanSumma', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711029, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711030, ' ', 'Id', ' ', 'Id', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711031, ' .  . . ()', 'IFS', '()', 'IFS', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711041, '()', 'KCSRCode', '()', 'DestKcsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711042, '', 'KD', '', 'KD', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711046, '()', 'KESRCODE', '()', 'DestKesr', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711047, '()', 'KFSR', '()', 'DestKfsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711048, '()', 'KVRCode', '()', 'DestKvr', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711049, '()', 'KVSRCode', '()', 'DestKvsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711050, '  ', 'RecordIndex', '  ', 'RecordIndex', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711051, '', 'TreeOwner0', '', ' ', 2, 217, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21711052, '', 'Note', '', 'Note', 2, 217, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21711053, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 217, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21712056, ' ', 'ClsType', ' ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712057, ' ', 'FacialAcc_Cls', ' ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712058, '/ ', 'FacialCode', '/ ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712059, ' .  . . ()', 'IFS', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712064, '()', 'INN', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712065, '()', 'INN20', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712066, '', 'KCSR', ' ()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712067, '()', 'KCSRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712068, '', 'KD', '', 'KD', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712072, '', 'KESR', ' ()', 'DestKesrKey', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712073, '()', 'KESRCODE', '()', 'DestKesr', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712074, '()', 'KFSR', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712075, '', 'KVR', ' ()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712076, '()', 'KVRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712077, '', 'KVSR', ' ()', 'DestKvsrKey', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712078, '()', 'KVSRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712082, '', 'Note', '', 'Note', 2, 217, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21712083, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 217, 2, 0, '', 0, null, 0, 2, '') ;

--  , (0)
CALL ImportField(21801106, '', 'KDCode', '', 'KDValue', 0, 218, 1, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(21810003, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 218, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21810004, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 218, 0, 1, '', 0, 17480, 0, 0, '') ;

CALL ImportField(21810030, '  ', 'SenderID', '  ', 'SenderId', 1, 218, 0, 1, '', 0, 17475, 0, 0, '') ;

CALL ImportField(21811100, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 218, 1, 1, '', 0, 25472, 0, 0, '') ;

CALL ImportField(21811101, '  ', 'RegionCls_name', '  ', ' ', 1, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811102, ' ', 'KDValue', ' ', 'KDValue', 1, 218, 1, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(21811103, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 218, 1, 1, '', 0, 38908, 0, 0, '') ;

CALL ImportField(21811104, ' ()', 'KDKVSRCode', ' ()', 'KDKVSRCode', 1, 218, 1, 1, '', 0, 25472, 0, 0, '') ;

CALL ImportField(21811105, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 218, 1, 0, '', 0, 16834, 0, 0, '') ;

CALL ImportField(21811138, '', 'AUTO_AUTORIZATION', '', ' ', 1, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811139, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 218, 1, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(21810001, ' ', 'ID', ' ', 'ID', 2, 218, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21810002, ' ', 'CryptoStatus', ' ', 'CryptoStatus', 2, 218, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21810005, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810006, '  ()', 'CREATEDATE', '  ()', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810007, '', 'NUMBER', '', 'Number', 2, 218, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21810008, '', 'Variant', '', 'Variant', 2, 218, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21810009, ' ', 'DateInput', ' ', 'DateInput', 2, 218, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21810010, ' ', 'DAT', ' ', 'Dat', 2, 218, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21810011, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 218, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21810012, '', 'BUDGETREF', '', 'BudgetRef', 2, 218, 0, 0, '', 0, 17472, 0, 0, '') ;

CALL ImportField(21810013, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 2, 218, 0, 1, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21810014, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 2, 218, 0, 1, '', 0, 17501, 0, 0, '') ;

CALL ImportField(21810015, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 2, 218, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(21810016, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 2, 218, 0, 1, '', 0, 17487, 0, 0, '') ;

CALL ImportField(21810017, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 2, 218, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(21810018, ' ', 'DOCDAT', ' ', 'DocDat', 2, 218, 0, 1, '', 0, 17466, 0, 0, '') ;

CALL ImportField(21810019, ' ', 'DOCNUMBER', ' ', 'DocNumber', 2, 218, 0, 1, '', 0, 17467, 0, 0, '') ;

CALL ImportField(21810020, '()', 'NOTE', '()', 'Note', 2, 218, 0, 0, '', 0, 17468, 0, 0, '') ;

CALL ImportField(21810021, ' ()', 'NOTE2', ' ()', 'NOTE2', 2, 218, 0, 1, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21810022, ' ', 'DocBaseCode', ' ', 'DocBase', 2, 218, 0, 0, ',', 0, 36865, 0, 0, '') ;

CALL ImportField(21810023, ' ()', 'DocBaseParent', ' ()', ' ', 2, 218, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21810024, '  ()', 'DocBase', '  ()', 'DocBaseKey', 2, 218, 0, 1, ',', 0, 17473, 0, 0, '') ;

CALL ImportField(21810025, ' ()', 'OrgRef', ' ', 'DestOrgRef', 2, 218, 0, 1, '', 0, 17484, 0, 0, '') ;

CALL ImportField(21810026, ' ', 'NOTE1', ' ', 'Note1', 2, 218, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21810027, '  ', 'REJECTCLS', '  ', 'RejectCls', 2, 218, 0, 0, '', 0, 17485, 0, 0, '') ;

CALL ImportField(21810028, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 218, 0, 0, '', 0, 17486, 0, 0, '') ;

CALL ImportField(21810029, ' ', 'DocStateRef', ' ', 'DocStateRef', 2, 218, 0, 1, '', 0, 17492, 0, 0, '') ;

CALL ImportField(21810031, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 218, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21810032, ' /', 'FacialCodeEx', ' /', 'FacialAccClsFacialCodeEx', 2, 218, 0, 1, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21810033, '', 'NOTIFYTYPE', '', 'NotifyType', 2, 218, 0, 0, '', 0, 17471, 0, 0, '') ;

CALL ImportField(21810034, '', 'RootDoc', '', 'RootDoc', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810035, ' ', 'AgrDocNumber', ' ', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810036, ' ', 'AgreementDate', ' ', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810037, '  ', 'AgrReestrNumber', '  ', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21810038, '  ()', 'AgrSumma', '  ()', ' ', 2, 218, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21810039, '    ', 'SummaYear1', '    ', 'SummaYear1', 2, 218, 0, 0, '1', 0, null, 0, 0, '') ;

CALL ImportField(21810040, '      ', 'SummaYear2', '      ', 'SummaYear2', 2, 218, 0, 0, '2', 0, null, 0, 0, '') ;

CALL ImportField(21810041, '      ', 'SummaYear3', '      ', 'SummaYear3', 2, 218, 0, 0, '3', 0, null, 0, 0, '') ;

CALL ImportField(21810042, '      ', 'SummaYear4', '', 'SummaYear4', 2, 218, 0, 0, '4', 0, null, 0, 0, '') ;

CALL ImportField(21810043, '    ', 'SummaOtherYears', '', 'SummaOtherYears', 2, 218, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21810044, '/', 'RootDocHeader', '', ' ', 2, 218, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21810143, '   ()', 'PayTargetFunds', '   ', ' ', 2, 218, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811045, '  ()', 'TransfertCls', '   ()', 'TransfertCls', 2, 218, 1, 1, '', 0, 17460, 0, 0, '') ;

CALL ImportField(21811046, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 2, 218, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(21811047, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 2, 218, 1, 0, '', 0, 25326, 0, 0, '') ;

CALL ImportField(21811048, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 2, 218, 1, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21811049, '', 'TreeOwner0', '', ' ', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21811050, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811051, '', 'OrgNameAndAcc', '', ' ', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811052, '()', 'INN', '()', 'DestOrgInn', 2, 218, 1, 1, '', 0, 16645, 0, 0, '') ;

CALL ImportField(21811053, '()', 'INN20', '()', 'DestOrgKpp', 2, 218, 1, 1, '', 0, 16653, 0, 0, '') ;

CALL ImportField(21811054, '()', 'NAME', '()', 'DestOrgNAME', 2, 218, 1, 1, '', 0, 16646, 0, 0, '') ;

CALL ImportField(21811055, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 2, 218, 1, 0, '', 0, 17451, 0, 0, '') ;

CALL ImportField(21811056, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 2, 218, 1, 0, '', 0, 17462, 0, 0, '') ;

CALL ImportField(21811057, ' ', 'ProgIndex', '  ', 'ProgIndex', 2, 218, 1, 1, '', 0, 17432, 0, 0, '') ;

CALL ImportField(21811058, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 2, 218, 1, 0, '', 0, 17456, 0, 0, '') ;

CALL ImportField(21811059, '', 'KVR', '()', 'DestKvrKey', 2, 218, 1, 1, '', 0, 17414, 0, 0, '') ;

CALL ImportField(21811060, '', 'KVSR', '()', 'DestKvsrKey', 2, 218, 1, 1, '', 0, 17412, 0, 0, '') ;

CALL ImportField(21811061, '', 'BUDGETREF', '', 'BUDGETREF', 2, 218, 1, 0, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21811062, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 2, 218, 1, 1, '', 0, 17433, 0, 0, '') ;

CALL ImportField(21811063, ' ', 'ID', ' ', 'ID', 2, 218, 1, 1, '', 0, 17409, 0, 0, '') ;

CALL ImportField(21811064, '()', 'KFSR', '()', 'DestKfsr', 2, 218, 1, 0, '', 0, 17411, 0, 0, '') ;

CALL ImportField(21811065, '', 'KCSR', '()', 'DestKcsrKey', 2, 218, 1, 1, '', 0, 17413, 0, 0, '') ;

CALL ImportField(21811066, '', 'KESR', '', 'DestKesrKey', 2, 218, 1, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(21811067, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 2, 218, 1, 0, '', 0, 17419, 0, 0, '') ;

CALL ImportField(21811068, '', 'FACTCODE', '()', 'DestFactCls', 2, 218, 1, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(21811069, '', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 2, 218, 1, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(21811070, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 2, 218, 1, 0, '', 0, 17454, 0, 0, '') ;

CALL ImportField(21811071, '', 'NOTE', '', 'NOTE', 2, 218, 1, 0, '', 0, 17431, 0, 0, '') ;

CALL ImportField(21811072, ' ', 'REGIONCLS', '', 'RegionCls', 2, 218, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21811073, '', 'Month01', '', 'Month01', 2, 218, 1, 0, '', 0, 17436, 0, 0, '') ;

CALL ImportField(21811074, '', 'Month02', '', 'Month02', 2, 218, 1, 0, '', 0, 17437, 0, 0, '') ;

CALL ImportField(21811075, '', 'Month03', '', 'Month03', 2, 218, 1, 0, '', 0, 17438, 0, 0, '') ;

CALL ImportField(21811076, '', 'Month04', '', 'Month04', 2, 218, 1, 0, '', 0, 17439, 0, 0, '') ;

CALL ImportField(21811077, '', 'Month05', '', 'Month05', 2, 218, 1, 0, '', 0, 17440, 0, 0, '') ;

CALL ImportField(21811078, '', 'Month06', '', 'Month06', 2, 218, 1, 0, '', 0, 17441, 0, 0, '') ;

CALL ImportField(21811079, '', 'Month07', '', 'Month07', 2, 218, 1, 0, '', 0, 17442, 0, 0, '') ;

CALL ImportField(21811080, '', 'Month08', '', 'Month08', 2, 218, 1, 0, '', 0, 17443, 0, 0, '') ;

CALL ImportField(21811081, '', 'Month09', '', 'Month09', 2, 218, 1, 0, '', 0, 17444, 0, 0, '') ;

CALL ImportField(21811082, '', 'Month10', '', 'Month10', 2, 218, 1, 0, '', 0, 17445, 0, 0, '') ;

CALL ImportField(21811083, '', 'Month11', '', 'Month11', 2, 218, 1, 0, '', 0, 17446, 0, 0, '') ;

CALL ImportField(21811084, '', 'Month12', '', 'Month12', 2, 218, 1, 0, '', 0, 17447, 0, 0, '') ;

CALL ImportField(21811085, ' 1', 'QUARTER1', ' 1', 'Quarter1', 2, 218, 1, 0, '1', 0, 17421, 0, 0, '1') ;

CALL ImportField(21811086, ' 2', 'QUARTER2', ' 2', 'Quarter2', 2, 218, 1, 0, '2', 0, 17422, 0, 0, '2') ;

CALL ImportField(21811087, ' 3', 'QUARTER3', ' 3', 'Quarter3', 2, 218, 1, 0, '3', 0, 17423, 0, 0, '3') ;

CALL ImportField(21811088, ' 4', 'QUARTER4', ' 4', 'Quarter4', 2, 218, 1, 0, '4', 0, 17424, 0, 0, '4') ;

CALL ImportField(21811089, '  ', 'SUMMAYEAR2', '  ', 'SUMMAYEAR2', 2, 218, 1, 0, '', 0, 17458, 0, 0, '') ;

CALL ImportField(21811090, ' ', 'SUMMAYEAR1', ' ', 'SUMMAYEAR1', 2, 218, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21811091, '  ', 'SUMMAYEAR3', '  ', 'SUMMAYEAR3', 2, 218, 1, 0, '', 0, 17459, 0, 0, '') ;

CALL ImportField(21811092, '', 'SUBKESR', '', 'DestSubKesrKey', 2, 218, 1, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(21811093, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 2, 218, 1, 0, '', 0, 17426, 0, 0, '') ;

CALL ImportField(21811094, ' . ', 'FINTYPECODE', '  ', 'DestFINTYPECls', 2, 218, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(21811095, ' ', 'ClsType', ' ', 'ClsType', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811096, ' ()', 'DescriptionCode', ' ()', 'DescriptionCode', 2, 218, 1, 1, '', 0, 16831, 0, 0, '') ;

CALL ImportField(21811097, ' ', 'IFS', ' ', 'IFS', 2, 218, 1, 0, '', 0, 17452, 0, 0, '') ;

CALL ImportField(21811098, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 2, 218, 1, 1, '', 0, 17050, 0, 0, '') ;

CALL ImportField(21811099, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811107, '()', 'KCSRCode', '()', 'DestKcsr', 2, 218, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(21811108, '', 'KD', '', 'KD', 2, 218, 1, 0, '', 0, 25270, 0, 0, '') ;

CALL ImportField(21811109, '()', 'KVRCode', '()', 'DestKvr', 2, 218, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(21811110, '()', 'KVSRCode', '()', 'DestKvsr', 2, 218, 1, 1, '', 0, 25472, 0, 0, '') ;

CALL ImportField(21811111, '.  ', 'SubKD', '.  ', 'SUBKD', 2, 218, 1, 0, '', 0, 25271, 0, 0, '') ;

CALL ImportField(21811112, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 2, 218, 1, 1, '', 0, 26542, 0, 0, '') ;

CALL ImportField(21811113, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 2, 218, 1, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(21811114, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21811115, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 2, 218, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(21811116, '  ', 'SubsidyClsOldCode', '', 'SubsidyClsOldCode', 2, 218, 1, 1, '', 0, 26641, 0, 0, '') ;

CALL ImportField(21811117, '  ', 'PayPromiseCls', '  ', 'PayPromiseCls', 2, 218, 1, 1, '', 0, 27835, 0, 0, '') ;

CALL ImportField(21811118, '  ', 'SubsidyClsOld', '  ', 'SubsidyClsOld', 2, 218, 1, 1, '', 0, 27836, 0, 0, '') ;

CALL ImportField(21811119, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 2, 218, 1, 1, '', 0, 17450, 0, 0, '') ;

CALL ImportField(21811120, ' ()', 'FACT', '()', 'DestFactClsKey', 2, 218, 1, 1, '', 0, 17418, 0, 0, '') ;

CALL ImportField(21811121, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 2, 218, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(21811122, '', 'InvestObjectCode', '', 'InvestObject', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21811123, '', 'InvestObject', '', 'InvestObjectKey', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811124, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811125, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21811126, ' ', 'SUMMAOTHERYEARS', ' ', 'SUMMAOTHERYEARS', 2, 218, 1, 0, '', 0, 39880, 0, 0, '') ;

CALL ImportField(21811127, '  ', 'SUMMAYEAR4', '  ', 'SUMMAYEAR4', 2, 218, 1, 0, '', 0, 39879, 0, 0, '') ;

CALL ImportField(21811128, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 218, 1, 1, '', 0, null, 0, 2, '') ;

CALL ImportField(21811129, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 218, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21811130, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 218, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21811131, '()', 'KESRCODE', '()', 'DestKesr', 2, 218, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(21811132, '()', 'SUBKESRCode', '()', 'DestSubKesr', 2, 218, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(21811133, ' / ', 'FacialCodeEx', ' / ', 'DestFacialAccClsFacialCodeEx', 2, 218, 1, 1, '', 0, 26617, 0, 0, '') ;

CALL ImportField(21811134, '  ', 'RegProjectResultCode', '  ', 'RegProjectResultCode', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21811135, '  ()', 'RegProjectResult', '  ', 'RegProjectResult', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811136, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 218, 1, 1, '', 0, 17427, 0, 0, '') ;

CALL ImportField(21811137, '  ', 'SenderID', '  ', 'SenderId', 2, 218, 1, 1, '', 0, 17434, 0, 0, '') ;

CALL ImportField(21811140, '  ()', 'CREATEDATE', '  ()', ' ', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811141, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 218, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21811142, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 218, 1, 0, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(30000001, ' ', '{("")}', ' () ', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000002, '  ', '{("")}', '   ', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000003, '  ()', '{("")}', '  ()', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000004, '  ', '{("")}', '  ( )', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000005, ' ', '{("")}', ' ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000006, ' ', '{("")}', ' ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000007, '', '{("")}', ' ', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000008, ' ', '{("")}', '    (   )', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000009, ' ', '{("")}', ' ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000010, ' ', '{("")}', ' ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000011, '  ', '{("")}', '  ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000012, ' ', '{("")}', ' ', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000013, '', '{("")}', ' ', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000015, ' ', '{("")}', '', ' ', 0, 300, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30000021, '', '{("")}', '   ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000022, ' ', '{("")}', ' ', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000023, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000024, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30000025, '  ()', 'CREATEDATE', '  ()', ' ', 0, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001014, '', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001016, ' ', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001017, '  ', '{("")}', '  ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001018, '   ()', '{("")}', '   ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001019, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001020, '  ', '{("")}', '  ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001022, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001023, '  ()', '{("")}', '  ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001024, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001025, '', '{("")}', '  ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001026, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001027, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001028, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001029, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001030, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001031, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001032, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001033, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001034, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001035, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001036, ' .() ', '{("")}', ' .() ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001037, ' .()', '{("")}', ' .()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001038, '  ( ..)', '{("")}', '  ( ..)', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001039, '  ', '{("")}', '  ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001040, '  ()', '{("")}', '  ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001041, '', '{("")}', '       ', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001042, '', '{("")}', '      ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001043, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001044, '', '{("")}', ' ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001045, ' ', '{("")}', '- ()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001046, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001047, ' ', '{("")}', '  ()', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001048, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001049, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001050, '  ()', 'CREATEDATE', '  ()', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001051, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001054, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001055, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001056, '', '{("")}', ' ()', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001057, '', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001058, '()', '{("")}', '()', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001059, ' ', '{("")}', ' ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001060, ' . ', '{("")}', '  ', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001061, ' .  ()', '{("")}', '  ', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001062, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001063, ' ()', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001064, ' ', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001065, '  ()', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001066, '  ', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001067, '   ()', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30001068, '', '{("")}', '', ' ', 0, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30001069, '', '{("")}', '', ' ', 0, 300, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(30011024, ' ', '{("")}', ' ', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011026, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011027, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011028, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011029, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011030, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011031, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011032, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011033, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011053, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011054, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011055, '', '{("")}', ' ()', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011056, '', '{("")}', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011057, '()', '{("")}', '()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011058, ' ', '{("")}', ' ', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011059, ' . ', '{("")}', '  ', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011060, ' .  ()', '{("")}', '  ', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011061, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011062, ' ()', '{("")}', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011063, ' ', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011064, ' ', '{("")}', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011065, '  ', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011066, '  ', '{("")}', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011067, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011068, '', '{("")}', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(30100001, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100002, ' ', 'SourceAccountName', ' ', 'SOURCEACCOUNTNAME', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100003, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100004, ' ', 'Reject_Cls', ' ', 'REJECTCLS', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100005, ' ', 'BuhPaymentCls', ' ', 'BUHPAYMENTCLS', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100006, '  ()', 'Note', '  ()', 'NOTE', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100007, ' ()', 'Summa', ' ()', 'SUMMA', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100008, '  ', 'SourceFacialAcc_Cls', '  ', 'SourceFacialAccCls', 0, 301, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30100009, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100010, '    ', ' ', '    ', 'SourceFKFacialCode', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100011, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100012, ' ', 'TypeOperationCls', ' ', 'OperationTypeCls', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100013, ' ', 'ID', ' ', 'ID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100014, '  ', 'FUID', '  ', 'FUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100015, '  ', ' ', '  ', 'SenderRecordID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100016, '  ', ' ', '  ', 'SenderID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100018, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100019, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100020, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100023, ' ', ' ', ' ', 'CARDNUMBER', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100024, '  /c ', 'SOURCEACCOUNT', '  /c ', 'SOURCEACCOUNT', 0, 301, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30100025, '   -', 'DESTACCOUNT', '   -', 'DESTACCOUNT', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100026, '\ ', ' ', '\ ', 'DestFacialAccCls', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100027, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100028, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100029, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100030, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100031, ' ', 'IsVised', ' ', 'IsVised', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100032, ' ', ' ', ' ', 'BidNumber', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100033, ' ', ' ', ' ', 'ManagerBid', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100034, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100035, ' ', ' ', ' ', 'StimateID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100038, '  ', ' ', '  ', 'ManBidFuid', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100040, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100041, '', ' ', '', 'DEPARTMENTCLS', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100043, '   ', 'SoftRejectCause', '   ', 'SoftRejectCause', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100044, '    ', ' ', '    ', 'DestAccountFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100046, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100047, ' ', ' ', ' ', 'DestFKFacialCode', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100048, '   ', ' ', '   ', 'DestOrgId', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100049, '    ', ' ', '    ', 'DestOrgFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100050, ' -', ' ', ' -', 'DestOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100051, ' -', ' ', ' -', 'DestOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100052, ' -', ' ', ' -', 'DestOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100053, ' -', ' ', ' -', 'DestOrgCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100054, ' ', ' ', ' ', 'DestBankFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100055, '  ', ' ', '  ', 'DestBankName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100056, '  ', ' ', '  ', 'DestBankBIK', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100057, '.  ', ' ', '.  ', 'DestBankCor', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100058, '   ', ' ', '   ', 'DestBankCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100059, ' \ ', ' ', ' \ ', 'DestFacialAccClsName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100060, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100061, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100062, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100063, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100064, '  ()', ' ', '  ()', 'DestFKOrgId', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100065, '   ', ' ', '   ', 'DestFKOrgFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100066, '   ', ' ', '   ', 'DestFKOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100067, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100068, '  ', ' ', '  ', 'DestFKOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100069, '   ', ' ', '   ', 'DestFKOrgCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100070, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100071, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100072, '   ', ' ', '   ', 'SourceOrgId', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100073, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100074, ' -', ' ', ' -', 'SourceOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100075, ' -', ' ', ' -', 'SourceOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100076, ' -', ' ', ' -', 'SourceOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100077, ' -', ' ', ' -', 'SourceOrgCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100078, ' ', ' ', ' ', 'SourceBankFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100079, '  ', ' ', '  ', 'SourceBankName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100080, '  ', ' ', '  ', 'SourceBankBIK', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100081, '.  ', ' ', '.  ', 'SourceBankCor', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100082, '   ', ' ', '   ', 'SourceBankCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100083, '\ ', 'SourceFacialAccName', '\ ', 'SourceFacialAccClsName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100084, ' \ ', 'SourceFacialCode', ' \ ', 'SourceFacialAccClsFacialCode', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100085, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100086, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100087, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100088, '  ()', ' ', '  ()', 'SourceFKOrgId', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100089, '   ', ' ', '   ', 'SourceFKOrgFUID', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100090, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100091, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100092, '  ', ' ', '  ', 'SourceFKOrgName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100093, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100094, '', '', ' ', '', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100133, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100134, '', 'BUDGETREF', '', 'BudgetRef', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100149, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 301, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30100160, ' ', 'DocStateName', ' ', 'DocStateName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100161, '.  (.)', 'DestAccountName', '.  (.)', 'DestAccountName', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100176, '  ', 'Accepted', '  ', 'Accepted', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100177, ' ', 'Reestr_Ref', ' ', 'Reestr_Ref', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100178, '  ', 'SourceRegionBudgetEst', '   ', 'SourceRegionBudgetEst', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100179, '()', 'CREATERUSER', '()', ' ', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100180, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100181, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30100182, '  ()', 'CREATEDATE', '  ()', ' ', 0, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101001, '   ', 'Note', '   ', 'NOTE', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101002, ' .  .', 'SourceFinTypeCode', '   ', 'SourceFINTYPECLS', 0, 301, 1, 0, ',,,', 0, null, 0, 0, '') ;

CALL ImportField(30101003, '  ', 'SourceFinSource', '  ', 'SourceFINSOURCECLS', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101004, '  ', 'DestFacialAcc_Cls', '  ', 'DestFacialAccCls', 0, 301, 1, 0, ',DestFacialACCCLS', 0, null, 0, 0, '') ;

CALL ImportField(30101005, '    ', 'DestFacialCode', '    ', 'DestFacialAccClsFacialCode', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101006, ' -', 'DestKVR', ' ', 'DestKVRKey', 0, 301, 1, 1, 'DestKVR,', 0, null, 0, 0, '') ;

CALL ImportField(30101007, ' -', 'DestKESR', ' ', 'DestKESRKey', 0, 301, 1, 1, 'DestKESR,', 0, 18871, 0, 0, '') ;

CALL ImportField(30101008, ' ', 'DestKFSR', ' ', 'DestKFSR', 0, 301, 1, 0, 'DestKFSR,', 0, null, 0, 0, '') ;

CALL ImportField(30101009, ' . ', 'MemOrderNum', ' . ', 'MemOrderNum', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101010, ' -', 'DestKCSR', ' ', 'DestKCSRKey', 0, 301, 1, 1, 'DestKCSR,', 0, null, 0, 0, '') ;

CALL ImportField(30101011, '  ', 'DestFinSource', '  ', 'DestFINSOURCECLS', 0, 301, 1, 0, 'DestFinSource,', 0, null, 0, 0, '') ;

CALL ImportField(30101012, ' .  -', 'DestFinTypeCode', '   ', 'DestFINTYPECLS', 0, 301, 1, 0, 'DestFinType,,', 0, null, 0, 0, '') ;

CALL ImportField(30101013, '  ', 'DestMeansType', '  ', 'DestMEANSTYPECLS', 0, 301, 1, 0, 'DestMeansType,', 0, null, 0, 0, '') ;

CALL ImportField(30101014, '  ', 'SourceMeansType', '  ', 'SourceMEANSTYPECLS', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101015, ' ', 'DestFactCode', ' ', 'DestFACTCLS', 0, 301, 1, 0, 'DestFact,', 0, null, 0, 0, '') ;

CALL ImportField(30101016, '  ', 'SourcePromise', '  ', 'SOURCEPROMISE', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101017, ' ', 'DestSubKESR', ' ', 'DestSubKESR,', 0, 301, 1, 1, 'DestSubKESR,', 0, 18898, 0, 0, '') ;

CALL ImportField(30101018, ' - ()', 'DestKVSR', ' - ()', 'DestKVSRKey', 0, 301, 1, 1, 'DestKVSR,', 0, null, 0, 0, '') ;

CALL ImportField(30101019, '  ', 'DestPromise', '  ', 'DestPROMISE', 0, 301, 1, 0, 'DestPromise,', 0, null, 0, 0, '') ;

CALL ImportField(30101020, ' ', 'SourceDirectionClsCode', ' ', 'SourceDirectionCLS', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101021, ' ', 'SourceFactCode', ' ', 'SourceFACTCLS', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101022, ' ', 'DestDirectionClsCode', ' ', 'DestDirectionCLS', 0, 301, 1, 0, 'DestDirectionCls,', 0, null, 0, 0, '') ;

CALL ImportField(30101023, '   ', 'Summa', '   ', 'SUMMA', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101024, ' .', 'SourceKVR', ' ', 'SourceKVRKey', 0, 301, 1, 1, 'SourceKVR,', 0, null, 0, 0, '') ;

CALL ImportField(30101025, ' .', 'SourceKESR', ' ', 'SourceKESRKey', 0, 301, 1, 1, 'SourceKESR,,', 0, 18868, 0, 0, '') ;

CALL ImportField(30101026, ' ', 'SourceKFSR', ' ', 'SourceKFSR', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101027, ' .', 'SourceKCSR', ' ', 'SourceKCSRKey', 0, 301, 1, 1, 'SourceKCSR,', 0, null, 0, 0, '') ;

CALL ImportField(30101028, ' . ()', 'SourceKVSR', ' . ()', 'SourceKVSRKey', 0, 301, 1, 1, 'SourceKVSR,', 0, null, 0, 0, '') ;

CALL ImportField(30101029, ' .', 'SourceSubKESR', ' ', 'SourceSUBKESRKey', 0, 301, 1, 1, ',,SourceSubKESR', 0, 18889, 0, 0, '') ;

CALL ImportField(30101031, '  ()', 'SourceBudgetPromiseNum', '  ()', '  ', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101032, '  ', 'SourceExecDocCollaps', '  ', '  ', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101033, '    ', 'SourceExecDoc', '    ', '    ', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101034, '   ', 'SourceExecDocNum', '   ', '   ', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101035, '   ', 'SourceExecDocReestr', '   ', '   ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101036, '  ', 'SourceExecDocDate', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101037, '  ', 'SourceExecDocType', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101038, '   ', 'SourceExecDocSumma', '   ', '   ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101039, '  ', 'SourceExecDocNote', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101040, '     ', 'DestBudgetPromise', '     ', '     ', 0, 301, 1, 1, 'DestBUDGETPROMISE,', 0, null, 0, 0, '') ;

CALL ImportField(30101041, '  ()', 'DestBudgetPromiseNum', '  ()', '  ', 0, 301, 1, 0, 'DESTBUDGETPROMISENUM,', 0, null, 0, 0, '') ;

CALL ImportField(30101042, '  ', 'DestExecDocCollaps', '  ', '  ', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101043, '    ', 'DestExecDoc', '    ', '    ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101044, '   ', 'DestExecDocNum', '   ', '   ', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101045, '   ', 'DestExecDocReestr', '   ', '   ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101046, '  ', 'DestExecDocDate', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101047, '  ', 'DestExecDocType', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101048, '   ', 'DestExecDocSumma', '   ', '   ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101049, '  ', 'DestExecDocNote', '  ', '  ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101050, '  ', 'SourceBudgetPromiseCollaps', '  ', 'SourceBudgetPromiseCollaps', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101051, '  ', 'SourceBudgetPromiseSumma', '  ', 'SourceBudgetPromiseSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101052, '  ', 'SourceBudgetPromiseDocNumber', '  ', 'SourceBudgetPromiseDocNumber', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101053, '  ', 'SourceBudgetPromiseDocDate', '  ', 'SourceBudgetPromiseDocDate', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101054, '  ', 'SourceBudgetPromiseDocSumma', '  ', 'SourceBudgetPromiseDocSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101055, '  .', 'SourceBudgetPromiseDocReestrNum', '  .', 'SourceBudgetPromiseDocReestrNum', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101056, '.  ', 'SourceBudgetPromiseDocNote', '.  ', 'SourceBudgetPromiseDocNote', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101057, ' .  ', 'SourceBudgetPromiseSONum', ' .  ', 'SourceBudgetPromiseSONum', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101058, ' .  ', 'SourceBudgetPromiseSODate', ' .  ', 'SourceBudgetPromiseSODate', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101059, ' .  ', 'SourceBudgetPromiseSOSumma', ' .  ', 'SourceBudgetPromiseSOSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101060, '  .  ', 'SourceBudgetPromiseSOReestrNum', '  .  ', 'SourceBudgetPromiseSOReestrNum', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101061, '. .  ', 'SourceBudgetPromiseSONote', '. .  ', 'SourceBudgetPromiseSONote', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101062, '  ', 'DestBudgetPromiseCollaps', '  ', 'DestBudgetPromiseCollaps', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101063, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101064, '   ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101065, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101066, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101067, '  . ', 'DestBudgetPromiseDocReestrNum', '  . ', 'DestBudgetPromiseDocReestrNum', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101068, '.  ', 'DestBudgetPromiseDocNote', '.  ', 'DestBudgetPromiseDocNote', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101069, ' .  ', 'DestBudgetPromiseSONum', ' .  ', 'DestBudgetPromiseSONum', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101070, ' .  ', 'DestBudgetPromiseSODate', ' .  ', 'DestBudgetPromiseSODate', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101071, ' .  ', 'DestBudgetPromiseSOSumma', ' .  ', 'DestBudgetPromiseSOSumma', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101072, '  .   ', 'DestBudgetPromiseSOReestrNum', '  .  ', 'DestBudgetPromiseSOReestrNum', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101073, '. .   ', 'DestBudgetPromiseSONote', '. .  ', 'DestBudgetPromiseSONote', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101074, ' ', 'Id', ' ', 'Id', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101075, '  ', 'FUID', '  ', 'FUID', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101076, '  ', ' ', '  ', 'SenderRecordID', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101077, '  ', ' ', '  ', 'SenderID', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101078, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101079, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101080, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101081, ' ', 'ClsType', ' ', 'ClsType', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101085, '  ', 'DestDOCTYPE', '  ', 'DestDOCTYPECLS', 0, 301, 1, 0, 'DESTDocType,', 0, null, 0, 0, '') ;

CALL ImportField(30101086, ' - ()', 'DestIFS', ' ', 'DestIFS', 0, 301, 1, 1, 'DestIFS,', 0, null, 0, 0, '') ;

CALL ImportField(30101089, '  ', 'SourceBUDGETPROMISE', '  ', 'SourceBUDGETPROMISE', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101090, '\ ', 'SourceFacialAcc_Cls', '\ ', 'SourceFacialAccCls', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101091, '  ', 'SourceDOCTYPE', '  ', 'SourceDOCTYPECLS', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101092, ' ', 'SourceIFS', ' ', 'SourceIFS', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101093, ' ', ' ', ' ', 'StimateID', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101102, ' ', 'DestRegionCls', ' ', 'DestRegionCls', 0, 301, 1, 0, 'DestRegionCls,,', 0, null, 0, 0, '') ;

CALL ImportField(30101103, ' ', 'DestDocBaseCode', ' ', 'DestDocBase', 0, 301, 1, 0, 'DestDocBase,,', 0, null, 0, 0, '') ;

CALL ImportField(30101104, ' ', 'SourceDocBaseCode', ' ', 'SourceDocBase', 0, 301, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(30101105, ' ', 'SourceRegionCls', ' ', 'SourceRegionCls', 0, 301, 1, 0, ',,,', 0, null, 0, 0, '') ;

CALL ImportField(30101124, ' ', 'TreeOwner0', ' ', ' ', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101125, ' ', 'TreeOwner1', ' ', ' ', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101135, '', 'BUDGETREF', '', 'BudgetRef', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101150, '  ', 'DestTransfertCls', '    ()', 'DestTransfertCls', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101151, '   -', 'DestTransfertClsCode', '   ', 'DestTransfertClsValue', 0, 301, 1, 0, ',DestTransfertClsCode', 0, null, 0, 0, '') ;

CALL ImportField(30101152, '  ', 'SourceTransfertCls', '    ()', 'SourceTransfertCls', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101153, '   .', 'SourceTransfertClsCode', '   ', 'SourceTransfertClsValue', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101154, ' -( -)', 'DestKCSRCode', '', 'DestKCSR', 0, 301, 1, 0, ',DestKCSRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101155, ' -( -)', 'DESTKVRCode', '', 'DestKVR', 0, 301, 1, 0, ',DESTKVRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101156, ' -', 'DestKVSRCode', ' -', 'DestKVSR', 0, 301, 1, 0, ',DestKVSRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101157, ' .( .)', 'SourceKCSRCode', '', 'SourceKCSR', 0, 301, 1, 0, ',,SourceKCSRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101158, ' .( .)', 'SOURCEKVRCode', '', 'SourceKVR', 0, 301, 1, 0, ',,SOURCEKVRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101159, ' .', 'SourceKVSRCode', ' .', 'SourceKVSR', 0, 301, 1, 0, ',,SourceKVSRCode', 0, null, 0, 0, '') ;

CALL ImportField(30101161, '', 'DestFacialAccName', '', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101162, ' - ()', 'DestKD', ' ', 'DestKD', 0, 301, 1, 1, 'DestKD,', 0, null, 0, 0, '') ;

CALL ImportField(30101163, ' -', 'DestIFSCode', ' ( )', 'DestIFS_DescriptionCode', 0, 301, 1, 0, 'DestIFS_FullID,', 0, null, 0, 0, '') ;

CALL ImportField(30101165, ' -', 'DestKDCode', ' ', 'DestKDValue', 0, 301, 1, 0, ',DestKDCode', 0, null, 0, 0, '') ;

CALL ImportField(30101166, ' . ()', 'SourceKD', ' . ()', 'SourceKD', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101167, ' .', 'SourceKDCode', ' .', 'SourceKDValue', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101169, ' .', 'SourceIFSCode', ' .', 'SourceIFS_DescriptionCode', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101170, '  .', 'SourceTargetClsCode', '  .', 'SourceTargetCls', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101171, '  -', 'DestTargetClsCode', '  -', 'DestTargetCls', 0, 301, 1, 0, ',DestTargetClsCode', 0, null, 0, 0, '') ;

CALL ImportField(30101172, '  .', 'SourceBudgetPromiseSOID', '  .', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101173, '  -', 'DestBudgetPromiseSOID', '  -', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101174, '  .', 'SourceFundsSource', '', ' ', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101175, '  -', 'DestFundsSource', '', ' ', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101176, '  -', 'DestSubsidyCls', '   ()', 'DestSubsidyCls', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101177, '  -', 'DestSubsidyClsCode', '  ', 'DestSubsidyClsCode', 0, 301, 1, 0, ',DestSubsidyClsCode', 0, null, 0, 0, '') ;

CALL ImportField(30101178, '  .', 'SourceSubsidyCls', '   ()', 'SourceSubsidyCls', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101179, '  .', 'SourceSubsidyClsCode', '  ', 'SourceSubsidyClsCode', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101180, '  ', 'DestRegionBudgetEst', '   ', 'DestRegionBudgetEst', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101181, '  -', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101182, '   -', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101183, '  .', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101184, '   .', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101185, '  - ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101186, '   - ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101187, '  . ()', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101188, '   . ()', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101189, ' .()', 'SourceFact', ' ', 'SourceFACTCLSKey', 0, 301, 1, 1, ',', 0, 18890, 0, 0, '') ;

CALL ImportField(30101190, ' .  - ()', 'DestFinType', '   ', 'DestFINTYPECLSKey', 0, 301, 1, 1, 'DestFinTypeKey,,', 0, 18902, 0, 0, '') ;

CALL ImportField(30101191, ' - ()', 'DestFact', ' ', 'DestFACTCLSKey', 0, 301, 1, 1, 'DestFactKey,', 0, 18899, 0, 0, '') ;

CALL ImportField(30101192, ' .  . ()', 'SourceFinType', '   ', 'SourceFINTYPECLSKey', 0, 301, 1, 1, ',,,', 0, 18893, 0, 0, '') ;

CALL ImportField(30101193, ' -()', 'DestDirectionCls', ' ', 'DestDirectionClsKey', 0, 301, 1, 1, 'DestDirectionClsKey,', 0, 18914, 0, 0, '') ;

CALL ImportField(30101194, ' .()', 'SourceDirectionCls', ' ', 'SourceDirectionClsKey', 0, 301, 1, 1, ',', 0, 18913, 0, 0, '') ;

CALL ImportField(30101195, '  ()', 'DestDocBase', ' ', 'DESTDOCBASEKey', 0, 301, 1, 1, 'DestDocBaseKey,,', 0, 18916, 0, 0, '') ;

CALL ImportField(30101196, '  ()', 'SourceDocBase', ' ', 'SOURCEDOCBASEKey', 0, 301, 1, 1, ',,', 0, 18915, 0, 0, '') ;

CALL ImportField(30101198, '  ()', 'SourceInvestObject', ' ', 'SourceInvestObjectKey', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101199, '  ()', 'DestInvestObject', ' ', 'DestInvestObjectKey', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101200, ' ', 'SourceInvestObjectCode', ' ', 'SourceInvestObject', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101201, ' ', 'DestInvestObjectCode', ' ', 'DestInvestObject', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101202, ' -', 'DestContractCostsClsCode', ' ', 'DestContractCostsCls', 0, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30101203, ' -', 'DestContractCostsCls', ' ', 'DestContractCostsClsKey', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101204, ' .', 'SourceContractCostsCls', ' ', 'SourceContractCostsClsKey', 0, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101205, ' .', 'SourceContractCostsClsCode', ' ', 'SourceContractCostsCls', 0, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30101206, '  .', 'SourceTargetCls', '   ()', 'SourceTargetClsKey', 0, 301, 1, 1, ',', 0, 40642, 0, 0, '') ;

CALL ImportField(30101207, '  -', 'DestTargetCls', '   ()', 'DestTargetClsKey', 0, 301, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30101208, '()', 'CREATERUSER', '()', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101209, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101210, '  ()', 'CREATEDATE', '  ()', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101211, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30101212, ' -( -)', 'DestKESRCode', ' -( -)', 'DestKESR', 0, 301, 1, 0, ',DestKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30101214, ' -( -)', 'DestSubKESRCode', ' ( -)', 'DestSubKESR,', 0, 301, 1, 0, 'DestSubKESR,', 0, 43610, 0, 0, '') ;

CALL ImportField(30101216, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 0, 301, 1, 0, ',,SourceKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30101218, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSubKESR', 0, 301, 1, 0, ',,SourceSubKESRCode', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(30111004, ' .', 'SourceKVR', ' ', 'SourceKVRKey', 1, 301, 1, 1, 'SourceKVR,', 0, 18867, 0, 0, '') ;

CALL ImportField(30111005, ' .', 'SourceKESR', ' ', 'SourceKESRKey', 1, 301, 1, 1, 'SourceKESR,,', 0, 18868, 0, 0, '') ;

CALL ImportField(30111006, ' .( .)', 'SourceKFSR', ' ', 'SourceKFSR', 1, 301, 1, 0, ',', 0, 18888, 0, 0, '') ;

CALL ImportField(30111007, ' .', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 301, 1, 1, 'SourceKCSR,', 0, 18887, 0, 0, '') ;

CALL ImportField(30111008, ' .', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 301, 1, 1, 'SourceKVSR,', 0, 18886, 0, 0, '') ;

CALL ImportField(30111009, ' .', 'SourceSubKESR', ' ', 'SourceSubKESRKey', 1, 301, 1, 1, ',,SourceSubKESR', 0, 18889, 0, 0, '') ;

CALL ImportField(30111016, ' -', 'DestKVR', ' ', 'DestKVRKey', 1, 301, 1, 1, 'DestKVR,', 0, 18870, 0, 0, '') ;

CALL ImportField(30111017, ' -', 'DestKESR', ' ', 'DestKESRKey', 1, 301, 1, 1, 'DestKESR,', 0, 18871, 0, 0, '') ;

CALL ImportField(30111018, ' -( -)', 'DestKFSR', ' ', 'DestKFSR', 1, 301, 1, 0, 'DestKFSR,', 0, 18897, 0, 0, '') ;

CALL ImportField(30111019, ' -', 'DestKCSR', ' ', 'DestKCSRKey', 1, 301, 1, 1, 'DestKCSR,', 0, 18896, 0, 0, '') ;

CALL ImportField(30111020, ' -', 'DestKVSR', ' ', 'DestKVSRKey', 1, 301, 1, 1, 'DestKVSR,', 0, 18895, 0, 0, '') ;

CALL ImportField(30111021, ' -', 'DestSubKESR', ' ', 'DestSubKESR,', 1, 301, 1, 1, 'DestSubKESR,', 0, 18898, 0, 0, '') ;

CALL ImportField(30111050, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 301, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30111052, ' ( -)', 'DestIFS_DescriptionCode', '     ', ' ', 1, 301, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(30111053, ' ( .)', 'SourceIFS_DescriptionCode', '     ', ' ', 1, 301, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(30111061, ' .  ', 'SourceBudgetPromiseSONum', ' .  ', 'SourceBudgetPromiseSONum', 1, 301, 1, 1, '', 0, 19798, 0, 0, '') ;

CALL ImportField(30111062, ' .  ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 1, 301, 1, 1, '', 0, 19799, 0, 0, '') ;

CALL ImportField(30111064, '  .  ', 'SourceBudgetPromiseSORNum', '  .  ', ' ', 1, 301, 1, 1, '', 0, 19830, 0, 0, '') ;

CALL ImportField(30111065, '. .  ', 'SourceBudgetPromiseSONote', '. .  ', 'SourceBudgetPromiseSONote', 1, 301, 1, 1, '', 0, 19821, 0, 0, '') ;

CALL ImportField(30111073, ' .  ', 'DestBudgetPromiseSONum', ' .  ', 'DestBudgetPromiseSONum', 1, 301, 1, 1, '', 0, 19798, 0, 0, '') ;

CALL ImportField(30111074, ' .  ', 'DestBudgetPromiseSODate', ' .  ', 'DestBudgetPromiseSODate', 1, 301, 1, 1, '', 0, 19799, 0, 0, '') ;

CALL ImportField(30111076, '  .  ', 'DestBudgetPromiseSORNum', '  .  ', 'DestBudgetPromiseSORNum', 1, 301, 1, 1, '', 0, 19830, 0, 0, '') ;

CALL ImportField(30111077, '. .  ', 'DestBudgetPromiseSONote', '. .  ', 'DestBudgetPromiseSONote', 1, 301, 1, 1, '', 0, 19821, 0, 0, '') ;

CALL ImportField(30111123, '', 'BUDGETREF', '', 'BudgetRef', 1, 301, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(30111140, ' -( -)', 'DestKCSRCode', ' -( -)', 'DestKCSR', 1, 301, 1, 0, ',DestKCSRCode', 0, 25462, 0, 0, '') ;

CALL ImportField(30111142, ' -( -)', 'DESTKVRCode', ' -( -)', 'DestKVR', 1, 301, 1, 0, ',DESTKVRCode', 0, 25467, 0, 0, '') ;

CALL ImportField(30111143, ' -( -)', 'DestKVSRCode', ' -( -)', 'DestKVSR', 1, 301, 1, 0, ',DestKVSRCode', 0, 25472, 0, 0, '') ;

CALL ImportField(30111145, ' .( .)', 'SourceKCSRCode', ' .( .)', 'SourceKCSR', 1, 301, 1, 0, ',,SourceKCSRCode', 0, 25462, 0, 0, '') ;

CALL ImportField(30111147, ' .( .)', 'SOURCEKVRCode', ' .( .)', 'SourceKVR', 1, 301, 1, 0, ',,SOURCEKVRCode', 0, 25467, 0, 0, '') ;

CALL ImportField(30111148, ' .( .)', 'SourceKVSRCode', ' .( .)', 'SourceKVSR', 1, 301, 1, 0, ',,SourceKVSRCode', 0, 25472, 0, 0, '') ;

CALL ImportField(30111154, '  -', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 301, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30111156, '  .', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 301, 1, 0, ',', 0, 27825, 0, 0, '') ;

CALL ImportField(30111157, '   .', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 1, 301, 1, 0, ',', 0, 27849, 0, 0, '') ;

CALL ImportField(30111158, '  -', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 301, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(30111160, '  .', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 301, 1, 1, ',', 0, 27844, 0, 0, '') ;

CALL ImportField(30111161, '   .', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 1, 301, 1, 1, ',', 0, 27845, 0, 0, '') ;

CALL ImportField(30111171, '  ()', 'SourceInvestObject', ' ', 'SourceInvestObjectKey', 1, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30111172, '  ()', 'DestInvestObject', ' ', 'DestInvestObjectKey', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111173, ' ', 'SourceInvestObjectCode', ' ', 'SourceInvestObject', 1, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30111174, ' ', 'DestInvestObjectCode', ' ', 'DestInvestObject', 1, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111213, ' -( -)', 'DestKESRCode', ' -( -)', 'DestKESR', 1, 301, 1, 0, ',DestKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30111215, ' -( -)', 'DestSubKESRCode', ' ( -)', 'DestSubKESR,', 1, 301, 1, 0, 'DestSubKESR,', 0, 43610, 0, 0, '') ;

CALL ImportField(30111217, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 301, 1, 0, ',,SourceKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30111219, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSubKESR', 1, 301, 1, 0, ',,SourceSubKESRCode', 0, 43610, 0, 0, '') ;

--  , +(2)
CALL ImportField(30110220, '   ', '', '   ', 'DestBankShortName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110221, ' - ', '', ' - ', 'DestorrespondentBankName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110222, '  -', '', '  -', 'DestOrgShortName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110223, '  -', '', '  -', 'SourceOrgShortName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110224, '   ', '', '   ', 'SourceBankShortName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110225, ' - ', '', ' - ', 'SourceorrespondentBankName', 2, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111226, '  ', 'SourceRegProjectResultCode', '  ', 'SourceRegProjectResultCode', 2, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111227, '  ()', 'SourceRegProjectResult', '  ', 'SourceRegProjectResult', 2, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111228, '  ', 'DestRegProjectResultCode', '  ', 'DestRegProjectResultCode', 2, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111229, '  ()', 'DestRegProjectResult', '  ', 'DestRegProjectResult', 2, 301, 1, 1, '', 0, null, 0, 0, '') ;

--   \, (0)
CALL ImportField(30200001, '', 'NDS', '', 'NDS', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200002, ' ', 'TaxNote', ' ', 'TaxNote', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200003, ' -', 'INN', ' -', 'DestOrgINN', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200004, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200005, '    ', 'SourceFacialCode', '    ', 'SourceFacialAccClsFacialCode', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200006, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200007, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200008, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200009, ' ', 'ReestrDate', ' ', 'REESTRDATE', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200010, '  ', 'Summa', '  ', 'SUMMA', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200011, ' ', 'PayTypeCls', ' ', 'PAYTYPECLS', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200012, ' -', 'NAME', ' -', 'DestOrgName', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200013, ' ', 'PayPriority', ' ', 'PayPriority', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200014, ' ', 'PayDate', ' ', 'PayDate', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200015, ' ', 'BuhPaymentCls', ' ', 'BUHPAYMENTCLS', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200016, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200017, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200019, '  ', 'ManagerBidNumber', '  ', 'ManagerBidNumber', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200020, ' ', 'Note', ' ', 'NOTE', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200021, ' ', 'DocStateName', ' ', 'DocStateName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200022, '/  ( )', 'SourceAccountName', '/  ( )', 'SourceAccountName', 0, 302, 0, 0, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200023, '  ', 'BidNumber', '  ', 'BidNumber', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200024, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200025, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200026, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200027, ' -', 'INN20', ' -', 'DestOrgKPP', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200028, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200029, '/ ', 'ACC', '/ ', 'DestAccountName', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200030, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 0, 302, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30200031, ' ', 'CardNumber', '  ', 'CARDNUMBER', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200032, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 302, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30200033, '  ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 0, 302, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30200034, '  ', 'DESTACCOUNT', '  -', 'DESTACCOUNT', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200035, ' ()', 'DocStateRef', ' ()', 'DocStateRef', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200036, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200037, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200038, ' ', 'IsVised', ' ', 'IsVised', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200039, ' ', 'ManagerBid', ' ', 'ManagerBid', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200040, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200042, '  ', ' ', '  ', 'SourceType', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200043, '  ', ' ', '  ', 'DestType', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200044, '  ', ' ', '  ', 'ManBidFuid', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200045, ' ', 'Reestr_Ref', ' ', 'Reestr_Ref', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200046, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200047, '', 'DEPARTMENTCLS', '', 'DEPARTMENTCLS', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200048, ' c', 'FEDERALFUNDSREF', ' c', 'FEDERALFUNDSREF', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200049, '   c', ' ', '   c', 'FEDERALFUNDSREESTR', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200050, ' ', ' ', ' ', 'LINKEDDOCUMENT', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200051, '  ', ' ', '  ', 'RequestNumber', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200052, '  ', ' ', '  ', 'RequestDate', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200053, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200054, ' ', ' ', ' ', 'SourceFKFacialCode', 0, 302, 0, 1, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200055, '   ', ' ', '   ', 'SourceOrgId', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200056, '    ', ' ', '    ', 'SourceOrgFUID', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200057, ' -', ' ', ' -', 'SourceOrgINN', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200058, ' -', ' ', ' -', 'SourceOrgKPP', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200059, ' -', ' ', ' -', 'SourceOrgName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200060, ' -', ' ', ' -', 'SourceOrgCity', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200061, ' ', ' ', ' ', 'SourceBankFUID', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200062, '  ', ' ', '  ', 'SourceBankName', 0, 302, 0, 1, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200063, '  ', ' ', '  ', 'SourceBankBIK', 0, 302, 0, 1, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200064, '.  ', ' ', '.  ', 'SourceBankCor', 0, 302, 0, 1, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200065, '   ', ' ', '   ', 'SourceBankCity', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200066, '\ ', ' ', ' \ ', 'SourceFacialAccClsName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200067, ' - \ ', 'SourceFacialAccClsOrgINN', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200068, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200069, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200070, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200071, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200072, '  ', ' ', '  ', 'SourceFKOrgName', 0, 302, 0, 1, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200073, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200074, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200075, ' ', 'SubFacialCode', ' ', 'DestFKFacialCode', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200076, '   ', ' ', '   ', 'DestOrgId', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200077, '    ', ' ', '    ', 'DestOrgFUID', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200078, ' -', ' ', ' -', 'DestOrgCity', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200079, ' ', ' ', ' ', 'DestBankFUID', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200080, '  ', ' ', '  ', 'DestBankName', 0, 302, 0, 1, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200081, '  ', ' ', '  ', 'DestBankBIK', 0, 302, 0, 1, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200082, '.  ', ' ', '.  ', 'DestBankCor', 0, 302, 0, 1, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200083, '   ', ' ', '   ', 'DestBankCity', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200084, '\ ()', ' ', '\ ', 'DestFacialAccClsName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200085, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200086, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200087, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200088, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200089, '   ', ' ', '   ', 'DestFKOrgINN', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200090, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200091, '  ', ' ', '  ', 'DestFKOrgName', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200092, '   ', ' ', '   ', 'DestFKOrgCity', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200093, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200124, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200130, ' ', 'ID', ' ', 'Id', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200131, '', 'BUDGETREF', '', 'BudgetRef', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200146, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200150, '  ', 'FaxDocsInfo', '  ', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200151, '  ', 'Org_Ref', '  ', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200156, '   ', 'FUID', '   ', 'FUID', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200158, '(  )', 'UINCode', '  ', 'UINCode', 0, 302, 0, 0, '', 0, 35367, 0, 0, '') ;

CALL ImportField(30200159, ' ', 'BidDate', '', 'BidDate', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200161, ' ', 'RegionContractor', ' ', 'RegionContractor', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200162, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200165, ' ()', 'CardRef', '  ', 'CardRef', 0, 302, 0, 1, '', 0, 31656, 0, 0, '') ;

CALL ImportField(30200166, ' ', 'CardRefName', '  ', 'CardRefName', 0, 302, 0, 0, '', 0, 18939, 0, 0, '') ;

CALL ImportField(30200167, ' ', 'DocOsn', ' ', 'DocOsn', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200168, ' ', 'CashierPersonalInfo', ' ', 'CashierPersonalInfo', 0, 302, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30200175, '', 'Signers', '', 'Signers', 0, 302, 0, 0, '', 0, 38174, 0, 2, '') ;

CALL ImportField(30200176, '   ', 'StimateID', '   ', 'StimateID', 0, 302, 0, 0, '', 0, 18999, 0, 0, '') ;

CALL ImportField(30200177, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 302, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30200178, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 302, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30200179, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 302, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30200180, '   ', '', '   ', 'SourceFKCode', 0, 302, 0, 0, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200181, '  ( )', '', '  ( )', 'UBPOrgName', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200182, ' ', '', ' ', 'SourceINN', 0, 302, 0, 0, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200183, ' ', '', ' ', 'SourceKPP', 0, 302, 0, 0, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200184, ' ', '', ' ', 'SourceName', 0, 302, 0, 0, '', 0, null, 30200178, 1, '') ;

CALL ImportField(30200185, '  ', '', '  ', 'GeneralOrgKVSR', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200186, ' ', '', ' ', 'GeneralOrgName', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200187, '   ', '', '   ', 'UBPCode', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200188, ' ', '', ' ', 'BudgetName', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200189, ' ', '', ' ', 'FOName', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200190, '  ', '', '  ', 'OKPO', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200191, ' ', '', ' ', 'DestName', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200192, '  ', '', '  ', 'DestINN', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200193, ' ', '', ' ', 'DetKPP', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200194, '  ', '', '  ', 'ExportDate', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200195, '  ', '', '  ', 'ExecutionDate', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200196, '   ', '', '   ', 'urrencyName', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200198, '  ', '', '  ', 'DestCLSType', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200199, '   ', '', '   ', 'DestKBK', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200201, '   ', '', '   ', 'DestTargetCLS', 0, 302, 0, 0, '', 0, null, 30200177, 1, '') ;

CALL ImportField(30200202, ' ', '', ' ', 'PaymentPurpose', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200203, '  ', '', '  ', 'NameRukUBP', 0, 302, 0, 0, '', 0, null, 30200175, 1, '') ;

CALL ImportField(30200204, ' ', '', ' ', 'PostRukUBP', 0, 302, 0, 0, '', 0, null, 30200175, 1, '') ;

CALL ImportField(30200205, '  ', '', '  ', 'NameBuhUBP', 0, 302, 0, 0, '', 0, null, 30200175, 1, '') ;

CALL ImportField(30200206, '  ', '', '  ', 'PostBuhUBP', 0, 302, 0, 0, '', 0, null, 30200175, 1, '') ;

CALL ImportField(30200207, '   ', '', '   ', 'ActivityKind', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200208, '   ', '', '   ', 'ZRNote', 0, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30200211, '()', 'CREATERUSER', '()', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200212, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200213, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30200214, '  ()', 'CREATEDATE', '  ()', ' ', 0, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201001, '   ', 'Summa', '   ', 'SUMMA', 0, 302, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30201002, ' . ', 'SOURCEFINTYPECODE', '  ', 'SOURCEFINTYPECLS', 0, 302, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(30201003, ' ', 'SOURCEFINSOURCE', ' ', 'SOURCEFINSOURCECLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201004, ' ', 'SourceMeansType', ' ', 'SOURCEMEANSTYPECLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201005, '', 'SOURCEFACTCODE', '', 'SOURCEFACTCLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201006, '', 'SourceSubKESR', '', 'SOURCESUBKESRKey', 0, 302, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(30201007, '', 'SourceKFSR', '', 'SourceKFSR', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201008, '', 'SourceDirectionClsCode', '', 'SourceDirectionCLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201009, ' ()', 'SOURCEKVSR', ' ()', 'SourceKVSRKey', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201010, '', 'SOURCEKVR', '', 'SourceKVRKey', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201011, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201012, '  ', 'SourcePromise', '  ', 'SOURCEPROMISE', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201013, ' ()', 'Note', ' ()', 'NOTE', 0, 302, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30201014, '', 'SourceKESR', '', 'SourceKESRKey', 0, 302, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(30201015, '     ', 'SourceBudgetPromise', '     ', 'SOURCEBUDGETPROMISE', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201016, '  ()', 'SourceBudgetPROMISENum', '  ()', 'SourceBudgetPROMISENum', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201017, '  ', 'SourceExecDocCollaps', '  ', ' ', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201018, '    ', 'SourceExecDoc', '    ', 'SourceExecDoc', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201019, '   ', 'SourceExecDocNum', '   ', 'SourceExecDocNum', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201020, '   ', 'SourceExecDocReestr', '   ', 'SourceExecDocReestr', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201021, '  ', 'SourceExecDocDate', '  ', 'SourceExecDocDate', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201022, '  ', 'SourceExecDocType', '  ', 'SourceExecDocType', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201023, '   ', 'SourceExecDocSumma', '   ', 'SourceExecDocSumma', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201024, '  ', 'SourceExecDocNote', '  ', 'SourceExecDocNote', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201025, '     ', '', '     ', 'DestBudgetPromise', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201035, '  ', 'SourceBudgetPromiseCollaps', '  ', 'SourceBudgetPromiseCollaps', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201036, ' ', 'SourceBudgetPromiseSumma', ' ', 'SourceBudgetPromiseSumma', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201037, ' ', 'SourceBudgetPromiseDocNumber', ' ', 'SourceBudgetPromiseDocNum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201038, ' ', 'SourceBudgetPromiseDocDate', ' ', 'SourceBudgetPromiseDocDate', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201039, ' ', 'SourceBudgetPromiseDocSumma', ' ', 'SourceBudgetPromiseDocSumma', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201040, '  .', 'SourceBudgetPromiseAgrRNum', '  .', 'SourceBudgetPromiseAgrReestrNum', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201041, '. ', 'SourceBudgetPromiseDocNote', '. ', 'SourceBudgetPromiseDocNote', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201042, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201043, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201044, ' . ', 'SourceBudgetPromiseSOSumma', ' . ', 'SourceBudgetPromiseSOSumma', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201045, '  . ', 'SourceBudgetPromiseSOReestrNum', '  . ', 'SourceBudgetPromiseSOReestrNum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201046, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201047, '  ', '', '  ', 'DestBudgetPromiseCollaps', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201048, '  ', '', '  ', 'DestBudgetPromiseSumma', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201049, '  ', '', '  ', 'DestBudgetPromiseAgrNum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201050, '  ', '', '  ', 'DestBudgetPromiseAgrDate', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201051, '  ', '', '  ', 'DestBudgetPromiseAgrSumma', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201052, '  ', '', '  ', 'DestBudgetPromiseAgrReestrNum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201053, '.  ', '', '.  ', 'DestBudgetPromiseAgrNote', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201054, ' .  ', '', ' .  ', 'DestBudgetPromiseSONum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201055, ' .  ', '', ' .  ', 'DestBudgetPromiseSODate', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201056, ' .  ', '', ' .  ', 'DestBudgetPromiseSOSumma', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201057, '  .  ', '', '  .  ', 'DestBudgetPromiseSOReestrNum', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201058, '. .  ', '', '. .  ', 'DestBudgetPromiseSONote', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201059, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 302, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30201060, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201061, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201066, '  ', 'SOURCEDOCTYPE', '  ', 'SOURCEDOCTYPECLS', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201067, ' ', 'SourceRegionCLS', ' ', 'SourceRegionCls', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201068, '()', 'SourceIFS', '        ', 'SourceIFS', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201071, '', 'TreeOwner0', '', ' ', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201106, ' ()', 'SourceKD', ' ', 'SourceKD', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201111, '', 'SourceDocBaseCode', '', 'SourceDocBase', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201121, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201125, ' ', 'SourceFundsSource', ' ', 'SourceFundsSource', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201132, '', 'BUDGETREF', '', 'BudgetRef', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201144, '  ', 'SourceTransfertCls', '   ()', 'SourceTransfertCls', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201145, '  ', 'SourceTransfertClsCode', '  ', 'SourceTransfertClsValue', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201147, '()', 'SourceKCSRCode', '', 'SourceKCSR', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201148, '()', 'SOURCEKVRCode', '', 'SourceKVR', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201149, '', 'SourceKVSRCode', ' ', 'SourceKVSR', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201152, ' ()', 'SourceKDCode', '', 'SourceKDCode', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201153, '', 'SourceIFSCode', '      ', 'SourceIFS_DescriptionCode', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201155, ' ', 'SourceBudgetPromiseSOID', '', ' ', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201157, '   ', 'FUID', '   ', 'FUID', 0, 302, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30201158, ' ', 'ID', ' ', 'ID', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201159, ' ', 'SourceSubsidyCls', '  ()', 'SourceSubsidyCls', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201160, ' ', 'SourceSubsidyClsCode', ' ', 'SourceSubsidyClsCode', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201161, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201162, '  ', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201163, '  ()', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201164, '   ()', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201168, '()', 'SourceFact', '', 'SourceFACTCLSKey', 0, 302, 1, 1, '', 0, 18890, 0, 0, '') ;

CALL ImportField(30201169, ' .  ()', 'SOURCEFINTYPE', '  ', 'SourceFINTYPECLSKey', 0, 302, 1, 1, ',', 0, 18893, 0, 0, '') ;

CALL ImportField(30201170, ' ()', 'SourceDirectionCls', '', 'SourceDirectionClsKey', 0, 302, 1, 1, '', 0, 18913, 0, 0, '') ;

CALL ImportField(30201171, ' ()', 'SourceDocBase', '', 'SOURCEDOCBASEKey', 0, 302, 1, 1, ',', 0, 18915, 0, 0, '') ;

CALL ImportField(30201173, '', 'SourceInvestObject', '', 'SourceInvestObjectKey', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201174, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 0, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30201177, '   ', 'StimateID', '   ', 'StimateId', 0, 302, 1, 0, '', 0, 18911, 0, 0, '') ;

CALL ImportField(30201197, '  ', '', '  ', 'SourceCLSType', 0, 302, 1, 0, '', 0, null, 30201178, 1, '') ;

CALL ImportField(30201200, ' ', 'SourceTargetCls', '  ()', 'SourceTargetCLSKey', 0, 302, 1, 1, '', 0, null, 30201178, 1, '') ;

CALL ImportField(30201209, '   ', '', '   ', 'NoteKBK', 0, 302, 1, 1, '', 0, null, 30201178, 1, '') ;

CALL ImportField(30201211, '  ', '', '  ', 'SourceKBK', 0, 302, 1, 1, '', 0, null, 30201178, 1, '') ;

CALL ImportField(30201212, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 0, 302, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30201213, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 0, 302, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30201214, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 0, 302, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30201215, '()', 'CREATERUSER', '()', ' ', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201216, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201217, '  ()', 'CREATEDATE', '  ()', ' ', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201218, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30201219, '()', 'SourceKESRCode', '()', 'SourceKESR', 0, 302, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(30201221, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 0, 302, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(30201224, ' (.  )', 'SourceExecDocMPNum', ' (.  )', 'SourceExecDocMPNum', 0, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201225, ' ', 'SourceBudgetPromiseAgrNumber', '', 'SourceBudgetPromiseAgrNum', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30201226, ' ', 'SourceBudgetPromiseAgrDate', '', 'SourceBudgetPromiseAgrDate', 0, 302, 1, 1, ',', 0, null, 0, 0, '') ;

--   \, (1)
CALL ImportField(30210075, '   ', ' ', '   ', 'SourceBankCity', 1, 302, 0, 0, '', 1, null, 0, 0, '') ;

CALL ImportField(30210077, '/   ', 'SourceFacialCode', '   ', 'SourceFacialAccClsFacialCode', 1, 302, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30210094, '   ', ' ', '   ', 'DestBankCity', 1, 302, 0, 0, '', 1, null, 0, 0, '') ;

CALL ImportField(30210135, '   ', 'StimateID', '   ', 'StimateID', 1, 302, 0, 0, '', 0, 18999, 0, 0, '') ;

CALL ImportField(30211001, '', 'SOURCESUBKESR', '', 'SOURCESUBKESRKey', 1, 302, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(30211003, '', 'SOURCEKVR', '', 'SourceKVRKey', 1, 302, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(30211004, '', 'SOURCEKESR', '', 'SourceKESRKey', 1, 302, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(30211005, '()', 'SOURCEKFSR', '', 'SourceKFSR', 1, 302, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(30211006, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 1, 302, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(30211007, '', 'SOURCEKVSR', ' ', 'SourceKVSRKey', 1, 302, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(30211014, '  ()', 'SourceBudgetPROMISENum', '  ()', 'SourceBudgetPROMISENum', 1, 302, 1, 0, ',', 0, 20223, 0, 0, '') ;

CALL ImportField(30211043, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 302, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30211054, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 1, 302, 1, 1, '', 0, 19798, 0, 0, '') ;

CALL ImportField(30211055, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 1, 302, 1, 1, '', 0, 19799, 0, 0, '') ;

CALL ImportField(30211057, '  . ', 'SourceBudgetPromiseSORNum', '  . ', ' ', 1, 302, 1, 1, '', 0, 19830, 0, 0, '') ;

CALL ImportField(30211058, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 1, 302, 1, 1, '', 0, 19821, 0, 0, '') ;

CALL ImportField(30211077, ' ()', 'SourceIFS_DescriptionCode', '  ( )', ' ', 1, 302, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(30211119, '', 'BUDGETREF', '', 'BudgetRef', 1, 302, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(30211132, '   ', 'StimateID', '   ', 'StimateId', 1, 302, 1, 1, '', 0, 18911, 0, 0, '') ;

CALL ImportField(30211140, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 302, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(30211142, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 302, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(30211143, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 302, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(30211147, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 302, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30211149, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 302, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(30211220, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 302, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(30211222, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 1, 302, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(30211223, ' (.  )', 'SourceExecDocMPNum', ' (.  )', 'SourceExecDocMPNum', 1, 302, 1, 0, ',', 0, 45406, 0, 0, '') ;

--   \, +(2)
CALL ImportField(30210003, ' / ', 'ACC', ' / ', 'DestAccountName', 2, 302, 0, 0, '', 0, 17112, 30210153, 1, '') ;

CALL ImportField(30210013, '/ ', 'DESTACCOUNT', '/ ', 'DESTACCOUNT', 2, 302, 0, 1, '', 0, 18958, 0, 0, '') ;

CALL ImportField(30210030, '/  ()', 'SOURCEACCOUNTNAME', '/  ()', 'SourceAccountName', 2, 302, 0, 0, '', 0, 17112, 30210154, 1, '') ;

CALL ImportField(30210043, '   ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 2, 302, 0, 1, ',', 0, 18956, 0, 0, '') ;

CALL ImportField(30210064, ' ', ' ', ' ', 'SourceFKFacialCode', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210072, '  ', ' ', '  ', 'SourceBankName', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210073, '  ', ' ', '  ', 'SourceBankBIK', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210074, '.  ', ' ', '.  ', 'SourceBankCor', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210091, '  ', ' ', '  ', 'DestBankName', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210092, '  ', ' ', '  ', 'DestBankBIK', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210093, '.  ', ' ', '.  ', 'DestBankCor', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210153, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 2, 302, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30210154, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 2, 302, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30210163, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 2, 302, 0, 0, '', 0, 45426, 0, 2, '') ;

CALL ImportField(30210166, ' ', '', ' ', 'SourceINN', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210167, ' ', '', ' ', 'SourceKPP', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210168, ' ', '', ' ', 'SourceName', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210175, ' ', '', ' ', 'DestName', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210176, '  ', '', '  ', 'DestINN', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210177, ' ', '', ' ', 'DetKPP', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210198, ' ', '', ' ', 'SourceLSFK', 2, 302, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30210199, ' ', '', ' ', 'DestLSFK', 2, 302, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30210200, '   (  )', 'CodePurpose', '   (  )', 'CodePurpose', 2, 302, 0, 0, '', 1, null, 30210163, 1, '') ;

CALL ImportField(30210227, '   ', '', '   ', 'DestBankShortName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210228, ' - ', '', ' - ', 'DestorrespondentBankName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210229, '  -', '', '  -', 'DestOrgShortName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210230, '  -', '', '  -', 'SourceOrgShortName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210231, '   ', '', '   ', 'SourceBankShortName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210232, ' - ', '', ' - ', 'SourceorrespondentBankName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210233, '  - \ ', '', '  - \ ', 'SourceFacialAccClsOrgShortName', 2, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211158, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 2, 302, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30211234, '    ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 302, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30211235, '    ()', 'SourcePayTargetFunds', '   ', ' ', 2, 302, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30211236, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 302, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30211237, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 302, 1, 1, '', 0, null, 0, 0, '') ;

--  (), (0)
CALL ImportField(30300001, '()', 'CREATERUSER', '()', ' ', 0, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30300002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30300003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30300004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30301080, '()', 'CREATERUSER', '()', ' ', 0, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30301081, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30301082, '  ()', 'CREATEDATE', '  ()', ' ', 0, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30301083, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 303, 1, 1, '', 0, null, 0, 0, '') ;

--  (), (1)
CALL ImportField(30311014, '()', 'DestKFSR', '', 'DestKFSR', 1, 303, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(30311015, '', 'DestKCSR', '', 'DestKCSRKey', 1, 303, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(30311016, ' ', 'DESTKVR', ' ', 'DESTKVRKey', 1, 303, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(30311017, '', 'DESTKESR', '', 'DESTKESRKey', 1, 303, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(30311020, ' ()', 'DestIFS_DescriptionCode', ' ', ' ', 1, 303, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(30311022, '', 'DestSubKESR', '', 'DestSubKESRKey', 1, 303, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(30311032, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 303, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30311036, '', 'DestKVSR', '', 'DestKVSRKey', 1, 303, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(30311074, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 303, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(30311075, ' ()', 'DESTKVRCode', ' ()', 'DESTKVR', 1, 303, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(30311076, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 303, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(30311080, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 303, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30311087, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 303, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(30311118, '()', 'DESTKESRCode', '()', 'DESTKESR', 1, 303, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(30311119, '()', 'DestSubKESRCode', '()', 'DestSubKESR', 1, 303, 1, 0, '', 0, 43610, 0, 0, '') ;

--  (), +(2)
CALL ImportField(30310120, '   ', '', '   ', 'DestBankShortName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310121, ' - ', '', ' - ', 'DestorrespondentBankName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310122, '  -', '', '  -', 'DestOrgShortName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310123, '  -', '', '  -', 'SourceOrgShortName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310124, '   ', '', '   ', 'SourceBankShortName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310125, ' - ', '', ' - ', 'SourceorrespondentBankName', 2, 303, 0, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(30400001, '  ', 'BidNumber', '  ', 'BidNumber', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400002, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400003, '    ', 'SourceFacialCode', '    ', 'SourceFacialCode', 0, 304, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30400004, '  ', 'ManagerBidNumber', '  ', 'ManagerBidNumber', 0, 304, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30400005, ' ', 'TrustNumber', ' ', 'TrustNumber', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400006, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400007, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400008, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400009, ' ', 'Period', ' ', 'Period', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400010, ' ', 'Name', ' -', 'DestOrgName', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400011, ' ', 'INN20', ' -', 'DestOrgKPP', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400012, ' ', 'INN', ' -', 'DestOrgINN', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400013, '/  ()', 'DESTFACIALACC_CLS', '/  ()', 'DestFacialAccCls', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400014, '/  ( )', 'ACC', '/  ( )', 'DestAccountName', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400015, '  ', 'Summa', '  ', 'Summa', 0, 304, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30400016, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400017, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400018, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400019, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400020, ' ', 'ReestrDate', ' ', 'REESTRDATE', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400021, ' ', 'PayTypeCls', ' ', 'PAYTYPECLS', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400022, ' ', 'Note', ' ', 'NOTE', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400023, ' ', 'PayPriority', ' ', 'PayPriority', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400024, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400025, ' ', 'BuhPaymentCls', ' ', 'BUHPAYMENTCLS', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400026, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400027, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400028, ' ', 'PaySymbolCls', ' ', 'PaySymbolCls', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400029, '/  ( )', 'SourceAccountName', '/  ( )', 'SourceAccountName', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400030, ' ', ' ', ' ', 'PayDate', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400031, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400033, '  ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 0, 304, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30400034, '  ', 'DESTACCOUNT', '  -', 'DESTACCOUNT', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400035, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400036, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400037, ' ', 'IsVised', ' ', 'IsVised', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400038, ' ', 'ManagerBid', ' ', 'ManagerBid', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400039, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400040, ' ', ' ', ' ', 'StimateID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400043, '  ', ' ', '  ', 'ManBidFuid', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400044, ' ', ' ', ' ', 'Reestr_Ref', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400045, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400046, '', ' ', '', 'DEPARTMENTCLS', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400047, ' ', ' ', ' ', 'LINKEDDOCUMENT', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400048, '  ', ' ', '  ', 'RequestNumber', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400049, '  ', ' ', '  ', 'RequestDate', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400050, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400051, ' ', ' ', ' ', 'SourceFKFacialCode', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400052, '   ', ' ', '   ', 'SourceOrgId', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400053, ' ', ' ', ' -', 'SourceOrgINN', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400054, ' ', ' ', ' -', 'SourceOrgKPP', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400055, ' ', ' ', ' -', 'SourceOrgName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400056, ' ', ' ', ' -', 'SourceOrgCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400057, ' ', ' ', ' ', 'SourceBankFUID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400058, '  ', ' ', '  ', 'SourceBankName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400059, '  ', ' ', '  ', 'SourceBankBIK', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400060, '.  ', ' ', '.  ', 'SourceBankCor', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400061, '   ', ' ', '   ', 'SourceBankCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400062, '\ ', ' ', '\ ', 'SourceFacialAccClsName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400063, ' \ ', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400064, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400065, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400066, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400067, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400068, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400069, '  ', ' ', '  ', 'SourceFKOrgName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400070, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400071, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400072, ' ', ' ', ' ', 'DestFKFacialCode', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400073, '   ', ' ', '   ', 'DestOrgId', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400074, '    ', ' ', '    ', 'DestOrgFUID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400075, ' -', ' ', ' -', 'DestOrgCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400076, ' ', ' ', ' ', 'DestBankFUID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400077, '  ', ' ', '  ', 'DestBankName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400078, '  ', ' ', '  ', 'DestBankBIK', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400079, '.  ', ' ', '.  ', 'DestBankCor', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400080, '   ', ' ', '   ', 'DestBankCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400081, '\  ()', ' ', '\ ', 'DestFacialAccClsName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400082, ' \  ()', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400083, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400084, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400085, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400086, '   ', ' ', '   ', 'DestFKOrgINN', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400087, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400088, '  ', ' ', '  ', 'DestFKOrgName', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400089, '   ', ' ', '   ', 'DestFKOrgCity', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400117, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400123, ' ', 'ID', ' ', 'ID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400125, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 304, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30400134, ' ', 'CashierPersonalInfo', ' ', 'CashierPersonalInfo', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400135, '', 'BUDGETREF', '', 'BudgetRef', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400137, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400143, ' ', 'DocStateName', ' ', 'DocStateName', 0, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30400145, ' ', 'BidDate', '', 'BidDate', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400150, '   ', 'FUID', '   ', 'FUID', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400151, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30400152, ' ', 'CardNumber', '  ', 'CARDNUMBER', 0, 304, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30400158, ' ()', 'CardRef', '  ', 'CardRef', 0, 304, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30400159, ' ', 'CardRefName', '  ', 'CardRefName', 0, 304, 0, 0, '', 0, 18939, 0, 1, '') ;

CALL ImportField(30400166, '', 'Signers', '', 'Signers', 0, 304, 0, 0, '', 0, 38174, 0, 1, '') ;

CALL ImportField(30400167, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 304, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30400168, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 304, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30400169, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 304, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30400170, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 0, 304, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30400171, '()', 'CREATERUSER', '()', ' ', 0, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30400172, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30400173, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30400174, '  ()', 'CREATEDATE', '  ()', ' ', 0, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401001, ' ', 'SOURCEFINSOURCE', ' ', 'SOURCEFINSOURCECLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401002, '   ', 'Summa', '   ', 'Summa', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401003, '', 'SourceKESR', '', 'SourceKESRKey', 0, 304, 1, 1, '', 0, 18868, 0, 1, '') ;

CALL ImportField(30401004, '', 'SourceKFSR', '', 'SourceKFSR', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401005, ' ', 'PaySymbolCls', ' ', 'PaySymbolCls', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401006, '', 'SourceDirectionClsCode', '', 'SourceDirectionCLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401007, ' ()', 'SOURCEKVSR', ' ()', 'SourceKVSRKey', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401008, ' ', 'SourceMeansType', ' ', 'SOURCEMEANSTYPECLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401009, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401010, '  ', 'SourcePromise', '  ', 'SOURCEPROMISE', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401011, '', 'SOURCEFACTCODE', '', 'SOURCEFACTCLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401012, '', 'SourceSubKESR', '', 'SOURCESUBKESRKey', 0, 304, 1, 1, '', 0, 18889, 0, 1, '') ;

CALL ImportField(30401013, '   ', 'Note', '   ', 'Note', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401014, '', 'SOURCEKVR', '', 'SourceKVRKey', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401015, ' . ', 'SOURCEFINTYPECODE', '  ', 'SOURCEFINTYPECLS', 0, 304, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30401016, '     ', 'SourceBudgetPromise', '     ', 'SOURCEBUDGETPROMISE', 0, 304, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30401017, '  ()', 'SourceBudgetPromiseNum', '  ()', 'SOURCEBUDGETPROMISENUM', 0, 304, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30401018, '  ', 'SourceExecDocCollaps', '  ', '  ', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401019, '    ', 'SourceExecDoc', '    ', 'SourceExecDoc', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401020, '   ', 'SourceExecDocNum', '   ', 'SourceExecDocNum', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401021, '   ', 'SourceExecDocReestr', '   ', 'SourceExecDocReestr', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401022, '  ', 'SourceExecDocDate', '  ', 'SourceExecDocDate', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401023, '  ', 'SourceExecDocType', '  ', 'SourceExecDocType', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401024, '   ', 'SourceExecDocSumma', '   ', 'SourceExecDocSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401025, '  ', 'SourceExecDocNote', '  ', 'SourceExecDocNote', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401026, '     ', ' ', '     ', '     ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401027, '  ()', ' ', '  ()', '  ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401028, '  ', ' ', '  ', '  ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401029, '    ', ' ', '    ', '    ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401030, '   ', ' ', '   ', '   ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401031, '   ', ' ', '   ', '   ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401032, '  ', ' ', '  ', '  ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401033, '  ', ' ', '  ', '  ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401034, '   ', ' ', '   ', '   ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401035, '  ', ' ', '  ', '  ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401036, '  ', 'SourceBudgetPromiseCollaps', '  ', 'SourceBudgetPromiseCollaps', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401037, ' ', 'SourceBudgetPromiseSumma', ' ', 'SourceBudgetPromiseSumma', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401038, ' ', 'SourceBudgetPromiseDocNumber', ' ', 'SourceBudgetPromiseDocNumber', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401039, ' ', 'SourceBudgetPromiseDocDate', ' ', 'SourceBudgetPromiseDocDate', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401040, ' ', 'SourceBudgetPromiseDocSumma', ' ', 'SourceBudgetPromiseDocSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401041, '  .', 'SourceBudgetPromiseDocReestrNum', '  .', 'SourceBudgetPromiseDocReestrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401042, '. ', 'SourceBudgetPromiseDocNote', '. ', 'SourceBudgetPromiseDocNote', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401043, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401044, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401045, ' . ', 'SourceBudgetPromiseSOSumma', ' . ', 'SourceBudgetPromiseSOSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401046, '  . ', 'SourceBudgetPromiseSOReestrNum', '  . ', 'SourceBudgetPromiseSOReestrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401047, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401048, '  ', ' ', '  ', 'DestBudgetPromiseCollaps', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401049, '  ', ' ', '  ', 'DestBudgetPromiseSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401050, '  ', ' ', '  ', 'DestBudgetPromiseAgrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401051, '  ', ' ', '  ', 'DestBudgetPromiseAgrDate', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401052, '  ', ' ', '  ', 'DestBudgetPromiseAgrSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401053, '  ', ' ', '  ', 'DestBudgetPromiseAgrReestrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401054, '.  ', ' ', '.  ', 'DestBudgetPromiseAgrNote', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401055, ' .  ', ' ', ' .  ', 'DestBudgetPromiseSONum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401056, ' .  ', ' ', ' .  ', 'DestBudgetPromiseSODate', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401057, ' .  ', ' ', ' .  ', 'DestBudgetPromiseSOSumma', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401058, '  .  ', ' ', '  .  ', 'DestBudgetPromiseSOReestrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401059, '. .  ', ' ', '. .  ', 'DestBudgetPromiseSONote', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401060, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401061, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401062, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401066, '\ ', 'SourceFacialAcc_Cls', '\ ', 'SourceFacialAccCls', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401067, '  ', 'SOURCEDOCTYPE', '  ', 'SOURCEDOCTYPECLS', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401068, ' ()', 'SourceIFS', ' ()', 'SourceIFS', 0, 304, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30401070, '', 'SourceRegionCLS', '', 'SourceRegionCLS', 0, 304, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30401071, ' ', ' ', ' ', 'StimateID', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401072, '', 'TreeOwner0', '', ' ', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401101, ' ()', 'SourceKD', ' ()', 'SourceKD', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401102, '', 'SourceDocBaseCode', '', 'SourceDocBase', 0, 304, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30401114, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401118, ' ', 'SourceFundsSource', ' ', 'SourceFundsSource', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401136, '', 'BUDGETREF', '', 'BudgetRef', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401138, '  ', 'SourceTransfertCls', '   ()', 'SourceTransfertCls', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401139, '  ', 'SourceTransfertClsCode', '  ', 'SourceTransfertClsValue', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401140, '()', 'SourceKCSRCode', '', 'SourceKCSR', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401141, '()', 'SOURCEKVRCode', '', 'SourceKVR', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401142, ' ', 'SourceKVSRCode', ' ', 'SourceKVSR', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401146, ' ()', 'SourceKDCode', ' ()', 'SourceKDCode', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401147, ' ()', 'SourceIFSCode', ' ()', 'SourceIFS_DescriptionCode', 0, 304, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30401148, ' ', 'TargetCls', ' ', ' ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401149, ' a', 'SourceBudgetPromiseSOID', ' ', 'SourceBudgetPromiseSOID', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401150, ' ', 'ID', ' ', 'Id', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401151, '   ', 'FUID', '   ', 'FUID', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401152, ' ', 'SourceSubsidyCls', '  ()', 'SourceSubsidyCls', 0, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30401153, ' ', 'SourceSubsidyClsCode', ' ', 'SourceSubsidyClsCode', 0, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30401154, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401155, '  ', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401156, '  ()', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401157, '   ()', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401160, '()', 'SourceFact', '', 'SourceFACTCLSKey', 0, 304, 1, 1, '', 0, 18890, 0, 1, '') ;

CALL ImportField(30401161, ' .  ()', 'SOURCEFINTYPE', '  ', 'SourceFINTYPECLSKey', 0, 304, 1, 1, ',', 0, 18893, 0, 1, '') ;

CALL ImportField(30401162, ' ()', 'SourceDirectionCls', '', 'SourceDirectionClsKey', 0, 304, 1, 1, '', 0, 18913, 0, 0, '') ;

CALL ImportField(30401163, ' ()', 'SourceDocBase', '', 'SOURCEDOCBASEKey', 0, 304, 1, 1, ',', 0, 18915, 0, 0, '') ;

CALL ImportField(30401164, '', 'SourceInvestObject', '', 'SourceInvestObjectKey', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401165, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401166, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 0, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30401167, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401168, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 0, 304, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30401169, ' ', 'SourceTargetCls', '  ()', 'SourceTargetClsKey', 0, 304, 1, 1, '', 0, 40642, 0, 0, '') ;

CALL ImportField(30401170, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 0, 304, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30401171, '()', 'CREATERUSER', '()', ' ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401172, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401173, '  ()', 'CREATEDATE', '  ()', ' ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401174, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30401175, '()', 'SourceKESRCode', '()', 'SourceKESR', 0, 304, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30401177, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 0, 304, 1, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(30410151, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 304, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30411011, '', 'SOURCEKVSR', ' ', 'SourceKVSRKey', 1, 304, 1, 1, '', 0, 18886, 0, 1, '') ;

CALL ImportField(30411012, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 1, 304, 1, 1, '', 0, 18887, 0, 1, '') ;

CALL ImportField(30411013, '()', 'SOURCEKFSR', '', 'SourceKFSR', 1, 304, 1, 0, '', 0, 18888, 0, 1, '') ;

CALL ImportField(30411014, '', 'SOURCEKESR', '', 'SourceKESRKey', 1, 304, 1, 1, '', 0, 18868, 0, 1, '') ;

CALL ImportField(30411015, '', 'SOURCEKVR', '', 'SourceKVRKey', 1, 304, 1, 1, '', 0, 18867, 0, 1, '') ;

CALL ImportField(30411016, '', 'SOURCESUBKESR', '', 'SOURCESUBKESRKey', 1, 304, 1, 1, '', 0, 18889, 0, 1, '') ;

CALL ImportField(30411045, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 304, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30411055, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 1, 304, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(30411056, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 1, 304, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(30411058, '  . ', 'SourceBudgetPromiseSORNum', '  . ', ' ', 1, 304, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(30411059, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 1, 304, 1, 1, '', 0, 19821, 0, 1, '') ;

CALL ImportField(30411078, ' ()', 'SourceIFS_DescriptionCode', '  ( )', ' ', 1, 304, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(30411112, '', 'BUDGETREF', '', 'BudgetRef', 1, 304, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(30411122, ' ', 'SourceIFS_FullID', 'SourceIFS_FullID( )', 'SOURCEIFS_DESCRIPTIONCODE', 1, 304, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30411130, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 304, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30411132, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 304, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30411133, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 304, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30411137, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 304, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30411139, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 304, 1, 1, '', 0, 27844, 0, 1, '') ;

CALL ImportField(30411149, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 304, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30411176, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 304, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30411178, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 1, 304, 1, 0, '', 0, 43610, 0, 0, '') ;

--   , +(2)
CALL ImportField(30411179, '   ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30411180, '   ()', 'SourcePayTargetFunds', '   ', ' ', 2, 304, 1, 1, '', 0, null, 0, 0, '') ;

--   \, (0)
CALL ImportField(30500001, ' ', 'ID', ' ', 'ID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500002, ' ', 'DOCNUMBER', ' ', 'DocumentNumber', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500003, '  ', 'FUID', '  ', 'FUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500004, '  ', ' ', '  ', 'SenderRecordID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500005, '  ', ' ', '  ', 'SenderID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500006, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500007, ' ', 'PAYDATE', ' ', 'PayDate', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500008, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500009, '', 'SUMMA', '', 'SUMMA', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500010, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500011, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500012, ' ', 'NOTE', ' ', 'NOTE', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500013, ' ', 'PAYPRIORITY', ' ', 'PayPriority', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500014, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500015, '. ', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500016, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500017, '  ', 'REJECTCAUSE', '  ', 'RejectCause', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500018, '   ', 'SOURCEACCOUNT', '   ', 'SOURCEACCOUNT', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500019, '\ ', 'SOURCEFACIALACC_CLS', '\ ', 'SourceFacialAccCls', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500020, '   -', 'DESTACCOUNT', '   -', 'DESTACCOUNT', 0, 305, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30500021, '\ ', 'DESTFACIALACC_CLS', '\ ', 'DestFacialAccCls', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500022, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500024, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500025, '/ ', 'Acc', '/ ', 'SourceAccountName', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500026, ' ', ' ', ' ', 'SourceFKFacialCode', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500027, ' ', 'DestAccountName', ' ', 'DestAccountName', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500028, ' ', 'DestFACIALCODE', ' ', 'DestFKFacialCode', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500029, ' -', ' ', ' -', 'DestOrgINN', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500030, ' -', ' ', ' -', 'DestOrgKPP', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500031, ' -', 'Name', ' -', 'SourceOrgName', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500032, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500033, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500035, ' ', ' ', ' ', 'BidNumber', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500036, ' ', ' ', ' ', 'ManagerBid', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500037, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500040, '  ', ' ', '  ', 'ManBidFuid', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500041, '', ' ', '', 'DEPARTMENTCLS', 0, 305, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30500042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500043, '   ', 'SoftRejectCause', '   ', 'SoftRejectCause', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500044, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500045, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500046, '   ', ' ', '   ', 'SourceOrgId', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500047, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500048, ' -', 'INN', ' -', 'SourceOrgINN', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500049, ' -', 'Inn20', ' -', 'SourceOrgKPP', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500050, ' -', ' ', ' -', 'SourceOrgCity', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500051, ' ', ' ', ' ', 'SourceBankFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500052, '  ', ' ', '  ', 'SourceBankName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500053, '  ', ' ', '  ', 'SourceBankBIK', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500054, '.  ', ' ', '.  ', 'SourceBankCor', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500055, '   ', ' ', '   ', 'SourceBankCity', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500056, ' \ ', ' ', ' \ ', 'SourceFacialAccClsName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500057, ' \ ', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500058, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500059, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500060, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500061, '  ()', ' ', '  ()', 'SourceFKOrgId', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500062, '   ', ' ', '   ', 'SourceFKOrgFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500063, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500064, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500065, '  ', ' ', '  ', 'SourceFKOrgName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500066, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500067, '    ', ' ', '    ', 'DestAccountFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500068, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500069, '   ', ' ', '   ', 'DestOrgId', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500070, '    ', ' ', '    ', 'DestOrgFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500071, ' -', ' ', ' -', 'DestOrgName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500072, ' -', ' ', ' -', 'DestOrgCity', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500073, ' ', ' ', ' ', 'DestBankFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500074, '  ', ' ', '  ', 'DestBankName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500075, '  ', ' ', '  ', 'DestBankBIK', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500076, '.  ', ' ', '.  ', 'DestBankCor', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500077, '   ', ' ', '   ', 'DestBankCity', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500078, ' \ ', ' ', ' \ ', 'DestFacialAccClsName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500079, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500080, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500081, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500082, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500083, '  ()', ' ', '  ()', 'DestFKOrgId', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500084, '   ', ' ', '   ', 'DestFKOrgFUID', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500085, '   ', ' ', '   ', 'DestFKOrgINN', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500086, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500087, '  ', ' ', '  ', 'DestFKOrgName', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500088, '   ', ' ', '   ', 'DestFKOrgCity', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500089, ' ', ' ', ' ', 'LinkedDocument', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500090, '- ', ' ', '- ', 'DestDocBase', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500092, '   ', ' ', '   ', 'FEDERALFUNDSName', 0, 305, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30500093, '   ', ' ', '   ', 'FEDERALFUNDSREF', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500094, '', ' ', ' ', '', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500117, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500121, '', 'BUDGETREF', '', 'BudgetRef', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500134, '( )', 'IsBlocked', '', 'IsBlocked', 0, 305, 0, 0, '', 0, 19012, 0, 0, '') ;

CALL ImportField(30500135, ' ( )', 'BlockedCause', ' ', 'BLOCKEDCAUSE', 0, 305, 0, 0, '', 0, 19013, 0, 0, '') ;

CALL ImportField(30500136, ' ( )', 'UnBlockedDate', ' ', 'UnBlockedDate', 0, 305, 0, 0, '', 0, 19014, 0, 0, '') ;

CALL ImportField(30500137, ' ( )', 'UnBlockedCause', ' ', 'UnblockedCause', 0, 305, 0, 0, '', 0, 19015, 0, 0, '') ;

CALL ImportField(30500138, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500145, ' ', 'DocStateName', ' ', 'DocStateName', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500146, ' ', 'DestFacialAcc_ClsName', ' ', ' ', 0, 305, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30500148, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500149, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 305, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30500150, '   ', 'TaxNote', '   ', 'TaxNote', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500159, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30500160, ' ', 'IsVised', ' ', 'IsVised', 0, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30500161, ' ', 'RegionContractor', ' ', 'RegionContractor', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500162, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500163, '    ', 'ElDocRef', '    ', ' ', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500165, ' ()', 'CardRef', '  ', 'CardRef', 0, 305, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30500169, '  ', 'CardRefName', '  ', 'CardRefName', 0, 305, 0, 0, '', 0, 18939, 0, 0, '') ;

CALL ImportField(30500170, '', 'UINCode', '  ', 'UINCode', 0, 305, 0, 0, '', 0, 35367, 0, 1, '') ;

CALL ImportField(30500171, ' ', 'CardNumber', '  ', 'CardNumber', 0, 305, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30500172, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 305, 0, 0, '', 0, 31657, 0, 1, '') ;

CALL ImportField(30500173, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 305, 0, 0, '', 0, 31658, 0, 1, '') ;

CALL ImportField(30500174, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 305, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30500176, '()', 'CREATERUSER', '()', ' ', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500177, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500178, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30500179, '  ()', 'CREATEDATE', '  ()', ' ', 0, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501001, ' ', 'ID', ' ', 'Id', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501002, '  ', 'FUID', '  ', 'FUID', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501003, '  ', ' ', '  ', 'SenderRecordID', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501004, '  ', ' ', '  ', 'SenderID', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501005, '', 'SUMMA', '', 'SUMMA', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501006, ' ', ' ', ' ', 'NOTE', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501007, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501008, '  ', 'RECORDINDEX', '  ', 'RecordIndex', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501009, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501010, '  ()', 'DESTBUDGETPROMISENUM', '  ()', 'DestBudgetPROMISENum', 0, 305, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501011, '  ', 'DESTBUDGETPROMISE', '  ', 'DestBUDGETPROMISE', 0, 305, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501012, '\ ', 'DestFacialAcc_Cls', '\ ', 'DestFacialAccCls', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501013, ' ()', 'DESTKVR', ' ', 'DestKVRKey', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501014, '', 'DESTKESR', '', 'DestKESRKey', 0, 305, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30501015, ' ()', 'DestKVSR', ' ()', 'DestKVSRKey', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501016, ' ()', 'DestKCSR', ' ', 'DestKCSRKey', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501017, ' ', 'DestKFSR', ' ', 'DestKFSR', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501018, '', 'DestSubKESR', '', 'DestSUBKESRKey', 0, 305, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30501019, ' ', 'DestFactCode', ' ', 'DestFACTCLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501020, '  ', 'DestMeansType', '  ', 'DestMEANSTYPECLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501021, '  ', 'DestFinSource', '  ', 'DestFINSOURCECLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501022, ' . ', 'DestFinTypeCode', '  ', 'DestFINTYPECLS', 0, 305, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501023, '  ', 'DestDocType', '  ', 'DestDOCTYPECLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501024, ' ', 'DestDirectionCLSCode', ' ', 'DestDirectionCLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501025, ' ', ' ', ' ', 'StimateID', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501026, '.  ', 'DestExecDocCollaps', '.  ', '.  ', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501027, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501028, '', 'DestExecDocNum', '', 'DestExecDocNum', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501029, ' ', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501030, '', 'DestExecDocDate', '', 'DestExecDocDate', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501031, '  ', 'DestExecDocType', '  ', 'DestExecDocType', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501032, ' .  ', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501033, '', 'DestExecDocNote', '', 'DestExecDocNote', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501034, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501035, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 305, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501036, '  ', 'DestBudgetPromiseDocNote', '  ', 'DestBudgetPromiseDocNote', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501037, '   ', 'DestBudgetPromiseDocReestrNum', '   ', 'DestBudgetPromiseDocReestrNum', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501038, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501039, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501040, '  ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501041, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501044, ' ()', 'DestIFS', '   .  . -', 'DestIFS', 0, 305, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501045, '', 'DestIFSCode', ' ( )', 'DestIFS_DescriptionCode', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501105, '', 'DestRegionCls', '', 'DestRegionCls', 0, 305, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30501106, '', 'DestDocBaseCode', '', 'DestDocBase', 0, 305, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30501118, '', 'TreeOwner0', '()', ' ', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501120, ' ()', 'DestKD', ' ', 'DestKD', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501122, '', 'BUDGETREF', '', 'BudgetRef', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501139, '   ()', 'DestTransfertCls', '   ()', 'DestTransfertCls', 0, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30501140, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501141, '', 'DestKCSRCode', '', 'DestKCSR', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501142, '', 'DESTKVRCode', '', 'DestKVR', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501143, '', 'DestKVSRCode', '', 'DestKVSR', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501144, ' ', 'DestFundsSource', '', 'DestFundsSource', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501151, '()', 'DestKDCode', ' ', 'DestKDValue', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501152, '  ', 'DestBudgetPromiseCollaps', '  ', 'DestBudgetPromiseCollaps', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501153, ' . ', 'DestBudgetPromiseSODate', ' . ', 'DestBudgetPromiseSODate', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501154, ' ', 'DestBudgetPromiseSOID', '', ' ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501155, '. . ', 'DestBudgetPromiseSONote', '. . ', 'DestBudgetPromiseSONote', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501156, ' . ', 'DestBudgetPromiseSONum', ' . ', 'DestBudgetPromiseSONum', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501157, '  . ', 'DestBudgetPromiseSOReestrNum', '  . ', 'DestBudgetPromiseSOReestrNum', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501158, ' . ', 'DestBudgetPromiseSOSumma', ' . ', 'DestBudgetPromiseSOSumma', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501159, ' ', 'DestSubsidyCls', '  ()', 'DestSubsidyCls ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501160, ' ', 'DestSubsidyClsCode', ' ', 'DestSubsidyClsCode', 0, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30501161, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501162, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501163, '   ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501164, '  ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501172, ' ()', 'DestFact', '', 'DestFACTCLSKey', 0, 305, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30501173, ' .  - ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 0, 305, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30501174, ' ()', 'DestDirectionCls', ' ', 'DestDirectionClsKey', 0, 305, 1, 1, '', 0, 18914, 0, 0, '') ;

CALL ImportField(30501175, ' ()', 'DestDocBase', '', 'DESTDOCBASEKey', 0, 305, 1, 1, ',', 0, 18916, 0, 0, '') ;

CALL ImportField(30501176, '', 'DestInvestObject', '', 'DestInvestObjectKey', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501177, '', 'DestInvestObjectCode', '', 'DestInvestObject', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501178, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30501179, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501181, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 0, 305, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30501182, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 0, 305, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30501183, '()', 'CREATERUSER', '()', ' ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501184, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501185, '  ()', 'CREATEDATE', '  ()', ' ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501186, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30501187, '()', 'DESTKESRCode', '()', 'DestKESR', 0, 305, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30501189, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 0, 305, 1, 0, '', 0, 43610, 0, 1, '') ;

--   \, (1)
CALL ImportField(30510058, '   ', ' ', '   ', 'SourceBankCity', 1, 305, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30510080, '   ', ' ', '   ', 'DestBankCity', 1, 305, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30511013, '', 'DESTKVR', ' ', 'DestKVRKey', 1, 305, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30511014, '', 'DESTKESR', '', 'DestKESRKey', 1, 305, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30511015, '', 'DestKVSR', ' ', 'DestKVSRKey', 1, 305, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30511016, '', 'DestKCSR', ' ', 'DestKCSRKey', 1, 305, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30511017, '()', 'DestKFSR', ' ', 'DestKFSR', 1, 305, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30511018, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 305, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30511035, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 305, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30511046, ' ()', 'DestIFS_DescriptionCode', ' ( )', ' ', 1, 305, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(30511117, '', 'BUDGETREF', '', 'BudgetRef', 1, 305, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(30511130, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 305, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30511132, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 305, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30511133, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 305, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30511138, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 305, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30511140, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 305, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30511188, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 305, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30511190, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 305, 1, 0, '', 0, 43610, 0, 1, '') ;

--   \, +(2)
CALL ImportField(30510173, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 2, 305, 0, 0, '', 0, 45426, 0, 2, '') ;

CALL ImportField(30510191, '   (  )', 'CodePurpose', '   (  )', 'CodePurpose', 2, 305, 0, 0, '', 1, null, 30510173, 1, '') ;

CALL ImportField(30511150, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 2, 305, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30511192, '   ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30511193, '   ()', 'DestPayTargetFunds', '   ', ' ', 2, 305, 1, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(30600051, '', 'BUDGETREF', '', 'BudgetRef', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600052, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DESTFACIALACCCLS', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600053, '. ', 'DestAccountName', '. ', 'DestAccountName', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600054, ' ', 'INN', ' ', 'SourceOrgINN', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600055, ' ', 'Inn20', ' ', 'SourceOrgKPP', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600056, '  ', 'NAME', '  ', 'SourceOrgNAME', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600057, ' ', 'Acc', ' ', 'SourceAccountName', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600058, '()', 'SUMMA', '()', 'SUMMA', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600059, ' ', 'NOTE', ' ', 'NOTE', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600060, ' ', 'ACCEPTDATE', ' ', 'ACCEPTDATE', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600061, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600063, ' ', 'DOCUMENTDATE', ' ', 'DOCUMENTDATE', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600064, ' ', 'DOCNUMBER', ' ', 'DocumentNumber', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600077, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600078, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600089, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600090, '  ()', 'REJECTCAUSE', '  ()', 'REJECTCAUSE', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600091, '. ', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600092, '/ ()', 'SOURCEFACIALACC_CLS', '/ ()', 'SOURCEFACIALACCCLS', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600093, '/  .', 'DestFacialCode', '/  .', 'DestFacialAccClsFacialCode', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600094, ' ', 'TYPEOPERATIONCLS', ' ', 'OPERATIONTYPECLS', 0, 306, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30600128, ' ', 'ID', ' ', 'ID', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600130, ' ', 'Progindex', '  ()', 'ProgIndex', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600137, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600143, ' ', 'DocStateName', ' ', 'DocStateName', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600144, '.  ()', 'DESTACCOUNT', '.  ()', 'DESTACCOUNT', 0, 306, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30600145, '  /c ', 'SOURCEACCOUNT', '  /c ', 'SOURCEACCOUNT', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600146, '(  )', 'UINCode', '  ', 'UINCode', 0, 306, 0, 0, '', 0, 35367, 0, 1, '') ;

CALL ImportField(30600147, '( )', 'IsBlocked', '', 'IsBlocked', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600148, ' ( )', 'BlockedCause', ' ', 'BLOCKEDCAUSE', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600149, ' ( )', 'UnBlockedDate', ' ', 'UnBlockedDate', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600150, ' ( )', 'UnBlockedCause', ' ', 'UnblockedCause', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600151, '  ', 'BlockedCondition', '  ', ' ', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600176, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600177, '  ', 'FUID', '  ', 'FUID', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600180, ' ()', 'DocStateRef', ' ()', 'DocStateRef', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600181, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600182, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600183, ' ', 'IsVised', ' ', 'IsVised', 0, 306, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30600188, ' ', 'CashierPersonalInfo', ' ', 'CashierPersonalInfo', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600189, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600190, ' ', 'CARDNUMBER', '  ', 'CARDNUMBER', 0, 306, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30600192, ' ()', 'CardRef', '  ', 'CardRef', 0, 306, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30600193, ' ', 'CardRefName', '  ', 'CardRefName', 0, 306, 0, 0, '', 0, 18939, 0, 1, '') ;

CALL ImportField(30600194, '()', 'CREATERUSER', '()', ' ', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600195, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600196, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30600197, '  ()', 'CREATEDATE', '  ()', ' ', 0, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601065, ' ', 'PAYSYMBOLCLS', ' ', 'PAYSYMBOLCLS', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601066, ' ', 'NOTE', ' ', 'NOTE', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601067, '', 'TreeOwner0', '', ' ', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601068, ' ()', 'DestKVSR', ' ()', 'DestKVSRKey', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601069, '', 'DestKFSR', '', 'DestKFSR', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601070, ' ()', 'DestKCSR', ' ()', 'DestKCSRKey', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601071, ' ()', 'DESTKVR', '', 'DestKVRKey', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601072, '', 'DESTKESR', '', 'DESTKESRKey', 0, 306, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30601073, '', 'DestFactCode', '', 'DestFactCls', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601074, '', 'DestDirectionCLSCode', '', 'DestDirectionCLS', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601075, ' .  . . ()', 'DestIFS', ' .  . . ()', 'DestIFS', 0, 306, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30601076, ' ()', 'DestKD', ' ()', 'DestKD', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601079, ' . ', 'DestFinTypeCode', '  ', 'DestFinTypeCls', 0, 306, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30601080, ' ', 'DestDocType', ' ', 'DestDocTypeCls', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601081, '()', 'SUMMA', '()', 'SUMMA', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601082, '  ', 'DESTPROMISE', '  ', 'DESTPROMISE', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601083, '  ()', 'DESTBUDGETPROMISENUM', '  ()', 'DESTBUDGETPROMISENUM', 0, 306, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30601084, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601085, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 306, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30601086, '', 'DestSubKESR', '', 'DestSubKESRKey', 0, 306, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30601087, ' ', 'DestMeansType', ' ', 'DestMeansTypeCls', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601088, ' ', 'DestFinSource', ' ', 'DestFinSourceCls', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601095, '', 'DestDocBaseCode', '', 'DestDocBase', 0, 306, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30601096, '', 'DestRegionCls', '', 'DestRegionCls', 0, 306, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30601118, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601122, ' ', 'DestFundsSource', ' ', 'DestFundsSource', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601129, '', 'BUDGETREF', '', 'BudgetRef', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601138, '  ', 'DestTransfertCls', '   ()', 'DestTransfertCls', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601139, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601140, '', 'DestKCSRCode', '', 'DestKCSR', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601141, '', 'DESTKVRCode', '', 'DestKVR', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601142, '', 'DestKVSRCode', '', 'DestKVSR', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601152, '', 'DestKDCode', '', 'DestKDValue', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601153, ' .  . .', 'DestIFSCode', ' .  . .', 'DestIFS_DescriptionCode', 0, 306, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30601154, '  ', 'DESTBUDGETPROMISE', '  ', 'DestBUDGETPROMISE', 0, 306, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30601155, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601156, '  ', 'DestBudgetPromiseDocNote', '  ', 'DestBudgetPromiseDocNote', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601157, '  ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601158, '   ', 'DestBudgetPromiseDocReestrNum', '   ', 'DestBudgetPromiseDocReestrNum', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601159, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601160, '  ', 'DestBudgetPromiseCollaps', '  ', 'DestBudgetPromiseCollaps', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601161, ' . ', 'DestBudgetPromiseSODate', ' . ', 'DestBudgetPromiseSODate', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601162, ' ', 'DestBudgetPromiseSOID', '', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601163, '. . ', 'DestBudgetPromiseSONote', '. . ', 'DestBudgetPromiseSONote', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601164, ' . ', 'DestBudgetPromiseSONum', ' . ', 'DestBudgetPromiseSONum', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601165, '  . ', 'DestBudgetPromiseSOReestrNum', '  . ', 'DestBudgetPromiseSOReestrNum', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601166, ' . ', 'DestBudgetPromiseSOSumma', ' . ', 'DestBudgetPromiseSOSumma', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601167, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601168, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601169, '.  ', 'DestExecDocCollaps', '.  ', '.  ', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601170, '', 'DestExecDocDate', '', 'DestExecDocDate', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601171, '', 'DestExecDocNote', '', 'DestExecDocNote', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601172, '', 'DestExecDocNum', '', 'DestExecDocNum', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601173, ' ', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601174, ' .  ', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601175, '  ', 'DestExecDocType', '  ', 'DestExecDocType', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601176, ' ', 'Progindex', '  ()', 'ProgIndex', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601178, '  ', 'FUID', '  ', 'FUID', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601184, '/ ', 'DestFacialAcc_Cls', '/ ', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601185, ' ', 'ID', ' ', 'Id', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601186, ' ', 'DestSubsidyCls', '  ()', 'DestSubsidyCls', 0, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30601187, ' ', 'DestSubsidyClsCode', ' ', 'DestSubsidyClsCode', 0, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30601188, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601189, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601190, '  ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601191, '   ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601194, ' ()', 'DestFact', '', 'DestFACTCLSKey', 0, 306, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30601195, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 0, 306, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30601196, ' ()', 'DestDirectionCls', ' ', 'DestDirectionClsKey', 0, 306, 1, 1, '', 0, 18914, 0, 0, '') ;

CALL ImportField(30601197, ' ()', 'DestDocBase', '', 'DESTDOCBASEKey', 0, 306, 1, 1, ',', 0, 18916, 0, 0, '') ;

CALL ImportField(30601198, '', 'DestInvestObject', '', 'DestInvestObjectKey', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601199, '', 'DestInvestObjectCode', '', 'DestInvestObject', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601200, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30601201, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601202, '()', 'CREATERUSER', '()', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601203, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601204, '  ()', 'CREATEDATE', '  ()', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601205, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30601207, '()', 'DESTKESRCode', '()', 'DestKESR', 0, 306, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30601209, '()', 'DestSubKESRCode', '()', 'DestSubKESR', 0, 306, 1, 0, '', 0, 43610, 0, 1, '') ;

--   , (1)
CALL ImportField(30610145, ' ', 'CardRefName', '  ', 'CardRefName', 1, 306, 0, 0, '', 0, 18939, 0, 0, '') ;

CALL ImportField(30611018, '', 'DestKVSR', '', 'DestKVSRKey', 1, 306, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30611019, '()', 'DestKFSR', '', 'DestKFSR', 1, 306, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30611020, '', 'DestKCSR', '', 'DestKCSRKey', 1, 306, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30611021, '', 'DESTKVR', '', 'DestKVRKey', 1, 306, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30611022, '', 'DESTKESR', '', 'DestKESRKey', 1, 306, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30611037, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 306, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30611039, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 306, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30611116, '', 'BUDGETREF', '', 'BudgetRef', 1, 306, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(30611133, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 306, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30611135, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 306, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30611136, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 306, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30611140, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 306, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30611142, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 306, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30611206, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 306, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30611208, '()', 'DestSubKESRCode', '()', 'DestSubKESR', 1, 306, 1, 0, '', 0, 43610, 0, 1, '') ;

--   , +(2)
CALL ImportField(30611210, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30611211, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 306, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(30700001, '()', 'CREATERUSER', '()', ' ', 0, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30700002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30700003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30700004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30701001, '()', 'CREATERUSER', '()', ' ', 0, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30701002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30701003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30701004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 307, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(30800003, '    ', ' ', '    ', 'SourceFKFacialCode', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800004, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800005, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800006, '  ', 'SourceFacialAcc_Cls', '  ', 'SourceFacialAccCls', 0, 308, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30800007, ' ()', 'Summa', ' ()', 'SUMMA', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800008, '  ()', 'Note', '  ()', 'NOTE', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800009, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800010, ' ', 'BuhPaymentCls', ' ', 'BUHPAYMENTCLS', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800011, ' ', 'TypeOperationCls', ' ', 'OperationTypeCls', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800012, ' ', 'Reject_Cls', ' ', 'REJECTCLS', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800013, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800014, ' ', 'SourceAccountName', ' ', 'SOURCEACCOUNTNAME', 0, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30800042, ' ', 'ID', ' ', 'ID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800043, '  ', 'FUID', '  ', 'FUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800044, '  ', ' ', '  ', 'SenderRecordID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800045, '  ', ' ', '  ', 'SenderID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800046, ' ', 'PayDate', ' ', 'PayDate', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800047, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800048, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800049, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800050, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800051, ' ', 'PayPriority', ' ', 'PayPriority', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800052, ' ', ' ', ' ', 'CARDNUMBER', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800053, '  /c ', 'SOURCEACCOUNT', '  /c ', 'SOURCEACCOUNT', 0, 308, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30800054, '   -', 'DESTACCOUNT', '   -', 'DESTACCOUNT', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800055, '\ ', 'DESTFACIALACC_CLS', '\ ', 'DestFacialAccCls', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800056, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800057, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800058, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800059, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800060, ' ', 'IsVised', ' ', 'IsVised', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800061, ' ', 'BidNumber', ' ', 'BidNumber', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800062, ' ', ' ', ' ', 'ManagerBid', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800063, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800064, ' ', ' ', ' ', 'StimateID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800065, '  ', ' ', '  ', 'ManBidFuid', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800067, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800068, '', ' ', '', 'DEPARTMENTCLS', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800069, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800070, '   ', 'SoftRejectCause', '   ', 'SoftRejectCause', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800071, '    ', ' ', '    ', 'DestAccountFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800072, ' ', ' ', ' ', 'DestAccountName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800073, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800074, ' ', ' ', ' ', 'DestFKFacialCode', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800075, '   ', ' ', '   ', 'DestOrgId', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800076, '    ', ' ', '    ', 'DestOrgFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800077, ' -', ' ', ' -', 'DestOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800078, ' -', ' ', ' -', 'DestOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800079, ' -', ' ', ' -', 'DestOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800080, ' -', ' ', ' -', 'DestOrgCity', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800081, ' ', ' ', ' ', 'DestBankFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800082, '  ', ' ', '  ', 'DestBankName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800083, '  ', ' ', '  ', 'DestBankBIK', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800084, '.  ', ' ', '.  ', 'DestBankCor', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800085, '   ', ' ', '   ', 'DestBankCity', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800086, ' \ ', ' ', ' \ ', 'DestFacialAccClsName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800087, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800088, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800089, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800090, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800091, '  ()', ' ', '  ()', 'DestFKOrgId', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800092, '   ', ' ', '   ', 'DestFKOrgFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800093, '   ', ' ', '   ', 'DestFKOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800094, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800095, '  ', ' ', '  ', 'DestFKOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800096, '   ', ' ', '   ', 'DestFKOrgCity', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800097, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800098, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800099, '   ', ' ', '   ', 'SourceOrgId', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800100, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800101, ' -', ' ', ' -', 'SourceOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800102, ' -', ' ', ' -', 'SourceOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800103, ' -', ' ', ' -', 'SourceOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800104, ' -', ' ', ' -', 'SourceOrgCity', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800105, ' ', ' ', ' ', 'SourceBankFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800106, '  ', ' ', '  ', 'SourceBankName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800107, '  ', ' ', '  ', 'SourceBankBIK', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800108, '.  ', ' ', '.  ', 'SourceBankCor', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800109, '   ', ' ', '   ', 'SourceBankCity', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800110, '', 'SourceFacialAccName', '\ ', 'SourceFacialAccClsName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800111, ' \ ', 'SourceFacialCode', ' \ ', 'SourceFacialAccClsFacialCode', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800112, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800113, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800114, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800115, '  ()', ' ', '  ()', 'SourceFKOrgId', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800116, '   ', ' ', '   ', 'SourceFKOrgFUID', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800117, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800118, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800119, '  ', ' ', '  ', 'SourceFKOrgName', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800120, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800180, '', ' ', ' ', '', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800183, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 0, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30800188, ' ', 'DocStateName', ' ', 'DocStateName', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800190, '  ', 'Accepted', '  ', 'Accepted', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800191, ' ', 'Reestr_Ref', ' ', 'Reestr_Ref', 0, 308, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30800193, '', 'BUDGETREF', '', 'BudgetRef', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800194, ' ', 'ClsType', ' ', 'CLSTYPE', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800195, ' ', 'ClsTypeText', ' ', ' ', 0, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30800228, '(  )', 'NDS', '', 'NDS', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800229, ' ', 'BidDate', '', 'BidDate', 0, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30800230, ' (  )', 'UINCode', '  ', 'UINCode', 0, 308, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30800231, ' ', 'DestClsType', '', ' ', 0, 308, 0, 1, '', 0, 38187, 0, 0, '') ;

CALL ImportField(30800232, ' / ', 'DestFacialAcc_ClsEx', '', ' ', 0, 308, 0, 0, '', 0, 26617, 0, 0, '') ;

CALL ImportField(30800233, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 308, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30800234, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 308, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30800235, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 308, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30800236, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 0, 308, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30800237, '()', 'CREATERUSER', '()', ' ', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800238, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800239, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800240, '  ()', 'CREATEDATE', '  ()', ' ', 0, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30800261, '', 'Signers', '', 'Signers', 0, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801001, ' ', 'SourceDirectionClsCode', ' ', 'SourceDirectionCLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801002, ' ', 'DestDirectionClsCode', ' ', 'DestDirectionCLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801015, '   ', 'Summa', '   ', 'SUMMA', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801016, ' . ()', 'SourceKVR', ' . ()', 'SourceKVRKey', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801017, ' .()', 'SourceKESR', ' .()', 'SourceKESRKey', 0, 308, 1, 1, ',', 0, 18868, 0, 1, '') ;

CALL ImportField(30801018, ' ', 'SourceKFSR', ' ', 'SourceKFSR', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801019, ' . ()', 'SourceKCSR', ' ', 'SourceKCSRKey', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801020, ' . ()', 'SourceKVSR', ' . ()', 'SourceKVSRKey', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801021, ' .()', 'SourceSubKESR', ' . ()', 'SourceSUBKESRKey', 0, 308, 1, 1, ',', 0, 18889, 0, 1, '') ;

CALL ImportField(30801022, ' ', 'SourceFactCode', ' ', 'SourceFACTCLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801023, '  ', 'SourceMeansType', '  ', 'SourceMEANSTYPECLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801024, ' .  .', 'SourceFinTypeCode', '   .', 'SourceFINTYPECLS', 0, 308, 1, 0, ',,,', 0, null, 0, 1, '') ;

CALL ImportField(30801025, '  ', 'SourceFinSource', '  ', 'SourceFINSOURCECLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801026, '  ', 'DestFacialAcc_Cls', '  ', 'DestFacialAccCls', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801027, '    ', 'DestFacialCode', '    ', 'DestFacialAccClsFacialCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801028, ' . ()', 'DestKVR', ' ', 'DestKVRKey', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801029, ' ', 'DestKESR', ' ', 'DestKESRKey', 0, 308, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30801030, ' ', 'DestKFSR', ' ', 'DestKFSR', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801031, ' . ()', 'DestKCSR', ' ', 'DestKCSRKey', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801032, ' . ()', 'DestKVSR', ' . ()', 'DestKVSRKey', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801033, ' ', 'DestSubKESR', ' ', 'DestSUBKESRKey', 0, 308, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30801034, ' ', 'DestFactCode', ' ', 'DestFACTCLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801035, '  ', 'DestMeansType', '  ', 'DestMEANSTYPECLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801036, ' .  ( )', 'DestFinTypeCode', '   -', 'DestFINTYPECLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801037, '  ', 'DestFinSource', '  ', 'DestFINSOURCECLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801038, '   ', 'Note', '   ', 'NOTE', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801039, ' . ', 'MemOrderNum', ' . ', 'MemOrderNum', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801040, '  ', 'SourcePromise', '  ', 'SOURCEPROMISE', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801041, '  ', 'DestPromise', '  ', 'DestPROMISE', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801063, '   ', 'DestTransfertCls', '', 'DestTransfertCls', 0, 308, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(30801064, '   -', 'DestTransfertClsCode', '', 'DestTransfertClsValue', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801065, '   ', 'SourceTransfertCls', '', 'SourceTransfertCls', 0, 308, 1, 1, ',', 0, 18935, 0, 1, '') ;

CALL ImportField(30801066, '   ', 'SourceTransfertClsCode', '', 'SourceTransfertClsValue', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801122, '  ()', 'SourceBudgetPromiseNum', '  ()', 'SourceBudgetPromiseNum', 0, 308, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(30801123, '  ', 'SourceExecDocCollaps', '  ', '  ', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801124, '    ', 'SourceExecDoc', '    ', '    ', 0, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801125, '   ', 'SourceExecDocNum', '   ', '   ', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801126, '   ', 'SourceExecDocReestr', '   ', '   ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801127, '  ', 'SourceExecDocDate', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801128, '  ', 'SourceExecDocType', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801129, '   ', 'SourceExecDocSumma', '   ', '   ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801130, '  ', 'SourceExecDocNote', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801131, '     ', 'DestBudgetPromise', '     ', 'DestBudgetPromise', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801132, '  ()', 'DestBudgetPromiseNum', '  ()', '  ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801133, '  ', 'DestExecDocCollaps', '  ', '  ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801134, '    ', 'DestExecDoc', '    ', '    ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801135, '   ', 'DestExecDocNum', '   ', '   ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801136, '   ', 'DestExecDocReestr', '   ', '   ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801137, '  ', 'DestExecDocDate', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801138, '  ', 'DestExecDocType', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801139, '   ', 'DestExecDocSumma', '   ', '   ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801140, '  ', 'DestExecDocNote', '  ', '  ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801141, '  ', 'SourceBudgetPromiseCollaps', '  ', 'SourceBudgetPromiseCollaps', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801142, '  ', 'SourceBudgetPromiseSumma', '  ', 'SourceBudgetPromiseSumma', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801143, '  ', 'SourceBudgetPromiseDocNumber', '  ', 'SourceBudgetPromiseDocNumber', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801144, '  ', 'SourceBudgetPromiseDocDate', '  ', 'SourceBudgetPromiseDocDate', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801145, '  ', 'SourceBudgetPromiseDocSumma', '  ', 'SourceBudgetPromiseDocSumma', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801146, '  .', 'SourceBudgetPromiseDocReestrNum', '  .', 'SourceBudgetPromiseDocReestrNum', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801147, '.  ', 'SourceBudgetPromiseDocNote', '.  ', 'SourceBudgetPromiseDocNote', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801148, ' .  ', 'SourceBudgetPromiseSONum', ' .  ', 'SourceBudgetPromiseSONum', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801149, ' .  ', 'SourceBudgetPromiseSODate', ' .  ', 'SourceBudgetPromiseSODate', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801150, ' .  ', 'SourceBudgetPromiseSOSumma', ' .  ', 'SourceBudgetPromiseSOSumma', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801151, '  .  ', 'SourceBudgetPromiseSOReestrNum', '  .  ', 'SourceBudgetPromiseSOReestrNum', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801152, '. .  ', 'SourceBudgetPromiseSONote', '. .  ', 'SourceBudgetPromiseSONote', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801153, '  ', 'DestBudgetPromiseCollaps', '  ', 'DestBudgetPromiseCollaps', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801154, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801155, '   ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801156, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801157, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801158, '   ', 'DestBudgetPromiseDocReestrNum', '   ', 'DestBudgetPromiseDocReestrNum', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801159, '.  ', 'DestBudgetPromiseDocNote', '.  ', 'DestBudgetPromiseDocNote', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801160, ' .  ', 'DestBudgetPromiseSONum', ' .  ', 'DestBudgetPromiseSONum', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801161, ' .  ', 'DestBudgetPromiseSODate', ' .  ', 'DestBudgetPromiseSODate', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801162, ' .  ', 'DestBudgetPromiseSOSumma', ' .  ', 'DestBudgetPromiseSOSumma', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801163, '  .   ', 'DestBudgetPromiseSOReestrNum', '  .  ', 'DestBudgetPromiseSOReestrNum', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801164, '. .   ', 'DestBudgetPromiseSONote', '. .  ', 'DestBudgetPromiseSONote', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801165, ' ', 'Id', ' ', 'Id', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801166, '  ', 'FUID', '  ', 'FUID', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801167, '  ', ' ', '  ', 'SenderRecordID', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801168, '  ', ' ', '  ', 'SenderID', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801169, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801170, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801171, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801172, ' ', 'ClsType', ' ', 'ClsType', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801173, '  ', 'DestDOCTYPE', '  ', 'DestDOCTYPECLS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801174, ' ( )', 'DestIFS', '', 'DestIFS', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801175, '  ', 'SourceBUDGETPROMISE', '  ', 'SourceBUDGETPROMISE', 0, 308, 1, 0, ',,', 0, null, 0, 1, '') ;

CALL ImportField(30801177, '  ', 'SourceDOCTYPE', '  ', 'SourceDOCTYPECLS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801178, ' ( )', 'SourceIFS', '', 'SourceIFS', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801179, ' ', ' ', ' ', 'StimateID', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801181, ' ', 'TreeOwner0', ' ', ' ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801182, ' ', 'TreeOwner1', ' ', ' ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801184, ' ', 'DestRegionCls', ' ', 'DestRegionCls', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801185, ' ', 'DestDocBaseCode', ' ', 'DestDocBase', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801186, ' ', 'SourceDocBaseCode', ' ', 'SourceDocBase', 0, 308, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(30801187, ' ', 'SourceRegionCls', ' ', 'SourceRegionCls', 0, 308, 1, 0, ',,,', 0, null, 0, 0, '') ;

CALL ImportField(30801194, '', 'BUDGETREF', '', 'BudgetRef', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801195, '', 'DestFacialAccName', '', ' ', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801196, ' .', 'SourceKCSRCode', '', 'SourceKCSR', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801197, ' .', 'SOURCEKVRCode', ' .', 'SourceKVR', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801198, ' .', 'SourceKVSRCode', ' .', 'SourceKVSR', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801199, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 0, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801200, '.  .', 'SourceFundsSource', '.  .', 'SourceFundsSource', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801201, '  .', 'DestClsType', '  .', 'DestClsType', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801202, ' .', 'DestKCSRCode', ' .', 'DestKCSR', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801203, ' .', 'DESTKVRCode', ' .', 'DestKVR', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801204, ' .', 'DestKVSRCode', ' .', 'DestKVSR', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801205, '  .', 'DestTargetClsCode', '  .', 'DestTargetCls', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801206, '.  ', 'DestFundsSource', '.  .', 'DestFundsSource', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801207, ' . ()', 'SourceKD', ' . ()', 'SOURCEKD', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801208, ' .', 'SourceKDCode', ' .', 'SourceKDValue', 0, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801209, ' . ()', 'DestKD', ' . ()', 'DestKD', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801210, ' .', 'DestKDCode', ' .', 'DestKDValue', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801211, ' ', 'PaySymbolCls', ' ', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801212, ' . .', 'SourceBudgetPromiseSOID', '', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801213, ' . .', 'DestBudgetPromiseSOID', ' . .', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801214, '  -', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801215, '   -', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801216, '  .', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801217, '   .', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801218, '  -', 'DestSubsidyCls', '', 'DestSubsidyCls', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801219, '  -', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801220, '  .', 'SourceSubsidyCls', '', 'SourceSubsidyCls', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801221, '  .', 'SourceSubsidyClsCode', '', 'SourceSubsidyClsCode', 0, 308, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801222, '  - ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801223, '   - ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 308, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30801224, '  . ()', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801225, '   . ()', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 0, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30801226, '. . . .', 'DestIFSCode', '', 'DestIFS_DescriptionCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801227, '. . . .', 'SourceIFSCode', '', 'SourceIFS_DescriptionCode', 0, 308, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30801231, '  ()', 'DestFact', ' ', 'DestFACTCLSKey', 0, 308, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30801232, '  ()', 'SourceFact', ' ', 'SourceFACTCLSKey', 0, 308, 1, 1, ',', 0, 18890, 0, 1, '') ;

CALL ImportField(30801233, ' .  ()', 'DestFinType', '   ', 'DestFINTYPECLSKey', 0, 308, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30801234, ' .  . ()', 'SourceFinType', '   ', 'SourceFINTYPECLSKey', 0, 308, 1, 1, ',,,', 0, 18893, 0, 1, '') ;

CALL ImportField(30801235, ' -()', 'DestDirectionCLS', ' ', 'DestDirectionClsKey', 0, 308, 1, 1, '', 0, 18914, 0, 0, '') ;

CALL ImportField(30801236, ' .()', 'SourceDirectionCLS', ' ', 'SourceDirectionClsKey', 0, 308, 1, 1, ',', 0, 18913, 0, 0, '') ;

CALL ImportField(30801237, '  ()', 'DestDocBase', ' ', 'DESTDOCBASEKey', 0, 308, 1, 1, ',', 0, 18916, 0, 0, '') ;

CALL ImportField(30801238, '  ()', 'SourceDocBase', ' ', 'SOURCEDOCBASEKey', 0, 308, 1, 1, ',,', 0, 18915, 0, 0, '') ;

CALL ImportField(30801239, '  ()', 'SourceInvestObject', ' ', 'SourceInvestObjectKey', 0, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801240, '  ()', 'DestInvestObject', ' ', 'DestInvestObjectKey', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801241, ' ', 'SourceInvestObjectCode', ' ', 'SourceInvestObject', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801242, ' ', 'DestInvestObjectCode', ' ', 'DestInvestObject', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801243, ' ', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30801244, ' ', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801245, ' ', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 0, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801246, ' ', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 0, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30801247, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 0, 308, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30801248, '  -', 'DestTargetCls', '   ()', 'DestTargetClsKey', 0, 308, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30801249, '  .', 'SourceTargetCls', '   ()', 'SourceTargetClsKey', 0, 308, 1, 1, ',', 0, 40642, 0, 0, '') ;

CALL ImportField(30801250, '()', 'CREATERUSER', '()', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801251, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801252, '  ()', 'CREATEDATE', '  ()', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801253, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30801255, ' ( )', 'DestKESRCode', ' ( )', 'DestKESR', 0, 308, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30801257, ' ( )', 'DestSubKESRCode', ' ( )', 'DestSUBKESR', 0, 308, 1, 0, '', 0, 24610, 0, 1, '') ;

CALL ImportField(30801259, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 0, 308, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(30801260, ' ( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSUBKESR', 0, 308, 1, 0, ',', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(30810063, ' ', 'ClsType', '', 'CLSTYPE', 1, 308, 0, 1, '', 0, 19008, 0, 0, '') ;

CALL ImportField(30810075, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 308, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30810262, '   ', '', '   ', 'DestBankCity', 1, 308, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30810263, '   ', '', '   ', 'SourceBankCity', 1, 308, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30810264, '', 'Signers', '', 'Signers', 1, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30811002, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 308, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30811027, ' ', 'DestSubKESR', ' ', 'DestSUBKESRKey', 1, 308, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30811044, ' ', 'SourceKCSR', ' .', 'SourceKCSRKey', 1, 308, 1, 1, ',', 0, 18887, 0, 1, '') ;

CALL ImportField(30811045, ' .()', 'SOURCEKESR', ' .()', 'SourceKESRKey', 1, 308, 1, 1, ',', 0, 18868, 0, 1, '') ;

CALL ImportField(30811046, ' ( )', 'SourceKFSR', ' .( .)', 'SourceKFSR', 1, 308, 1, 0, ',', 0, 18888, 0, 1, '') ;

CALL ImportField(30811047, ' ', 'SOURCEKVR', ' .', 'SourceKVRKey', 1, 308, 1, 1, ',', 0, 18867, 0, 1, '') ;

CALL ImportField(30811048, ' ', 'SourceKVSR', ' .', 'SourceKVSRKey', 1, 308, 1, 1, ',', 0, 18886, 0, 1, '') ;

CALL ImportField(30811052, ' ', 'SourceSubKESR', ' .', 'SourceSUBKESRKey', 1, 308, 1, 1, ',', 0, 18889, 0, 1, '') ;

CALL ImportField(30811060, ' ( )', 'SourceKCSRCode', ' .( .)', 'SourceKCSR', 1, 308, 1, 0, ',', 0, 25462, 0, 1, '') ;

CALL ImportField(30811061, ' ( )', 'SOURCEKVRCode', ' .( .)', 'SourceKVR', 1, 308, 1, 0, ',', 0, 25467, 0, 1, '') ;

CALL ImportField(30811062, ' ( )', 'SourceKVSRCode', ' .( .)', 'SourceKVSR', 1, 308, 1, 0, ',', 0, 25472, 0, 1, '') ;

CALL ImportField(30811067, ' ', 'DestKCSR', '', 'DestKCSRKey', 1, 308, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30811068, ' ( )', 'DestKCSRCode', '', 'DestKCSR', 1, 308, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30811069, ' ', 'DESTKESR', ' ', 'DestKESRKey', 1, 308, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30811070, ' ( )', 'DestKFSR', '', 'DestKFSR', 1, 308, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30811071, ' ', 'DESTKVR', '', 'DestKVRKey', 1, 308, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30811072, ' ( )', 'DESTKVRCode', '', 'DestKVR', 1, 308, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30811073, ' ', 'DestKVSR', '', 'DestKVSRKey', 1, 308, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30811074, ' ( )', 'DestKVSRCode', '', 'DestKVSR', 1, 308, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30811085, '  ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 308, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30811087, '  ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 308, 1, 0, ',', 0, 27825, 0, 1, '') ;

CALL ImportField(30811089, '  ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 308, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30811091, '  ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 308, 1, 1, ',', 0, 27844, 0, 1, '') ;

CALL ImportField(30811107, ' .  . ()', 'SourceFinType', '   ', 'SourceFINTYPECLSKey', 1, 308, 1, 1, ',,,', 0, 18893, 0, 1, '') ;

CALL ImportField(30811111, '  ()', 'SourceInvestObject', ' ', 'SourceInvestObjectKey', 1, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30811112, '  ()', 'DestInvestObject', ' ', 'DestInvestObjectKey', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811113, ' ', 'SourceInvestObjectCode', ' ', 'SourceInvestObject', 1, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30811114, ' ', 'DestInvestObjectCode', ' ', 'DestInvestObject', 1, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30811119, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 308, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30811254, ' ( )', 'DestKESRCode', ' ( )', 'DestKESR', 1, 308, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30811256, ' ( )', 'DestSubKESRCode', ' ( )', 'DestSUBKESR', 1, 308, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(30811258, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 308, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(30811261, ' ( .)', 'SourceSubKESRCode', ' ( .)', 'SourceSUBKESR', 1, 308, 1, 0, ',', 0, 43610, 0, 1, '') ;

--  , +(2)
CALL ImportField(30811265, '    ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30811266, '    ()', 'SourcePayTargetFunds', '   ', ' ', 2, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811267, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30811268, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 308, 1, 1, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(31100072, ' ', 'ID', ' ', 'ID', 0, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31100075, ' ', 'CardNumber', '  ', 'CardNumber', 0, 311, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31100076, '()', 'CREATERUSER', '()', ' ', 0, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31100077, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31100078, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31100079, '  ()', 'CREATEDATE', '  ()', ' ', 0, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101034, ' ', 'RECORDINDEX', '  ', 'RECORDINDEX', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101093, '', 'SourceInvestObject', '', ' ', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101094, '', 'SourceInvestObjectCode', '', ' ', 0, 311, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31101095, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101096, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 0, 311, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31101097, '()', 'CREATERUSER', '()', ' ', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101098, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101099, '  ()', 'CREATEDATE', '  ()', ' ', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31101100, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 311, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(31111004, '', 'SOURCEKVR', '', 'SOURCEKVRKey', 1, 311, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(31111005, '', 'SOURCEKESR', '', 'SOURCEKESRKey', 1, 311, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31111006, '()', 'SourceKFSR', '', 'SourceKFSR', 1, 311, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(31111007, '', 'SourceKCSR', '', 'SourceKCSRKey', 1, 311, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(31111008, '', 'SourceKVSR', '', 'SourceKVSRKey', 1, 311, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(31111009, '', 'SourceSubKESR', '', 'SourceSubKESRKey', 1, 311, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31111017, ' ', 'DESTKVR', ' ', 'DESTKVRKey', 1, 311, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31111018, '  ()', 'DESTKESR', ' ', 'DESTKESRKey', 1, 311, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31111019, ' ', 'DestKFSR', ' ', 'DestKFSR', 1, 311, 1, 1, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31111020, ' ', 'DestKCSR', ' ', 'DestKCSRKey', 1, 311, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31111021, ' ', 'DestKVSR', ' ', 'DestKVSRKey', 1, 311, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31111022, '  ()', 'DestSubKESR', ' ', 'DestSubKESRKey', 1, 311, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31111044, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 311, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31111080, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 311, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31111082, '()', 'SOURCEKVRCode', '()', 'SOURCEKVR', 1, 311, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31111083, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 311, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31111091, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 311, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31111093, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 311, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(31111116, ' ', 'DESTKESRCode', ' ', 'DESTKESR', 1, 311, 1, 1, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31111117, ' ', 'DestSubKESRCode', ' ', 'DestSubKESR', 1, 311, 1, 1, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31111118, '()', 'SOURCEKESRCode', '()', 'SOURCEKESR', 1, 311, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31111119, '()', 'SourceSubKESRCode', '()', 'SourceSubKESR', 1, 311, 1, 0, '', 0, 43610, 0, 0, '') ;

--    , +(2)
CALL ImportField(31111120, '    ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 311, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31111121, '    ()', 'SourcePayTargetFunds', '   ', ' ', 2, 311, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31111122, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 311, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31111123, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 311, 1, 1, '', 0, null, 0, 0, '') ;

--     , (0)
CALL ImportField(31200001, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200002, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200003, ' ', 'Reject_Cls', ' ', 'REJECTCLS', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200004, '  / ', 'DestAccount', '  / ', 'DESTACCOUNT', 0, 312, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31200005, '   ()', 'DESTFACIALACC_CLS', '  ', 'DestFacialAccCls', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200006, '  (  )', 'SourceFacialAcc_Cls', '  (  )', 'SourceFacialAccCls', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200007, ' ', 'CardNumber', ' ', 'CARDNUMBER', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200008, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200009, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200010, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200011, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200012, ' ', 'PAYDATE', ' ', 'PayDate', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200013, ' ', 'TypeOperationCls', ' ', 'OperationTypeCls', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200014, '  / ', 'SourceAccount', '  / ', 'SOURCEACCOUNT', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200015, '/  ( )', 'SourceAccountName', '/  ( )', 'SourceAccountName', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200016, '/  ( )', 'DestAccountName', '/  ( )', 'DestAccountName', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200017, '', 'Summa', '', 'Summa', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200018, ' ', 'ReestrDate', ' ', 'REESTRDATE', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200019, ' ', 'PAYPRIORITY', ' ', 'PayPriority', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200020, '  ', 'AcceptDate', '  ', 'AcceptDate', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200021, '. ', 'BuhPaymentCls', '. ', 'BuhPaymentCls', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200022, ' ', 'Note', ' ', 'NOTE', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200023, ' ', 'ID', ' ', 'ID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200024, '  ', 'FUID', '  ', 'FUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200025, '  ', ' ', '  ', 'SenderRecordID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200026, '  ', ' ', '  ', 'SenderID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200027, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200028, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200029, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200030, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200031, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200032, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200033, ' ', 'IsVised', ' ', 'IsVised', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200034, ' ', ' ', ' ', 'BidNumber', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200035, ' ', ' ', ' ', 'ManagerBid', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200036, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200037, ' ', ' ', ' ', 'StimateID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200040, '  ', ' ', '  ', 'ManBidFuid', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200041, ' ', ' ', ' ', 'Reestr_Ref', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200042, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200043, '', ' ', '', 'DEPARTMENTCLS', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200044, '    ', ' ', '    ', 'DestAccountFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200045, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200046, ' ', ' ', ' ', 'DestFKFacialCode', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200047, '   ', ' ', '   ', 'DestOrgId', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200048, '    ', ' ', '    ', 'DestOrgFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200049, ' -', ' ', ' -', 'DestOrgINN', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200050, ' -', ' ', ' -', 'DestOrgKPP', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200051, ' -', ' ', ' -', 'DestOrgName', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200052, ' -', ' ', ' -', 'DestOrgCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200053, ' ', ' ', ' ', 'DestBankFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200054, '  ', ' ', '  ', 'DestBankName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200055, '  ', ' ', '  ', 'DestBankBIK', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200056, '.  ', ' ', '.  ', 'DestBankCor', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200057, '   ', ' ', '   ', 'DestBankCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200058, '\ ', ' ', '\ ', 'DestFacialAccClsName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200059, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200060, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200061, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200062, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200063, '  ()', ' ', '  ()', 'DestFKOrgId', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200064, '   ', ' ', '   ', 'DestFKOrgFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200065, '   ', ' ', '   ', 'DestFKOrgINN', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200066, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200067, '  ', ' ', '  ', 'DestFKOrgName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200068, '   ', ' ', '   ', 'DestFKOrgCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200069, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200070, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200071, ' ', ' ', ' ', 'SourceFKFacialCode', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200072, '   ', ' ', '   ', 'SourceOrgId', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200073, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200074, ' -', ' ', ' -', 'SourceOrgINN', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200075, ' -', ' ', ' -', 'SourceOrgKPP', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200076, ' -', ' ', ' -', 'SourceOrgName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200077, ' -', ' ', ' -', 'SourceOrgCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200078, ' ', ' ', ' ', 'SourceBankFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200079, '  ', ' ', '  ', 'SourceBankName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200080, '  ', ' ', '  ', 'SourceBankBIK', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200081, '.  ', ' ', '.  ', 'SourceBankCor', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200082, '   ', ' ', '   ', 'SourceBankCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200083, '\ (  )', ' ', '\ ', 'SourceFacialAccClsName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200084, ' \ ', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200085, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200086, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200087, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200088, '  ()', ' ', '  ()', 'SourceFKOrgId', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200089, '   ', ' ', '   ', 'SourceFKOrgFUID', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200090, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200091, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200092, '  ', ' ', '  ', 'SourceFKOrgName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200093, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200115, '   ', 'TaxNote', '   ', 'TaxNote', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200116, '', 'BUDGETREF', '', 'BudgetRef', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200130, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200140, ' ', 'DocStateName', ' ', 'DocStateName', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200141, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 312, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31200145, '     (.)', 'DestFacialCode', '    ', ' ', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200159, '', 'UINCode', '  ', 'UINCode', 0, 312, 0, 0, '', 0, 35367, 0, 0, '') ;

CALL ImportField(31200160, '()', 'CREATERUSER', '()', ' ', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200161, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200162, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31200163, '  ()', 'CREATEDATE', '  ()', ' ', 0, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201001, '', 'DestDirectionClsCode', ' ', 'DestDirectionCls', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201002, '    ', 'DestFacialCode', '     ()', 'DestFacialCode', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201003, '', 'SOURCEFACTCODE', '', 'SOURCEFACTCLS', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201004, ' ', 'SourceSubKESR', ' ', 'SOURCESUBKESRKey', 0, 312, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31201005, ' ', 'DestPromise', ' ', 'DestPromise', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201006, ' . ', 'MemOrderNum', ' . ', 'MemOrderNum', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201007, ' ()', 'Note', ' ()', 'Note', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201008, ' ()', 'Summa', ' ()', 'Summa', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201010, ' ', 'SourceFinSource', ' ', 'SOURCEFINSOURCECLS', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201011, '  ', 'DestFacialAcc_Cls', '   ()', 'DestFacialAccCls', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201012, ' . ', 'SourceFinTypeCode', '  ', 'SOURCEFINTYPECLS', 0, 312, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201013, ' . ()', 'SourceKVSR', ' ', 'SourceKVSRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201014, ' ', 'SourceKCSR', ' ', 'SourceKCSRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201015, '', 'SourceKFSR', '', 'SourceKFSR', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201016, ' ', 'SourceKESR', ' ', 'SourceKESRKey', 0, 312, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31201017, ' ', 'SourceKVR', ' ', 'SourceKVRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201029, '     ', 'DestBudgetPromise', '     ', '     ', 0, 312, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201030, '  ()', 'DestBudgetPromiseNum', '  ()', '  ', 0, 312, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201031, '  ', 'DestExecDocCollaps', '  ', '  ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201032, '    ', 'DestExecDoc', '    ', '    ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201033, '   ', 'DestExecDocNum', '   ', '   ', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201034, '   ', 'DestExecDocReestr', '   ', '   ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201035, '  ', 'DestExecDocDate', '  ', '  ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201036, '  ', 'DestExecDocType', '  ', '  ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201037, '   ', 'DestExecDocSumma', '   ', '   ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201038, '  ', 'DestExecDocNote', '  ', '  ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201051, '  ', 'DestBudgetPromiseCollaps', '  ', 'DestBudgetPromiseCollaps', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201052, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201053, '  ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201054, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201055, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201056, '  ', 'DestBudgetPromiseDocReestrNum', '  ', 'DestBudgetPromiseDocReestrNum', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201057, '.  ', 'DestBudgetPromiseDocNote', '.  ', 'DestBudgetPromiseDocNote', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201058, ' .  ', 'DestBudgetPromiseSONum', ' .  ', 'DestBudgetPromiseSONum', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201059, ' .  ', 'DestBudgetPromiseSODate', ' .  ', 'DestBudgetPromiseSODate', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201060, ' .  ', 'DestBudgetPromiseSOSumma', ' .  ', 'DestBudgetPromiseSOSumma', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201061, '  .  ', 'DestBudgetPromiseSOReestrNum', '  .  ', 'DestBudgetPromiseSOReestrNum', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201062, '. .  ', 'DestBudgetPromiseSONote', '. .  ', 'DestBudgetPromiseSONote', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201063, ' ', 'Id', ' ', 'Id', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201064, '  ', 'FUID', '  ', 'FUID', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201065, '  ', ' ', '  ', 'SenderRecordID', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201066, '  ', ' ', '  ', 'SenderID', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201067, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201068, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201069, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201070, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 312, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201074, '', 'DestKVR', ' ', 'DestKVRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201075, '', 'DestKESR', '', 'DestKESRKey', 0, 312, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31201076, ' ()', 'DestKVSR', ' ', 'DestKVSRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201077, '', 'DestKCSR', ' ', 'DestKCSRKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201078, ' ', 'DestKFSR', ' ', 'DestKFSR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201079, '', 'DestSUBKESR', '', 'DestSUBKESRKey', 0, 312, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31201080, ' ', 'DestFACTCode', ' ', 'DestFACTCLS', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201081, ' ', 'DestMEANSTYPE', '  ', 'DestMEANSTYPECLS', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201082, '  ', 'DestFINSOURCE', '  ', 'DestFINSOURCECLS', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201083, ' .  ', 'DestFINTYPECode', '   ', 'DestFINTYPECLS', 0, 312, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201084, ' ', ' ', '  ', 'DestDOCTYPECLS', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201085, ' .  . . ()', 'DestIFS', '', 'DestIFS', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201089, '  ', 'SourceMEANSTYPE', '  ', 'SourceMEANSTYPECLS', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201093, ' ', ' ', ' ', 'StimateID', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201102, ' ()', 'DestKD', ' ', 'DestKD', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201103, '', 'DestDocBaseCode', '', 'DestDocBase', 0, 312, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201104, '', 'DestRegionCls', '', 'DestRegionCls', 0, 312, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201113, ' ', 'DestFundsSource', ' ', 'DestFundsSource', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201114, '', 'TreeOwner0', '()', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201117, '', 'BUDGETREF', '', 'BudgetRef', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201132, '  ', 'DestTransfertCls', '    ()', 'DestTransfertCls', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201133, '  ', 'DestTransfertClsCode', '   ', 'DestTransfertClsValue', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201134, '()', 'DestKCSRCode', '', 'DestKCSR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201135, '()', 'DESTKVRCode', '', 'DestKVR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201136, '', 'DestKVSRCode', '', 'DestKVSR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201137, ' .( .)', 'SourceKCSRCode', '', 'SourceKCSR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201138, ' .( .)', 'SourceKVRCode', '', 'SourceKVR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201139, ' .', 'SourceKVSRCode', ' .', 'SourceKVSR', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201146, ' .  . .', 'DestIFSCode', ' .  . .', 'DestIFS_DescriptionCode', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201147, '', 'DestKDCode', '', 'DestKDValue', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201148, ' ', 'DestBudgetPromiseSOID', '', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201149, ' .', 'SourceDirectionClsCode', ' .', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201150, ' .', 'SourceRegionCls', ' .', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201151, ' .  .', 'SourceDocBaseCode', ' .  .', 'SOURCEDOCBASE', 0, 312, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31201152, ' ', 'DestSubsidyCls', '  ()', 'DestSubsidyCls', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201153, ' ', 'DestSubsidyClsCode', ' ', 'DestSubsidyClsCode', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201154, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201155, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201156, '  ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201157, '   ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201158, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201160, '()', 'DestFact', ' ', 'DestFACTCLSKey', 0, 312, 1, 1, '', 0, 18899, 0, 0, '') ;

CALL ImportField(31201161, '()', 'SourceFact', ' ', 'SOURCEFACTCLSKey', 0, 312, 1, 1, '', 0, 18899, 0, 0, '') ;

CALL ImportField(31201162, ' .   ()', 'DestFINTYPE', '   ', 'DestFINTYPECLSKey', 0, 312, 1, 1, ',', 0, 18902, 0, 0, '') ;

CALL ImportField(31201163, ' .   ()', 'SourceFINTYPE', '  ', 'SOURCEFINTYPECLSKey', 0, 312, 1, 1, ',', 0, 18902, 0, 0, '') ;

CALL ImportField(31201164, '()', 'DestDirectionCLS', ' ', 'DestDirectionClsKey', 0, 312, 1, 1, '', 0, 18914, 0, 0, '') ;

CALL ImportField(31201165, '  ()', 'SourceDirectionCLS', '', 'SourceDirectionClsKey', 0, 312, 1, 1, '', 0, 18913, 0, 0, '') ;

CALL ImportField(31201166, ' ()', 'DestDocBase', '', 'DESTDOCBASEKEY', 0, 312, 1, 1, ',', 0, 18916, 0, 0, '') ;

CALL ImportField(31201167, '- ()', 'SourceDocBase', '- ', 'SOURCEDOCBASEKEY', 0, 312, 1, 1, ',', 0, 18916, 0, 0, '') ;

CALL ImportField(31201168, '', 'DestInvestObject', '', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201169, '', 'DestInvestObjectCode', '', ' ', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201170, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201171, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31201172, '()', 'CREATERUSER', '()', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201173, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201174, '  ()', 'CREATEDATE', '  ()', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201175, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31201177, '()', 'DestKESRCode', '()', 'DestKESR', 0, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31201179, '()', 'DestSUBKESRCode', '()', 'DestSUBKESR', 0, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31201180, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 0, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31201182, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSUBKESR', 0, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

--     , (1)
CALL ImportField(31211009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 312, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31211016, '', 'DestKVR', ' ', 'DestKVRKey', 1, 312, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31211017, '', 'DestKESR', '', 'DestKESRKey', 1, 312, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31211018, '', 'DestKVSR', ' ', 'DestKVSRKey', 1, 312, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31211019, '', 'DestKCSR', ' ', 'DestKCSRKey', 1, 312, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31211020, '()', 'DestKFSR', ' ', 'DestKFSR', 1, 312, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31211021, '', 'DestSUBKESR', '', 'DestSUBKESRKey', 1, 312, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31211034, ' ', 'SourceKVR', ' ', 'SourceKVRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211035, ' ', 'SourceKESR', ' ', 'SourceKESRKey', 1, 312, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31211036, ' ', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211037, ' ', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211038, ' ', 'SourceKFSR', ' ', 'SourceKFSR', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211039, ' ', 'SourceSUBKESR', ' ', 'SourceSUBKESRKey', 1, 312, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31211067, ' .  ', 'DestBudgetPromiseSONum', ' .  ', 'DestBudgetPromiseSONum', 1, 312, 1, 1, '', 0, 19798, 0, 0, '') ;

CALL ImportField(31211068, ' .  ', 'DestBudgetPromiseSODate', ' .  ', 'DestBudgetPromiseSODate', 1, 312, 1, 1, '', 0, 19799, 0, 0, '') ;

CALL ImportField(31211070, '  .  ', 'DestBudgetPromiseSORNum', '  .  ', 'DestBudgetPromiseSORNum', 1, 312, 1, 1, '', 0, 19830, 0, 0, '') ;

CALL ImportField(31211071, '. .  ', 'DestBudgetPromiseSONote', '. .  ', 'DestBudgetPromiseSONote', 1, 312, 1, 1, '', 0, 19821, 0, 0, '') ;

CALL ImportField(31211075, ' ()', 'DestIFS_DescriptionCode', '  ( )', ' ', 1, 312, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(31211112, '', 'BUDGETREF', '', 'BudgetRef', 1, 312, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(31211125, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 312, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31211127, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 312, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31211128, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 312, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31211132, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 312, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(31211133, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 312, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31211176, '()', 'DestKESRCode', '()', 'DestKESR', 1, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31211178, '()', 'DestSUBKESRCode', '()', 'DestSUBKESR', 1, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31211181, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31211183, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSUBKESR', 1, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

--     , +(2)
CALL ImportField(31211184, '    ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 312, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31211185, '    ()', 'SourcePayTargetFunds', '   ', ' ', 2, 312, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31211186, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31211187, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 312, 1, 1, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(31400001, ' ', 'BuhPaymentCls', ' ', 'BUHPAYMENTCLS', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400002, ' ', 'Note', ' ', 'NOTE', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400003, '/   ', 'DESTFACIALACC_CLS', '/   ', 'DestFacialAccCls', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400004, '  /  ()', 'DestAccount', '  /  ()', 'DESTACCOUNT', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400005, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400006, ' ', 'Reject_Cls', ' ', 'REJECTCLS', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400007, ' ', 'TypeOperationCls', ' ', 'OperationTypeCls', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400008, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400009, ' ', 'PAYPRIORITY', ' ', 'PayPriority', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400010, ' ', 'DocNumber', ' ', 'DocumentNumber', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400011, '', 'Summa', '', 'SUMMA', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400012, '/  ()', 'DestAccountName', '/  ()', 'DestAccountName', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400013, '/  ()', 'SourceAccountName', '/  ()', 'SourceAccountName', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400014, '  /  ()', 'SourceAccount', '  /  ()', 'SOURCEACCOUNT', 0, 314, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31400015, ' ', 'PAYDATE', ' ', 'PayDate', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400016, ' ', 'DocumentDate', ' ', 'DocumentDate', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400017, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400018, ' ', 'ID', ' ', 'ID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400019, '  ', 'FUID', '  ', 'FUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400020, '  ', ' ', '  ', 'SenderRecordID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400021, '  ', ' ', '  ', 'SenderID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400022, ' ', 'ReestrNumber', ' ', 'ReestrNumber', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400023, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400024, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400025, ' ', 'CARDNUMBER', ' ', 'CARDNUMBER', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400027, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400028, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400029, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400030, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400031, ' ', 'IsVised', ' ', 'IsVised', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400032, ' ', ' ', ' ', 'BidNumber', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400033, ' ', ' ', ' ', 'ManagerBid', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400034, '  ', ' ', '  ', 'LASTEXTRCHANGE', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400035, ' ', ' ', ' ', 'StimateID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400038, '  ', ' ', '  ', 'ManBidFuid', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400039, ' ', ' ', ' ', 'Reestr_Ref', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400040, ' ', ' ', ' ', 'CRYPTOSTATUS', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400041, '', ' ', '', 'DEPARTMENTCLS', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400042, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400043, '   ', 'SoftRejectCause', '   ', 'SoftRejectCause', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400044, '    ', ' ', '    ', 'DestAccountFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400045, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400046, ' ', ' ', ' ', 'DestFKFacialCode', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400047, '   ', ' ', '   ', 'DestOrgId', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400048, '    ', ' ', '    ', 'DestOrgFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400049, ' -', ' ', ' -', 'DestOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400050, ' -', ' ', ' -', 'DestOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400051, ' -', ' ', ' -', 'DestOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400052, ' -', ' ', ' -', 'DestOrgCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400053, ' ', ' ', ' ', 'DestBankFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400054, '  ', ' ', '  ', 'DestBankName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400055, '  ', ' ', '  ', 'DestBankBIK', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400056, '.  ', ' ', '.  ', 'DestBankCor', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400057, '   ', ' ', '   ', 'DestBankCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400058, '\ (  )', ' ', '\ ', 'DestFacialAccClsName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400059, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400060, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400061, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400062, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400063, '  ()', ' ', '  ()', 'DestFKOrgId', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400064, '   ', ' ', '   ', 'DestFKOrgFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400065, '   ', ' ', '   ', 'DestFKOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400066, '   ', ' ', '   ', 'DestFKOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400067, '  ', ' ', '  ', 'DestFKOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400068, '   ', ' ', '   ', 'DestFKOrgCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400069, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400070, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400071, ' ', ' ', ' ', 'SourceFKFacialCode', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400072, '   ', ' ', '   ', 'SourceOrgId', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400073, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400074, ' -', ' ', ' -', 'SourceOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400075, ' -', ' ', ' -', 'SourceOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400076, ' -', ' ', ' -', 'SourceOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400077, ' -', ' ', ' -', 'SourceOrgCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400078, ' ', ' ', ' ', 'SourceBankFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400079, '  ', ' ', '  ', 'SourceBankName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400080, '  ', ' ', '  ', 'SourceBankBIK', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400081, '.  ', ' ', '.  ', 'SourceBankCor', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400082, '   ', ' ', '   ', 'SourceBankCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400083, ' \ ', ' ', ' \ ', 'SourceFacialAccClsName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400084, ' \ ', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400085, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400086, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400087, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400088, '  ()', ' ', '  ()', 'SourceFKOrgId', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400089, '   ', ' ', '   ', 'SourceFKOrgFUID', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400090, '   ', ' ', '   ', 'SourceFKOrgINN', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400091, '   ', ' ', '   ', 'SourceFKOrgKPP', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400092, '  ', ' ', '  ', 'SourceFKOrgName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400093, '   ', ' ', '   ', 'SourceFKOrgCity', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400115, '   ', 'TaxNote', '   ', 'TaxNote', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400116, '', 'BUDGETREF', '', 'BudgetRef', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400129, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400138, ' ', 'DocStateName', ' ', 'DocStateName', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400140, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 314, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31400154, '', 'UINCode', '  ', 'UINCode', 0, 314, 0, 0, '', 0, 35367, 0, 0, '') ;

CALL ImportField(31400155, '()', 'CREATERUSER', '()', ' ', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400156, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400157, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31400158, '  ()', 'CREATEDATE', '  ()', ' ', 0, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401001, ' ', 'SourceMeansType', '  ', 'SourceMEANSTYPECLS', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401002, '', 'SourceDirectionClsCode', ' ', 'SourceDirectionCls', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401003, '  ', 'SourceFacialAcc_Cls', '  ', 'SourceFacialAccCls', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401004, '    ', 'SourceFacialCode', '    ', 'SourceFacialAccClsFacialCode', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401005, '', 'SourceKVR', ' ', 'SourceKVRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401006, '', 'SourceKESR', ' ', 'SourceKESRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401007, '', 'SourceKFSR', ' ', 'SourceKFSR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401008, '', 'SourceKCSR', ' ', 'SourceKCSRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401009, '', 'SourceKVSR', ' ', 'SourceKVSRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401010, '', 'SourceFactCode', ' ', 'SourceFACTCLS', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401011, ' . ', 'SourceFinTypeCode', '   ', 'SourceFINTYPECLS', 0, 314, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401012, ' ', 'SourceFinSource', '  ', 'SourceFINSOURCECLS', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401013, '   ', 'Summa', '   ', 'SUMMA', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401014, '   ', 'Note', '   ', 'NOTE', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401015, '  ', 'SourcePromise', '  ', 'SourcePROMISE', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401016, ' ', 'SourceSubKESR', ' ', 'SourceSUBKESRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401017, '     ', 'SourceBudgetPromise', '     ', '     ', 0, 314, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401018, '  ()', 'SourceBudgetPromiseNum', '  ()', '  ', 0, 314, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401019, '  ', 'SourceExecDocCollaps', '  ', '  ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401020, '    ', 'SourceExecDoc', '    ', '    ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401021, '   ', 'SourceExecDocNum', '   ', '   ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401022, '   ', 'SourceExecDocReestr', '   ', '   ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401023, '  ', 'SourceExecDocDate', '  ', '  ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401024, '  ', 'SourceExecDocType', '  ', '  ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401025, '   ', 'SourceExecDocSumma', '   ', '   ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401026, '  ', 'SourceExecDocNote', '  ', '  ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401037, '  ', 'SourceBudgetPromiseCollaps', '  ', 'SourceBudgetPromiseCollaps', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401038, ' ', 'SourceBudgetPromiseSumma', ' ', 'SourceBudgetPromiseSumma', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401039, ' ', 'SourceBudgetPromiseDocNumber', ' ', 'SourceBudgetPromiseDocNumber', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401040, ' ', 'SourceBudgetPromiseDocDate', ' ', 'SourceBudgetPromiseDocDate', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401041, ' ', 'SourceBudgetPromiseDocSumma', ' ', 'SourceBudgetPromiseDocSumma', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401042, '  .', 'SourceBudgetPromiseDocReestrNum', '  .', 'SourceBudgetPromiseDocReestrNum', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401043, '. ', 'SourceBudgetPromiseDocNote', '. ', 'SourceBudgetPromiseDocNote', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401044, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401045, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401046, ' . ', 'SourceBudgetPromiseSOSumma', ' . ', 'SourceBudgetPromiseSOSumma', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401047, '  . ', 'SourceBudgetPromiseSOReestrNum', '  . ', 'SourceBudgetPromiseSOReestrNum', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401048, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401061, ' ', 'Id', ' ', 'Id', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401062, '  ', 'FUID', '  ', 'FUID', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401063, '  ', ' ', '  ', 'SenderRecordID', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401064, '  ', ' ', '  ', 'SenderID', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401065, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401066, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401067, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401068, ' ', 'ClsType', ' (, , )', 'ClsType', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401074, ' ', 'DestKVR', ' ', 'DestKVRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401075, ' ', 'DestKESR', ' ', 'DestKESRKey', 0, 314, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31401076, ' ', 'DestKVSR', ' ', 'DestKVSRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401077, ' ', 'DestKCSR', ' ', 'DestKCSRKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401078, ' ', 'DestKFSR', ' ', 'DestKFSR', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401079, ' ', 'DestSUBKESR', ' ', 'DestSUBKESRKey', 0, 314, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31401080, ' ', 'DestFACTCode', ' ', 'DestFACTCLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401081, '  ', 'DestMEANSTYPE', '  ', 'DestMEANSTYPECLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401082, '  ', 'DestFINSOURCE', '  ', 'DestFINSOURCECLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401083, ' .  ', 'DestFINTYPECode', '   ', 'DestFINTYPECLS', 0, 314, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401084, '  ', ' ', '  ', 'DestDOCTYPECLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401085, '', 'DestDirectionCLSCode', '', 'DestDirectionCLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401090, '  ', ' ', '  ', 'SourceDOCTYPECLS', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401091, '', 'SourceIFS', '', 'SourceIFS', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401092, ' ', ' ', ' ', 'StimateID', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401102, ' ', 'SourceKD', ' ', 'SOURCEKD', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401103, '', 'SourceDocBaseCode', '', 'SourceDocBase', 0, 314, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401104, '', 'SourceRegionCls', '', 'SourceRegionCls', 0, 314, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401113, ' ', 'SourceFundsSource', ' ', 'SourceFundsSource', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401114, '', 'TreeOwner0', '()', ' ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401117, '', 'BUDGETREF', '', 'BudgetRef', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401130, '  ', 'SourceTransfertCls', '    ()', 'SourceTransfertCls', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401131, '  ', 'SourceTransfertClsCode', '   ', 'SourceTransfertClsValue', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401132, '()', 'SourceKCSRCode', '', 'SourceKCSR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401133, '()', 'SOURCEKVRCode', '', 'SourceKVR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401134, '()', 'SourceKVSRCode', '', 'SourceKVSR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401135, ' .( .)', 'DestKCSRCode', '', 'DestKCSR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401136, ' .( .)', 'DestKVRCode', '', 'DestKVR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401137, ' .( .)', 'DestKVSRCode', '', 'DestKVSR', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401141, ' ()', 'SourceIFSCode', ' ()', 'SourceIFS_DescriptionCode', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401142, ' ()', 'SourceKDCode', '', 'SourceKDValue', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401143, '', 'MemOrderNum', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401144, ' ', 'SourceBudgetPromiseSOID', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401145, '', 'DestDocBaseCode', '', ' ', 0, 314, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31401146, '', 'DestRegionCls', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401147, ' ', 'SourceSubsidyCls', '  ()', 'SourceSubsidyCls', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401148, ' ', 'SourceSubsidyClsCode', ' ', 'SourceSubsidyClsCode', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401149, ' ', 'SourceBudAllocationClsCode', '', ' ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401150, '  ', 'SourcePayPromiseClsCode', '', ' ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401151, '  ()', 'SourceBudAllocationCls', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401152, '   ()', 'SourcePayPromiseCls', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401153, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401155, ' ()', 'SourceFACT', ' ', 'SourceFACTCLSKey', 0, 314, 1, 1, '', 0, 18890, 0, 0, '') ;

CALL ImportField(31401156, ' ()', 'DestFACT', ' ', 'DestFACTCLSKey', 0, 314, 1, 1, '', 0, 18890, 0, 0, '') ;

CALL ImportField(31401157, ' . ', 'SourceFINTYPE', ' . ', 'SourceFINTYPECLSKey', 0, 314, 1, 1, ',', 0, 18893, 0, 0, '') ;

CALL ImportField(31401158, ' .   ()', 'DestFINTYPE', '   ', 'DestFINTYPECLSKey', 0, 314, 1, 1, ',', 0, 18893, 0, 0, '') ;

CALL ImportField(31401159, '  ()', 'DestDirectionCLS', ' ', 'DestDirectionCLSKey', 0, 314, 1, 1, '', 0, 18914, 0, 0, '') ;

CALL ImportField(31401160, ' ()', 'SourceDirectionCLS', ' ', 'SourceDirectionCLSKey', 0, 314, 1, 1, '', 0, 18913, 0, 0, '') ;

CALL ImportField(31401161, ' ()', 'SourceDocBase', '', 'SourceDocBaseKey', 0, 314, 1, 1, ',', 0, 18915, 0, 0, '') ;

CALL ImportField(31401162, '-', 'DestDocBase', '-', 'DestDocBaseKey', 0, 314, 1, 1, ',', 0, 18915, 0, 0, '') ;

CALL ImportField(31401163, '', 'SourceInvestObject', '', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401164, '', 'SourceInvestObjectCode', '', ' ', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401165, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 0, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31401166, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401167, '()', 'CREATERUSER', '()', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401168, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401169, '  ()', 'CREATEDATE', '  ()', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401170, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31401171, ' .( .)', 'DestKESRCode', ' .( .)', 'DestKESR', 0, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31401172, ' .( .)', 'DestSUBKESRCode', ' .( .)', 'DestSUBKESR', 0, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31401173, '()', 'SourceKESRCode', '()', 'SourceKESR', 0, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31401175, '()', 'SourceSubKESRCode', '()', 'SourceSUBKESR', 0, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

--    , (1)
CALL ImportField(31411009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 314, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31411016, ' ', 'DestKVR', ' ', 'DestKVRKey', 1, 314, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31411017, ' ', 'DestKESR', ' ', 'DestKESRKey', 1, 314, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31411018, ' ', 'DestKVSR', ' ', 'DestKVSRKey', 1, 314, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31411019, ' ', 'DestKCSR', ' ', 'DestKCSRKey', 1, 314, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31411020, ' ', 'DestKFSR', ' ', 'DestKFSR', 1, 314, 1, 1, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31411021, ' ', 'DestSUBKESR', ' ', 'DestSUBKESRKey', 1, 314, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31411034, '', 'SourceKVR', ' ', 'SourceKVRKey', 1, 314, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(31411035, '', 'SourceKESR', ' ', 'SourceKESRKey', 1, 314, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31411036, '', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 314, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(31411037, '', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 314, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(31411038, '()', 'SourceKFSR', ' ', 'SourceKFSR', 1, 314, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(31411039, '', 'SourceSUBKESR', ' ', 'SourceSUBKESRKey', 1, 314, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31411055, ' .  ', 'SourceBudgetPromiseSONum', ' .  ', 'SourceBudgetPromiseSONum', 1, 314, 1, 1, '', 0, 19798, 0, 0, '') ;

CALL ImportField(31411056, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 1, 314, 1, 1, '', 0, 19799, 0, 0, '') ;

CALL ImportField(31411058, '  .  ', 'SourceBudgetPromiseSORNum', '  .  ', ' ', 1, 314, 1, 1, '', 0, 19830, 0, 0, '') ;

CALL ImportField(31411059, '. .  ', 'SourceBudgetPromiseSONote', '. .  ', 'SourceBudgetPromiseSONote', 1, 314, 1, 1, '', 0, 19821, 0, 0, '') ;

CALL ImportField(31411075, ' ()', 'SourceIFS_DescriptionCode', ' ()', ' ', 1, 314, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(31411112, '', 'BUDGETREF', '', 'BudgetRef', 1, 314, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(31411125, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 314, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31411127, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 314, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31411128, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 314, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31411132, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 314, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31411134, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 314, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(31411174, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31411176, '()', 'SourceSubKESRCode', '()', 'SourceSUBKESR', 1, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31411177, ' .( .)', 'DestKESRCode', ' .( .)', 'DestKESR', 1, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31411178, ' .( .)', 'DestSUBKESRCode', ' .( .)', 'DestSUBKESR', 1, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

--    , +(2)
CALL ImportField(31411179, '    ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 314, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(31411180, '    ()', 'SourcePayTargetFunds', '   ', ' ', 2, 314, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(31411181, '    ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31411182, '    ()', 'DestPayTargetFunds', '   ', ' ', 2, 314, 1, 1, '', 0, null, 0, 0, '') ;

--      , (0)
CALL ImportField(31500079, '()', 'CREATERUSER', '()', ' ', 0, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31500080, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31500081, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31500082, '  ()', 'CREATEDATE', '  ()', ' ', 0, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31501001, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 315, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31501002, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31501003, '()', 'CREATERUSER', '()', ' ', 0, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31501004, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31501005, '  ()', 'CREATEDATE', '  ()', ' ', 0, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31501006, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 315, 1, 1, '', 0, null, 0, 0, '') ;

--      , (1)
CALL ImportField(31511016, '', 'DestKVSR', '', 'DestKVSRKey', 1, 315, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31511017, '()', 'DestKFSR', '', 'DestKFSR', 1, 315, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31511018, '', 'DestKCSR', '', 'DestKCSRKey', 1, 315, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31511019, '', 'DESTKVR', '', 'DestKVRKey', 1, 315, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31511020, '', 'DESTKESR', '', 'DestKESRKey', 1, 315, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31511031, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 315, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31511037, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 315, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31511068, ' ', 'DestIFS', ' ', 'DestIFS', 1, 315, 1, 1, '', 0, 18921, 0, 0, '') ;

CALL ImportField(31511083, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 315, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31511085, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 315, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31511086, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 315, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31511090, ' ', 'DestBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 315, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31511092, ' ', 'DestBudAllocationCls', '', ' ', 1, 315, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(31511107, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 315, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31511108, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 315, 1, 0, '', 0, 43610, 0, 0, '') ;

--      , +(2)
CALL ImportField(31511109, '   ', 'DestPayTargetFundsCode', '   ', 'DestPayTargetFunds', 2, 315, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31511110, '   ()', 'DestPayTargetFunds', '   ', ' ', 2, 315, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(31600001, '()', 'CREATERUSER', '()', ' ', 0, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31600002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31600003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31600004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31601001, '()', 'CREATERUSER', '()', ' ', 0, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31601002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31601003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31601004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 316, 1, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(32200001, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 322, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32200002, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 322, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32200005, '()', 'CREATERUSER', '()', ' ', 0, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32200006, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32200007, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32200008, '  ()', 'CREATEDATE', '  ()', ' ', 0, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201080, '  ', 'SourceTransfertCls', '   ()', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201081, '  ', 'SourceTransfertClsCode', '  ', ' ', 0, 322, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32201082, '', 'SourceInvestObject', '', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201083, '', 'SourceInvestObjectCode', '', ' ', 0, 322, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32201084, '', 'SourceContractCostsCls', '', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201085, '', 'SourceContractCostsClsCode', '', ' ', 0, 322, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32201087, ' ', 'SourceTargetCls', '  ()', 'SourceTargetClsKey', 0, 322, 1, 1, '', 0, 40642, 0, 0, '') ;

CALL ImportField(32201088, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 0, 322, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32201089, '()', 'CREATERUSER', '()', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201090, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201091, '  ()', 'CREATEDATE', '  ()', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32201092, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 322, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(32210020, ' ', 'BuhOperationCLS', ' ', ' ', 1, 322, 0, 0, '', 0, 19007, 0, 0, '') ;

CALL ImportField(32210082, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 322, 0, 0, '', 0, 45426, 0, 2, '') ;

CALL ImportField(32210104, '   (  )', 'CodePurpose', '   (  )', 'CodePurpose', 1, 322, 0, 0, '', 1, null, 32210082, 1, '') ;

CALL ImportField(32211023, '', 'SourceKVSR', '', ' ', 1, 322, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(32211024, '()', 'SourceKFSR', '', ' ', 1, 322, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(32211025, '', 'SourceKCSR', '', ' ', 1, 322, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(32211026, '', 'SOURCEKVR', '', ' ', 1, 322, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(32211027, '', 'SOURCEKESR', '', ' ', 1, 322, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(32211039, '', 'SourceSubKESR', '', ' ', 1, 322, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(32211047, ' ', 'BuhOperationCLS', ' ', ' ', 1, 322, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(32211077, '()', 'SourceKCSRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(32211078, '()', 'SOURCEKVRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(32211079, '()', 'SourceKVSRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(32211080, ' ', 'SourceBudAllocationClsCode', '', ' ', 1, 322, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(32211082, ' ', 'SourceBudAllocationCls', '', ' ', 1, 322, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(32211094, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 322, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32211102, '()', 'SOURCEKESRCode', '()', ' ', 1, 322, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(32211103, '()', 'SourceSubKESRCode', '()', ' ', 1, 322, 1, 0, '', 0, 43610, 0, 0, '') ;

--   , +(2)
CALL ImportField(32211105, '   ', 'SourcePayTargetFundsCode', '   ', 'SourcePayTargetFunds', 2, 322, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32211106, '   ()', 'SourcePayTargetFunds', '   ', ' ', 2, 322, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(32300069, ' .', 'DOCNUMBER', ' .', 'DocNumber', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300070, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300071, '', 'BUDGETREF', '', 'BudgetRef', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300072, '/ ', 'SourceAccountName', '/ ', ' ', 0, 323, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32300073, '()', 'SUMMA', '()', 'SUMMA', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300074, ' ', 'NOTE', ' ', 'NOTE', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300075, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300076, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300077, ' ', 'ClsType', ' ', 'CLSTYPE', 0, 323, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32300095, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300096, '/() ', 'SOURCEFACIALACC_CLS', '/() ', 'SourceFacialAccCls', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300116, ' ', 'CryptoStatus', '', 'CRYPTOSTATUS', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300117, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300120, '. ', 'BUHPAYMENTCLS', '. ', 'DestType', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300121, ' ', 'ID', ' ', 'ID', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300123, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300124, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300125, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300126, '. c', 'DESTACCOUNT', '. c', 'DESTACCOUNT', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300127, '', 'DocStateRef', '', 'DocStateRef', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300128, '. c()', 'SOURCEACCOUNT', '. c()', 'SOURCEACCOUNT', 0, 323, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32300135, ' ', 'PayDate', ' ', 'PayDate', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300150, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300151, ' ', 'DocStateName', ' ', 'DocStateName', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300154, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300157, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300158, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300159, '.  .', 'DestAccountName', '.  .', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300160, '/ . (.)', 'DestFacialAcc_Cls', '/ . .', 'DestFacialAccCls', 0, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32300161, '/  . (.)', 'DestFacialCode', '/c  . .', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300183, ' ', 'PaySymbolCls', '', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300184, ' ', 'PayTypeCls', '', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300186, '  ', 'FUID', '  ', 'FUID', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300188, '    ', 'DetAcceptDate', '', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300190, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300191, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300192, ' ', 'IsVised', ' ', 'IsVised', 0, 323, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32300193, '', 'ProgIndex', '', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300194, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 323, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32300195, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 323, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32300196, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 323, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32300197, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 0, 323, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32300198, '()', 'CREATERUSER', '()', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300199, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300200, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300201, '  ()', 'CREATEDATE', '  ()', ' ', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300202, ' ', ' ', ' ', 'SourceBankFUID', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300203, ' ', ' ', ' ', 'DestBankFUID', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300204, '  ', ' ', '  ', 'SourceBankBIK', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300205, '  ', ' ', '  ', 'DestBankBIK', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300206, '   ', ' ', '   ', 'SourceBankCity', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300207, '   ', ' ', '   ', 'DestBankCity', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300208, '.  ', ' ', '.  ', 'SourceBankCor', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300209, '.  ', ' ', '.  ', 'DestBankCor', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300210, '  ', ' ', '  ', 'SourceBankName', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300211, '  ', ' ', '  ', 'DestBankName', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300212, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32300213, ' ', ' ', ' ', 'DestBankDepartmentNumber', 0, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301079, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301080, '', 'TreeOwner0', '', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301081, '', 'DestKVSR', '', 'DestKVSRKey', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301082, '()', 'DestKFSR', '', 'DestKFSR', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301083, '', 'DestKCSR', '', 'DestKCSRKey', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301084, ' ', 'DESTKVR', ' ', 'DestKVRKey', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301085, '', 'DESTKESR', '', 'DestKESRKey', 0, 323, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(32301086, '()', 'DestFactCode', '', 'DestFACTCLS', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301087, '()', 'DestDirectionCLSCode', '', 'DestDirectionCLS', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301091, ' ', 'DestMeansType', ' ', 'DestMEANSTYPECLS', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301092, '()', 'SUMMA', '()', 'SUMMA', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301093, ' ', 'NOTE', ' ', 'NOTE', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301098, ' ', 'AcceptDate', ' ', 'ACCEPTDATE', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301099, '', 'DestSubKESR', '', 'DestSUBKESRKey', 0, 323, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(32301100, '', 'DestRegionCls', '', 'DESTREGIONCLS', 0, 323, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32301101, ' ', 'DestFinSource', ' ', 'DestFINSOURCECLS', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301102, ' . ', 'DestFinTypeCode', '  ', 'DestFINTYPECLS', 0, 323, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32301103, ' ', 'DestDocType', ' ', 'DestDOCTYPECLS', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301104, '', 'DestDocBaseCode', '', 'DESTDOCBASE', 0, 323, 1, 0, ',,', 0, null, 0, 1, '') ;

CALL ImportField(32301105, ' . ', 'MEMORDERNUM', ' . ', 'MemOrderNum', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301106, ' . -', 'DestPromise', ' . -', 'DestPROMISE', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301107, '  ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DESTBUDGETPROMISENUM', 0, 323, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32301108, '/   ', 'DestFacialCode', '/   ', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301109, ' . - ', 'DestBudgetPromiseCollaps', ' . - ', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301110, '.  ', 'DestExecDocCollaps', '.  ', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301111, '(.  )', 'DestExecDocNum', '', 'DestExecDocNum', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301129, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 0, 323, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32301130, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301131, ' ', 'DestIFS', ' ', 'DestIFS', 0, 323, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32301132, '', 'BUDGETREF', '', 'BudgetRef', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301133, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301134, ' ', 'ID', ' ', 'Id', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301145, '  ', 'DestTransfertCls', '   ()', 'DestTransfertCls', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301146, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301147, '()', 'DestKCSRCode', '', 'DestKCSR', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301148, ' ()', 'DESTKVRCode', '', 'DestKVR', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301149, '()', 'DestKVSRCode', '', 'DestKVSR', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301162, '', 'DestFacialAccName', '', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301163, ' ', 'DestGeneralOrg', ' ', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301164, ' .  . .', 'DestIFSCode', ' .  . .', 'DestIFS_DescriptionCode', 0, 323, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32301165, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301166, '  ', 'DestBudgetPromiseDocNote', '  ', 'DestBudgetPromiseDocNote', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301167, '  ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301168, '   ', 'DestBudgetPromiseDocReestrNum', '   ', 'DestBudgetPromiseDocReestrNum', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301169, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301170, ' . ', 'DestBudgetPromiseSODate', ' . ', 'DestBudgetPromiseSODate', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301171, ' ', 'DestBudgetPromiseSOID', '', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301172, '. . ', 'DestBudgetPromiseSONote', '. . ', 'DestBudgetPromiseSONote', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301173, ' . ', 'DestBudgetPromiseSONum', ' . ', 'DestBudgetPromiseSONum', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301174, '  . ', 'DestBudgetPromiseSOReestrNum', '  . ', 'DestBudgetPromiseSOReestrNum', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301175, ' . ', 'DestBudgetPromiseSOSumma', ' . ', 'DestBudgetPromiseSOSumma', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301176, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301177, '', 'DestExecDocDate', '', 'DestExecDocDate', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301178, '', 'DestExecDocNote', '', 'DestExecDocNote', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301179, ' ', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301180, ' .  ', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301181, '  ', 'DestExecDocType', '  ', 'DestExecDocType', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301182, '  .', 'DestAssignmentKind', '  .', 'DestAssignmentKind', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301187, '  ', 'FUID', '  ', 'FUID', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301194, ' ', 'PaySymbolCls', '', ' ', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301196, ' ', 'TargetCls', ' ', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301197, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301198, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301199, ' ', 'DestSubsidyCls', '', 'DestSubsidyCls', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301200, ' ', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301201, '  ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301202, '   ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301203, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301204, ' ()', 'DestFact', '', 'DestFACTCLSKey', 0, 323, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(32301205, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 0, 323, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(32301206, ' ()', 'DestDirectionCLS', '', 'DestDirectionCLSKey', 0, 323, 1, 1, '', 0, 18914, 0, 1, '') ;

CALL ImportField(32301207, ' ()', 'DestDocBase', '', 'DESTDOCBASEKEY', 0, 323, 1, 1, ',,', 0, 18916, 0, 1, '') ;

CALL ImportField(32301208, '', 'DestInvestObject', '', 'DestInvestObjectKey', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301209, '', 'DestInvestObjectCode', '', 'DestInvestObject', 0, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32301210, ' ()', 'TransfertOrg_Name', ' ()', ' ', 0, 323, 1, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(32301211, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 0, 323, 1, 1, '', 0, 38150, 0, 1, '') ;

CALL ImportField(32301212, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32301213, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32301214, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 0, 323, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32301215, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 0, 323, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(32301216, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 0, 323, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32301217, '()', 'CREATERUSER', '()', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301218, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301219, '  ()', 'CREATEDATE', '  ()', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301220, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32301222, '()', 'DESTKESRCode', '()', 'DestKESR', 0, 323, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(32301224, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 0, 323, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(32310008, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 1, 323, 0, 0, '', 0, 19007, 0, 1, '') ;

CALL ImportField(32310052, '. c()', 'SOURCEACCOUNT', '. c()', 'SOURCEACCOUNT', 1, 323, 0, 1, ',', 0, 18956, 0, 1, '') ;

CALL ImportField(32310144, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 323, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32310150, ' ', ' ', ' ', 'SourceBankFUID', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310151, ' ', ' ', ' ', 'DestBankFUID', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310152, '  ', ' ', '  ', 'SourceBankBIK', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310153, '  ', ' ', '  ', 'DestBankBIK', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310154, '   ', ' ', '   ', 'SourceBankCity', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310155, '   ', ' ', '   ', 'DestBankCity', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310156, '.  ', ' ', '.  ', 'SourceBankCor', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310157, '.  ', ' ', '.  ', 'DestBankCor', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310158, '  ', ' ', '  ', 'SourceBankName', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310159, '  ', ' ', '  ', 'DestBankName', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310160, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32310161, ' ', ' ', ' ', 'DestBankDepartmentNumber', 1, 323, 0, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(32311014, '', 'DestKVSR', '', 'DestKVSRKey', 1, 323, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(32311015, '()', 'DestKFSR', '', 'DestKFSR', 1, 323, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(32311016, '', 'DestKCSR', '', 'DestKCSRKey', 1, 323, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(32311017, ' ', 'DESTKVR', ' ', 'DestKVRKey', 1, 323, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(32311018, '', 'DESTKESR', '', 'DestKESRKey', 1, 323, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(32311031, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 323, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(32311056, '', 'BUDGETREF', '', 'BudgetRef', 1, 323, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(32311142, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 323, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(32311143, ' ()', 'DESTKVRCode', ' ()', 'DestKVR', 1, 323, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(32311144, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 323, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(32311147, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 323, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(32311151, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 323, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(32311157, '', 'DestInvestObject', '', 'DestInvestObjectKey', 1, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311158, '', 'DestInvestObjectCode', '', 'DestInvestObject', 1, 323, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32311167, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 323, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32311221, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 323, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(32311223, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 323, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (0)
CALL ImportField(32400088, ' .', 'DOCNUMBER', ' .', 'DocNumber', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400089, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400090, '', 'BUDGETREF', '', 'BudgetRef', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400091, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SOURCEFACIALACCCLS', 0, 324, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32400092, '/ ', 'SourceAccountName', '/ ', ' ', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400093, '()', 'SUMMA', '()', 'SUMMA', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400094, ' ', 'NOTE', ' ', 'NOTE', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400095, ' ', 'ACCEPTDATE', ' ', 'ACCEPTDATE', 0, 324, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32400096, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400097, ' ', 'ClsType', ' ', 'CLSTYPE', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400118, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400131, '/   ', 'SourceFACIALCODE', '/   ', ' ', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400152, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400154, '. ', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400155, ' ', 'ID', ' ', 'ID', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400157, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400158, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 0, 324, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32400159, '  ()', 'REJECTCAUSE', '  ()', 'REJECTCAUSE', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400160, '', 'DocStateRef', '', 'DocStateRef', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400161, '. c ()', 'SOURCEACCOUNT', '. c ()', 'SOURCEACCOUNT', 0, 324, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32400162, '. c', 'DESTACCOUNT', '. c', 'DESTACCOUNT', 0, 324, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32400163, ' ', 'PayDate', ' ', 'PayDate', 0, 324, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32400191, ' ', 'TypeOperationCls', ' ', 'TypeOperationCls', 0, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32400192, '/  .', 'DestFacialAcc_Cls', '/  .', 'DestFacialAccCls', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400193, '/  .', 'DestFacialCode', '/  .', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400215, '  ', 'FUID', '  ', 'FUID', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400217, '    ', 'DetAcceptDate', '', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400218, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400219, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400220, ' ', 'IsVised', ' ', 'IsVised', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400239, ' ', 'DocStateName', ' ', 'DocStateName', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400240, '.  .', 'DestAccountName', '.  .', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400242, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400243, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400244, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 324, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32400245, '', 'ProgIndex', '', 'ProgIndex', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400246, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 0, 324, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32400247, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 0, 324, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32400248, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 0, 324, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32400249, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 0, 324, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32400250, '()', 'CREATERUSER', '()', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400251, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400252, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32400253, '  ()', 'CREATEDATE', '  ()', ' ', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401099, '', 'TreeOwner0', '', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401111, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 0, 324, 1, 0, ',DestFacialACCCLS', 0, null, 0, 0, '') ;

CALL ImportField(32401112, '()', 'SUMMA', '()', 'SUMMA', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401113, ' ', 'NOTE', ' ', 'NOTE', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401115, '  ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DESTBUDGETPROMISENUM', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401116, '', 'DestDocBaseCode', '', 'DestDocBaseCode', 0, 324, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(32401120, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32401127, ' -', 'DestRegionCls', ' -', 'DESTREGIONCLS', 0, 324, 1, 0, 'DestRegionCls,,', 0, null, 0, 0, '') ;

CALL ImportField(32401128, ' . ', 'MEMORDERNUM', ' . ', 'MemOrderNum', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401130, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401132, '/   ', 'destfacialcode', '/   ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401133, ' . - ', 'SourceBudgetPromiseCollaps', ' . - ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401134, ' . - ', 'DestBudgetPromiseCollaps', ' . - ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401135, '.  ', 'SourceExecDocCollaps', '.  ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401136, '(.  )', 'SourceExecDocNum', '   ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401137, '.  ', 'DestExecDocCollaps', '.  ', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401138, '(.  )', 'DestExecDocNum', '   ', 'DestExecDocNum', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401139, ' -', 'DestFactCode', ' -', 'DestFactCode', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401141, ' - -', 'DestFinSource', ' - -', 'DestFINSOURCE', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401142, ' . ', 'DestFinTypeCode', '   -', 'DestFinTypeCode', 0, 324, 1, 0, ',,', 0, null, 0, 0, '') ;

CALL ImportField(32401143, '', 'DestKCSR', ' -', 'DestKCSRKey', 0, 324, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32401144, '', 'DESTKESR', '', 'DestKESRKey', 0, 324, 1, 1, ',', 0, 18871, 0, 1, '') ;

CALL ImportField(32401145, ' -', 'DestKFSR', ' -', 'DestKFSR', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401146, '', 'DESTKVR', ' -', 'DestKVRKey', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401147, '', 'DestKVSR', ' -', 'DestKVSRKey', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401148, '  -', 'DestMeansType', '  -', 'DestMEANSTYPE', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401149, '', 'DestSubKESR', '', 'DestSUBKESRKey', 0, 324, 1, 1, ',', 0, 18898, 0, 1, '') ;

CALL ImportField(32401150, '  -', 'DestDocType', '  -', 'DestDocType', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401151, ' -', 'DestDirectionCLSCode', ' -', 'DestDirectionCLSCode', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401164, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 0, 324, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401165, ' ..  ', 'SourceExecDoc', ' ..  ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401166, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401168, '', 'BUDGETREF', '', 'BudgetRef', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401169, ' ', 'RECORDINDEX', ' ', 'RECORDINDEX', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401170, ' ', 'ID', ' ', 'ID', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401186, '  ', 'DestTransfertCls', '    ()', 'DestTransfertCls', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401187, '  ', 'DestTransfertClsCode', '   ', 'DestTransfertClsValue', 0, 324, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32401188, '()', 'DestKCSRCode', '', 'DestKCSR', 0, 324, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32401189, '()', 'DESTKVRCode', '', 'DestKVR', 0, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32401190, '()', 'DestKVSRCode', '', 'DestKVSR', 0, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32401194, '', 'DestFacialAccName', '', ' ', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401195, ' ', 'DestGeneralOrg', ' ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401196, ' .  . .', 'DestIFSCode', ' .  . .', 'DestIFS_DescriptionCode', 0, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32401197, '  ', 'DestBudgetPromiseDocDate', '  ', 'DestBudgetPromiseDocDate', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401198, '  ', 'DestBudgetPromiseDocNote', '  ', 'DestBudgetPromiseDocNote', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401199, '  ', 'DestBudgetPromiseDocNumber', '  ', 'DestBudgetPromiseDocNumber', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401200, '   ', 'DestBudgetPromiseDocReestrNum', '   ', 'DestBudgetPromiseDocReestrNum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401201, '  ', 'DestBudgetPromiseDocSumma', '  ', 'DestBudgetPromiseDocSumma', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401202, ' . ', 'DestBudgetPromiseSODate', ' . ', 'DestBudgetPromiseSODate', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401203, ' ', 'DestBudgetPromiseSOID', '', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401204, '. . ', 'DestBudgetPromiseSONote', '. . ', 'DestBudgetPromiseSONote', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401205, ' . ', 'DestBudgetPromiseSONum', ' . ', 'DestBudgetPromiseSONum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401206, '  . ', 'DestBudgetPromiseSOReestrNum', '  . ', 'DestBudgetPromiseSOReestrNum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401207, ' . ', 'DestBudgetPromiseSOSumma', ' . ', 'DestBudgetPromiseSOSumma', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401208, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401209, '', 'DestExecDocDate', '', 'DestExecDocDate', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401210, '', 'DestExecDocNote', '', 'DestExecDocNote', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401211, ' ', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401212, ' .  ', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401213, '  ', 'DestExecDocType', '  ', 'DestExecDocType', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401214, '  .', 'DestAssignmentKind', '  .', 'DestAssignmentKind', 0, 324, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(32401216, '  ', 'FUID', '  ', 'FUID', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401221, '  ', 'SourceExecDocDate', '  ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401222, '  ', 'SourceExecDocNote', '  ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401223, '   ', 'SourceExecDocReestr', '   ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401224, '   ', 'SourceExecDocSumma', '   ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401225, '  ', 'SourceExecDocType', '  ', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401226, ' ', 'SourceBudgetPromiseDocDate', ' ', 'SourceBudgetPromiseDocDate', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401227, '. ', 'SourceBudgetPromiseDocNote', '. ', 'SourceBudgetPromiseDocNote', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401228, ' ', 'SourceBudgetPromiseDocNumber', ' ', 'SourceBudgetPromiseDocNumber', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401229, '  .', 'SourceBudgetPromiseDocReestrNum', '  .', 'SourceBudgetPromiseDocReestrNum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401230, ' ', 'SourceBudgetPromiseDocSumma', ' ', 'SourceBudgetPromiseDocSumma', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401231, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseSODate', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401232, ' ', 'SourceBudgetPromiseSOID', '', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401233, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseSONote', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401234, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseSONum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401235, '  . ', 'SourceBudgetPromiseSOReestrNum', '  . ', 'SourceBudgetPromiseSOReestrNum', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401236, ' . ', 'SourceBudgetPromiseSOSumma', ' . ', 'SourceBudgetPromiseSOSumma', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401237, ' ', 'SourceBudgetPromiseSumma', ' ', 'SourceBudgetPromiseSumma', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401238, ' ', 'DestTargetClsCode', ' ', 'DestTARGETCLS', 0, 324, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32401241, ' .  . . ()', 'DestIFS', ' .  . . ()', 'DestIFS', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401242, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401243, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401244, ' ', 'DestSubsidyCls', '', 'DestSubsidyCls', 0, 324, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401245, ' ', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 0, 324, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401246, '  ()', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 0, 324, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401247, '   ()', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 0, 324, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(32401248, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401249, ' ()', 'DestFact', ' -', 'DestFACTCLSKey', 0, 324, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(32401250, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 0, 324, 1, 1, ',,,', 0, 18902, 0, 1, '') ;

CALL ImportField(32401251, ' ()', 'DestDirectionCls', ' ', 'DestDirectionClsKey', 0, 324, 1, 1, ',', 0, 18914, 0, 0, '') ;

CALL ImportField(32401252, ' ()', 'DestDocBase', '', 'DESTDOCBASEKey', 0, 324, 1, 1, ',,', 0, 18916, 0, 0, '') ;

CALL ImportField(32401253, '', 'DestInvestObject', '', 'DestInvestObjectKey', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401254, '', 'DestInvestObjectCode', '', 'DestInvestObject', 0, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32401255, ' ()', 'TransfertOrg_Name', ' ()', ' ', 0, 324, 1, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(32401256, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 0, 324, 1, 1, '', 0, 38150, 0, 1, '') ;

CALL ImportField(32401257, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 0, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32401258, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 0, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32401259, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 0, 324, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32401260, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 0, 324, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(32401262, '()', 'CREATERUSER', '()', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401263, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401264, '  ()', 'CREATEDATE', '  ()', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401265, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32401267, '()', 'DESTKESRCode', '()', 'DestKESR', 0, 324, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(32401269, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 0, 324, 1, 0, ',', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(32410010, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 1, 324, 0, 0, '', 0, 19007, 0, 1, '') ;

CALL ImportField(32410181, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 324, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32411066, '', 'BUDGETREF', '', 'BudgetRef', 1, 324, 1, 1, '', 0, 18872, 0, 0, '') ;

CALL ImportField(32411075, '', 'DestKCSR', ' -', 'DestKCSRKey', 1, 324, 1, 1, ',', 0, 18896, 0, 1, '') ;

CALL ImportField(32411076, '', 'DESTKESR', '', 'DestKESRKey', 1, 324, 1, 1, ',', 0, 18871, 0, 1, '') ;

CALL ImportField(32411077, '()', 'DestKFSR', ' -', 'DestKFSR', 1, 324, 1, 0, ',', 0, 18897, 0, 1, '') ;

CALL ImportField(32411078, '', 'DESTKVR', ' -', 'DestKVRKey', 1, 324, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(32411079, '', 'DestKVSR', ' -', 'DestKVSRKey', 1, 324, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(32411081, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 324, 1, 1, ',', 0, 18898, 0, 1, '') ;

CALL ImportField(32411182, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 324, 1, 0, ',', 0, 25462, 0, 1, '') ;

CALL ImportField(32411183, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 324, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(32411184, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 324, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(32411188, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 324, 1, 0, ',', 0, 27825, 0, 1, '') ;

CALL ImportField(32411192, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 324, 1, 1, ',', 0, 27842, 0, 1, '') ;

CALL ImportField(32411196, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 1, 324, 1, 1, ',,', 0, 18902, 0, 1, '') ;

CALL ImportField(32411198, '', 'DestInvestObject', '', 'DestInvestObjectKey', 1, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411199, '', 'DestInvestObjectCode', '', 'DestInvestObject', 1, 324, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32411207, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 324, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32411266, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 324, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(32411268, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 324, 1, 0, ',', 0, 43610, 0, 1, '') ;

--    , (0)
CALL ImportField(32500003, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 0, 325, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32500005, ' / ', 'SourceFacialCodeEx', ' / ', ' ', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500007, '/   ', 'SourceFACIALCODE', '/   ', ' ', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500009, ' ', 'ACCEPTDATE', ' ', 'ACCEPTDATE', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500011, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500013, ' ', 'DOCNUMBER', ' ', 'DOCNUMBER', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500015, ' ', 'DOCUMENTDATE', ' ', 'DOCUMENTDATE', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500017, ' ', 'REESTRNUMBER', ' ', 'REESTRNUMBER', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500019, ' ', 'ClsType', ' ', 'ClsType', 0, 325, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32500021, '/ ', 'SourceAccountName', '/ ', ' ', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500023, '', 'BUDGETREF', '', 'BUDGETREF', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500025, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500028, '. ()', 'DESTFACIALACC_CLS', '. ()', 'DESTFACIALACC_CLS', 0, 325, 0, 0, ',DestFacialACCCLS', 0, null, 0, 0, '') ;

CALL ImportField(32500030, '', 'DepartmentCls', '', ' ', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500032, ' ', 'BidNumber', ' ', 'BidNumber', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500035, ' ', 'AutoSanctionCode', ' ', ' ', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500049, '()', 'Summa', '', 'Summa', 0, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32500096, ' ', 'DocStateName', ' ', 'DocStateName', 0, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32500098, ' ()', 'DocStateRef', ' ()', 'DocStateRef', 0, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32501037, '  ', 'SOURCEPROMISE', '  ', 'SOURCEPROMISE', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501039, '  ()', 'SourceBudgetPROMISENum', '  ()', 'SourceBudgetPROMISENum', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501041, ' ', 'SourceBudgetPromiseAgrDate', ' ', 'SourceBudgetPromiseAgrDate', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501043, '    ', 'SourceExecDoc', '  . ', 'SourceExecDoc', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501045, ' (.  )', 'SourceExecDocMPNum', ' (.  )', 'SourceExecDocMPNum', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501047, '   ', 'SourceExecDocNum', '   ', 'SourceExecDocNum', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501053, ' ', 'SourceKVSRCode', ' ', 'SourceKVSR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501055, '', 'SourceKFSR', '', 'SourceKFSR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501057, '', 'SourceKCSRCode', '', 'SourceKCSR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501059, '', 'SOURCEKVRCode', '', 'SourceKVR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501061, '()', 'SourceIFS_KVSRCode', '()', ' ', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501063, ' ()', 'SourceIFS_DescriptionCode', ' ()', ' ', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501065, '()', 'SourceIFSAGCode', '()', ' ', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501067, '()', 'SOURCEKESRCode', '()', 'SourceKESR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501069, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501071, ' ', 'SourceMeansType', ' ', 'SourceMeansType', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501073, '', 'SourceFactCode', '', 'SourceFactCode', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501075, '', 'SourceDirectionCLSCode', '', 'SourceDirectionCLS', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501077, ' ', 'ClsType', ' ', 'ClsType', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501079, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501081, '  ', 'SourceTransfertClsCode', '  ', 'SourceTransfertClsValue', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501083, ' ', 'SourceFinSource', ' ', 'SOURCEFINSOURCECLS', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501085, ' . ', 'SOURCEFINTYPECODE', ' . ', 'SOURCEFINTYPECLS', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501087, ' ', 'SourceDocType', ' ', 'SOURCEDOCTYPECLS', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501089, '', 'SourceDocBaseCode', '', 'SourceDocBase', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32501091, '', 'SourceContractCostsCLSCode', '', 'SourceContractCostsCLS', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501093, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501099, '  ', 'SourcePayPromiseClsCode', '  ', 'SourcePayPromiseClsCode', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501101, ' ', 'SourceBudAllocationClsCode', ' ', 'SourceBudAllocationClsCode', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501103, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501105, '  ', 'BuhAccounts', '', ' ', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501107, '  ', 'CardNumber', '  ', 'CARDNUMBER', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501109, '   ', 'DateBirth', '   ', 'DATEBIRTH', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501111, '  ', 'PaymentCodeTypeCode', '  ', 'PaymentCodeType', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501113, '  ', 'CODEPURPOSE', '  ', 'CODEPURPOSE', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501115, '', 'Summa', '', 'Summa', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501117, '  ', 'LineNumber', '  ', 'LINENUMBER', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501119, ',    ', 'AmountIspDoc', ',    ', 'AMOUNTISPDOC', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501121, '', 'NOTE', '', 'NOTE', 0, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32501135, '()', 'SourceIFS', '        ', 'SourceIFS', 0, 325, 1, 0, ',', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(32510002, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 1, 325, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32510004, ' / ', 'SourceFacialCodeEx', ' / ', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510006, '/   ', 'SourceFACIALCODE', '/   ', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510008, ' ', 'ACCEPTDATE', ' ', 'ACCEPTDATE', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510010, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510012, ' ', 'DOCNUMBER', ' ', 'DOCNUMBER', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510014, ' ', 'DOCUMENTDATE', ' ', 'DOCUMENTDATE', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510016, ' ', 'REESTRNUMBER', ' ', 'REESTRNUMBER', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510018, ' ', 'ClsType', ' ', 'ClsType', 1, 325, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32510020, '/ ', 'SourceAccountName', '/ ', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510022, '', 'BUDGETREF', '', 'BUDGETREF', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510024, ' ', 'OperationDirection', ' ', 'OperationDirection', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510026, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510027, '. ()', 'DESTFACIALACC_CLS', '. ()', 'DESTFACIALACC_CLS', 1, 325, 0, 0, ',DestFacialACCCLS', 0, null, 0, 0, '') ;

CALL ImportField(32510029, '', 'DepartmentCls', '', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510031, ' ', 'BidNumber', ' ', 'BidNumber', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510033, '  ', 'SENDERID', '  ', 'SENDERID', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510034, ' ', 'AutoSanctionCode', ' ', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510048, '()', 'Summa', '', 'Summa', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510050, '  ', 'ParentElBank', '', ' ', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510051, '(  )', 'Status', '', 'Status', 1, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510095, ' ', 'DocStateName', ' ', 'DocStateName', 1, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32510097, ' ()', 'DocStateRef', ' ()', 'DocStateRef', 1, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32511036, '  ', 'SOURCEPROMISE', '  ', 'SOURCEPROMISE', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511038, '  ()', 'SourceBudgetPROMISENum', '  ()', 'SourceBudgetPROMISENum', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511040, ' ', 'SourceBudgetPromiseAgrDate', ' ', 'SourceBudgetPromiseAgrDate', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511042, '    ', 'SourceExecDoc', '  . ', 'SourceExecDoc', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511044, ' (.  )', 'SourceExecDocMPNum', ' (.  )', 'SourceExecDocMPNum', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511046, '   ', 'SourceExecDocNum', '   ', 'SourceExecDocNum', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511052, ' ', 'SourceKVSRCode', ' ', 'SourceKVSR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511054, '', 'SourceKFSR', '', 'SourceKFSR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511056, '', 'SourceKCSRCode', '', 'SourceKCSR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511058, '', 'SOURCEKVRCode', '', 'SourceKVR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511060, '()', 'SourceIFS_KVSRCode', '()', ' ', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511062, ' ()', 'SourceIFS_DescriptionCode', ' ()', ' ', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511064, '()', 'SourceIFSAGCode', '()', ' ', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511066, '()', 'SOURCEKESRCode', '()', 'SourceKESR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511068, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511070, ' ', 'SourceMeansType', ' ', 'SourceMeansType', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511072, '', 'SourceFactCode', '', 'SourceFactCode', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511074, '', 'SourceDirectionCLSCode', '', 'SourceDirectionCLS', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511076, ' ', 'ClsType', ' ', 'ClsType', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511078, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511080, '  ', 'SourceTransfertClsCode', '  ', 'SourceTransfertClsValue', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511082, ' ', 'SourceFinSource', ' ', 'SOURCEFINSOURCECLS', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511084, ' . ', 'SOURCEFINTYPECODE', ' . ', 'SOURCEFINTYPECLS', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511086, ' ', 'SourceDocType', ' ', 'SOURCEDOCTYPECLS', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511088, '', 'SourceDocBaseCode', '', 'SourceDocBase', 1, 325, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32511090, '', 'SourceContractCostsCLSCode', '', 'SourceContractCostsCLS', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511092, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511094, '  ', 'SourcePayPromiseClsCode', '  ', 'SourcePayPromiseClsCode', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511100, ' ', 'SourceBudAllocationClsCode', ' ', 'SourceBudAllocationClsCode', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511102, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511104, '  ', 'BuhAccounts', '', ' ', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511106, '  ', 'CardNumber', '  ', 'CARDNUMBER', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511108, '   ', 'DateBirth', '   ', 'DATEBIRTH', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511110, '  ', 'PaymentCodeTypeCode', '  ', 'PaymentCodeType', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511112, '  ', 'CODEPURPOSE', '  ', 'CODEPURPOSE', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511114, '', 'Summa', '', 'Summa', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511116, '  ', 'LineNumber', '  ', 'LINENUMBER', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511118, ',    ', 'AmountIspDoc', ',    ', 'AMOUNTISPDOC', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511120, '', 'NOTE', '', 'NOTE', 1, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511135, ' ', 'SourceIFS', ' ', 'SourceIFS', 1, 325, 1, 1, ',', 0, 18920, 0, 0, '') ;

--    , +(2)
CALL ImportField(32510122, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 2, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510123, '  ()', 'REJECTCAUSE', '  ()', 'REJECTCAUSE', 2, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510133, ' ', 'Reestr_Ref', ' ', 'Reestr_Ref', 2, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32510135, '  ', 'SourceAccount', '  ', 'SourceAccount', 2, 325, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(32510136, ' ', 'ID', ' ', 'Id', 2, 325, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32510137, ' ()', 'AutoSanction', '  ', 'AutoSanction', 2, 325, 0, 1, '', 0, 39225, 0, 0, '') ;

CALL ImportField(32510143, '(  )', 'SourceStoredPaymentProps', '(  )', 'SourceStoredPaymentProps', 2, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510144, '(  )', 'DestStoredPaymentProps', '(  )', 'DestStoredPaymentProps', 2, 325, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32510145, '', 'Signers', '', ' ', 2, 325, 0, 0, '', 0, 38174, 0, 2, '') ;

CALL ImportField(32510146, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 2, 325, 0, 1, '', 0, 45426, 0, 2, '') ;

CALL ImportField(32511124, '', 'SourceKVR', '', 'SourceKVRKey', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511125, '', 'SourceKESR', '', 'SourceKESRKey', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511126, '  ()', 'SOURCEKVSR', '', 'SOURCEKVSRKey', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511127, ' ()', 'SOURCEKCSR', '', 'SOURCEKCSRKey', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511128, '', 'SourceSubKESR', '', 'SourceSubKESRKey', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511129, ' ()', 'SourceTransfertCls', '', 'SourceTransfertCls', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511130, '  ()', 'SourceSubsidyCls', '', 'SourceSubsidyCls', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511131, '   ()', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511132, '   ()', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511134, '   ()', 'PaymentCodeType', '', 'PaymentCodeTypeKey', 2, 325, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32511138, '  ', 'SourceRegProjectResultCode', '  ', 'SourceRegProjectResultCode', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511139, '  ()', 'SourceRegProjectResult', '  ', 'SourceRegProjectResultKey', 2, 325, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32511140, '   ', 'ACCEPTDATE', '   ', 'ACCEPTDATE_DET', 2, 325, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32511141, '   ', 'REJECT_CLS', '   ', 'REJECT_CLS_DET', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32511142, '  ()  ', 'REJECTCAUSE', '  ()  ', 'REJECTCAUSE_DET', 2, 325, 1, 0, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(40111056, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 1, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40113084, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 3, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40114100, '()', 'KVSR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114101, '()', 'KFSR', '', ' ', 1, 401, 4, 0, '', 0, 18148, 0, 0, '') ;

CALL ImportField(40114102, '()', 'KCSR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114103, '()', 'KVR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114104, '()', 'KESR', '', ' ', 1, 401, 4, 0, '', 0, 18151, 0, 0, '') ;

CALL ImportField(40114106, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 4, 0, '', 0, 18142, 0, 0, '') ;

CALL ImportField(40114235, '()', 'KCSRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40114236, '()', 'KVRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40114237, '()', 'KVSRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40114256, '()', 'KESRCode', '()', ' ', 1, 401, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40116121, '', 'KVSR', '', ' ', 1, 401, 6, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(40116122, '()', 'KFSR', '', ' ', 1, 401, 6, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(40116123, '', 'KCSR', '', ' ', 1, 401, 6, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(40116124, '', 'KVR', '', ' ', 1, 401, 6, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(40116125, '', 'KESR', '', ' ', 1, 401, 6, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(40116139, '', 'SUBKESR', '', ' ', 1, 401, 6, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(40116143, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 6, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(40116241, '()', 'KCSRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40116242, '()', 'KVRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40116243, '()', 'KVSRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40116257, '()', 'KESRCode', '()', ' ', 1, 401, 6, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40116259, '()', 'SUBKESRCode', '()', ' ', 1, 401, 6, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(40118167, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 8, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40110192, '', 'KVSR', '', ' ', 1, 401, 10, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(40110193, '()', 'KFSR', '', ' ', 1, 401, 10, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(40110194, '', 'KCSR', '', ' ', 1, 401, 10, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(40110195, '', 'KVR', '', ' ', 1, 401, 10, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(40110196, '', 'KESR', '', ' ', 1, 401, 10, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(40110202, '', 'SUBKESR', '', ' ', 1, 401, 10, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(40110209, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 10, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(40110246, '()', 'KCSRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40110247, '()', 'KVRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40110248, '()', 'KVSRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40110258, '()', 'KESRCode', '()', ' ', 1, 401, 10, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40110260, '()', 'SUBKESRCode', '()', ' ', 1, 401, 10, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(50111038, '', 'KVSR', '', ' ', 1, 501, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(50111039, '()', 'KFSR', '', ' ', 1, 501, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(50111040, '', 'KCSR', '', ' ', 1, 501, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(50111041, '', 'KVR', '', ' ', 1, 501, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(50111042, '', 'KESR', '', ' ', 1, 501, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(50111045, '', 'SUBKESR', '', ' ', 1, 501, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(50111062, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(50111181, '()', 'KCSRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(50111182, '()', 'KVRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(50111183, '()', 'KVSRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50111191, '()', 'KESRCODE', '()', ' ', 1, 501, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50111195, '()', 'SUBKESRCode', '()', ' ', 1, 501, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(50113074, '', 'KVSR', '', ' ', 1, 501, 3, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(50113075, '()', 'KFSR', '', ' ', 1, 501, 3, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(50113076, '', 'KCSR', '', ' ', 1, 501, 3, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(50113077, '', 'KVR', '', ' ', 1, 501, 3, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(50113078, '', 'KESR', '', ' ', 1, 501, 3, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(50113081, '', 'SUBKESR', '', ' ', 1, 501, 3, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(50113096, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 3, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(50113185, '()', 'KCSRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(50113186, '()', 'KVRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(50113187, '()', 'KVSRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50113192, '()', 'KESRCODE', '()', ' ', 1, 501, 3, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50113196, '()', 'SUBKESRCode', '()', ' ', 1, 501, 3, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(50114104, '( )', 'KVSR', '', ' ', 1, 501, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(50114114, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 4, 0, '', 0, 18142, 0, 0, '') ;

CALL ImportField(50114170, '( )', 'KVSRCode', '( )', ' ', 1, 501, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50114193, '( )', 'KESRCODE', '( )', ' ', 1, 501, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50116125, '( )', 'KVSR', '', ' ', 1, 501, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(50116139, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 6, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(50116175, '( )', 'KVSRCode', '( )', ' ', 1, 501, 6, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50116194, '( )', 'KESRCODE', '( )', ' ', 1, 501, 6, 0, '', 0, 43607, 0, 0, '') ;

--   , (1)
CALL ImportField(70111007, '', 'KVSR', '', ' ', 1, 701, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(70111008, '()', 'KFSR', '', ' ', 1, 701, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(70111009, '', 'KCSR', '', ' ', 1, 701, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(70111010, '', 'KVR', '', ' ', 1, 701, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(70111011, '', 'KESR', '', ' ', 1, 701, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(70111018, '', 'SUBKESR', '', ' ', 1, 701, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(70111044, ' ', 'BuhOperationCLS', ' ', ' ', 1, 701, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(70111066, '()', 'KCSRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(70111067, '()', 'KVRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(70111068, '()', 'KVSRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(70111074, '()', 'KESRCode', '()', ' ', 1, 701, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(70111075, '()', 'SUBKESRCode', '()', ' ', 1, 701, 1, 0, '()', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(70310004, '', 'KVSR', '', ' ', 1, 703, 0, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(70310005, '()', 'KFSR', '', ' ', 1, 703, 0, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(70310006, '', 'KCSR', '', ' ', 1, 703, 0, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(70310007, '', 'KVR', '', ' ', 1, 703, 0, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(70310008, '', 'KESR', '', ' ', 1, 703, 0, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(70310015, '', 'SUBKESR', '', ' ', 1, 703, 0, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(70310039, ' ', 'BuhOperationCLS', ' ', ' ', 1, 703, 0, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(70310049, '()', 'KCSRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(70310050, '()', 'KVRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(70310051, '()', 'KVSRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(70310055, '()', 'KESRCode', '()', ' ', 1, 703, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(70310056, '()', 'SUBKESRCode', '()', ' ', 1, 703, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (0)
CALL ImportField(80100001, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100002, ' ', 'AcceptSumma', ' ', 'AcceptSumma', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100003, '', 'BUDGETREF', '', 'BUDGETREF', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100004, ' ', ' ', ' ', 'CryptoStatus', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100005, '   ', 'DFACCOUNT', '   ', 'DFACCOUNT', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100007, ' ', 'DFAccountName', ' ', 'DFAccountName', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100008, '', 'DocStateName', '', 'DocStateName', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100009, '', 'DOCSTATEREF', '', 'DOCSTATEREF', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100010, ' ', ' ', ' ', 'DOCUMENTSTATE', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100011, '', 'SourceFacialAcc', '', 'SourceFacialAccCls', 0, 801, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(80100012, ' ', 'FINSOURCE', ' ', 'FinSourceCls', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100013, ' ', 'ID', ' ', 'ID', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100014, ' ', ' ', ' ', 'ImportID', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100015, ' ', 'INPUTDATE', ' ', 'INPUTDATE', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100016, '', 'AMONTH', '', 'AMONTH', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100017, ' ', 'ANUMBER', ' ', 'ANUMBER', 0, 801, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(80100018, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 801, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(80100019, ' ', 'REJECT_CLS', ' ', 'RejectCls', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100020, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100021, ' ', ' ', ' ', 'RVersion', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100022, ' ', ' ', ' ', 'SenderID', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100023, ' ', ' ', ' ', 'SenderINN', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100024, '   ', ' ', '   ', 'SenderRecordID', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100025, '', 'AYEAR', '', 'YEAR', 0, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80100026, '', 'FacialAccCls', '', 'FACIALACCCLS', 0, 801, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(80100027, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100028, '.   ', 'FUID', '.   ', 'FUID', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100045, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100046, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100047, ' ', 'IsVised', ' ', 'IsVised', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100048, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100049, ' ', 'DocSuspended', ' ', ' ', 0, 801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80100068, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 801, 0, 1, '', 0, 18757, 0, 1, '') ;

CALL ImportField(80101003, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101004, ' ', 'AcceptSumma', ' ', 'AcceptSumma', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101005, '', 'BUDGETREF', '', 'BUDGETREF', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101006, '', 'DIRECTIONCLSCODE', '', 'DIRECTIONCLS', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101007, ' ', 'DocTypes', ' ', 'DocTypeCls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101008, ' ', 'FACIALACC', ' ', 'DestFacialAccCls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101009, '   ', 'FACIALCode', '   ', 'DestFacialAccClsFacialCode', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101010, '', 'FACTCODE', '', 'FACTCls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101011, ' ', 'FINSOURCE', ' ', 'FINSOURCECls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101012, ' . ', 'FINTYPECODE', ' . ', 'FINTYPECls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101013, '  ', 'ID', '  ', 'ID', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101014, ' ', ' ', ' ', 'ImportID', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101015, '', 'INN', '', 'DestOrgInn', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101016, '', 'INN20', '', 'DestOrgKpp', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101017, '', 'KCSR', '', 'KCSRKey', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101018, '', 'KESR', '', 'KESRKey', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101019, '', 'KFSR', '', 'KFSR', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101020, '', 'KVR', '', 'KVRKey', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101021, '', 'KVSR', '', 'KVSRKey', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101022, ' ', 'MEANSTYPE', ' ', 'MEANSTYPECls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101023, '', 'AMONTH', '', 'AMONTH', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101024, ' ', 'NAME', ' ', 'DestOrgName', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101025, '', 'NOTE', '', 'NOTE', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101026, '  ', ' ', '  ', 'DestOrgId', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101027, ' ', 'PROGINDEX', ' ', 'PROGINDEX', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101028, '  ', 'RECORDINDEX', '  ', 'RECORDINDEX', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101029, '', 'REGIONCLS', '', 'REGIONCLS', 0, 801, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(80101030, '', 'REQUESTFLAG', '', 'REQUESTFLAG', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101031, ' ', ' ', ' ', 'RVersion', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101032, '', 'SUBKESR', '', 'SUBKESRKey', 0, 801, 1, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(80101033, '()', 'TreeOwner0', '()', ' ', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101034, '', 'AYEAR', '', 'AYEAR', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101035, '   ', 'DFACCOUNT', '   ', 'SourceAccount', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101036, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101037, ' .  . .', 'IFS', ' .  . .', 'IFS', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101038, ' ', 'ClsType', ' ', 'ClsType', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101039, '', ' ', '', 'DocStateName', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101040, '', 'DOCSTATEREF', '', 'DOCSTATEREF', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101041, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101042, '.   ', 'FUID', '.   ', 'FUID', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101049, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 801, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(80101051, '', 'SourceFacialAcc', '', 'SourceFacialAccCls', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101063, '()', 'KCSRCode', '', 'KCSR', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101064, '()', 'KVRCode', '', 'KVR', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101065, '()', 'KVSRCode', '', 'KVSR', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101068, ' ()', 'IFSCode', ' ()', 'SourceIFS_DescriptionCode', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101069, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101070, ' ', 'OrgName', '', ' ', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101071, ' ', 'SourceFacialCode', '  ', ' ', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101072, ' ', 'DFAccountName', ' ', ' ', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101073, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101074, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101075, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101078, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101084, ' ()', 'FACT', '', 'FactCLSKey', 0, 801, 1, 1, '', 0, 18636, 0, 0, '') ;

CALL ImportField(80101085, ' .  ()', 'FINTYPE', ' .  ()', 'FinTypeCLSKey', 0, 801, 1, 1, '', 0, 18634, 0, 0, '') ;

CALL ImportField(80101086, ' ()', 'DIRECTIONCLS', '', 'DIRECTIONCLSKEY', 0, 801, 1, 1, '', 0, 18663, 0, 0, '') ;

CALL ImportField(80101087, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 801, 1, 1, ',', 0, 18664, 0, 0, '') ;

CALL ImportField(80101088, '', 'InvestObject', '', ' ', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101089, '', 'InvestObjectCode', '', ' ', 0, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80101090, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80101092, '()', 'KESRCode', '()', 'KESR', 0, 801, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(80101093, '()', 'SUBKESRCode', '()', 'SUBKESR', 0, 801, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(80101094, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 801, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(80101095, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 801, 1, 1, '', 0, null, 0, 1, '') ;

--  , (1)
CALL ImportField(80110016, '', 'AMONTH', '', 'MONTH', 1, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80110018, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 801, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(80110027, '', 'AYEAR', '', 'YEAR', 1, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80110046, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 801, 0, 1, '', 0, 18757, 0, 1, '') ;

CALL ImportField(80111022, '', 'KCSR', '', 'KCSRKey', 1, 801, 1, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80111023, '', 'KESR', '', 'KESRKey', 1, 801, 1, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80111024, '()', 'KFSR', '', 'KFSR', 1, 801, 1, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80111025, '', 'KVR', '', 'KVRKey', 1, 801, 1, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80111026, '', 'KVSR', '', 'KVSRKey', 1, 801, 1, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80111028, '', 'AMONTH', '', 'MONTH', 1, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80111040, '', 'SUBKESR', '', 'SUBKESRKey', 1, 801, 1, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80111042, '', 'AYEAR', '', 'YEAR', 1, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80111048, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 1, 801, 1, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80111058, '()', 'KCSRCode', '()', 'KCSR', 1, 801, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80111059, '()', 'KVRCode', '()', 'KVR', 1, 801, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80111060, '()', 'KVSRCode', '()', 'KVSR', 1, 801, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80111091, '()', 'KESRCode', '', 'KESR', 1, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80111094, '()', 'SUBKESRCode', '()', 'SUBKESR', 1, 801, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(80111095, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 801, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(80111096, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 801, 1, 1, '', 0, null, 0, 1, '') ;

--   (), (1)
CALL ImportField(80210006, '', 'KVSR', '', ' ', 1, 802, 0, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80210007, '()', 'KFSR', '', ' ', 1, 802, 0, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80210008, '', 'KCSR', '', ' ', 1, 802, 0, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80210009, '', 'KVR', '', ' ', 1, 802, 0, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80210010, '', 'KESR', '', ' ', 1, 802, 0, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80210017, '', 'SUBKESR', '', ' ', 1, 802, 0, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80210024, ' ', 'BuhOperationCLS', ' ', ' ', 1, 802, 0, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80210036, '()', 'KCSRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80210037, '()', 'KVRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80210038, '()', 'KVSRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80210046, '()', 'KESRCode', '()', ' ', 1, 802, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(80210047, '()', 'SUBKESRCode', '()', ' ', 1, 802, 0, 0, '', 0, 43610, 0, 0, '') ;

--     , (1)
CALL ImportField(80311012, '()', 'KFSR', '', ' ', 1, 803, 1, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80311013, '', 'KCSR', '', ' ', 1, 803, 1, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80311014, '', 'KVR', '', ' ', 1, 803, 1, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80311015, '', 'KESR', '', ' ', 1, 803, 1, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80311029, '', 'SUBKESR', '', ' ', 1, 803, 1, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80311033, ' ', 'BuhOperationCLS', ' ', ' ', 1, 803, 1, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80311035, '', 'KVSR', '', ' ', 1, 803, 1, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80311049, '()', 'KCSRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80311050, '()', 'KVRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80311051, '()', 'KVSRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80311059, '()', 'KESRCode', '()', ' ', 1, 803, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(80311060, '()', 'SUBKESRCode', '()', ' ', 1, 803, 1, 0, '', 0, 43610, 0, 0, '') ;

-- , (0)
CALL ImportField(90000001, ' ', '{("")}', ' ', ' ', 0, 900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90000002, '()', '{("")}', ' ', ' ', 0, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90000003, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90000004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90000005, '  ()', 'CREATEDATE', '  ()', ' ', 0, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001001, ' ', '{("")}', ' ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001002, '   ()', '{("")}', '   ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001003, '  ', '{("")}', '  ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001004, '', '{("")}', '  ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001005, ' ', '{("")}', ' ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001006, '', '{("")}', '   ', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001007, '', '{("")}', '    ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001008, ' ', '{("")}', ' ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001009, ' ', '{("")}', ' ', ' ', 0, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90001010, ' ', '{("")}', '  ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001011, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001012, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001013, '  ()', 'CREATEDATE', '  ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90001014, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 900, 1, 1, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(90100001, '()', 'CREATERUSER', '()', ' ', 0, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90100002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90100003, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90100004, '  ()', 'CREATEDATE', '  ()', ' ', 0, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90101065, '()', 'CREATERUSER', '()', ' ', 0, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90101066, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90101067, '  ()', 'CREATEDATE', '  ()', ' ', 0, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90101068, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 901, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(90111030, ' ', 'BuhOperationCLS', ' ', ' ', 1, 901, 1, 0, '', 0, 17720, 0, 0, '') ;

--   (), (0)
CALL ImportField(90200048, '   ()', 'TransfertClsFrom', '    ()', ' ', 0, 902, 0, 0, 'TransfertClsFrom,', 0, null, 0, 0, '') ;

CALL ImportField(90200049, '   ', 'TransfertClsTo', '    ()', ' ', 0, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90200050, '   ', 'TransfertClsFromCode', '', ' ', 0, 902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90200051, '   ', 'TransfertClsToCode', '', ' ', 0, 902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90200052, '()', 'CREATERUSER', '()', ' ', 0, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90200053, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90200054, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90200055, '  ()', 'CREATEDATE', '  ()', ' ', 0, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90201001, '()', 'CREATERUSER', '()', ' ', 0, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90201002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90201003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90201004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 902, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(90210032, ' ', 'BuhOperationCLS', ' ', ' ', 1, 902, 0, 0, '', 0, 17720, 0, 0, '') ;

--   , (0)
CALL ImportField(90300001, '', 'GeneralDocFeatures', '', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300002, '  ', 'FacialAccCls', '  ', 'FacialAccCls', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300003, ' ', 'BuildDate', ' ', 'BuildDate', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300004, ' ', 'DocNumber', ' ', 'DocNumber', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300005, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300006, ' ', 'IncAccountName', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300007, '  ()', 'IncAccountComment', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300008, ' ', 'TypeOperationCls', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300009, ' ', 'RejectCls', ' ', 'RejectCls', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300010, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300011, ' ', 'SoftRejectCls', ' ', '', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300012, ' ', 'SoftRejectCause', ' ', '', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300013, ' ', 'ReestrDate', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300014, ' ', 'ReestrNumber', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300015, '', 'Summa', '    ', 'Summa', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300016, ' ', 'CreateDate', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300017, ' ', 'UpdateDate', ' ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300018, '', 'DocStateRef', ' ', 'DocStateRef', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300021, ' ', 'DocStateName', ' ', 'DocStateName', 0, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90300036, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300037, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300038, ' ', 'IsVised', ' ', 'IsVised', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300056, '', 'BUDGETREF', '', 'BudgetRef', 0, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90300057, '/ ', 'FacialCode', '/ ', ' ', 0, 903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90300058, '  ()', 'IncAccount', '  ()', 'IncAccount', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300059, ' ', 'ProgIndex', '', 'ProgIndex', 0, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90300124, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300130, ' ', 'ID', ' ', 'Id', 0, 903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90300131, '()', 'CREATERUSER', '()', ' ', 0, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90300132, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301008, '', 'DirectionClsCode', '', 'DirectionCLS', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301009, ' ()', 'KVSR', ' ()', 'KVSRKey', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301010, '', 'KVR', '', 'KVRKey', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301011, '', 'KCSR', '', 'KCSRKey', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301019, ' ', 'FacialAcc_Cls', ' ', 'FacialAcc_Cls', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301020, '/ ', 'facialcode', '/ ', ' ', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301021, ' ', 'ClsType', '  (/)', 'ClsType', 0, 903, 1, 0, '', 0, 17723, 0, 1, '') ;

CALL ImportField(90301022, ' ()', 'KD', '   ', 'KD', 0, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90301023, ' ()', 'IFS', '   ', 'IFS', 0, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90301024, '', 'Debit', '      ()', 'Debit', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301025, '', 'Credit', '     ', 'Credit', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301026, ' ', 'BuhOperationCls', ' ', 'BuhOperationCLS', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301027, ' ', 'MeansType', '  ', 'MeansType', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301028, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 903, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90301029, '', 'INN', '', 'Org_refINN', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301030, '', 'INN20', '', 'Org_refKPP', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301031, '', 'Name', '', 'Org_refName', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301032, '', 'Acc', '', 'AccountRefName', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301033, '', 'DOCNUM', ' ', 'DocNum', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301034, '', 'Note', '', 'Note', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301035, '', 'NDS', ' ', 'NDS', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301036, '', 'RegionCls', ' ', 'RegionCLS', 0, 903, 1, 0, ',,', 0, null, 0, 1, '') ;

CALL ImportField(90301037, ' ', 'DocType', '  ', 'DocType', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301038, ' ', 'SubKD', '  ', 'SubKD', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301039, '', 'GosNI', '', 'GosNI', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301040, '. ', 'BuhPaymentCls', ' ', ' ', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301041, '', 'AccountIndex', ' ', 'AccountIndex', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301042, '', 'KESR', '', 'KESRKey', 0, 903, 1, 1, '', 0, 17712, 0, 1, '') ;

CALL ImportField(90301043, '', 'KFSR', '', 'KFSR', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301044, '', 'FactCode', ' ', 'Fact', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301045, '', 'DocBaseCode', '', 'DocBase', 0, 903, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(90301046, ' ', 'DocDate', ' ', 'DocDate', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301047, ' . ', 'ELPACKETNUM', ' . ', ' ', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301048, ' . ', 'ELNUM', ' . ', 'EL_DocNumber', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301049, ' . ', 'NOTEEX', ' . ', 'EL_Note', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301050, '', 'OKATO', '', 'OKATO', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301051, ' ', 'AddOKATO', ' ', 'AddOKATO', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301052, '  ()', 'CREATEDATE', ' ', ' ', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301053, '  ()', 'UPDATEDATE', ' ', ' ', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301054, '', 'Org_Ref', '', 'Org_ref', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301055, ' ()', 'Acc_Ref', '', 'AccountRef', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301057, '', 'BUDGETREF', '', 'BudgetRef', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301058, '   ', 'taxnote', '   ', 'TaxNote', 0, 903, 1, 0, '', 0, 17705, 0, 1, '') ;

CALL ImportField(90301080, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301081, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301087, '', 'UINCode', '  ', 'UINCode', 0, 903, 1, 0, '', 0, 35368, 0, 1, '') ;

CALL ImportField(90301125, ' ', 'FundsSource', ' ', 'FundsSource', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301147, '()', 'KCSRCode', '', 'KCSR', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301148, '()', 'KVRCode', '', 'KVR', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301149, '', 'KVSRCode', '', 'KVSR', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301150, ' ( )', 'UnBlockedCause', ' ', 'UnblockedCause', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301151, '  ', 'BlockedCondition', '  ', ' ', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301158, ' ', 'ID', ' ', 'ID', 0, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90301159, '', 'KDCode', '', 'KDValue', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301160, '', 'IFSCode', '', 'FinSourceValue', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301161, '  (.)', 'ProgIndex', '  (.)', 'ProgIndex', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301162, '    ', 'ElDocRef', '    ', ' ', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301163, '  ', 'RECORDINDEX', '  ', 'RecordIndex', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301164, '( )', 'IsBlocked', '', 'IsBlocked', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301165, ' ( )', 'BlockedCause', ' ', 'BLOCKEDCAUSE', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301166, ' ( )', 'UnBlockedDate', ' ', 'UnBlockedDate', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301167, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90301168, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301169, ' ()', 'Fact', '', 'FactKey', 0, 903, 1, 1, '', 0, 17710, 0, 1, '') ;

CALL ImportField(90301170, ' .  ()', 'FinType', '  ', 'FINTYPEKey', 0, 903, 1, 1, '', 0, 36856, 0, 1, '') ;

CALL ImportField(90301171, ' . ', 'FinTypeCode', '  ', 'FINTYPE', 0, 903, 1, 0, '', 0, 36853, 0, 1, '') ;

CALL ImportField(90301172, ' ()', 'DirectionCLS', '', 'DirectionClsKey', 0, 903, 1, 1, '', 0, 17733, 0, 1, '') ;

CALL ImportField(90301173, ' ()', 'DocBase', '', 'DocBaseKey', 0, 903, 1, 1, ',', 0, 17709, 0, 1, '') ;

CALL ImportField(90301174, '', 'InvestObject', '', 'InvestObjectKey', 0, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90301175, '', 'InvestObjectCode', '', 'InvestObject', 0, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90301176, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 903, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90301177, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 903, 1, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90301179, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90301181, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90301187, '()', 'KESRCode', '()', 'KESR', 0, 903, 1, 0, '', 0, 43607, 0, 1, '') ;

--   , (1)
CALL ImportField(90311014, ' ()', 'ProgramCode', '', 'ProgramCode', 1, 903, 1, 0, '', 0, 16834, 0, 0, '') ;

CALL ImportField(90311030, '', 'KESR', '', 'KESRKey', 1, 903, 1, 1, '', 0, 17712, 0, 1, '') ;

CALL ImportField(90311040, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 903, 1, 0, '', 0, 17720, 0, 1, '') ;

CALL ImportField(90311065, '', 'BudgetRef', '', 'BudgetRef', 1, 903, 1, 1, '', 0, 17687, 0, 0, '') ;

CALL ImportField(90311073, ' . ', 'NOTEEX', ' . ', 'EL_Note', 1, 903, 1, 1, '', 0, 17696, 0, 0, '') ;

CALL ImportField(90311093, '', 'InvestObject', '', 'InvestObjectKey', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311094, '', 'InvestObjectCode', '', 'InvestObject', 1, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90311186, '()', 'KESRCode', '()', 'KESR', 1, 903, 1, 0, '', 0, 43607, 0, 1, '') ;

--   , +(2)
CALL ImportField(90311188, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90311189, '   ()', 'PayTargetFunds', '   ', ' ', 2, 903, 1, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(90500036, '  ()', 'TransfertCls', '   ()', ' ', 0, 905, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90500037, '  ', 'TransfertClsCode', '  ', ' ', 0, 905, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90500038, '', 'InvestObject', '', ' ', 0, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90500039, '', 'InvestObjectCode', '', ' ', 0, 905, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90500040, '', 'KESR', '', 'KESRKey', 0, 905, 0, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90500041, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 905, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90500050, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 905, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90500052, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 905, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90500053, '()', 'CREATERUSER', '()', ' ', 0, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90500054, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90500055, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90500056, '  ()', 'CREATEDATE', '  ()', ' ', 0, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90500060, '()', 'KESRCode', '()', 'KESR', 0, 905, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90501001, '()', 'CREATERUSER', '()', ' ', 0, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90501002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90501003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90501004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 905, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(90510026, ' ', 'BuhOperationCLS', ' ', ' ', 1, 905, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90510046, '', 'KESR', '', 'KESRKey', 1, 905, 0, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90510059, '()', 'KESRCode', '()', 'KESR', 1, 905, 0, 0, '', 0, 43607, 0, 0, '') ;

--   (), (0)
CALL ImportField(90600079, '  ', 'TransfertCls', '   ()', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600081, '  ', 'TransfertClsCode', '  ', ' ', 0, 906, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90600084, '', 'InvestObject', '', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600085, '', 'InvestObjectCode', '', ' ', 0, 906, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90600086, '', 'KESR', '', 'KESRKey', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600087, '()', 'CREATERUSER', '()', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600088, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600089, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600090, '  ()', 'CREATEDATE', '  ()', ' ', 0, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90600095, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 906, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90600097, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 906, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90600113, '()', 'KESRCode', '()', 'KESR', 0, 906, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90601080, '  ', 'TransfertCls', '   ()', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601082, '  ', 'TransfertClsCode', '  ', ' ', 0, 906, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90601083, '', 'InvestObject', '', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601084, '', 'InvestObjectCode', '', ' ', 0, 906, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90601085, '', 'KESR', '', 'KESRKey', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601086, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 906, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90601087, '()', 'CREATERUSER', '()', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601088, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601089, '  ()', 'CREATEDATE', '  ()', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601090, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90601099, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 906, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90601101, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 906, 1, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90601114, '()', 'KESRCode', '()', 'KESR', 0, 906, 1, 0, '', 0, 43607, 0, 0, '') ;

--   (), (1)
CALL ImportField(90610022, ' ', 'BuhOperationCLS', ' ', ' ', 1, 906, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90610082, '', 'KESR', '', 'KESRKey', 1, 906, 0, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90610115, '()', 'KESRCode', '()', 'KESR', 1, 906, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90611045, ' ', 'BuhOperationCLS', ' ', ' ', 1, 906, 1, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90611088, '', 'KESR', '', 'KESRKey', 1, 906, 1, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90611116, '()', 'KESRCode', '()', 'KESR', 1, 906, 1, 0, '', 0, 43607, 0, 0, '') ;

--   (), (0)
CALL ImportField(90700050, '  ', 'TransfertCls', '   ()', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700051, '  ', 'TransfertClsCode', '  ', ' ', 0, 907, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90700052, '', 'InvestObject', '', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700053, '', 'InvestObjectCode', '', ' ', 0, 907, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90700054, '', 'KESR', '', 'KESRKey', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700055, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 907, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90700056, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 907, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90700057, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 907, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90700058, '()', 'CREATERUSER', '()', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700059, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700060, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700061, '  ()', 'CREATEDATE', '  ()', ' ', 0, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90700067, '()', 'KESRCode', '()', 'KESR', 0, 907, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90701001, '()', 'CREATERUSER', '()', ' ', 0, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90701002, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90701003, '  ()', 'CREATEDATE', '  ()', ' ', 0, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90701004, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 907, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(90710025, ' ', 'BuhOperationCLS', ' ', ' ', 1, 907, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90710058, '', 'KESR', '', 'KESRKey', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710068, '()', 'KESRCode', '()', 'KESR', 1, 907, 0, 0, '', 0, 43607, 0, 0, '') ;

--  , (1)
CALL ImportField(120110005, '', 'KVSR', '', ' ', 1, 1201, 0, 1, '', 0, 17341, 0, 0, '') ;

CALL ImportField(120110006, '( )', 'KFSR', '', ' ', 1, 1201, 0, 0, '', 0, 17342, 0, 0, '') ;

CALL ImportField(120110007, '', 'KCSR', '', ' ', 1, 1201, 0, 1, '', 0, 17345, 0, 0, '') ;

CALL ImportField(120110008, '', 'KVR', '', ' ', 1, 1201, 0, 1, '', 0, 17344, 0, 0, '') ;

CALL ImportField(120110009, '', 'KESR', '', ' ', 1, 1201, 0, 1, '', 0, 17343, 0, 0, '') ;

CALL ImportField(120110019, ' ', 'KVSR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17347, 0, 0, '') ;

CALL ImportField(120110020, '( )', 'KFSR_corr', '', ' ', 1, 1201, 0, 0, '', 0, 17348, 0, 0, '') ;

CALL ImportField(120110021, '', 'KCSR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17351, 0, 0, '') ;

CALL ImportField(120110022, '', 'KVR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17350, 0, 0, '') ;

CALL ImportField(120110023, '()', 'KESR_corr', '()', ' ', 1, 1201, 0, 0, '', 0, 17349, 0, 0, '') ;

CALL ImportField(120110035, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1201, 0, 0, '', 0, 17338, 0, 0, '') ;

CALL ImportField(120110045, '( )', 'KCSR_corrCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(120110046, '( )', 'KCSRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(120110049, '( )', 'KVR_corrCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(120110050, '( )', 'KVRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(120110051, ' ( )', 'KVSR_corrCode', ' ( )', ' ', 1, 1201, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(120110052, '( )', 'KVSRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(120110068, '', 'SubKESR', '', ' ', 1, 1201, 0, 1, '', 0, 17387, 0, 0, '') ;

CALL ImportField(120110079, '()', 'KESRCode', '()', ' ', 1, 1201, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(120110080, '()', 'SubKESRCode', '()', ' ', 1, 1201, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(150110003, '', 'KVSR', '', ' ', 1, 1501, 0, 1, '', 0, 18381, 0, 0, '') ;

CALL ImportField(150110004, '()', 'KFSR', '', ' ', 1, 1501, 0, 0, '', 0, 18379, 0, 0, '') ;

CALL ImportField(150110005, '', 'KCSR', '', ' ', 1, 1501, 0, 1, '', 0, 18380, 0, 0, '') ;

CALL ImportField(150110006, '', 'KVR', '', ' ', 1, 1501, 0, 1, '', 0, 18382, 0, 0, '') ;

CALL ImportField(150110007, '', 'KESR', '', ' ', 1, 1501, 0, 1, '', 0, 18383, 0, 0, '') ;

CALL ImportField(150110010, '', 'SUBKESR', '', ' ', 1, 1501, 0, 1, '', 0, 18384, 0, 0, '') ;

CALL ImportField(150110041, '()', 'KCSRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(150110042, '()', 'KVRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(150110043, '()', 'KVSRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(150110056, '()', 'KESRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(150110057, '()', 'SUBKESRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (0)
CALL ImportField(160100001, '  ', 'ANUMBER', '  ', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100002, ' /', 'ACCEPTDATE', ' /', 'ACCEPTDATE', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100003, '/', 'ACCEPTED_REVERTED', '/', 'ACCEPTED_REVERTED', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100004, ' ', 'AGREEMENT_TYPE', ' ', 'Agreement_Type', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100005, ' ', 'AGREEMENT_NUM', ' ', 'Agreement_Num', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100006, ' ', 'AGREEMENT_DATE', ' ', 'Agreement_Date', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100007, '  ', 'AGREEMENT_END', '  ', 'Agreement_End', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100008, '  ', 'AGREEMENT_NOTE', '  ', 'Agreement_Note', 0, 1601, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(160100009, '( )', 'Supplier_Name', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100010, '( )', 'Supplier_INN', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100011, '( )', 'Supplier_INN20', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100012, ' ', 'Agreement_Summa', ' ', 'Agreement_Summa', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100013, '  ', 'TOTALSUMM', '  ', 'TotalSumm', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100014, '( )', 'BudgetOrg_Name', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100015, ' ', 'FACIALACC_CLS', ' ', 'FacialAccCls', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100046, ' ', 'DELIVERY_RULES', ' ', 'Delivery_Rules', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100047, '( )', 'BudgetOrg_INN20', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100048, '( )', 'BudgetOrg_INN', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100049, '', 'BUDGETREF', '', 'BUDGETREF', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100050, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100051, ' ', 'Reject_Cls', ' ', 'RejectCls', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100058, ' ', 'BUDGETORG_REF', ' ', 'BUDGETORG_REF', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100059, ' ', 'ID', ' ', 'ID', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100060, ' ', 'SUPPLIER_REF', ' ', 'SUPPLIER_REF', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100063, 'CryptoStatus', 'CryptoStatus', 'CryptoStatus', ' ', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100071, '( )', 'Supplier_Acc', '', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100079, '/ ', 'SUPPLIER_ACC_REF', '  ', 'SUPPLIER_ACC_REF', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100082, '   ', 'FACIALCode', '   ', ' ', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100084, '', 'DocStateName', '', 'DocStateName', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100085, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100086, '', 'DOCSTATEREF', '', 'DOCSTATEREF', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100087, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100088, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100090, '.   ', 'FUID', '.   ', 'FUID', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100091, ' ', 'IsVised', ' ', 'IsVised', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100092, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100093, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 1601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160100097, ' ', 'InfoNumber', ' ', 'InfoNumber', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160100098, ' ', 'AdvanceSumma', '  ', 'AdvanceSumma', 0, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101017, '  ', 'PARENT_PROMISE', '  ', 'PARENT_PROMISE', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101018, ' ', 'REGISTRNUMBER', ' ', 'REGISTRNUMBER', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101019, ' ', 'FacialAcc_Cls', ' ', 'FacialAccCls', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101020, '', 'TreeOwner0', '', ' ', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101021, '', 'KVSR', '', 'KVSRKey', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101022, '()', 'KFSR', '', 'KFSR', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101023, '', 'KCSR', '', 'KCSRKey', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101024, '', 'KVR', '', 'KVRKey', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101025, '', 'KESR', '', 'KESRKey', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101026, '', 'FACTCODE', '', 'FACT', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101027, ' ', 'MeansType', ' ', 'MeansType', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101028, ' . ', 'FinTypeCode', ' . ', 'FinTypeCls', 0, 1601, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(160101029, ' ', 'FinSource', ' ', 'FinSourceCls', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101030, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101031, '    ', 'SUMMA', '', 'SUMMA', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101032, '', 'MONTH01', '', 'Month01', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101033, '', 'MONTH02', '', 'Month02', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101034, '', 'MONTH03', '', 'Month03', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101035, '', 'MONTH04', '', 'Month04', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101036, '', 'MONTH05', '', 'Month05', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101037, '', 'MONTH06', '', 'Month06', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101038, '', 'MONTH07', '', 'Month07', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101039, '', 'MONTH08', '', 'Month08', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101040, '', 'MONTH09', '', 'Month09', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101041, '', 'MONTH10', '', 'Month10', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101042, '', 'MONTH11', '', 'Month11', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101043, '', 'MONTH12', '', 'Month12', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101044, '', 'SubKESR', '', 'SubKESRKey', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101045, '', 'RegionCls', '', 'RegionCls', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101052, '()', 'DirectionCLSCode', '', 'DirectionCLS', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101053, ' ', 'DocType', ' ', 'DocTypeCls', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101054, ' ', 'CloseDate', ' ', 'CloseDate', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101055, ' ', 'Child_Promise', ' ', 'Child_Promise', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101061, '', 'BUDGETREF', '', ' ', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101062, ' ', 'ID', ' ', 'ID', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101064, ' ', 'ASSIGNMENTKIND', ' ', 'AssignmentKind', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101065, ' ', 'SUMMAYEAR1', ' ', 'SummaYear1', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101066, '  ', 'SUMMAYEAR2', '  ', 'SummaYear2', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101067, '  ', 'SUMMAYEAR3', '  ', 'SummaYear3', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101074, '()', 'KCSRCode', '', 'KCSR', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101075, '()', 'KVRCode', '', 'KVR', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101076, '()', 'KVSRCode', '', 'KVSR', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101077, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101078, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101083, ' ', 'TargetCls', '', ' ', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101089, '  ', 'Title_Ref', '  ', 'RECORDINDEX', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101094, '.   ', 'FUID', '.   ', 'FUID', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101095, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101096, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101097, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101098, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 1601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160101099, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101100, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 1601, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(160101101, ' ()', 'FACT', '', 'FactClsKey', 0, 1601, 1, 1, '', 0, 19025, 0, 0, '') ;

CALL ImportField(160101102, ' .  ()', 'FinType', ' .  ()', 'FinTypeClsCode', 0, 1601, 1, 1, ',', 0, 19029, 0, 0, '') ;

CALL ImportField(160101103, '()', 'DirectionCLS', '', 'DirectionCLSKey', 0, 1601, 1, 1, '', 0, 19057, 0, 0, '') ;

CALL ImportField(160101104, '()', 'KESRCode', '()', 'KESR', 0, 1601, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(160101106, '()', 'SUBKESRCode', '()', 'SubKESR', 0, 1601, 1, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(160110080, '/ ', 'SUPPLIER_ACC_REF', '  ', 'SUPPLIER_ACC_REF', 1, 1601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160111021, '', 'KVSR', '', 'KVSRKey', 1, 1601, 1, 1, '', 0, 19021, 0, 0, '') ;

CALL ImportField(160111022, '()', 'KFSR', '', 'KFSR', 1, 1601, 1, 0, '', 0, 19020, 0, 0, '') ;

CALL ImportField(160111023, '', 'KCSR', '', 'KCSRKey', 1, 1601, 1, 1, '', 0, 19022, 0, 0, '') ;

CALL ImportField(160111024, '', 'KVR', '', 'KVRKey', 1, 1601, 1, 1, '', 0, 19023, 0, 0, '') ;

CALL ImportField(160111025, '', 'KESR', '', 'KESRKey', 1, 1601, 1, 1, '', 0, 19024, 0, 0, '') ;

CALL ImportField(160111030, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1601, 1, 0, '', 0, 19058, 0, 0, '') ;

CALL ImportField(160111044, '', 'SubKESR', '', 'SubKESRKey', 1, 1601, 1, 1, '', 0, 19031, 0, 0, '') ;

CALL ImportField(160111074, '()', 'KCSRCode', '()', 'KCSR', 1, 1601, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(160111075, '()', 'KVRCode', '()', 'KVR', 1, 1601, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(160111076, '()', 'KVSRCode', '()', 'KVSR', 1, 1601, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(160111079, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1601, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(160111083, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1601, 1, 1, '', 0, 27860, 0, 0, '') ;

CALL ImportField(160111105, '()', 'KESRCode', '()', 'KESR', 1, 1601, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(160111107, '()', 'SUBKESRCode', '()', 'SubKESR', 1, 1601, 1, 0, '', 0, 43610, 0, 0, '') ;

-- . - , (0)
CALL ImportField(160200038, '  ()', 'TransfertCls', '   ()', ' ', 0, 1602, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(160200039, '  ', 'TransfertClsCode', '  ', ' ', 0, 1602, 0, 0, '', 0, null, 0, 0, '') ;

-- . - , (1)
CALL ImportField(160210011, '', 'KFSR', '', ' ', 1, 1602, 0, 0, '', 0, 19020, 0, 0, '') ;

CALL ImportField(160210012, '', 'KVSR', '', ' ', 1, 1602, 0, 1, '', 0, 19021, 0, 0, '') ;

CALL ImportField(160210013, '', 'KCSR', '', ' ', 1, 1602, 0, 1, '', 0, 19022, 0, 0, '') ;

CALL ImportField(160210014, '', 'KVR', '', ' ', 1, 1602, 0, 1, '', 0, 19023, 0, 0, '') ;

CALL ImportField(160210015, '', 'KESR', '', ' ', 1, 1602, 0, 1, '', 0, 19024, 0, 0, '') ;

CALL ImportField(160210018, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1602, 0, 0, '', 0, 19058, 0, 0, '') ;

CALL ImportField(160210022, '', 'SubKESR', '', ' ', 1, 1602, 0, 1, '', 0, 19031, 0, 0, '') ;

CALL ImportField(160210035, '', 'KCSRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(160210036, '', 'KVRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(160210037, '', 'KVSRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(160210039, ' ', 'BudAllocationClsCode', '', ' ', 1, 1602, 0, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(160210048, '()', 'KESRCode', '()', ' ', 1, 1602, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(160210049, '()', 'SubKESRCode', '()', ' ', 1, 1602, 0, 0, '', 0, 43610, 0, 0, '') ;

-- , (1)
CALL ImportField(170110027, '', 'KCSR', '', 'KCSRKey', 1, 1701, 0, 1, '', 0, 19129, 0, 0, '') ;

CALL ImportField(170110029, '', 'KESR', '', 'KESRKey', 1, 1701, 0, 1, '', 0, 19131, 0, 0, '') ;

CALL ImportField(170110030, '()', 'KFSR', '', 'KFSR', 1, 1701, 0, 0, '', 0, 19127, 0, 0, '') ;

CALL ImportField(170110031, '', 'KVR', '', 'KVRKey', 1, 1701, 0, 1, '', 0, 19130, 0, 0, '') ;

CALL ImportField(170110032, '', 'KVSR', '', 'KVSRKey', 1, 1701, 0, 1, '', 0, 19128, 0, 0, '') ;

CALL ImportField(170110049, '', 'SUBKESR', '', 'SUBKESRKey', 1, 1701, 0, 1, '', 0, 19132, 0, 0, '') ;

CALL ImportField(170110057, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 1, 1701, 0, 0, '', 0, 19178, 0, 0, '') ;

CALL ImportField(170110081, '()', 'KCSRCode', '()', 'KCSR', 1, 1701, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(170110083, '()', 'KVRCode', '()', 'KVR', 1, 1701, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(170110084, '()', 'KVSRCode', '()', 'KVSR', 1, 1701, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(170110087, ' ', 'BudAllocationCLS', '', 'BudAllocationCLSKey', 1, 1701, 0, 1, '', 0, 29948, 0, 0, '') ;

CALL ImportField(170110088, ' ', 'BudAllocationCLSCode', '', 'BudAllocationCLS', 1, 1701, 0, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(170110097, '()', 'KESRCode', '()', 'KESR', 1, 1701, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(170110098, '()', 'SubKESRCode', '()', 'SUBKESR', 1, 1701, 0, 0, '', 0, 43610, 0, 0, '') ;

-- (), (1)
CALL ImportField(170210015, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1702, 0, 0, '', 0, 19178, 0, 0, '') ;

CALL ImportField(170210024, '', 'KVR', '()', ' ', 1, 1702, 0, 1, '', 0, 19130, 0, 0, '') ;

CALL ImportField(170210025, '', 'KVSR', '()', ' ', 1, 1702, 0, 1, '', 0, 19128, 0, 0, '') ;

CALL ImportField(170210028, '()', 'KFSR', '()', ' ', 1, 1702, 0, 0, '', 0, 19127, 0, 0, '') ;

CALL ImportField(170210029, '', 'KCSR', '()', ' ', 1, 1702, 0, 1, '', 0, 19129, 0, 0, '') ;

CALL ImportField(170210030, '', 'KESR', '', ' ', 1, 1702, 0, 1, '', 0, 19131, 0, 0, '') ;

CALL ImportField(170210043, '', 'SubKESR', '', ' ', 1, 1702, 0, 1, '', 0, 19132, 0, 0, '') ;

CALL ImportField(170210048, '()', 'KCSRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210049, '()', 'KVRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210050, '()', 'KVSRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210054, '()', 'KESRCode', '()', ' ', 1, 1702, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(170210055, '()', 'SUBKESRCode', '()', ' ', 1, 1702, 0, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(180510093, '  ', 'CodePurpose', '  ', ' ', 1, 1805, 0, 0, '', 0, 45948, 0, 0, '') ;

--   , (1)
CALL ImportField(181010065, '  ', 'CodePurpose', '  ', ' ', 1, 1810, 0, 0, '', 0, 45935, 0, 0, '') ;

--   , (1)
CALL ImportField(181610003, '', 'KVSR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610004, '', 'KFSR', '', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610005, '', 'KCSR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610006, '', 'KVR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610007, '', 'KESR', '', ' ', 1, 1816, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181610026, '', 'KVRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610027, '', 'KVSRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610028, '', 'KCSRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610034, '', 'SubKESR', '', ' ', 1, 1816, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181610038, ' ', 'BuhOperationCls', ' ', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610047, '  ()', 'BudAllocationCls', '   ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610048, ' ', 'BudAllocationClsCode', '  ', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610102, '()', 'KESRCode', '()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610104, '()', 'SubKESRCode', '()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611063, '', 'KFSR', '', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611064, '', 'KVSR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611065, '', 'KVSRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611066, '', 'KCSR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611067, '', 'KCSRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611068, '', 'KVR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611069, '', 'KVRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611070, '', 'KESR', '', ' ', 1, 1816, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181611073, '', 'SubKESR', '', ' ', 1, 1816, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181611090, '  ()', 'BudAllocationCls', '   ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611091, ' ', 'BudAllocationClsCode', '  ', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611097, ' ', 'BuhOperationCls', ' ', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611103, '()', 'KESRCode', '()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611105, '()', 'SubKESRCode', '()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

--     , (1)
CALL ImportField(181810052, '  ', 'IKZ', '  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810053, '    ', 'ADVANCEPRICEVALUE', '    ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810054, '   ', 'ADVANCESUMINPERCENTS', '   ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810055, '-  ', 'NOTIFICATIONNUMBER', '-  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814056, ' ', 'ID', ' ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814057, '  ', 'RECORDINDEX', '  ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814058, '', 'PROGINDEX', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814059, ' ', 'DOCTYPE', ' ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814060, '', 'url', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814061, '', 'DESCRIPTION', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

--   -  2020   , (1)
CALL ImportField(181910001, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910002, ' ', 'PACKETNAME', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910003, ' ', 'ANUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910004, ' ', 'VERSIONNUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910005, ' ', 'CUSTOMER_REGNUM', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910006, '', 'CUSTOMER_FULLNAME', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910007, '', 'CUSTOMER_INN', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910008, '', 'CUSTOMER_KPP', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910009, '', 'EXECUTIONDATE_YEAR', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910010, ' ', 'FCSORDER_PLACING', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910011, ' ', 'PUBLISHDATE', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910012, ' ', 'ID', 'ID', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910025, '', 'CUSTOMER_HEAD', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910026, ' ', 'EDITIONNUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911013, ' ', 'Number', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911014, '  ', 'KBK', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911015, '', 'YEAR', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911016, '', 'PRICE', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911017, '  ', 'MAXPRICE', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911018, '  ', 'SUBJECTNAME', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911019, '  ', 'IKZ', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911020, '  ', 'PLACINGWAY_NAME', '  ()', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911021, '   ', 'PLACINGWAY_CODE', '  ()', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911022, '  ', 'CHANGEREASON_NAME', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911023, '  ', 'CHANGEREASON_ID', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911024, ' ', 'PACKETSECTION', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

--   -  2020 , (1)
CALL ImportField(182010001, ' ', 'ID', 'ID', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010002, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010003, ' ', 'PACKETNAME', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010004, ' ', 'ANUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010005, ' ', 'VERSIONNUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010006, ' ', 'CUSTOMER_REGNUM', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010007, '', 'CUSTOMER_FULLNAME', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010008, '', 'CUSTOMER_INN', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010009, '', 'CUSTOMER_KPP', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010010, '', 'CUSTOMER_HEAD', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010011, '', 'EXECUTIONDATE_YEAR', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010012, ' ', 'FCSORDER_PLACING', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010013, ' ', 'EDITIONNUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010027, ' ', 'PUBLISHDATE', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010028, ' ', 'CR', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010029, ' ', 'DocumentBase', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011015, ' ', 'Number', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011016, '  ', 'KBK', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011017, '', 'YEAR', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011018, '', 'PRICE', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011019, '  ', 'MAXPRICE', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011020, '  ', 'SUBJECTNAME', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011021, '  ', 'IKZ', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011022, '  ', 'PLACINGWAY_NAME', '  ()', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011023, '   ', 'PLACINGWAY_CODE', '  ()', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011024, '  ', 'CHANGEREASON_NAME', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011025, '  ', 'CHANGEREASON_ID', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011026, ' ', 'PACKETSECTION', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011030, ' ', 'FacialAcc', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011031, '. ', 'AddCls', '. ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

--     , (1)
CALL ImportField(182110001, 'ID', 'ID', 'ID', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110002, '/', 'DocNumber', '  ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110003, '  ', 'ReestrNumber', '  ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110004, '', 'BudgetRef', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110005, ' ', 'SendBy', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110006, '   ', 'OrgAttrsCreateDate', '   ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110007, ' ', 'DocumentDate', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110008, ' ', 'SendDate', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110009, ' ', 'AcceptDate', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110010, ' ', 'CreateDate', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110011, '', 'ID_ELS', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110012, '', 'ID_JKU', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110013, ' ', 'ElExch_PackageID', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110014, '  ', 'ID_All', '  ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110015, '  . ', 'ElExch_PacketName', '  . ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110016, '', 'INNA', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110017, ' ', 'INN', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110018, ' ', 'ConsumerINN', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110019, '  ', 'InfoPay', '  ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110020, '', 'ID_IPD', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110021, '', 'KPPA', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110022, ' ', 'FacialAccCls', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110023, ' ', 'Note', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110024, '', 'NameA', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110025, ' ', 'Name', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110026, ' . ', 'FacialAcc_ClsName', ' . ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110027, ' ', 'PayQueue', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110028, '', 'ParentSource', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110029, ' ', 'ElExch_Note', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110030, ' ', 'Reject_Cls', ' ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110031, '', 'Status', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110032, '', 'Summa', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110033, '', 'AccA', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110034, '', 'UINCode', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110035, '  ', 'PaymentIdentifier', '  ', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182110036, '', 'ID_FIAS', '', ' ', 1, 1821, 0, 0, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(182410001, 'ID', 'ID', 'ID', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410002, 'KPP', 'KPP', 'KPP', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410003, '', 'BudgetRef', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410004, ' ', 'MessageType', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410005, ' ', 'DateClose', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410006, ' ', 'DateOpen', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410007, ' ', 'SendDate', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410008, ' ', 'DateChange', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410009, '', 'INN', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410010, '', 'ServiceINN', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410011, '  ', 'ReportFormCode', '  ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410012, '', 'ServiceKPP', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410013, ' ', 'FacialAcc_Cls', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410014, '', 'Name', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410015, '', 'ServiceName', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410016, ' /', 'FAName', ' /', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410017, '  ', 'PrevCls', '  ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410018, ' ', 'ServiceOrganization', ' ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410019, '', 'OGRN', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410020, '', 'ServiceOGRN', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410021, '', 'Organization', '', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410022, '     ', 'AboutAcc', '     ', ' ', 1, 1824, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182410023, '', 'Status', '', ' ', 1, 1824, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182411001, 'ID', 'ID', 'ID', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411002, 'ServiceOrgCode', 'ServiceOrgCode', 'ServiceOrgCode', ' ', 1, 1824, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182411003, ' ', 'OrgType', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411004, ' ', 'MessageFlag', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411005, '  ', 'FAUpdateDate', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411006, ' ', 'FACloseDate', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411007, '  ', 'ExtProcDate', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411008, ' ', 'FAOpenDate', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411009, ' ', 'MessageDate', ' ', ' ', 1, 1824, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182411010, '', 'ServiceOrgExecPost', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411011, '  ', 'IdDocCancelled', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411012, '', 'FAOrgINN', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411013, '', 'ServiceOrgINN', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411014, ' ', 'ExtProcCode', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411015, ' ', 'ExtProcErrCode', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411016, '  ', 'KND', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411017, '', 'FAOrgKPP', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411018, '', 'ServiceOrgKPP', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411019, '', 'FAOrgName', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411020, '', 'ServiceOrgName', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411021, '  ', 'ExtProcErrElemCode', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411022, '  ', 'FACode_Old', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411023, ' ', 'MessageNumber', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411024, ' ', 'ServiceOrganization', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411025, '', 'FAOrgOGRN', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411026, '', 'Organization', '', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411027, ' ', 'MessageType', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411028, ' ', 'ProcNote', ' ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411029, '     ', 'AboutAcc', '     ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411030, '  ', 'ServiceOrgInform', '  ', ' ', 1, 1824, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182411031, '  ', 'ErrorNote', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411032, '', 'ServiceOrgTel', '', ' ', 1, 1824, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182411033, '  ', 'IdDoc', '  ', ' ', 1, 1824, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182411034, '  ', 'ServiceOrgExecFIO', '  ', ' ', 1, 1824, 1, 0, '', 0, null, 0, 0, '') ;

--     	, (1)
CALL ImportField(182510001, 'ID', 'ID', 'ID', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510002, ' ', 'SENDDATE', ' ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510003, ' ', 'ElPacketNumber', ' ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510004, '  ', 'MessageID', '  ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510005, '  . ', 'PACKETNUMBER', '  . ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510006, ' ', 'CodeFormat', ' ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510007, ' ', 'Note', ' ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510008, '  ', 'DocNumber', '  ', ' ', 1, 1825, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(182510009, '', 'Status', '', ' ', 1, 1825, 0, 0, '', 0, null, 0, 0, '') ;

--   (), (0)
CALL ImportField(190000001, ' ', '{("")}', ' () ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000002, '  ', '{("")}', '   ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000003, '  ()', '{("")}', '  ()', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000004, '  ', '{("")}', '  ( )', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000005, ' ', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000006, ' ', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000007, '', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000008, ' ()', '{("")}', '   ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000009, ' ', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000010, ' ', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000011, ' ', '{("")}', '   ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000012, ' ', '{("")}', ' ', ' ', 0, 1900, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190000013, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190000014, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190000015, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190000016, '  ()', '{("")}', '  ()', ' ', 0, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001001, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001002, '   ()', '{("")}', '   ()', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001003, ' ', '{("")}', '   ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001013, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001029, '', '{("")}', '  . .', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001030, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001031, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001032, ' ()', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001033, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001034, '', '{("")}', ' ()', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001035, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 0, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001036, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001037, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001038, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190001039, ' ', '{("")}', ' ', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001040, ' ', '{("")}', '  ()', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001044, '', '{("")}', '', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190001046, '', '{("")}', ' ()', ' ', 0, 1900, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(190010017, '  ()', '{("")}', '  ()', ' ', 1, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011013, ' ', '{("")}', ' ', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011036, '', '{("")}', ' ()', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011042, ' ', '{("")}', ' ', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011043, ' ', '{("")}', '  ()', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011045, '', '{("")}', '', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011046, '', '{("")}', ' ()', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

--  (), (0)
CALL ImportField(190100021, '', 'DocStateName', '', 'DocStateName', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100056, ' ', 'CryptoStatus', 'CryptoStatus', 'CryptoStatus', 0, 1901, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(190100084, ' ', 'ID', 'ID', 'Id', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100088, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 0, 1901, 0, 0, '_', 0, null, 0, 1, '_') ;

CALL ImportField(190100093, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100094, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100095, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100141, '', 'Variant', '', 'Variant', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100142, ' ', 'NotifyType', ' ', 'NotifyType', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100143, ' ', 'Dat', ' ', 'Dat', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100145, ' ', 'DocDat', ' . ', 'DocDat', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100146, ' ', 'DocNumber', ' . ', 'DocNumber', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100147, ' ', 'Note1', ' ', 'Note1', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100148, ' ', 'Note2', ' ', 'Note2', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100149, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 1901, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(190100150, ' ()', 'DocBaseParent', ' ()', ' ', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100151, '', 'Number', '', 'Number', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100152, ' ', 'RejectCls', ' ', 'RejectCls', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100153, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 1901, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190100154, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100155, '    ', 'FUId', '    ', 'FUId', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100156, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100157, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100158, ' ', 'DateInput', ' ', 'DateInput', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100159, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100160, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100161, ' ', 'IsVised', ' ', 'IsVised', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100162, ' ', 'OrgName', ' ', 'DestOrgName', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100163, '', 'Note', '', 'Note', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100164, '', 'KPPERIOD', '', 'KPPERIOD', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100165, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 1901, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(190100166, '', 'BUDGETREF', '', 'BudgetRef', 0, 1901, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190100178, '  (.)', 'ClsType', ' ', 'ClsType', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100179, '/c ', 'FacialCode', '/c ', ' ', 0, 1901, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190100183, '  (.)', 'ProgIndex', '', 'ProgIndex', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100192, ' ()', 'OrgRef', '', 'DestOrgRef', 0, 1901, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190100211, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 1901, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190100212, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 1901, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190100213, '()', 'CREATERUSER', '()', ' ', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100214, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100215, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100216, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190100217, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 1901, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190100218, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 1901, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190101062, ' ', 'RECORDINDEX', 'RECORDINDEX', 'RecordIndex', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101089, '1-  ', 'CurMonth1', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101090, '2-  ', 'CurMonth2', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101091, '3-  ', 'CurMonth3', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101092, '  ', 'CurQuarter', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101096, '', 'Kfsr', '', 'DestKfsr', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101097, '', 'Kesr', '', 'DestKesrKey', 0, 1901, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190101098, '', 'KCSR', '', 'DestKcsr', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101099, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101100, '', 'Kvsr', '', 'DestKvsr', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101101, '', 'Kvr', '', 'DestKvr', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101102, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101103, ' ', 'Id', '* ', 'Id', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101104, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101106, ' ', 'RegionCls', ' ', 'RegionCls', 0, 1901, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190101107, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 1901, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190101108, '', 'FactCode', '', 'DestFactCls', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101109, '', 'Acc', '', 'DestAccountName', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101110, '', 'INN', '', 'DestOrgInn', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101111, '', 'INN20', '', 'DestOrgKpp', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101112, '', 'Name', '', 'DestOrgNAME', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101113, '', 'NOTE', '', 'NOTE', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101114, '', 'SubKESR', '', 'DestSubKesrKey', 0, 1901, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190101115, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101116, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101117, '    ', 'FUId', '    ', 'FUId', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101119, '', 'Month01', '', 'Month01', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101120, '', 'Month02', '', 'Month02', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101121, '', 'Month03', '', 'Month03', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101122, '', 'Month04', '', 'Month04', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101123, '', 'Month05', '', 'Month05', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101124, '', 'Month06', '', 'Month06', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101125, '', 'Month07', '', 'Month07', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101126, '', 'Month08', '', 'Month08', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101127, '', 'Month09', '', 'Month09', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101128, '', 'Month10', '', 'Month10', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101129, '', 'Month11', '', 'Month11', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101130, '', 'Month12', '', 'Month12', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101131, '4', 'Quarter4', '4', 'Quarter4', 0, 1901, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(190101132, '1', 'Quarter1', '1', 'Quarter1', 0, 1901, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(190101133, '2', 'Quarter2', '2', 'Quarter2', 0, 1901, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(190101134, '3', 'Quarter3', '3', 'Quarter3', 0, 1901, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(190101135, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101136, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101137, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101138, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101139, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101140, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101167, '', 'BUDGETREF', '', 'BUDGETREF', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101180, ' .  . . ()', 'IFS', ' ', 'IFS', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101181, '< >', 'KDCode', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101182, '< >', 'SubKD', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101183, ' .  . .', 'IFSCode', ' .  . .', 'IFS_FinSourceValue', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101184, '< >', 'KVSRCode', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101185, '< >', 'KCSRCode', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101186, '< >', 'KVRCode', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101187, '< >', 'KD', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101188, ' ()', 'OrgParent', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101189, '  ', 'ONYEAR', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101190, '', 'OnYearIncome', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101191, '', 'OnYearCharges', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101193, '  (.)', 'ProgIndex', '', 'ProgIndex', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101194, '  (.)', 'ClsType', '', 'ClsType', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101195, ' ', 'TargetCls', '', 'TargetClsKey', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101196, '  3 ', 'On3Year', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101197, '  3  ()', 'On3YearCharges', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101198, '  3  ()', 'On3YearIncome', '', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101199, '  / ()', 'Org_Ref', '', 'Org_Ref_Det', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101200, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101201, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101202, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101203, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101204, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101205, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101206, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190101207, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190101208, ' ()', 'FACT', '', 'DestFactClsKey', 0, 1901, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190101209, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 1901, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(190101210, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKEY', 0, 1901, 1, 1, '', 0, 17450, 0, 0, '') ;

CALL ImportField(190101211, '', 'InvestObject', '', 'InvestObjectKey', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101212, '', 'InvestObjectCode', '', 'InvestObject', 0, 1901, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190101213, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 1901, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190101214, '()', 'CREATERUSER', '()', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101215, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101216, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101217, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101218, '()', 'KESRCode', '()', 'DestKesr', 0, 1901, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190101220, '()', 'SubKESRCode', '()', 'DestSubKesr', 0, 1901, 1, 0, '', 0, 43610, 0, 1, '') ;

--  (), (1)
CALL ImportField(190110001, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 1901, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190110014, ' ', 'OrgName', ' ', 'DestOrgName', 1, 1901, 0, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(190110069, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 1901, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(190110074, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 1901, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(190110093, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 1901, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190110094, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 1901, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190111019, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1901, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190111048, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1901, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190111095, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1901, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190111099, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1901, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190111107, '', 'Kesr', '', 'DestKesrKey', 1, 1901, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190111113, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1901, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(190111114, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1901, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(190111219, '()', 'KESRCode', '()', 'DestKesr', 1, 1901, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190111221, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1901, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), (0)
CALL ImportField(190200021, '', 'DocStateName', '', 'DocStateName', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200033, ' ', 'CryptoStatus', 'CryptoStatus', 'CryptoStatus', 0, 1902, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(190200083, ' ', 'ID', ' ', 'Id', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200087, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 0, 1902, 0, 0, '_', 0, null, 0, 1, '_') ;

CALL ImportField(190200091, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200151, '', 'Variant', '', 'Variant', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200152, ' ', 'NotifyType', ' ', 'NotifyType', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200153, ' ', 'Dat', ' ', 'Dat', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200154, ' ', 'DocDat', ' . ', 'DocDat', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200155, ' ', 'DocNumber', ' . ', 'DocNumber', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200156, ' ', 'Note1', ' ', 'Note1', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200157, ' ', 'Note2', ' ', 'Note2', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200158, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 1902, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(190200159, ' ()', 'DocBaseParent', ' ()', ' ', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200160, '', 'Number', '', 'Number', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200161, ' ', 'RejectCls', ' ', 'RejectCls', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200162, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 1902, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190200163, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200164, '    ', 'FUId', '    ', 'FUId', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200165, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200166, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200167, ' ', 'DateInput', ' ', 'DateInput', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200168, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200169, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200170, ' ', 'IsVised', ' ', 'IsVised', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200171, ' ', 'OrgName', ' ', 'DestOrgName', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200172, '', 'Note', '', 'Note', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200173, '', 'KPPERIOD', '', 'KPPERIOD', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200174, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 1902, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(190200175, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200176, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200177, '', 'BUDGETREF', '', 'BudgetRef', 0, 1902, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190200178, '  (.)', 'ClsType', ' ', 'ClsType', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200179, '/c ', 'FacialCode', '/c ', ' ', 0, 1902, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190200183, '  (.)', 'ProgIndex', '', 'ProgIndex', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200192, ' ()', 'OrgRef', '', 'DestOrgRef', 0, 1902, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190200211, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 1902, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190200212, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 1902, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190200213, '()', 'CREATERUSER', '()', ' ', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200214, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200215, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200216, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190200217, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 1902, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190200218, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 1902, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190201031, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201088, '1-  ', 'CurMonth1', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201090, '3-  ', 'CurMonth3', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201092, '', 'Kfsr', '', 'DestKfsr', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201093, '', 'Kesr', '', 'DestKesrKey', 0, 1902, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190201094, '', 'KCSR', '', 'DestKcsr', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201096, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201097, '', 'Kvsr', '', 'DestKvsr', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201098, '', 'Kvr', '', 'DestKvr', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201108, '2-  ', 'CurMonth2', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201110, '  ', 'CurQuarter', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201111, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201112, ' ', 'Id', '* ', 'Id', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201113, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201114, '   .', 'Acc_ref', '   .', 'DestAccount', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201115, ' ', 'RegionCls', ' ', 'RegionCls', 0, 1902, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190201116, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 1902, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190201117, '', 'FactCode', '', 'DestFactCls', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201119, '', 'Acc', '', 'DestAccountName', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201120, '', 'INN', '', 'DestOrgInn', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201121, '', 'INN20', '', 'DestOrgKpp', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201123, '', 'Name', '', 'DestOrgNAME', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201124, '', 'NOTE', '', 'NOTE', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201125, '', 'SubKESR', '', 'DestSubKesrKey', 0, 1902, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190201126, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201127, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201128, '    ', 'FUId', '    ', 'FUId', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201129, '', 'Month01', '', 'Month01', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201130, '', 'Month02', '', 'Month02', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201131, '', 'Month03', '', 'Month03', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201132, '', 'Month04', '', 'Month04', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201133, '', 'Month05', '', 'Month05', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201134, '', 'Month06', '', 'Month06', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201135, '', 'Month07', '', 'Month07', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201136, '', 'Month08', '', 'Month08', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201137, '', 'Month09', '', 'Month09', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201138, '', 'Month10', '', 'Month10', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201139, '', 'Month11', '', 'Month11', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201140, '', 'Month12', '', 'Month12', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201141, '4', 'Quarter4', '4', 'Quarter4', 0, 1902, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(190201142, '1', 'Quarter1', '1', 'Quarter1', 0, 1902, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(190201143, '2', 'Quarter2', '2', 'Quarter2', 0, 1902, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(190201144, '3', 'Quarter3', '3', 'Quarter3', 0, 1902, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(190201145, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201146, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201147, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201148, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201149, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201150, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201178, '', 'BUDGETREF', '', 'BUDGETREF', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201180, ' .  . . ()', 'IFS', ' ', 'IFS', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201181, '< >', 'KDCode', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201182, '< >', 'SubKD', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201183, ' .  . .', 'IFSCode', ' .  . .', 'IFS_FinSourceValue', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201184, '< >', 'KVSRCode', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201185, '< >', 'KCSRCode', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201186, '< >', 'KVRCode', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201187, '< >', 'KD', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201188, ' ()', 'OrgParent', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201189, '  ', 'ONYEAR', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201190, '', 'OnYearIncome', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201191, '', 'OnYearCharges', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201193, '  (.)', 'ProgIndex', '', 'ProgIndex', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201194, '  (.)', 'ClsType', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201195, ' ', 'TargetCls', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201196, '  3 ', 'On3Year', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201197, '  3  ()', 'On3YearCharges', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201198, '  3  ()', 'On3YearIncome', '', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201199, '  / ()', 'Org_Ref', '', 'Org_Ref_Det', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201200, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201201, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201202, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201203, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201204, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201205, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201206, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190201207, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190201208, ' ()', 'FACT', '()', 'DestFactClsKey', 0, 1902, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190201209, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 1902, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(190201210, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 0, 1902, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(190201211, '', 'InvestObject', '', 'InvestObjectKey', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201212, '', 'InvestObjectCode', '', 'InvestObject', 0, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190201213, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 1902, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190201214, '()', 'CREATERUSER', '()', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201215, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201216, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201217, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201218, '()', 'KESRCode', '()', 'DestKesr', 0, 1902, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190201220, '()', 'SubKESRCode', '()', 'DestSubKesr', 0, 1902, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(190201224, ' ', 'TargetClsCode', 'TargetCls', 'TargetCls', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

--    (), (1)
CALL ImportField(190210015, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 1902, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(190210016, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 1902, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190210020, ' ', 'ProgIndex', 'ProgIndex', 'ProgIndex', 1, 1902, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(190210092, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 1902, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190210093, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 1902, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190211012, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1902, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190211071, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1902, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190211094, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1902, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190211098, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1902, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190211105, '', 'Kesr', '', 'DestKesrKey', 1, 1902, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190211219, '()', 'KESRCode', '()', 'DestKesr', 1, 1902, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190211221, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1902, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(190211222, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1902, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190211223, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1902, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (0)
CALL ImportField(190300085, ' ', 'ID', ' ', 'Id', 0, 1903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190300101, '', 'NUMBER', '', 'Number', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300102, ' ', 'OrgName', ' ', 'DestOrgName', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300111, '', 'Variant', '', 'Variant', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300113, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 1903, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(190300114, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 1903, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190300117, ' . ()', 'DOCDAT', ' . ()', 'DocDat', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300118, ' ', 'DateInput', ' ', 'DateInput', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300119, ' ', 'DAT', ' ', 'Dat', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300120, ' ', 'ProgIndex', 'ProgIndex', ' ', 0, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190300122, '', 'NOTIFYTYPE', '', 'NotifyType', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300123, '', 'BUDGETREF', '', 'BudgetRef', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300128, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300131, ' . ()', 'DOCNUMBER', ' . ()', 'DocNumber', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300133, ' ', 'ORGREF', ' ', 'DestOrgRef', 0, 1903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190300134, '()', 'NOTE', '()', 'Note', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300135, ' ()', 'NOTE2', ' ()', 'Note2', 0, 1903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190300137, ' ', 'NOTE1', ' ', 'Note1', 0, 1903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190300138, '  ', 'REJECTCLS', '  ', 'RejectCls', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300139, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 1903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190300157, '', 'DocStateRef', 'DocStateRef', 'DocStateRef', 0, 1903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190300158, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 1903, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(190300165, ' ()', 'DocBaseParent', ' ()', ' ', 0, 1903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190300168, '', 'KPPERIOD', '', 'KPPeriod', 0, 1903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190300189, '  ()', 'DocBase', '  ()', 'DocBaseKey', 0, 1903, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190300190, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 1903, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190300191, '()', 'CREATERUSER', '()', ' ', 0, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190300192, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190300193, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190300194, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190300195, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 1903, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190300196, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 1903, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190301030, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301103, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301104, ' ', 'OrgParent', ' ', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301105, '( )', 'INN', '( )', 'DestOrgInn', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301106, '( )', 'INN20', '( )', 'DestOrgKpp', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301107, '( )', 'NAME', '( )', 'DestOrgNAME', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301110, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301112, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301121, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301124, '', 'BUDGETREF', '', 'BUDGETREF', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301125, ' ', 'ID', ' ', 'Id', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301127, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301129, '', 'FACTCODE', '', 'DestFactCls', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301130, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301132, '', 'Org_ref', 'Org_ref', 'Org_Ref_Det', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301136, '', 'NOTE', '', 'NOTE', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301140, ' ', 'REGIONCLS', '', 'RegionCls', 0, 1903, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190301141, '', 'Month08', '', 'Month08', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301142, '', 'Month04', '', 'Month04', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301143, '', 'Month12', '', 'Month12', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301144, '', 'Month07', '', 'Month07', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301145, '', 'Month06', '', 'Month06', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301146, ' 1', 'QUARTER1', ' 1', 'Quarter1', 0, 1903, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(190301147, ' 2', 'QUARTER2', ' 2', 'Quarter2', 0, 1903, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(190301148, ' 3', 'QUARTER3', ' 3', 'Quarter3', 0, 1903, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(190301149, ' 4', 'QUARTER4', ' 4', 'Quarter4', 0, 1903, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(190301150, '', 'Month05', '', 'Month05', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301151, '', 'Month03', '', 'Month03', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301152, '', 'Month11', '', 'Month11', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301153, '', 'Month10', '', 'Month10', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301154, '', 'Month09', '', 'Month09', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301155, '', 'Month02', '', 'Month02', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301156, '', 'Month01', '', 'Month01', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301159, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301160, ' . ', 'FINTYPECODE', '  ', 'DestFINTYPECls', 0, 1903, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(190301162, ' ', 'IFS', ' ', 'IFS', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301164, '  ', 'IFSCode', '  ( )', 'IFS_FinSourceValue', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301169, '1-  ', 'CurMonth1', '1-  ', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301170, '2-  ', 'CurMonth2', '2-  ', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301171, '3-  ', 'CurMonth3', '3-  ', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301172, '  ', 'CurQuarter', '  ', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301176, '  ', 'TransfertCls', '  ', 'TransfertCls', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301177, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301178, ' ', 'ClsType', ' ', 'ClsType', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301180, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301181, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301182, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301183, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190301184, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301185, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 0, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190301186, ' ()', 'FACT', '', 'DestFactClsKey', 0, 1903, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190301187, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 0, 1903, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(190301188, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 0, 1903, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(190301189, '', 'InvestObject', '', 'InvestObjectKey', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301190, '', 'InvestObjectCode', '', 'InvestObject', 0, 1903, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190301191, '', 'Kesr', '', 'DestKesrKey', 0, 1903, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190301192, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 1903, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190301193, '()', 'CREATERUSER', '()', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301194, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301195, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301196, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190301198, '()', 'KESRCode', '()', 'DestKesr', 0, 1903, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190301200, '()', 'SubKESRCode', '()', 'DestSubKesr', 0, 1903, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(190301201, '', 'SubKESR', '', 'DestSubKesrKey', 0, 1903, 1, 1, '', 0, 17416, 0, 1, '') ;

--   (), (1)
CALL ImportField(190310013, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 1903, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(190310014, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 1903, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(190310093, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 1903, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190310094, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 1903, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190311010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1903, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190311070, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1903, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190311095, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1903, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190311099, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1903, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190311106, '', 'Kesr', '', 'DestKesrKey', 1, 1903, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190311109, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1903, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(190311110, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1903, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(190311197, '()', 'KESRCode', '()', 'DestKesr', 1, 1903, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190311199, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1903, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), (0)
CALL ImportField(190600087, ' ', 'ID', ' ', 'Id', 0, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190600088, '()', 'CREATERUSER', '()', ' ', 0, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190600089, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190600090, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190600091, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601031, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601032, '', 'InvestObject', '', ' ', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601033, '', 'InvestObjectCode', '', ' ', 0, 1906, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190601034, '', 'Kesr', '', 'DestKesrKey', 0, 1906, 1, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(190601035, '()', 'CREATERUSER', '()', ' ', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601036, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601037, '  ()', 'CREATEDATE', '  ()', ' ', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601038, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190601112, '()', 'KESRCode', '()', 'DestKesr', 0, 1906, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(190601114, '()', 'SubKESRCode', '()', 'DestSubKesr', 0, 1906, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(190601115, '', 'SubKESR', '', 'DestSubKesrKey', 0, 1906, 1, 1, '', 0, 17416, 0, 0, '') ;

--    (), (1)
CALL ImportField(190610014, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 1906, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(190610015, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 1906, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(190610094, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 1906, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190610095, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 1906, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190611011, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1906, 1, 1, '', 0, 17451, 0, 0, '') ;

CALL ImportField(190611071, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1906, 1, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(190611097, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1906, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(190611101, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1906, 1, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(190611108, '', 'Kesr', '', 'DestKesrKey', 1, 1906, 1, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(190611111, '()', 'KESRCode', '()', 'DestKesr', 1, 1906, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(190611113, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1906, 1, 0, '', 0, 43610, 0, 0, '') ;

--   (), (0)
CALL ImportField(220000001, ' ', '{("")}', ' () ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000002, '  ', '{("")}', '   ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000003, '  ()', '{("")}', '  ()', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000004, '  ', '{("")}', '  ( )', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000005, ' ', '{("")}', ' ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000006, ' ', '{("")}', ' ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000007, '', '{("")}', ' ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000008, ' ', '{("")}', ' ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000010, ' ', '{("")}', ' ', ' ', 0, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220000011, ' ', '{("")}', '   ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000012, ' ', '{("")}', ' ', ' ', 0, 2200, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220000013, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220000014, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220000015, '  ()', 'CREATEDATE', '  ()', ' ', 0, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220000016, '  ()', '{("")}', '  ()', ' ', 0, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001009, ' ', '{("")}', '  ()', ' ', 0, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001010, '', '{("")}', ' ()', ' ', 0, 2200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220001011, '()', 'CREATERUSER', '()', ' ', 0, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001012, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001013, '  ()', 'CREATEDATE', '  ()', ' ', 0, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001014, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220001017, '', '{("")}', '', ' ', 0, 2200, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(220010017, '  ()', '{("")}', '  ()', ' ', 1, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011010, '', '{("")}', ' ()', ' ', 1, 2200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220011018, '', '{("")}', '', ' ', 1, 2200, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (0)
CALL ImportField(220100001, '', 'KPPERIOD', '', 'KPPERIOD', 0, 2201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220100002, '', 'Note', '', 'Note', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100003, ' ', 'DateInput', ' ', 'DateInput', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100004, '', 'Variant', '', 'Variant', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100005, ' ', 'RejectCls', ' ', 'RejectCls', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100006, ' ', 'NotifyType', ' ', 'NotifyType', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100007, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 0, 2201, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(220100008, ' ', 'Dat', ' ', 'Dat', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100009, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100010, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100011, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100012, ' ', 'DocDat', ' . ', 'DocDat', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100013, '    ', 'FUId', '    ', 'FUId', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100014, ' ', 'Id', ' ', 'Id', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100015, ' ', 'DocSuspended', '* ', 'DocSuspended', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100016, ' ', 'BeginDocStateRef', ' ', 'BeginDocStateRef', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100017, '  ()', 'SoftRejectCause', '  ()', 'SoftRejectCause', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100018, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 0, 2201, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(220100019, ' ', 'DocNumber', ' . ', 'DocNumber', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100020, ' ', 'Note1', ' ', 'Note1', 0, 2201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220100021, ' ', 'Note2', ' ', 'Note2', 0, 2201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220100022, ' ', 'DocStateRef', ' ', 'DocStateRef', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100023, ' ', 'IsVised', ' ', 'IsVised', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100024, ' ', 'DocBaseCode', ' ', 'DocBase', 0, 2201, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(220100025, ' ()', 'DocBaseParent', ' ()', ' ', 0, 2201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220100026, '', 'Number', '', 'Number', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100027, ' ()', 'RejectNote', ' ()', 'RejectCause', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100028, ' ', 'OrgName', ' ', 'DestOrgName', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100067, 'CryptoStatus', 'CryptoStatus', 'CryptoStatus', 'CRYPTOSTATUS', 0, 2201, 0, 1, '', 0, 17490, 0, 1, '') ;

CALL ImportField(220100097, '', 'DocStateName', '', 'DocStateName', 0, 2201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220100108, '', 'BUDGETREF', '', 'BudgetRef', 0, 2201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220100123, '< >', 'ProgIndex', '', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100162, '< >', 'Ba_Lbo_Flag', '', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100163, '  (.)', 'ClsType', '', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100165, '/c ', 'FacialCode', '', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100166, '', 'OrgRef', '', 'DestOrgRef', 0, 2201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220100207, '  ()', 'DOCBASE', '  ()', 'DocBaseKey', 0, 2201, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(220100208, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 2201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(220100209, '()', 'CREATERUSER', '()', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100210, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100211, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100212, '  ()', 'CREATEDATE', '  ()', ' ', 0, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220100213, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 0, 2201, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(220100214, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 0, 2201, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(220101056, '. ', 'SUBKD', '. ', 'SubKd', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101057, '  ()', 'KD', '  ()', 'KD', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101058, '  ', 'CurQuarter', '', ' ', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101059, '1-  ', 'CurMonth1', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101060, '2-  ', 'CurMonth2', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101061, '3-  ', 'CurMonth3', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101063, '4', 'Quarter4', '4', 'Quarter4', 0, 2201, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(220101065, '   ', 'SummaYear1', '   ', 'SummaYear1', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101066, '   ', 'SummaYear2', '   ', 'SummaYear2', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101067, '    ', 'FUId', '    ', 'FUId', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101068, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101069, '   .', 'Acc_ref', '   .', 'DestAccount', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101070, '', 'NOTE', '', 'NOTE', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101071, ' ', 'AssignmentKind', '  ', 'AssignmentKind', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101072, ' ', 'Id', '* ', 'Id', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101073, ' ', 'KESRCorr', ' ', 'KESRCorr', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101074, '  ', 'RecordIndex', '  ', 'RecordIndex', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101075, ' ', 'RegionCls', ' ', 'RegionCls', 0, 2201, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(220101076, '1', 'Quarter1', '1', 'Quarter1', 0, 2201, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(220101077, '   ', 'SummaYear3', '   ', 'SummaYear3', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101078, '2', 'Quarter2', '2', 'Quarter2', 0, 2201, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(220101079, '3', 'Quarter3', '3', 'Quarter3', 0, 2201, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(220101080, '', 'Kfsr', '', 'DestKfsr', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101081, '', 'Kesr', '', 'DestKesrKey', 0, 2201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(220101082, '', 'KCSR', '', 'DestKcsr', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101083, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101084, '', 'Kvsr', '', 'DestKvsr', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101085, '', 'Kvr', '', 'DestKvr', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101086, '', 'SubKESR', '', 'DestSubKesrKey', 0, 2201, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(220101087, '', 'DirectionClsCode', '', 'DestDirectionCLS', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101088, ' . ', 'FinTypeCode', '  ', 'DestFINTYPECls', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101089, '', 'FactCode', '', 'DestFactCls', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101090, '', 'Acc', '', 'DestAccountName', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101091, '', 'INN', '', 'DestOrgInn', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101092, '', 'INN20', '', 'DestOrgKpp', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101093, '', 'Name', '', 'DestOrgNAME', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101094, '  ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101095, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101096, '', 'Month01', '', 'Month01', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101097, '', 'Month02', '', 'Month02', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101098, '', 'Month03', '', 'Month03', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101099, '', 'Month04', '', 'Month04', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101100, '', 'Month05', '', 'Month05', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101101, '', 'Month06', '', 'Month06', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101102, '', 'Month07', '', 'Month07', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101103, '', 'Month08', '', 'Month08', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101104, '', 'Month09', '', 'Month09', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101105, '', 'Month10', '', 'Month10', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101106, '', 'Month11', '', 'Month11', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101107, '', 'Month12', '', 'Month12', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101109, '', 'BUDGETREF', '', 'BudgetRef', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101110, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101111, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101180, ' .  . . ()', 'IFS', ' ', 'DestIFS', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101183, ' .  . .', 'IFSCode', ' .  . .', 'DestIFS_DescriptionCode', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101184, '', 'OrgParent', '', ' ', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101186, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 2201, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(220101187, '< >', 'OnYearIncome', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101188, '< >', 'On3Year', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101189, '< >', 'On3YearCharges', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101190, '< >', 'On3YearIncome', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101192, '< >', 'OnYearCharges', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101193, ' ()', 'Org_Ref', '', 'Org_Ref_Det', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101195, '  (.)', 'ClsType', '', 'ClsType', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101196, '  ', 'ONYEAR', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101197, '', 'KVRCode', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101198, '', 'KCSRCode', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101199, '', 'KVSRCode', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101200, ' ', 'KDCode', ' ', 'KDValue', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101201, ' ', 'ProgIndex', '', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101202, ' ', 'SubsidyCls', '', 'SubsidyCls', 0, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220101203, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 0, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220101204, ' ()', 'Fact', '', 'DestFactClsKey', 0, 2201, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(220101205, ' .  ()', 'FinType', '  ', 'DestFINTYPEKey', 0, 2201, 1, 1, '', 0, 17425, 0, 0, '') ;

CALL ImportField(220101206, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 0, 2201, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(220101207, '', 'InvestObject', '', 'InvestObjectKey', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101208, '', 'InvestObjectCode', '', 'InvestObject', 0, 2201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220101209, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 2201, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(220101210, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 2201, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(220101211, '()', 'CREATERUSER', '()', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101212, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101213, '  ()', 'CREATEDATE', '  ()', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101214, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220101215, '()', 'KESRCode', '()', 'DestKesr', 0, 2201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(220101217, '()', 'SubKESRCode', '()', 'DestSubKesr', 0, 2201, 1, 0, '', 0, 43610, 0, 1, '') ;

--   (), (1)
CALL ImportField(220110043, ' ', 'PlanDocTypeCode', ' ', 'PlanDocType', 1, 2201, 0, 0, '', 0, 46130, 0, 1, '') ;

CALL ImportField(220110052, ' ', 'AssignmentSourceCode', ' ', 'AssignmentSource', 1, 2201, 0, 0, '', 0, 46136, 0, 1, '') ;

CALL ImportField(220110076, '  ()', 'PlanDocType', '  ()', 'PlanDocTypeKey', 1, 2201, 0, 1, '', 0, 17487, 0, 1, '') ;

CALL ImportField(220110077, '  ()', 'AssignmentSource', '  ()', 'AssignmentSourceKey', 1, 2201, 0, 1, '', 0, 17501, 0, 1, '') ;

CALL ImportField(220111047, '', 'BUDGETREF', '', 'BudgetRef', 1, 2201, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(220111080, '', 'Kesr', '', 'DestKesrKey', 1, 2201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(220111216, '()', 'KESRCode', '()', 'DestKesr', 1, 2201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(220111218, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 2201, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(220111219, '', 'SubKESR', '', 'DestSubKesrKey', 1, 2201, 1, 1, '', 0, 17416, 0, 1, '') ;

--  , +(2)
CALL ImportField(250110023, ' ', 'protocolDocTypeText', ' ', ' ', 2, 2501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250112003, '', 'KFSR', '', 'KFSR', 2, 2501, 2, 0, '', 0, 20225, 0, 0, '') ;

CALL ImportField(250112004, '', 'KESR', '', 'KESRKey', 2, 2501, 2, 1, '', 0, 20226, 0, 0, '') ;

CALL ImportField(250112005, '', 'KVR', '', 'KVRKey', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112006, '', 'KCSR', '', 'KCSRKey', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112007, '', 'KVSR', '', 'KVSRKey', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112010, '', 'KVRCode', '', 'KVR', 2, 2501, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(250112011, '', 'KCSRCode', '', 'KCSR', 2, 2501, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(250112012, '', 'KVSRCode', '', 'KVSR', 2, 2501, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(250112078, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 2501, 2, 1, '', 0, 40887, 0, 0, '') ;

CALL ImportField(250112094, '()', 'KESRCode', '()', 'KESR', 2, 2501, 2, 0, '', 0, 43607, 0, 0, '') ;

--  , +(2)
CALL ImportField(250210002, '  ', 'Summa', '', 'Summa', 2, 2502, 0, 0, '', 0, 19797, 0, 1, 'Summa') ;

CALL ImportField(250210004, ' ', 'ReviewNote', '', 'ReviewNote', 2, 2502, 0, 0, '', 0, 19845, 0, 1, 'ReviewNote') ;

CALL ImportField(250210007, '', 'Region', '', 'Region', 2, 2502, 0, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250210008, ' ', 'ReestrNumber', '', 'ReestrNumber', 2, 2502, 0, 0, '', 0, 19830, 0, 1, 'ReestrNumber') ;

CALL ImportField(250210009, ' ', 'PaymentDate', '', 'PaymentDate', 2, 2502, 0, 0, '', 0, 19831, 0, 1, 'PaymentDate') ;

CALL ImportField(250210010, '', 'Note', '', 'Note', 2, 2502, 0, 0, '', 0, 19821, 0, 1, 'Note') ;

CALL ImportField(250210011, '      ', 'FinCardAdvance', '', 'FinCardAdvance', 2, 2502, 0, 0, '', 0, 19833, 0, 1, 'FinCardAdvance') ;

CALL ImportField(250210012, '', 'FactCode', '', 'Fact', 2, 2502, 0, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250210014, '/c ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2502, 0, 0, '', 0, 19803, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250210015, ' ', 'ExecuterName', '', 'Executer_Name', 2, 2502, 0, 0, '', 0, 24613, 0, 1, 'Executer_Name') ;

CALL ImportField(250210016, ' ', 'ExecuterKPP', '', 'Executer_INN20', 2, 2502, 0, 0, '', 0, 24612, 0, 1, 'Executer_INN20') ;

CALL ImportField(250210017, ' ', 'ExecuterINN', '', 'Executer_INN', 2, 2502, 0, 0, '', 0, 24611, 0, 1, 'Executer_INN') ;

CALL ImportField(250210019, ' ', 'DocNumber', '', 'DocNumber', 2, 2502, 0, 0, '', 0, 19798, 0, 1, 'DocNumber') ;

CALL ImportField(250210020, ' ', 'DeliveryRules', '', 'DeliveryRules', 2, 2502, 0, 0, '', 0, 19825, 0, 1, 'DeliveryRules') ;

CALL ImportField(250210023, ' ', 'CloseDate', '', 'CloseDate', 2, 2502, 0, 0, '', 0, 19824, 0, 1, 'CloseDate') ;

CALL ImportField(250210024, ' ', 'ClientName', '', 'Client_Name', 2, 2502, 0, 0, '', 0, 24608, 0, 1, 'Client_Name') ;

CALL ImportField(250210025, ' ', 'ClientKPP', '', 'Client_INN20', 2, 2502, 0, 0, '', 0, 24607, 0, 1, 'Client_INN20') ;

CALL ImportField(250210026, ' ', 'ClientINN', '', 'Client_INN', 2, 2502, 0, 0, '', 0, 24606, 0, 1, 'Client_INN') ;

CALL ImportField(250210029, ' ', 'CardAdvancePercent', '', 'CardAdvancePercent', 2, 2502, 0, 0, '', 0, 19807, 0, 1, 'CardAdvancePercent') ;

CALL ImportField(250210030, '  ', 'CardAdvance', '', 'CardAdvance', 2, 2502, 0, 0, '', 0, 19808, 0, 1, 'CardAdvance') ;

CALL ImportField(250210031, ' ', 'AgreementType', '', 'AgreementType', 2, 2502, 0, 1, '', 0, null, 0, 1, 'AgreementType') ;

CALL ImportField(250210033, ' ', 'AgreementSumma', '', 'AgreementSumma', 2, 2502, 0, 0, '', 0, 19826, 0, 1, 'AgreementSumma') ;

CALL ImportField(250210034, '     ', 'AgreementFinSumma', '', 'AgreementFinSumma', 2, 2502, 0, 0, '', 0, 19827, 0, 1, 'AgreementFinSumma') ;

CALL ImportField(250210035, ' ', 'AgreementEndDate', '', 'AgreementEndDate', 2, 2502, 0, 0, '', 0, 19800, 0, 1, 'AgreementEndDate') ;

CALL ImportField(250210036, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2502, 0, 0, '', 0, 19799, 0, 1, 'AgreementDate') ;

CALL ImportField(250210037, ' ', 'AgreementCardAdvance', '', 'AgreementCardAdvance', 2, 2502, 0, 0, 'AgreementCardAdvance', 0, 19832, 0, 1, 'AgreementCardAdvance') ;

CALL ImportField(250210038, ' ', 'AgreementBeginDate', '', 'AgreementBeginDate', 2, 2502, 0, 0, '', 0, 19841, 0, 1, 'AgreementBeginDate') ;

CALL ImportField(250210042, ' ', 'PurportDoc', '', 'PurportDoc', 2, 2502, 0, 0, '', 0, 19849, 0, 1, 'PurportDoc') ;

CALL ImportField(250210043, '  ', 'UnknownAmount', '', 'UnknownAmount', 2, 2502, 0, 0, ',', 0, 19869, 0, 1, 'UnknownAmount') ;

CALL ImportField(250210044, ' ', 'ExecuterAccName', '', 'ExecuterAccName', 2, 2502, 0, 0, '', 0, 17112, 0, 1, 'ExecuterAccRef') ;

CALL ImportField(250210045, ' ', 'ExecuterCountry', ' ', 'Executer_Country', 2, 2502, 0, 0, '', 0, 24610, 0, 1, 'Executer_Country') ;

CALL ImportField(250210047, ' ', 'ExecuterPhone', ' ', 'Executer_Phone', 2, 2502, 0, 0, '', 0, 24614, 0, 1, 'Executer_Phone') ;

CALL ImportField(250210048, ' ', 'ExecuterStatus', ' ', 'Executer_Status', 2, 2502, 0, 0, '', 0, 24615, 0, 1, 'Executer_Status') ;

CALL ImportField(250210050, 'Executer_Ref', 'Executer_Ref', '', 'Executer_Ref', 2, 2502, 0, 1, '', 0, null, 0, 1, 'Executer_Ref') ;

CALL ImportField(250210051, 'Client_Ref', 'Client_Ref', '', 'Client_Ref', 2, 2502, 0, 1, '', 0, null, 0, 1, 'Client_Ref') ;

CALL ImportField(250210052, 'EXECUTERACCREF', 'EXECUTERACCREF', '', 'EXECUTERACCREF', 2, 2502, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF') ;

CALL ImportField(250210053, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2502, 0, 0, '', 0, 29903, 0, 1, 'InfoNumber') ;

CALL ImportField(250210054, '   ', 'AdjustmentRef', '', 'AdjustmentRef', 2, 2502, 0, 1, '', 1, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250210057, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2502, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250210058, ' ()', 'Fact', '', 'FactKey', 2, 2502, 0, 1, '', 0, 19822, 0, 1, 'FactKey') ;

CALL ImportField(250210064, 'ID', 'ID', '', 'ID', 2, 2502, 0, 1, ',', 0, null, 0, 1, 'ID') ;

CALL ImportField(250210067, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210068, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210074, '.  ', 'StoredContent', '', 'StoredContent', 2, 2502, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250210075, ' ', 'DocumentNumber', '', 'DocumentNumber', 2, 2502, 0, 0, '', 0, null, 0, 1, 'DocumentNumber') ;

CALL ImportField(250210076, ' ', 'CloseDoc', ' ', 'CloseDoc', 2, 2502, 0, 0, '', 0, null, 0, 1, 'CloseDoc') ;

CALL ImportField(250210077, ' ', 'InnerNumber', ' ', 'InnerNumber', 2, 2502, 0, 1, '', 0, null, 0, 1, 'InnerNumber') ;

CALL ImportField(250210078, ' ', 'AdjustmentNumber', ' ', 'AdjustmentNumber', 2, 2502, 0, 1, '', 0, null, 0, 1, 'AdjustmentNumber') ;

CALL ImportField(250210079, '  ', 'AdjustmentDocNumber', '  ', 'AdjustmentDocNumber', 2, 2502, 0, 1, '', 0, null, 0, 1, 'AdjustmentDocNumber') ;

CALL ImportField(250210080, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 2502, 0, 1, '', 0, null, 0, 1, 'LastAccepted') ;

CALL ImportField(250210081, ' ', 'DocStateRef', ' ', 'DocStateRef', 2, 2502, 0, 1, '', 0, null, 0, 1, 'DocStateRef') ;

CALL ImportField(250210082, '    ', 'NotifyDate', '    ', 'NotifyDate', 2, 2502, 0, 0, '', 0, null, 0, 1, 'NotifyDate') ;

CALL ImportField(250210083, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 2502, 0, 1, ',', 0, null, 0, 0, 'ProgIndex') ;

CALL ImportField(250210084, '    ', 'TreasurySupportID', '', 'TreasurySupportID', 2, 2502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250211004, ' ', 'ANumber', '', 'ANumber', 2, 2502, 1, 0, '', 0, 20109, 0, 1, 'ANumber') ;

CALL ImportField(250212002, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250212004, '', 'SubKESR', '', 'SubKESRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'SubKESRKey') ;

CALL ImportField(250212005, '', 'Region', '', 'Region', 2, 2502, 2, 0, ',', 0, null, 0, 1, 'Region') ;

CALL ImportField(250212010, ' ', 'PromiseType', '', 'PromiseType', 2, 2502, 2, 0, '', 0, null, 0, 1, 'PromiseType') ;

CALL ImportField(250212011, '  ', 'ParentNumber', '', 'ParentNumber', 2, 2502, 2, 1, '', 0, null, 0, 1, 'ParentNumber') ;

CALL ImportField(250212025, ' ', 'MeansType', '', 'MeansType', 2, 2502, 2, 0, '', 0, null, 0, 1, 'MeansType') ;

CALL ImportField(250212026, '', 'KVSR', '', 'KVSRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250212027, '', 'KVR', '', 'KVRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250212028, '', 'KFSR', '', 'KFSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250212029, '', 'KESR', '', 'KESRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250212030, '', 'KCSR', '', 'KCSRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250212031, ' . ', 'FinTypeCode', '', 'FinType', 2, 2502, 2, 0, ',', 0, null, 0, 1, 'FinType') ;

CALL ImportField(250212032, ' ', 'FinSource', '', 'FinSource', 2, 2502, 2, 0, '', 0, null, 0, 1, 'FinSource') ;

CALL ImportField(250212033, '', 'FactCode', '', 'Fact', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Fact') ;

CALL ImportField(250212035, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2502, 2, 0, ',', 0, null, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250212036, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250212037, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 2, 2502, 2, 0, '', 0, null, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250212040, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250212041, '', 'KVSRCode', '', 'KVSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250212042, '', 'KVRCode', '', 'KVR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250212043, '', 'KCSRCode', '', 'KCSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250212045, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250212046, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250212050, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2502, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250212051, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2502, 2, 0, '', 0, null, 0, 1, 'DirectionCls') ;

CALL ImportField(250212052, ' ()', 'Fact', '', 'FactKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'FactKey') ;

CALL ImportField(250212053, ' . ', 'FinType', '', 'FinTypeKey', 2, 2502, 2, 1, ',', 0, null, 0, 1, 'FinTypeKey') ;

CALL ImportField(250212054, '', 'InvestObject', '', 'InvestObjectKey', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212055, '', 'InvestObjectCode', '', 'InvestObject', 2, 2502, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250212056, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2502, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250212057, '', 'ContractCostsClsCode', '', 'ContractCostsClsCode', 2, 2502, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250212058, '', 'ContractCostsCls', '', 'ContractCostsCls', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212062, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2502, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250212063, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2502, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250212075, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2502, 2, 1, '', 0, 27829, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250212076, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2502, 2, 1, '', 0, null, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250212077, '   ()', 'TransfertCls', '   ()', 'TransfertCls', 2, 2502, 2, 1, '', 0, 22774, 0, 1, 'TransfertCls') ;

CALL ImportField(250212078, ' ', 'AssignmentKind', ' ', 'AssignmentKind', 2, 2502, 2, 1, '', 0, null, 0, 1, 'AssignmentKind') ;

CALL ImportField(250212079, '  ', 'InnerPromiseNum', '  ', 'InnerPromiseNum', 2, 2502, 2, 1, '', 0, null, 0, 1, 'InnerPromiseNum') ;

CALL ImportField(250212080, '   ', 'AdjustmentRef', '   ', 'AdjustmentRef', 2, 2502, 2, 1, '', 0, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250212081, '  ', 'AdjustmentNumber', '  ', 'AdjustmentNumber', 2, 2502, 2, 1, '', 0, null, 0, 1, 'AdjustmentNumber') ;

CALL ImportField(250212082, '   ', 'LastAdjustment', '   ', 'LastAdjustment', 2, 2502, 2, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250212083, '    ', 'OldNumber', '    ', 'OldNumber', 2, 2502, 2, 1, '', 0, null, 0, 1, 'OldNumber') ;

CALL ImportField(250212090, '()', 'KESRCode', '', 'KESR', 2, 2502, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250212091, '()', 'SubKESRCode', '', 'SubKESR', 2, 2502, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

CALL ImportField(250212092, '', 'Note', '', 'Note', 2, 2502, 2, 0, '', 0, 20297, 0, 1, 'Note') ;

CALL ImportField(250212093, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 2502, 2, 1, '', 0, null, 0, 1, 'ProgIndex') ;

CALL ImportField(250212094, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 2502, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250212095, '   ()', 'PayTargetFunds', '   ', ' ', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250213009, '', 'Amount', '', 'Amount', 2, 2502, 3, 0, '', 0, null, 0, 1, 'Amount') ;

--   , +(2)
CALL ImportField(250310006, ' ', 'Summa', '', 'Summa', 2, 2503, 0, 0, ',', 0, 19744, 0, 1, 'Summa') ;

CALL ImportField(250310007, '  ', 'StepNumber', '', 'StepNumber', 2, 2503, 0, 0, '', 0, 19752, 0, 1, 'StepNumber') ;

CALL ImportField(250310016, ' ', 'RegistrationType', '', 'RegistrationType', 2, 2503, 0, 0, '', 0, null, 0, 1, 'RegistrationType') ;

CALL ImportField(250310025, '', 'Note', '', 'Note', 2, 2503, 0, 0, '', 0, 19762, 0, 1, 'Note') ;

CALL ImportField(250310027, '  ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2503, 0, 0, ',', 0, 19754, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250310029, ' ', 'DocumentDate', '', 'DocumentDate', 2, 2503, 0, 0, ',', 0, 19740, 0, 1, 'DocumentDate') ;

CALL ImportField(250310030, ' ', 'DocType', '', 'DocType', 2, 2503, 0, 0, '', 0, 19738, 0, 1, 'DocType') ;

CALL ImportField(250310031, ' ', 'DocNumber', '', 'DocNumber', 2, 2503, 0, 0, ',', 0, 19739, 0, 1, 'DocNumber') ;

CALL ImportField(250310034, ' ', 'AgreementNumber', '', 'AgreementNumber', 2, 2503, 0, 0, '', 0, 19798, 0, 1, 'AgreementNumber') ;

CALL ImportField(250310035, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'AgreementDate') ;

CALL ImportField(250310036, '  ', 'AcceptDate', '', 'AcceptDate', 2, 2503, 0, 0, '', 0, 19741, 0, 1, 'AcceptDate') ;

CALL ImportField(250310039, ' ', 'ExecSumms', '', ' ', 2, 2503, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250310041, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2503, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250310043, '  / ', 'SupplierAcc_Ref', '', 'Supplieracc_ref', 2, 2503, 0, 1, ',', 0, 17109, 0, 1, 'Supplieracc_ref') ;

CALL ImportField(250310044, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'InfoNumber') ;

CALL ImportField(250310045, ' ', 'NotifyDate', '', 'NotifyDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'NotifyDate') ;

CALL ImportField(250310046, ' ', 'MoneyPromiseNumber', '', 'MoneyPromiseNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'MoneyPromiseNumber') ;

CALL ImportField(250310047, ' ', 'PurportDoc', '', 'PurportDoc', 2, 2503, 0, 0, '', 0, null, 0, 1, 'PurportDoc') ;

CALL ImportField(250310048, '  ', 'SupplierStoredProps', '', 'SupplierStoredProps', 2, 2503, 0, 0, '', 0, null, 0, 1, 'SupplierStoredProps') ;

CALL ImportField(250310049, 'ID', 'ID', '', 'ID', 2, 2503, 0, 1, ',', 0, null, 0, 1, 'ID') ;

CALL ImportField(250310062, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2503, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250310068, '.  ', 'StoredContent', '', 'StoredContent', 2, 2503, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250310076, ' ', 'AutoPayType', ' ', 'AutoPayType', 2, 2503, 0, 0, '', 0, 43489, 0, 1, '') ;

CALL ImportField(250310077, ' ', 'PayDate', '', 'PayDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'PayDate') ;

CALL ImportField(250310078, '   ()', 'AutoSanction', '', 'AutoSanction', 2, 2503, 0, 0, '', 0, null, 0, 1, 'AutoSanction') ;

CALL ImportField(250310079, '  ', 'AutoSanctionCode', '', ' ', 2, 2503, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250310080, '', 'Recipient_OrgRef', '', 'Recipient_Ref', 2, 2503, 0, 1, '', 0, null, 0, 1, 'Recipient_OrgRef') ;

CALL ImportField(250310081, '', 'Supplier_ORGRef', '', 'Supplier_Ref', 2, 2503, 0, 1, '', 0, null, 0, 1, 'Supplier_ORGRef') ;

CALL ImportField(250310082, ' ', 'DocStateRef', ' ', 'DocStateRef', 2, 2503, 0, 1, ',', 0, null, 0, 1, 'DocStateRef') ;

CALL ImportField(250310083, ' ', 'InnerNumber', ' ', 'InnerNumber', 2, 2503, 0, 1, '', 0, null, 0, 1, 'InnerNumber') ;

CALL ImportField(250310084, ' ', 'AdjustmentNumber', ' ', 'AdjustmentNumber', 2, 2503, 0, 1, '', 0, null, 0, 0, 'AdjustmentNumber') ;

CALL ImportField(250310085, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 2503, 0, 1, '', 0, null, 0, 1, 'LastAccepted') ;

CALL ImportField(250312002, ' ', 'ANumber', '', 'ANumber', 2, 2503, 2, 0, '', 0, 20223, 0, 1, 'ANumber') ;

CALL ImportField(250312003, ' ', 'BuhOperationCls', '', 'BuhOperationCls', 2, 2503, 2, 0, '', 0, 20279, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250312004, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2503, 2, 0, '', 0, 36861, 0, 1, 'DirectionCls') ;

CALL ImportField(250312005, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2503, 2, 0, ',', 0, 20249, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250312007, '', 'FactCode', '', 'Fact', 2, 2503, 2, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250312008, ' ', 'FinSource', '', 'FinSource', 2, 2503, 2, 0, '', 0, 20246, 0, 1, 'FinSource') ;

CALL ImportField(250312009, ' . ', 'FinTypeCode', '', 'FinType', 2, 2503, 2, 0, ',', 0, 36853, 0, 1, 'FinType') ;

CALL ImportField(250312010, '', 'KCSRCode', '', 'KCSRCode', 2, 2503, 2, 0, '', 0, 25462, 0, 1, 'KCSRCode') ;

CALL ImportField(250312011, '', 'KESR', '', 'KESRKey', 2, 2503, 2, 1, '', 0, 20226, 0, 1, 'KESRKey') ;

CALL ImportField(250312012, '', 'KFSR', '', 'KFSR', 2, 2503, 2, 0, '', 0, 20225, 0, 1, 'KFSR') ;

CALL ImportField(250312013, '', 'KVRCode', '', 'KVRCode', 2, 2503, 2, 0, '', 0, 25467, 0, 1, 'KVRCode') ;

CALL ImportField(250312014, '', 'KVSRCode', '', 'KVSRCode', 2, 2503, 2, 0, '', 0, 25472, 0, 1, 'KVSRCode') ;

CALL ImportField(250312015, ' ', 'MeansType', '', 'MeansType', 2, 2503, 2, 0, '', 0, 20245, 0, 1, 'MeansType') ;

CALL ImportField(250312028, '  ', 'ParentNumber', '', 'ParentNumber', 2, 2503, 2, 0, '', 0, null, 0, 1, 'ParentNumber') ;

CALL ImportField(250312029, ' ', 'PromiseType', '', 'PromiseType', 2, 2503, 2, 0, '', 0, 20261, 0, 1, 'PromiseType') ;

CALL ImportField(250312034, '', 'Region', '', 'Region', 2, 2503, 2, 0, ',', 0, 20243, 0, 1, 'Region') ;

CALL ImportField(250312035, '', 'SubKESR', '', 'SubKESRKey', 2, 2503, 2, 1, '', 0, 20244, 0, 1, 'SubKESRKey') ;

CALL ImportField(250312037, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2503, 2, 0, '', 0, 20265, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250312039, '  ', 'TransfertClsCode', '', 'TransfertClsCode', 2, 2503, 2, 0, '', 0, 25326, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250312041, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2503, 2, 0, '', 0, 27825, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250312042, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2503, 2, 0, '', 0, 27849, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250312045, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2503, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250312046, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2503, 2, 1, '', 0, 20277, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250312047, ' ()', 'Fact', '', 'FactKey', 2, 2503, 2, 1, '', 0, 20248, 0, 1, 'FactKey') ;

CALL ImportField(250312048, ' . ', 'FinType', '', 'FinTypeKey', 2, 2503, 2, 1, ',', 0, 20247, 0, 1, 'FinTypeKey') ;

CALL ImportField(250312049, '', 'InvestObject', '', 'InvestObjectKey', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312050, '', 'InvestObjectCode', '', 'InvestObject', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312051, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2503, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250312052, '', 'ContractCostsCls', '', 'ContractCostsCls', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312053, '', 'ContractCostsClsCode', '', 'ContractCostsClsCode', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312054, '    ', 'OldNumber', '', 'OldNumber', 2, 2503, 2, 0, '', 0, 20263, 0, 1, 'OldNumber') ;

CALL ImportField(250312057, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2503, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250312058, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2503, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250312069, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2503, 2, 1, '', 0, 27829, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250312070, ' ()', 'KCSR', '', 'KCSRKey', 2, 2503, 2, 1, '', 0, 16858, 0, 1, 'KCSR') ;

CALL ImportField(250312071, ' ()', 'KVR', '', 'KVRKey', 2, 2503, 2, 1, '', 0, 16865, 0, 1, 'KVR') ;

CALL ImportField(250312072, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2503, 2, 1, '', 0, 27853, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250312073, ' ()', 'KVSR', '', 'KVSRKey', 2, 2503, 2, 1, '', 0, 16852, 0, 1, 'KVSR') ;

CALL ImportField(250312074, '   ()', 'TransfertCls', '', 'TransfertCls', 2, 2503, 2, 1, '', 0, 22774, 0, 1, 'TransfertCls') ;

CALL ImportField(250312075, '    ', 'OldYearData', '    ', 'OldYearData', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312078, '()', 'KESRCode', '', 'KESR', 2, 2503, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250312079, '()', 'SubKESRCode', '', 'SubKESR', 2, 2503, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

CALL ImportField(250312080, '', 'Note', '', 'Note', 2, 2503, 2, 0, '', 0, 20297, 0, 1, 'Note') ;

CALL ImportField(250312081, ' ', 'AdjustmentNumber', ' ', 'AdjustmentNumber', 2, 2503, 2, 1, '', 0, null, 0, 1, 'AdjustmentNumber') ;

CALL ImportField(250312082, '   ', 'InnerPromiseNum', '   ', 'InnerPromiseNum', 2, 2503, 2, 1, '', 0, null, 0, 1, 'InnerPromiseNum') ;

CALL ImportField(250312083, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 2503, 2, 1, '', 0, null, 0, 1, 'ProgIndex') ;

CALL ImportField(250312086, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312087, '   ()', 'PayTargetFunds', '   ', ' ', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(250400117, 'ID   ', 'FUID', '', ' ', 0, 2504, 0, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(250410001, ' ', 'ExecuterCountry', ' ', 'Executer_Country', 2, 2504, 0, 0, ',', 0, 24610, 0, 1, 'Executer_Country') ;

CALL ImportField(250410002, ' ', 'ExecuterAddress', ' ', 'Executer_Address', 2, 2504, 0, 0, ',', 0, 24609, 0, 1, 'Executer_Address') ;

CALL ImportField(250410003, ' ', 'ExecuterPhone', ' ', 'Executer_Phone', 2, 2504, 0, 0, ',', 0, 24614, 0, 1, 'Executer_Phone') ;

CALL ImportField(250410004, ' ', 'ExecuterStatus', ' ', 'Executer_Status', 2, 2504, 0, 0, ',', 0, 24615, 0, 1, 'Executer_Status') ;

CALL ImportField(250410006, '  ', 'UnknownAmount', '  ', 'UnknownAmount', 2, 2504, 0, 0, ',', 0, 19869, 0, 1, 'UnknownAmount') ;

CALL ImportField(250410007, '  ', 'Summa', '', 'Summa', 2, 2504, 0, 0, ',,', 0, 19797, 0, 1, 'Summa') ;

CALL ImportField(250410013, ' ', 'ReviewNote', '', 'ReviewNote', 2, 2504, 0, 0, '', 0, 19845, 0, 1, 'ReviewNote') ;

CALL ImportField(250410016, '', 'Region', '', 'Region', 2, 2504, 0, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250410017, ' ', 'ReestrNumber', '', 'ReestrNumber', 2, 2504, 0, 0, '', 0, 19830, 0, 1, 'ReestrNumber') ;

CALL ImportField(250410018, ' .', 'PurportDoc', ' .', 'PurportDoc', 2, 2504, 0, 0, '', 0, 19849, 0, 1, 'PurportDoc') ;

CALL ImportField(250410020, '  ', 'protocolSaleType', '  ', 'protocolSaleType', 2, 2504, 0, 0, ',', 0, 19860, 0, 1, 'protocolSaleType') ;

CALL ImportField(250410022, '  ', 'ProtocolReasonName', '  ', 'ProtocolReasonName', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolReason') ;

CALL ImportField(250410024, ' - ', 'ProtocolNumberTop', '', 'ProtocolNumberTop', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolNumberTop') ;

CALL ImportField(250410025, ' ', 'ProtocolNumber', ' ', 'ProtocolNumber', 2, 2504, 0, 0, ',,', 0, 19843, 0, 1, 'ProtocolNumber') ;

CALL ImportField(250410027, ' ', 'protocolDocTypeText', ' ', ' ', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolDocType') ;

CALL ImportField(250410029, ' ', 'protocolDocType', ' ', 'protocolDocType', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'protocolDocType') ;

CALL ImportField(250410030, ' ', 'ProtocolDate', '', 'ProtocolDate', 2, 2504, 0, 0, ',,', 0, 19844, 0, 1, 'ProtocolDate') ;

CALL ImportField(250410032, '    ', 'NotifyDate', '    ', 'NotifyDate', 2, 2504, 0, 0, '', 0, 19861, 0, 1, 'NotifyDate') ;

CALL ImportField(250410033, '', 'Note', '', 'Note', 2, 2504, 0, 0, '', 0, 19821, 0, 1, 'Note') ;

CALL ImportField(250410036, ' - ', 'fsOrgan', ' - ', 'fsOrgan', 2, 2504, 0, 0, '', 0, 19850, 0, 1, 'fsOrgan') ;

CALL ImportField(250410039, '  ', 'fsOffBudget', '  ', 'fsOffBudget', 2, 2504, 0, 0, '', 0, 19852, 0, 1, 'fsOffBudget') ;

CALL ImportField(250410042, ' ', 'fsBudgetName', ' ', 'fsBudgetName', 2, 2504, 0, 0, '', 0, 19851, 0, 1, 'fsBudgetName') ;

CALL ImportField(250410043, '      ', 'FinCardAdvance', '', 'FinCardAdvance', 2, 2504, 0, 0, '', 0, 19833, 0, 1, 'FinCardAdvance') ;

CALL ImportField(250410044, '', 'FactCode', '', 'Fact', 2, 2504, 0, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250410047, ' ', 'ExecuterName', '', 'Executer_Name', 2, 2504, 0, 0, ',', 0, 24613, 0, 1, 'Executer_Name') ;

CALL ImportField(250410048, ' ', 'ExecuterKPP', '', 'Executer_INN20', 2, 2504, 0, 0, ',', 0, 24612, 0, 1, 'Executer_INN20') ;

CALL ImportField(250410049, ' ', 'ExecuterINN', '', 'Executer_INN', 2, 2504, 0, 0, ',', 0, 24611, 0, 1, 'Executer_INN') ;

CALL ImportField(250410057, ' ', 'DocNumber', '', 'DocNumber', 2, 2504, 0, 0, ',', 0, 19798, 0, 1, 'DocNumber') ;

CALL ImportField(250410058, ' ', 'DocBaseType', ' ', 'DocBaseType', 2, 2504, 0, 0, '', 0, 19867, 0, 1, 'DocBaseType') ;

CALL ImportField(250410059, '  ', 'DocBaseText', '  ', 'DocBaseText', 2, 2504, 0, 0, '', 0, 19866, 0, 1, 'DocBaseText') ;

CALL ImportField(250410063, ' ', 'DeliveryRules', '', 'DeliveryRules', 2, 2504, 0, 0, '', 0, 19825, 0, 1, 'DeliveryRules') ;

CALL ImportField(250410066, ' ', 'CloseDate', '', 'CloseDate', 2, 2504, 0, 0, '', 0, 19824, 0, 1, 'CloseDate') ;

CALL ImportField(250410067, ' ', 'ClientName', '', 'Client_Name', 2, 2504, 0, 0, ',', 0, 24608, 0, 1, 'Client_Name') ;

CALL ImportField(250410068, ' ', 'ClientKPP', '', 'Client_INN20', 2, 2504, 0, 0, ',', 0, 24607, 0, 1, 'Client_INN20') ;

CALL ImportField(250410069, ' ', 'ClientINN', '', 'Client_INN', 2, 2504, 0, 0, ',', 0, 24606, 0, 1, 'Client_INN') ;

CALL ImportField(250410079, ' ', 'CardAdvancePercent', '', 'CardAdvancePercent', 2, 2504, 0, 0, '', 0, 19807, 0, 1, 'CardAdvancePercent') ;

CALL ImportField(250410080, '  ', 'CardAdvance', '', 'CardAdvance', 2, 2504, 0, 0, ',,', 0, 19808, 0, 1, 'CardAdvance') ;

CALL ImportField(250410081, ' ', 'AgreementSumma', '', 'AgreementSumma', 2, 2504, 0, 0, ',,', 0, 19826, 0, 1, 'AgreementSumma') ;

CALL ImportField(250410082, '     ', 'AgreementFinSumma', '', 'AgreementFinSumma', 2, 2504, 0, 0, '', 0, 19827, 0, 1, 'AgreementFinSumma') ;

CALL ImportField(250410083, ' ', 'AgreementEndDate', '', 'AgreementEndDate', 2, 2504, 0, 0, ',', 0, 19800, 0, 1, 'AgreementEndDate') ;

CALL ImportField(250410084, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2504, 0, 0, ',', 0, 19799, 0, 1, 'AgreementDate') ;

CALL ImportField(250410085, ' ', 'AgreementCardAdvance', '', 'AgreementCardAdvance', 2, 2504, 0, 0, ',,', 0, 19832, 0, 1, 'AgreementCardAdvance') ;

CALL ImportField(250410086, ' ', 'AgreementBeginDate', '', 'AgreementBeginDate', 2, 2504, 0, 0, ',', 0, 19841, 0, 1, 'AgreementBeginDate') ;

CALL ImportField(250410089, 'Executer_Ref', 'Executer_Ref', '', 'Executer_Ref', 2, 2504, 0, 1, '', 0, null, 0, 1, 'Executer_Ref') ;

CALL ImportField(250410090, 'Client_Ref', 'Client_Ref', '', 'Client_Ref', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'Client_Ref') ;

CALL ImportField(250410091, 'EXECUTERACCREF', 'EXECUTERACCREF', '', 'EXECUTERACCREF', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'EXECUTERACCREF') ;

CALL ImportField(250410092, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2504, 0, 0, '', 0, 29903, 0, 1, 'InfoNumber') ;

CALL ImportField(250410093, '   ', 'AdjustmentRef', '', 'AdjustmentRef', 2, 2504, 0, 1, '', 1, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250410094, ' ', 'DocType', '', 'DocType', 2, 2504, 0, 0, '', 0, 26539, 0, 1, 'DocType') ;

CALL ImportField(250410096, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2504, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250410098, ' ()', 'Fact', '', 'FactKey', 2, 2504, 0, 1, '', 0, 19822, 0, 1, 'FactKey') ;

CALL ImportField(250410099, '  ', 'ExecuterStoredProps', '', 'ExecuterStoredProps', 2, 2504, 0, 0, '', 0, 43484, 0, 1, 'ExecuterStoredProps') ;

CALL ImportField(250410101, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 2504, 0, 0, '', 0, null, 0, 1, 'PurchaseCode') ;

CALL ImportField(250410103, ' ', 'DocumentNumber', '', 'DocumentNumber', 2, 2504, 0, 0, '', 0, null, 0, 1, 'DocumentNumber') ;

CALL ImportField(250410104, ' ', 'DocStateRef', '', 'DocStateRef', 2, 2504, 0, 0, '', 0, null, 0, 1, 'DocStateRef') ;

CALL ImportField(250410105, 'ID', 'ID', '', 'ID', 2, 2504, 0, 1, ',,', 0, null, 0, 1, 'ID') ;

CALL ImportField(250410106, 'RealID', 'RealID', '', 'RealID', 2, 2504, 0, 1, '', 0, null, 0, 1, 'RealID') ;

CALL ImportField(250410113, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410114, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410116, '.  ', 'StoredContent', '', 'StoredContent', 2, 2504, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250410141, ' ', 'AUTOPAYTYPE', ' ', 'AUTOPAYTYPE', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410142, '    ', 'AUTOPAYMONTH', '    ', 'AUTOPAYMONTH', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410143, '   / ', 'AUTOPAYDAY', '   / ', 'AUTOPAYDAY', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410144, '  /', 'ReestrRecordNumber', '', 'ReestrRecordNumber', 2, 2504, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250410145, '     ', 'ProtocolReason', '     ', 'ProtocolReason', 2, 2504, 0, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(250410146, ' ', 'AgreementType', ' ', 'AgreementType', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'AgreementType') ;

CALL ImportField(250410147, ' ', 'CloseDoc', ' ', 'CloseDoc', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410148, ' ', 'InnerNumber', ' ', 'InnerNumber', 2, 2504, 0, 1, ',,', 0, null, 0, 1, 'InnerNumber') ;

CALL ImportField(250410149, ' ', 'AdjustmentNumber', ' ', 'AdjustmentNumber', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'AdjustmentNumber') ;

CALL ImportField(250410150, '  ', 'AdjustmentDocNumber', '  ', 'AdjustmentDocNumber', 2, 2504, 0, 1, '', 0, null, 0, 1, 'AdjustmentDocNumber') ;

CALL ImportField(250410151, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 2504, 0, 1, '', 0, null, 0, 1, 'LastAccepted') ;

CALL ImportField(250410152, '  ', 'ProgIndex', '  ', 'ProgIndex', 2, 2504, 0, 1, ',', 0, null, 0, 1, 'ProgIndex') ;

CALL ImportField(250410153, '    ', 'TreasurySupportID', '', 'TreasurySupportID', 2, 2504, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250410164, ' ', 'AgreementNumberRest', '', 'AgreementNumberRest', 2, 2504, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250410165, ' ', 'AgreementNumber', '', 'AgreementNumber', 2, 2504, 0, 0, '', 0, 19798, 0, 1, 'AgreementNumber') ;

CALL ImportField(250410166, '  ', 'isKS', '', 'isKS', 2, 2504, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250410167, ' ', 'rootDoc', '  ,       ', 'rootDoc', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412002, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250412007, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2504, 2, 0, '', 0, null, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250412009, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2504, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250412010, '', 'SubKESR', '', 'SubKESRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'SubKESRKey') ;

CALL ImportField(250412011, '', 'Region', '', 'Region', 2, 2504, 2, 0, ',', 0, null, 0, 1, 'Region') ;

CALL ImportField(250412016, ' ', 'PromiseType', '', 'PromiseType', 2, 2504, 2, 0, '', 0, null, 0, 1, 'PromiseType') ;

CALL ImportField(250412017, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250412030, ' ', 'MeansType', '', 'MeansType', 2, 2504, 2, 0, '', 0, null, 0, 1, 'MeansType') ;

CALL ImportField(250412031, '', 'KVSRCode', '', 'KVSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250412032, '', 'KVSR', '', 'KVSRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250412033, '', 'KVRCode', '', 'KVR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250412034, '', 'KVR', '', 'KVRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250412035, '', 'KFSR', '', 'KFSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250412036, '', 'KESR', '', 'KESRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250412037, '', 'KCSRCode', '', 'KCSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250412038, '', 'KCSR', '', 'KCSRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250412039, ' . ', 'FinTypeCode', '', 'FinType', 2, 2504, 2, 0, ',', 0, null, 0, 1, 'FinType') ;

CALL ImportField(250412040, ' ', 'FinSource', '', 'FinSource', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FinSource') ;

CALL ImportField(250412041, '', 'FactCode', '', 'Fact', 2, 2504, 2, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250412043, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2504, 2, 0, ',', 0, null, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250412044, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2504, 2, 0, '', 0, 36861, 0, 1, 'DirectionCls') ;

CALL ImportField(250412045, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250412046, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250412047, ' ', 'ANumber', '', 'ANumber', 2, 2504, 2, 0, '', 0, null, 0, 1, 'ANumber') ;

CALL ImportField(250412050, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250412051, ' ()', 'Fact', '', 'FactKey', 2, 2504, 2, 1, '', 0, 20248, 0, 1, 'FactKey') ;

CALL ImportField(250412052, ' .  ()', 'FinType', '', 'FinTypeKey', 2, 2504, 2, 1, ',', 0, null, 0, 1, 'FinTypeKey') ;

CALL ImportField(250412053, '', 'InvestObject', '', 'InvestObjectKey', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412054, '', 'InvestObjectCode', '', 'InvestObject', 2, 2504, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250412055, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2504, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250412062, ' ', 'AssignmentKind', ' ', 'AssignmentKind', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412063, '  ', 'ParentNumber', '  ', 'ParentNumber', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412064, '   ', 'LastAdjustment', '   ', 'LastAdjustment', 2, 2504, 2, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250412065, '  ', 'InnerPromiseNum', '  ', 'InnerPromiseNum', 2, 2504, 2, 1, '', 0, null, 0, 1, 'InnerPromiseNum') ;

CALL ImportField(250412066, '   ', 'AdjustmentRef', '   ', 'AdjustmentRef', 2, 2504, 2, 1, '', 0, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250412067, '  ', 'AdjustmentNumber', '   ', 'AdjustmentNumber', 2, 2504, 2, 1, '', 0, null, 0, 1, 'AdjustmentNumber') ;

CALL ImportField(250412068, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 2504, 2, 1, '', 0, null, 0, 1, ' ') ;

CALL ImportField(250412107, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2504, 2, 1, '', 0, null, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250412108, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'TransfertCls') ;

CALL ImportField(250412109, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2504, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250412110, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2504, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250412121, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2504, 2, 1, '', 0, null, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250412158, '()', 'KESRCode', '()', 'KESR', 2, 2504, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250412159, '()', 'SubKESRCode', '()', 'SubKESR', 2, 2504, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

CALL ImportField(250412160, '  ()', 'FacialAcc_ClsEx', '  ()', 'FacialAcc_ClsEx', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FacialCodeEx') ;

CALL ImportField(250412161, '    ', 'OldNumber', '    ', 'OldNumber', 2, 2504, 2, 1, '', 0, 20263, 0, 1, 'OldNumber') ;

CALL ImportField(250412162, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 2504, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250412163, '   ()', 'PayTargetFunds', '   ', ' ', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250414126, ' (+)', 'TreeOwner0', '', 'TreeOwner0', 2, 2504, 4, 0, '', 0, null, 0, 1, 'TreeOwner0') ;

CALL ImportField(250414127, '', 'SUMMA', '', 'SUMMA', 2, 2504, 4, 0, '', 0, null, 0, 1, 'SUMMA') ;

CALL ImportField(250414128, '', 'Note', '', 'Note', 2, 2504, 4, 0, '', 0, null, 0, 1, 'Note') ;

CALL ImportField(250414129, ' ', 'MEANSTYPE', ' ', 'MEANSTYPE', 2, 2504, 4, 0, '', 0, null, 0, 1, 'MEANSTYPE') ;

CALL ImportField(250414130, '', 'KVSRCode', '', 'KVSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250414131, '', 'KVSR', '', 'KVSRKey', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250414132, '', 'KVRCode', '', 'KVR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250414133, '', 'KVR', '', 'KVRKey', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250414134, '', 'KFSR', '', 'KFSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250414135, '', 'KESR', '', 'KESRKey', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250414136, '', 'KCSRCode', '', 'KCSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250414137, '', 'KCSR', '', 'KCSRKey', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250414138, '', 'FinYear', '', 'FinYear', 2, 2504, 4, 0, '', 0, null, 0, 1, 'FinYear') ;

CALL ImportField(250414139, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2504, 4, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250414140, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2504, 4, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250414141, '()', 'KESRCode', '()', 'KESR', 2, 2504, 4, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250415010, '', 'KESR', '', 'KESRKey', 2, 2504, 5, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250416145, 'ORGREF', 'ORGREF', '   ', 'ORGREF', 2, 2504, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250416146, 'ACCREF', 'ACCREF', '    ', 'ACCREF', 2, 2504, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250416147, '  ', 'STOREDPROPS', '  ', 'STOREDPROPS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416148, ' ', 'INN', ' ', 'INN', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416149, ' ', 'INN20', ' ', 'INN20', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416150, ' ', 'NAME', ' ', 'NAME', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416151, ' ', 'STATUS', ' ', 'STATUS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416152, ' ', 'COUNTRY', ' ', 'COUNTRY', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416153, ' ', 'ADDRESS', ' ', 'ADDRESS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416154, ' ', 'PHONE', ' ', 'PHONE', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416155, ' ', 'ACCNAME', ' ', 'ACCNAME', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416156, ' (+)', 'Executer', ' (+)', 'Executer', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

--       , (1)
CALL ImportField(280111016, ' ', 'BuhOperationCLS', ' ', ' ', 1, 2801, 1, 0, '', 0, 17200, 0, 0, '') ;

--   , (0)
CALL ImportField(280200017, '  ', 'TransfertCls', '   ()', ' ', 0, 2802, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(280200018, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 2802, 0, 0, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(280210008, ' ', 'BuhOperationCLS', ' ', ' ', 1, 2802, 0, 0, '', 0, 17297, 0, 0, '') ;

--    , +(2)
CALL ImportField(300110003, '. -  ', 'YearAcceptSumma', '. -  ', 'YearAcceptSumma', 2, 3001, 0, 0, ',', 0, 21307, 0, 0, '') ;

CALL ImportField(300110004, '', 'AYear', '', 'AYear', 2, 3001, 0, 0, ',,', 0, 21284, 0, 0, '') ;

CALL ImportField(300110005, '  ', 'UnknownAmount', '  ', 'UnknownAmount', 2, 3001, 0, 0, '', 0, 21318, 0, 0, '') ;

CALL ImportField(300110006, ' ', 'TenderTarget', ' ', 'TenderTarget', 2, 3001, 0, 0, ',', 0, 21309, 0, 0, '') ;

CALL ImportField(300110008, ' ', 'TenderOption', ' ', 'TenderOption', 2, 3001, 0, 0, '', 0, 21308, 0, 0, '') ;

CALL ImportField(300110009, '    ', 'SupportUndertaker', '    ', 'SupportUndertaker', 2, 3001, 0, 0, ',', 0, 21320, 0, 0, '') ;

CALL ImportField(300110015, ' ', 'RefinementCause', '', 'RefinementCause', 2, 3001, 0, 0, '', 0, 21314, 0, 0, '') ;

CALL ImportField(300110018, '  ', 'PeriodYear', '  ', 'PeriodYear', 2, 3001, 0, 0, '', 0, 21319, 0, 0, '') ;

CALL ImportField(300110019, '', 'Period', '', 'Period', 2, 3001, 0, 0, '', 0, 21283, 0, 0, '') ;

CALL ImportField(300110021, '', 'Note', '', 'Note', 2, 3001, 0, 0, ',,', 0, 21310, 0, 0, '') ;

CALL ImportField(300110022, ' ', 'MultiPurpose', ' ', 'MultiPurpose', 2, 3001, 0, 0, '', 0, 21280, 0, 0, '') ;

CALL ImportField(300110024, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 2, 3001, 0, 0, ',', 0, 21279, 0, 0, '') ;

CALL ImportField(300110025, ' ', 'DOCUMENTDATE', ' ', 'DOCUMENTDATE', 2, 3001, 0, 0, ',', 0, 21281, 0, 0, '') ;

CALL ImportField(300110026, ' ', 'DocNumber', ' ', 'DocNumber', 2, 3001, 0, 0, ',', 0, 21278, 0, 0, '') ;

CALL ImportField(300110029, ' .', 'ACCEPTSUMMA', ' .', 'ACCEPTSUMMA', 2, 3001, 0, 0, ',,', 0, 21286, 0, 0, '') ;

CALL ImportField(300110030, ' ', 'ACCEPTDATE', ' ', 'ACCEPTDATE', 2, 3001, 0, 0, '', 0, 21282, 0, 0, '') ;

CALL ImportField(300110031, '   ', 'ReworkCause', '   ', 'ReworkCause', 2, 3001, 0, 0, '', 0, 25041, 0, 0, '') ;

CALL ImportField(300110032, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3001, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300110033, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110034, ' ', 'AVersion', '', 'AVersion', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110035, '  /', 'ParentRef', '', 'PArentRef', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110036, ' ', 'AdjustmentNumber', '', 'AdjustmentNumber', 2, 3001, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300110037, ' ', 'Accepted', ' ', 'Accepted', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110038, ' ', 'InnerNumber', ' ', 'InnerNumber', 2, 3001, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300110039, ' ', 'ID', ' ', 'ID', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110040, '   ', 'AdjustmentRef', '   ', 'AdjustmentRef', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110041, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110042, '  ', 'ProtocolReason', '  ', 'ProtocolReason', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110043, '  ', 'AgreementExecutionDate', '  ', 'AgreementExecutionDate', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110044, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110045, '    ', 'RealID', '    ', 'RealID', 2, 3001, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300110046, '  ', 'ParentInnerNumber', '  ', 'ParentInnerNumber', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111002, ' ', 'VatPercent', '', 'VatPercent', 2, 3001, 1, 0, '', 0, 21107, 0, 0, '') ;

CALL ImportField(300111006, ' ', 'TenderObjectCls', ' ', 'TenderObjectCls', 2, 3001, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(300111008, '', 'SubKESR', '', 'SubKESRKey', 2, 3001, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(300111014, ' ', 'ProductName', '  ', 'ProductName', 2, 3001, 1, 0, '', 0, 20697, 0, 0, '') ;

CALL ImportField(300111016, ' ', 'ProductCode', '', 'ProductCode', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111017, '    ', 'PriceVAT', '    ', 'PriceVAT', 2, 3001, 1, 0, '', 0, 21123, 0, 0, '') ;

CALL ImportField(300111021, ' ', 'OKATO', ' ', 'OKATO', 2, 3001, 1, 0, '', 0, 21048, 0, 0, '') ;

CALL ImportField(300111035, ' ', 'MeansTypeCls', ' ', 'MeansTypeCls', 2, 3001, 1, 0, '', 0, 21042, 0, 0, '') ;

CALL ImportField(300111038, '', 'KVSR', '', 'KVSRKey', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111039, '', 'KVR', '', 'KVRKey', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111040, '', 'KFSR', '', 'KFSR', 2, 3001, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(300111041, '', 'KESR', '', 'KESRKey', 2, 3001, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(300111042, '', 'KCSR', '', 'KCSRKey', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111045, ' . ', 'FinTypeCode', ' . ', 'FinType', 2, 3001, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(300111047, ' ', 'FinSourceCls', '', 'FinSourceCls', 2, 3001, 1, 0, '', 0, 21041, 0, 0, '') ;

CALL ImportField(300111049, '', 'FactClsCode', '', 'FactCls', 2, 3001, 1, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(300111051, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 2, 3001, 1, 0, ',', 0, 21033, 0, 0, '') ;

CALL ImportField(300111053, '', 'DirectionClsCode', '', 'DirectionCls', 2, 3001, 1, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(300111057, ' ', 'DeliveryPeriod', ' ', 'DeliveryPeriod', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111060, '  ', 'DeliveryEndDate', '  ', 'DeliveryEndDate', 2, 3001, 1, 0, '', 0, 21051, 0, 0, '') ;

CALL ImportField(300111061, ' ', 'DeliveryDate', ' ', 'DeliveryDate', 2, 3001, 1, 0, '', 0, 21050, 0, 0, '') ;

CALL ImportField(300111062, '  ', 'DeliveryAmount', '  ', 'DeliveryAmount', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111065, '  .', 'AcceptVatSumma', '', 'AcceptVatSumma', 2, 3001, 1, 0, '', 0, 21109, 0, 0, '') ;

CALL ImportField(300111072, ' .', 'AcceptPrice', ' .', 'AcceptPrice', 2, 3001, 1, 0, '', 0, 21047, 0, 0, '') ;

CALL ImportField(300111085, '   .', 'AcceptCost', '', 'AcceptCost', 2, 3001, 1, 0, '', 0, 21111, 0, 0, '') ;

CALL ImportField(300111086, ' .', 'AcceptAmount', ' .', 'AcceptAmount', 2, 3001, 1, 0, '', 0, 21045, 0, 0, '') ;

CALL ImportField(300111088, '', 'KVSRCode', '', 'KVSR', 2, 3001, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(300111089, '', 'KVRCode', '', 'KVR', 2, 3001, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(300111090, '', 'KCSRCode', '', 'KCSR', 2, 3001, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(300111093, ' ', 'BudAllocationClsCode', '  ', 'BudAllocationClsCode', 2, 3001, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(300111094, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 2, 3001, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(300111095, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 3001, 1, 1, '', 0, 21104, 0, 0, '') ;

CALL ImportField(300111096, ' ()', 'FactCls', '', 'FactClsKey', 2, 3001, 1, 1, '', 0, 21040, 0, 0, '') ;

CALL ImportField(300111097, ' .  ()', 'FinType', ' . ', 'FinTypeKey', 2, 3001, 1, 1, ',', 0, 21114, 0, 0, '') ;

CALL ImportField(300111102, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111103, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111104, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3001, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(300111105, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3001, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(300111116, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111117, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111118, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3001, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(300111119, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111120, ' ', 'ID', ' ', 'ID', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111121, ' ', 'PositionNumber', ' ', 'PositionNumber', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111151, '()', 'KESRCode', '()', 'KESR', 2, 3001, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(300111152, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3001, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(300111153, '   ', 'SummaOtherYears', '', 'SummaOtherYears', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300117146, ' ', 'DocTypeCls', '', 'DocTypeCls', 2, 3001, 7, 0, '', 0, 21968, 0, 0, '') ;

--     223-, +(2)
CALL ImportField(300610002, '. -  ', 'YearAcceptSumma', '', 'YearAcceptSumma', 2, 3006, 0, 0, ',', 0, 21307, 0, 0, '') ;

CALL ImportField(300610003, ' ', 'TenderTarget', '', 'TenderTarget', 2, 3006, 0, 0, ',', 0, 21309, 0, 0, '') ;

CALL ImportField(300610004, ' ', 'TenderOption', '', 'TenderOption', 2, 3006, 0, 0, '', 0, 21308, 0, 0, '') ;

CALL ImportField(300610005, '   ', 'SupportUnderTaker', '', 'SupportUnderTaker', 2, 3006, 0, 0, ',', 0, 21320, 0, 0, '') ;

CALL ImportField(300610009, '  ', 'PeriodYear', '', 'PeriodYear', 2, 3006, 0, 0, '', 0, 21319, 0, 0, '') ;

CALL ImportField(300610010, '', 'Period', '', 'Period', 2, 3006, 0, 0, '', 0, 21283, 0, 0, '') ;

CALL ImportField(300610012, '', 'Note', '', 'Note', 2, 3006, 0, 0, ',,', 0, 21310, 0, 0, '') ;

CALL ImportField(300610014, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3006, 0, 0, ',', 0, 21279, 0, 0, '') ;

CALL ImportField(300610015, ' ', 'DocumentDate', '', 'DocumentDate', 2, 3006, 0, 0, ',', 0, 21281, 0, 0, '') ;

CALL ImportField(300610016, ' ', 'DocNumber', '', 'DocNumber', 2, 3006, 0, 0, ',', 0, 21278, 0, 0, '') ;

CALL ImportField(300610017, '', 'AYear', '', 'AYear', 2, 3006, 0, 0, ',,', 0, 21284, 0, 0, '') ;

CALL ImportField(300610018, '', 'AcceptSumma', '', 'AcceptSumma', 2, 3006, 0, 0, ',,', 0, 21286, 0, 0, '') ;

CALL ImportField(300610019, ' ', 'AcceptDate', '', 'AcceptDate', 2, 3006, 0, 0, '', 0, 21282, 0, 0, '') ;

CALL ImportField(300610020, '   ', 'ReworkCause', '   ', 'ReworkCause', 2, 3006, 0, 0, '', 0, 25041, 0, 0, '') ;

CALL ImportField(300610021, '  ', 'ProtocolReason', '', 'ProtocolReason', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610026, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3006, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300610027, '  ', 'AgreementExecutionDate', '', 'AgreementExecutionDate', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610049, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610050, ' ', 'AVersion', '', 'AVersion', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610051, '  /', 'ParentRef', '', 'ParentRef', 2, 3006, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(300610066, ' ', 'AdjustmentNumber', '', 'AdjustmentNumber', 2, 3006, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300610074, ' ', 'Accepted', ' ', 'Accepted', 2, 3006, 0, 1, '', 0, null, 0, 1, 'Accepted') ;

CALL ImportField(300610075, ' ', 'InnerNumber', ' ', 'InnerNumber', 2, 3006, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(300610076, ' ', 'ID', ' ', 'ID', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610077, '   ', 'AdjustmentRef', '   ', 'AdjustmentRef', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610078, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610079, ' ', 'UnknownAmount', ' ', 'UnknownAmount', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610080, '', 'Multipurpose', '', 'Multipurpose', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610081, ' ', 'RefinementCause', ' ', 'RefinementCause', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610082, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610083, '  ', 'RealID', '  ', 'RealID', 2, 3006, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300610084, ' ', 'PeriodVariant', ' ', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610085, ' ', 'PeriodOther', ' ', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610086, '  ', 'ParentInnerNumber', '  ', 'ParentInnerNumber', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611001, ' ', 'VATPercent', '', 'VATPercent', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611002, ' ', 'ProductName', '', 'ProductName', 2, 3006, 1, 0, ',', 0, 20697, 0, 0, '') ;

CALL ImportField(300611003, '  ', 'PriceVAT', '', 'PriceVAT', 2, 3006, 1, 0, '', 0, 21123, 0, 0, '') ;

CALL ImportField(300611005, '2', 'OKPD2', '', 'OKPD2', 2, 3006, 1, 0, '2', 0, 37808, 0, 0, '') ;

CALL ImportField(300611008, '', 'KESR', '', 'KESRKey', 2, 3006, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(300611009, '', 'KCSR', '', 'KCSRKey', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611010, '', 'FactCLSCode', '', 'FactCLS', 2, 3006, 1, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(300611012, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3006, 1, 0, ',', 0, 21033, 0, 0, '') ;

CALL ImportField(300611013, ' ', 'AcceptVATSumma', '', 'AcceptVATSumma', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611020, '  ', 'AcceptPrice', '', 'AcceptPrice', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611033, '  ', 'AcceptCost', '', 'AcceptCost', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611034, '', 'AcceptAmount', '', 'AcceptAmount', 2, 3006, 1, 0, '', 0, 21045, 0, 0, '') ;

CALL ImportField(300611036, '', 'KVSR', '', 'KVSRKey', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611037, '', 'KFSR', '', 'KFSR', 2, 3006, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(300611038, '', 'KVR', '', 'KVRKey', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611039, ' ', 'MeansTypeCls', ' ', 'MeansTypeCls', 2, 3006, 1, 0, '', 0, 21042, 0, 0, '') ;

CALL ImportField(300611041, '', 'KCSRCode', '', 'KCSR', 2, 3006, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(300611042, '', 'KVSRCode', '', 'KVSR', 2, 3006, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(300611043, '', 'KVRCode', '', 'KVR', 2, 3006, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(300611046, '', 'DirectionClsCode', '', ' ', 2, 3006, 1, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(300611049, ' . ', 'FinTypeCode', '', ' ', 2, 3006, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(300611051, '', 'subkesr', '', 'SubKESRKey', 2, 3006, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(300611052, ' ', 'SubsidyClsCode', '', ' ', 2, 3006, 1, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(300611053, ' ()', 'DirectionCls', '', ' ', 2, 3006, 1, 1, '', 0, 21104, 0, 0, '') ;

CALL ImportField(300611054, ' .  ()', 'FinType', '', ' ', 2, 3006, 1, 1, ',', 0, 21114, 0, 0, '') ;

CALL ImportField(300611055, ' ', 'FinSourceCls', '', 'FinSourceCls', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611056, '', 'InvestObject', '', 'InvestObjectKey', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611057, '', 'InvestObjectCode', '', 'InvestObject', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611058, ' ()', 'FactCls', '', 'FactClsKey', 2, 3006, 1, 0, '', 0, 21040, 0, 0, '') ;

CALL ImportField(300611059, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611060, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611061, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611065, '  ()', 'BudAllocationCls', '', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611066, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3006, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(300611067, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3006, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(300611068, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3006, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(300611079, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611080, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611084, '()', 'KESRCode', '()', 'KESR', 2, 3006, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(300611085, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3006, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(300611086, '', 'OKATO', '', 'OKATO', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611087, '  ', 'TenderObjectCls', '  ', 'TenderObjectCls', 2, 3006, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(300611088, ' ', 'ID', ' ', 'ID', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611089, ' ', 'DeliveryPeriod', ' ', 'DeliveryPeriod', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611090, ' ', 'DeliveryDate', ' ', 'DeliveryDate', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611091, '  ', 'DeliveryEndDate', '  ', 'DeliveryEndDate', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611092, ' ', 'DeliveryAmount', ' ', 'DeliveryAmount', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611093, ' ', 'PositionNumber', ' ', 'PositionNumber', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

--  - , +(2)
CALL ImportField(301110002, '-  ', 'YearAcceptSumma', '', 'YearAcceptSumma', 2, 3011, 0, 0, ',', 0, 21307, 0, 0, '') ;

CALL ImportField(301110003, '  ', 'TenderTarget', '', 'TenderTarget', 2, 3011, 0, 0, ',', 0, 21309, 0, 0, '') ;

CALL ImportField(301110009, '     ', 'PeriodYear', '', 'PeriodYear', 2, 3011, 0, 0, '', 0, 21319, 0, 0, '') ;

CALL ImportField(301110010, '   ', 'PeriodVariant', '', ' ', 2, 3011, 0, 0, '', 0, 21283, 0, 0, '') ;

CALL ImportField(301110012, '', 'Note', '', 'Note', 2, 3011, 0, 0, ',,', 0, 21310, 0, 0, '') ;

CALL ImportField(301110014, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3011, 0, 0, ',', 0, 21279, 0, 0, '') ;

CALL ImportField(301110017, ' ', 'AYear', '', 'AYear', 2, 3011, 0, 0, ',,', 0, 21284, 0, 0, '') ;

CALL ImportField(301110018, '', 'AcceptSumma', '', 'AcceptSumma', 2, 3011, 0, 0, ',,', 0, 21286, 0, 0, '') ;

CALL ImportField(301110019, '  ', 'AcceptDate', '', 'AcceptDate', 2, 3011, 0, 0, '', 0, 21282, 0, 0, '') ;

CALL ImportField(301110020, '   ', 'ReworkCause', '', 'ReworkCause', 2, 3011, 0, 0, '', 0, 25041, 0, 0, '') ;

CALL ImportField(301110024, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3011, 0, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(301110025, '   ', 'PeriodOther', '', ' ', 2, 3011, 0, 0, '', 0, 21283, 0, 0, '') ;

CALL ImportField(301110026, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3011, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301110028, ' ', 'AVersion', '', 'AVersion', 2, 3011, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301110029, '  /', 'ParentRef', '', 'ParentRef', 2, 3011, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(301110052, ' ', 'AdjustmentNumber', '', 'AdjustmentNumber', 2, 3011, 0, 1, ',,', 0, null, 0, 0, '') ;

CALL ImportField(301110059, ' ', 'DocumentDate', ' ', 'DocumentDate', 2, 3011, 0, 0, ',', 0, null, 0, 1, 'DocumentDate') ;

CALL ImportField(301110060, ' ', 'TenderOption', ' ', 'TenderOption', 2, 3011, 0, 0, '', 0, null, 0, 1, 'TenderOption') ;

CALL ImportField(301110061, ' ', 'DocNumber', ' ', 'DocNumber', 2, 3011, 0, 0, ',', 0, null, 0, 1, 'DocNumber') ;

CALL ImportField(301110062, '', 'Period', '', 'Period', 2, 3011, 0, 0, '', 0, null, 0, 0, 'Period') ;

CALL ImportField(301110063, '   ', 'SupportUnderTaker', '   ', 'SupportUnderTaker', 2, 3011, 0, 0, ',', 0, null, 0, 1, 'SupportUnderTaker') ;

CALL ImportField(301110064, '  ', 'ProtocolReason', '  ', 'ProtocolReason', 2, 3011, 0, 0, '', 0, null, 0, 1, 'ProtocolReason') ;

CALL ImportField(301110065, '  ', 'AgreementExecutionDate', '  ', 'AgreementExecutionDate', 2, 3011, 0, 0, '', 0, null, 0, 1, 'AgreementExecutionDate') ;

CALL ImportField(301110066, ' ', 'Accepted', ' ', 'Accepted', 2, 3011, 0, 1, '', 0, null, 0, 1, 'Accepted') ;

CALL ImportField(301110067, '  ', 'InnerNumber', '  ', 'InnerNumber', 2, 3011, 0, 1, ',', 0, null, 0, 1, 'InnerNumber') ;

CALL ImportField(301110068, ' ', 'ID', ' ', 'ID', 2, 3011, 0, 1, '', 0, null, 0, 1, 'ID') ;

CALL ImportField(301110069, '   ', 'AdjustmentRef', '   ', 'AdjustmentRef', 2, 3011, 0, 1, '', 0, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(301110070, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 3011, 0, 1, '', 0, null, 0, 1, 'ProgIndex') ;

CALL ImportField(301110071, ' ', 'UnknownAmount', ' ', 'UnknownAmount', 2, 3011, 0, 1, '', 0, null, 0, 1, 'UnknownAmount') ;

CALL ImportField(301110072, '', 'MultiPurpose', '', 'MultiPurpose', 2, 3011, 0, 1, '', 0, null, 0, 1, 'MultiPurpose') ;

CALL ImportField(301110073, ' ', 'RefinementCause', ' ', 'RefinementCause', 2, 3011, 0, 0, '', 0, null, 0, 1, 'RefinementCause') ;

CALL ImportField(301110074, '  ', 'LastAccepted', '  ', 'LastAccepted', 2, 3011, 0, 1, '', 0, null, 0, 1, 'LastAccepted') ;

CALL ImportField(301110075, '  . ', 'RealID', '  . ', 'RealID', 2, 3011, 0, 0, '', 0, null, 0, 1, 'RealID') ;

CALL ImportField(301110076, '  ', 'ParentInnerNumber', '  ', 'ParentInnerNumber', 2, 3011, 0, 1, '', 0, null, 0, 1, 'ParentInnerNumber') ;

CALL ImportField(301111002, '', 'KESR', '', 'KESRKey', 2, 3011, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(301111003, '', 'KCSR', '', 'KCSRKey', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111004, '', 'FactCLSCode', '', 'FactCLS', 2, 3011, 1, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(301111006, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3011, 1, 0, ',', 0, 21033, 0, 0, '') ;

CALL ImportField(301111025, '', 'KVSR', '', 'KVSRKey', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111026, '', 'KFSR', '', 'KFSR', 2, 3011, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(301111027, '', 'KVR', '', 'KVRKey', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111028, 'MEANSTYPECls', 'MEANSTYPECls', 'MEANSTYPECls', 'MEANSTYPECls', 2, 3011, 1, 0, '', 0, 21042, 0, 0, '') ;

CALL ImportField(301111029, '', 'KCSRCode', '', 'KCSR', 2, 3011, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(301111030, '', 'KVSRCode', '', 'KVSR', 2, 3011, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(301111031, '', 'KVRCode', '', 'KVR', 2, 3011, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(301111034, '', 'DirectionClsCode', '', ' ', 2, 3011, 1, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(301111037, ' . ', 'FinTypeCode', '', ' ', 2, 3011, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(301111038, '', 'subkesr', '', 'SubKESRKey', 2, 3011, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(301111039, ' ', 'SubsidyClsCode', '', ' ', 2, 3011, 1, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(301111040, ' ', 'FinSourceCls', '', 'FinSourceCls', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111041, ' .  ()', 'FinType', '', ' ', 2, 3011, 1, 1, ',', 0, 21114, 0, 0, '') ;

CALL ImportField(301111042, ' ()', 'DirectionCls', '', ' ', 2, 3011, 1, 1, '', 0, 21104, 0, 0, '') ;

CALL ImportField(301111043, '', 'InvestObject', '', 'InvestObjectKey', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111044, '', 'InvestObjectCode', '', 'InvestObject', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111045, ' ()', 'FactCls', '', 'FactClsKey', 2, 3011, 1, 0, '', 0, 21040, 0, 0, '') ;

CALL ImportField(301111046, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111047, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111048, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111052, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3011, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(301111053, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3011, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(301111064, '  ()', 'BudAllocationCls', '', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111065, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111066, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111067, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3011, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(301111068, '()', 'KESRCode', '()', 'KESR', 2, 3011, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(301111069, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3011, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(301111070, '', 'OKATO', '', 'OKATO', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111071, ' ', 'TenderObjectCls', ' ', 'TenderObjectCls', 2, 3011, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(301111072, ' ', 'ID', ' ', 'ID', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111073, ' ', 'DeliveryPeriod', ' ', 'DeliveryPeriod', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111074, ' ', 'DeliveryDate', ' ', 'DeliveryDate', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111075, '  ', 'DeliveryEndDate', '  ', 'DeliveryEndDate', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111076, ' ', 'DeliveryAmount', ' ', 'DeliveryAmount', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111077, ' ', 'PositionNumber', ' ', 'PositionNumber', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111078, ' ', 'VATPercent', ' ', 'VATPercent', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111079, '', 'AcceptPrice', '', 'AcceptPrice', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111080, '', 'AcceptAmount', '', 'AcceptAmount', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111081, '  ', 'AcceptCost', '  ', 'AcceptCost', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111082, ' ', 'AcceptVATSumma', ' ', 'AcceptVATSumma', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111083, '  ', 'PriceVat', '  ', 'PriceVat', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111084, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111085, '   ()', 'PayTargetFunds', '   ', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

--   , (0)
CALL ImportField(361000001, '', 'ReportDate', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000002, '', 'ReportMonth', '', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000004, '', 'ReportYear', '', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000005, '', 'DocNumber', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000006, ' ', 'RegionCLS', ' ', '', 0, 3610, 0, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(361000007, ' c', 'FacialAcc_CLS', ' c', 'FacialAcc_CLS', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000008, ' ', 'ActivityKind', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000009, ' ', 'RejectCLS', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000010, '  ', 'RejectCause', '  ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000011, ' ', 'Note', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000012, ' ', 'AcceptDate', ' ', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000013, '  ', 'ERROR', '  ', 'ERROR', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000014, '', 'ClientsType', '', '', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(361000016, ' ', 'HigherOrgRef', ' ', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000017, '  ', 'TYPEDFORM', '  ', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000019, '   ', 'TYPEDFORMTMPLT', '   ', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000020, '', 'PERIOD', '', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000021, ' ', 'TypedFormName', ' ', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000022, ' ', 'GroupIndex', ' ', ' ', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000023, ' ', 'DocStateName', ' ', 'DocStateName', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000024, '   ()', 'SoftRejectCause', '   ()', 'SoftRejectCause', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000025, '  ', 'SoftRejectCls', '  ', 'SoftRejectCls', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000026, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000027, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000028, ' ', 'IsVised', ' ', 'IsVised', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000029, ' ', 'ID', ' ', 'Id', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000030, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000031, ' ()', 'DocStateRef', ' ()', 'DocStateRef', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000032, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 3610, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(361000193, '', 'BUDGETREF', '', 'BudgetRef', 0, 3610, 0, 0, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(370110013, ' (. ) ', 'FacialAccCls', '', 'FacialAccCls', 2, 3701, 0, 0, '', 0, 20714, 0, 0, '') ;

--  , (0)
CALL ImportField(440100001, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 0, 4401, 0, 0, '', 0, 21688, 0, 1, '') ;

CALL ImportField(440100003, ' ', 'BUDGETREF', ' ', 'BudgetRef', 0, 4401, 0, 1, '', 0, 21683, 0, 1, '') ;

CALL ImportField(440100004, ' ', 'CRYPTOSTATUS', ' ', 'CryptoStatus', 0, 4401, 0, 1, '', 0, 21700, 0, 1, '') ;

CALL ImportField(440100005, '  \ ', 'DFACCOUNT', '  \ ', 'DFAccount', 0, 4401, 0, 1, '', 0, 21687, 0, 1, '') ;

CALL ImportField(440100006, ' ', 'DocNumber', ' ', 'DocNumber', 0, 4401, 0, 0, '', 0, 21684, 0, 1, '') ;

CALL ImportField(440100007, ' ', 'DOCSTATEREF', ' ', 'DocStateRef', 0, 4401, 0, 1, '', 0, 21701, 0, 1, '') ;

CALL ImportField(440100008, ' ', 'DOCUMENTFORMAT', ' ', 'DocumentFormat', 0, 4401, 0, 1, '', 0, 21692, 0, 1, '') ;

CALL ImportField(440100009, ' ', 'FACIALACCCLS', ' ', 'FacialAccCLS', 0, 4401, 0, 1, '', 0, 21691, 0, 1, '') ;

CALL ImportField(440100012, ' ', 'InputDate', ' ', 'InputDate', 0, 4401, 0, 1, '', 0, 21686, 0, 1, '') ;

CALL ImportField(440100016, '', 'Note', '', 'Note', 0, 4401, 0, 0, '', 0, 21695, 0, 1, '') ;

CALL ImportField(440100017, '    ', 'NotifyNumber', '    ', 'NotifyNumber', 0, 4401, 0, 0, '', 0, 21685, 0, 1, '') ;

CALL ImportField(440100018, '', 'NotifyType', ' ', 'NotifyType', 0, 4401, 0, 1, '', 0, 21694, 0, 1, '') ;

CALL ImportField(440100019, ' ', 'PROGINDEX', ' ', 'ProgIndex', 0, 4401, 0, 1, '', 0, 21690, 0, 1, '') ;

CALL ImportField(440100020, '  ', 'SENDERID', '  ', 'SenderID', 0, 4401, 0, 1, '', 0, 21698, 0, 1, '') ;

CALL ImportField(440100021, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 0, 4401, 0, 1, '', 0, 21699, 0, 1, '') ;

CALL ImportField(440100022, ' ', 'SpecialNote', ' ', 'SpecialNote', 0, 4401, 0, 1, '', 0, 21697, 0, 1, '') ;

CALL ImportField(440100033, ' ', 'ID', ' ', 'ID', 0, 4401, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440100039, ' ', 'RejectCLS', ' ', 'REJECTCLS', 0, 4401, 0, 0, '', 0, 21707, 0, 1, '') ;

CALL ImportField(440100040, '  ()', 'RejectCause', '  ()', 'REJECTCAUSE', 0, 4401, 0, 0, '', 0, 21708, 0, 1, '') ;

CALL ImportField(440100041, '()', 'CREATERUSER', '()', 'CreaterUser', 0, 4401, 0, 1, '', 0, 21703, 0, 1, '') ;

CALL ImportField(440100042, '()', 'UPDATERUSER', '()', 'UpdaterUser', 0, 4401, 0, 1, '', 0, 21705, 0, 1, '') ;

CALL ImportField(440100043, ' ()', 'UPDATEDATE', ' ()', 'UpdateDate', 0, 4401, 0, 1, '', 0, 21706, 0, 1, '') ;

CALL ImportField(440100044, ' ()', 'CREATEDATE', ' ()', 'CreateDate', 0, 4401, 0, 1, '', 0, 21704, 0, 1, '') ;

CALL ImportField(440100045, '', 'Org_Ref', 'Org_Ref', '', 0, 4401, 0, 1, '', 0, 21693, 0, 1, '') ;

CALL ImportField(440100046, '    ', 'DATE_PP', '    ', 'DATE_PP', 0, 4401, 0, 1, '', 0, 25050, 0, 1, '') ;

CALL ImportField(440100047, '(   )', 'DATE_UTV_BA', '(   )', 'DATE_UTV_BA', 0, 4401, 0, 0, '', 0, 25051, 0, 1, '') ;

CALL ImportField(440100048, '(   )', 'DATE_UTV_LBO', '(   )', 'DATE_UTV_LBO', 0, 4401, 0, 0, '', 0, 25052, 0, 1, '') ;

CALL ImportField(440100049, '(   )', 'DATE_UTV_POF', '(   )', 'DATE_UTV_POF', 0, 4401, 0, 0, '', 0, 25053, 0, 1, '') ;

CALL ImportField(440100050, ' (   )', 'DATE_UTV_PP', ' (   )', 'DATE_UTV_PP', 0, 4401, 0, 0, '', 0, 25054, 0, 1, '') ;

CALL ImportField(440100051, '    ()', 'Date_UTV_Reestr', '    ()', 'DATE_UTV_Reestr', 0, 4401, 0, 1, '', 0, 25055, 0, 1, '') ;

CALL ImportField(440100052, '    ', 'NOM_PP', '    ', 'NOM_PP', 0, 4401, 0, 1, '', 0, 25057, 0, 1, '') ;

CALL ImportField(440100053, ' ()', 'ReestrDate', ' ()', 'REESTRDATE', 0, 4401, 0, 1, '', 0, 25058, 0, 1, '') ;

CALL ImportField(440100054, ' ()', 'ReestrNumber', ' ()', 'REESTRNUMBER', 0, 4401, 0, 1, '', 0, 25059, 0, 1, '') ;

CALL ImportField(440100055, '  ', 'SpecialNoteCode', '  ', 'SpecialNoteCode', 0, 4401, 0, 0, '', 0, 25060, 0, 1, '') ;

CALL ImportField(440100056, '  ', 'TIP_RR', '  ', 'TIP_RR', 0, 4401, 0, 0, '', 0, 25062, 0, 1, '') ;

CALL ImportField(440100058, '(  )', 'Status', '     ', 'Status', 0, 4401, 0, 1, '', 0, 17233, 0, 0, '') ;

CALL ImportField(440100061, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 4401, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440100072, ' . ', 'FinTypeCode', ' . ', 'FINTYPE', 0, 4401, 0, 1, '', 0, 36853, 0, 0, '') ;

CALL ImportField(440101023, ' ', 'ActivityKind', ' ', 'ACTIVITYKIND', 0, 4401, 1, 1, '', 0, 21718, 0, 1, '') ;

CALL ImportField(440101024, ' ', 'ID', ' ', 'ID', 0, 4401, 1, 1, '', 0, 21710, 0, 1, '') ;

CALL ImportField(440101025, '', 'KCSR', '', 'KCSR', 0, 4401, 1, 1, '', 0, 21713, 0, 1, '') ;

CALL ImportField(440101026, '', 'KESR', '', 'KESRKey', 0, 4401, 1, 1, '', 0, 21716, 0, 1, '') ;

CALL ImportField(440101027, '()', 'KFSR', '', 'KFSR', 0, 4401, 1, 1, '', 0, 21714, 0, 1, '') ;

CALL ImportField(440101028, '', 'KVR', '', 'KVR', 0, 4401, 1, 1, '', 0, 21715, 0, 1, '') ;

CALL ImportField(440101029, '', 'KVSR', '', 'KVSR', 0, 4401, 1, 1, '', 0, 21712, 0, 1, '') ;

CALL ImportField(440101030, '', 'NOTE', '', 'Note', 0, 4401, 1, 0, '', 0, 21721, 0, 1, '') ;

CALL ImportField(440101031, '  ', 'SENDERID', '  ', 'SenderID', 0, 4401, 1, 1, '', 0, 21729, 0, 1, '') ;

CALL ImportField(440101032, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 0, 4401, 1, 1, '', 0, 21730, 0, 1, '') ;

CALL ImportField(440101035, '  ', 'SUMMAFIN', ' ', 'SUMMAFIN', 0, 4401, 1, 1, '', 0, 21724, 0, 1, '') ;

CALL ImportField(440101038, ' ', 'TargetClsCode', ' ', 'TargetCLS', 0, 4401, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(440101046, '()', 'CREATERUSER', '()', 'CreaterUser', 0, 4401, 1, 1, '', 0, 21732, 0, 1, '') ;

CALL ImportField(440101047, '()', 'UPDATERUSER', '()', 'UpdaterUser', 0, 4401, 1, 1, '', 0, 21734, 0, 1, '') ;

CALL ImportField(440101048, ' ()', 'UPDATEDATE', ' ()', 'UpdateDate', 0, 4401, 1, 1, '', 0, 21735, 0, 1, '') ;

CALL ImportField(440101049, ' ()', 'CREATEDATE', ' ()', 'CreateDate', 0, 4401, 1, 1, '', 0, 21733, 0, 1, '') ;

CALL ImportField(440101050, '  ()', 'IFS', 'IFS', 'IFS', 0, 4401, 1, 1, '', 0, 21717, 0, 1, '') ;

CALL ImportField(440101052, ' ', 'RECORDINDEX', 'RECORDINDEX', 'RecordIndex', 0, 4401, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440101053, '  , ', 'BA_LBO_FLAG', '  , ', 'BA_LBO_FLAG', 0, 4401, 1, 1, '_', 0, 25357, 0, 1, '_') ;

CALL ImportField(440101054, ' ', 'BUHOPERATIONCLS', ' ', ' ', 0, 4401, 1, 0, '', 0, 25358, 0, 0, '') ;

CALL ImportField(440101055, '    ', 'SummaYear1', '    ', 'SummaYear1', 0, 4401, 1, 1, '', 0, 25365, 0, 1, '') ;

CALL ImportField(440101056, '    ', 'SummaYear2', '    ', 'SummaYear2', 0, 4401, 1, 1, '', 0, 25366, 0, 1, '') ;

CALL ImportField(440101057, '    ', 'SummaYear3', '    ', 'SummaYear3', 0, 4401, 1, 1, '', 0, 25367, 0, 1, '') ;

CALL ImportField(440101058, '', 'DirectionCLSCode', '', ' ', 0, 4401, 1, 1, '', 0, 25359, 0, 0, '') ;

CALL ImportField(440101059, '', 'FactCode', '', ' ', 0, 4401, 1, 1, '', 0, 25360, 0, 0, '') ;

CALL ImportField(440101060, ' ', 'MeansType', '', ' ', 0, 4401, 1, 1, '', 0, 25361, 0, 0, '') ;

CALL ImportField(440101061, '', 'RegionCLS', '', ' ', 0, 4401, 1, 1, '', 0, 25362, 0, 0, '') ;

CALL ImportField(440101062, '', 'SubKESR', '', 'SubKESRKey', 0, 4401, 1, 1, '', 0, 25364, 0, 1, '') ;

CALL ImportField(440101063, ' ', 'SubsidyCls', '', ' ', 0, 4401, 1, 1, '', 0, 27636, 0, 0, '') ;

CALL ImportField(440101064, '  ', 'TransfertCls', '', ' ', 0, 4401, 1, 1, '', 0, 27637, 0, 0, '') ;

CALL ImportField(440101065, ' ', 'BudAllocationCLS', '', ' ', 0, 4401, 1, 1, '', 0, 27930, 0, 0, '') ;

CALL ImportField(440101066, '  ', 'PayPromiseCLS', '', ' ', 0, 4401, 1, 1, '', 0, 27931, 0, 0, '') ;

CALL ImportField(440101067, ' ', 'CLSTYPE', ' ', 'CLSTYPE', 0, 4401, 1, 1, '', 0, 21720, 0, 0, '') ;

CALL ImportField(440101070, ' ()', 'Fact', '', ' ', 0, 4401, 1, 1, '', 0, 25360, 0, 0, '') ;

CALL ImportField(440101071, ' .  ()', 'FinType', ' .  ()', 'FINTYPEKey', 0, 4401, 1, 1, '', 0, 36850, 0, 0, '') ;

CALL ImportField(440101072, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 4401, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440101073, ' ()', 'DirectionCLS', '', ' ', 0, 4401, 1, 1, '', 0, 25359, 0, 0, '') ;

CALL ImportField(440101074, '', 'InvestObject', '', 'InvestObjectKey', 0, 4401, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(440101075, '', 'InvestObjectCode', '', 'InvestObject', 0, 4401, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(440101076, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 4401, 1, 1, '', 0, 21719, 0, 1, '') ;

CALL ImportField(440101078, '()', 'KESRCode', '()', 'KESR', 0, 4401, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(440101079, '()', 'SubKESRCode', '()', 'SubKESR', 0, 4401, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(440111025, '', 'KCSR', '', 'KCSR', 1, 4401, 1, 1, '', 0, 21713, 0, 1, '') ;

CALL ImportField(440111026, '', 'KESR', '', 'KESRKey', 1, 4401, 1, 1, '', 0, 21716, 0, 1, '') ;

CALL ImportField(440111027, '()', 'KFSR', '', 'KFSR', 1, 4401, 1, 1, '', 0, 21714, 0, 1, '') ;

CALL ImportField(440111028, '', 'KVR', '', 'KVR', 1, 4401, 1, 1, '', 0, 21715, 0, 1, '') ;

CALL ImportField(440111029, '', 'KVSR', '', 'KVSR', 1, 4401, 1, 1, '', 0, 21712, 0, 1, '') ;

CALL ImportField(440111052, ' ', 'CLSTYPE', ' ', 'CLSTYPE', 1, 4401, 1, 1, '', 0, 21720, 0, 0, '') ;

CALL ImportField(440111054, ' ', 'BUHOPERATIONCLS', ' ', ' ', 1, 4401, 1, 0, '', 0, 25358, 0, 0, '') ;

CALL ImportField(440111062, '', 'SubKESR', '', 'SubKESRKey', 1, 4401, 1, 1, '', 0, 25364, 0, 1, '') ;

CALL ImportField(440111065, ' ', 'BudAllocationCLS', '', ' ', 1, 4401, 1, 1, '', 0, 27930, 0, 0, '') ;

CALL ImportField(440111070, '', 'InvestObject', '', 'InvestObjectKey', 1, 4401, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(440111071, '', 'InvestObjectCode', '', 'InvestObject', 1, 4401, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(440111077, '()', 'KESRCode', '()', 'KESR', 1, 4401, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(440111080, '()', 'SubKESRCode', '()', 'SubKESR', 1, 4401, 1, 0, '', 0, 43610, 0, 1, '') ;

--  ,, (0)
CALL ImportField(440300033, ' ', 'ID', ' ', ' ', 0, 4403, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(440300034, ' ', 'FACIALACCCLS', ' ', 'FacialAccCls', 0, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440300057, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 4403, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440301052, 'RECORDINDEX', 'RECORDINDEX', 'RECORDINDEX', ' ', 0, 4403, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(440301053, '', 'InvestObject', '', ' ', 0, 4403, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(440301054, '', 'InvestObjectCode', '', ' ', 0, 4403, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(440301069, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 4403, 1, 0, '', 0, null, 0, 2, '') ;

--  ,, (1)
CALL ImportField(440311025, '', 'KCSR', '', 'KCSRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311026, '', 'KESR', '', 'KESRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311027, '()', 'KFSR', '', 'KFSR', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311028, '', 'KVR', '', 'KVRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311029, '', 'KVSR', '', 'KVSRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311054, ' ', 'BUHOPERATIONCLS', ' ', ' ', 1, 4403, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(440311062, '', 'SubKESR', '', 'SubKESRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311071, '()', 'KESRCode', '()', 'KESR', 1, 4403, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(440311072, '()', 'SubKESRCode', '()', 'SubKESR', 1, 4403, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (0)
CALL ImportField(470100024, 'ID   ', 'FUID', '', 'FUID', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470100029, ' ', 'IsVised', '', 'IsVised', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470100030, '    ', 'IsInBudget', '', 'IsInBudget', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470100031, ' ', 'DocSuspended', '', 'DocSuspended', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470100032, '  ', 'SoftRejectCls', '', 'SoftRejectCls', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470100033, '   ()', 'SoftRejectCause', '', 'SoftRejectCause', 0, 4701, 0, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(470110001, ' ', 'SERIALNUMBER', '', 'SERIALNUMBER', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110002, '  ', 'STARTDATE', '', 'STARTDATE', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110003, '  ', 'ENDDATE', '', 'ENDDATE', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110004, ' ', 'OWNERORGANIZATION', '', 'OWNERORGANIZATION', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110005, '', 'OWNER', '', 'OWNER', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110006, '', 'NOTE', '', 'NOTE', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110007, ' ', 'ISENABLED', '', 'ISENABLED', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110008, ' ()', 'CREATERUSER', '', 'CREATERUSER', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110009, '  ()', 'CREATEDATE', '', 'CREATEDATE', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110010, ' ()', 'UPDATERUSER', '', 'UPDATERUSER', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110011, '  ()', 'UPDATEDATE', '', 'UPDATEDATE', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110012, 'ID', 'ID', '', 'ID', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110013, ' ', 'DocStateRef', '', 'DocStateRef', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110014, ' ', 'Accepted', '', 'Accepted', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110015, '  ', 'UseStartDate', '', 'UseStartDate', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110016, '  ', 'UseEndDate', '', 'UseEndDate', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110017, '  ', 'AuthSerialNumber', '', 'AuthSerialNumber', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110018, ' ', 'AuthOWNERORGANIZATION', '', 'AuthOWNERORGANIZATION', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110019, ' ', 'AdditionalInfo', '', 'AdditionalInfo', 2, 4701, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(470110020, ' ', 'AcceptDate', '', 'AcceptDate', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110021, ' ', 'RejectCls', '', 'RejectCls', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110022, '  ()', 'RejectCause', '', 'RejectCause', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110023, ' ', 'OperationType', '', 'OperationType', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110025, '', 'OwnerTitle', '', 'OwnerTitle', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110026, 'C  ', 'UserRef', '', 'UserRef', 2, 4701, 0, 1, 'C', 0, null, 0, 0, 'C') ;

CALL ImportField(470110027, '    ', 'AuthStartDate', '', 'AuthStartDate', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(470110028, '    ', 'AuthEndDate', '', 'AuthEndDate', 2, 4701, 0, 0, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(480100012, '  ', 'BeginDocStateRef', '', 'BeginDocStateRef', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480100018, '  ', 'IsInBudget', '', 'IsInBudget', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480100023, '  ', 'FUID', '', 'FUID', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480100025, '  ', 'SoftRejectCls', '', 'SoftRejectCls', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480100026, '  ()', 'SoftRejectCause', '', 'SoftRejectCause', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480100027, ' ', 'DocSuspended', '', 'DocSuspended', 0, 4801, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(480101024, '  ', 'FUID', '', 'FUID', 0, 4801, 1, 1, '', 0, null, 0, 0, '') ;

--  / , (0)
CALL ImportField(520100001, ' ', 'id', ' ', 'id', 0, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520100002, '   ', 'ISSUEDATE', '   ', 'ISSUEDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100004, ' ( )', 'LAWDEPARTMENTDATE', ' ( )', 'LAWDEPARTMENTDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100005, ' ( )', 'LAWDEPARTMENTNUMBER', ' ( )', 'LAWDEPARTMENTNUMBER', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100006, '    ', 'LEVIERACC_REF', '   ', 'LEVIERACC_REF', 0, 5201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520100007, '   ', 'LEVIERORG_REF', '   ', 'LEVIERORG_REF', 0, 5201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520100008, '  ', 'NAMEJUDICIALAGENCY', '  ', 'NAMEJUDICIALAGENCY', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100009, '  ', 'NAMEJUDICIALDECISION', '  ', 'NAMEJUDICIALDECISION', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100010, '', 'NOTE', '', 'NOTE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100011, '  ', 'UNIQUENUMBER', '    ', 'UNIQUENUMBER', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100012, '  ', 'PRESENTDATE', '   ', 'PRESENTDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100013, ' ', 'NUMBERDOSSIER', ' ', 'NUMBERDOSSIER', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100014, ' ', 'PROGINDEX', ' ', 'PROGINDEX', 0, 5201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520100015, '  ()', 'REJECTCAUSE', '  ()', 'REJECTCAUSE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100016, ' ', 'REJECT_CLS', ' ', 'REJECT_CLS', 0, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520100017, '  ', 'SHEETSCOUNT', '  ', 'SHEETSCOUNT', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100018, '   ', 'DELIVERYDATE', '   ', 'DELIVERYDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100019, '-    ', 'COURTSHEETSCOUNT', '    ', 'COURTSHEETSCOUNT', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100021, '      ', 'STARTDATE', '      ', 'STARTDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100026, '', 'BUDGETREF', '', ' ', 0, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520100029, '  ', 'DOCNUMBER', '  ', 'DOCNUMBER', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100030, '', 'DOCSTATEREF', '', 'DOCSTATEREF', 0, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520100032, '', 'ISINVALID', '   ,          ', 'ISINVALID', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100033, '/  ', 'FACIALACC_CLS', '/  ', 'FACIALACC_CLS', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100034, '', 'WRITEXECUTIONTOTALSUMMA', '', 'WRITEXECUTIONTOTALSUMMA', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100035, '', 'LevierParent', ' ', ' ', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100037, '()', 'LevierAcc', '()', 'LevierAccountName', 0, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520100038, '()', 'LevierInn', '()', 'LevierOrgINN', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100039, '()', 'LevierInn20', '()', 'LevierOrgKPP', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100043, ' ', 'ENDDATE', '     ', 'ENDDATE', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100051, '  ', 'CASECATEGORY', '  ', 'CASECATEGORY', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100052, '  ', 'WritType', '  : 0 - ; 1 - /; 2 -   ', 'WritType', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100053, '', 'WritPeriod', '   : 0 - ; 1 - ; 2 - ', 'WritPeriod', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100054, ' ', 'InnerNumber', '', 'InnerNumber', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100055, '  -', 'NameJudicialAgencyRef', '', 'NameJudicialAgencyRef', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100056, '  ', 'JudicialDecisionDate', '', 'JudicialDecisionDate', 0, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520100057, '  ', 'NumberPostNotice', '', 'NumberPostNotice', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100058, '  ', 'DatePostNotice', '', 'DatePostNotice', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100059, ' ', 'NumberDepartmentCB', '', 'NumberDepartmentCB', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100060, '()', 'LevierName', '', 'LevierName', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100061, '-', 'DestOrgName', '', ' ', 0, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520100062, ' ', 'CompletionDate', '   ', 'CompletionDate', 0, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520100063, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 5201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(520101001, '.  ', 'BudgetPromise', '.  ', 'BudgetPromise', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101002, '', 'BUDGETREF', '', 'BUDGETREF', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101003, '', 'DIRECTIONCLSCode', '', 'DIRECTIONCLS', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101004, ' ', 'DOCTYPE', ' ', 'DOCTYPE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101005, '  ', 'FACIALACC_CLS', '  ', 'FACIALACC_CLS', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101006, '', 'FACTCode', '', 'FACT', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101007, ' ', 'FINSOURCE', ' ', 'FINSOURCE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101008, ' . ', 'FINTYPECode', ' . ', 'FINTYPE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101009, '', 'KCSR', '', 'KCSRKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101010, '()', 'KCSRCode', '()', 'KCSRCode', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101011, '', 'KESR', '', 'KESRKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101012, '()', 'KFSR', '()', 'KFSR', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101013, '', 'KVR', '', 'KVRKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101014, '()', 'KVRCode', '()', 'KVRCode', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101015, '', 'KVSR', '', 'KVSRKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101016, '()', 'KVSRCode', '()', 'KVSRCode', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101017, ' ', 'MEANSTYPE', ' ', 'MEANSTYPE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101018, ' ', 'PROGINDEX', ' ', 'PROGINDEX', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101019, ' ', 'PROMISE', ' ', 'PROMISE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101020, ' ', 'RECORDINDEX', ' ', 'RECORDINDEX', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101021, '', 'REGIONCLS', '', 'REGIONCLS', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101022, '', 'SUBKESR', '', 'SUBKESRKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101023, '   ', 'WRITEXECUTIONSUMMA', '   ', 'WRITEXECUTIONSUMMA', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101030, '', 'MONTH01', '     ', 'MONTH01', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101031, '', 'MONTH02', '     ', 'MONTH02', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101032, '', 'MONTH03', '     ', 'MONTH03', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101033, '', 'MONTH04', '     ', 'MONTH04', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101034, '', 'MONTH05', '     ', 'MONTH05', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101035, '', 'MONTH06', '     ', 'MONTH06', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101036, '', 'MONTH07', '     ', 'MONTH07', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101037, '', 'MONTH08', '     ', 'MONTH08', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101038, '', 'MONTH09', '     ', 'MONTH09', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101039, '', 'MONTH10', '     ', 'MONTH10', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101040, '', 'MONTH11', '     ', 'MONTH11', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101041, '', 'MONTH12', '     ', 'MONTH12', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101042, ' 1', 'QUARTER1', '      ', 'QUARTER1', 0, 5201, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(520101043, ' 2', 'QUARTER2', '      ', 'QUARTER2', 0, 5201, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(520101044, ' 3', 'QUARTER3', '      ', 'QUARTER3', 0, 5201, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(520101045, ' 4', 'QUARTER4', '      ', 'QUARTER4', 0, 5201, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(520101046, '  ', 'MONTHLYDATE', '    ', 'MONTHLYDATE', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101047, '  ', 'QUARTERLYMONTHDAY', '     ', 'QUARTERLYMONTHDAY', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101048, '   ', 'QUARTERLYMONTHNUMBER', '      ', 'QUARTERLYMONTHNUMBER', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101049, '  ', 'PARENTID', '      .      ', ' ', 0, 5201, 1, 1, 'PARENTID', 0, null, 0, 0, '') ;

CALL ImportField(520101050, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101051, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101052, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101053, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101054, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101055, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 0, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520101056, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101057, '   ()', 'PayPromiseCls', '', 'PayPromiseCls', 0, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520101058, ' ', 'id', ' ', 'id', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101062, ' ()', 'FACT', '', 'FACTKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101063, ' . ()', 'FINTYPE', ' . ()', 'FINTYPEKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101064, ' ()', 'DIRECTIONCLS', '', 'DIRECTIONCLSKey', 0, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520101065, '', 'InvestObject', '', 'InvestObjectKey', 0, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520101066, '', 'InvestObjectCode', '', 'InvestObject', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101067, '', 'TreeOwner0', '', ' ', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101068, ' ', 'kd', ' ', 'KD', 0, 5201, 1, 1, '', 0, 38500, 0, 1, '') ;

CALL ImportField(520101069, ' ', 'KDCode', ' ', 'KDValue', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101070, ' ', 'ClsType', ' ', 'ClsType', 0, 5201, 1, 0, '', 0, 38499, 0, 1, '') ;

CALL ImportField(520101071, ' . ', 'BudgetPromiseCollaps', '', ' ', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101072, '  ( . -)', 'BudgetPromiseNum', '', ' ', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101073, ' ', 'Note', '  ', 'Note', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101074, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101075, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520101076, ' ', 'IFS', ' ', 'IFS', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101077, ' .  . .', 'IFSCode', ' .  . .', 'IFSValue', 0, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520101078, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 5201, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(520101080, ' ', 'TargetClsCode', ' ', 'TargetCLS', 0, 5201, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(520101081, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 5201, 1, 1, '', 0, 40888, 0, 1, '') ;

CALL ImportField(520101082, '   (.)', 'CaseCategory', '   (.)', 'CaseCategoryDet', 0, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520101083, '()', 'KESRCode', '()', 'KESR', 0, 5201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(520101085, '()', 'SubKESRCode', '()', 'SUBKESR', 0, 5201, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(520102001, ' ', 'id', ' ', 'id', 0, 5201, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520102002, '', 'NOTIFYCLS', ' ', 'NOTIFYCLS', 0, 5201, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520102003, '', 'DESCRIPTION', '', 'DESCRIPTION', 0, 5201, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520102004, '', 'NOTE', '', 'NOTE', 0, 5201, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520102005, ' ', 'RECORDINDEX', '  ', 'RECORDINDEX', 0, 5201, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520102006, '', 'NOTIFYNUMBER', ' ', 'NOTIFYNUMBER', 0, 5201, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520102007, '', 'NOTIFYDATE', ' ', 'NOTIFYDATE', 0, 5201, 2, 0, '', 0, null, 0, 1, '') ;

--  / , (1)
CALL ImportField(520110014, ' ', 'PROGINDEX', ' ', 'PROGINDEX', 1, 5201, 0, 1, '', 0, 25417, 0, 0, '') ;

CALL ImportField(520110043, '  ', 'DebtorName', '', 'DebtorName', 1, 5201, 0, 0, '', 0, 31831, 0, 0, '') ;

CALL ImportField(520111009, '', 'KCSR', '', 'KCSRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111010, '()', 'KCSRCode', '()', 'KCSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111011, '', 'KESR', '', 'KESRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111012, '()', 'KFSR', '()', 'KFSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111013, '', 'KVR', '', 'KVRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111014, '()', 'KVRCode', '()', 'KVR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111015, '', 'KVSR', '', 'KVSRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111016, '()', 'KVSRCode', '()', 'KVSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111022, '', 'SUBKESR', '', 'SUBKESRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111054, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111055, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111062, '', 'InvestObject', '', 'InvestObjectKey', 1, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520111063, '', 'InvestObjectCode', '', 'InvestObject', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111084, '()', 'KESRCode', '()', 'KESR', 1, 5201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(520111086, '()', 'SubKESRCode', '()', 'SUBKESR', 1, 5201, 1, 0, '', 0, 43610, 0, 1, '') ;

--  / , +(2)
CALL ImportField(520110006, '    ', 'LEVIERACC_REF', '   ', 'LEVIERACC_REF', 2, 5201, 0, 1, '', 0, 25409, 0, 0, '') ;

CALL ImportField(520110007, '   ', 'LEVIERORG_REF', '   ', 'LEVIERORG_REF', 2, 5201, 0, 1, '', 0, 25410, 0, 0, '') ;

CALL ImportField(520110039, '()', 'LevierInn20', '()', 'LevierOrgKPP', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110047, '', 'attr_LevierParent', ' ', ' ', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110060, '-', 'DestOrgName', '', ' ', 2, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520110068, ' -', '', ' -', 'LevierOrgCity', 2, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520110069, ' ', '', ' ', 'LevierFKFacialCode', 2, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111087, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111088, '   ()', 'PayTargetFunds', '   ', ' ', 2, 5201, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(540210001, ' ', 'ID', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540210002, ' ', 'FormDate', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540210003, ' ', 'ExportDate', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211001, '  ', 'RecordIndex', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211002, ' ', 'ID', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211003, ' ', 'PacketNumber', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211004, ' ', 'PageTab', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211005, ' ', 'PageID', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211006, ' ', 'WasError', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211007, '  ', 'NoData', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(550100004, ' ', 'InputDate', ' ', 'InputDate', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100005, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100006, ' ', 'Summa', ' ', 'Summa', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100007, '  ', 'OriginalProgindex', '  ', 'OriginalProgindex', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100008, ' ', 'OriginalAttr', ' ', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100009, '( )', 'OriginalNumber', '( )', 'OriginalNumber', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100010, '( )', 'OriginalSumma', '( )', 'OriginalSumma', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100011, '( )', 'OriginalDate', '( )', 'OriginalDate', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100012, ' ( )', 'OriginalNote', ' ( )', 'OriginalNote', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100013, '( )', 'OriginalPayerParent', '( )', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100014, ' ( \)', 'OriginalPayerhandBook', ' ()', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100015, '( \)', 'OriginalPayerAcc', '()', 'OriginalPayerAcc', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100016, '( \)', 'OriginalPayerOrgName', '()', 'OriginalPayerOrgName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100017, '( \)', 'OriginalPayerOrgInn', '()', 'OriginalPayerOrgInn', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100018, '( \)', 'OriginalPayerOrgInn20', '()', 'OriginalPayerOrgInn20', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100019, '( \)', 'OriginalPayerBankName', '()', 'OriginalPayerBankName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100020, '( \)', 'OriginalPayerBankMfo', '()', 'OriginalPayerBankMfo', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100021, '. ( \)', 'OriginalPayerBankCor', '. ()', 'OriginalPayerBankCor', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100022, '_( \)', 'OriginalPayerFKOrgINN', '_()', 'OriginalPayerFKOrgINN', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100023, '_( \)', 'OriginalPayerFKOrgName', '_()', 'OriginalPayerFKOrgName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100024, '_( \)', 'OriginalPayerFKLS', '_()', 'OriginalPayerFKLS', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100025, '_( \)', 'OriginalPayerFKCode', '_()', 'OriginalPayerFKCode', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100026, '( )', 'OriginalAcceptorParent', '( )', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100027, ' ( \)', 'OriginalAcceptorHandBook', ' ()', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100028, '( \)', 'OriginalAcceptorAcc', '()', 'OriginalAcceptorAcc', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100029, '( \)', 'OriginalAcceptorOrgName', '()', 'OriginalAcceptorOrgName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100030, '( \)', 'OriginalAcceptorOrgInn', '()', 'OriginalAcceptorOrgInn', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100031, '( \)', 'OriginalAcceptorOrgInn20', '()', 'OriginalAcceptorOrgInn20', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100032, '( \)', 'OriginalAcceptorBankName', '()', 'OriginalAcceptorBankName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100033, '( \)', 'OriginalAcceptorBankMfo', '()', 'OriginalAcceptorBankMfo', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100034, '. ( \)', 'OriginalAcceptorBankCor', '. ()', 'OriginalAcceptorBankCor', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100035, '_( \)', 'OriginalAcceptorFKOrgINN', '_()', 'OriginalAcceptorFKOrgINN', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100036, '_( \)', 'OriginalAcceptorFKOrgName', '_()', 'OriginalAcceptorFKOrgName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100037, '_( \)', 'OriginalAcceptorFKLS', '_()', 'OriginalAcceptorFKLS', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100038, '_( \)', 'OriginalAcceptorFKCode', '_()', 'OriginalAcceptorFKCode', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100039, '', 'NoteEx', '', 'NoteEx', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100040, '', 'Note', '', 'Note', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100041, ' ', 'Reject_Cls', ' ', 'RejectCls', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100042, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100044, ' ', 'DocType', ' ', 'DocType', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100045, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100046, '', 'OriginalRecordindex', '', 'OriginalRecordindex', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100047, '', 'OriginalPayerAcc_Ref', '', 'OriginalPayerAcc_Ref', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100048, '', 'OriginalAcceptorAcc_Ref', '', 'OriginalAcceptorAcc_Ref', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100082, '   ', 'PayDocRef', '', ' ', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100090, ' ', 'id', ' ', 'ID', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100094, '  ', 'ElDocRef', '  ', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100095, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100096, ' ', 'RecordDate', ' ', 'RecordDate', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100097, '( \)', 'OriginalPayerBankFilName', '()', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100098, '( \)', 'OriginalAcceptorBankFilName', '()', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100099, '( )', 'AdminAcceptorInn', '( )', 'AdminAcceptorInn', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100100, '( )', 'AdminAcceptorInn20', '( )', 'AdminAcceptorInn20', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100101, ' ( )', 'TerritorialFKParent', ' ( )', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100102, '( \ )', 'TerritorialFKInn', '( )', 'TerritorialFKInn', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100103, '( \ )', 'TerritorialFKInn20', '( )', 'TerritorialFKInn20', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100104, '  ', 'FKParent', '  ', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100105, '(  )', 'FKInn', '(  )', 'FKInn', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100106, '(  )', 'FKInn20', '(  )', 'FKInn20', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100107, '(  )', 'FKName', '(  )', 'FKName', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100109, '', 'BasicNote', '', 'BasicNote', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100110, ' ', 'IsVised', ' ', 'IsVised', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100111, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100112, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100113, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550100114, '  ', 'LastExtrChange', '  ', 'LastExtrChange', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100140, ' . ( )', 'ELNUM', '', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100141, ' ', 'PersonalInfo', '', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100153, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100159, ' ', 'RequestNUmber', ' ', 'RequestNUmber', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100161, ' ', 'DocNumber', ' ', 'DocNumber', 0, 5501, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550100162, ' ', 'FoAcc', ' ', ' ', 0, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550100163, ' ', 'RegionContractor', ' ', 'RegionContractor', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100164, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 5501, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550100165, '()', 'CREATERUSER', '()', ' ', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100166, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100167, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550100168, '  ()', 'CREATEDATE', '  ()', ' ', 0, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101049, '', 'ParentId', '', 'ParentId', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101050, ' ', 'OriginalClassification', ' ', ' ', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101051, '', 'Summa', '', 'Summa', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101052, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101053, '', 'TreeOwner0', '', ' ', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101054, '', 'KVSR', '()', 'KVSRKey', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101055, '()', 'KFSR', '()', 'KFSR', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101056, '', 'KCSR', '()', 'KCSRKey', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101057, '', 'KVR', '()', 'KVRKey', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101058, '', 'KESR', '', 'KESRKey', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101066, ' ', 'clstype', ' ', 'clstype', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101067, '', 'DirectionClsCode', '', 'DirectionCls', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101068, '', 'FACTCode', '', 'FACT', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101069, ' ', 'MeansType', ' ', 'MeansType', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101070, ' ', 'FinSource', ' ', 'FinSource', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101071, ' . ', 'FinTypeCode', '  ', 'FinType', 0, 5501, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(550101072, ' ', 'DOCTYPE', ' ', 'DOCTYPE', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101073, '', 'REGIONCLS', '', 'REGIONCLS', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101074, '', 'SubKesr', '', 'SubKesrKey', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101075, ' ', 'FundsSource', ' ', 'FundsSource', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101077, ' ', 'DocumentProgIndex', ' ', 'DocumentProgIndex', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101078, ' ', 'ChangeParent', ' ', ' ', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101079, ' ( )', 'ChangeHandBook', ' ( )', ' ', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101080, '( )', 'ChangeAcc', '( )', 'ChangeAcc', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101081, '( )', 'ChangeOrgName', '( )', 'ChangeOrgName', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101082, '( )', 'ChangeOrgINN', '( )', 'ChangeOrgINN', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101083, '( )', 'ChangeOrgINN20', '( )', 'ChangeOrgINN20', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101084, '( )', 'IsBlocked', '( )', 'IsBlocked', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101085, ' ( )', 'BlockedCause', ' ( )', 'BlockedCause', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101086, ' ( )', 'UnBlockedDate', ' ( )', 'UnBlockedDate', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101087, ' ( )', 'UnBlockedCause', ' ( )', 'UnBlockedCause', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101088, ' ', 'IFS', ' ', 'IFS', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101090, ' ', 'kd', ' ', 'kd', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101091, '  ', 'ChangeAcc_Ref', '  ', 'ChangeAcc_Ref', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101092, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101108, '', 'Note', '', 'Note', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101110, '  ', 'RecordIndex', ' ', 'RecordIndex', 0, 5501, 1, 1, '', 0, 22938, 0, 1, '') ;

CALL ImportField(550101111, ' ', 'id', ' ', 'ID', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101115, '     ', '', '     ', 'DestBudgetPromise', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101116, '.  ', 'BudgetPromise', '', 'BudgetPromise', 0, 5501, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(550101117, ' ', 'BudgetPromiseAgrDate', ' ', 'BudgetPromiseAgrDate', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101118, ' ', 'BudgetPromiseAgrNum', ' ', 'BudgetPromiseAgrNum', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101119, '  .', 'BudgetPromiseAgrRNum', '  .', 'BudgetPromiseAgrRNum', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101121, ' . -', 'BudgetPromiseCollaps', '  ', 'BudgetPromiseCollaps', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101122, ' ( . -)', 'BudgetPromiseNum', '  ()', 'BudgetPromiseNum', 0, 5501, 1, 0, ',', 0, 20223, 0, 0, '') ;

CALL ImportField(550101123, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseSODate', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101124, '. . ', 'BudgetPromiseSONote', '. . ', 'BudgetPromiseSONote', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101125, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseSONum', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101126, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseSORNum', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101127, ' . ', 'BudgetPromiseSOSumma', ' . ', ' ', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101128, ' ', 'BudgetPromiseSumma', ' ', 'BudgetPromiseSumma', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101129, ' .. ', 'ExecDoc', '', 'ExecDoc', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101130, '. ', 'ExecDocCollaps', '', ' ', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101131, '(.  )', 'ExecDocDate', '  ', 'ExecDocDate', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101132, '(.  )', 'ExecDocNote', '  ', 'ExecDocNote', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101133, '(. )', 'ExecDocNum', '', 'ExecDocNum', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101134, ' (.  )', 'ExecDocReestr', '   ', 'ExecDocReestr', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101135, '(.  )', 'ExecDocSumma', '   ', 'ExecDocSumma', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101136, '(.  )', 'ExecDocType', '  ', 'ExecDocType', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101141, ' ', 'ADDOKATO', '', 'ADDOKATO', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101142, '', 'OKATO', '', 'OKATO', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101143, '   ', 'ORIGINALCLSSUMMA', '   ', 'ORIGINALCLSSUMMA', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101144, '     ', 'NoteCls', '     ', 'NoteCls', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101152, ' ', 'OperationType', ' ', 'OperationType', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101154, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101155, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101156, '()', 'KCSRCode', '()', 'KCSR', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101157, '()', 'KVRCode', '()', 'KVR', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101158, '()', 'KVSRCode', '()', 'KVSR', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101162, ' ', 'KDCode', ' ', 'KDValue', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101163, ' .  . .', 'IFSCode', ' .  . .', 'IFSValue', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101164, ' ', 'PROMISE', ' ', 'PROMISE', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101165, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101166, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550101167, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 5501, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550101168, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 0, 5501, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550101169, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 5501, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550101170, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 0, 5501, 1, 1, '', 0, 27839, 0, 1, '') ;

CALL ImportField(550101171, ' ()', 'FACT', '', 'FactKey', 0, 5501, 1, 1, '', 0, 22922, 0, 1, '') ;

CALL ImportField(550101172, ' .  ()', 'FinType', '  ', 'FinTypeKey', 0, 5501, 1, 1, ',', 0, 22925, 0, 1, '') ;

CALL ImportField(550101173, '()', 'DirectionCls', '', 'DirectionClsKey', 0, 5501, 1, 1, '', 0, 22920, 0, 1, '') ;

CALL ImportField(550101174, '', 'InvestObject', '', 'InvestObjectKey', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101175, '', 'InvestObjectCode', '', 'InvestObject', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101176, '', 'OKTMOCode', '', 'OKTMOCode', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101177, '', 'OKTMO', '', 'OKTMO', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550101178, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101179, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550101180, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 5501, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550101181, ' ', 'TargetClsCode', ' ', 'TargetCLS', 0, 5501, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(550101182, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 5501, 1, 1, '', 0, 40890, 0, 1, '') ;

CALL ImportField(550101183, '()', 'CREATERUSER', '()', ' ', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101184, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101185, '  ()', 'CREATEDATE', '  ()', ' ', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101186, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550101188, '()', 'KESRCode', '()', 'KESR', 0, 5501, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550101190, '()', 'SubKESRCode', '()', 'SubKESR', 0, 5501, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(550101191, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 0, 5501, 1, 1, '', 0, null, 0, 1, '') ;

--    , (1)
CALL ImportField(550110046, '', 'OriginalRecordindex', '', 'OriginalRecordindex', 1, 5501, 0, 1, '', 0, 22862, 0, 0, '') ;

CALL ImportField(550110099, '( )', 'AdminAcceptorInn', '( )', 'AdminAcceptorInn', 1, 5501, 0, 0, '', 0, 22895, 0, 0, '') ;

CALL ImportField(550110100, '( )', 'AdminAcceptorInn20', '( )', 'AdminAcceptorInn20', 1, 5501, 0, 0, '', 0, 22896, 0, 0, '') ;

CALL ImportField(550111054, '', 'KVSR', '()', 'KVSRKey', 1, 5501, 1, 1, '', 0, 22915, 0, 1, '') ;

CALL ImportField(550111055, '()', 'KFSR', '()', 'KFSR', 1, 5501, 1, 0, '', 0, 22916, 0, 1, '') ;

CALL ImportField(550111056, '', 'KCSR', '()', 'KCSRKey', 1, 5501, 1, 1, '', 0, 22917, 0, 1, '') ;

CALL ImportField(550111057, '', 'KVR', '()', 'KVRKey', 1, 5501, 1, 1, '', 0, 22918, 0, 1, '') ;

CALL ImportField(550111058, '', 'KESR', '', 'KESRKey', 1, 5501, 1, 1, '', 0, 22919, 0, 1, '') ;

CALL ImportField(550111074, '', 'SubKesr', '', 'SubKESRKey', 1, 5501, 1, 1, '', 0, 22927, 0, 1, '') ;

CALL ImportField(550111076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCls', 1, 5501, 1, 0, '', 0, 22931, 0, 1, '') ;

CALL ImportField(550111114, ' .. ', 'ExecDoc', ' .. ', 'ExecDoc', 1, 5501, 1, 1, '', 0, 25284, 0, 1, '') ;

CALL ImportField(550111125, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseSODate', 1, 5501, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(550111127, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseSONum', 1, 5501, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(550111129, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseSORNum', 1, 5501, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(550111146, '()', 'KCSRCode', '()', 'KCSR', 1, 5501, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(550111147, '()', 'KVRCode', '()', 'KVR', 1, 5501, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(550111148, '()', 'KVSRCode', '()', 'KVSR', 1, 5501, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(550111157, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5501, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550111158, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 5501, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550111160, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 5501, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550111166, '', 'InvestObject', '', 'InvestObjectKey', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111167, '', 'InvestObjectCode', '', 'InvestObject', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111187, '()', 'KESRCode', '()', 'KESR', 1, 5501, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550111189, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5501, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(550111190, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 1, 5501, 1, 1, '', 0, null, 0, 1, '') ;

--    , +(2)
CALL ImportField(550111192, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111193, '   ()', 'PayTargetFunds', '   ', ' ', 2, 5501, 1, 1, '', 0, null, 0, 0, '') ;

--    , (0)
CALL ImportField(550200001, '', 'DocStateRef', '', 'DocStateRef', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200002, ' ', 'DocNumber', ' ', 'DocNumber', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200004, ' ', 'InputDate', ' ', 'InputDate', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200005, ' ', 'AcceptDate', ' ', 'AcceptDate', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200006, ' ', 'Summa', ' ', 'Summa', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200007, '  ', 'OriginalProgindex', '  ', 'OriginalProgindex', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200008, ' ', 'OriginalAttr', ' ', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200010, '( )', 'OriginalSumma', '( )', 'OriginalSumma', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200011, '( )', 'OriginalDate', '( )', 'OriginalDate', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200012, ' ( )', 'OriginalNote', ' ( )', 'OriginalNote', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200013, '( )', 'OriginalPayerParent', '( )', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200014, ' ( \)', 'OriginalPayerhandBook', ' ()', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200015, '( \)', 'OriginalPayerAcc', '()', 'OriginalPayerAcc', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200016, '( \)', 'OriginalPayerOrgName', '()', 'OriginalPayerOrgName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200017, '( \)', 'OriginalPayerOrgInn', '()', 'OriginalPayerOrgInn', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200018, '( \)', 'OriginalPayerOrgInn20', '()', 'OriginalPayerOrgInn20', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200019, '( \)', 'OriginalPayerBankName', '()', 'OriginalPayerBankName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200020, '( \)', 'OriginalPayerBankMfo', '()', 'OriginalPayerBankMfo', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200021, '. ( \)', 'OriginalPayerBankCor', '. ()', 'OriginalPayerBankCor', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200022, '_( \)', 'OriginalPayerFKOrgINN', '_()', 'OriginalPayerFKOrgINN', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200023, '_( \)', 'OriginalPayerFKOrgName', '_()', 'OriginalPayerFKOrgName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200024, '_( \)', 'OriginalPayerFKLS', '_()', 'OriginalPayerFKLS', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200025, '_( \)', 'OriginalPayerFKCode', '_()', 'OriginalPayerFKCode', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200026, '( )', 'OriginalAcceptorParent', '( )', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200027, ' ( \)', 'OriginalAcceptorHandBook', ' ()', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200028, '( \)', 'OriginalAcceptorAcc', '()', 'OriginalAcceptorAcc', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200029, '( \)', 'OriginalAcceptorOrgName', '()', 'OriginalAcceptorOrgName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200030, '( \)', 'OriginalAcceptorOrgInn', '()', 'OriginalAcceptorOrgInn', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200031, '( \)', 'OriginalAcceptorOrgInn20', '()', 'OriginalAcceptorOrgInn20', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200032, '( \)', 'OriginalAcceptorBankName', '()', 'OriginalAcceptorBankName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200033, '( \)', 'OriginalAcceptorBankMfo', '()', 'OriginalAcceptorBankMfo', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200034, '. ( \)', 'OriginalAcceptorBankCor', '. ()', 'OriginalAcceptorBankCor', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200035, '_( \)', 'OriginalAcceptorFKOrgINN', '_()', 'OriginalAcceptorFKOrgINN', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200036, '_( \)', 'OriginalAcceptorFKOrgName', '_()', 'OriginalAcceptorFKOrgName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200037, '_( \)', 'OriginalAcceptorFKLS', '_()', 'OriginalAcceptorFKLS', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200038, '_( \)', 'OriginalAcceptorFKCode', '_()', 'OriginalAcceptorFKCode', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200039, '', 'NoteEx', '', 'NoteEx', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200040, '', 'Note', '', 'Note', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200041, ' ', 'Reject_Cls', ' ', 'RejectCls', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200042, '  ()', 'RejectCause', '  ()', 'RejectCause', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200044, ' ', 'DocType', ' ', 'DocType', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200045, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200046, '', 'OriginalRecordindex', '', 'OriginalRecordindex', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200047, '', 'OriginalPayerAcc_Ref', '', 'OriginalPayerAcc_Ref', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200048, '', 'OriginalAcceptorAcc_Ref', '', 'OriginalAcceptorAcc_Ref', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200082, '   ', 'PayDocRef', '', ' ', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200090, ' ', 'id', ' ', 'id', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200094, '  ', 'io', '', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200095, ' ', 'OperationDirection', ' ', 'OperationDirection', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200096, ' ', 'RecordDate', ' ', 'RecordDate', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200097, '( \)', 'OriginalPayerBankFilName', '()', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200098, '( \)', 'OriginalAcceptorBankFilName', '()', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200099, '( )', 'AdminAcceptorInn', '( )', 'AdminAcceptorInn', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200100, '( )', 'AdminAcceptorInn20', '( )', 'AdminAcceptorInn20', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200101, ' ( )', 'TerritorialFKParent', ' ( )', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200102, '( \ )', 'TerritorialFKInn', '( )', 'TerritorialFKInn', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200103, '( \ )', 'TerritorialFKInn20', '( )', 'TerritorialFKInn20', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200104, '  ', 'FKParent', '  ', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200105, '(  )', 'FKInn', '(  )', 'FKInn', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200106, '(  )', 'FKInn20', '(  )', 'FKInn20', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200107, '(  )', 'FKName', '(  )', 'FKName', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200108, '', 'BasicNote', '', 'BasicNote', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200111, '( )', 'OriginalNumber', '( )', 'OriginalNumber', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200112, ' ', 'IsVised', ' ', 'IsVised', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200113, '  ', 'IsInBudget', '  ', 'IsInBudget', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200114, ' ', 'DocSuspended', ' ', 'DocSuspended', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200115, '  ', 'BeginDocStateRef', '  ', 'BeginDocStateRef', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200116, '  ', '', '  ', 'LASTEXTRCHANGE', 0, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550200120, ' . ( )', 'ELNUM', '', 'ELNUM', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200121, ' ', 'PersonalInfo', '', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200137, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 0, 5502, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550200138, '  ', 'ElDocRef', '  ', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200144, ' ', 'RequestNUmber', ' ', 'RequestNUmber', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200145, ' ', 'FoAcc', ' ', ' ', 0, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550200146, ' ', 'RegionContractor', ' ', 'RegionContractor', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200148, '.  ', 'StoredContent', '.  ', 'StoredContent', 0, 5502, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550200149, '()', 'CREATERUSER', '()', ' ', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200150, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200151, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550200152, '  ()', 'CREATEDATE', '  ()', ' ', 0, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201049, '', 'ParentId', '', 'ParentId', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201050, ' ', 'OriginalClassification', ' ', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201051, '', 'Summa', '', 'Summa', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201052, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201053, '', 'TreeOwner0', '', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201054, '', 'KVSR', '()', 'KVSRKey', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201055, '()', 'KFSR', '()', 'KFSR', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201056, '', 'KCSR', '()', 'KCSRKey', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201057, '', 'KVR', '()', 'KVRKey', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201058, '', 'KESR', '', 'KESRKey', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201062, '()', 'KDKVSR', '()', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201066, ' ', 'ClsType', ' ', 'ClsType', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201067, '', 'DirectionClsCode', '', 'DirectionCls', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201068, '', 'FACTCode', '', 'FACT', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201069, ' ', 'MeansType', ' ', 'MeansType', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201070, ' ', 'FinSource', ' ', 'FinSource', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201071, ' . ', 'FinTypeCode', '  ', 'FinType', 0, 5502, 1, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(550201072, ' ', 'DOCTYPE', ' ', 'DOCTYPE', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201073, '', 'REGIONCLS', '', 'REGIONCLS', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201074, '', 'SubKesr', '', 'SubKesrKey', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201075, ' ', 'FundsSource', ' ', 'FundsSource', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201077, ' ', 'DocumentProgIndex', ' ', 'DocumentProgIndex', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201078, ' ', 'ChangeParent', ' ', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201079, ' ( )', 'ChangeHandBook', ' ( )', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201080, '( )', 'ChangeAcc', '( )', 'ChangeAcc', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201081, '( )', 'ChangeOrgName', '( )', 'ChangeOrgName', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201082, '( )', 'ChangeOrgINN', '( )', 'ChangeOrgINN', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201083, '( )', 'ChangeOrgINN20', '( )', 'ChangeOrgINN20', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201084, '( )', 'IsBlocked', '( )', 'IsBlocked', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201085, ' ( )', 'BlockedCause', ' ( )', 'BlockedCause', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201086, ' ( )', 'UnBlockedDate', ' ( )', 'UnBlockedDate', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201087, ' ( )', 'UnBlockedCause', ' ( )', 'UnBlockedCause', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201088, ' ', 'IFS', ' ', 'IFS', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201089, ' ', 'id', ' ', 'id', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201090, ' ', 'kd', ' ', 'kd', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201091, '  ', 'ChangeAcc_Ref', '  ', 'ChangeAcc_Ref', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201092, ' ', 'ProgIndex', ' ', 'ProgIndex', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201093, '', 'DocumentRecordIndex', '', 'DocumentRecordIndex', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201108, '', 'Note', '', 'Note', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201110, ' ', 'RecordIndex', ' ', 'RecordIndex', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201122, ' ', 'ADDOKATO', '', 'ADDOKATO', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201123, '', 'OKATO', '', 'OKATO', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201133, '   ', 'ORIGINALCLSSUMMA', '   ', 'ORIGINALCLSSUMMA', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201134, '     ', 'NoteCls', '     ', 'NoteCls', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201135, ' ', 'OperationType', ' ', 'OperationType', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201139, '  ', 'TransfertCls', '   ()', 'TransfertCls', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201140, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201141, '()', 'KCSRCode', '()', 'KCSR', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201142, '()', 'KVRCode', '()', 'KVR', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201143, '()', 'KVSRCode', '()', 'KVSR', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201147, ' .. ', 'ExecDoc', '', 'ExecDoc', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201148, ' ( . -)', 'BudgetPromiseNum', '  ()', 'BudgetPromiseNum', 0, 5502, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(550201149, '. ', 'ExecDocCollaps', '', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201150, ' ', 'KDCode', ' ', 'KDValue', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201151, ' .  . .', 'IFSCode', ' .  . .', 'IFSValue', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201152, ' ', 'PROMISE', ' ', 'PROMISE', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201167, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 0, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550201168, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201169, ' . -', 'BudgetPromiseCollaps', ' . -', ' ', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201170, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 0, 5502, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550201171, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 0, 5502, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550201172, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 0, 5502, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550201173, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 0, 5502, 1, 1, '', 0, 27839, 0, 1, '') ;

CALL ImportField(550201174, ' ()', 'FACT', '', 'FactKey', 0, 5502, 1, 1, '', 0, 22922, 0, 1, '') ;

CALL ImportField(550201175, ' .  ()', 'FinType', '  ', 'FinTypeKey', 0, 5502, 1, 1, ',', 0, 22925, 0, 1, '') ;

CALL ImportField(550201176, ' ()', 'DirectionCls', '', 'DirectionClsKey', 0, 5502, 1, 1, '', 0, 22920, 0, 1, '') ;

CALL ImportField(550201177, '', 'OKTMO', '', 'OKTMO', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201178, '', 'OKTMOCode', '', 'OKTMOCode', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201179, '', 'InvestObject', '', 'InvestObjectKey', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201180, '', 'InvestObjectCode', '', 'InvestObject', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201181, '.  ', 'BudgetPromise', '.  ', 'BUDGETPROMISE', 0, 5502, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(550201182, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201183, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201184, ' ', 'BudgetPromiseAgrDate', ' ', 'BudgetPromiseAgrDate', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201185, ' ', 'BudgetPromiseAgrNum', ' ', 'BudgetPromiseAgrNum', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201186, '  .', 'BudgetPromiseAgrRNum', '  .', 'BudgetPromiseAgrRNum', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201187, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseSODate', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201188, '. . ', 'BudgetPromiseSONote', '. . ', 'BudgetPromiseSONote', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201189, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseSONum', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201190, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseSORNum', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201191, ' . ', 'BudgetPromiseSOSumma', ' . ', ' ', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201192, ' ', 'BudgetPromiseSumma', ' ', 'BudgetPromiseSumma', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550201193, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 0, 5502, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550201194, ' ', 'TargetClsCode', ' ', 'TargetCLS', 0, 5502, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(550201195, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 5502, 1, 1, '', 0, 40890, 0, 1, '') ;

CALL ImportField(550201196, '()', 'CREATERUSER', '()', ' ', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201197, ' ()', 'UPDATERUSER', ' ()', ' ', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201198, '  ()', 'CREATEDATE', '  ()', ' ', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201199, '  ()', 'UPDATEDATE', '  ()', ' ', 0, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550201201, '()', 'KESRCode', '()', 'KESR', 0, 5502, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550201203, '()', 'SubKESRCode', '()', 'SubKESR', 0, 5502, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(550201204, '(. )', 'ExecDocNum', '(. )', 'ExecDocNum', 0, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550201205, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 0, 5502, 1, 1, '', 0, null, 0, 1, '') ;

--    , (1)
CALL ImportField(550210046, '', 'OriginalRecordindex', '', 'OriginalRecordindex', 1, 5502, 0, 1, '', 0, 22862, 0, 0, '') ;

CALL ImportField(550210099, '( )', 'AdminAcceptorInn', '( )', 'AdminAcceptorInn', 1, 5502, 0, 0, '', 0, 22895, 0, 0, '') ;

CALL ImportField(550210100, '( )', 'AdminAcceptorInn20', '( )', 'AdminAcceptorInn20', 1, 5502, 0, 0, '', 0, 22896, 0, 0, '') ;

CALL ImportField(550211054, '', 'KVSR', '()', 'KVSRKey', 1, 5502, 1, 1, '', 0, 22915, 0, 1, '') ;

CALL ImportField(550211055, '()', 'KFSR', '()', 'KFSR', 1, 5502, 1, 0, '', 0, 22916, 0, 1, '') ;

CALL ImportField(550211056, '', 'KCSR', '()', 'KCSRKey', 1, 5502, 1, 1, '', 0, 22917, 0, 1, '') ;

CALL ImportField(550211057, '', 'KVR', '()', 'KVRKey', 1, 5502, 1, 1, '', 0, 22918, 0, 1, '') ;

CALL ImportField(550211058, '', 'KESR', '', 'KESRKey', 1, 5502, 1, 1, '', 0, 22919, 0, 1, '') ;

CALL ImportField(550211074, '', 'SubKesr', '', 'SubKESRKey', 1, 5502, 1, 1, '', 0, 22927, 0, 1, '') ;

CALL ImportField(550211076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCls', 1, 5502, 1, 0, '', 0, 22931, 0, 1, '') ;

CALL ImportField(550211113, ' .. ', 'ExecDoc', ' .. ', 'ExecDoc', 1, 5502, 1, 1, '', 0, 25284, 0, 1, '') ;

CALL ImportField(550211127, '()', 'KCSRCode', '()', 'KCSR', 1, 5502, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(550211128, '()', 'KVRCode', '()', 'KVR', 1, 5502, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(550211129, '()', 'KVSRCode', '()', 'KVSR', 1, 5502, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(550211136, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5502, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550211137, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 5502, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550211139, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 5502, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550211145, '', 'InvestObject', '', 'InvestObjectKey', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211146, '', 'InvestObjectCode', '', 'InvestObject', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211152, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseSODate', 1, 5502, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(550211154, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseSONum', 1, 5502, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(550211155, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseSORNum', 1, 5502, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(550211200, '()', 'KESRCode', '()', 'KESR', 1, 5502, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550211202, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5502, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(550211203, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 1, 5502, 1, 1, '', 0, null, 0, 1, '') ;

--    , +(2)
CALL ImportField(550211002, ' ', 'ExecDocDate', '  ', 'ExecDocDate', 2, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550211206, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211207, '   ()', 'PayTargetFunds', '   ', ' ', 2, 5502, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(550311005, ' ', 'BudAllocationCls', '   ()', 'BudAllocationCls', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311011, '', 'KVSR', '', 'KVSR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311012, '()', 'Kfsr', '', 'Kfsr', 1, 5503, 1, 0, '', 0, 31729, 0, 0, '') ;

CALL ImportField(550311013, '', 'KCSR', '', 'KCSR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311014, '', 'KVR', '', 'KVR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311015, '', 'Kesr', '', 'KesrKey', 1, 5503, 1, 1, '', 0, 31728, 0, 0, '') ;

CALL ImportField(550311016, '', 'SubKESR', '', 'SubKESRKey', 1, 5503, 1, 1, '', 0, 31738, 0, 0, '') ;

CALL ImportField(550311022, '  ()', 'KD', ' ', 'KD', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311030, ' ', 'BudAllocationClsCode', '  ', 'BudAllocationClsCode', 1, 5503, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550311036, '()', 'KcsrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(550311041, '()', 'KvrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(550311042, '()', 'KvsrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(550311068, '()', 'KESRCode', '()', 'Kesr', 1, 5503, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(550311070, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5503, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(550311072, ' ', 'KDValue', ' ', 'KDValue', 1, 5503, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550311073, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 1, 5503, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550311074, '   ()', 'PayTargetFunds', '   ', ' ', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311077, '   ', 'IncomeTargetFundsCode', '   ', 'IncomeTargetFunds', 1, 5503, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550311078, '   ()', 'IncomeTargetFunds', '   ', ' ', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311081, '     ', 'AnalyticalPartitionCode', '     ', 'AnalyticalPartition', 1, 5503, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550311082, '     ()', 'AnalyticalPartition', '     ', ' ', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311085, '  ', 'RegProjectResultCode', '  ', 'RegProjectResult', 1, 5503, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550311086, '  ()', 'RegProjectResult', '  ', ' ', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312006, ' ', 'BudAllocationClsCode', '', ' ', 1, 5503, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550312017, '()', 'KcsrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(550312022, '', 'Kesr', '', 'KesrKey', 1, 5503, 2, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(550312023, '()', 'Kfsr', '', ' ', 1, 5503, 2, 0, '', 0, 17411, 0, 0, '') ;

CALL ImportField(550312024, '()', 'KvrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(550312025, '()', 'KvsrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(550312030, '', 'SubKesr', '', 'SubKESRKey', 1, 5503, 2, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(550312041, '', 'Kvsr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312042, '', 'Kvr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312043, '', 'Kcsr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312047, ' ', 'BudAllocationCls', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312069, '()', 'KESRCode', '()', 'Kesr', 1, 5503, 2, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(550312071, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5503, 2, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(550312075, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 1, 5503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550312076, '   ()', 'PayTargetFunds', '   ', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312079, '   ', 'IncomeTargetFundsCode', '   ', 'IncomeTargetFunds', 1, 5503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550312080, '   ()', 'IncomeTargetFunds', '   ', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312083, '     ', 'AnalyticalPartitionCode', '     ', 'AnalyticalPartition', 1, 5503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550312084, '     ()', 'AnalyticalPartition', '     ', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312087, '  ', 'RegProjectResultCode', '  ', 'RegProjectResult', 1, 5503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550312088, '  ()', 'RegProjectResult', '  ', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

-- , (0)
CALL ImportField(960100032, ' ()', 'NAME', '', ' ', 0, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960100034, ' ', 'SHORTNAME', '', ' ', 0, 9601, 0, 0, '', 0, null, 0, 0, '') ;

-- , +(2)
CALL ImportField(960110032, ' ()', 'ORG_NAME', '', ' ', 2, 9601, 0, 0, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(960200003, ' ()', 'ACC_REF', '', ' ', 0, 9602, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960200009, ' ', 'ACOMMENT', '', ' ', 0, 9602, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960200013, '  ', 'CLOSED', '', ' ', 0, 9602, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960200017, '  ', 'SERVICEACC', '', ' ', 0, 9602, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960200023, '', 'FACIALACC_CLS', '', ' ', 0, 9602, 0, 0, '', 0, null, 0, 0, '') ;

-- , +(2)
CALL ImportField(960310012, ' -', 'CBRNAME', '', ' ', 2, 9603, 0, 1, '', 0, 46304, 0, 0, '') ;

--    , (1)
CALL ImportField(970910006, ' (  )', 'DELETEDATE', '', ' ', 1, 9709, 0, 0, '', 0, 27865, 0, 0, '') ;

CALL ImportField(970910007, '   ', 'STARTDATE', '', ' ', 1, 9709, 0, 0, '', 0, 27866, 0, 0, '') ;

CALL ImportField(970910008, '', '_FAVORITE', '', ' ', 1, 9709, 0, 0, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(970910001, ' ', 'CREATEDATE', '', ' ', 2, 9709, 0, 1, '', 0, 22388, 0, 0, '') ;

CALL ImportField(970910002, '', 'ID', '', ' ', 2, 9709, 0, 0, '', 0, 22386, 0, 0, '') ;

CALL ImportField(970910003, '', 'NAME', '', ' ', 2, 9709, 0, 0, '', 0, 22387, 0, 0, '') ;

CALL ImportField(970910004, ' ', 'UPDATEDATE', '', ' ', 2, 9709, 0, 1, '', 0, 22389, 0, 0, '') ;

CALL ImportField(970910005, ' ', 'STRCODE', '', ' ', 2, 9709, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(970910009, ' ', 'ShortName', '', ' ', 2, 9709, 0, 0, '', 0, 44618, 0, 0, '') ;

CALL ImportField(970910010, '', 'BudgetRef', '', ' ', 2, 9709, 0, 0, '', 0, 44617, 0, 0, '') ;

CALL ImportField(970910011, ' -  ', 'TransferBudgetRef', '', ' ', 2, 9709, 0, 0, '', 0, 44622, 0, 0, '') ;

CALL ImportField(970910012, ' ', 'TransfertKind', '', ' ', 2, 9709, 0, 0, '', 0, 44620, 0, 0, '') ;

CALL ImportField(970910013, '', 'TransferKCSR', '', ' ', 2, 9709, 0, 0, '', 0, 44259, 0, 0, '') ;

CALL ImportField(970910015, '', 'TransferKFSR', '', ' ', 2, 9709, 0, 0, '', 0, 44258, 0, 0, '') ;

CALL ImportField(970910016, '', 'TransferKVR', '', ' ', 2, 9709, 0, 0, '', 0, 44260, 0, 0, '') ;

CALL ImportField(970910017, ' ', 'TransferKVSR', '', ' ', 2, 9709, 0, 0, '', 0, 44257, 0, 0, '') ;

CALL ImportField(970910018, ' ', 'ParentTargetCls', '', ' ', 2, 9709, 0, 1, '', 0, 44624, 0, 0, '') ;

CALL ImportField(970910019, ' ', 'ParentTargetClsCode', '', ' ', 2, 9709, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(970910020, '', 'CREATERUSER', '', ' ', 2, 9709, 0, 1, '', 0, 44615, 0, 0, '') ;

CALL ImportField(970910021, '', 'UPDATERUSER', '', ' ', 2, 9709, 0, 1, '', 0, 44616, 0, 0, '') ;

CALL ImportField(970910022, '   ', 'LowerBudgetKD', '', ' ', 2, 9709, 0, 0, '', 0, 44623, 0, 0, '') ;

CALL ImportField(970910023, '   ', 'ReceiveKDValue', '', ' ', 2, 9709, 0, 0, '', 0, 44619, 0, 0, '') ;

CALL ImportField(970910024, '', 'InvestObjectCode', '', ' ', 2, 9709, 0, 0, '', 0, 38205, 0, 0, '') ;

CALL ImportField(970910025, '', 'InvestObject', '', ' ', 2, 9709, 0, 1, '', 0, 44621, 0, 0, '') ;

CALL ImportField(970910026, '', 'OverCofinancingCode', '', ' ', 2, 9709, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(970910027, '', 'OverCofinancing', '', ' ', 2, 9709, 0, 1, '', 0, 44626, 0, 0, '') ;

CALL ImportField(970910028, '', 'IsCofinancing', '', ' ', 2, 9709, 0, 0, '', 0, 44629, 0, 0, '') ;

CALL ImportField(970910029, '  (.)', 'Detail_CREATEDATE', '', ' ', 2, 9709, 0, 1, '', 0, 44610, 0, 0, '') ;

CALL ImportField(970910030, '  (.)', 'Detail_UPDATEDATE', '', ' ', 2, 9709, 0, 1, '', 0, 44612, 0, 0, '') ;

CALL ImportField(970910031, ' (.)', 'Detail_CREATERUSER', '', ' ', 2, 9709, 0, 1, '', 0, 44611, 0, 0, '') ;

CALL ImportField(970910032, ' (.)', 'Detail_UPDATERUSER', '', ' ', 2, 9709, 0, 1, '', 0, 44613, 0, 0, '') ;

CALL ImportField(970910033, '  (.)', 'Detail_AssignmentKind', '  ', ' ', 2, 9709, 0, 0, '', 0, 44603, 0, 0, '') ;

CALL ImportField(970910034, '  (.)', 'Detail_BudAllocationCls', '', ' ', 2, 9709, 0, 1, '', 0, 44604, 0, 0, '') ;

CALL ImportField(970910035, '  (.)', 'Detail_BudAllocationClsCode', '', ' ', 2, 9709, 0, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(970910036, ' (.)', 'Detail_ContractCostsCls', '', ' ', 2, 9709, 0, 1, '', 0, 44609, 0, 0, '') ;

CALL ImportField(970910037, ' (.)', 'Detail_ContractCostsClsCode', '', ' ', 2, 9709, 0, 0, '', 0, 40459, 0, 0, '') ;

CALL ImportField(970910038, ' (.)', 'Detail_DirectionCLS', '', ' ', 2, 9709, 0, 1, '', 0, 44605, 0, 0, '') ;

CALL ImportField(970910039, ' (.)', 'Detail_DirectionCLSCode', '', ' ', 2, 9709, 0, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(970910040, ' .  () (.)', 'Detail_FINTYPE', '  ', ' ', 2, 9709, 0, 1, '', 0, 44598, 0, 0, '') ;

CALL ImportField(970910041, ' .  (.)', 'Detail_FINTYPECODE', '  ', ' ', 2, 9709, 0, 0, '', 0, 36853, 0, 0, '') ;

CALL ImportField(970910042, ' (.)', 'Detail_TransferKCSR', '', ' ', 2, 9709, 0, 1, '', 0, 44588, 0, 0, '') ;

CALL ImportField(970910043, ' (.)', 'Detail_TransferKCSRCode', '', ' ', 2, 9709, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(970910044, ' (.)', 'Detail_Kesr', '', ' ', 2, 9709, 0, 1, '', 0, 44590, 0, 0, '') ;

CALL ImportField(970910045, ' (.)', 'Detail_KESRCODE', '', ' ', 2, 9709, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(970910046, ' (.)', 'Detail_TransferKFSR', '', ' ', 2, 9709, 0, 0, '', 0, 44591, 0, 0, '') ;

CALL ImportField(970910047, ' (.)', 'Detail_TransferKVR', '', ' ', 2, 9709, 0, 1, '', 0, 44592, 0, 0, '') ;

CALL ImportField(970910048, ' (.)', 'Detail_TransferKVRCode', '', ' ', 2, 9709, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(970910049, ' (.)', 'Detail_TransferKVSR', '', ' ', 2, 9709, 0, 1, '', 0, 44593, 0, 0, '') ;

CALL ImportField(970910050, ' (.)', 'Detail_TransferKVSRCode', '', ' ', 2, 9709, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(970910051, ' (.)', 'Detail_SubKesr', '', ' ', 2, 9709, 0, 1, '', 0, 44599, 0, 0, '') ;

CALL ImportField(970910052, ' (.)', 'Detail_SubKesrCode', '', ' ', 2, 9709, 0, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(970910053, '  (.)', 'Detail_SubsidyCls', ' ', ' ', 2, 9709, 0, 1, '', 0, 44607, 0, 0, '') ;

CALL ImportField(970910054, '  (.)', 'Detail_SubsidyClsCode', ' ', ' ', 2, 9709, 0, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(970910055, '  (.)', 'Detail_FundsSource', ' ', ' ', 2, 9709, 0, 0, '', 0, 44608, 0, 0, '') ;

CALL ImportField(970910056, ' (.)', 'Detail_InvestObjectCode', '', ' ', 2, 9709, 0, 0, '', 0, 38205, 0, 0, '') ;

CALL ImportField(970910057, ' (.)', 'Detail_InvestObject', '', ' ', 2, 9709, 0, 1, '', 0, 44596, 0, 0, '') ;

CALL ImportField(970910058, '   (.)', 'Detail_PayPromiseCls', '  ', ' ', 2, 9709, 0, 1, '', 0, 44606, 0, 0, '') ;

CALL ImportField(970910059, '   (.)', 'Detail_PayPromiseClsCode', '  ', ' ', 2, 9709, 0, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(970910060, ' (.)', 'Detail_FACT', '', ' ', 2, 9709, 0, 1, '', 0, 44597, 0, 0, '') ;

CALL ImportField(970910061, ' (.)', 'Detail_FACTCODE', '', ' ', 2, 9709, 0, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(970910062, ' (.)', 'Detail_OKTMO', '', ' ', 2, 9709, 0, 1, '', 0, 44600, 0, 0, '') ;

CALL ImportField(970910063, ' (.)', 'Detail_OKTMOCode', '', ' ', 2, 9709, 0, 0, '', 0, 32822, 0, 0, '') ;

CALL ImportField(970910064, '  (.)', 'Detail_RegionCls', '', ' ', 2, 9709, 0, 0, '', 0, 44602, 0, 0, '') ;

CALL ImportField(970910065, '  (.)', 'Detail_MeansType', ' ', ' ', 2, 9709, 0, 0, '', 0, 44595, 0, 0, '') ;

CALL ImportField(970910066, '  (  )', 'Detail_TargetCls', '  (  )', ' ', 2, 9709, 0, 1, '', 0, 44594, 0, 0, '') ;

CALL ImportField(970910067, ' (  )', 'Detail_DELETEDATE', '', ' ', 2, 9709, 0, 0, '', 0, 44745, 0, 0, '') ;

CALL ImportField(970910068, '   ', 'Detail_STARTDATE', '', ' ', 2, 9709, 0, 0, '', 0, 44746, 0, 0, '') ;

-- , (1)
CALL ImportField(971010010, '', 'CREATERUSER', '', ' ', 1, 9710, 0, 1, '', 0, 45704, 0, 0, '') ;

CALL ImportField(971010011, '', 'UPDATERUSER', '', ' ', 1, 9710, 0, 1, '', 0, 45705, 0, 0, '') ;

-- , +(2)
CALL ImportField(971010001, ' ', 'CREATEDATE', '', ' ', 2, 9710, 0, 1, '', 0, 45704, 0, 0, '') ;

CALL ImportField(971010002, '', 'ID', '', ' ', 2, 9710, 0, 1, '', 0, 45700, 0, 0, '') ;

CALL ImportField(971010003, '', 'NAME', '', ' ', 2, 9710, 0, 0, '', 0, 45701, 0, 0, '') ;

CALL ImportField(971010004, ' ', 'UPDATEDATE', '', ' ', 2, 9710, 0, 1, '', 0, 45703, 0, 0, '') ;

CALL ImportField(971010005, ' ', 'BUDGETREF', '', ' ', 2, 9710, 0, 0, '', 0, 45706, 0, 0, '') ;

CALL ImportField(971010006, '', 'CODE', '', ' ', 2, 9710, 0, 0, '', 0, 45707, 0, 0, '') ;

CALL ImportField(971010007, ' (  )', 'DELETEDATE', '', ' ', 2, 9710, 0, 0, '', 0, 45708, 0, 0, '') ;

CALL ImportField(971010008, '   ', 'STARTDATE', '', ' ', 2, 9710, 0, 0, '', 0, 45710, 0, 0, '') ;

CALL ImportField(971010009, ' ', 'SHORTNAME', '', ' ', 2, 9710, 0, 0, '', 0, 45709, 0, 0, '') ;

CALL ImportField(971010012, '     ', 'NAMEMAINEVENT', '', ' ', 2, 9710, 0, 0, '', 0, 45711, 0, 0, '') ;

CALL ImportField(971010013, ' ', 'PARENTPROJECT', '', ' ', 2, 9710, 0, 0, '', 0, 45712, 0, 0, '') ;

--   , (1)
CALL ImportField(971110009, '', 'CREATERUSER', '', ' ', 1, 9711, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971110010, '', 'UPDATERUSER', '', ' ', 1, 9711, 0, 1, '', 0, null, 0, 0, '') ;

--   , +(2)
CALL ImportField(971110001, ' ', 'CREATEDATE', '', ' ', 2, 9711, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971110002, '', 'ID', '', ' ', 2, 9711, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971110003, '', 'NAME', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110004, ' ', 'UPDATEDATE', '', ' ', 2, 9711, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971110005, ' ', 'BUDGETREF', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110006, '', 'CODE', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110007, ' (  )', 'DELETEDATE', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110008, '   ', 'STARTDATE', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110011, '. ', 'NationalProject', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110012, ' ', 'ResultType', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971110013, ' ', 'ResultKind', '', ' ', 2, 9711, 0, 0, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(971210008, ' ', 'EXTID', '', ' ', 1, 9712, 0, 1, '', 0, 47451, 0, 0, '') ;

CALL ImportField(971210009, '  ', 'EXTROOTID', '', ' ', 1, 9712, 0, 1, '', 0, 47452, 0, 0, '') ;

CALL ImportField(971210010, '', 'EXTOWNER', '', ' ', 1, 9712, 0, 1, '', 0, 47453, 0, 0, '') ;

CALL ImportField(971210011, '', 'EXTSYNCDATE', '', ' ', 1, 9712, 0, 1, '', 0, 47454, 0, 0, '') ;

CALL ImportField(971210012, '', 'EXTVERSION', '', ' ', 1, 9712, 0, 1, '', 0, 47455, 0, 0, '') ;

CALL ImportField(971210013, '', 'EXTVERSIONDATE', '', ' ', 1, 9712, 0, 1, '', 0, 47456, 0, 0, '') ;

CALL ImportField(971210015, '', 'CREATERUSER', '', ' ', 1, 9712, 0, 1, '', 0, 47458, 0, 0, '') ;

CALL ImportField(971210017, '', 'UPDATERUSER', '', ' ', 1, 9712, 0, 1, '', 0, 47460, 0, 0, '') ;

--    , +(2)
CALL ImportField(971210001, '', 'ID', '', ' ', 2, 9712, 0, 1, '', 0, 47444, 0, 0, '') ;

CALL ImportField(971210002, '', 'NAME', '', ' ', 2, 9712, 0, 0, '', 0, 47445, 0, 0, '') ;

CALL ImportField(971210003, '', 'CODE', '', ' ', 2, 9712, 0, 0, '', 0, 47446, 0, 0, '') ;

CALL ImportField(971210004, '', 'BUDGETREF', '', ' ', 2, 9712, 0, 0, '', 0, 47447, 0, 0, '') ;

CALL ImportField(971210005, '   ', 'STARTDATE', '', ' ', 2, 9712, 0, 0, '', 0, 47448, 0, 0, '') ;

CALL ImportField(971210006, ' ', 'DELETEDATE', '', ' ', 2, 9712, 0, 0, '', 0, 47449, 0, 0, '') ;

CALL ImportField(971210007, '', 'NOTE', '', ' ', 2, 9712, 0, 0, '', 0, 47450, 0, 0, '') ;

CALL ImportField(971210014, ' ', 'CREATEDATE', '', ' ', 2, 9712, 0, 1, '', 0, 47457, 0, 0, '') ;

CALL ImportField(971210016, ' ', 'UPDATEDATE', '', ' ', 2, 9712, 0, 1, '', 0, 47459, 0, 0, '') ;

--    , (1)
CALL ImportField(971310011, '', 'CREATERUSER', '', ' ', 1, 9713, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971310013, '', 'UPDATERUSER', '', ' ', 1, 9713, 0, 1, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(971310001, '', 'ID', '', ' ', 2, 9713, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971310002, '', 'NAME', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310003, '', 'CODE', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310004, '', 'BUDGETREF', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310005, '   ', 'STARTDATE', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310006, ' ', 'DELETEDATE', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310007, '', 'NOTE', '', ' ', 2, 9713, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971310008, ' ', 'EXTID', '', ' ', 2, 9713, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971310009, '  ', 'EXTROOTID', '', ' ', 2, 9713, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971310010, ' ', 'CREATEDATE', '', ' ', 2, 9713, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971310012, ' ', 'UPDATEDATE', '', ' ', 2, 9713, 0, 1, '', 0, null, 0, 0, '') ;

--      , (1)
CALL ImportField(971410011, '', 'CREATERUSER', '', ' ', 1, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410013, '', 'UPDATERUSER', '', ' ', 1, 9714, 0, 1, '', 0, null, 0, 0, '') ;

--      , +(2)
CALL ImportField(971410001, '', 'ID', '', ' ', 2, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410002, '', 'NAME', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410003, '', 'CODE', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410004, '', 'BUDGETREF', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410005, '   ', 'STARTDATE', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410006, ' ', 'DELETEDATE', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410007, '', 'NOTE', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410008, ' ', 'EXTID', '', ' ', 2, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410009, '  ', 'EXTROOTID', '', ' ', 2, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410010, ' ', 'CREATEDATE', '', ' ', 2, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410012, ' ', 'UPDATEDATE', '', ' ', 2, 9714, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971410014, ' ', 'FACIALACC_CLS', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971410015, '-', 'ROOTDOC', '', ' ', 2, 9714, 0, 0, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(971610011, '', 'CREATERUSER', '', ' ', 1, 9716, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971610013, '', 'UPDATERUSER', '', ' ', 1, 9716, 0, 1, '', 0, null, 0, 0, '') ;

--   , +(2)
CALL ImportField(971610001, '', 'ID', '', ' ', 2, 9716, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971610002, '', 'NAME', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610003, '', 'CODE', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610004, '', 'BUDGETREF', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610005, '   ', 'STARTDATE', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610006, ' ', 'DELETEDATE', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610007, '', 'NOTE', '', ' ', 2, 9716, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(971610008, ' ', 'EXTID', '', ' ', 2, 9716, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971610009, '  ', 'EXTROOTID', '', ' ', 2, 9716, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971610010, ' ', 'CREATEDATE', '', ' ', 2, 9716, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(971610012, ' ', 'UPDATEDATE', '', ' ', 2, 9716, 0, 1, '', 0, null, 0, 0, '') ;

-- , +(2)
CALL ImportField(980510015, ' ', 'NationalProject', '', ' ', 2, 9805, 0, 1, '', 0, 45713, 0, 0, '') ;

-- , +(2)
CALL ImportField(980810007, '', '_FAVORITE', '', ' ', 2, 9808, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(980810008, '', 'CODE', '', ' ', 2, 9808, 0, 1, '', 0, 43610, 0, 0, '') ;

CALL ImportField(980810009, ' ', 'BUDGETREF', '', ' ', 2, 9808, 0, 1, '', 0, 43611, 0, 0, '') ;

-- , +(2)
CALL ImportField(980910008, '', 'KESR', '', ' ', 2, 9809, 0, 1, '', 0, 16835, 0, 0, '') ;

CALL ImportField(980910009, ' ()', 'KVSR', '', ' ', 2, 9809, 0, 0, '', 0, 16830, 0, 0, '') ;

CALL ImportField(980910017, '', 'KVSRCODE', '', ' ', 2, 9809, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(980910027, '()', 'KESRCode', '', ' ', 2, 9809, 0, 0, '', 0, 43607, 0, 0, '') ;

--   , +(2)
CALL ImportField(982710006, 'ID', 'ID', '', ' ', 2, 9827, 0, 0, '', 0, 16956, 0, 0, '') ;

CALL ImportField(982710010, '', 'CODE', '', ' ', 2, 9827, 0, 1, '', 0, 36853, 0, 0, '') ;

-- - , +(2)
CALL ImportField(982910007, '', 'ID', '', ' ', 2, 9829, 0, 0, '', 0, 16974, 0, 0, '') ;

CALL ImportField(982910012, '', 'CODE', '', ' ', 2, 9829, 0, 1, '', 0, 36865, 0, 0, '') ;

--  , +(2)
CALL ImportField(984110022, '', 'KCSR', '', ' ', 2, 9841, 0, 0, '', 0, 17137, 0, 0, '') ;

CALL ImportField(984110023, '', 'KESR', '', ' ', 2, 9841, 0, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(984110024, '', 'KFSR', '', ' ', 2, 9841, 0, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(984110025, '', 'KVR', '', ' ', 2, 9841, 0, 0, '', 0, 17139, 0, 0, '') ;

CALL ImportField(984110026, '', 'KVSR', '', ' ', 2, 9841, 0, 0, '', 0, 17136, 0, 0, '') ;

CALL ImportField(984110052, '()', 'KESRCode', '', ' ', 2, 9841, 0, 0, '', 0, 43607, 0, 0, '') ;

--  , +(2)
CALL ImportField(984910015, ' ', 'MEANSTYPE', '', ' ', 2, 9849, 0, 1, '', 0, 44584, 0, 0, '') ;

--    , (1)
CALL ImportField(985210018, '', 'KVSRCODE', '', ' ', 1, 9852, 0, 0, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(985210010, '', 'KESR', '', ' ', 2, 9852, 0, 1, '', 0, 17054, 0, 0, '') ;

CALL ImportField(985210011, ' ()', 'KVSR', '', ' ', 2, 9852, 0, 0, '', 0, 17049, 0, 0, '') ;

CALL ImportField(985210027, '()', 'KESRCode', '', ' ', 2, 9852, 0, 0, '', 0, 43607, 0, 0, '') ;

-- , +(2)
CALL ImportField(985410017, '', 'KVSR', '', ' ', 2, 9854, 0, 1, '', 0, 38217, 0, 0, '') ;

CALL ImportField(985410018, '', 'KCSR', '', ' ', 2, 9854, 0, 0, '', 0, 38218, 0, 0, '') ;

CALL ImportField(985410029, '', 'KVSRCODE', '', ' ', 2, 9854, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(985410032, ' ', 'InvestDirection', '', ' ', 2, 9854, 0, 0, '', 0, 44429, 0, 0, '') ;

CALL ImportField(985410033, ' ', 'ProvidingPurpose', '', ' ', 2, 9854, 0, 0, '', 0, 44430, 0, 0, '') ;

CALL ImportField(985410034, '', 'APower', '', ' ', 2, 9854, 0, 0, '', 0, 44431, 0, 0, '') ;

CALL ImportField(985410035, ' ', 'DeveloperName', '', ' ', 2, 9854, 0, 0, '', 0, 44432, 0, 0, '') ;

CALL ImportField(985410036, '  ', 'DevelopStartDate', '', ' ', 2, 9854, 0, 0, '', 0, 44433, 0, 0, '') ;

CALL ImportField(985410037, '  ', 'DevelopEndDate', '', ' ', 2, 9854, 0, 0, '', 0, 44434, 0, 0, '') ;

CALL ImportField(985410038, '  ', 'DevelopCost', '', ' ', 2, 9854, 0, 0, '', 0, 44435, 0, 0, '') ;

CALL ImportField(985410039, '  ', 'TotalCost', '', ' ', 2, 9854, 0, 0, '', 0, 44436, 0, 0, '') ;

CALL ImportField(985410040, ' ', 'Coordinates', '', ' ', 2, 9854, 0, 0, '', 0, 44437, 0, 0, '') ;

CALL ImportField(985410041, '   ', 'RegistryAgreementNumber', '', ' ', 2, 9854, 0, 0, '', 0, 44438, 0, 0, '') ;

CALL ImportField(985410045, '', 'ID', '', ' ', 2, 9854, 0, 0, '', 0, 38204, 0, 0, '') ;

CALL ImportField(985410046, ' ', 'OwnerLevel', '', ' ', 2, 9854, 0, 0, '', 0, 38210, 0, 0, '') ;

CALL ImportField(985410048, '   ', 'PowerUnitCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410049, '    ', 'DeveloperCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410050, '    ', 'CustomerCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410051, ' -   ', 'OwningOrgCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410052, '   ', 'BudgetCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410054, ' - ', 'EstimateDocExist', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410055, '  ', 'CostUnitCode', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410056, '  ', 'CoFinancing', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(985410057, ' ', 'STOREDCONTENT', '', ' ', 2, 9854, 0, 1, '', 0, null, 0, 2, '') ;

--  , +(2)
CALL ImportField(986410001, ' ', 'CREATEDATE', '', ' ', 2, 9864, 0, 1, '', 0, 20689, 0, 0, '') ;

CALL ImportField(986410002, '', 'CODE', '', ' ', 2, 9864, 0, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(986410004, ' ', 'UPDATEDATE', '', ' ', 2, 9864, 0, 1, '', 0, 20690, 0, 0, '') ;

CALL ImportField(986410006, '', 'ID', '', ' ', 2, 9864, 0, 1, '', 0, 20687, 0, 0, '') ;

CALL ImportField(986410007, '', 'BUDGETREF', '', ' ', 2, 9864, 0, 1, '', 0, 46133, 0, 0, '') ;

CALL ImportField(986410008, '   ', 'STARTDATE', '', ' ', 2, 9864, 0, 0, '', 0, 46135, 0, 0, '') ;

CALL ImportField(986410009, ' ', 'DELETEDATE', '', ' ', 2, 9864, 0, 0, '', 0, 46134, 0, 0, '') ;

CALL ImportField(986410010, '', 'CREATERUSER', '', ' ', 2, 9864, 0, 1, '', 0, 46131, 0, 0, '') ;

CALL ImportField(986410011, '', 'UPDATERUSER', '', ' ', 2, 9864, 0, 1, '', 0, 46132, 0, 0, '') ;

--     , +(2)
CALL ImportField(986810018, '', 'CODE', '', ' ', 2, 9868, 0, 1, '', 0, 43607, 0, 0, '') ;

CALL ImportField(986810019, ' ', 'BUDGETREF', '', ' ', 2, 9868, 0, 1, '', 0, 43608, 0, 0, '') ;

-- , (0)
CALL ImportField(987800012, '', 'AYEAR', '', ' ', 0, 9878, 0, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(987910006, ' (  )', 'DELETEDATE', '', ' ', 1, 9879, 0, 0, '', 0, 27865, 0, 0, '') ;

CALL ImportField(987910007, '   ', 'STARTDATE', '', ' ', 1, 9879, 0, 0, '', 0, 27866, 0, 0, '') ;

CALL ImportField(987910008, '', '_FAVORITE', '', ' ', 1, 9879, 0, 0, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(987910001, ' ', 'CREATEDATE', '', ' ', 2, 9879, 0, 1, '', 0, 22388, 0, 0, '') ;

CALL ImportField(987910002, '', 'ID', '', ' ', 2, 9879, 0, 0, '', 0, 22386, 0, 0, '') ;

CALL ImportField(987910003, '', 'NAME', '', ' ', 2, 9879, 0, 0, '', 0, 22387, 0, 0, '') ;

CALL ImportField(987910004, ' ', 'UPDATEDATE', '', ' ', 2, 9879, 0, 1, '', 0, 22389, 0, 0, '') ;

CALL ImportField(987910005, ' ', 'STRCODE', '', ' ', 2, 9879, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(987910009, ' ', 'ShortName', '', ' ', 2, 9879, 0, 0, '', 0, 44618, 0, 0, '') ;

CALL ImportField(987910010, '', 'BudgetRef', '', ' ', 2, 9879, 0, 0, '', 0, 44617, 0, 0, '') ;

CALL ImportField(987910011, ' -  ', 'TransferBudgetRef', '', ' ', 2, 9879, 0, 0, '', 0, 44622, 0, 0, '') ;

CALL ImportField(987910012, ' ', 'TransfertKind', '', ' ', 2, 9879, 0, 0, '', 0, 44620, 0, 0, '') ;

CALL ImportField(987910013, '', 'TransferKCSR', '', ' ', 2, 9879, 0, 0, '', 0, 44259, 0, 0, '') ;

CALL ImportField(987910015, '', 'TransferKFSR', '', ' ', 2, 9879, 0, 0, '', 0, 44258, 0, 0, '') ;

CALL ImportField(987910016, '', 'TransferKVR', '', ' ', 2, 9879, 0, 0, '', 0, 44260, 0, 0, '') ;

CALL ImportField(987910017, ' ', 'TransferKVSR', '', ' ', 2, 9879, 0, 0, '', 0, 44257, 0, 0, '') ;

CALL ImportField(987910018, ' ', 'ParentTargetCls', '', ' ', 2, 9879, 0, 1, '', 0, 44624, 0, 0, '') ;

CALL ImportField(987910019, ' ', 'ParentTargetClsCode', '', ' ', 2, 9879, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(987910020, '', 'CREATERUSER', '', ' ', 2, 9879, 0, 1, '', 0, 44615, 0, 0, '') ;

CALL ImportField(987910021, '', 'UPDATERUSER', '', ' ', 2, 9879, 0, 1, '', 0, 44616, 0, 0, '') ;

CALL ImportField(987910022, '   ', 'LowerBudgetKD', '', ' ', 2, 9879, 0, 0, '', 0, 44623, 0, 0, '') ;

CALL ImportField(987910023, '   ', 'ReceiveKDValue', '', ' ', 2, 9879, 0, 0, '', 0, 44619, 0, 0, '') ;

CALL ImportField(987910024, '', 'InvestObjectCode', '', ' ', 2, 9879, 0, 0, '', 0, 38205, 0, 0, '') ;

CALL ImportField(987910025, '', 'InvestObject', '', ' ', 2, 9879, 0, 1, '', 0, 44621, 0, 0, '') ;

CALL ImportField(987910026, '', 'OverCofinancingCode', '', ' ', 2, 9879, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(987910027, '', 'OverCofinancing', '', ' ', 2, 9879, 0, 1, '', 0, 44626, 0, 0, '') ;

CALL ImportField(987910028, '', 'IsCofinancing', '', ' ', 2, 9879, 0, 0, '', 0, 44629, 0, 0, '') ;

--   , +(2)
CALL ImportField(988410018, '', 'TRANSFERKCSR', '', ' ', 2, 9884, 0, 0, '', 0, 25337, 0, 0, '') ;

CALL ImportField(988410019, '', 'TRANSFERKCSRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410021, '', 'TRANSFERKESR', '', ' ', 2, 9884, 0, 0, '', 0, 25339, 0, 0, '') ;

CALL ImportField(988410022, '', 'TRANSFERKFSR', '', ' ', 2, 9884, 0, 0, '', 0, 25340, 0, 0, '') ;

CALL ImportField(988410023, '', 'TRANSFERKVR', '', ' ', 2, 9884, 0, 0, '', 0, 25341, 0, 0, '') ;

CALL ImportField(988410024, '', 'TRANSFERKVRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410025, '', 'TRANSFERKVSR', '', ' ', 2, 9884, 0, 0, '', 0, 25342, 0, 0, '') ;

CALL ImportField(988410026, '', 'TRANSFERKVSRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410042, '', 'FactCode', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410043, ' ()', 'FACT', '', ' ', 2, 9884, 0, 0, '', 0, 43561, 0, 0, '') ;

CALL ImportField(988410044, '', 'TRANSFERKESRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(988610010, '', '_FAVORITE', '', ' ', 1, 9886, 0, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(988610001, ' ', 'CREATEDATE', '', ' ', 2, 9886, 0, 1, '', 0, 22987, 0, 0, '') ;

CALL ImportField(988610002, '', 'CREATERUSER', '', ' ', 2, 9886, 0, 1, '', 0, 22986, 0, 0, '') ;

CALL ImportField(988610003, '', 'CODE', '', ' ', 2, 9886, 0, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(988610005, ' ', 'UPDATEDATE', '', ' ', 2, 9886, 0, 1, '', 0, 22989, 0, 0, '') ;

CALL ImportField(988610006, '', 'UPDATERUSER', '', ' ', 2, 9886, 0, 1, '', 0, 22988, 0, 0, '') ;

CALL ImportField(988610011, '', 'ID', '', ' ', 2, 9886, 0, 1, '', 0, 22984, 0, 0, '') ;

CALL ImportField(988610012, '', 'BUDGETREF', '', ' ', 2, 9886, 0, 1, '', 0, 46137, 0, 0, '') ;

--  , +(2)
CALL ImportField(989010012, ' ', 'ASSIGNMENTKIND', '', ' ', 2, 9890, 0, 1, '', 0, 43451, 0, 0, '') ;

--  , (1)
CALL ImportField(990312042, '', 'KVSR', '', ' ', 1, 9903, 2, 1, '', 0, 17136, 0, 0, '') ;

CALL ImportField(990312043, '', 'KCSR', '', ' ', 1, 9903, 2, 1, '', 0, 17137, 0, 0, '') ;

CALL ImportField(990312044, '', 'KFSR', '', ' ', 1, 9903, 2, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(990312045, '', 'KVR', '', ' ', 1, 9903, 2, 1, '', 0, 17139, 0, 0, '') ;

CALL ImportField(990312046, '', 'KESR', '', ' ', 1, 9903, 2, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(990312083, '', 'KCSRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(990312084, '', 'KVRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(990312085, '', 'KVSRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(990312121, '()', 'KESRCode', '()', ' ', 1, 9903, 2, 0, '', 0, 43607, 0, 0, '') ;

--  , +(2)
CALL ImportField(990310096, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990310097, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 9903, 0, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(991610225, ' \       ', '_', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0, '') ;

CALL InsertConst(32, 47, 3, ' \       ', '', 0, 0, 9916) ;

CALL ImportField(991610226, ' \    ', '_', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0, '') ;

CALL InsertConst(32, 48, 3, ' \    ', '', 0, 0, 9916) ;

CALL ImportField(991610227, ' \        ', '_', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0, '') ;

CALL InsertConst(32, 49, 3, ' \        ', '', 0, 0, 9916) ;

CALL ImportField(991610228, ' \ ', '_', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0, '') ;

CALL InsertConst(32, 51, 3, ' \ ', '', 0, 0, 9916) ;

--  , +(2)
CALL ImportField(991610229, '   ( )', '', '', ' ', 2, 9916, 0, 1, '', 0, null, 0, 0, '') ;

CALL InsertConst(40, 2, 3, '   ( )', '', 0, 0, null) ;

--   , (1)
CALL ImportField(992110004, '', 'OKTMO', '', ' ', 1, 9921, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992111019, '', 'KCSR', '', ' ', 1, 9921, 1, 1, '', 0, 17137, 0, 0, '') ;

CALL ImportField(992111020, '', 'KCSRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(992111021, '', 'KESR', '', ' ', 1, 9921, 1, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(992111022, '', 'KFSR', '', ' ', 1, 9921, 1, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(992111024, '', 'KVR', '', ' ', 1, 9921, 1, 1, '', 0, 17139, 0, 0, '') ;

CALL ImportField(992111025, '', 'KVRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(992111026, '', 'KVSR', '', ' ', 1, 9921, 1, 1, '', 0, 17136, 0, 0, '') ;

CALL ImportField(992111027, '', 'KVSRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(992111043, '()', 'KESRCode', '', ' ', 1, 9921, 1, 0, '', 0, 43607, 0, 0, '') ;

--   , (1)
CALL ImportField(992512001, '', 'KESR', '', ' ', 1, 9925, 2, 1, '', 0, 22627, 0, 0, '') ;

CALL ImportField(992512031, '()', 'KESRCode', '', ' ', 1, 9925, 2, 0, '', 0, 43607, 0, 0, '') ;

--    , (1)
CALL ImportField(992810002, '', 'KVR', '', ' ', 1, 9928, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992810003, '', 'KESR', '', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810010, '()', 'KESRCode', '', ' ', 1, 9928, 0, 0, '', 0, 43607, 0, 0, '') ;

--     , (1)
CALL ImportField(992910002, '', 'KVSRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910003, '', 'KFSR', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910004, '', 'KCSRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910005, '', 'KVRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910006, '', 'KESR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910008, '', 'SubKESR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910014, ' ', 'BudAllocationClsCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910021, ' ()', 'KVSR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910022, ' ()', 'KCSR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910023, ' ()', 'KVR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910028, '  ()', 'BudAllocationCls', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910036, '()', 'KESRCode', '', ' ', 1, 9929, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(992910037, '()', 'SubKESRCode', '', ' ', 1, 9929, 0, 0, '', 0, 43610, 0, 0, '') ;

--     , +(2)
CALL ImportField(992910038, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910039, '   ()', 'PayTargetFunds', '   ', ' ', 2, 9929, 0, 1, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(993010009, '', 'KFSR', '', ' ', 2, 9930, 0, 0, '', 0, 39181, 0, 0, '') ;

CALL ImportField(993010010, ' ()', 'KCSR', '', ' ', 2, 9930, 0, 0, '', 0, 39182, 0, 0, '') ;

CALL ImportField(993010011, ' ()', 'KVSR', '', ' ', 2, 9930, 0, 0, '', 0, 39183, 0, 0, '') ;

CALL ImportField(993010012, ' ()', 'KVR', '', ' ', 2, 9930, 0, 0, '', 0, 39184, 0, 0, '') ;

CALL ImportField(993010013, '', 'KESR', '', ' ', 2, 9930, 0, 1, '', 0, 39185, 0, 0, '') ;

CALL ImportField(993010014, '  ()', 'KD', '', ' ', 2, 9930, 0, 0, '', 0, 39186, 0, 0, '') ;

CALL ImportField(993010015, '    ()', 'IFS', '', ' ', 2, 9930, 0, 0, '', 0, 39187, 0, 0, '') ;

CALL ImportField(993010026, '()', 'KESRCode', '', ' ', 2, 9930, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(993010027, ' .  ()', 'FINTYPE', '', ' ', 2, 9930, 0, 0, '', 0, 44405, 0, 0, '') ;

CALL ImportField(993010028, ' ()', 'FACT', '', ' ', 2, 9930, 0, 0, '', 0, 44407, 0, 0, '') ;

CALL ImportField(993010029, ' ()', 'SUBKESR', '', ' ', 2, 9930, 0, 0, '', 0, 44409, 0, 0, '') ;

CALL ImportField(993010030, '', 'REGIONCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44408, 0, 0, '') ;

CALL ImportField(993010031, '  ()', 'SUBSIDYCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44410, 0, 0, '') ;

CALL ImportField(993010032, '  ()', 'TARGETCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44411, 0, 0, '') ;

CALL ImportField(993010033, ' ()', 'DIRECTIONCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44406, 0, 0, '') ;

CALL ImportField(993010034, '   ()', 'TRANSFERTCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44412, 0, 0, '') ;

CALL ImportField(993010035, ' ()', 'CONTRACTCOSTSCLS', '', ' ', 2, 9930, 0, 0, '', 0, 44422, 0, 0, '') ;

CALL ImportField(993010036, ' ()', 'INVESTOBJECT', '', ' ', 2, 9930, 0, 0, '', 0, 44423, 0, 0, '') ;

CALL ImportField(993010037, '.  ', 'STOREDCONTENT', '', ' ', 2, 9930, 0, 0, '', 0, 44425, 0, 0, '') ;

CALL ImportField(993010038, '  ()', 'DOCTYPECLS', '', ' ', 2, 9930, 0, 0, '', 0, 44450, 0, 0, '') ;

CALL ImportField(993010039, ' . ', 'FINTYPECODE', '', ' ', 2, 9930, 0, 0, '', 0, 36853, 0, 0, '') ;

CALL ImportField(993010040, '', 'InvestObjectCode', '', ' ', 2, 9930, 0, 0, '', 0, 38205, 0, 0, '') ;

CALL ImportField(993010041, '', 'ContractCostsClsCode', '', ' ', 2, 9930, 0, 0, '', 0, 40459, 0, 0, '') ;

CALL ImportField(993010042, '', 'DirectionCLSCode', '', ' ', 2, 9930, 0, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(993010043, '', 'FactCode', '', ' ', 2, 9930, 0, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(993010044, '', 'KCSRCode', '', ' ', 2, 9930, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(993010045, '()', 'KVRCode', '', ' ', 2, 9930, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(993010046, '()', 'KVSRCode', '', ' ', 2, 9930, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(993010047, '', 'SubKesrCode', '', ' ', 2, 9930, 0, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(993010048, ' ', 'SubsidyClsCode', '', ' ', 2, 9930, 0, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(993010049, ' ', 'TargetClsCode', '', ' ', 2, 9930, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(993010050, '  ', 'TransfertClsCode', '', ' ', 2, 9930, 0, 0, '', 0, 25326, 0, 0, '') ;

CALL ImportField(993010051, '', 'IFS_FinSourceValue', '', ' ', 2, 9930, 0, 0, '', 0, 17055, 0, 0, '') ;

CALL ImportField(993010052, ' ', 'KDValue', '', ' ', 2, 9930, 0, 1, '', 0, 16836, 0, 0, '') ;

CALL ImportField(993010053, '   ', 'PayTargetFundsCode', '   ', 'PayTargetFunds', 2, 9930, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993010054, '   ()', 'PayTargetFunds', '   ', ' ', 2, 9930, 0, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(993110002, '', 'KFSR', '', ' ', 1, 9931, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993110003, '', 'KVR', '', ' ', 1, 9931, 0, 0, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(993310001, ' ', 'ID', '', ' ', 1, 9933, 0, 1, '', 0, 46332, 0, 0, '') ;

CALL ImportField(993310002, '', 'Name', '  ', ' ', 1, 9933, 0, 0, '', 0, 46333, 0, 0, '') ;

CALL ImportField(993310003, '  ', 'Code', '   ', ' ', 1, 9933, 0, 0, '', 0, 46334, 0, 0, '') ;

CALL ImportField(993310004, '', 'BudgetRef', ',      ', ' ', 1, 9933, 0, 0, '', 0, 46335, 0, 0, '') ;

CALL ImportField(993310005, '  ', 'StartDate', '    ', ' ', 1, 9933, 0, 0, '', 0, 46336, 0, 0, '') ;

CALL ImportField(993310006, '  ', 'DeleteDate', '    ', ' ', 1, 9933, 0, 0, '', 0, 46337, 0, 0, '') ;

CALL ImportField(993310007, '', 'Note', '', ' ', 1, 9933, 0, 0, '', 0, 46338, 0, 0, '') ;

CALL ImportField(993310008, '  ()', 'CreateDate', '  ()', ' ', 1, 9933, 0, 1, '', 0, 46339, 0, 0, '') ;

CALL ImportField(993310009, ' ()', 'CREATERUSER', ' ()', 'CREATERUSER_CPT', 1, 9933, 0, 1, '', 0, 46340, 0, 0, '') ;

CALL ImportField(993310010, '  ()', 'UpdateDate', '  ()', ' ', 1, 9933, 0, 1, '', 0, 46341, 0, 0, '') ;

CALL ImportField(993310011, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9933, 0, 1, '', 0, 46342, 0, 0, '') ;

CALL ImportField(993311012, ' ', 'ID', '', ' ', 1, 9933, 1, 1, '', 0, 46344, 0, 0, '') ;

CALL ImportField(993311013, '  ', 'RecordIndex', ' ', ' ', 1, 9933, 1, 1, '', 0, 46345, 0, 0, '') ;

CALL ImportField(993311014, '', 'ClsName', ' ', ' ', 1, 9933, 1, 0, '', 0, 46347, 0, 0, '') ;

CALL ImportField(993311015, ' ', 'ClsType', '   ', ' ', 1, 9933, 1, 1, '', 0, 46348, 0, 0, '') ;

CALL ImportField(993311016, '  ()', 'CreateDate', '  ()', ' ', 1, 9933, 1, 1, '', 0, 46349, 0, 0, '') ;

CALL ImportField(993311017, ' ()', 'CREATERUSER', ' ()', 'CREATERUSER_DET', 1, 9933, 1, 1, '', 0, 46350, 0, 0, '') ;

CALL ImportField(993311018, '  ()', 'UpdateDate', '  ()', ' ', 1, 9933, 1, 1, '', 0, 46351, 0, 0, '') ;

CALL ImportField(993311019, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9933, 1, 1, '', 0, 46352, 0, 0, '') ;

--   , (1)
CALL ImportField(993410001, '', 'ID', '', ' ', 1, 9934, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993410002, ' ', 'Code', '  ', ' ', 1, 9934, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993410003, '', 'Name', '   ', ' ', 1, 9934, 0, 1, '', 0, 46333, 0, 0, '') ;

CALL ImportField(993410004, '', 'BudgetRef', ',      ', ' ', 1, 9934, 0, 1, '', 0, 46335, 0, 0, '') ;

CALL ImportField(993410005, '  ', 'StartDate', '    ', ' ', 1, 9934, 0, 1, '', 0, 46336, 0, 0, '') ;

CALL ImportField(993410006, '  ', 'DeleteDate', '    ', ' ', 1, 9934, 0, 1, '', 0, 46337, 0, 0, '') ;

CALL ImportField(993410007, '  ()', 'CreateDate', '  ()', ' ', 1, 9934, 0, 1, '', 0, 46339, 0, 0, '') ;

CALL ImportField(993410008, ' ()', 'CREATERUSER', ' ()', 'CREATERUSER_CPT', 1, 9934, 0, 1, '', 0, 46340, 0, 0, '') ;

CALL ImportField(993410009, '  ()', 'UpdateDate', '  ()', ' ', 1, 9934, 0, 1, '', 0, 46341, 0, 0, '') ;

CALL ImportField(993410010, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9934, 0, 1, '', 0, 46342, 0, 0, '') ;

CALL ImportField(993410091, '.  ', 'StoredContent', '.  ', ' ', 1, 9934, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993410093, 'ExtID', 'EXTID', '', ' ', 1, 9934, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411011, ' ', 'ID', '', ' ', 1, 9934, 1, 1, '', 0, 46483, 0, 0, '') ;

CALL ImportField(993411012, '  ', 'RecordIndex', ' ', ' ', 1, 9934, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993411013, '', 'KVSR', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46486, 0, 0, '') ;

CALL ImportField(993411014, '', 'KVSRCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(993411015, '', 'KFSR', '', ' ', 1, 9934, 1, 0, '', 0, 46487, 0, 0, '') ;

CALL ImportField(993411016, '', 'KCSR', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46485, 0, 0, '') ;

CALL ImportField(993411017, '', 'KCSRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(993411018, '', 'KVR', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46488, 0, 0, '') ;

CALL ImportField(993411019, '', 'KVRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(993411020, '', 'KESR', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46489, 0, 0, '') ;

CALL ImportField(993411021, '', 'KESRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(993411022, '', 'SubKESR', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46490, 0, 0, '') ;

CALL ImportField(993411023, '', 'SubKESRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(993411024, '', 'DirectionCls', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46491, 0, 0, '') ;

CALL ImportField(993411025, '', 'DirectionClsCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 36861, 0, 0, '') ;

CALL ImportField(993411026, '', 'Variant', '', ' ', 1, 9934, 1, 0, '', 0, 46492, 0, 0, '') ;

CALL ImportField(993411027, '', 'FACT', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46493, 0, 0, '') ;

CALL ImportField(993411028, '', 'FACTCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 36863, 0, 0, '') ;

CALL ImportField(993411029, '', 'PayPromiseCls', '   ()', ' ', 1, 9934, 1, 0, '', 0, 46494, 0, 0, '') ;

CALL ImportField(993411030, '', 'PayPromiseClsCode', '   ()', ' ', 1, 9934, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(993411031, '', 'BudAllocationCls', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46495, 0, 0, '') ;

CALL ImportField(993411032, '', 'BudAllocationClsCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(993411033, '', 'ContractCostsCls', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46496, 0, 0, '') ;

CALL ImportField(993411034, '', 'ContractCostsClsCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 40459, 0, 0, '') ;

CALL ImportField(993411035, '', 'InvestObject', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46497, 0, 0, '') ;

CALL ImportField(993411036, '', 'InvestObjectCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, 38205, 0, 0, '') ;

CALL ImportField(993411037, ' . ', 'FinType', ' .  ()', ' ', 1, 9934, 1, 0, ',', 0, 46498, 0, 0, '') ;

CALL ImportField(993411038, ' . ', 'FinTypeCode', ' .  ()', ' ', 1, 9934, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(993411039, ' ', 'MeansType', ' ', ' ', 1, 9934, 1, 0, '', 0, 46499, 0, 0, '') ;

CALL ImportField(993411040, ' ', 'TargetCls', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46500, 0, 0, '') ;

CALL ImportField(993411041, ' ', 'TargetClsCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(993411042, ' ', 'RegionCls', ' ', ' ', 1, 9934, 1, 0, '', 0, 46501, 0, 0, '') ;

CALL ImportField(993411043, ' ', 'SubsidyCls', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46502, 0, 0, '') ;

CALL ImportField(993411044, ' ', 'SubsidyClsCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(993411045, '  ', 'TransfertCls', '   ()', ' ', 1, 9934, 1, 0, '', 0, 46503, 0, 0, '') ;

CALL ImportField(993411046, '  ', 'TransfertClsCode', '   ()', ' ', 1, 9934, 1, 0, '', 0, 25326, 0, 0, '') ;

CALL ImportField(993411047, ' ', 'PlanDocType', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46504, 0, 0, '') ;

CALL ImportField(993411048, ' ', 'PlanDocTypeCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46130, 0, 0, '') ;

CALL ImportField(993411049, ' ', 'AssignmentSource', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46505, 0, 0, '') ;

CALL ImportField(993411050, ' ', 'AssignmentSourceCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46136, 0, 0, '') ;

CALL ImportField(993411051, ' ', 'AssignmentKind', '  ', ' ', 1, 9934, 1, 0, '', 0, 46506, 0, 0, '') ;

CALL ImportField(993411052, ' ', 'KD', '  ()', ' ', 1, 9934, 1, 0, '', 0, 46507, 0, 0, '') ;

CALL ImportField(993411053, ' ', 'KDValue', '  ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411054, '()', 'KDKVSRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411055, ' ()', 'KDDescriptionCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411056, '()', 'KDProgramCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411057, '()', 'KDAGCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411058, ' ', 'IFS', ' ', ' ', 1, 9934, 1, 0, '', 0, 46511, 0, 0, '') ;

CALL ImportField(993411059, '()', 'IFS_KVSRCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411060, ' ()', 'IFS_DescriptionCode', '  ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411070, '()', 'IFSAGCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411071, ' ', 'ReestrType', ' ', ' ', 1, 9934, 1, 0, '', 0, 46512, 0, 0, '') ;

CALL ImportField(993411072, '', 'OKTMO', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46513, 0, 0, '') ;

CALL ImportField(993411073, '', 'OKTMOCode', ' ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411074, '', 'DocBase', ' ()', ' ', 1, 9934, 1, 0, ',', 0, 46514, 0, 0, '') ;

CALL ImportField(993411075, '', 'DocBaseCode', ' ()', ' ', 1, 9934, 1, 0, ',', 0, 36865, 0, 0, '') ;

CALL ImportField(993411076, ' ', 'FundsSource', ' ', ' ', 1, 9934, 1, 0, '', 0, 46515, 0, 0, '') ;

CALL ImportField(993411077, ' ', 'FinSource', ' ', ' ', 1, 9934, 1, 0, '', 0, 46516, 0, 0, '') ;

CALL ImportField(993411078, ' ', 'DocType', ' ', ' ', 1, 9934, 1, 0, '', 0, 46517, 0, 0, '') ;

CALL ImportField(993411079, ' ', 'CommDirectionExpenceCls', ' ', ' ', 1, 9934, 1, 0, '', 0, 46518, 0, 0, '') ;

CALL ImportField(993411080, ' ', 'PayDestination', ' ', ' ', 1, 9934, 1, 0, '', 0, 46519, 0, 0, '') ;

CALL ImportField(993411081, ' ', 'FacialAcc_Cls', ' ', ' ', 1, 9934, 1, 0, '', 0, 46520, 0, 0, '') ;

CALL ImportField(993411082, ' ', 'NationalProject', ' ', ' ', 1, 9934, 1, 0, '', 0, 46521, 0, 0, '') ;

CALL ImportField(993411083, '', 'BudgetRef', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46522, 0, 0, '') ;

CALL ImportField(993411084, '', 'Note', '', ' ', 1, 9934, 1, 0, '', 0, 46525, 0, 0, '') ;

CALL ImportField(993411085, '  ', 'StartDate', '    ', ' ', 1, 9934, 1, 0, '', 0, 46523, 0, 0, '') ;

CALL ImportField(993411086, '  ', 'DeleteDate', '    ', ' ', 1, 9934, 1, 0, '', 0, 46524, 0, 0, '') ;

CALL ImportField(993411087, '  ()', 'CreateDate', '  ()', ' ', 1, 9934, 1, 1, '', 0, 46526, 0, 0, '') ;

CALL ImportField(993411088, ' ()', 'CREATERUSER', ' ()', 'CREATERUSER_DET', 1, 9934, 1, 1, '', 0, 46527, 0, 0, '') ;

CALL ImportField(993411089, '  ()', 'UpdateDate', '  ()', ' ', 1, 9934, 1, 1, '', 0, 46528, 0, 0, '') ;

CALL ImportField(993411090, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9934, 1, 1, '', 0, 46529, 0, 0, '') ;

CALL ImportField(993411092, '.   ()', 'StoredContentDet', '.   ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993411094, '', 'AnalyticalGroupIFS', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46508, 0, 0, '') ;

CALL ImportField(993411095, '', 'AnalyticalGroupKD', ' ()', ' ', 1, 9934, 1, 0, '', 0, 46509, 0, 0, '') ;

CALL ImportField(993411096, '', 'ProgramCode', '   ()', ' ', 1, 9934, 1, 0, '', 0, 46510, 0, 0, '') ;

CALL ImportField(993411097, '  ', 'IFS_FinSourceValue', '   ()', ' ', 1, 9934, 1, 0, '', 0, null, 0, 0, '') ;

--       
ALTER TRIGGER TR_INTCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 ENABLE
/

DROP PROCEDURE ImportField
/

/*      */
ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 DISABLE
/

Update TB_DocumentFields df
set documentcls=doctyperef*100+detailnumber
where (detailnumber<100)and(documentcls is null)
 and(exists(select dc.id from documentcls dc where id=df.doctyperef*100+df.detailnumber))
/

ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 ENABLE
/

DROP PROCEDURE DeleteFields
/

DROP PROCEDURE InsertConst
/

DROP PROCEDURE DELETECONST
/




CREATE OR REPLACE PROCEDURE DOCLOCK_IMPORT(
  NAME_              VARCHAR2,
  LOCKMASK_          NUMBER,
  DOCREF_            NUMBER,
  DETAILNUM_         NUMBER,
  RUNPOS_            NUMBER,
  LOCKACTION_        NUMBER,
  USERIGHTS_        NUMBER,
  FORMULA_           VARCHAR2,
  FORDELETE_         NUMBER,
  ISSYSTEM_          NUMBER,
  NOTE_              VARCHAR2,
  FORINSERT_         NUMBER,
  VALIDATEMESSAGE_ VARCHAR2,
  VALIDATELEVEL_   NUMBER,
  VALIDATEFILTER_  VARCHAR2,
  ISBUDGET_ NUMBER,
  DEFAULTVALUE_ VARCHAR2)
IS
  DOCLOCKID$ Number(10);
BEGIN
   BEGIN
     SELECT ID
     INTO DOCLOCKID$
     FROM DOCLOCK
     WHERE (DOCREF = DOCREF_) AND(DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       DOCLOCKID$ := NULL;  
   END;
   
   IF (DOCLOCKID$ is not null) THEN
     IF (ISSYSTEM_ = 3) THEN
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_,
         USERIGHTS = USERIGHTS_,
         DEFAULTVALUE = DEFAULTVALUE_
       WHERE ID = DOCLOCKID$;  
     ELSE
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_,
         DEFAULTVALUE = DEFAULTVALUE_
       WHERE ID = DOCLOCKID$;    
     END IF;  
   ELSE
     INSERT INTO DOCLOCK
       (ISBUDGET,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORMULA,FORDELETE,ISSYSTEM,NOTE,FORINSERT,VALIDATEMESSAGE,VALIDATELEVEL,VALIDATEFILTER,DEFAULTVALUE)
     VALUES
       (ISBUDGET_,NAME_,LOCKMASK_,DOCREF_,DETAILNUM_,RUNPOS_,LOCKACTION_,USERIGHTS_,FORMULA_,FORDELETE_,ISSYSTEM_,NOTE_,FORINSERT_,VALIDATEMESSAGE_,VALIDATELEVEL_,VALIDATEFILTER_,DEFAULTVALUE_);
   END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(
  NAME_      VARCHAR2,
  DOCREF_    NUMBER,
  DETAILNUM_ NUMBER,
  FIELDREF_  NUMBER,
  ISBUDGET_ NUMBER)
IS
  NID$ NUMBER(10);
  cnt$ number(10);
BEGIN
  BEGIN
    SELECT ID
    INTO NID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      NID$ := NULL;  
  END;

  IF (NID$ is not null) THEN
    CNT$ := 0;
    SELECT count(ID)
    into cnt$
    FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    
    IF (cnt$ = 0) THEN
      INSERT INTO DOCLOCKFIELDS
        (DOCLOCKREF,FIELDREF,ISSYSTEM)
      VALUES
        (NID$,FIELDREF_,1);
    ELSE
      UPDATE DOCLOCKFIELDS SET
        ISSYSTEM = 1
      WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    END IF;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCK_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCK
    WHERE ID = DOCLOCKID$;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, CANCHANGEFIELDS_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION  
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;  

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = DOCLOCKID$) AND ((ISSYSTEM = 1) OR ((ISSYSTEM = 0) AND (CANCHANGEFIELDS_ = 0) ));
  END IF;
END;
/

-- 
CALL DOCLOCK_DELETE('    ',202, 1, 0) ;

CALL DOCLOCK_DELETE('    ',202, 1, 1) ;

CALL DOCLOCK_DELETE('    ',205, 1, 0) ;

CALL DOCLOCK_DELETE('  ',213, -1, 0) ;

CALL DOCLOCK_DELETE('  ',213, -1, 1) ;

CALL DOCLOCK_DELETE('  ',213, -1, 0) ;

CALL DOCLOCK_DELETE('  ',213, -1, 1) ;

CALL DOCLOCK_DELETE('  ',215, 0, 1) ;

CALL DOCLOCK_DELETE(' .    ',216, -1, 2) ;

CALL DOCLOCK_DELETE('    ',301, 1, 0) ;

CALL DOCLOCK_DELETE('    ',301, 1, 1) ;

CALL DOCLOCK_DELETE('     ',301, 1, 0) ;

CALL DOCLOCK_DELETE('     ',301, 1, 1) ;

CALL DOCLOCK_DELETE('     ',301, 1, 1) ;

CALL DOCLOCK_DELETE('      ',301, 1, 1) ;

CALL DOCLOCK_DELETE('  ',302, -1, 1) ;

CALL DOCLOCK_DELETE('  ',302, -1, 0) ;

CALL DOCLOCK_DELETE('  ',302, -1, 1) ;

CALL DOCLOCK_DELETE('  ',302, -1, 0) ;

CALL DOCLOCK_DELETE('  ',305, -1, 0) ;

CALL DOCLOCK_DELETE('  ',305, -1, 1) ;

CALL DOCLOCK_DELETE('  ',305, -1, 1) ;

CALL DOCLOCK_DELETE('  ',305, -1, 0) ;

CALL DOCLOCK_DELETE('     , ',2502, 2, 1) ;

CALL DOCLOCK_DELETE('     , ',2503, 2, 1) ;

CALL DOCLOCK_DELETE('     , ',2504, 2, 1) ;

CALL DOCLOCK_DELETE('    ',2504, 4, 1) ;

CALL DOCLOCK_DELETE('    ',2504, 4, 0) ;

CALL DOCLOCK_DELETE('    ',2504, 5, 2) ;

CALL DOCLOCK_DELETE('     ',3011, 0, 2) ;

CALL DOCLOCK_DELETE('    ',3011, 0, 2) ;

CALL DOCLOCK_DELETE('   ',3011, 0, 2) ;

CALL DOCLOCK_DELETE('  ',9929, 0, 1) ;

CALL DOCLOCK_DELETE('   ',9933, 0, 1) ;

CALL DOCLOCK_DELETE('  ',9934, -1, 1) ;

CALL DOCLOCK_IMPORT('   ',0,200,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[20011008])))
([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011028,1) ;

CALL DOCLOCK_IMPORT('     ,',0,200,1,0,11,0,' ( in (213, 214, 215))',0,1,'          "",   -   ""',0,'       ""          ""  ',null,'((.[20011012]=2)  ([988410016] = 0)) 

((.[20011012]=0)  ([988410016] = 1))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ,', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ,',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('      ',0,200,1,0,11,0,'([20011012] = 0)   ( in (213, 214, 215))',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[20011018] = 0)  (.[20011024] = [988410026]))

(([988410022] = 0)  (.[20011020] = 0)  (.[20011020] = [988410022]))

(([988410023] = 0)  (.[20011019] = 0)  (.[20011023] = [988410024]))

(([988410018] = 0)  (.[20011022] = 0)  (.[20011025] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,' in (214, 215)',0,1,'',0,'      ""',null,'([988410016] = 0)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'([20011012] = 2)   ( in (213, 214, 215))',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[20011017] = 0)  ([988410008] = .[20011026]) 
   ((("..",[988410006])=0)
    (((".",.[20011017]), (".",[988410006]), "9.99.99.999.99"))
   (((".",[988410006])=(".",.[20011017]))
     ((".",[988410006])=0))
   (("..",[988410006])=("..",.[20011017]))) 
(((".", .[20011017]) div 100000) between 218 and 219)  
(((".", .[20011017]) div 1000) = 11302)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('    / ,',0,200,1,0,11,0,' ((=204)(=212)  (=218))',0,3,'  \,  ,       ',0,'    / , ,  / , , /       ',null,'([984110041]=0)([984110045]=0)([984110046]=0)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    / ,', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,',200,1,20011008,1) ;

CALL DOCLOCK_IMPORT('  ',32768,200,1,0,3,0,' ( in (205, 213))',0,1,'  ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011033,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011031,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011030,1) ;

CALL DOCLOCK_IMPORT('   ',32768,200,1,0,3,0,'((("..",[20010014]) between 10800  11199)    (("_...",[20011008]) between 10800  11199)     ((("_...",[20011008]) between 10000  10499)         (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011014,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'([20011012] = 2)   ( in (213, 214, 215))',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[20011017] = 0)  ([970910023] = .[20011026])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011043,1) ;

CALL DOCLOCK_IMPORT('    ',0,200,1,0,17,0,' ( in (205, 209, 211, 212, 213, 214, 215))',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[20011024], .[20011020], .[20011025], .[20011023], .[20011050], .[20011027], .[20011052], .[20011035],
 .[20011053], .[20011055], .[20011056], .[20011059], .[20011014],
 .[20011034], .[20011060], .[20011061], .[20011063])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',200,1,20011043,1) ;

CALL DOCLOCK_IMPORT('    ',0,200,1,0,11,0,' ( in (205, 209, 211, 212, 213, 214, 215))',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[20001024] = "")  ([970910017] = "000"))  
  ((.[20001024] <> "")  (.[20001024], [970910017], "9.9.9")))  
(((.[20001020] = "")  ([970910015] = "0000"))  
  ((.[20001020] <> "")  (.[20001020], [970910015], "99.99"))) 
(((.[20001025] = "")  ([970910013] = "0000000000"))  
  ((.[20001025] <> "")  (.[20001025], [970910013], ">aa.a.aa.aaaaa")))     
(((.[20001023] = "")  ([970910016] = "000"))  
  ((.[20001023] <> "")  (.[20001023], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[20001018] = 0)  (.[20001024] = [970910050])) 
(([970910046] = 0)  (.[20001020] = 0)  (.[20001020] = [970910046])) 
(([970910047] = 0)  (.[20001019] = 0)  (.[20001023] = [970910048])) 
(([970910042] = 0)  (.[20001022] = 0)  (.[20001025] = [970910043])) 
(([970910044] = 0)  (.[20001021] = 0)  (.[20001049] = [970910045])) 
(([970910065] = 0)  (.[20001027] = 0)  (.[20001027] = [970910065])) 
(([970910056] = "")  (.[20001051] = "")  (.[20001051] = [970910056])) 
(([970910060] = 0)  (.[20001036] = 0)  (.[20001035] = [970910061])) 
(([970910051] = 0)  (.[20001053] = 0)  (.[20001052] = [970910052])) 
(([970910064] = 0)  (.[20001054] = 0)  (.[20001054] = [970910064])) 
(([970910040] = 0)  (.[20001055] = 0)  (.[20001056] = [970910041])) 
(([970910038] = 0)  (.[20001057] = 0)  (.[20001058] = [970910039]))   
(([970910054] = "")  (.[20001014] = "")  (.[20001014] = [970910054])) 
(([970910033] = 0)  (.[20001065] = 0)  (.[20001065] = [970910033])) 
(([970910035] = "")  (.[20001059] = "")  (.[20001059] = [970910035])) 
(([970910059] = "")  (.[20001061] = "")  (.[20001061] = [970910059]))  
(([970910037] = "")  (.[20001063] = "")  (.[20001063] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',200,1,20001043,0) ;

CALL DOCLOCK_IMPORT('  ',32768,200,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 200, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20001049,0) ;

CALL DOCLOCK_IMPORT('  ',32768,200,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 200, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011050,1) ;

CALL DOCLOCK_IMPORT('    ',0,200,1,0,11,0,' ( in (216, 217))',0,3,'     ',0,'      ',null,'((.[20001012] = 0)  ([986810009] = 1)) 
((.[20001012] = 1)  ([986810008] = 1)) 
((.[20001012] = 2)  ([986810007] = 1))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 200, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',200,1,20001021,0) ;

CALL DOCLOCK_IMPORT('   ',0,200,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[20001008])))
([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20001028,0) ;

CALL DOCLOCK_IMPORT('    / ,',0,200,1,0,11,0,' ((=204)(=212)  (=218))',0,3,'  \,  ,       ',0,'    / , ,  / , , /       ',null,'([984110041]=0)([984110045]=0)([984110046]=0)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    / ,', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,',200,1,20001008,0) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'[20001012] = 2',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[20001017] = 0)  ([988410008] = .[20001026]) 
 ((("..",[988410006])=0)
   (((".",.[20001017]), (".",[988410006]), "9.99.99.999.99"))   
   (((".",[988410006])=(".",.[20001017]))
    ((".",[988410006])=0))
   (("..",[988410006])=("..",.[20001017]))) 
(((".", .[20001017]) div 100000) between 218 and 219)  
(((".", .[20001017]) div 1000) = 11302)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20001011,0) ;

CALL DOCLOCK_IMPORT('      ',0,200,1,0,11,0,'[20001012] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[20001018] = 0)  (.[20001024] = [988410026]))

(([988410022] = 0)  (.[20001020] = 0)  (.[20001020] = [988410022]))

(([988410023] = 0)  (.[20001019] = 0)  (.[20001023] = [988410024]))

(([988410018] = 0)  (.[20001022] = 0)  (.[20001025] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 200, 1, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',200,1,20001011,0) ;

CALL DOCLOCK_IMPORT('  ',32768,200,1,0,3,0,' ( in (205, 213))',0,1,'  ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20001033,0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20001032,0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20001031,0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20001030,0) ;

CALL DOCLOCK_IMPORT('   ',32768,200,1,0,3,0,'((("..",[20000014]) between 10800  11199)       (("_...",[20001008]) between 10800  11199)        ((("_...",[20001008]) between 10000  10499)         (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20001014,0) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[20001012] = 0)  (("..",[980810002]) = 1)) 
((.[20001012] = 1)  (("..",[980810002])  = 1)) 
((.[20001012] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[20001012] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[20001012] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[20001012] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20001053,0) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[20011012] = 0)  (("..",[980810002]) = 1)) 
((.[20011012] = 1)  (("..",[980810002])  = 1)) 
((.[20011012] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[20011012] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[20011012] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[20011012] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011054,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'[20001012] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[20001017] = 0)  ([970910023] = .[20001026])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20001043,0) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,201,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 201, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111207,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111050,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111049,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111055,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111011,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110017,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110016,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110010,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110023,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110003,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110012,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110005,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110006,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110007,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110014,1) ;

CALL DOCLOCK_IMPORT('   ',0,201,0,0,11,0,'((32,30,3) = 0)  ((32,30,3) = 4)',0,1,'  ()  ,               ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 201, 0, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',201,0,20110015,1) ;

CALL DOCLOCK_IMPORT('     ',0,201,0,0,11,0,'(((32,30,3) = 0)  ((32,30,3) = 4))',0,1,'  () ,       , ,       ',0,'  .    , ,       ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 201, 0, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',201,0,20110015,1) ;

CALL DOCLOCK_IMPORT('   ',0,201,0,0,11,0,'((32,30,3) = 0)  ((32,30,3) = 4)',0,1,'  ()  ,               ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 201, 0, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',201,0,20100014,0) ;

CALL DOCLOCK_IMPORT('     ',0,201,0,0,11,0,'(((32,30,3) = 0)  ((32,30,3) = 4))',0,1,'  () ,       , ,       ',0,'  .    , ,       ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 201, 0, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',201,0,20100014,0) ;

CALL DOCLOCK_IMPORT('   ',0,201,1,0,11,0,'',0,1,'             .       \',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 201, 1, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',201,1,20111019,1) ;

CALL DOCLOCK_IMPORT('   ',0,201,1,0,11,0,'',0,1,'             .       \',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 201, 1, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',201,1,20101111,0) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,202,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 202, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211046,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210010,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211152,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210013,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210015,1) ;

CALL DOCLOCK_IMPORT('   ',0,202,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 202, 0, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',202,0,20210039,1) ;

CALL DOCLOCK_IMPORT('   ',0,202,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 202, 0, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',202,0,20200028,0) ;

CALL DOCLOCK_IMPORT('   ',0,202,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 202, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',202,1,20211038,1) ;

CALL DOCLOCK_IMPORT('   ',0,202,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 202, 1, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',202,1,20201108,0) ;

CALL DOCLOCK_IMPORT('    ',0,202,1,0,11,0,'([20211096]=0) ((32,45,3) between 0 and 2)',0,3,'         ,    "() "',0,'    .      ,    "() ',null,'(((32,45,3) = 0)   ([980410006] like "?00") 
   (([980410006] like "??0")  (".KVR[CODE].{COUNTNOTNULL(CODE)}",
  (''CODE like "''+ [980410006] div 1 +''_"''))>1))
 (((32,45,3) = 1)  ([980410006] like "??0")  ([980410006] <> "000")) 
 (((32,45,3) = 2)  ([980410006] like "?00")  ([980410006] <> "000"))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 202, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',202,1,20211021,1) ;

CALL DOCLOCK_IMPORT('    ',0,202,1,0,11,0,'([20201104]=0) ((32,45,3) between 0 and 2)',0,3,'         ,    "() "',0,'    .      ,    "() ',null,'(((32,45,3) = 0)   ([980410006] like "?00") 
   (([980410006] like "??0")  (".KVR[CODE].{COUNTNOTNULL(CODE)}",
  (''CODE like "''+ [980410006] div 1 +''_"''))>1))
 (((32,45,3) = 1)  ([980410006] like "??0")  ([980410006] <> "000")) 
 (((32,45,3) = 2)  ([980410006] like "?00")  ([980410006] <> "000"))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 202, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',202,1,20201047,0) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,203,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 203, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311161,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310013,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311046,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310010,1) ;

CALL DOCLOCK_IMPORT('   ',0,203,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 203, 0, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',203,0,20310039,1) ;

CALL DOCLOCK_IMPORT('   ',0,203,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 203, 0, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',203,0,20300124,0) ;

CALL DOCLOCK_IMPORT('   ',0,203,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 203, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',203,1,20311038,1) ;

CALL DOCLOCK_IMPORT('   ',0,203,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 203, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',203,1,20301139,0) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,204,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 204, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411152,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410013,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411046,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410010,1) ;

CALL DOCLOCK_IMPORT('   ',0,204,0,0,11,0,'',0,1,'    .    () ,       ,         01.08.00  01.11.99,  01.02.00  01.03.99       03.02.00',0,'  .    ,  () , (),  ,   ,      ',null,'([960110035] between 10800 and 11199)([960110035] between 10200 and 10399)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 204, 0, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',204,0,20410039,1) ;

CALL DOCLOCK_IMPORT('   / ()',0,204,0,0,11,0,'',0,1,'  - \ (). -          01.08.00  01.11.99   01.02.00  01.03.99',0,'-     ,  () , (),   ,   ',null,'(("..",[984110031]) between 10800 and 11199)(("..",[984110031]) between 10200 and 10399)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   / ()', 204, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   / ()',204,0,20400040,0) ;

CALL DOCLOCK_IMPORT('   / ()',0,204,0,0,11,0,'',0,1,'  - \ (). -          01.08.00  01.11.99   01.02.00  01.03.99',0,'-     ,  () , (),   ,   ',null,'(("..",[984110031]) between 10800 and 11199)(("..",[984110031]) between 10200 and 10399)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   / ()', 204, 0, 0, 1) ;

--  "\  "
CALL DOCLOCKFIELDS_INSERTFIELD('   / ()',204,0,20410034,1) ;

CALL DOCLOCK_IMPORT('   ',0,204,0,0,11,0,'',0,1,'    .     () ,       ,         01.08.00  01.11.99,  01.02.00  01.03.99       03.02.00',0,'  .    ,  () , (),  ,   ,      ',null,'([960110035] between 10800 and 11199)([960110035] between 10200 and 10399)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 204, 0, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',204,0,20400028,0) ;

CALL DOCLOCK_IMPORT('    / ,  ()',0,204,1,0,10,0,' (([20401054] <> 0)  (("_._",[20401054]))  (("_...",[20401054]) = 11000)  ([20401124] = 0))',0,3,'       /, -   ()',0,'         "/"    ()',0,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    / ,  ()', 204, 1, 0, 0) ;

--  "  (.)"
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,  ()',204,1,20401124,0) ;

CALL DOCLOCK_IMPORT('    ',0,205,1,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[20511093], .[20511031], .[20511090], .[20511092], .[20511118], .[20511068], .[20511105], .[20511036],
 .[20511119], .[20511047], .[20511069], .[20511037], 0,
 .[20511012], .[20511096], .[20511097], .[20511108])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 205, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',205,1,20511112,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,206,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 206, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611201,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610015,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610011,1) ;

CALL DOCLOCK_IMPORT('     ',0,206,0,0,11,0,'(((32,30,3) = 0)  ((32,30,3) = 3))',0,1,'  () ,       , ,       ',0,'  .    , ,       ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 206, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',206,0,20610040,1) ;

CALL DOCLOCK_IMPORT('   ',0,206,0,0,11,0,'((32,30,3) = 0)  ((32,30,3) = 3)',0,1,'  ()  ,               ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 206, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',206,0,20610040,1) ;

CALL DOCLOCK_IMPORT('   ',0,206,0,0,11,0,'((32,30,3) = 0)  ((32,30,3) = 3)',0,1,'  ()  ,               ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 206, 0, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',206,0,20600014,0) ;

CALL DOCLOCK_IMPORT('     ',0,206,0,0,11,0,'(((32,30,3) = 0)  ((32,30,3) = 3))',0,1,'  () ,       , ,       ',0,'  .    , ,       ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 206, 0, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',206,0,20600014,0) ;

CALL DOCLOCK_IMPORT('   ',0,206,1,0,11,0,'',0,1,'             .       \',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 206, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',206,1,20611039,1) ;

CALL DOCLOCK_IMPORT('   ',0,206,1,0,11,0,'',0,1,'             .       \',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 206, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',206,1,20601108,0) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,207,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 207, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711222,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710011,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,208,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 208, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811224,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810011,1) ;

CALL DOCLOCK_IMPORT('    ',0,209,2,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[20902020] = "")  ([970910017] = "000"))  
  ((.[20902020] <> "")  (.[20902020], [970910017], "9.9.9")))  
(((.[20902018] = "")  ([970910015] = "0000"))  
  ((.[20902018] <> "")  (.[20902018], [970910015], "99.99"))) 
(((.[20902016] = "")  ([970910013] = "0000000000"))  
  ((.[20902016] <> "")  (.[20902016], [970910013], ">aa.a.aa.aaaaa")))     
(((.[20902019] = "")  ([970910016] = "000"))  
  ((.[20902019] <> "")  (.[20902019], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[20902039] = 0)  (.[20902020] = [970910050])) 
(([970910046] = 0)  (.[20902018] = 0)  (.[20902018] = [970910046])) 
(([970910047] = 0)  (.[20902038] = 0)  (.[20902019] = [970910048])) 
(([970910042] = 0)  (.[20902037] = 0)  (.[20902016] = [970910043])) 
(([970910044] = 0)  (.[20902017] = 0)  (.[20902155] = [970910045])) 
(([970910065] = 0)  (.[20902021] = 0)  (.[20902021] = [970910065])) 
(([970910056] = "")  (.[20902164] = "")  (.[20902164] = [970910056])) 
(([970910060] = 0)  (.[20902009] = 0)  (.[20902043] = [970910061])) 
(([970910051] = 0)  (.[20902027] = 0)  (.[20902156] = [970910052])) 
(([970910064] = 0)  (.[20902025] = 0)  (.[20902025] = [970910064])) 
(([970910040] = 0)  (.[20902010] = 0)  (.[20902044] = [970910041])) 
(([970910038] = 0)  (.[20902006] = 0)  (.[20902042] = [970910039]))   
(([970910054] = "")  (.[20902040] = "")  (.[20902040] = [970910054])) 
(([970910033] = 0)  (.[20902001] = 0)  (.[20902001] = [970910033])) 
(([970910035] = "")  (.[20902139] = "")  (.[20902139] = [970910035])) 
(([970910059] = "")  (.[20902143] = "")  (.[20902143] = [970910059]))  
(([970910037] = "")  (.[20902161] = "")  (.[20902161] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 209, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',209,2,20902145,0) ;

CALL DOCLOCK_IMPORT('    ',0,209,2,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[20912020], .[20912018], .[20912016], .[20912019], .[20912155], .[20912021], .[20912160], .[20912009],
 .[20912156], .[20912025], .[20912010], .[20912006], .[20912040],
 .[20912001], .[20912045], .[20912046], .[20912159])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 209, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',209,2,20912047,1) ;

CALL DOCLOCK_IMPORT('   ',32768,209,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 209, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',209,2,20912048,1) ;

CALL DOCLOCK_IMPORT('  ',32768,209,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 209, 2, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,2,20902155,0) ;

CALL DOCLOCK_IMPORT('  ',32768,209,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 209, 2, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,2,20912155,1) ;

CALL DOCLOCK_IMPORT('   ',32768,209,2,0,3,0,'((("..",[20900021]) between 10800  11199)    (("_...",[20902007]) between 10800  11199)     ((("_...",[20902007]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 209, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',209,2,20902040,0) ;

CALL DOCLOCK_IMPORT('      ',0,209,2,0,11,0,'[20902032] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[20902039] = 0)  (.[20902020] = [988410026]))

(([988410022] = 0)  (.[20902018] = 0)  (.[20902018] = [988410022]))

(([988410023] = 0)  (.[20902038] = 0)  (.[20902019] = [988410024]))

(([988410018] = 0)  (.[20902037] = 0)  (.[20902016] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 209, 2, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',209,2,20902035,0) ;

CALL DOCLOCK_IMPORT('      ',0,209,2,0,11,0,'[20912032] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[20912039] = 0)  (.[20912020] = [988410026]))

(([988410022] = 0)  (.[20912018] = 0)  (.[20912018] = [988410022]))

(([988410023] = 0)  (.[20912038] = 0)  (.[20912019] = [988410024]))

(([988410018] = 0)  (.[20912037] = 0)  (.[20912016] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 209, 2, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',209,2,20912035,1) ;

CALL DOCLOCK_IMPORT('   ',32768,209,2,0,3,0,'((("..",[20910021]) between 10800  11199)    (("_...",[20912007]) between 10800  11199)     ((("_...",[20912007]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 209, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',209,2,20912040,1) ;

CALL DOCLOCK_IMPORT('      ',0,210,2,0,11,0,'[21010005] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[21012020] = 0)  (.[21012021] = [988410026]))

(([988410022] = 0)  (.[21012017] = 0)  (.[21012017] = [988410022]))

(([988410023] = 0)  (.[21012018] = 0)  (.[21012019] = [988410024]))

(([988410018] = 0)  (.[21012013] = 0)  (.[21012014] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 210, 2, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',210,2,21012045,1) ;

CALL DOCLOCK_IMPORT('  ',32768,210,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 210, 2, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,2,21002071,0) ;

CALL DOCLOCK_IMPORT('  ',32768,210,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 210, 2, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,2,21012071,1) ;

CALL DOCLOCK_IMPORT('   ',32768,210,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 210, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',210,2,21012067,1) ;

CALL DOCLOCK_IMPORT('      ',0,210,2,0,11,0,'[21000005] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[21002020] = 0)  (.[21002021] = [988410026]))

(([988410022] = 0)  (.[21002017] = 0)  (.[21002017] = [988410022]))

(([988410023] = 0)  (.[21002018] = 0)  (.[21002019] = [988410024]))

(([988410018] = 0)  (.[21002013] = 0)  (.[21002014] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 210, 2, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',210,2,21002045,0) ;

CALL DOCLOCK_IMPORT('   ',32768,210,2,0,3,0,'((("..",[21000022]) between 10800  11199)   (("_...",[21000014]) between 10000  10499))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 210, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',210,2,21002057,0) ;

CALL DOCLOCK_IMPORT('   ',32768,210,2,0,3,0,'((("..",[21010021]) between 10800  11199)   (("_...",[21010014]) between 10000  10499))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,1',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 210, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',210,2,21012052,1) ;

CALL DOCLOCK_IMPORT('      ',0,210,2,0,11,0,'[21000005] = 0',0,3,'      ',0,'     ',null,'([970910066] is null) ? 
((((.[21002021] = "")  ([970910017] = "000"))  
  ((.[21002021] <> "")  (.[21002021], [970910017], "9.9.9")))  
(((.[21002017] = "")  ([970910015] = "0000"))  
  ((.[21002017] <> "")  (.[21002017], [970910015], "99.99"))) 
(((.[21002014] = "")  ([970910013] = "0000000000"))  
  ((.[21002014] <> "")  (.[21002014], [970910013], ">aa.a.aa.aaaaa")))     
(((.[21002019] = "")  ([970910016] = "000"))  
  ((.[21002019] <> "")  (.[21002019], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[21002020] = 0)  (.[21002021] = [970910050])) 
(([970910046] = 0)  (.[21002017] = 0)  (.[21002017] = [970910046])) 
(([970910047] = 0)  (.[21002018] = 0)  (.[21002019] = [970910048])) 
(([970910042] = 0)  (.[21002013] = 0)  (.[21002014] = [970910043])) 
(([970910044] = 0)  (.[21002015] = 0)  (.[21002071] = [970910045])) 
(([970910065] = 0)  (.[21002022] = 0)  (.[21002022] = [970910065])) 
(([970910056] = "")  (.[21002075] = "")  (.[21002076] = [970910056])) 
(([970910060] = 0)  (.[21002009] = 0)  (.[21002059] = [970910061])) 
(([970910051] = 0)  (.[21002043] = 0)  (.[21002072] = [970910052])) 
(([970910064] = 0)  (.[21002041] = 0)  (.[21002041] = [970910064])) 
(([970910040] = 0)  (.[21002010] = 0)  (.[21002078] = [970910041])) 
(([970910038] = 0)  (.[21002006] = 0)  (.[21002080] = [970910039]))   
(([970910054] = "")  (.[21002055] = "")  (.[21002057] = [970910054])) 
(([970910033] = 0)  (.[21002001] = 0)  (.[21002001] = [970910033])) 
(([970910035] = "")  (.[21002082] = "")  (.[21002084] = [970910035])) 
(([970910059] = "")  (.[21002086] = "")  (.[21002088] = [970910059]))  
(([970910037] = "")  (.[21002068] = "")  (.[21002069] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 210, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',210,2,21002062,0) ;

CALL DOCLOCK_IMPORT('      ',0,210,2,0,11,0,'[21010005] = 0',0,3,'      ',0,'     ',null,'([970910066] is null) ? 
((((.[21012021] = "")  ([970910017] = "000"))  
  ((.[21012021] <> "")  (.[21012021], [970910017], "9.9.9")))  
(((.[21012017] = "")  ([970910015] = "0000"))  
  ((.[21012017] <> "")  (.[21012017], [970910015], "99.99"))) 
(((.[21012014] = "")  ([970910013] = "0000000000"))  
  ((.[21012014] <> "")  (.[21012014], [970910013], ">aa.a.aa.aaaaa")))     
(((.[21012019] = "")  ([970910016] = "000"))  
  ((.[21012019] <> "")  (.[21012019], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[21012020] = 0)  (.[21012021] = [970910050])) 
(([970910046] = 0)  (.[21012017] = 0)  (.[21012017] = [970910046])) 
(([970910047] = 0)  (.[21012018] = 0)  (.[21012019] = [970910048])) 
(([970910042] = 0)  (.[21012013] = 0)  (.[21012014] = [970910043])) 
(([970910044] = 0)  (.[21012015] = 0)  (.[21012071] = [970910045])) 
(([970910065] = 0)  (.[21012022] = 0)  (.[21012022] = [970910065])) 
(([970910056] = "")  (.[21012065] = "")  (.[21012064] = [970910056])) 
(([970910060] = 0)  (.[21012058] = 0)  (.[21012009] = [970910061])) 
(([970910051] = 0)  (.[21012043] = 0)  (.[21012072] = [970910052])) 
(([970910064] = 0)  (.[21012041] = 0)  (.[21012041] = [970910064])) 
(([970910040] = 0)  (.[21012060] = 0)  (.[21012010] = [970910041])) 
(([970910038] = 0)  (.[21012059] = 0)  (.[21012006] = [970910039]))   
(([970910054] = "")  (.[21012053] = "")  (.[21012052] = [970910054])) 
(([970910033] = 0)  (.[21012001] = 0)  (.[21012001] = [970910033])) 
(([970910035] = "")  (.[21012054] = "")  (.[21012055] = [970910035])) 
(([970910059] = "")  (.[21012056] = "")  (.[21012057] = [970910059]))  
(([970910037] = "")  (.[21012063] = "")  (.[21012062] = [970910037])))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 210, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',210,2,21012066,1) ;

CALL DOCLOCK_IMPORT('    ',0,211,2,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[21102015] = "")  ([970910017] = "000"))  
  ((.[21102015] <> "")  (.[21102015], [970910017], "9.9.9")))  
(((.[21102013] = "")  ([970910015] = "0000"))  
  ((.[21102013] <> "")  (.[21102013], [970910015], "99.99"))) 
(((.[21102011] = "")  ([970910013] = "0000000000"))  
  ((.[21102011] <> "")  (.[21102011], [970910013], ">aa.a.aa.aaaaa")))     
(((.[21102014] = "")  ([970910016] = "000"))  
  ((.[21102014] <> "")  (.[21102014], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[21102030] = 0)  (.[21102015] = [970910050])) 
(([970910046] = 0)  (.[21102013] = 0)  (.[21102013] = [970910046])) 
(([970910047] = 0)  (.[21102029] = 0)  (.[21102014] = [970910048])) 
(([970910042] = 0)  (.[21102028] = 0)  (.[21102011] = [970910043])) 
(([970910044] = 0)  (.[21102012] = 0)  (.[21102056] = [970910045])) 
(([970910065] = 0)  (.[21102016] = 0)  (.[21102016] = [970910065])) 
(([970910056] = "")  (.[21102087] = "")  (.[21102087] = [970910056])) 
(([970910060] = 0)  (.[21102043] = 0)  (.[21102005] = [970910061])) 
(([970910051] = 0)  (.[21102020] = 0)  (.[21102060] = [970910052])) 
(([970910064] = 0)  (.[21102019] = 0)  (.[21102019] = [970910064])) 
(([970910040] = 0)  (.[21102045] = 0)  (.[21102006] = [970910041])) 
(([970910038] = 0)  (.[21102047] = 0)  (.[21102002] = [970910039]))   
(([970910054] = "")  (.[21102031] = "")  (.[21102031] = [970910054])) 
(([970910033] = 0)  (.[21102024] = 0)  (.[21102024] = [970910033])) 
(([970910035] = "")  (.[21102083] = "")  (.[21102083] = [970910035])) 
(([970910059] = "")  (.[21102085] = "")  (.[21102085] = [970910059]))  
(([970910037] = "")  (.[21102049] = "")  (.[21102049] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 211, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',211,2,21102052,0) ;

CALL DOCLOCK_IMPORT('    ',0,211,2,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[21112019], .[21112017], .[21112015], .[21112018], .[21112058], .[21112020], .[21112080], .[21112008],
 .[21112062], .[21112024], .[21112009], .[21112005], .[21112033],
 .[21112004], .[21112076], .[21112077], .[21112049])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 211, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',211,2,21112052,1) ;

CALL DOCLOCK_IMPORT('  ',32768,211,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 211, 2, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,2,21102056,0) ;

CALL DOCLOCK_IMPORT('  ',32768,211,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 211, 2, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,2,21112058,1) ;

CALL DOCLOCK_IMPORT('   ',32768,211,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 211, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',211,2,21112051,1) ;

CALL DOCLOCK_IMPORT('      ',0,211,2,0,11,0,'[21102023] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[21102030] = 0)  (.[21102015] = [988410026]))

(([988410022] = 0)  (.[21102013] = 0)  (.[21102013] = [988410022]))

(([988410023] = 0)  (.[21102029] = 0)  (.[21102014] = [988410024]))

(([988410018] = 0)  (.[21102028] = 0)  (.[21102011] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 211, 2, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',211,2,21102026,0) ;

CALL DOCLOCK_IMPORT('      ',0,211,2,0,11,0,'[21112003] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[21112031] = 0)  (.[21112019] = [988410026]))

(([988410022] = 0)  (.[21112017] = 0)  (.[21112017] = [988410022]))

(([988410023] = 0)  (.[21112030] = 0)  (.[21112018] = [988410024]))

(([988410018] = 0)  (.[21112032] = 0)  (.[21112015] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 211, 2, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',211,2,21112028,1) ;

CALL DOCLOCK_IMPORT('   ',32768,211,2,0,3,0,'((("..",[21100020]) between 10800  11199)    (("_...",[21102003]) between 10800  11199)     ((("_...",[21102003]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 211, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',211,2,21102031,0) ;

CALL DOCLOCK_IMPORT('   ',32768,211,2,0,3,0,'((("..",[21110019]) between 10800  11199)    (("_...",[21112006]) between 10800  11199)     ((("_...",[21112006]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 211, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',211,2,21112033,1) ;

CALL DOCLOCK_IMPORT('    ',0,212,2,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[21202015] = "")  ([970910017] = "000"))  
  ((.[21202015] <> "")  (.[21202015], [970910017], "9.9.9")))  
(((.[21202013] = "")  ([970910015] = "0000"))  
  ((.[21202013] <> "")  (.[21202013], [970910015], "99.99"))) 
(((.[21202011] = "")  ([970910013] = "0000000000"))  
  ((.[21202011] <> "")  (.[21202011], [970910013], ">aa.a.aa.aaaaa")))     
(((.[21202014] = "")  ([970910016] = "000"))  
  ((.[21202014] <> "")  (.[21202014], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[21202030] = 0)  (.[21202015] = [970910050])) 
(([970910046] = 0)  (.[21202013] = 0)  (.[21202013] = [970910046])) 
(([970910047] = 0)  (.[21202029] = 0)  (.[21202014] = [970910048])) 
(([970910042] = 0)  (.[21202028] = 0)  (.[21202011] = [970910043])) 
(([970910044] = 0)  (.[21202012] = 0)  (.[21202059] = [970910045])) 
(([970910065] = 0)  (.[21202016] = 0)  (.[21202016] = [970910065])) 
(([970910056] = "")  (.[21202073] = "")  (.[21202073] = [970910056])) 
(([970910060] = 0)  (.[21202044] = 0)  (.[21202005] = [970910061])) 
(([970910051] = 0)  (.[21202020] = 0)  (.[21202063] = [970910052])) 
(([970910064] = 0)  (.[21202019] = 0)  (.[21202019] = [970910064])) 
(([970910040] = 0)  (.[21202046] = 0)  (.[21202006] = [970910041])) 
(([970910038] = 0)  (.[21202048] = 0)  (.[21202002] = [970910039]))   
(([970910054] = "")  (.[21202031] = "")  (.[21202031] = [970910054])) 
(([970910033] = 0)  (.[21202024] = 0)  (.[21202024] = [970910033])) 
(([970910035] = "")  (.[21202069] = "")  (.[21202069] = [970910035])) 
(([970910059] = "")  (.[21202071] = "")  (.[21202071] = [970910059]))  
(([970910037] = "")  (.[21202050] = "")  (.[21202050] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 212, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',212,2,21202053,0) ;

CALL DOCLOCK_IMPORT('    ',0,212,2,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[21212019], .[21212017], .[21212015], .[21212018], .[21212057], .[21212020], .[21212066], .[21212008],
 .[21212061], .[21212024], .[21212009], .[21212005], .[21212033],
 .[21212004], .[21212062], .[21212063], .[21212050])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',212,2,21212053,1) ;

CALL DOCLOCK_IMPORT('  ',32768,212,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 212, 2, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,2,21202059,0) ;

CALL DOCLOCK_IMPORT('  ',32768,212,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 212, 2, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,2,21212057,1) ;

CALL DOCLOCK_IMPORT('   ',32768,212,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',212,2,21212052,1) ;

CALL DOCLOCK_IMPORT('   ',32768,212,2,0,3,0,'((("..",[21200020]) between 10800  11199)    (("_...",[21202003]) between 10800  11199)     ((("_...",[21202003]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 212, 2, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',212,2,21202031,0) ;

CALL DOCLOCK_IMPORT('   ',32768,212,2,0,3,0,'((("..",[21210019]) between 10800  11199)    (("_...",[21212006]) between 10800  11199)     ((("_...",[21212006]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',212,2,21212033,1) ;

CALL DOCLOCK_IMPORT('  ',0,213,-1,0,15,1,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 213, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21311008,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21310031,2) ;

CALL DOCLOCK_IMPORT('  ',0,213,-1,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 213, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21311008,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21310031,2) ;

CALL DOCLOCK_IMPORT('   ',0,213,1,0,11,0,'',0,3,'    01.01. - 01.03.',0,'    (01.01.),  (01.02. - 01.03.)       (03.02.00)',null,'([960110035] between 10100 and 10399)([960110035] = 30200)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 213, 1, 0, 2) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',213,1,21311051,2) ;

CALL DOCLOCK_IMPORT('      ()',0,213,1,0,11,0,'(-1,5,3) <> 2',0,1,' ,    = ,    ,          "    ().  = ""',0,'      ""        ',null,'([988410016] = 0)  ([988410008] = (".",.[21311041]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ()', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ()',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('      (,)',0,213,1,0,11,0,'((-1,5,3) = 2)  (("",[21310031] , 277, 213) <> 2)',0,1,' ,    = ,          "    ().  = ""',0,'      ""        ',null,'([988410016] = 0)  ([988410008] = (".",.[21311041]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      (,)', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      (,)',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('      (, )',0,213,1,0,11,0,'((-1,5,3) = 2)  (("",[21310031] , 277, 213) = 2)',0,1,' ,    = ,              "    ()".  = ""',0,'      ""           ',null,'([988410016] = 1)  ([988410026] = ("..",.[21311044])) 
([988410022] = ("..",.[21311044]))  
([988410019] = ("..",.[21311044]))  
([988410024] = ("..",.[21311044]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      (, )', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      (, )',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,15,1,'',0,1,'',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 0) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21401008,0) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21400031,0) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,12,0,'',0,3,'',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 0) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21401008,0) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21400031,0) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,15,1,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21411008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21410031,1) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,12,0,'',0,3,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21411008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21410031,1) ;

CALL DOCLOCK_IMPORT('  ',1048576,214,-1,0,7,0,'',1,3,'   .   ,   .           ',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 2) ;

CALL DOCLOCK_IMPORT(' ',1048576,214,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 214, -1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',214,-1,21410006,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',214,-1,21410021,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',214,-1,21410020,1) ;

CALL DOCLOCK_IMPORT('  ',2,214,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',64,214,-1,0,8,2,'',1,1,'         .       ',1,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,15,1,'',0,1,'',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 0) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21501008,0) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21500031,0) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,12,0,'',0,3,'',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 0) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21501008,0) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21500031,0) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,15,1,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21511008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21510031,1) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,12,0,'',0,3,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21511008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21510031,1) ;

CALL DOCLOCK_IMPORT(' ',1048576,215,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 215, -1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',215,-1,21510021,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',215,-1,21510020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',215,-1,21510006,1) ;

CALL DOCLOCK_IMPORT('  ',2,215,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',64,215,-1,0,8,2,'',1,1,'         .       ',1,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',1048576,215,-1,0,7,0,'',1,3,'   .   ,   .           ',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 2) ;

CALL DOCLOCK_IMPORT(' .    ',131072,216,-1,0,7,0,'[21610006] = "1"',0,1,'     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' .    ', 216, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',0,216,-1,0,15,1,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21611060,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21610058,2) ;

CALL DOCLOCK_IMPORT('  ',0,216,-1,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21611060,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21610058,2) ;

CALL DOCLOCK_IMPORT(' ',65536,216,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 216, -1, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610013,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610012,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610057,2) ;

CALL DOCLOCK_IMPORT('  ',65536,216,-1,0,7,0,'',1,1,'   .   ,   .           .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,216,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 216, -1, 1, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610007,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611051,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611050,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611049,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611047,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611045,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611042,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611035,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611034,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611033,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611032,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611031,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611030,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611029,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611028,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611027,1) ;

--  " 4"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611026,1) ;

--  " 3"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611025,1) ;

--  " 2"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611024,1) ;

--  " 1"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611023,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611022,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611021,1) ;

--  "\  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610017,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610013,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610012,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610009,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610057,1) ;

CALL DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'',0,1,'  .       ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610013,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610012,2) ;

CALL DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'[21610056]<200',0,1,'  .        .',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610057,2) ;

CALL DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'[21610056]>=200',0,1,'  .       .',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610057,2) ;

CALL DOCLOCK_IMPORT('  ',0,217,-1,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21712083,2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21711053,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21710083,2) ;

CALL DOCLOCK_IMPORT('  ',0,217,-1,0,15,1,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21712083,2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21711053,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21710083,2) ;

CALL DOCLOCK_IMPORT('  ',65536,217,-1,0,7,0,'',1,1,'   .   ,   .           .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) ;

CALL DOCLOCK_IMPORT(' ',65536,217,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 217, -1, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710005,2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710015,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710016,2) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,217,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 217, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710013,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710016,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710006,1) ;

CALL DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'',0,1,'  .       ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710015,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710016,2) ;

CALL DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'[21710082]<200',0,1,'  .        .',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710005,2) ;

CALL DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'[21710082]>=200',0,1,'  .       .',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710005,2) ;

CALL DOCLOCK_IMPORT('      ',0,300,1,0,11,0,'[30011019] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[30011026] = 0)  (.[30011033] = [988410026]))

(([988410022] = 0)  (.[30011029] = 0)  (.[30011029] = [988410022]))

(([988410023] = 0)  (.[30011028] = 0)  (.[30011032] = [988410024]))

(([988410018] = 0)  (.[30011027] = 0)  (.[30011031] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 300, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',300,1,30011018,1) ;

CALL DOCLOCK_IMPORT('     , ',0,300,1,0,11,0,'(("_._",[30010008])    ("_._",[30010008])    ("_.",[30010008]))  ( in(0323,0324))',0,1,',     ,   =- \,  =.    \ \,     <>.   \ \      .',0,'         ',null,'([988910008] = ("_.",.[30010008])
 ((".",[988910008]) between 10100  10199))
   
(( ("_._",.[30010008])
 ([988910010] = 0))

(("_._",.[30010008])
 ([988910010] <> 0)))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 300, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',300,1,30011023,1) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'([30011019] = 2)   ((( <> 305)  ( <> 302))    (("_..",[30010008]) between 010800 and 011099))',0,1,'          ,    / , ()         /.      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[30011025] = 0)  (.[30011034] = [988410008])
 ((("..",[988410006])=0)
  (((".",.[30011025]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[30011025]))
     ((".",[988410006])=0))
 (("..",[988410006])=("..",.[30011025])))
 (((".", .[30011025]) div 100000) between 218 and 219) 
 (((".", .[30011025]) div 1000) = 11302)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30011018,1) ;

CALL DOCLOCK_IMPORT('   ',32768,300,1,0,3,0,'((("_...",[30010008]) between 10800  11199)    (("_...",[30010008]) between 10000  10499)   ( in(0323,0324)))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',300,1,30011022,1) ;

CALL DOCLOCK_IMPORT('    ',0,300,1,0,17,0,' ( in (306, 307, 311, 312, 314, 315))',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[30011033], .[30011029], .[30011031], .[30011032], .[30011053], .[30011035], .[30011054], .[30011043],
 .[30011057], .[30011058], .[30011059], .[30011061], .[30011022],
 0, .[30011063], .[30011065], .[30011067])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',300,1,30011047,1) ;

CALL DOCLOCK_IMPORT('    ',0,300,1,0,11,0,' ( in (306, 307, 311, 312, 314, 315))',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[30001033] = "")  ([970910017] = "000"))  
  ((.[30001033] <> "")  (.[30001033], [970910017], "9.9.9")))  
(((.[30001029] = "")  ([970910015] = "0000"))  
  ((.[30001029] <> "")  (.[30001029], [970910015], "99.99"))) 
(((.[30001031] = "")  ([970910013] = "0000000000"))  
  ((.[30001031] <> "")  (.[30001031], [970910013], ">aa.a.aa.aaaaa")))     
(((.[30001032] = "")  ([970910016] = "000"))  
  ((.[30001032] <> "")  (.[30001032], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[30001026] = 0)  (.[30001033] = [970910050])) 
(([970910046] = 0)  (.[30001029] = 0)  (.[30001029] = [970910046])) 
(([970910047] = 0)  (.[30001028] = 0)  (.[30001032] = [970910048])) 
(([970910042] = 0)  (.[30001027] = 0)  (.[30001031] = [970910043])) 
(([970910044] = 0)  (.[30001030] = 0)  (.[30001054] = [970910045])) 
(([970910065] = 0)  (.[30001035] = 0)  (.[30001035] = [970910065])) 
(([970910056] = "")  (.[30001055] = "")  (.[30001055] = [970910056])) 
(([970910060] = 0)  (.[30001044] = 0)  (.[30001043] = [970910061])) 
(([970910051] = 0)  (.[30001057] = 0)  (.[30001058] = [970910052])) 
(([970910064] = 0)  (.[30001059] = 0)  (.[30001059] = [970910064])) 
(([970910040] = 0)  (.[30001061] = 0)  (.[30001060] = [970910041])) 
(([970910038] = 0)  (.[30001063] = 0)  (.[30001062] = [970910039]))   
(([970910054] = "")  (.[30001022] = "")  (.[30001022] = [970910054])) 
(([970910035] = "")  (.[30001064] = "")  (.[30001064] = [970910035])) 
(([970910059] = "")  (.[30001066] = "")  (.[30001066] = [970910059]))  
(([970910037] = "")  (.[30001068] = "")  (.[30001068] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 300, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',300,1,30001047,0) ;

CALL DOCLOCK_IMPORT('  ',32768,300,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 300, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',300,1,30001054,0) ;

CALL DOCLOCK_IMPORT('  ',32768,300,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 300, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',300,1,30011053,1) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'([30001019] = 2)   ((( <> 305)  ( <> 302))    (("_..",[30000008]) between 010800 and 011099))',0,2,'          ,    / , ()         /.      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[30001025] = 0)  (.[30001034] = [988410008])
 ((("..",[988410006])=0)
  (((".",.[30001025]), (".",[988410006]), "9.99.99.999.99")) 
  (((".",[988410006])=(".",.[30001025]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[30001025])))
 (((".", .[30001025]) div 100000) between 218 and 219)   
 (((".", .[30001025]) div 1000) = 11302)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 1, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30001018,0) ;

CALL DOCLOCK_IMPORT('      ',0,300,1,0,11,0,'[30001019] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[30001026] = 0)  (.[30001033] = [988410026]))

(([988410022] = 0)  (.[30001029] = 0)  (.[30001029] = [988410022]))

(([988410023] = 0)  (.[30001028] = 0)  (.[30001032] = [988410024]))

(([988410018] = 0)  (.[30001027] = 0)  (.[30001031] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 300, 1, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',300,1,30001018,0) ;

CALL DOCLOCK_IMPORT('   ',32768,300,1,0,3,0,'((("_...",[30000008]) between 10800  11199)    (("_...",[30000008]) between 10000  10499)   ( in(0323,0324)))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 300, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',300,1,30001022,0) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30001019] = 0)  (("..",[980810002]) = 1)) 
((.[30001019] = 1)  (("..",[980810002])  = 1)) 
((.[30001019] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30001019] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30001019] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30001019] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30001057,0) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30011019] = 0)  (("..",[980810002]) = 1)) 
((.[30011019] = 1)  (("..",[980810002])  = 1)) 
((.[30011019] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30011019] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30011019] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30011019] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30011056,1) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'[30001019] = 2',0,1,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30001025] = 0)  (.[30001034] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30001047,0) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'[30011019] = 2',0,1,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30011025] = 0)  (.[30011034] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30011047,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,301,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111100,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111002,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111048,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111012,1) ;

--  " - ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111010,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111028,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111101,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111032,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111030,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111001,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111022,1) ;

--  " - -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111025,1) ;

--  " .  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111031,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111029,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111219,1) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111215,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,301,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 301, -1, 1, 1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111219,1) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111215,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111027,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111100,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111002,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111011,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111048,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111012,1) ;

--  " - ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111050,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111028,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111023,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111101,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111032,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111030,1) ;

--  " ( -)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111052,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111001,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111022,1) ;

--  " - -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111025,1) ;

--  " .  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111031,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110098,1) ;

CALL DOCLOCK_IMPORT('    .   ',0,301,1,0,11,0,'[30111051] = 0',0,1,'          , , , .    ,         ,      ',0,'        ',null,'(([988410025] = 0)  (.[30111020] = 0)  (.[30111143] = [988410026]))

(([988410022] = 0)  (.[30111018] = 0)  (.[30111018] = [988410022]))

(([988410023] = 0)  (.[30111016] = 0)  (.[30111142] = [988410024]))

(([988410018] = 0)  (.[30111019] = 0)  (.[30111140] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    .   ', 301, 1, 0, 1) ;

--  "   ."
CALL DOCLOCKFIELDS_INSERTFIELD('    .   ',301,1,30111136,1) ;

CALL DOCLOCK_IMPORT('    ',32768,301,1,0,3,0,'((("_...",[30111014]) between 10800  11199)    (("_...",[30111014]) between 10000  10499) )',0,1,'  "  "  \    -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,  ()).',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30111150,1) ;

CALL DOCLOCK_IMPORT('    ',0,301,1,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[30101156] = "")  ([970910017] = "000"))  
  ((.[30101156] <> "")  (.[30101156], [970910017], "9.9.9")))  
(((.[30101008] = "")  ([970910015] = "0000"))  
  ((.[30101008] <> "")  (.[30101008], [970910015], "99.99"))) 
(((.[30101154] = "")  ([970910013] = "0000000000"))  
  ((.[30101154] <> "")  (.[30101154], [970910013], ">aa.a.aa.aaaaa")))     
(((.[30101155] = "")  ([970910016] = "000"))  
  ((.[30101155] <> "")  (.[30101155], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[30101018] = 0)  (.[30101156] = [970910050])) 
(([970910046] = 0)  (.[30101008] = 0)  (.[30101008] = [970910046])) 
(([970910047] = 0)  (.[30101006] = 0)  (.[30101155] = [970910048])) 
(([970910042] = 0)  (.[30101010] = 0)  (.[30101154] = [970910043])) 
(([970910044] = 0)  (.[30101007] = 0)  (.[30101212] = [970910045])) 
(([970910065] = 0)  (.[30101013] = 0)  (.[30101013] = [970910065])) 
(([970910056] = "")  (.[30101201] = "")  (.[30101201] = [970910056])) 
(([970910060] = 0)  (.[30101191] = 0)  (.[30101015] = [970910061])) 
(([970910051] = 0)  (.[30101017] = 0)  (.[30101017] = [970910052])) 
(([970910064] = 0)  (.[30101102] = 0)  (.[30101102] = [970910064])) 
(([970910040] = 0)  (.[30101190] = 0)  (.[30101012] = [970910041])) 
(([970910038] = 0)  (.[30101193] = 0)  (.[30101022] = [970910039]))   
(([970910054] = "")  (.[30101177] = "")  (.[30101177] = [970910054])) 
(([970910035] = "")  (.[30101181] = "")  (.[30101181] = [970910035])) 
(([970910059] = "")  (.[30101182] = "")  (.[30101182] = [970910059]))  
(([970910037] = "")  (.[30101202] = "")  (.[30101202] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30101207,0) ;

CALL DOCLOCK_IMPORT('  .   ',0,301,1,0,11,0,'',0,3,'  .    ',0,'   .    ',null,'((.[30100149] = 0)  ([986810009] = 1)) 
((.[30100149] = 1)  ([986810008] = 1)) 
((.[30100149] = 2)  ([986810007] = 1))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  .   ', 301, 1, 0, 0) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('  .   ',301,1,30101007,0) ;

CALL DOCLOCK_IMPORT('  .   ',0,301,1,0,11,0,'',0,3,'  .    ',0,'   .    ',null,'((.[30110110] = 0)  ([986810009] = 1)) 
((.[30110110] = 1)  ([986810008] = 1)) 
((.[30110110] = 2)  ([986810007] = 1))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  .   ', 301, 1, 0, 1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('  .   ',301,1,30111017,1) ;

CALL DOCLOCK_IMPORT('    ',0,301,1,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[30111143], .[30111018], .[30111140], .[30111142], .[30111213], .[30111023], .[30111174], .[30111022],
 .[30111215], .[30111101], .[30111024], .[30111030], .[30111150],
 0, .[30111154], .[30111155], .[30111175])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30111193,1) ;

CALL DOCLOCK_IMPORT('   ',32768,301,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  " ",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 301, 1, 0, 0) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',301,1,30101212,0) ;

CALL DOCLOCK_IMPORT('   ',32768,301,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  " ",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 301, 1, 0, 1) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',301,1,30111213,1) ;

CALL DOCLOCK_IMPORT('    .   ',0,301,1,0,11,0,'[30101081] = 0',0,1,'          , , , .    ,         ,      ',0,'        ',null,'(([988410025] = 0)  (.[30101018] = 0)  (.[30101156] = [988410026]))

(([988410022] = 0)  (.[30101008] = 0)  (.[30101008] = [988410022]))

(([988410023] = 0)  (.[30101006] = 0)  (.[30101155] = [988410024]))

(([988410018] = 0)  (.[30101010] = 0)  (.[30101154] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    .   ', 301, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    .   ',301,1,30101150,0) ;

CALL DOCLOCK_IMPORT('    ',32768,301,1,0,3,0,'((("_...",[30101004]) between 10800  11199)    (("_...",[30101004]) between 10000  10499) )',0,1,'  "  "  \    -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,  ()).',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30101177,0) ;

CALL DOCLOCK_IMPORT('  .    ',0,301,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30110110] = 0)  (("..",[980810002]) = 1)) 
((.[30110110] = 1)  (("..",[980810002])  = 1)) 
((.[30110110] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30110110] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30110110] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30110110] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  .    ', 301, 1, 0, 1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('  .    ',301,1,30111021,1) ;

CALL DOCLOCK_IMPORT('   .   ',0,301,1,0,11,0,'[30101081] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30101162] = 0)  (.[30101165] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   .   ', 301, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('   .   ',301,1,30101207,0) ;

CALL DOCLOCK_IMPORT('   .   ',0,301,1,0,11,0,'[30111051] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30111122] = 0)  (.[30111130] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   .   ', 301, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('   .   ',301,1,30111193,1) ;

CALL DOCLOCK_IMPORT('  .    ',0,301,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30100149] = 0)  (("..",[980810002]) = 1)) 
((.[30100149] = 1)  (("..",[980810002])  = 1)) 
((.[30100149] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30100149] = 0)  ((".",Copy((".",[980810002]),0,3)) = 1)) 
((.[30100149] = 1)  ((".",Copy((".",[980810002]),0,3))  = 1)) 
((.[30100149] = 2)  ((".",Copy((".",[980810002]),0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  .    ', 301, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  .    ',301,1,30101017,0) ;

CALL DOCLOCK_IMPORT('  ',0,302,-1,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 302, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30211158,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30210163,2) ;

CALL DOCLOCK_IMPORT('    ',1074855941,302,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 302, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211015,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211008,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211012,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211222,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,302,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 302, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211222,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211012,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211043,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211015,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210104,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210025,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210005,1) ;

--  " /"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210034,1) ;

CALL DOCLOCK_IMPORT('  ',0,302,-1,0,15,1,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 302, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30211158,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30210163,2) ;

CALL DOCLOCK_IMPORT(' , ,   ',0,302,-1,0,16,1,' ((".",0))  (((("%root%\\\\300\", "",[30210013],[30210153])) ) (("%root%\\\\300\", "__",[30210157],[30210014],[30210154],[30210043],[30211220],[30211142],[30210030]) in (1,4)))',0,1,'  , ,    ',0,'   ,        ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' , ,   ', 302, -1, 0, 1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD(' , ,   ',302,-1,30210014,1) ;

CALL DOCLOCK_IMPORT(' , ,   ',0,302,-1,0,16,1,' ((".",0))  (((("%root%\\\\300\", "",[30200034],[30200177])) ) (("%root%\\\\300\", "__",[30200158],[30200020],[30200178],[30200033],[30201219],[30201148],[30200022]) in (1,4)))',0,1,'  , ,     ',0,'   ,        ',0,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE(' , ,   ', 302, -1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' , ,   ',302,-1,30200020,0) ;

CALL DOCLOCK_IMPORT('   ',0,302,-1,0,16,1,' ((".",0))  (((("%root%\\\\300\", "",[30210013],[30210153]))   (("%root%\\\\300\", "",[30211220],[30211142],[30210030]) in (1,4))) (("%root%\\\\300\", "",[30210157]) in (1,4)))',0,1,'     ',0,'      ,           ͻ',1,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 302, -1, 0, 1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',302,-1,30210157,1) ;

CALL DOCLOCK_IMPORT('   ',0,302,-1,0,16,1,' ((".",0))  (((("%root%\\\\300\", "",[30200034],[30200177]))   (("%root%\\\\300\", "",[30201219],[30201148],[30200022]) in (1,4))) (("%root%\\\\300\", "",[30200158]) in (1,4)))',0,1,'     ',0,'      ,           ͻ',1,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 302, -1, 0, 0) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',302,-1,30200158,0) ;

CALL DOCLOCK_IMPORT(' , , ,   ',0,302,0,0,10,1,' ((".",0))  (((("%root%\\\\300\", "",[30210013],[30210153]))   (("%root%\\\\300\", "") in (0)) ) ((("%root%\\\\300\", "",[30210157]) in (0,1))   (("%root%\\\\300\", "",[30210014]) in (0,1))   (("%root%\\\\300\", "",[30210014]) in (0,1))   (("%root%\\\\300\", "",[30210014],[30210154],[30210043]) in (0,1))  ))',0,1,'  , , ,      ',0,'      ,     , ,   ',1,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' , , ,   ', 302, 0, 0, 1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD(' , , ,   ',302,0,30210014,1) ;

CALL DOCLOCK_IMPORT(' , , ,   ',0,302,0,0,10,1,' ((".",0))  (((("%root%\\\\300\", "",[30200034],[30200177]))   (("%root%\\\\300\", "") in (0)) ) ((("%root%\\\\300\", "",[30200158]) in (0,1))   (("%root%\\\\300\", "",[30200020]) in (0,1))   (("%root%\\\\300\", "",[30200020]) in (0,1))   (("%root%\\\\300\", "",[30200020],[30200178],[30200033]) in (0,1))  ))',0,1,'  , , ,      ',0,'      ,     , ,   ',1,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE(' , , ,   ', 302, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' , , ,   ',302,0,30200020,0) ;

CALL DOCLOCK_IMPORT('    ',1075904517,303,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 303, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311026,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311039,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311018,1) ;

--  " . -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311030,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311040,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311119,1) ;

CALL DOCLOCK_IMPORT('    ',1075904517,304,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 304, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411007,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411001,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411018,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411010,1) ;

--  " O "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411009,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411008,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411178,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1075838980,304,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 304, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411178,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411007,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411001,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411018,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411045,1) ;

--  " O "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411009,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410022,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410096,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410011,1) ;

CALL DOCLOCK_IMPORT('  - \',32768,304,1,0,3,0,'(("_..",[30410017]) < 10800)  (("_..",[30410017]) > 11199)',0,3,'  " "      -   01.08.00-01.11.99.',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  - \', 304, 1, 0, 1) ;

CALL DOCLOCK_IMPORT('  - \',32768,304,1,0,3,0,'(("_..",[30400018]) < 10800)  (("_..",[30400018]) > 11199)',0,3,'  " "      -   01.08.00-01.11.99.',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  - \', 304, 1, 0, 0) ;

CALL DOCLOCK_IMPORT('  ',0,305,-1,0,15,1,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 305, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30511150,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30510173,2) ;

CALL DOCLOCK_IMPORT('  ',0,305,-1,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 305, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30511150,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30510173,2) ;

CALL DOCLOCK_IMPORT(' ,   ',2097156,305,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 305, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511190,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511023,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511022,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511020,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511103,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511104,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30510099,1) ;

CALL DOCLOCK_IMPORT('    ',2228229,305,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 305, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511190,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511023,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511022,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511103,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511104,1) ;

CALL DOCLOCK_IMPORT(' ,   ',4194308,306,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 306, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611208,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611023,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611049,1) ;

--  " ( . - )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611033,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611040,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30610011,1) ;

CALL DOCLOCK_IMPORT('    ',4325381,306,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 306, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611208,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611023,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611049,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611033,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611024,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611035,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,308,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811050,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811043,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811041,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811036,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811035,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811025,1) ;

--  " .  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811018,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811017,1) ;

--  " ( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811261,1) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811256,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811008,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,308,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 308, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811050,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811049,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811043,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811041,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811036,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810006,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811025,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811024,1) ;

--  "  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811020,1) ;

--  " .  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811018,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811002,1) ;

--  " ( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811261,1) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811256,1) ;

CALL DOCLOCK_IMPORT('    .   ',0,308,1,0,11,0,'[30811003] = 0',0,1,'          , , , .    ,         ,      ',0,'        ',null,'(([988410025] = 0)  (.[30811073] = 0)  (.[30811074] = [988410026]))

(([988410022] = 0)  (.[30811070] = 0)  (.[30811070] = [988410022]))

(([988410023] = 0)  (.[30811071] = 0)  (.[30811072] = [988410024]))

(([988410018] = 0)  (.[30811067] = 0)  (.[30811068] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    .   ', 308, 1, 0, 1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('    .   ',308,1,30811063,1) ;

CALL DOCLOCK_IMPORT('    ',0,308,1,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[30801204] = "")  ([970910017] = "000"))  
  ((.[30801204] <> "")  (.[30801204], [970910017], "9.9.9")))  
(((.[30801030] = "")  ([970910015] = "0000"))  
  ((.[30801030] <> "")  (.[30801030], [970910015], "99.99"))) 
(((.[30801202] = "")  ([970910013] = "0000000000"))  
  ((.[30801202] <> "")  (.[30801202], [970910013], ">aa.a.aa.aaaaa")))     
(((.[30801203] = "")  ([970910016] = "000"))  
  ((.[30801203] <> "")  (.[30801203], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[30801032] = 0)  (.[30801204] = [970910050])) 
(([970910046] = 0)  (.[30801030] = 0)  (.[30801030] = [970910046])) 
(([970910047] = 0)  (.[30801028] = 0)  (.[30801203] = [970910048])) 
(([970910042] = 0)  (.[30801031] = 0)  (.[30801202] = [970910043])) 
(([970910044] = 0)  (.[30801029] = 0)  (.[30801255] = [970910045])) 
(([970910065] = 0)  (.[30801035] = 0)  (.[30801035] = [970910065])) 
(([970910056] = "")  (.[30801242] = "")  (.[30801242] = [970910056])) 
(([970910060] = 0)  (.[30801231] = 0)  (.[30801034] = [970910061])) 
(([970910051] = 0)  (.[30801033] = 0)  (.[30801257] = [970910052])) 
(([970910064] = 0)  (.[30801184] = 0)  (.[30801184] = [970910064])) 
(([970910040] = 0)  (.[30801233] = 0)  (.[30801036] = [970910041])) 
(([970910038] = 0)  (.[30801235] = 0)  (.[30801002] = [970910039]))   
(([970910054] = "")  (.[30801219] = "")  (.[30801219] = [970910054])) 
(([970910035] = "")  (.[30801214] = "")  (.[30801214] = [970910035])) 
(([970910059] = "")  (.[30801215] = "")  (.[30801215] = [970910059]))  
(([970910037] = "")  (.[30801243] = "")  (.[30801243] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30801248,0) ;

CALL DOCLOCK_IMPORT('    ',0,308,1,0,17,0,'',0,1,'      ',0,'     ',null,'/* , , , , , , , , 
  , , , , , 
  , , ,  */
("%root%\\\\0\", "",
 .[30811074], .[30811070], .[30811068], .[30811072], .[30811254], .[30811024], .[30811114], .[30811016],
 .[30811256], .[30811026], .[30811018], .[30811008], .[30811082],
 0, .[30811085], .[30811086], .[30811115])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30811120,1) ;

CALL DOCLOCK_IMPORT('   ',32768,308,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  " ",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 308, 1, 0, 0) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',308,1,30801255,0) ;

CALL DOCLOCK_IMPORT('   ',32768,308,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  " ",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 308, 1, 0, 1) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',308,1,30811254,1) ;

CALL DOCLOCK_IMPORT('    ',0,308,1,0,11,0,'',0,3,'     ',0,'      ',null,'((.[30810063] = 0)  ([986810009] = 1)) 
((.[30810063] = 1)  ([986810008] = 1)) 
((.[30810063] = 2)  ([986810007] = 1))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 1) ;

--  " .()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30811045,1) ;

CALL DOCLOCK_IMPORT('    .   ',0,308,1,0,11,0,'[30801172] = 0',0,1,'          , , , .    ,         ,      ',0,'        ',null,'(([988410025] = 0)  (.[30801032] = 0)  (.[30801204] = [988410026]))

(([988410022] = 0)  (.[30801030] = 0)  (.[30801030] = [988410022]))

(([988410023] = 0)  (.[30801028] = 0)  (.[30801203] = [988410024]))

(([988410018] = 0)  (.[30801031] = 0)  (.[30801202] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    .   ', 308, 1, 0, 0) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('    .   ',308,1,30801063,0) ;

CALL DOCLOCK_IMPORT('    ',0,308,1,0,11,0,'',0,3,'     ',0,'      ',null,'((.[30001019] = 0)  ([986810009] = 1)) 
((.[30001019] = 1)  ([986810008] = 1)) 
((.[30001019] = 2)  ([986810007] = 1))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 0) ;

--  " .()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30801017,0) ;

CALL DOCLOCK_IMPORT('   ',32768,308,1,0,3,0,'((("_...",[30801026]) between 10800  11199)     (("_...",[30801026]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 308, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',308,1,30801219,0) ;

CALL DOCLOCK_IMPORT('   ',32768,308,1,0,3,0,'((("_...", [30810064]) between 10800  11199)     (("_...",[30810064]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 308, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',308,1,30811082,1) ;

CALL DOCLOCK_IMPORT('      ',0,308,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30001019] = 0)  (("..",[980810002]) = 1)) 
((.[30001019] = 1)  (("..",[980810002])  = 1)) 
((.[30001019] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30001019] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30001019] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30001019] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 308, 1, 0, 0) ;

--  " .()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',308,1,30801021,0) ;

CALL DOCLOCK_IMPORT('      ',0,308,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30800231] = 0)  (("..",[980810002]) = 1)) 
((.[30800231] = 1)  (("..",[980810002])  = 1)) 
((.[30800231] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30800231] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30800231] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30800231] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 308, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',308,1,30801033,0) ;

CALL DOCLOCK_IMPORT('       ',0,308,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'        ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30810070] = 0)  (("..",[980810002]) = 1)) 
((.[30810070] = 1)  (("..",[980810002])  = 1)) 
((.[30810070] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30810070] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30810070] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30810070] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('       ', 308, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('       ',308,1,30811027,1) ;

CALL DOCLOCK_IMPORT('      ',0,308,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'        ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[30810063] = 0)  (("..",[980810002]) = 1)) 
((.[30810063] = 1)  (("..",[980810002])  = 1)) 
((.[30810063] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[30810063] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[30810063] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[30810063] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 308, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',308,1,30811052,1) ;

CALL DOCLOCK_IMPORT('   .   ',0,308,1,0,11,0,'[30801172] = 2',0,1,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30801209] = 0)  (.[30801210] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   .   ', 308, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('   .   ',308,1,30801248,0) ;

CALL DOCLOCK_IMPORT('   .   ',0,308,1,0,11,0,'[30811003] = 2',0,1,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[30811019] = 0)  (.[30811093] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   .   ', 308, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('   .   ',308,1,30811120,1) ;

CALL DOCLOCK_IMPORT('    ',1048577,322,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 322, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211040,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211033,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211028,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211043,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211044,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32210020,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211103,1) ;

CALL DOCLOCK_IMPORT('      ',0,322,0,0,11,0,'',0,3,'',0,'',null,'([984110014] <> "")',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 322, 0, 0, 1) ;

--  "/ "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',322,0,32210005,1) ;

CALL DOCLOCK_IMPORT('   ',32768,323,1,0,3,0,'((("_...", [32311012]) between 10800  11199)   (("_...",[32311012]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32311150,1) ;

CALL DOCLOCK_IMPORT('   ',0,323,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32301079])))
([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32301211,0) ;

CALL DOCLOCK_IMPORT('   ',0,323,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32311012])))
([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32311163,1) ;

CALL DOCLOCK_IMPORT('   ',32768,323,1,0,3,0,'((("_...", [32300160]) between 10800  11199)   (("_...",[32300160]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32301200,0) ;

CALL DOCLOCK_IMPORT('   ',32768,324,-1,0,3,0,'((("_...",[32411026]) between 10800  11199)    (("_...",[32411026]) between 10000  10499) )',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, -1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,-1,32411191,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,324,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 324, -1, 1, 1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411074,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411080,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411083,1) ;

--  " ( . - )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411030,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411084,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411072,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411073,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411082,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411040,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411268,1) ;

CALL DOCLOCK_IMPORT('  ',0,324,-1,0,12,0,'',0,3,'',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 324, -1, 0, 0) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32400249,0) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32401259,0) ;

CALL DOCLOCK_IMPORT('  ',0,324,-1,0,12,0,'',0,3,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 324, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410181,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32411207,1) ;

CALL DOCLOCK_IMPORT('   ',32768,324,-1,0,3,0,'((("_...",[32401111]) between 10800  11199)   (("_...",[32401111]) between 10000  10499) )',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, -1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,-1,32401245,0) ;

CALL DOCLOCK_IMPORT('   ',0,324,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32401111])))
([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, 1, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,1,32401256,0) ;

CALL DOCLOCK_IMPORT('   ',0,324,1,0,11,0,'',0,1,'    ,  ,   - \      .',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32411026])))
([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, 1, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,1,32411204,1) ;

CALL DOCLOCK_IMPORT('  ',32768,325,0,0,7,1,'',1,3,'',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 325, 0, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',32768,401,6,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 401, 6, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',401,6,40116257,1) ;

CALL DOCLOCK_IMPORT('  ',32768,501,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 501, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',501,1,50111191,1) ;

CALL DOCLOCK_IMPORT('  ',32768,501,3,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 501, 3, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',501,3,50113192,1) ;

CALL DOCLOCK_IMPORT('  ',32768,701,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 701, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',701,1,70111074,1) ;

CALL DOCLOCK_IMPORT('    ',1,703,-1,0,4,2,'',0,2,'      .         .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 703, -1, 1, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310009,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310019,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310056,1) ;

CALL DOCLOCK_IMPORT('  ',32768,703,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 703, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',703,0,70310055,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,801,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 801, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111094,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111048,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111005,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111009,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111016,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111035,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111027,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110012,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110007,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110017,1) ;

CALL DOCLOCK_IMPORT('      ',0,801,1,0,11,0,'[80111052] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[80111026] = 0)  (.[80111060] = [988410026]))

(([988410022] = 0)  (.[80111024] = 0)  (.[80111024] = [988410022]))

(([988410023] = 0)  (.[80111025] = 0)  (.[80111059] = [988410024]))

(([988410018] = 0)  (.[80111022] = 0)  (.[80111058] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 801, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',801,1,80111055,1) ;

CALL DOCLOCK_IMPORT('  ',32768,801,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 801, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',801,1,80101092,0) ;

CALL DOCLOCK_IMPORT('  ',32768,801,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 801, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',801,1,80111091,1) ;

CALL DOCLOCK_IMPORT('      ',0,801,1,0,11,0,'[80101038] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[80101021] = 0)  (.[80101065] = [988410026]))

(([988410022] = 0)  (.[80101019] = 0)  (.[80101019] = [988410022]))

(([988410023] = 0)  (.[80101020] = 0)  (.[80101064] = [988410024]))

(([988410018] = 0)  (.[80101017] = 0)  (.[80101063] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 801, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',801,1,80101073,0) ;

CALL DOCLOCK_IMPORT('    ',0,801,1,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[80101065] = "")  ([970910017] = "000"))  
  ((.[80101065] <> "")  (.[80101065], [970910017], "9.9.9")))  
(((.[80101019] = "")  ([970910015] = "0000"))  
  ((.[80101019] <> "")  (.[80101019], [970910015], "99.99"))) 
(((.[80101063] = "")  ([970910013] = "0000000000"))  
  ((.[80101063] <> "")  (.[80101063], [970910013], ">aa.a.aa.aaaaa")))     
(((.[80101064] = "")  ([970910016] = "000"))  
  ((.[80101064] <> "")  (.[80101064], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[80101021] = 0)  (.[80101065] = [970910050])) 
(([970910046] = 0)  (.[80101019] = 0)  (.[80101019] = [970910046])) 
(([970910047] = 0)  (.[80101020] = 0)  (.[80101064] = [970910048])) 
(([970910042] = 0)  (.[80101017] = 0)  (.[80101063] = [970910043])) 
(([970910044] = 0)  (.[80101018] = 0)  (.[80101092] = [970910045])) 
(([970910065] = 0)  (.[80101022] = 0)  (.[80101022] = [970910065])) 
(([970910056] = "")  (.[80101089] = "")  (.[80101089] = [970910056])) 
(([970910060] = 0)  (.[80101084] = 0)  (.[80101010] = [970910061])) 
(([970910051] = 0)  (.[80101032] = 0)  (.[80101093] = [970910052])) 
(([970910064] = 0)  (.[80101029] = 0)  (.[80101029] = [970910064])) 
(([970910040] = 0)  (.[80101085] = 0)  (.[80101012] = [970910041])) 
(([970910038] = 0)  (.[80101086] = 0)  (.[80101006] = [970910039]))   
(([970910054] = "")  (.[80101075] = "")  (.[80101075] = [970910054]))  
(([970910037] = "")  (.[80101094] = "")  (.[80101094] = [970910037])))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 801, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',801,1,80101090,0) ;

CALL DOCLOCK_IMPORT('    ',0,801,1,0,11,0,'',0,1,'      ',0,'     ',null,'/*        ,         */
([970910066] is null) ? 
((((.[80111060] = "")  ([970910017] = "000"))  
  ((.[80111060] <> "")  (.[80111060], [970910017], "9.9.9")))  
(((.[80111024] = "")  ([970910015] = "0000"))  
  ((.[80111024] <> "")  (.[80111024], [970910015], "99.99"))) 
(((.[80111058] = "")  ([970910013] = "0000000000"))  
  ((.[80111058] <> "")  (.[80111058], [970910013], ">aa.a.aa.aaaaa")))     
(((.[80111059] = "")  ([970910016] = "000"))  
  ((.[80111059] <> "")  (.[80111059], [970910016], ">a.a.a")))) :
/*      */
((([970910049] = 0)  (.[80111026] = 0)  (.[80111060] = [970910050])) 
(([970910046] = 0)  (.[80111024] = 0)  (.[80111024] = [970910046])) 
(([970910047] = 0)  (.[80111025] = 0)  (.[80111059] = [970910048])) 
(([970910042] = 0)  (.[80111022] = 0)  (.[80111058] = [970910043])) 
(([970910044] = 0)  (.[80111023] = 0)  (.[80111091] = [970910045])) 
(([970910065] = 0)  (.[80111027] = 0)  (.[80111027] = [970910065])) 
(([970910056] = "")  (.[80111085] = "")  (.[80111085] = [970910056])) 
(([970910060] = 0)  (.[80111081] = 0)  (.[80111014] = [970910061])) 
(([970910051] = 0)  (.[80111040] = 0)  (.[80111094] = [970910052])) 
(([970910064] = 0)  (.[80111035] = 0)  (.[80111035] = [970910064])) 
(([970910040] = 0)  (.[80111082] = 0)  (.[80111017] = [970910041])) 
(([970910038] = 0)  (.[80111080] = 0)  (.[80111008] = [970910039]))   
(([970910054] = "")  (.[80111076] = "")  (.[80111076] = [970910054]))  
(([970910037] = "")  (.[80111095] = "")  (.[80111095] = [970910037])))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 801, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',801,1,80111086,1) ;

CALL DOCLOCK_IMPORT('  ',32768,802,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 802, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',802,0,80210046,1) ;

CALL DOCLOCK_IMPORT('  ',32768,803,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 803, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',803,1,80311059,1) ;

CALL DOCLOCK_IMPORT('     ',0,900,1,0,11,0,'[90001001] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[90001004] = 0)  (.[90001005] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 900, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',900,1,90001010,0) ;

CALL DOCLOCK_IMPORT('     ',0,900,1,0,11,0,'[90011001] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[90011004] = 0)  (.[90011005] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 900, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',900,1,90011010,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1501,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1501, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1501,0,150110056,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,1601,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1601, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111107,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111052,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111053,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111026,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111030,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111027,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111028,1) ;

--  "/"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110003,1) ;

--  " /"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110002,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110001,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110051,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110050,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1601,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1601, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1601,1,160101104,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1601,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1601, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1601,1,160111105,1) ;

CALL DOCLOCK_IMPORT('      ',0,1601,1,0,11,0,'',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[160101021] = 0)  (.[160101076] = [988410026]))

(([988410022] = 0)  (.[160101022] = 0)  (.[160101022] = [988410022]))

(([988410023] = 0)  (.[160101024] = 0)  (.[160101075] = [988410024]))

(([988410018] = 0)  (.[160101023] = 0)  (.[160101074] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 1601, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',1601,1,160101077,0) ;

CALL DOCLOCK_IMPORT('      ',0,1601,1,0,11,0,'',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[160111021] = 0)  (.[160111076] = [988410026]))

(([988410022] = 0)  (.[160111022] = 0)  (.[160111022] = [988410022]))

(([988410023] = 0)  (.[160111024] = 0)  (.[160111075] = [988410024]))

(([988410018] = 0)  (.[160111023] = 0)  (.[160111074] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 1601, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',1601,1,160111072,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1602,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1602, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1602,0,160210048,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1701,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1701, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1701,0,170110097,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1702,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1702, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1702,0,170210054,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1816,0,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,0,181610102,1) ;

CALL DOCLOCK_IMPORT('  ',0,1816,0,0,9,0,'(([181610099] is null)  ((30,35,3) = 0)  ((30,15,3) = 1)) ? (1) : (((".",[181610099]) = 1)    ((".",[181610099]) = 0)    ((".",[181610099]) <> 0)    ((".",[181610099])=[181610024]) )',0,3,'  ',0,'          ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,0,181610099,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1816,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,1,181611103,1) ;

CALL DOCLOCK_IMPORT('  ',0,1816,1,0,9,0,'(([181611100] is null)  ((30,35,3) = 0)  ((30,15,3) = 1)) ? (1) : (((".",[181611100]) = 1)    ((".",[181611100]) = 0)    ((".",[181611100]) <> 0)    ((".",[181611100])=[181611095]) )',0,3,'  ',0,'          ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,1,181611100,1) ;

CALL DOCLOCK_IMPORT('     ',0,1820,0,0,12,3,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 1820, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1820,0,182010029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1820,0,182010028,1) ;

CALL DOCLOCK_IMPORT('  .   ',0,1820,1,0,12,3,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  .   ', 1820, 1, 0, 1) ;

--  ". "
CALL DOCLOCKFIELDS_INSERTFIELD('  .   ',1820,1,182011031,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  .   ',1820,1,182011030,1) ;

CALL DOCLOCK_IMPORT('  ',0,1900,0,0,9,0,'([190010012] > 99)  ([190010002] is not null)',0,3,'  ',0,'   ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1900, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1900,0,190010012,1) ;

CALL DOCLOCK_IMPORT('   ',32768,1900,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1900, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1900,1,190011042,1) ;

CALL DOCLOCK_IMPORT('     ',0,1900,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[190001001] = 0)  (("..",[980810002]) = 1)) 
((.[190001001] = 1)  (("..",[980810002])  = 1)) 
((.[190001001] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[190001001] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[190001001] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[190001001] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 1900, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1900,1,190001046,0) ;

CALL DOCLOCK_IMPORT('     ',0,1900,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[190011001] = 0)  (("..",[980810002]) = 1)) 
((.[190011001] = 1)  (("..",[980810002])  = 1)) 
((.[190011001] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[190011001] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[190011001] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[190011001] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 1900, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1900,1,190011046,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,1901,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1901, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111048,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111020,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111023,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190111025,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110013,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110050,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110051,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110001,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110006,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110012,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1901,-1,190110004,1) ;

CALL DOCLOCK_IMPORT('   ',0,1901,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1901, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1901,0,190110057,1) ;

CALL DOCLOCK_IMPORT('   ',0,1901,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1901, 0, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1901,0,190100192,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1901,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1901, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,1,190101218,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1901,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1901, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,1,190111219,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,1902,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1902, -1, 1, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210001,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211077,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211075,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211050,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211040,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211039,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190211012,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210073,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210049,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210048,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210019,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210013,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1902,-1,190210016,1) ;

CALL DOCLOCK_IMPORT('   ',0,1902,0,0,11,0,'',0,1,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1902, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1902,0,190210043,1) ;

CALL DOCLOCK_IMPORT('   ',0,1902,0,0,11,0,'',0,1,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1902, 0, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1902,0,190200192,0) ;

CALL DOCLOCK_IMPORT('   ',0,1902,1,0,11,0,'',0,1,'   ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1902, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1902,1,190211042,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1902,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1902, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,1,190201218,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1902,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1902, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,1,190211219,1) ;

CALL DOCLOCK_IMPORT('   ',0,1902,1,0,11,0,'',0,1,'   ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1902, 1, 0, 0) ;

--  "  / ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1902,1,190201199,0) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,1903,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1903, -1, 1, 1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190311075,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190311074,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190311049,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190311039,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190311038,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310072,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310048,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310023,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310019,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310002,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310001,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1903,-1,190310014,1) ;

CALL DOCLOCK_IMPORT('   ',0,1903,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1903, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1903,0,190310042,1) ;

CALL DOCLOCK_IMPORT('   ',0,1903,0,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1903, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1903,0,190300133,0) ;

CALL DOCLOCK_IMPORT('   ',0,1903,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1903, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1903,1,190311041,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1903,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1903, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,1,190301198,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1903,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1903, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,1,190311197,1) ;

CALL DOCLOCK_IMPORT('   ',0,1903,1,0,11,0,'',0,3,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1903, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1903,1,190301132,0) ;

CALL DOCLOCK_IMPORT(' ,   ',262148,1906,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1906, -1, 1, 1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190611076,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190611075,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190611050,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610049,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610001,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190611040,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190611039,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610048,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610073,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610015,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1906,-1,190610012,1) ;

CALL DOCLOCK_IMPORT('   ',0,1906,0,0,11,0,'',0,1,'   ',0,'  .          ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1906, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1906,0,190610043,1) ;

CALL DOCLOCK_IMPORT('   ',0,1906,1,0,11,0,'',0,1,'   ',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 1906, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1906,1,190611042,1) ;

CALL DOCLOCK_IMPORT('  ',32768,1906,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1906, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,1,190601112,0) ;

CALL DOCLOCK_IMPORT('  ',32768,1906,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 1906, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,1,190611111,1) ;

CALL DOCLOCK_IMPORT('   ',0,2201,0,0,11,0,'',0,3,'     ,   ',0,'  .    , , ,      ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2201, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2201,0,220110069,1) ;

CALL DOCLOCK_IMPORT('   ',0,2201,0,0,11,0,'',0,3,'     ,   ',0,'  .    , , ,      ',null,'([960110035] > 10099  [960110035] < 10400)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2201, 0, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2201,0,220100166,0) ;

CALL DOCLOCK_IMPORT('   ',0,2201,1,0,11,0,'',0,3,'             .',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2201, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2201,1,220111070,1) ;

CALL DOCLOCK_IMPORT('   ',0,2201,1,0,11,0,'',0,3,'             .',0,'  .           ',null,'([960110035] > 0  [960110035] < 20000)([960110035] = 30200)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2201, 1, 0, 0) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2201,1,220101193,0) ;

CALL DOCLOCK_IMPORT('     ',0,2201,1,0,11,0,'',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[220111046] = 0)  (.[220111012] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 2201, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',2201,1,220111084,1) ;

CALL DOCLOCK_IMPORT('     ',0,2201,1,0,11,0,'',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[220101057] = 0)  (.[220101200] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 2201, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',2201,1,220101210,0) ;

CALL DOCLOCK_IMPORT('  ',32768,2201,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2201, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,1,220101215,0) ;

CALL DOCLOCK_IMPORT('  ',32768,2201,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2201, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,1,220111216,1) ;

CALL DOCLOCK_IMPORT('b',0,2502,0,0,9,0,'',0,3,'',0,'',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('b', 2502, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('b',2502,0,250210017,2) ;

CALL DOCLOCK_IMPORT('     , ',0,2502,2,0,11,0,'("_._",[250212035])    ("_._",[250212035])  ("_.",[250212035])',0,1,' \ ,         2,3,4,7,8;    \ ,       5,6,9;   \        7  8.',0,'         ',null,'(("_._",.[250212035])
 (([984910001] between 2  4)([984910001] between 7  8)))

(("_.",.[250212035])
 ([984910001] between 7  8))

(("_._",.[250212035])
 (([984910001] between 5  6)([984910001] = 9)))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 2502, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',2502,2,250212025,2) ;

CALL DOCLOCK_IMPORT('      ',0,2502,2,0,11,0,'',0,3,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[250212026] = 0)  (.[250212041] = [988410026]))

(([988410022] = 0)  (.[250212028] = 0)  (.[250212028] = [988410022]))

(([988410023] = 0)  (.[250212027] = 0)  (.[250212042] = [988410024]))

(([988410018] = 0)  (.[250212030] = 0)  (.[250212043] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 2502, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2502,2,250212077,2) ;

CALL DOCLOCK_IMPORT('   ',32768,2502,2,0,3,0,'((("..",[250212035]) between 10800  11199)    (("_...",[250212035]) between 10800  11199)     ((("_...",[250212035]) between 10000  10499)         (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2502, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2502,2,250212050,2) ;

CALL DOCLOCK_IMPORT('  ',32768,2502,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2502, 2, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2502,2,250212090,2) ;

CALL DOCLOCK_IMPORT('  ',0,2503,0,0,11,0,'',0,3,'',0,'',null,'(([981110005] = 0)  ([981110007] > 0))  ([981110007] <> 6)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,0,250310030,2) ;

CALL DOCLOCK_IMPORT('      ',0,2503,0,0,11,0,'(".",[250310049])   (".",[250310049])',0,3,'            ,  / 25.03 :       ,         ,  ,  ',0,'        ,  ,  ',null,' ([981110007] = 3  [981110007] = 4  [981110007] = 5)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 2503, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2503,0,250310030,2) ;

CALL DOCLOCK_IMPORT('  ',0,2503,2,0,12,0,'(50,52,3) = 1',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 2, 0, 2) ;

--  "    "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312054,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312055,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312002,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312028,2) ;

--  "    "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312075,2) ;

CALL DOCLOCK_IMPORT('     , ',0,2503,2,0,11,0,'("_._",[250312005])    ("_._",[250312005])  ("_.",[250312005])',0,1,' \ ,         2,3,4,7,8;    \ ,       5,6,9;   \        7  8.',0,'         ',null,'(("_._",.[250312005])
 (([984910001] between 2  4)([984910001] between 7  8)))

(("_.",.[250312005])
 ([984910001] between 7  8))

(("_._",.[250312005])
 (([984910001] between 5  6)([984910001] = 9)))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 2503, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',2503,2,250312015,2) ;

CALL DOCLOCK_IMPORT('      ',0,2503,2,0,11,0,'',0,3,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[250312073] = 0)  (.[250312014] = [988410026]))

(([988410022] = 0)  (.[250312012] = 0)  (.[250312012] = [988410022]))

(([988410023] = 0)  (.[250312071] = 0)  (.[250312013] = [988410024]))

(([988410018] = 0)  (.[250312070] = 0)  (.[250312010] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 2503, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2503,2,250312074,2) ;

CALL DOCLOCK_IMPORT('  ',32768,2503,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 2, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312078,2) ;

CALL DOCLOCK_IMPORT('   ',32768,2503,2,0,3,0,'((("..",[250312005]) between 10800  11199)    (("_...",[250312005]) between 10800  11199)     ((("_...",[250312005]) between 10000  10499)         (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2503, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2503,2,250312045,2) ;

CALL DOCLOCK_IMPORT('  ',65536,2504,-1,0,7,0,'[250410104] is null',1,3,'   .   ,   .           .',2,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, -1, 0, 2) ;

CALL DOCLOCK_IMPORT(' ',0,2504,0,0,10,0,'((".DOCTYPES.REGISTRATIONTYPE",[250410094]) = 6)   ([250410089] is not null)',0,1,'',0,'  ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',2504,0,250410049,2) ;

CALL DOCLOCK_IMPORT('   ',0,2504,0,0,10,0,'((".DOCTYPES.REGISTRATIONTYPE",[250410094]) = 6)   ([250410086] is not null)',0,1,'',0,'  ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2504,0,250410086,2) ;

CALL DOCLOCK_IMPORT('   ',0,2504,0,0,10,0,'((".DOCTYPES.REGISTRATIONTYPE",[250410094]) = 6)   ([250410083] is not null)',0,1,'',0,'  ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2504,0,250410083,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,10,0,'((".DOCTYPES.REGISTRATIONTYPE",[250410094]) = 6)   ([250410084] is not null)',0,1,'',0,'  ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410084,2) ;

CALL DOCLOCK_IMPORT('   36  ',0,2504,0,0,10,0,'[250410101] like "____________________________________"  [250410101] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   36  ', 2504, 0, 0, 2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   36  ',2504,0,250410101,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,10,0,'[250410086] <= [250410083]',0,1,'        ',0,'              ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410083,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,10,0,'([250410086] <= [250410083])  ([250410083] is null)',0,1,'',0,'              ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410086,2) ;

CALL DOCLOCK_IMPORT('   ',0,2504,0,0,10,0,'((-1,85,3) = 0)  (((-1,85,3) = 1)  ([250410099] <> ""))',0,1,'',0,'  ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2504, 0, 0, 2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2504,0,250410099,2) ;

CALL DOCLOCK_IMPORT('     , ',0,2504,2,0,11,0,'("_._",[250412043])    ("_._",[250412043])  ("_.",[250412043])',0,1,' \ ,         2,3,4,7,8;    \ ,       5,6,9;   \        7  8.',0,'         ',null,'(("_._",.[250412043])
 (([984910001] between 2  4)([984910001] between 7  8)))

(("_.",.[250412043])
 ([984910001] between 7  8))

(("_._",.[250412043])
 (([984910001] between 5  6)([984910001] = 9)))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 2504, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',2504,2,250412030,2) ;

CALL DOCLOCK_IMPORT('      ',0,2504,2,0,11,1,'',0,1,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[250412032] = 0)  (.[250412031] = [988410026]))

(([988410022] = 0)  (.[250412035] = 0)  (.[250412035] = [988410022]))

(([988410023] = 0)  (.[250412034] = 0)  (.[250412033] = [988410024]))

(([988410018] = 0)  (.[250412038] = 0)  (.[250412037] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 2504, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2504,2,250412108,2) ;

CALL DOCLOCK_IMPORT('    ',0,2504,2,0,11,0,'',0,3,'     ',0,'      ',null,'[986810009]',2,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 2504, 2, 0, 2) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',2504,2,250412036,2) ;

CALL DOCLOCK_IMPORT('  ',32768,2504,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 2, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,2,250412158,2) ;

CALL DOCLOCK_IMPORT('   ',32768,2504,2,0,3,0,'((("..",[250412043]) between 10800  11199)    (("_...",[250412043]) between 10800  11199)     (("_...",[250412043]) between 10000  10499)        )',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 2504, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2504,2,250412009,2) ;

CALL DOCLOCK_IMPORT('      ',0,2504,4,0,11,0,'',0,3,'',0,'      ',null,'[986810009]',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 2504, 4, 0, 2) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2504,4,250414135,2) ;

CALL DOCLOCK_IMPORT('      ',0,3001,1,0,11,1,'',0,1,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[300111088] = 0)  (.[300111038] = [988410026]))

(([988410022] = 0)  (.[300111040] = 0)  (.[300111040] = [988410022]))

(([988410023] = 0)  (.[300111089] = 0)  (.[300111039] = [988410024]))

(([988410018] = 0)  (.[300111090] = 0)  (.[300111042] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 3001, 1, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',3001,1,300111118,2) ;

CALL DOCLOCK_IMPORT('  ',32768,3001,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 3001, 1, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',3001,1,300111151,2) ;

CALL DOCLOCK_IMPORT(' ',65540,3005,-1,0,4,1,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 3005, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510011,1) ;

CALL DOCLOCK_IMPORT('    -',0,3006,0,0,10,0,'([300610051] is not null)  ([300610017] < 2017)',0,1,'',0,'       223-',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('    -', 3006, 0, 0, 2) ;

--  "  /"
CALL DOCLOCKFIELDS_INSERTFIELD('    -',3006,0,300610051,2) ;

CALL DOCLOCK_IMPORT('      ',0,3006,1,0,11,1,'',0,1,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[300611042] = 0)  (.[300611036] = [988410026]))

(([988410022] = 0)  (.[300611037] = 0)  (.[300611037] = [988410022]))

(([988410023] = 0)  (.[300611043] = 0)  (.[300611038] = [988410024]))

(([988410018] = 0)  (.[300611041] = 0)  (.[300611009] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 3006, 1, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',3006,1,300611066,2) ;

CALL DOCLOCK_IMPORT('     ,',0,3006,1,0,11,0,'("_._",[300610014])   ("_._",[300610014])   ("_.",[300610014])',0,3,',        =- \,  =. ',0,'         ',null,'([988910008] = ("_.",.[300610014])
 (((".",[988910008]) between 10100  10199)
 ((".",[988910008]) between 11000  11099)))
   
(( ("_._",.[300610014])
 ([988910010] = 0))

(("_._",.[300610014])
 ([988910010] <> 0)))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     ,', 3006, 1, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ,',3006,1,300611080,2) ;

CALL DOCLOCK_IMPORT('   ',0,3006,1,0,11,0,'("_.",[300610014])   ("_.",[300610014])',0,1,' (   , , )          .     \   .   \      .',0,'         ',null,'(("_...",.[300610014]) between 10000  10499)

(((".",[988910008]) between 10100  10199)

([988910008] = ("_.",.[300610014]))
 ((("_.",.[300610014])<>0)
      (("_.",.[300610014])=0)
     ((".",[988910008])= ("_.",.[300610014])))
)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 3006, 1, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',3006,1,300611080,2) ;

CALL DOCLOCK_IMPORT('  ',32768,3006,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 3006, 1, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',3006,1,300611084,2) ;

CALL DOCLOCK_IMPORT(' ',65540,3010,0,0,4,1,'',0,1,'',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 3010, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010019,1) ;

CALL DOCLOCK_IMPORT('     ',0,3011,0,0,10,0,'[301110029] is not null',0,1,'',0,'     - ',0,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 3011, 0, 0, 2) ;

--  "  /"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',3011,0,301110029,2) ;

CALL DOCLOCK_IMPORT('     ,',0,3011,1,0,11,0,'("_._",[301110014])   ("_._",[301110014])   ("_.",[301110014])',0,3,',        =- \,  =. ',0,'         ',null,'([988910008] = ("_.",.[301110014])
 (((".",[988910008]) between 10100  10199)
 ((".",[988910008]) between 11000  11099)))
   
(( ("_._",.[301110014])
 ([988910010] = 0))

(("_._",.[301110014])
 ([988910010] <> 0)))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     ,', 3011, 1, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ,',3011,1,301111066,2) ;

CALL DOCLOCK_IMPORT('   ',0,3011,1,0,11,0,'("_.",[301110014])   ("_.",[301110014])',0,1,' (   , , )          .     \   .   \      .',0,'         ',null,'(("_...",.[301110014]) between 10000  10499)

(((".",[988910008]) between 10100  10199)

([988910008] = ("_.",.[301110014]))
 ((("_.",.[301110014])<>0)
      (("_.",.[301110014])=0)
     ((".",[988910008])= ("_.",.[301110014])))
)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 3011, 1, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',3011,1,301111066,2) ;

CALL DOCLOCK_IMPORT('      ',0,3011,1,0,11,1,'',0,1,'          , , , .',0,'       ',null,'(([988410025] = 0)  (.[301111030] = 0)  (.[301111025] = [988410026]))

(([988410022] = 0)  (.[301111026] = 0)  (.[301111026] = [988410022]))

(([988410023] = 0)  (.[301111031] = 0)  (.[301111027] = [988410024]))

(([988410018] = 0)  (.[301111029] = 0)  (.[301111003] = [988410019]))',2,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 3011, 1, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',3011,1,301111067,2) ;

CALL DOCLOCK_IMPORT('  ',32768,3011,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 3011, 1, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',3011,1,301111068,2) ;

CALL DOCLOCK_IMPORT('  ',32768,4401,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 4401, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,1,440101078,0) ;

CALL DOCLOCK_IMPORT('  ',32768,4401,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 4401, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,1,440111077,1) ;

CALL DOCLOCK_IMPORT('  ',2,4403,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 4403, -1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ,   ',4,4403,-1,0,8,2,'',1,1,'     ,   .       .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 4403, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',32768,4403,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 4403, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4403,1,440311071,1) ;

CALL DOCLOCK_IMPORT('  ',0,4701,-1,0,12,0,'',0,1,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 4701, -1, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4701,-1,470110019,2) ;

CALL DOCLOCK_IMPORT('  ',0,5201,0,0,12,3,'(5201, "") <> 0',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 0, 0, 2) ;

--  "-"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110060,2) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110047,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110046,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110045,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110044,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110039,2) ;

CALL DOCLOCK_IMPORT('  ',0,5201,0,0,9,0,'([520101058])=0',0,3,'        ',0,'       ',0,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 0, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520100053,0) ;

CALL DOCLOCK_IMPORT('  ',32768,5201,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,1,520101083,0) ;

CALL DOCLOCK_IMPORT('  ',32768,5201,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,1,520111084,1) ;

CALL DOCLOCK_IMPORT('      ',0,5201,1,0,11,0,'[520101070] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[520101015] = 0)  (.[520101016] = [988410026]))

(([988410022] = 0)  (.[520101012] = 0)  (.[520101012] = [988410022]))

(([988410023] = 0)  (.[520101013] = 0)  (.[520101014] = [988410024]))

(([988410018] = 0)  (.[520101009] = 0)  (.[520101010] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5201, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5201,1,520101052,0) ;

CALL DOCLOCK_IMPORT('      ',0,5201,1,0,11,0,'[520111071] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[520111015] = 0)  (.[520111016] = [988410026]))

(([988410022] = 0)  (.[520111012] = 0)  (.[520111012] = [988410022]))

(([988410023] = 0)  (.[520111013] = 0)  (.[520111014] = [988410024]))

(([988410018] = 0)  (.[520111009] = 0)  (.[520111010] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5201, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5201,1,520111052,1) ;

CALL DOCLOCK_IMPORT('     ',0,5201,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[520101070] = 0)  (("..",[980810002]) = 1)) 
((.[520101070] = 1)  (("..",[980810002])  = 1)) 
((.[520101070] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[520101070] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[520101070] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[520101070] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5201, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5201,1,520101022,0) ;

CALL DOCLOCK_IMPORT('     ',0,5201,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[520111071] = 0)  (("..",[980810002]) = 1)) 
((.[520111071] = 1)  (("..",[980810002])  = 1)) 
((.[520111071] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[520111071] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[520111071] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[520111071] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5201, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5201,1,520111022,1) ;

CALL DOCLOCK_IMPORT('     ',0,5201,1,0,11,0,'[520101070] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[520101068]= 0)  ([970910023] = .[520101069])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5201, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5201,1,520101081,0) ;

CALL DOCLOCK_IMPORT('     ',0,5201,1,0,11,0,'[520111071] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[520111064] = 0)  ([970910023] = .[520111070])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5201, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5201,1,520111081,1) ;

CALL DOCLOCK_IMPORT('      ',0,5501,1,0,11,0,'[550111066] = 0',0,3,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[550111054] = 0)  (.[550111148] = [988410026]))

(([988410022] = 0)  (.[550111055] = 0)  (.[550111055] = [988410022]))

(([988410023] = 0)  (.[550111057] = 0)  (.[550111147] = [988410024]))

(([988410018] = 0)  (.[550111056] = 0)  (.[550111146] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5501, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5501,1,550111144,1) ;

CALL DOCLOCK_IMPORT('   ()',1048576,5501,1,0,5,0,'([550111092] = 315)  ([550110007] is not null)',0,3,'     ,        .     .      .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ()', 5501, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ()',5501,1,550111077,1) ;

CALL DOCLOCK_IMPORT('  ',32768,5501,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5501, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,1,550101188,0) ;

CALL DOCLOCK_IMPORT('  ',32768,5501,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5501, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,1,550111187,1) ;

CALL DOCLOCK_IMPORT('    ',0,5501,1,0,11,0,'not ((32,51,3) in (2,3))',0,3,'     ',0,'      ',null,'((.[550101066] = 0)  ([986810009] = 1)) 
((.[550101066] = 1)  ([986810008] = 1)) 
((.[550101066] = 2)  ([986810007] = 1))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 5501, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',5501,1,550101058,0) ;

CALL DOCLOCK_IMPORT('    ',0,5501,1,0,11,0,'not ((32,51,3) in (2,3))',0,3,'     ',0,'      ',null,'((.[550111066] = 0)  ([986810009] = 1)) 
((.[550111066] = 1)  ([986810008] = 1)) 
((.[550111066] = 2)  ([986810007] = 1))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 5501, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',5501,1,550111058,1) ;

CALL DOCLOCK_IMPORT('     ,',0,5501,1,0,11,0,'(([550101066] = 1)  (("_.", [550101088]) = 0))',0,1,'  ,      ,  =0 (    )        "",   -   ""',0,'       ""          ""  ',null,'([988410016] = 0)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ,', 5501, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ,',5501,1,550101154,0) ;

CALL DOCLOCK_IMPORT('      ',0,5501,1,0,11,0,'[550101066] = 0',0,3,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[550101054] = 0)  (.[550101158] = [988410026]))

(([988410022] = 0)  (.[550101055] = 0)  (.[550101055] = [988410022]))

(([988410023] = 0)  (.[550101057] = 0)  (.[550101157] = [988410024]))

(([988410018] = 0)  (.[550101056] = 0)  (.[550101156] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5501, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5501,1,550101154,0) ;

CALL DOCLOCK_IMPORT('   ()',1048576,5501,1,0,5,0,'([550101092] = 315)  ([550100007] is not null)',0,3,'     ,        .     .      .',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ()', 5501, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ()',5501,1,550101077,0) ;

CALL DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[550101066]= 0)  (("..",[980810002]) = 1)) 
((.[550101066] = 1)  (("..",[980810002])  = 1)) 
((.[550101066] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[550101066] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[550101066] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[550101066] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550101074,0) ;

CALL DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[550111066]= 0)  (("..",[980810002]) = 1)) 
((.[550111066] = 1)  (("..",[980810002])  = 1)) 
((.[550111066] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[550111066] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[550111066] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[550111066] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550111074,1) ;

CALL DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'[550101066] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[550101090] = 0)  (.[550101162] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550101182,0) ;

CALL DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'[550111066] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[550111090] = 0)  (.[550111156] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550111172,1) ;

CALL DOCLOCK_IMPORT('      ',0,5502,1,0,11,0,'[550211066]  =  0',0,3,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[550211054] = 0)  (.[550211129] = [988410026]))

(([988410022] = 0)  (.[550211055] = 0)  (.[550211055] = [988410022]))

(([988410023] = 0)  (.[550211057] = 0)  (.[550211128] = [988410024]))

(([988410018] = 0)  (.[550211056] = 0)  (.[550211127] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5502, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5502,1,550211125,1) ;

CALL DOCLOCK_IMPORT('   ()',2097152,5502,1,0,5,0,'([550211092] = 315)  ([550210007] is not null)',0,3,'     ,        .     .      .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ()', 5502, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ()',5502,1,550211077,1) ;

CALL DOCLOCK_IMPORT('  ',32768,5502,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5502, 1, 0, 0) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,1,550201201,0) ;

CALL DOCLOCK_IMPORT('  ',32768,5502,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5502, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,1,550211200,1) ;

CALL DOCLOCK_IMPORT('    ',0,5502,1,0,11,0,'not ((32,51,3) in (2,3))',0,3,'     ',0,'      ',null,'((.[550201066] = 0)  ([986810009] = 1)) 
((.[550201066] = 1)  ([986810008] = 1)) 
((.[550201066] = 2)  ([986810007] = 1))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 5502, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',5502,1,550201058,0) ;

CALL DOCLOCK_IMPORT('    ',0,5502,1,0,11,0,'not ((32,51,3) in (2,3))',0,3,'     ',0,'      ',null,'((.[550211066] = 0)  ([986810009] = 1)) 
((.[550211066] = 1)  ([986810008] = 1)) 
((.[550211066] = 2)  ([986810007] = 1))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 5502, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',5502,1,550211058,1) ;

CALL DOCLOCK_IMPORT('      ',0,5502,1,0,11,0,'[550201066]  =  0',0,3,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[550201054] = 0)  (.[550201143] = [988410026]))

(([988410022] = 0)  (.[550201055] = 0)  (.[550201055] = [988410022]))

(([988410023] = 0)  (.[550201057] = 0)  (.[550201142] = [988410024]))

(([988410018] = 0)  (.[550201056] = 0)  (.[550201141] = [988410019]))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5502, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5502,1,550201139,0) ;

CALL DOCLOCK_IMPORT('   ()',2097152,5502,1,0,5,0,'([550201092] = 315)  ([550200007] is not null)',0,3,'     ,        .     .      .',0,'',null,'',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   ()', 5502, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ()',5502,1,550201077,0) ;

CALL DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[550201066]= 0)  (("..",[980810002]) = 1)) 
((.[550201066] = 1)  (("..",[980810002])  = 1)) 
((.[550201066] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[550201066] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[550201066] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[550201066] = 2)  ((".",Copy([980810008],0,3))  = 1))))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 0) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550201074,0) ;

CALL DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[550211066]= 0)  (("..",[980810002]) = 1)) 
((.[550211066] = 1)  (("..",[980810002])  = 1)) 
((.[550211066] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[550211066] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[550211066] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[550211066] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550211074,1) ;

CALL DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'[550201066] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[550201090] = 0)  (.[550201150] = [970910023])',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550201195,0) ;

CALL DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'[550211066] = 2',0,3,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[550211090] = 0)  (.[550211135] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550211160,1) ;

CALL DOCLOCK_IMPORT('  ',32768,5503,1,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5503, 1, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5503,1,550311068,1) ;

CALL DOCLOCK_IMPORT('      ',0,5503,1,0,11,0,'[550311008] = 0',0,1,'          , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[550311011] = 0)  (.[550311042] = [988410026]))

(([988410022] = 0)  (.[550311012] = 0)  (.[550311012] = [988410022]))

(([988410023] = 0)  (.[550311014] = 0)  (.[550311041] = [988410024]))

(([988410018] = 0)  (.[550311013] = 0)  (.[550311036] = [988410019]))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 5503, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ',5503,1,550311025,1) ;

CALL DOCLOCK_IMPORT('    ',0,5503,1,0,11,0,'',0,1,'',0,'   ,    ',null,'([970910010] = .[550311057])  ([970910010] = 0)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 5503, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',5503,1,550311067,1) ;

CALL DOCLOCK_IMPORT('     ',0,5503,1,0,11,0,'[550311008] = 2',0,1,'       ',0,'     ',null,'([970910023] = "00000000000000000000")  (.[550311022] = 0)  (.[550311072] = [970910023])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5503, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5503,1,550311067,1) ;

CALL DOCLOCK_IMPORT('     ',0,5503,1,0,11,0,'(32,51,3) in (1,2,3)',0,1,'       ',0,'        ',null,'(((32,51,3) in (1,2))  (((.[550311008]= 0)  (("..",.[980810002]) = 1)) 
((.[550311008] = 1)  (("..",[980810002])  = 1)) 
((.[550311008] = 2)  (("..",[980810002])  = 1)))) 
(((32,51,3) = 3)  (((.[550311008] = 0)  ((".",Copy([980810008],0,3)) = 1)) 
((.[550311008] = 1)  ((".",Copy([980810008],0,3))  = 1)) 
((.[550311008] = 2)  ((".",Copy([980810008],0,3))  = 1))))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 5503, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5503,1,550311016,1) ;

CALL DOCLOCK_IMPORT('  ',32768,5503,2,0,3,0,'(32,51,3) in (2,3)',0,1,'  "",     (32, 51)     ',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 5503, 2, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5503,2,550312069,1) ;

CALL DOCLOCK_IMPORT(' ',0,9903,0,0,11,0,'([990310057] between 10000 and 19999)',0,3,'  ().   (, ) ()    , ,       ',0,'     ().  ()  ()    , ,       ',null,'(([960110035]>=10100)([960110035]<10500)(.[990310069]<>[960110033]))  
((.[990310057]>=10100)(.[990310057]<10500)(.[990310069]=[960110033])) 
([960110035] = 30200)  (.[990310057] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 9903, 0, 0, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ',9903,0,990310084,1) ;

CALL DOCLOCK_IMPORT('  ',32768,9903,0,0,5,0,'([990310083] is not null) and (([990310057] < 30200) or ([990310057] > 30299))',0,3,'  ,       .',0,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9903, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310057,1) ;

--  "E-mail "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310018,1) ;

--  " Web-"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310019,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310076,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310020,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310060,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310059,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310021,1) ;

CALL DOCLOCK_IMPORT('  ',0,9903,2,0,11,0,'',0,3,'  .     /, ()      ',0,'      .      /      ',null,'([960110035] between 10800 and 11099)([960110035] = 30200)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9903, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9903,2,990312098,1) ;

CALL DOCLOCK_IMPORT('   -',0,9903,2,0,11,0,'',0,3,'     -  ',0,'          -',null,'([980310002] = 0)  ([980310002] = .[990310058])',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   -', 9903, 2, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   -',9903,2,990312042,1) ;

CALL DOCLOCK_IMPORT('    ',32768,9928,-1,0,7,0,'((53,1,3)=1)  ("196", (53,3,8))',1,3,'    ',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9928, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('    ',32768,9931,-1,0,7,0,'((53,1,3)=1)  ("195", (53,3,8))',1,3,'    ',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9931, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('    ',32768,9933,-1,0,7,0,'((53,1,3)=1)  ("301", (53,3,8))  ([993310003] like "2*")',1,3,'    ',1,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9933, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',65536,9933,-1,0,7,0,'',1,3,'   .           .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9933, -1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ',65536,9933,-1,0,8,0,'',1,1,'  .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 9933, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',2,9933,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9933, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('   ',0,9933,0,0,10,0,'([993310005] <= [993310006])  ([993310005] is null)  ([993310006] is null)',0,3,'       ',0,'             ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9933, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9933,0,993310005,1) ;

CALL DOCLOCK_IMPORT('    ',32768,9934,-1,0,7,0,'((53,1,3)=1)  ("302", (53,3,8))  ([993410002] like "2*")',1,3,'    ',1,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, -1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ',65536,9934,-1,0,8,0,'',1,1,'  .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE(' ', 9934, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',2,9934,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9934, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,0,0,10,0,'([993410005] <= [993410006])  ([993410005] is null)  ([993410006] is null)',0,3,'        ',0,'           ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,0,993410005,1) ;

CALL DOCLOCK_IMPORT('  ',65536,9934,0,0,7,0,'',1,3,'   .           .',2,'',null,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 9934, 0, 0, 1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411015]) >= [993411086])    ((("..",[993411015]) >= [993411085])  ([993411086] is null))    (("..",[993411015]) is null)  ([993411015] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411015,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411015]) <= [993411085])    ((("..",[993411015]) <= [993411086])  ([993411085] is null))    (("..",[993411015]) is null)  ([993411015] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411015,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411013]) >= [993411086])    ((("..",[993411013]) >= [993411085])  ([993411086] is null))    (("..",[993411013]) is null)  ([993411013] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411013,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411013]) <= [993411085])    ((("..",[993411013]) <= [993411086])  ([993411085] is null))    (("..",[993411013]) is null)  ([993411013] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411013,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'([993411086] <= [993410006])  ([993411086] is null)  ([993410006] is null)',0,3,'             ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411086,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(([993411085] >= [993410005])  ([993411085] <= [993410006]))    (([993411085] is null)  ([993410005] is null)  ([993410006] is null))',0,3,'             ',0,'       .                    ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411085,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411018]) >= [993411086])    ((("..",[993411018]) >= [993411085])  ([993411086] is null))    (("..",[993411018]) is null)  ([993411018] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411018,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411074]) >= [993411086])    ((("..",[993411074]) >= [993411085])  ([993411086] is null))    (("..",[993411074]) is null)  ([993411074] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411074,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'((".PROGRAMCODE.DELETEDATE",[993411096]) >= [993411086])    (((".PROGRAMCODE.DELETEDATE",[993411096]) >= [993411085])  ([993411086] is null))    ((".PROGRAMCODE.DELETEDATE",[993411096]) is null)  ([993411096] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411096,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411016]) >= [993411086])    ((("..",[993411016]) >= [993411085])  ([993411086] is null))    (("..",[993411016]) is null)  ([993411016] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411016,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411095]) >= [993411086])    ((("..",[993411095]) >= [993411085])  ([993411086] is null))    (("..",[993411095]) is null)  ([993411095] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411095,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411094]) >= [993411086])    ((("..",[993411094]) >= [993411085])  ([993411086] is null))    (("..",[993411094]) is null)  ([993411094] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411094,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411033]) >= [993411086])    ((("..",[993411033]) >= [993411085])  ([993411086] is null))    (("..",[993411033]) is null)  ([993411033] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411033,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411020]) >= [993411086])    ((("..",[993411020]) >= [993411085])  ([993411086] is null))    (("..",[993411020]) is null)  ([993411020] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411020,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'((".OKTMO.DELETEDATE",[993411072]) >= [993411086])    (((".OKTMO.DELETEDATE",[993411072]) >= [993411085])  ([993411086] is null))    ((".OKTMO.DELETEDATE",[993411072]) is null)  ([993411072] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411072,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411082]) >= [993411086])    ((("..",[993411082]) >= [993411085])  ([993411086] is null))    (("..",[993411082]) is null)  ([993411082] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411082,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411035]) >= [993411086])    ((("..",[993411035]) >= [993411085])  ([993411086] is null))    (("..",[993411035]) is null)  ([993411035] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411035,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("_..",[993411081]) <= [993411085])    ((("_..",[993411081]) <= [993411086])  ([993411085] is null))    (("_..",[993411081]) is null)  ([993411081] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411081,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411018]) <= [993411085])    ((("..",[993411018]) <= [993411086])  ([993411085] is null))    (("..",[993411018]) is null)  ([993411018] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411018,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411022]) >= [993411086])    ((("..",[993411022]) >= [993411085])  ([993411086] is null))    (("..",[993411022]) is null)  ([993411022] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411022,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411074]) <= [993411085])    ((("..",[993411074]) <= [993411086])  ([993411085] is null))    (("..",[993411074]) is null)  ([993411074] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411074,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'((".PROGRAMCODE.STARTDATE",[993411096]) <= [993411085])    (((".PROGRAMCODE.STARTDATE",[993411096]) <= [993411086])  ([993411085] is null))    ((".PROGRAMCODE.STARTDATE",[993411051]) is null)  ([993411051] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411096,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411016]) <= [993411085])    ((("..",[993411016]) <= [993411086])  ([993411085] is null))    (("..",[993411016]) is null)  ([993411016] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411016,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".TARGETCLS.DELETEDATE",[993411040]) >= [993411086])    (((".TARGETCLS.DELETEDATE",[993411040]) >= [993411085])  ([993411086] is null))    ((".TARGETCLS.DELETEDATE",[993411040]) is null)  ([993411040] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411040,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411094]) <= [993411085])    ((("..",[993411094]) <= [993411086])  ([993411085] is null))    (("..",[993411094]) is null)  ([993411094] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411094,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411033]) <= [993411085])    ((("..",[993411033]) <= [993411086])  ([993411085] is null))    (("..",[993411033]) is null)  ([993411033] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411033,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411095]) <= [993411085])    ((("..",[993411095]) <= [993411086])  ([993411085] is null))    (("..",[993411095]) is null)  ([993411095] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411095,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411047]) >= [993411086])    ((("_..",[993411047]) >= [993411085])  ([993411086] is null))    (("_..",[993411047]) is null)  ([993411047] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411047,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411020]) <= [993411085])    ((("..",[993411020]) <= [993411086])  ([993411085] is null))    (("..",[993411020]) is null)  ([993411020] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411020,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'((".OKTMO.STARTDATE",[993411072]) <= [993411085])    (((".OKTMO.STARTDATE",[993411072]) <= [993411086])  ([993411085] is null))    ((".OKTMO.STARTDATE",[993411072]) is null)  ([993411072] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411072,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411052]) >= [993411086])    ((("..",[993411052]) >= [993411085])  ([993411086] is null))    (("..",[993411052]) is null)  ([993411052] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411052,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411027]) >= [993411086])    ((("..",[993411027]) >= [993411085])  ([993411086] is null))    (("..",[993411027]) is null)  ([993411027] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411027,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411024]) >= [993411086])    ((("..",[993411024]) >= [993411085])  ([993411086] is null))    (("..",[993411024]) is null)  ([993411024] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411024,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411039]) >= [993411086])    ((("_..",[993411039]) >= [993411085])  ([993411086] is null))    (("_..",[993411039]) is null)  ([993411039] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411039,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411082]) <= [993411085])    ((("..",[993411082]) <= [993411086])  ([993411085] is null))    (("..",[993411082]) is null)  ([993411082] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411082,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411035]) <= [993411085])    ((("..",[993411035]) <= [993411086])  ([993411085] is null))    (("..",[993411024]) is null)  ([993411024] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411035,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".SUBSIDYCLS.DELETEDATE",[993411043]) >= [993411086])    (((".SUBSIDYCLS.DELETEDATE",[993411043]) >= [993411085])  ([993411086] is null))    ((".SUBSIDYCLS.DELETEDATE",[993411043]) is null)  ([993411043] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411043,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411022]) <= [993411085])    ((("..",[993411022]) <= [993411086])  ([993411085] is null))    (("..",[993411022]) is null)  ([993411022] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411022,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411049]) >= [993411086])    ((("_..",[993411049]) >= [993411085])  ([993411086] is null))    (("_..",[993411049]) is null)  ([993411049] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411049,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("_..",[993411081]) >= [993411086])    ((("_..",[993411081]) >= [993411085])  ([993411086] is null))    (("_..",[993411081]) is null)  ([993411081] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411081,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".TARGETCLS.STARTDATE",[993411040]) <= [993411085])    (((".TARGETCLS.STARTDATE",[993411040]) <= [993411086])  ([993411085] is null))    ((".TARGETCLS.STARTDATE",[993411040]) is null)  ([993411040] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411040,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411047]) <= [993411085])    ((("_..",[993411047]) <= [993411086])  ([993411085] is null))    (("_..",[993411047]) is null)  ([993411051] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411047,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411052]) <= [993411085])    ((("..",[993411052]) <= [993411086])  ([993411085] is null))    (("..",[993411013]) is null)  ([993411013] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411052,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411024]) <= [993411085])    ((("..",[993411024]) <= [993411086])  ([993411085] is null))    (("..",[993411024]) is null)  ([993411024] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411024,1) ;

CALL DOCLOCK_IMPORT('   ',0,9934,1,0,10,0,'(("..",[993411027]) <= [993411085])    ((("..",[993411027]) <= [993411086])  ([993411085] is null))    (("..",[993411027]) is null)  ([993411027] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'    ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('   ',9934,1,993411027,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411051]) >= [993411086])    ((("_..",[993411051]) >= [993411085])  ([993411086] is null))    (("_..",[993411051]) is null)  ([993411051] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411051,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411042]) >= [993411086])    ((("..",[993411042]) >= [993411085])  ([993411086] is null))    (("..",[993411042]) is null)  ([993411042] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411042,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411039]) <= [993411085])    ((("_..",[993411039]) <= [993411086])  ([993411085] is null))    (("_..",[993411039]) is null)  ([993411039] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411039,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".SUBSIDYCLS.STARTDATE",[993411043]) <= [993411085])    (((".SUBSIDYCLS.STARTDATE",[993411043]) <= [993411086])  ([993411085] is null))    ((".SUBSIDYCLS.STARTDATE",[993411043]) is null)  ([993411043] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411043,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411049]) <= [993411085])    ((("_..",[993411049]) <= [993411086])  ([993411085] is null))    (("_..",[993411049]) is null)  ([993411051] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411049,1) ;

CALL DOCLOCK_IMPORT('     ',0,9934,1,0,10,0,'(("..",[993411045]) >= [993411086])    ((("..",[993411045]) >= [993411085])  ([993411086] is null))    (("..",[993411045]) is null)  ([993411045] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'      ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 9934, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',9934,1,993411045,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411031]) >= [993411086])    ((("..",[993411031]) >= [993411085])  ([993411086] is null))    (("..",[993411031]) is null)  ([993411031] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411031,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("_..",[993411051]) <= [993411085])    ((("_..",[993411051]) <= [993411086])  ([993411085] is null))    (("_..",[993411051]) is null)  ([993411051] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411051,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411042]) <= [993411085])    ((("..",[993411042]) <= [993411086])  ([993411085] is null))    (("..",[993411042]) is null)  ([993411042] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411042,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".COMMDIRECTIONEXPENCECLS.DELETEDATE",[993411079]) >= [993411086])    (((".COMMDIRECTIONEXPENCECLS.DELETEDATE",[993411079]) >= [993411085])  ([993411086] is null))    ((".COMMDIRECTIONEXPENCECLS.DELETEDATE",[993411079]) is null)  ([993411079] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                 ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411079,1) ;

CALL DOCLOCK_IMPORT('     ',0,9934,1,0,10,0,'(("..",[993411045]) <= [993411085])    ((("..",[993411045]) <= [993411086])  ([993411085] is null))    (("..",[993411045]) is null)  ([993411045] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'      ',0,'                   ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 9934, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',9934,1,993411045,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'(("..",[993411031]) <= [993411085])    ((("..",[993411031]) <= [993411086])  ([993411085] is null))    (("..",[993411031]) is null)  ([993411031] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411031,1) ;

CALL DOCLOCK_IMPORT('     ',0,9934,1,0,10,0,'(("..",[993411029]) >= [993411086])    ((("..",[993411029]) >= [993411085])  ([993411086] is null))    (("..",[993411029]) is null)  ([993411029] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'      ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',9934,1,993411029,1) ;

CALL DOCLOCK_IMPORT('    ',0,9934,1,0,10,0,'((".COMMDIRECTIONEXPENCECLS.STARTDATE",[993411079]) <= [993411085])    (((".COMMDIRECTIONEXPENCECLS.STARTDATE",[993411079]) <= [993411086])  ([993411085] is null))    ((".COMMDIRECTIONEXPENCECLS.STARTDATE",[993411079]) is null)  ([993411079] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'     ',0,'                  ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    ', 9934, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9934,1,993411079,1) ;

CALL DOCLOCK_IMPORT('     ',0,9934,1,0,10,0,'(("..",[993411029]) <= [993411085])    ((("..",[993411029]) <= [993411086])  ([993411085] is null))    (("..",[993411029]) is null)  ([993411029] is null)    (([993411085] is null)  ([993411086] is null))',0,3,'      ',0,'                   ',0,'',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 9934, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('     ',9934,1,993411029,1) ;

DROP PROCEDURE DOCLOCK_IMPORT      
/

DROP PROCEDURE DocLockFields_InsertField
/

DROP PROCEDURE DOCLOCK_DELETE
/

DROP PROCEDURE DOCLOCKFIELDS_DELETE
/

CREATE OR REPLACE PROCEDURE LINKTYPE_DELETE(
  NAME_         VARCHAR2,
  TEMPLATECLS_  NUMBER,
  PARENTDOCCLS_ NUMBER,
  CHILDDOCCLS_  NUMBER) IS
BEGIN
  FOR tab_rec in (SELECT id FROM LINKTYPE LT
  WHERE (((NAME_ <> '') or (NAME_ is not null)) and (LT.NAME = NAME_)) or 
    (((NAME_ = '') or (NAME_ is null)) and (LT.TEMPLATECLS = TEMPLATECLS_ AND LT.PARENTDOCCLS = PARENTDOCCLS_ AND LT.CHILDDOCCLS = CHILDDOCCLS_)))    
  LOOP
    UPDATE STATE_JUMPCONTROL SET
      REFERENCEREF = NULL
    WHERE REFERENCEREF = tab_rec.id;
    DELETE FROM REPLACEMENTCLSDETAIL WHERE LINKID IN (SELECT ID FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id);
    DELETE FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id;
    DELETE FROM LINKTYPE LT
      WHERE LT.ID = tab_rec.id;
  END LOOP;     
END;
/

CREATE OR REPLACE PROCEDURE LINKTYPE_IMPORT(
   ID_                    NUMBER,
   NAME_                  VARCHAR2,
   TEMPLATECLS_           NUMBER,
   PARENTDOCCLS_          NUMBER,
   CHILDDOCCLS_           NUMBER,
   LINKCOMMENT_           VARCHAR2,
   BLOCKPARENT_           NUMBER,
   BLOCKCHILD_            NUMBER,
   CANDELBLOCKPARENT_     NUMBER,
   CANDELBLOCKCHILD_      NUMBER,
   PARENTPICTURETYPE_     NUMBER,
   PARENTPICTURENAME_     VARCHAR2,
   CHILDPICTURETYPE_      NUMBER,
   CHILDPICTURENAME_      VARCHAR2,
   PICTURECOLLECTIONNAME_ VARCHAR2,
   URMUSE_                NUMBER,
   DELMACROSNAME_         VARCHAR2,
   NEEDDELCHILD_          NUMBER,
   LINKKIND_              NUMBER
) IS
   CNT$ NUMBER(10);
BEGIN
   /*          ,     */
   /*  ,   , ,  ,     */
   IF (
   ((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0))or(Name_ is not null))   
   THEN
     FOR tab_rec in(SELECT id FROM LINKTYPE LT WHERE 
		 (id<>ID_)	
         and(((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0)and(LT.TEMPLATECLS = TEMPLATECLS_)
         and (LT.PARENTDOCCLS = PARENTDOCCLS_) and (LT.CHILDDOCCLS = CHILDDOCCLS_))
         or((Name_ is not null)and(lt.Name=Name_))))
     LOOP
        /*             */    
        DELETE FROM LINKRECORDS WHERE LINKTYPEREF = -10;  
        DELETE FROM TB_LINKTYPE WHERE ID = -10;
        DELETE FROM DOCUMENTCLS WHERE ID = -10;
        DELETE FROM DOCUMENTTYPES WHERE ID = -10;
        INSERT INTO DOCUMENTTYPES(ID, PROGINDEX) VALUES(-10, -10);
        INSERT INTO DOCUMENTCLS(ID, DOCTYPE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM)
           VALUES(-10, -10, ' ', ' ', ' ', ' ');
        INSERT INTO LINKTYPE(ID, PARENTDOCCLS, CHILDDOCCLS, NAME) VALUES(-10, -10, -10, ' ');
        UPDATE STATE_JUMPCONTROL SET
           REFERENCEREF = -10
        WHERE
           REFERENCEREF = tab_rec.id;
        UPDATE LINKRECORDS SET
           LINKTYPEREF = -10
        WHERE
           LINKTYPEREF = tab_rec.id;
        DELETE FROM TB_LINKTYPE WHERE ID = tab_rec.Id;
     END LOOP;
   end if;
   /*      */ 
   SELECT count(*) into CNT$
      FROM LINKTYPE LT WHERE LT.ID = ID_;
   IF (CNT$ = 0)    
   THEN
      INSERT INTO LINKTYPE
       (ID,NAME,TEMPLATECLS,PARENTDOCCLS, CHILDDOCCLS, LINKCOMMENT, BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,
        CANDELBLOCKCHILD, PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,
        PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND)
      VALUES
       (ID_,NAME_,TEMPLATECLS_, PARENTDOCCLS_, CHILDDOCCLS_, LINKCOMMENT_, BLOCKPARENT_,BLOCKCHILD_,CANDELBLOCKPARENT_,
        CANDELBLOCKCHILD_, PARENTPICTURETYPE_,PARENTPICTURENAME_,CHILDPICTURETYPE_,CHILDPICTURENAME_,
        PICTURECOLLECTIONNAME_,URMUSE_,DELMACROSNAME_,NEEDDELCHILD_,LINKKIND_);
   ELSE
      UPDATE LINKTYPE SET
         NAME = NAME_,
         TEMPLATECLS = TEMPLATECLS_,
         PARENTDOCCLS = PARENTDOCCLS_,
         CHILDDOCCLS = CHILDDOCCLS_,
         LINKCOMMENT = LINKCOMMENT_,
         BLOCKPARENT = BLOCKPARENT_,
         BLOCKCHILD = BLOCKCHILD_,
         CANDELBLOCKPARENT = CANDELBLOCKPARENT_,
         CANDELBLOCKCHILD = CANDELBLOCKCHILD_,
         PARENTPICTURETYPE = PARENTPICTURETYPE_,
         PARENTPICTURENAME = PARENTPICTURENAME_,
         CHILDPICTURETYPE = CHILDPICTURETYPE_,
         CHILDPICTURENAME = CHILDPICTURENAME_,
         PICTURECOLLECTIONNAME = PICTURECOLLECTIONNAME_,
         URMUSE = URMUSE_,
         DELMACROSNAME = DELMACROSNAME_,
         NEEDDELCHILD = NEEDDELCHILD_,
         LINKKIND = LINKKIND_
      WHERE ID = ID_;
   END IF;      
   
   /*      ,      */
   UPDATE STATE_JUMPCONTROL SET
     REFERENCEREF = ID_
   WHERE
     REFERENCEREF = -10;
   UPDATE LINKRECORDS SET
      LINKTYPEREF = ID_
   WHERE
      LINKTYPEREF = -10;
   /*   */  
   DELETE FROM TB_LINKTYPE WHERE ID = -10;
   DELETE FROM DOCUMENTCLS WHERE ID = -10;
   DELETE FROM DOCUMENTTYPES WHERE ID = -10;
END;
/

--  
CALL LINKTYPE_DELETE('',0, 20701, 21601) ;

CALL LINKTYPE_IMPORT(303000300,'',null,300601,300601,'    ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(303000500,'',null,300300,300300,'    ',1,0,0,0,1,'',1,'','',0,'',0,0) ;

CALL LINKTYPE_IMPORT(303000400,'',null,300601,300601,'     ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(30303600,'->',null,30201,32301,'',1,0,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30303700,'_->_',null,30200,32300,'',1,0,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30304000,'->',null,30800,30500,'',1,0,0,0,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(302500100,'  -> ',null,300600,250400,'    ',1,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(304900700,'',null,300500,490200,'  ',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(184900100,'->',null,181800,490200,'      ',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(20300300,'',null,21100,32300,'      ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(220200100,'()->',null,220100,20500,'         ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(220200200,'()->',null,220101,20501,'         ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(20205000,' 14 () ->  14 ()',null,21501,21501,'   (14 /)    (14 /)',1,0,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(34903200,'2',null,30300,490200,'',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(20205100,' 14 () ->  14 ()',null,21500,21500,'   (14 /)    (14 /)',1,0,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30304100,'->',null,30800,32400,'',1,0,0,0,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30304200,'->',null,30501,30201,'      ',1,0,0,0,1,'',1,'','',0,'',0,2) ;

CALL LINKTYPE_IMPORT(24902200,'->',null,20101,490100,'       ',0,0,0,0,1,'',1,'','',0,'',0,0) ;

CALL LINKTYPE_IMPORT(554800100,'',null,550100,480100,'       ',0,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(554800200,'',null,550200,480100,'       ',0,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(20300400,'- ',null,20100,30300,'      ',1,0,0,0,1,'',1,'','1616',1,'',1,0) ;

CALL LINKTYPE_IMPORT(20300500,'->',null,20101,30301,'      ',1,0,0,0,1,'',1,'','1616',1,'',1,0) ;

CALL LINKTYPE_IMPORT(303000600,'3011',null,301101,301101,'  ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(303000700,'3011',null,301101,301101,'   ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(302500200,'  -> ',null,301100,250400,'    ',1,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(20205200,'',null,21001,21001,'    (, )     (, )  ',1,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(20205300,'',null,21001,21001,'    (, )     (, )   ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(20205400,'',null,21002,21002,'    ()     ()  ',1,0,0,0,1,'',1,'','1616',1,'',0,0) ;

CALL LINKTYPE_IMPORT(20205500,'',null,21002,21002,'    ()     ()   ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(474700100,'  ->  ',null,470100,470100,'       ',0,0,0,0,1,'',1,'','',1,'',0,0) ;

CALL LINKTYPE_IMPORT(474900100,'',null,470100,490200,'    ',0,0,0,0,1,'',1,'','',1,'',0,1) ;

CALL LINKTYPE_IMPORT(20205600,'C_->   _',null,20200,20800,'   ()     ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(20205700,'C_->   _',null,20201,20801,'   ()     ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(20205900,'',null,21100,21700,'     ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(20206000,'',null,20701,21601,'     ',1,0,0,0,1,'',1,'','1616',1,'',1,0) ;

CALL LINKTYPE_IMPORT(20206100,'',null,21101,21701,'     ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30304300,'',null,30500,30500,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) ;

CALL LINKTYPE_IMPORT(30304400,'',null,30501,30501,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) ;

CALL LINKTYPE_IMPORT(90900700,'',null,90301,90301,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) ;

CALL LINKTYPE_IMPORT(20206200,'',null,20200,20200,'  ()   ( )',0,0,0,1,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(35502600,'___',null,32501,550201,'',1,0,0,0,1,'',1,'','',0,'',0,0) ;

CALL LINKTYPE_IMPORT(24902300,'2',null,21000,490200,'     ',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(34801100,'',null,32500,480100,'',0,0,0,0,1,'',1,'','',0,'',0,0) ;

CALL LINKTYPE_IMPORT(34903300,'2',null,32500,490200,'       ',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

DROP PROCEDURE LINKTYPE_DELETE
/

DROP PROCEDURE LINKTYPE_IMPORT
/

CREATE OR REPLACE PROCEDURE STATICLINK_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATICLINKS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE STATICLINK_IMPORT(
  ID_             NUMBER,
  NAME_           VARCHAR2,
  PARENTFIELDREF_ NUMBER,
  CHILDFIELDREF_  NUMBER,
  LINKKIND_      NUMBER,
  ParentDelAction_ NUMBER
) IS
  FINDID$ NUMBER;
  FINDNEWID$ NUMBER;
  IDExists$ NUMBER;
BEGIN
  /*     ID,    CHILDFIELDREF,PARENTFIELDREF. 
   ,     ,    ID.       ID  , 
   (  )     id ,      */
  BEGIN
    SELECT
      SL.ID
    INTO FINDID$
    FROM 
      STATICLINKS SL
    WHERE (SL.CHILDFIELDREF = CHILDFIELDREF_) AND (SL.PARENTFIELDREF = PARENTFIELDREF_) AND (SL.ID <> ID_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      FINDID$ := NULL;
  END;
  
  IF (FINDID$ IS NOT NULL) THEN
  /*   ID         */

    SELECT COUNT (ID)
      INTO IDExists$
      FROM STATE_JUMPCONTROL
    WHERE (STATICLINKREF = FINDID$);

    IF (IDExists$ > 0) THEN

      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM 
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
 
      IF (FINDNEWID$ IS NULL) THEN
        INSERT INTO STATICLINKS
         (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
        VALUES
          (ID_,NAME_,CHILDFIELDREF_,PARENTFIELDREF_,1,ParentDelAction_);
      END IF;        
      UPDATE STATE_JUMPCONTROL
        SET STATICLINKREF = ID_
      WHERE (STATICLINKREF = FINDID$);

      DELETE FROM STATICLINKS  
      WHERE ID=FINDID$;
    ELSE   
      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
      IF (FINDNEWID$ IS NULL) THEN
        UPDATE STATICLINKS
        SET ID=ID_
        WHERE ID=FINDID$;
      ELSE
        DELETE FROM STATICLINKS
        WHERE ID=FINDID$;
      END IF;
    END IF;
      
  END IF; /*  id  */
  
  /*       ( ), 
   ,            CHILDFIELDREF.
   ,        1( )*/
  IF (LINKKIND_=0) THEN
    UPDATE STATICLINKS
    SET LINKKIND=1  
    WHERE (CHILDFIELDREF = CHILDFIELDREF_) AND (ID <> ID_) AND (LINKKIND=0);
  END IF;    
  
  /*        id.  ,   .  ,   */
  BEGIN
    SELECT SL.ID
      INTO FINDID$
      FROM
        STATICLINKS SL
      WHERE
        (SL.ID = ID_);
  EXCEPTION
      WHEN NO_DATA_FOUND THEN
        FINDID$ := NULL;
  END;
  IF (FINDID$ IS NOT NULL) THEN
    UPDATE STATICLINKS SET
      NAME           = NAME_,
      PARENTFIELDREF = PARENTFIELDREF_,
      CHILDFIELDREF  = CHILDFIELDREF_,
      LINKKIND       = LINKKIND_,
      ParentDelAction = ParentDelAction_
      WHERE ID = ID_;
  ELSE
    INSERT INTO STATICLINKS
     (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
    VALUES
      (ID_,NAME_,PARENTFIELDREF_,CHILDFIELDREF_,LINKKIND_,ParentDelAction_);
  END IF;      

END;
/

--  
CALL STATICLINK_DELETE(999800400) ;

CALL STATICLINK_DELETE(989900700) ;

CALL STATICLINK_DELETE(999900200) ;

CALL STATICLINK_DELETE(999901700) ;

CALL STATICLINK_DELETE(990232200) ;

CALL STATICLINK_DELETE(983001100) ;

CALL STATICLINK_DELETE(993700100) ;

CALL STATICLINK_DELETE(982505400) ;

CALL STATICLINK_DELETE(982505100) ;

CALL STATICLINK_DELETE(982505000) ;

CALL STATICLINK_DELETE(982505200) ;

CALL STATICLINK_DELETE(992501800) ;

CALL STATICLINK_DELETE(982505300) ;

CALL STATICLINK_DELETE(990228000) ;

CALL STATICLINK_DELETE(990228400) ;

CALL STATICLINK_DELETE(990338500) ;

CALL STATICLINK_DELETE(990338400) ;

CALL STATICLINK_DELETE(990338000) ;

CALL STATICLINK_DELETE(990338100) ;

CALL STATICLINK_DELETE(990338600) ;

CALL STATICLINK_DELETE(990338700) ;

CALL STATICLINK_DELETE(990338900) ;

CALL STATICLINK_DELETE(990339200) ;

CALL STATICLINK_DELETE(990339100) ;

CALL STATICLINK_DELETE(990339500) ;

CALL STATICLINK_DELETE(990339700) ;

CALL STATICLINK_DELETE(990339900) ;

CALL STATICLINK_DELETE(990232100) ;

CALL STATICLINK_DELETE(990232300) ;

CALL STATICLINK_DELETE(990232500) ;

CALL STATICLINK_DELETE(990232700) ;

CALL STATICLINK_DELETE(990232900) ;

CALL STATICLINK_DELETE(990233000) ;

CALL STATICLINK_DELETE(990233200) ;

CALL STATICLINK_DELETE(990233400) ;

CALL STATICLINK_DELETE(990233600) ;

CALL STATICLINK_DELETE(990233700) ;

CALL STATICLINK_DELETE(990234000) ;

CALL STATICLINK_DELETE(990234200) ;

CALL STATICLINK_DELETE(992203500) ;

CALL STATICLINK_DELETE(990337800) ;

CALL STATICLINK_DELETE(990232000) ;

CALL STATICLINK_DELETE(990337900) ;

CALL STATICLINK_DELETE(990338200) ;

CALL STATICLINK_DELETE(990338300) ;

CALL STATICLINK_DELETE(990338800) ;

CALL STATICLINK_DELETE(990339000) ;

CALL STATICLINK_DELETE(990339400) ;

CALL STATICLINK_DELETE(990339300) ;

CALL STATICLINK_DELETE(990339600) ;

CALL STATICLINK_DELETE(990339800) ;

CALL STATICLINK_DELETE(990340000) ;

CALL STATICLINK_DELETE(990231900) ;

CALL STATICLINK_DELETE(990232400) ;

CALL STATICLINK_DELETE(990232600) ;

CALL STATICLINK_DELETE(990232800) ;

CALL STATICLINK_DELETE(990233100) ;

CALL STATICLINK_DELETE(990233300) ;

CALL STATICLINK_DELETE(990233800) ;

CALL STATICLINK_DELETE(990233900) ;

CALL STATICLINK_DELETE(990234100) ;

CALL STATICLINK_DELETE(990234300) ;

CALL STATICLINK_DELETE(990233500) ;

CALL STATICLINK_DELETE(992203600) ;

CALL STATICLINK_DELETE(990803400) ;

CALL STATICLINK_DELETE(990803300) ;

CALL STATICLINK_DELETE(990803500) ;

CALL STATICLINK_DELETE(990803600) ;

CALL STATICLINK_DELETE(990908400) ;

CALL STATICLINK_DELETE(990908300) ;

CALL STATICLINK_DELETE(990908600) ;

CALL STATICLINK_DELETE(990908500) ;

CALL STATICLINK_DELETE(990908700) ;

CALL STATICLINK_DELETE(990908800) ;

CALL STATICLINK_DELETE(992503000) ;

CALL STATICLINK_DELETE(992503100) ;

CALL STATICLINK_DELETE(992503200) ;

CALL STATICLINK_DELETE(992503300) ;

CALL STATICLINK_DELETE(993002900) ;

CALL STATICLINK_DELETE(993003000) ;

CALL STATICLINK_DELETE(993003100) ;

CALL STATICLINK_DELETE(994402500) ;

CALL STATICLINK_DELETE(994402400) ;

CALL STATICLINK_DELETE(994402600) ;

CALL STATICLINK_DELETE(995201100) ;

CALL STATICLINK_DELETE(995201000) ;

CALL STATICLINK_DELETE(995504600) ;

CALL STATICLINK_DELETE(995504500) ;

CALL STATICLINK_DELETE(995504800) ;

CALL STATICLINK_DELETE(995504700) ;

CALL STATICLINK_DELETE(995505000) ;

CALL STATICLINK_DELETE(990235400) ;

CALL STATICLINK_DELETE(990235900) ;

CALL STATICLINK_DELETE(990235300) ;

CALL STATICLINK_DELETE(990235600) ;

CALL STATICLINK_DELETE(990235500) ;

CALL STATICLINK_DELETE(990235800) ;

CALL STATICLINK_DELETE(990235700) ;

CALL STATICLINK_DELETE(992504300) ;

CALL STATICLINK_DELETE(990236200) ;

CALL STATICLINK_DELETE(964700000) ;

CALL STATICLINK_DELETE(964700100) ;

CALL STATICLINK_DELETE(990239200) ;

CALL STATICLINK_DELETE(999905600) ;

CALL STATICLINK_IMPORT(979800100,'.TARGETCLS->.ID',970910002,984910004,0,0) ;

CALL STATICLINK_IMPORT(979900100,'.TARGETCLS->.ID',970910002,988410029,0,0) ;

CALL STATICLINK_IMPORT(970200300,'_.1.TARGETCLS()->.ID',970910002,20101103,0,0) ;

CALL STATICLINK_IMPORT(985200900,'.1.SUBKESR()->.ID',980810002,520111022,0,0) ;

CALL STATICLINK_IMPORT(985200800,'.1.SUBKESR()->.ID',980810002,520101022,0,1) ;

CALL STATICLINK_IMPORT(985506000,'.1.SUBKESR()->.ID',980810002,550311016,0,0) ;

CALL STATICLINK_IMPORT(995505400,'_.1.INVESTOBJECT()->.ID',985410045,550111166,0,0) ;

CALL STATICLINK_IMPORT(995505300,'_.1.INVESTOBJECT()->.ID',985410045,550101174,0,0) ;

CALL STATICLINK_IMPORT(995505500,'_.1.INVESTOBJECT()->.ID',985410045,550201179,0,0) ;

CALL STATICLINK_IMPORT(995505600,'_.1.INVESTOBJECT()->.ID',985410045,550211145,0,0) ;

CALL STATICLINK_IMPORT(995201400,'.1.INVESTOBJECT()->.ID',985410045,520111062,0,0) ;

CALL STATICLINK_IMPORT(995201300,'.1.INVESTOBJECT()->.ID',985410045,520101065,0,0) ;

CALL STATICLINK_IMPORT(990909000,'_.1.INVESTOBJECT()->.ID',985410045,90311093,0,0) ;

CALL STATICLINK_IMPORT(990908900,'_.1.INVESTOBJECT()->.ID',985410045,90301174,0,0) ;

CALL STATICLINK_IMPORT(990909200,'_.INVESTOBJECT()->.ID',985410045,90510044,0,0) ;

CALL STATICLINK_IMPORT(990909100,'_.INVESTOBJECT()->.ID',985410045,90500038,0,0) ;

CALL STATICLINK_IMPORT(990909300,'_.INVESTOBJECT()->.ID',985410045,90700052,0,0) ;

CALL STATICLINK_IMPORT(990909400,'_.INVESTOBJECT()->.ID',985410045,90710056,0,0) ;

CALL STATICLINK_IMPORT(990237400,'_.1.INVESTOBJECT()->.ID',985410045,20111186,0,0) ;

CALL STATICLINK_IMPORT(990236600,'_.1.INVESTOBJECT()->.ID',985410045,20101189,0,0) ;

CALL STATICLINK_IMPORT(990341900,'.1.SOURCEINVESTOBJECT()->.ID',985410045,30211156,0,0) ;

CALL STATICLINK_IMPORT(990341800,'.1.SOURCEINVESTOBJECT()->.ID',985410045,30201173,0,0) ;

CALL STATICLINK_IMPORT(990342200,'.1.SOURCEINVESTOBJECT()->.ID',985410045,30411145,0,0) ;

CALL STATICLINK_IMPORT(990342100,'.1.SOURCEINVESTOBJECT()->.ID',985410045,30401164,0,0) ;

CALL STATICLINK_IMPORT(990342400,'.1.DESTINVESTOBJECT()->.ID',985410045,30511146,0,0) ;

CALL STATICLINK_IMPORT(990342300,'.1.DESTINVESTOBJECT()->.ID',985410045,30501176,0,0) ;

CALL STATICLINK_IMPORT(990342600,'.1.DESTINVESTOBJECT()->.ID',985410045,30611148,0,0) ;

CALL STATICLINK_IMPORT(990342500,'.1.DESTINVESTOBJECT()->.ID',985410045,30601198,0,0) ;

CALL STATICLINK_IMPORT(990343200,'_.1.SOURCEINVESTOBJECT()->.ID',985410045,31111107,0,0) ;

CALL STATICLINK_IMPORT(990343100,'_.1.SOURCEINVESTOBJECT()->.ID',985410045,31101093,0,0) ;

CALL STATICLINK_IMPORT(990343400,'_.1.DESTINVESTOBJECT()->.ID',985410045,31211142,0,0) ;

CALL STATICLINK_IMPORT(990343300,'_.1.DESTINVESTOBJECT()->.ID',985410045,31201168,0,0) ;

CALL STATICLINK_IMPORT(990343600,'_.1.SOURCEINVESTOBJECT()->.ID',985410045,31411142,0,0) ;

CALL STATICLINK_IMPORT(990343500,'_.1.SOURCEINVESTOBJECT()->.ID',985410045,31401163,0,0) ;

CALL STATICLINK_IMPORT(990343700,'_.1.DESTINVESTOBJECT()->.ID',985410045,31511098,0,0) ;

CALL STATICLINK_IMPORT(990344100,'.1.DESTINVESTOBJECT()->.ID',985410045,32311157,0,0) ;

CALL STATICLINK_IMPORT(990344000,'.1.DESTINVESTOBJECT()->.ID',985410045,32301208,0,0) ;

CALL STATICLINK_IMPORT(990344300,'.1.DESTINVESTOBJECT()->.ID',985410045,32411198,0,0) ;

CALL STATICLINK_IMPORT(990344200,'.1.DESTINVESTOBJECT()->.ID',985410045,32401253,0,0) ;

CALL STATICLINK_IMPORT(990343900,'.1.SOURCEINVESTOBJECT()->.ID',985410045,32211090,0,0) ;

CALL STATICLINK_IMPORT(990343800,'.1.SOURCEINVESTOBJECT()->.ID',985410045,32201082,0,0) ;

CALL STATICLINK_IMPORT(990342000,'.1.DESTINVESTOBJECT()->.ID',985410045,30311095,0,0) ;

CALL STATICLINK_IMPORT(994402800,'.1.INVESTOBJECT()->.ID',985410045,440111070,0,0) ;

CALL STATICLINK_IMPORT(994402700,'.1.INVESTOBJECT()->.ID',985410045,440101074,0,0) ;

CALL STATICLINK_IMPORT(994403000,'.1.INVESTOBJECT()->.ID',985410045,440311067,0,0) ;

CALL STATICLINK_IMPORT(994402900,'.1.INVESTOBJECT()->.ID',985410045,440301053,0,0) ;

CALL STATICLINK_IMPORT(992504600,'.2.INVESTOBJECT()->.ID',985410045,250212054,0,0) ;

CALL STATICLINK_IMPORT(992504700,'.2.INVESTOBJECT()->.ID',985410045,250312049,0,0) ;

CALL STATICLINK_IMPORT(992504800,'.2.INVESTOBJECT()->.ID',985410045,250412053,0,0) ;

CALL STATICLINK_IMPORT(993004300,'.1.INVESTOBJECT()->.ID',985410045,300111098,0,0) ;

CALL STATICLINK_IMPORT(993004400,'.1.INVESTOBJECT()->.ID',985410045,300611056,0,0) ;

CALL STATICLINK_IMPORT(990342900,'.1.SOURCEINVESTOBJECT->.ID',985410045,30811111,0,0) ;

CALL STATICLINK_IMPORT(990343000,'.1.DESTINVESTOBJECT->.ID',985410045,30811112,0,0) ;

CALL STATICLINK_IMPORT(990342700,'.1.SOURCEINVESTOBJECT->.ID',985410045,30801239,0,0) ;

CALL STATICLINK_IMPORT(990342800,'.1.DESTINVESTOBJECT->.ID',985410045,30801240,0,0) ;

CALL STATICLINK_IMPORT(990341600,'.1.SOURCEINVESTOBJECT->.ID',985410045,30111171,0,0) ;

CALL STATICLINK_IMPORT(990341400,'.1.SOURCEINVESTOBJECT->.ID',985410045,30101198,0,0) ;

CALL STATICLINK_IMPORT(990341700,'.1.DESTINVESTOBJECT->.ID',985410045,30111172,0,0) ;

CALL STATICLINK_IMPORT(990341500,'.1.DESTINVESTOBJECT->.ID',985410045,30101199,0,0) ;

CALL STATICLINK_IMPORT(990237500,'_.1.INVESTOBJECT()->.ID',985410045,20211109,0,0) ;

CALL STATICLINK_IMPORT(990236700,'_.1.INVESTOBJECT()->.ID',985410045,20201132,0,0) ;

CALL STATICLINK_IMPORT(990237600,'_.1.INVESTOBJECT()->.ID',985410045,20311099,0,0) ;

CALL STATICLINK_IMPORT(990236800,'_.1.INVESTOBJECT()->.ID',985410045,20301150,0,0) ;

CALL STATICLINK_IMPORT(990237700,'_.1.INVESTOBJECT()->.ID',985410045,20411119,0,0) ;

CALL STATICLINK_IMPORT(990236900,'_.1.INVESTOBJECT()->.ID',985410045,20401138,0,0) ;

CALL STATICLINK_IMPORT(990237800,'.1.INVESTOBJECT()->.ID',985410045,20511106,0,0) ;

CALL STATICLINK_IMPORT(990237000,'.1.INVESTOBJECT()->.ID',985410045,20501097,0,0) ;

CALL STATICLINK_IMPORT(990237900,'__.1.INVESTOBJECT()->.ID',985410045,20611187,0,0) ;

CALL STATICLINK_IMPORT(990237100,'__.1.INVESTOBJECT()->.ID',985410045,20601190,0,0) ;

CALL STATICLINK_IMPORT(990238000,'_.1.INVESTOBJECT()->.ID',985410045,20711187,0,0) ;

CALL STATICLINK_IMPORT(990237200,'_.1.INVESTOBJECT()->.ID',985410045,20701211,0,0) ;

CALL STATICLINK_IMPORT(990238100,'__.1.INVESTOBJECT()->.ID',985410045,20811188,0,0) ;

CALL STATICLINK_IMPORT(990237300,'__.1.INVESTOBJECT()->.ID',985410045,20801213,0,0) ;

CALL STATICLINK_IMPORT(970300000,'.1.SOURCETARGETCLS()->.ID',970910002,30201200,0,0) ;

CALL STATICLINK_IMPORT(970300900,'.1.SOURCETARGETCLS()->.ID',970910002,30211184,0,0) ;

CALL STATICLINK_IMPORT(993004500,'.1.INVESTOBJECT()->.ID',985410045,301111043,0,0) ;

CALL STATICLINK_IMPORT(990238500,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20111195,0,0) ;

CALL STATICLINK_IMPORT(990238400,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20101194,0,0) ;

CALL STATICLINK_IMPORT(990234400,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20201134,0,0) ;

CALL STATICLINK_IMPORT(990234500,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20301152,0,0) ;

CALL STATICLINK_IMPORT(990234600,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20401139,0,0) ;

CALL STATICLINK_IMPORT(990234700,'.1.CONTRACTCOSTSCLS()->.ID',989710001,20501098,0,0) ;

CALL STATICLINK_IMPORT(990234800,'__.1.CONTRACTCOSTSCLS()->.ID',989710001,20601191,0,0) ;

CALL STATICLINK_IMPORT(990234900,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20701212,0,0) ;

CALL STATICLINK_IMPORT(990235000,'__.1.CONTRACTCOSTSCLS()->.ID',989710001,20801214,0,0) ;

CALL STATICLINK_IMPORT(990235100,'_.2.CONTRACTCOSTSCLS()->.ID',989710001,21102048,0,0) ;

CALL STATICLINK_IMPORT(990235200,'_.2.CONTRACTCOSTSCLS()->.ID',989710001,21202049,0,0) ;

CALL STATICLINK_IMPORT(990340100,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,30201213,0,0) ;

CALL STATICLINK_IMPORT(990340200,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,30401167,0,0) ;

CALL STATICLINK_IMPORT(990340300,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30501179,0,0) ;

CALL STATICLINK_IMPORT(990340400,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30601201,0,0) ;

CALL STATICLINK_IMPORT(990340600,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30801244,0,0) ;

CALL STATICLINK_IMPORT(990340500,'.1.SOURCECONTRACTCOSTSCLS(,)->.ID',989710001,30801245,0,0) ;

CALL STATICLINK_IMPORT(990340700,'_.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,31101095,0,0) ;

CALL STATICLINK_IMPORT(990340800,'_.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,31201170,0,0) ;

CALL STATICLINK_IMPORT(990340900,'_.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,31401166,0,0) ;

CALL STATICLINK_IMPORT(990341000,'_.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,31501002,0,0) ;

CALL STATICLINK_IMPORT(990341100,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,32201084,0,0) ;

CALL STATICLINK_IMPORT(990341300,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,32401257,0,0) ;

CALL STATICLINK_IMPORT(995505100,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,550101178,0,0) ;

CALL STATICLINK_IMPORT(995505200,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,550201182,0,0) ;

CALL STATICLINK_IMPORT(995201200,'.1.CONTRACTCOSTSCLS()->.ID',989710001,520101075,0,0) ;

CALL STATICLINK_IMPORT(990341200,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,32301213,0,0) ;

CALL STATICLINK_IMPORT(992504500,'.ID->.ID',993010001,250310049,0,0) ;

CALL STATICLINK_IMPORT(990238200,'.1.INVESTOBJECT()->.ID',985410045,21011053,0,0) ;

CALL STATICLINK_IMPORT(990238300,'.2.INVESTOBJECT()->.ID',985410045,21012065,0,0) ;

CALL STATICLINK_IMPORT(970300300,'.1.SOURCETARGETCLS()->.ID',970910002,30111191,0,0) ;

CALL STATICLINK_IMPORT(970300400,'.1.DESTTARGETCLS()->.ID',970910002,30111193,0,0) ;

CALL STATICLINK_IMPORT(970300700,'.1.DESTTARGETCLS()->.ID',970910002,30311111,0,0) ;

CALL STATICLINK_IMPORT(970300800,'.1.SOURCETARGETCLS()->.ID',970910002,30411150,0,0) ;

CALL STATICLINK_IMPORT(970301100,'.1.DESTTARGETCLS()->.ID',970910002,30511151,0,0) ;

CALL STATICLINK_IMPORT(970301400,'.1.DESTTARGETCLS()->.ID',970910002,30811120,0,0) ;

CALL STATICLINK_IMPORT(970301300,'.1.SOURCETARGETCLS(,)->.ID',970910002,30811122,0,0) ;

CALL STATICLINK_IMPORT(970301700,'.1.SOURCETARGETCLS()->.ID',970910002,32211096,0,0) ;

CALL STATICLINK_IMPORT(970301900,'.1.DESTTARGETCLS()->.ID',970910002,32311169,0,0) ;

CALL STATICLINK_IMPORT(970302100,'.1.DESTTARGETCLS()->.ID',970910002,32411209,0,0) ;

CALL STATICLINK_IMPORT(970200200,'_.1.TARGETCLS()->.ID',970910002,20111200,0,0) ;

CALL STATICLINK_IMPORT(970200400,'_.1.TARGETCLS()->.ID',970910002,20211116,0,0) ;

CALL STATICLINK_IMPORT(970200600,'_.1.TARGETCLS()->.ID',970910002,20311104,0,0) ;

CALL STATICLINK_IMPORT(970200800,'_.1.TARGETCLS()->.ID',970910002,20411125,0,0) ;

CALL STATICLINK_IMPORT(970201000,'.1.TARGETCLS()->.ID',970910002,20511112,0,0) ;

CALL STATICLINK_IMPORT(970201100,'__.1.TARGETCLS()->.ID',970910002,20611191,0,0) ;

CALL STATICLINK_IMPORT(970201300,'__.1.TARGETCLS()->.ID',970910002,20811192,0,0) ;

CALL STATICLINK_IMPORT(970201500,'_.2.TARGETCLS()->.ID',970910002,20912047,0,0) ;

CALL STATICLINK_IMPORT(970201700,'.1.TARGETCLS()->.ID',970910002,21011054,0,0) ;

CALL STATICLINK_IMPORT(970201800,'.2.TARGETCLS()->.ID',970910002,21012066,0,0) ;

CALL STATICLINK_IMPORT(970202100,'_.2.TARGETCLS()->.ID',970910002,21112052,0,1) ;

CALL STATICLINK_IMPORT(970202300,'_.2.TARGETCLS()->.ID',970910002,21212053,0,1) ;

CALL STATICLINK_IMPORT(972200000,'_.1.TARGETCLS()->.ID',970910002,220111084,0,0) ;

CALL STATICLINK_IMPORT(970300100,'.1.->.ID',970910002,30011047,0,1) ;

CALL STATICLINK_IMPORT(970200100,'.1.->.ID',970910002,20011043,0,1) ;

CALL STATICLINK_IMPORT(970300200,'.1.->.ID',970910002,30001047,0,1) ;

CALL STATICLINK_IMPORT(970300500,'.1.SOURCETARGETCLS()->.ID',970910002,30101206,0,0) ;

CALL STATICLINK_IMPORT(970300600,'.1.DESTTARGETCLS()->.ID',970910002,30101207,0,0) ;

CALL STATICLINK_IMPORT(970301000,'.1.SOURCETARGETCLS()->.ID',970910002,30401169,0,0) ;

CALL STATICLINK_IMPORT(970301200,'.1.DESTTARGETCLS()->.ID',970910002,30501181,0,0) ;

CALL STATICLINK_IMPORT(970301600,'.1.DESTTARGETCLS()->.ID',970910002,30801248,0,0) ;

CALL STATICLINK_IMPORT(970301500,'.1.SOURCETARGETCLS(,)->.ID',970910002,30801249,0,0) ;

CALL STATICLINK_IMPORT(970301800,'.1.SOURCETARGETCLS()->.ID',970910002,32201087,0,0) ;

CALL STATICLINK_IMPORT(970302000,'.1.DESTTARGETCLS()->.ID',970910002,32301215,0,0) ;

CALL STATICLINK_IMPORT(970302200,'.1.DESTTARGETCLS()->.ID',970910002,32401260,0,0) ;

CALL STATICLINK_IMPORT(970200000,'.1.->.ID',970910002,20001043,0,1) ;

CALL STATICLINK_IMPORT(970200500,'_.1.TARGETCLS()->.ID',970910002,20201138,0,0) ;

CALL STATICLINK_IMPORT(970200700,'_.1.TARGETCLS()->.ID',970910002,20301154,0,0) ;

CALL STATICLINK_IMPORT(970200900,'_.1.TARGETCLS()->.ID',970910002,20401145,0,0) ;

CALL STATICLINK_IMPORT(970201200,'__.1.TARGETCLS()->.ID',970910002,20601194,0,0) ;

CALL STATICLINK_IMPORT(970201400,'__.1.TARGETCLS()->.ID',970910002,20801217,0,0) ;

CALL STATICLINK_IMPORT(970201900,'.1.TARGETCLS()->.ID',970910002,21001063,0,0) ;

CALL STATICLINK_IMPORT(970202000,'.2.TARGETCLS()->.ID',970910002,21002062,0,0) ;

CALL STATICLINK_IMPORT(970202200,'_.2.TARGETCLS()->.ID',970910002,21102052,0,1) ;

CALL STATICLINK_IMPORT(970202400,'_.2.TARGETCLS()->.ID',970910002,21202053,0,1) ;

CALL STATICLINK_IMPORT(970201600,'_.2.TARGETCLS()->.ID',970910002,20902145,0,0) ;

CALL STATICLINK_IMPORT(972200100,'_.1.TARGETCLS()->.ID',970910002,220101210,0,0) ;

CALL STATICLINK_IMPORT(970800100,'_.1.TARGETCLS()->.ID',970910002,80101090,0,0) ;

CALL STATICLINK_IMPORT(970800000,'_.1.TARGETCLS()->.ID',970910002,80111086,0,0) ;

CALL STATICLINK_IMPORT(970800200,'_.TARGETCLS()->.ID',970910002,80210045,0,0) ;

CALL STATICLINK_IMPORT(970800300,'_.1.TARGETCLS()->.ID',970910002,80311058,0,0) ;

CALL STATICLINK_IMPORT(970900100,'.1.->.ID',970910002,90001010,0,0) ;

CALL STATICLINK_IMPORT(970900000,'.1.{("")}()->.ID',970910002,90011010,0,0) ;

CALL STATICLINK_IMPORT(970900300,'_.1.TARGETCLS()->.ID',970910002,90301177,0,0) ;

CALL STATICLINK_IMPORT(970900200,'_.1.TARGETCLS()->.ID',970910002,90311097,0,0) ;

CALL STATICLINK_IMPORT(970900400,'_.TARGETCLS()->.ID',970910002,90510053,0,0) ;

CALL STATICLINK_IMPORT(970900500,'_.TARGETCLS()->.ID',970910002,90710061,0,0) ;

CALL STATICLINK_IMPORT(972500000,'.2.TARGETCLS->.ID',970910002,250112078,0,1) ;

CALL STATICLINK_IMPORT(972500100,'.2.TARGETCLS->.ID',970910002,250212063,0,1) ;

CALL STATICLINK_IMPORT(972500200,'.2.TARGETCLS->.ID',970910002,250312058,0,1) ;

CALL STATICLINK_IMPORT(972500300,'.2.TARGETCLS->.ID',970910002,250412110,0,1) ;

CALL STATICLINK_IMPORT(973000000,'.1.TARGETCLS->.ID',970910002,300111105,0,1) ;

CALL STATICLINK_IMPORT(973000100,'.1.TARGETCLS->.ID',970910002,300611068,0,1) ;

CALL STATICLINK_IMPORT(973000200,'.1.TARGETCLS->.ID',970910002,301111053,0,1) ;

CALL STATICLINK_IMPORT(974400100,'.1.TARGETCLS()->.ID',970910002,440101076,0,0) ;

CALL STATICLINK_IMPORT(974400000,'.1.TARGETCLS()->.ID',970910002,440111073,0,0) ;

CALL STATICLINK_IMPORT(974400200,'.1.TARGETCLS()->.ID',970910002,440311070,0,0) ;

CALL STATICLINK_IMPORT(975200100,'.1.TARGETCLS()->.ID',970910002,520101081,0,0) ;

CALL STATICLINK_IMPORT(975200000,'.1.TARGETCLS()->.ID',970910002,520111081,0,0) ;

CALL STATICLINK_IMPORT(975500100,'_.1.TARGETCLS()->.ID',970910002,550101182,0,0) ;

CALL STATICLINK_IMPORT(975500000,'_.1.TARGETCLS()->.ID',970910002,550111172,0,0) ;

CALL STATICLINK_IMPORT(975500300,'_.1.TARGETCLS()->.ID',970910002,550201195,0,0) ;

CALL STATICLINK_IMPORT(975500200,'_.1.TARGETCLS()->.ID',970910002,550211160,0,0) ;

CALL STATICLINK_IMPORT(975500400,'.1.TARGETCLS()->.ID',970910002,550311067,0,0) ;

CALL STATICLINK_IMPORT(960204900,'.ORGREF()->.ID',960110033,21310019,0,0) ;

CALL STATICLINK_IMPORT(980229500,'.FACIALACCCLS()->.ID',984110021,21310027,0,0) ;

CALL STATICLINK_IMPORT(980228900,'.DOCBASE(,)->.ID',982910007,21310030,0,0) ;

CALL STATICLINK_IMPORT(960204800,'.ORGREF()->.ID',960110033,21300019,0,0) ;

CALL STATICLINK_IMPORT(980229400,'.FACIALACCCLS()->.ID',984110021,21300027,0,0) ;

CALL STATICLINK_IMPORT(980228800,'.DOCBASE(,)->.ID',982910007,21300030,0,0) ;

CALL STATICLINK_IMPORT(980229900,'__.FACIALACCCLS()->.ID',984110021,21410027,0,0) ;

CALL STATICLINK_IMPORT(980229800,'__.FACIALACCCLS()->.ID',984110021,21400027,0,0) ;

CALL STATICLINK_IMPORT(980230700,'__.DOCBASE(,)->.ID',982910007,21410030,0,0) ;

CALL STATICLINK_IMPORT(980230600,'__.DOCBASE(,)->.ID',982910007,21400030,0,0) ;

CALL STATICLINK_IMPORT(980231100,'__.FACIALACCCLS()->.ID',984110021,21510027,0,0) ;

CALL STATICLINK_IMPORT(980231000,'__.FACIALACCCLS()->.ID',984110021,21500027,0,0) ;

CALL STATICLINK_IMPORT(980231500,'__.DOCBASE(,)->.ID',982910007,21510030,0,0) ;

CALL STATICLINK_IMPORT(980231400,'__.DOCBASE(,)->.ID',982910007,21500030,0,0) ;

CALL STATICLINK_IMPORT(970202600,'.1.TARGETCLS()->.ID',970910002,21311006,0,0) ;

CALL STATICLINK_IMPORT(990236100,'.1.TRANSFERTCLS()->.ID',988410002,21311011,0,0) ;

CALL STATICLINK_IMPORT(980229300,'.1.MEANSTYPE()->.ID',984910002,21311013,0,0) ;

CALL STATICLINK_IMPORT(980229700,'.1.FACIALACC_CLS()->.ID',984110021,21311035,0,0) ;

CALL STATICLINK_IMPORT(980229100,'.1.REGIONCLS(,,)->.ID',981210005,21311036,0,0) ;

CALL STATICLINK_IMPORT(970202500,'.1.TARGETCLS()->.ID',970910002,21301006,0,0) ;

CALL STATICLINK_IMPORT(990236000,'.1.TRANSFERTCLS()->.ID',988410002,21301011,0,0) ;

CALL STATICLINK_IMPORT(980229200,'.1.MEANSTYPE()->.ID',984910002,21301013,0,0) ;

CALL STATICLINK_IMPORT(980229600,'.1.FACIALACC_CLS()->.ID',984110021,21301035,0,0) ;

CALL STATICLINK_IMPORT(980229000,'.1.REGIONCLS(,,)->.ID',981210005,21301036,0,0) ;

CALL STATICLINK_IMPORT(980228600,'.1.KD()->.ID',980910006,21301041,0,0) ;

CALL STATICLINK_IMPORT(980228700,'.1.KD()->.ID',980910006,21311041,0,0) ;

CALL STATICLINK_IMPORT(970202800,'__.1.TARGETCLS()->.ID',970910002,21411006,0,0) ;

CALL STATICLINK_IMPORT(970202700,'__.1.TARGETCLS()->.ID',970910002,21401006,0,0) ;

CALL STATICLINK_IMPORT(980230300,'__.1.MEANSTYPE()->.ID',984910002,21411013,0,0) ;

CALL STATICLINK_IMPORT(980230200,'__.1.MEANSTYPE()->.ID',984910002,21401013,0,0) ;

CALL STATICLINK_IMPORT(980230100,'__.1.FACIALACC_CLS()->.ID',984110021,21411035,0,0) ;

CALL STATICLINK_IMPORT(980230000,'__.1.FACIALACC_CLS()->.ID',984110021,21401035,0,0) ;

CALL STATICLINK_IMPORT(980230500,'__.1.REGIONCLS(,,)->.ID',981210005,21411036,0,0) ;

CALL STATICLINK_IMPORT(980230400,'__.1.REGIONCLS(,,)->.ID',981210005,21401036,0,0) ;

CALL STATICLINK_IMPORT(980230800,'__.1.KD()->.ID',980910006,21401041,0,0) ;

CALL STATICLINK_IMPORT(980230900,'__.1.KD()->.ID',980910006,21411041,0,0) ;

CALL STATICLINK_IMPORT(970203000,'__.1.TARGETCLS()->.ID',970910002,21511006,0,0) ;

CALL STATICLINK_IMPORT(970202900,'__.1.TARGETCLS()->.ID',970910002,21501006,0,0) ;

CALL STATICLINK_IMPORT(980232100,'__.1.MEANSTYPE()->.ID',984910002,21511013,0,0) ;

CALL STATICLINK_IMPORT(980232000,'__.1.MEANSTYPE()->.ID',984910002,21501013,0,0) ;

CALL STATICLINK_IMPORT(980231300,'__.1.FACIALACC_CLS()->.ID',984110021,21511035,0,0) ;

CALL STATICLINK_IMPORT(980231200,'__.1.FACIALACC_CLS()->.ID',984110021,21501035,0,0) ;

CALL STATICLINK_IMPORT(980231700,'__.1.REGIONCLS(,,)->.ID',981210005,21511036,0,0) ;

CALL STATICLINK_IMPORT(980231600,'__.1.REGIONCLS(,,)->.ID',981210005,21501036,0,0) ;

CALL STATICLINK_IMPORT(980231800,'__.1.KD()->.ID',980910006,21501041,0,0) ;

CALL STATICLINK_IMPORT(980231900,'__.1.KD()->.ID',980910006,21511041,0,0) ;

CALL STATICLINK_IMPORT(982507300,'.4.MEANSTYPE->.ID',984910002,250414129,0,0) ;

CALL STATICLINK_IMPORT(982507000,'.4.KVSR->.ID',980310002,250414131,0,1) ;

CALL STATICLINK_IMPORT(982506900,'.4.KVR->.ID',980410002,250414133,0,1) ;

CALL STATICLINK_IMPORT(982507100,'.4.KFSR->.ID',980210004,250414134,0,0) ;

CALL STATICLINK_IMPORT(992504400,'.4.KESR->.ID',986810006,250414135,0,0) ;

CALL STATICLINK_IMPORT(982507200,'.4.KCSR->.ID',980510002,250414137,0,0) ;

CALL STATICLINK_IMPORT(972500400,'.4.TARGETCLS->.ID',970910002,250414140,0,0) ;

CALL STATICLINK_IMPORT(960204700,'.1.ORG_REF()->.ID',960110033,21311051,0,0) ;

CALL STATICLINK_IMPORT(545400000,'.1.RECORDINDEX->.ID',540210001,540211001,0,0) ;

CALL STATICLINK_IMPORT(980232200,'_.2.KD()->.ID',980910006,21112065,0,0) ;

CALL STATICLINK_IMPORT(980232300,'_.2.SUBKD()->.ID',981010006,21112069,0,0) ;

CALL STATICLINK_IMPORT(999903900,'.INVESTOBJECT->.ID',985410045,993010036,0,0) ;

CALL STATICLINK_IMPORT(990236400,'.1.->.ID',985410045,20011051,0,1) ;

CALL STATICLINK_IMPORT(990236500,'.1.->.ID',985410045,20001050,0,1) ;

CALL STATICLINK_IMPORT(980232400,'.1.->.ID',980810002,20011054,0,1) ;

CALL STATICLINK_IMPORT(980232500,'.1.->.ID',980810002,20001053,0,1) ;

CALL STATICLINK_IMPORT(980357800,'.1.->.ID',980810002,30001057,0,1) ;

CALL STATICLINK_IMPORT(980357900,'.1.->.ID',980810002,30011056,0,1) ;

CALL STATICLINK_IMPORT(983004600,'.7.DOCTYPECLS->.ID',981110005,300117146,0,1) ;

CALL STATICLINK_IMPORT(981908500,'.1.->.ID',980810002,190001046,0,1) ;

CALL STATICLINK_IMPORT(981908600,'.1.->.ID',980810002,190011046,0,1) ;

CALL STATICLINK_IMPORT(979800200,'.NATIONALPROJECT->. .ID',971010002,980510015,0,0) ;

CALL STATICLINK_IMPORT(990238700,'.BUDGETREF()->.ID',987810006,21610007,0,0) ;

CALL STATICLINK_IMPORT(960205100,'.ORGREF()->.ID',960110033,21610011,0,0) ;

CALL STATICLINK_IMPORT(990238800,'.REJECTCLS()->.ID',985010005,21610012,0,0) ;

CALL STATICLINK_IMPORT(980233100,'.FACIALACCCLS()->.ID',984110021,21610017,0,0) ;

CALL STATICLINK_IMPORT(20203100,'.1.RECORDINDEX()->.ID()',21610005,21611041,0,2) ;

CALL STATICLINK_IMPORT(980233000,'.1.FACIALACC_CLS()->.ID',984110021,21611042,0,0) ;

CALL STATICLINK_IMPORT(980232700,'.1.KVSR()->.ID',980310002,21611043,0,0) ;

CALL STATICLINK_IMPORT(980232800,'.1.KFSR()->.ID',980210004,21611045,0,0) ;

CALL STATICLINK_IMPORT(980232600,'.1.KVR()->.ID',980410002,21611046,0,0) ;

CALL STATICLINK_IMPORT(980232900,'.1.KCSR()->.ID',980510002,21611048,0,0) ;

CALL STATICLINK_IMPORT(960205000,'.1.ORG_REF()->.ID',960110033,21611050,0,0) ;

CALL STATICLINK_IMPORT(990239100,'.BUDGETREF()->.ID',987810006,21710003,0,0) ;

CALL STATICLINK_IMPORT(980233400,'.FACIALACCCLS()->.ID',984110021,21710008,0,0) ;

CALL STATICLINK_IMPORT(960205200,'.ORGREF()->.ID',960110033,21710012,0,0) ;

CALL STATICLINK_IMPORT(990239000,'.REJECTCLS()->.ID',985010005,21710016,0,0) ;

CALL STATICLINK_IMPORT(980233300,'.1.KD()->.ID',980910006,21711042,0,0) ;

CALL STATICLINK_IMPORT(20203200,'.1.RECORDINDEX()->.ID()',21610005,21711050,0,2) ;

CALL STATICLINK_IMPORT(980233500,'.2.FACIALACC_CLS()->.ID',984110021,21712057,0,0) ;

CALL STATICLINK_IMPORT(980233200,'.1.KD()->.ID',980910006,21611057,0,0) ;

CALL STATICLINK_IMPORT(990238900,'.1.IFS()->.ID',985210008,21611058,0,0) ;

CALL STATICLINK_IMPORT(990215400,'_.PLANDOCTYPE()->.ID',986410006,20100212,0,0) ;

CALL STATICLINK_IMPORT(990200100,'_.PLANDOCTYPE()->.ID',986410006,20110092,0,0) ;

CALL STATICLINK_IMPORT(990216900,'_.PLANDOCTYPE()->.ID',986410006,20200157,0,0) ;

CALL STATICLINK_IMPORT(990200800,'_.PLANDOCTYPE()->.ID',986410006,20210100,0,0) ;

CALL STATICLINK_IMPORT(990218200,'_.PLANDOCTYPE()->.ID',986410006,20300165,0,0) ;

CALL STATICLINK_IMPORT(990201500,'_.PLANDOCTYPE()->.ID',986410006,20310164,0,0) ;

CALL STATICLINK_IMPORT(990219500,'_.PLANDOCTYPE()->.ID',986410006,20400157,0,0) ;

CALL STATICLINK_IMPORT(990202200,'_.PLANDOCTYPE()->.ID',986410006,20410108,0,0) ;

CALL STATICLINK_IMPORT(990202900,'.PLANDOCTYPE()->.ID',986410006,20510121,0,0) ;

CALL STATICLINK_IMPORT(990221000,'__.PLANDOCTYPE()->.ID',986410006,20600205,0,0) ;

CALL STATICLINK_IMPORT(990203600,'__.PLANDOCTYPE()->.ID',986410006,20610204,0,0) ;

CALL STATICLINK_IMPORT(990222200,'_.PLANDOCTYPE()->.ID',986410006,20700228,0,0) ;

CALL STATICLINK_IMPORT(990206300,'_.PLANDOCTYPE()->.ID',986410006,20710176,0,0) ;

CALL STATICLINK_IMPORT(990223500,'__.PLANDOCTYPE()->.ID',986410006,20800229,0,0) ;

CALL STATICLINK_IMPORT(990207400,'__.PLANDOCTYPE()->.ID',986410006,20810228,0,0) ;

CALL STATICLINK_IMPORT(990209400,'_.PLANDOCTYPE()->.ID',986410006,20910158,0,0) ;

CALL STATICLINK_IMPORT(990224800,'.PLANDOCTYPE()->.ID',986410006,21000074,0,0) ;

CALL STATICLINK_IMPORT(990209800,'.PLANDOCTYPE()->.ID',986410006,21010074,0,0) ;

CALL STATICLINK_IMPORT(990241500,'_.PLANDOCTYPE()->.ID',986410006,21100073,0,0) ;

CALL STATICLINK_IMPORT(990241400,'_.PLANDOCTYPE()->.ID',986410006,21110074,0,0) ;

CALL STATICLINK_IMPORT(990241300,'_.PLANDOCTYPE()->.ID',986410006,21200066,0,0) ;

CALL STATICLINK_IMPORT(990241200,'_.PLANDOCTYPE()->.ID',986410006,21210067,0,0) ;

CALL STATICLINK_IMPORT(990238600,'.PLANDOCTYPE()->.ID',986410006,21610059,0,0) ;

CALL STATICLINK_IMPORT(990241100,'.PLANDOCTYPE()->.ID',986410006,21710084,0,0) ;

CALL STATICLINK_IMPORT(992203000,'_.PLANDOCTYPE()->.ID',986410006,220100213,0,0) ;

CALL STATICLINK_IMPORT(992200100,'_.PLANDOCTYPE()->.ID',986410006,220110076,0,0) ;

CALL STATICLINK_IMPORT(991908700,'_.PLANDOCTYPE()->.ID',986410006,190100217,0,0) ;

CALL STATICLINK_IMPORT(991900100,'_.PLANDOCTYPE()->.ID',986410006,190110093,0,0) ;

CALL STATICLINK_IMPORT(991910000,'_.PLANDOCTYPE()->.ID',986410006,190200217,0,0) ;

CALL STATICLINK_IMPORT(991900800,'_.PLANDOCTYPE()->.ID',986410006,190210092,0,0) ;

CALL STATICLINK_IMPORT(991911300,'_.PLANDOCTYPE()->.ID',986410006,190300195,0,0) ;

CALL STATICLINK_IMPORT(991901500,'_.PLANDOCTYPE()->.ID',986410006,190310093,0,0) ;

CALL STATICLINK_IMPORT(991903800,'__.PLANDOCTYPE()->.ID',986410006,190610094,0,0) ;

CALL STATICLINK_IMPORT(990200000,'_.ASSIGNMENTSOURCE()->.ID',988610011,20110093,0,0) ;

CALL STATICLINK_IMPORT(990215300,'_.ASSIGNMENTSOURCE()->.ID',988610011,20100213,0,0) ;

CALL STATICLINK_IMPORT(990200700,'_.ASSIGNMENTSOURCE()->.ID',988610011,20210101,0,0) ;

CALL STATICLINK_IMPORT(990216800,'_.ASSIGNMENTSOURCE()->.ID',988610011,20200158,0,0) ;

CALL STATICLINK_IMPORT(990201400,'_.ASSIGNMENTSOURCE()->.ID',988610011,20310165,0,0) ;

CALL STATICLINK_IMPORT(990218100,'_.ASSIGNMENTSOURCE()->.ID',988610011,20300166,0,0) ;

CALL STATICLINK_IMPORT(990202100,'_.ASSIGNMENTSOURCE()->.ID',988610011,20410109,0,0) ;

CALL STATICLINK_IMPORT(990219400,'_.ASSIGNMENTSOURCE()->.ID',988610011,20400158,0,0) ;

CALL STATICLINK_IMPORT(990202800,'.ASSIGNMENTSOURCE()->.ID',988610011,20510122,0,0) ;

CALL STATICLINK_IMPORT(990203500,'__.ASSIGNMENTSOURCE()->.ID',988610011,20610205,0,0) ;

CALL STATICLINK_IMPORT(990220900,'__.ASSIGNMENTSOURCE()->.ID',988610011,20600206,0,0) ;

CALL STATICLINK_IMPORT(990206100,'_.ASSIGNMENTSOURCE()->.ID',988610011,20710177,0,0) ;

CALL STATICLINK_IMPORT(990222000,'_.ASSIGNMENTSOURCE()->.ID',988610011,20700229,0,0) ;

CALL STATICLINK_IMPORT(990207200,'__.ASSIGNMENTSOURCE()->.ID',988610011,20810229,0,0) ;

CALL STATICLINK_IMPORT(990223300,'__.ASSIGNMENTSOURCE()->.ID',988610011,20800230,0,0) ;

CALL STATICLINK_IMPORT(990209200,'_.ASSIGNMENTSOURCE()->.ID',988610011,20910159,0,0) ;

CALL STATICLINK_IMPORT(990209600,'.ASSIGNMENTSOURCE()->.ID',988610011,21010075,0,0) ;

CALL STATICLINK_IMPORT(990224600,'.ASSIGNMENTSOURCE()->.ID',988610011,21000075,0,0) ;

CALL STATICLINK_IMPORT(990227800,'_.ASSIGNMENTSOURCE()->.ID',988610011,21110075,0,0) ;

CALL STATICLINK_IMPORT(990228200,'_.ASSIGNMENTSOURCE()->.ID',988610011,21210068,0,0) ;

CALL STATICLINK_IMPORT(991900000,'_.ASSIGNMENTSOURCE()->.ID',988610011,190110094,0,0) ;

CALL STATICLINK_IMPORT(991908600,'_.ASSIGNMENTSOURCE()->.ID',988610011,190100218,0,0) ;

CALL STATICLINK_IMPORT(991900700,'_.ASSIGNMENTSOURCE()->.ID',988610011,190210093,0,0) ;

CALL STATICLINK_IMPORT(991909900,'_.ASSIGNMENTSOURCE()->.ID',988610011,190200218,0,0) ;

CALL STATICLINK_IMPORT(991901400,'_.ASSIGNMENTSOURCE()->.ID',988610011,190310094,0,0) ;

CALL STATICLINK_IMPORT(991911200,'_.ASSIGNMENTSOURCE()->.ID',988610011,190300196,0,0) ;

CALL STATICLINK_IMPORT(991903700,'__.ASSIGNMENTSOURCE()->.ID',988610011,190610095,0,0) ;

CALL STATICLINK_IMPORT(992200000,'_.ASSIGNMENTSOURCE()->.ID',988610011,220110077,0,0) ;

CALL STATICLINK_IMPORT(992202900,'_.ASSIGNMENTSOURCE()->.ID',988610011,220100214,0,0) ;

CALL STATICLINK_IMPORT(990800000,'_.PLANDOCTYPE()->.ID',986410006,80110046,0,0) ;

CALL STATICLINK_IMPORT(990802700,'_.PLANDOCTYPE()->.ID',986410006,80100068,0,0) ;

CALL STATICLINK_IMPORT(989905400,'.1.KVSR()->.ID',980310002,993411013,0,0) ;

CALL STATICLINK_IMPORT(989905500,'.1.KCSR()->.ID',980510002,993411016,0,0) ;

CALL STATICLINK_IMPORT(989905300,'.1.KVR()->.ID',980410002,993411018,0,0) ;

CALL STATICLINK_IMPORT(999904000,'.1.KESR()->.ID',986810006,993411020,0,0) ;

CALL STATICLINK_IMPORT(989905600,'.1.SUBKESR()->.ID',980810002,993411022,0,0) ;

CALL STATICLINK_IMPORT(999904100,'.1.DIRECTIONCLS()->.ID',986910002,993411024,0,0) ;

CALL STATICLINK_IMPORT(989905700,'.1.FACT()->.ID',982810005,993411027,0,0) ;

CALL STATICLINK_IMPORT(999904200,'.1.PAYPROMISECLS()->.ID',989110006,993411029,0,0) ;

CALL STATICLINK_IMPORT(999904300,'.1.BUDALLOCATIONCLS()->.ID',989010006,993411031,0,0) ;

CALL STATICLINK_IMPORT(999904400,'.1.CONTRACTCOSTSCLS()->.ID',989710001,993411033,0,0) ;

CALL STATICLINK_IMPORT(999904500,'.1.INVESTOBJECT()->.1.ID',991311007,993411035,0,0) ;

CALL STATICLINK_IMPORT(989905800,'.1.FINTYPE(,)->.ID',982710006,993411037,0,0) ;

CALL STATICLINK_IMPORT(989905900,'.1.MEANSTYPE()->.ID',984910002,993411039,0,0) ;

CALL STATICLINK_IMPORT(999904600,'.1.TARGETCLS()->.ID',987910002,993411040,0,0) ;

CALL STATICLINK_IMPORT(989906000,'.1.REGIONCLS()->.ID',981210005,993411042,0,0) ;

CALL STATICLINK_IMPORT(999904700,'.1.SUBSIDYCLS()->.ID',988910006,993411043,0,0) ;

CALL STATICLINK_IMPORT(999904800,'.1.TRANSFERTCLS()->.ID',988410002,993411045,0,0) ;

CALL STATICLINK_IMPORT(999904900,'.1.PLANDOCTYPE()->.ID',986410006,993411047,0,0) ;

CALL STATICLINK_IMPORT(999905000,'.1.ASSIGNMENTSOURCE()->.ID',988610011,993411049,0,0) ;

CALL STATICLINK_IMPORT(999905100,'.1.ASSIGNMENTKIND()->.ID',988510003,993411051,0,0) ;

CALL STATICLINK_IMPORT(989906100,'.1.KD()->.ID',980910006,993411052,0,0) ;

CALL STATICLINK_IMPORT(999905200,'.1.IFS()->.ID',985210008,993411058,0,0) ;

CALL STATICLINK_IMPORT(999905300,'.1.REESTRTYPE()->.ID',985310005,993411071,0,0) ;

CALL STATICLINK_IMPORT(999905400,'.1.OKTMO()->.ID',989510001,993411072,0,0) ;

CALL STATICLINK_IMPORT(999905500,'.1.FUNDSSOURCE()->.ID',988010003,993411076,0,0) ;

CALL STATICLINK_IMPORT(989906200,'.1.FINSOURCE()->.ID',981310002,993411077,0,0) ;

CALL STATICLINK_IMPORT(989906300,'.1.DOCTYPE()->.ID',981110005,993411078,0,0) ;

CALL STATICLINK_IMPORT(989906400,'.1.FACIALACC_CLS()->.ID',984110021,993411081,0,0) ;

CALL STATICLINK_IMPORT(979900200,'.1.NATIONALPROJECT->. .ID',971010002,993411082,0,0) ;

CALL STATICLINK_IMPORT(999905700,'.1.BUDGETREF->.ID',987810006,993411083,0,0) ;

CALL STATICLINK_IMPORT(990239600,'.BUDGETREF()->.ID',987810006,21810012,0,0) ;

CALL STATICLINK_IMPORT(990239400,'.ASSIGNMENTSOURCE()->.ID',988610011,21810014,0,0) ;

CALL STATICLINK_IMPORT(990240600,'.PLANDOCTYPE()->.ID',986410006,21810016,0,0) ;

CALL STATICLINK_IMPORT(980233600,'.DOCBASE()->.ID',982910007,21810024,0,0) ;

CALL STATICLINK_IMPORT(960205400,'.ORGREF()->.ID',960110033,21810025,0,0) ;

CALL STATICLINK_IMPORT(990240700,'.REJECTCLS()->.ID',985010005,21810027,0,0) ;

CALL STATICLINK_IMPORT(980234600,'.NOTIFYTYPE()->.ID',981310002,21810033,0,0) ;

CALL STATICLINK_IMPORT(990241000,'.1.TRANSFERTCLS()->.ID',988410002,21811045,0,0) ;

CALL STATICLINK_IMPORT(990239500,'.1.BUDALLOCATIONCLS()->.ID',989010006,21811048,0,0) ;

CALL STATICLINK_IMPORT(990239800,'.1.BUHOPERATIONCLS()->.ID',987110012,21811055,0,0) ;

CALL STATICLINK_IMPORT(990239300,'.1.ASSIGNMENTKIND()->.ID',988510003,21811056,0,0) ;

CALL STATICLINK_IMPORT(990240100,'.1.FUNDSSOURCE()->.ID',988010003,21811058,0,0) ;

CALL STATICLINK_IMPORT(980234300,'.1.KVR()->.ID',980410002,21811059,0,0) ;

CALL STATICLINK_IMPORT(980234400,'.1.KVSR()->.ID',980310002,21811060,0,0) ;

CALL STATICLINK_IMPORT(990239700,'.1.BUDGETREF()->.ID',987810006,21811061,0,0) ;

CALL STATICLINK_IMPORT(20203300,'.1.RECORDINDEX()->.ID()',21810001,21811062,0,2) ;

CALL STATICLINK_IMPORT(980234200,'.1.KFSR()->.ID',980210004,21811064,0,0) ;

CALL STATICLINK_IMPORT(980234000,'.1.KCSR()->.ID',980510002,21811065,0,0) ;

CALL STATICLINK_IMPORT(990240400,'.1.KESR()->.ID',986810006,21811066,0,0) ;

CALL STATICLINK_IMPORT(980233700,'.1.FACIALACC_CLS()->.ID',984110021,21811067,0,0) ;

CALL STATICLINK_IMPORT(960205300,'.1.ORG_REF()->.ID',960110033,21811070,0,0) ;

CALL STATICLINK_IMPORT(980234700,'.1.REGIONCLS()->.ID	9812',981210005,21811072,0,0) ;

CALL STATICLINK_IMPORT(980234900,'.1.SUBKESR()->.ID',980810002,21811092,0,0) ;

CALL STATICLINK_IMPORT(980234500,'.1.MEANSTYPE()->.ID',984910002,21811093,0,0) ;

CALL STATICLINK_IMPORT(990240200,'.1.IFS()->.ID',985210008,21811097,0,0) ;

CALL STATICLINK_IMPORT(980234100,'.1.KD()->.ID',980910006,21811108,0,0) ;

CALL STATICLINK_IMPORT(980234800,'.1.SUBKD()->.ID',981010006,21811111,0,0) ;

CALL STATICLINK_IMPORT(990240800,'.1.SUBSIDYCLS()->.ID',988910006,21811112,0,0) ;

CALL STATICLINK_IMPORT(990240500,'.1.PAYPROMISECLS()->.ID',989110006,21811117,0,0) ;

CALL STATICLINK_IMPORT(990240900,'.1.SUBSIDYCLSOLD()->.ID',988910006,21811118,0,0) ;

CALL STATICLINK_IMPORT(990240000,'.1.DIRECTIONCLS()->.ID',986910002,21811119,0,0) ;

CALL STATICLINK_IMPORT(980233800,'.1.FACT()->.ID',982810005,21811120,0,0) ;

CALL STATICLINK_IMPORT(980233900,'.1.FINTYPE()->.ID',982710006,21811121,0,0) ;

CALL STATICLINK_IMPORT(990240300,'.1.INVESTOBJECT()->.ID',985410045,21811123,0,0) ;

CALL STATICLINK_IMPORT(990239900,'.1.CONTRACTCOSTSCLS()->.ID',989710001,21811124,0,0) ;

CALL STATICLINK_IMPORT(970203100,'.1.TARGETCLS()->.ID',970910002,21811129,0,0) ;

CALL STATICLINK_IMPORT(980358000,'.SOURCEFACIALACC_CLS(,)->.ID',984110021,32500003,0,0) ;

CALL STATICLINK_IMPORT(990344400,'.BUDGETREF()->.ID',987810006,32500023,0,0) ;

CALL STATICLINK_IMPORT(980358100,'.1.SOURCEKVR()->.ID',980410002,32511124,0,0) ;

CALL STATICLINK_IMPORT(980358200,'.1.SOURCEKVSR()->.ID',980310002,32511126,0,0) ;

CALL STATICLINK_IMPORT(980358400,'.1.SOURCESUBKESR()->.ID',980810002,32511128,0,0) ;

CALL STATICLINK_IMPORT(980358300,'.1.SOURCETRANSFERTCLS()->.ID',980510002,32511129,0,0) ;

CALL STATICLINK_IMPORT(990344500,'.1.SOURCETRANSFERTCLS()->.ID',988410002,32511129,1,0) ;

CALL STATICLINK_IMPORT(990344600,'.1.SOURCESUBSIDYCLS()->.ID',988910006,32511130,0,0) ;

CALL STATICLINK_IMPORT(30304200,'.REESTR_REF()->.ID()',30710012,32510133,0,1) ;

DROP PROCEDURE STATICLINK_DELETE
/

DROP PROCEDURE STATICLINK_IMPORT
/

CREATE OR REPLACE PROCEDURE FILTERS_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATE_JUMPCONTROL
  WHERE STATE_JUMPCONTROL.FILTERCODE = ID_;
  UPDATE STATE_ACTIONJUMPS SAJ
  SET SAJ.FILTERCODE = NULL, SAJ.OPTIONS = NULL
  WHERE SAJ.FILTERCODE = ID_;
  DELETE FROM State_Filter SF
  WHERE SF.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORT(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValue_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValue,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValue_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValue = FilterValue_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORTURM(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValueURM_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValueURM,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValueURM_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValueURM = FilterValueURM_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

-- 
CALL FILTERS_IMPORT(3250100, '', '  ', '([32510122])', 0, 1, 2) ;

CALL FILTERS_IMPORTURM(3250100, '', '  ', '([32510122])', 0, 1, 2) ;

DROP PROCEDURE FILTERS_DELETE
/

DROP PROCEDURE FILTERS_IMPORT
/

DROP PROCEDURE FILTERS_IMPORTURM
/

CREATE OR REPLACE PROCEDURE STATUSICONS_IMPORT(
  ID_ NUMBER,
  NOTE_ VARCHAR2,
  DOCREF_ NUMBER,
  DETAILNUM_ NUMBER,
  ICONNAME_ VARCHAR2,
  ISSYSTEM_ NUMBER,
  ICONPOS_ NUMBER,
  RUNPOS_ NUMBER,
  RESERVEPOS_ NUMBER,
  ICONHINT_ VARCHAR2,
  ICONKIND_ NUMBER,
  LOCKMASK_ NUMBER,
  FORMULA_ VARCHAR2,
  ISBUDGET_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM STATUSICONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE STATUSICONS SET
      NOTE = NOTE_,
      DOCREF = DOCREF_,
      DETAILNUM = DETAILNUM_,
      ICONNAME = ICONNAME_,
      ISSYSTEM = ISSYSTEM_,
      ICONPOS = ICONPOS_,
      RUNPOS = RUNPOS_,
      RESERVEPOS = RESERVEPOS_,
      ICONHINT = ICONHINT_,
      ICONKIND = ICONKIND_,
      LOCKMASK = LOCKMASK_,
      ISBUDGET = ISBUDGET_,
      FORMULA = FORMULA_
    WHERE ID = ID_;
  ELSE
    INSERT INTO STATUSICONS
      (ISBUDGET, ID, NOTE, DOCREF, DETAILNUM, ICONNAME, ISSYSTEM, ICONPOS, RUNPOS, RESERVEPOS, ICONHINT, ICONKIND, LOCKMASK, FORMULA)
    VALUES
      (ISBUDGET_, ID_, NOTE_, DOCREF_, DETAILNUM_, ICONNAME_, ISSYSTEM_, ICONPOS_, RUNPOS_, RESERVEPOS_, ICONHINT_, ICONKIND_, LOCKMASK_, FORMULA_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE STATUSICONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM STATUSICONS SI
  WHERE SI.ID = ID_;
END;
/

--  
CALL STATUSICONS_DELETE(45093) ;

CALL STATUSICONS_IMPORT(39873,'',302,0,'',1,2,3,1,'     ',0,0,'([30210135])',1) ;

CALL STATUSICONS_IMPORT(39874,'',304,0,'',1,2,3,1,'     ',0,0,'([30410040])',1) ;

CALL STATUSICONS_IMPORT(45019,' ,   ',1821,0,'',1,1,1,0,'[182110029]',0,0,'([182110029])',1) ;

CALL STATUSICONS_IMPORT(46104,'',4403,0,'',1,1,1,1,'    ',1,4,'',1) ;

DROP PROCEDURE STATUSICONS_IMPORT
/

DROP PROCEDURE STATUSICONS_DELETE
/


CREATE OR REPLACE PROCEDURE ENUMS_IMPORT(NAME_ VARCHAR2,FACIALACCCLS_ NUMBER) IS
  IDEXISTS$ NUMBER;
BEGIN
  SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMS WHERE NAME = NAME_;
  IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMS E1
      WHERE (E1.NAME = NAME_) AND (E1.ID > (SELECT MIN(E2.ID) FROM ENUMS E2 WHERE E2.NAME = NAME_));
  END IF;
  IF (IDEXISTS$ > 0) THEN
    UPDATE ENUMS SET
      FACIALACCCLS = FACIALACCCLS_,
      ISSYSTEM = 1
    WHERE NAME = NAME_;
  ELSE
    INSERT INTO ENUMS
      (NAME,FACIALACCCLS,ISSYSTEM)    
    VALUES
      (NAME_,FACIALACCCLS_,1);
  END IF;    
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_IMPORT(ENUMNAME_ VARCHAR2,NAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
  IDEXISTS$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      IDENUM$ := NULL;
  END;  
  IF (IDENUM$ IS NOT NULL) THEN
    SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMVALUES WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMVALUES EV1
      WHERE (EV1.ENUMREF = IDENUM$) AND (EV1.VAL = VAL_) AND
        (EV1.ID > (SELECT MIN(EV2.ID) FROM ENUMVALUES EV2 WHERE EV2.ENUMREF = IDENUM$ AND EV2.VAL = VAL_));
    END IF;
    IF (IDEXISTS$ > 0) THEN
      UPDATE ENUMVALUES SET
        NAME = NAME_
      WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    ELSE
      INSERT INTO ENUMVALUES
        (VAL,NAME,ENUMREF)  
      VALUES
        (VAL_,NAME_,IDENUM$);
    END IF;    
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE ENUMS_DELETE(NAME_ VARCHAR2) IS
BEGIN
  DELETE FROM ENUMS WHERE NAME = NAME_;
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_DELETE(ENUMNAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
     WHEN NO_DATA_FOUND THEN
       IDENUM$ := NULL;  
  END;
  IF (IDENUM$ IS NOT NULL) THEN
    DELETE FROM ENUMVALUES WHERE (VAL = VAL_) AND (ENUMREF = IDENUM$);
  END IF;  
END;
/

-- 
CALL ENUMVALUES_DELETE('',10) ;

CALL ENUMVALUES_DELETE('',11) ;

CALL ENUMVALUES_DELETE('',12) ;

CALL ENUMVALUES_DELETE('',13) ;

CALL ENUMVALUES_DELETE('',14) ;

CALL ENUMVALUES_DELETE('',15) ;

CALL ENUMVALUES_DELETE('',18) ;

CALL ENUMVALUES_DELETE('',22) ;

CALL ENUMVALUES_DELETE('',24) ;

CALL ENUMVALUES_DELETE('',25) ;

CALL ENUMVALUES_DELETE('',27) ;

CALL ENUMVALUES_DELETE('',0) ;

CALL ENUMVALUES_IMPORT('','  ',527) ;

CALL ENUMVALUES_IMPORT('','   ',283) ;

CALL ENUMVALUES_IMPORT('','',5) ;

CALL ENUMVALUES_IMPORT('','01= ( ,     ,   ) - ',1) ;

CALL ENUMVALUES_IMPORT('','03=   ,           ,     ',3) ;

CALL ENUMVALUES_IMPORT('','06=   - ,       (  ,   )',6) ;

CALL ENUMVALUES_IMPORT('','07=  (  ,   )',7) ;

CALL ENUMVALUES_IMPORT('','08= -  (),            (  ,     )',8) ;

CALL ENUMVALUES_IMPORT('','09= ( ,     ,   ) - ',9) ;

CALL ENUMVALUES_IMPORT('','10= ( ,     ,   ) - ,   ',10) ;

CALL ENUMVALUES_IMPORT('','11= ( ,     ,   ) - ,   ',11) ;

CALL ENUMVALUES_IMPORT('','12= ( ,     ,   ) -   () ',12) ;

CALL ENUMVALUES_IMPORT('','13= ( ,       ,     ,   ) - ',13) ;

CALL ENUMVALUES_IMPORT('','15=  (  ),  ,    ,            ,    - ',15) ;

CALL ENUMVALUES_IMPORT('','16=   -  (  ,   )',16) ;

CALL ENUMVALUES_IMPORT('','17=   -  (  ,   )',17) ;

CALL ENUMVALUES_IMPORT('','18=  ,   ,          ',18) ;

CALL ENUMVALUES_IMPORT('','19=   ,  ,         (  ,     )',19) ;

CALL ENUMVALUES_IMPORT('','20=  (  ),  ,           (  ,     )',20) ;

CALL ENUMVALUES_IMPORT('','23=     (  ,   )',23) ;

CALL ENUMVALUES_IMPORT('','24= - ,       ,  ,   ,        (  ,     )',24) ;

CALL ENUMVALUES_IMPORT('','27=  (  ),      ,     ,          ',27) ;

CALL ENUMVALUES_IMPORT('','28=   -     (  ,   )',28) ;

CALL ENUMVALUES_IMPORT('','29=                (  ,   )',29) ;

CALL ENUMVALUES_IMPORT('','=     ,  ()          (,  )',1) ;

CALL ENUMVALUES_IMPORT('','=         (,  )',3) ;

CALL ENUMVALUES_IMPORT('','= -   ',16) ;

CALL ENUMVALUES_IMPORT('','=    /  ',17) ;

CALL ENUMVALUES_IMPORT('','=     ,      /      ',19) ;

CALL ENUMVALUES_IMPORT('','=    ',28) ;

CALL ENUMVALUES_IMPORT('','=   -  ,    -',35) ;

CALL ENUMVALUES_IMPORT('','= (  )         , , ,  ,   ,       ',29) ;

CALL ENUMVALUES_IMPORT('','= ',30) ;

CALL ENUMVALUES_IMPORT('','=       ()',31) ;

CALL ENUMVALUES_IMPORT('','=         ,        ',32) ;

CALL ENUMVALUES_IMPORT('','=         ,        ',33) ;

CALL ENUMVALUES_IMPORT('','=    , , ,  ,      ',34) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' ',0) ;

CALL ENUMVALUES_IMPORT('','  ',1) ;

CALL ENUMVALUES_IMPORT('','   - ',2) ;

CALL ENUMVALUES_IMPORT('',' ',3) ;

CALL ENUMVALUES_IMPORT('',' (, ),           ,      ',4) ;

CALL ENUMVALUES_IMPORT('','-  ',5) ;

CALL ENUMVALUES_IMPORT('',' (, ),           ,       ',6) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('','',0) ;

CALL ENUMVALUES_IMPORT('','',1) ;

CALL ENUMVALUES_IMPORT('','',2) ;

CALL ENUMVALUES_IMPORT('',' ',3) ;

CALL ENUMVALUES_IMPORT('',' ',4) ;

CALL ENUMVALUES_IMPORT('',' ',5) ;

CALL ENUMVALUES_IMPORT('',' ',6) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' ',0) ;

CALL ENUMVALUES_IMPORT('','',1) ;

CALL ENUMVALUES_IMPORT('','- ',2) ;

CALL ENUMVALUES_IMPORT('',',      ',3) ;

CALL ENUMVALUES_IMPORT('',' ',4) ;

CALL ENUMVALUES_IMPORT('','',5) ;

CALL ENUMVALUES_IMPORT('','',6) ;

CALL ENUMVALUES_IMPORT('','',7) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' ',1) ;

CALL ENUMVALUES_IMPORT('','   ',2) ;

CALL ENUMVALUES_IMPORT('','  ',3) ;

CALL ENUMVALUES_IMPORT('',' ',4) ;

CALL ENUMVALUES_IMPORT('',' ',5) ;

CALL ENUMVALUES_IMPORT('',' .',6) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('','  ',0) ;

CALL ENUMVALUES_IMPORT('','',1) ;

CALL ENUMVALUES_IMPORT('','',2) ;

CALL ENUMVALUES_IMPORT('',' ',3) ;

CALL ENUMVALUES_IMPORT('','',4) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('','  ',0) ;

CALL ENUMVALUES_IMPORT('','    ',1) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' ',1) ;

CALL ENUMVALUES_IMPORT('',',  ',2) ;

CALL ENUMVALUES_IMPORT('',' ',3) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' (,  , )   ',1) ;

CALL ENUMVALUES_IMPORT('','  ( )',2) ;

CALL ENUMVALUES_IMPORT('',' ()  ( )',3) ;

CALL ENUMVALUES_IMPORT('','  ',4) ;

CALL ENUMVALUES_IMPORT('','   () ',5) ;

CALL ENUMVALUES_IMPORT('',' ',6) ;

CALL ENUMVALUES_IMPORT('','  ',7) ;

CALL ENUMVALUES_IMPORT('',' () -  ( )',8) ;

CALL ENUMVALUES_IMPORT('',' ,    ',9) ;

CALL ENUMVALUES_IMPORT('',' - ',10) ;

CALL ENUMVALUES_IMPORT('','    (  )',11) ;

CALL ENUMVALUES_IMPORT('',' - (-) ,      ',12) ;

CALL ENUMVALUES_IMPORT('','     ',13) ;

CALL ENUMVALUES_IMPORT('',' , , ',14) ;

CALL ENUMVALUES_IMPORT('','   ',15) ;

DROP PROCEDURE ENUMS_IMPORT
/

DROP PROCEDURE ENUMVALUES_IMPORT
/

DROP PROCEDURE ENUMS_DELETE
/

DROP PROCEDURE ENUMVALUES_DELETE
/

--      
INSERT INTO DFUCHANGELOG (VersionID, BEGINUPDATECODE, ENDUPDATECODE, LASTUPDATEDFU, ISBUDGET, INCLUDEDEL, INCLUDEBLOCKS, INCLUDEDOCS, SCRIPTCREATOR, SCRIPTCREATEDATE, NOTE) VALUES (3634, 130000, 140000, TO_DATE('30.08.2021 14:26:49', 'DD.MM.YYYY HH24:MI:SS'), 2, 1, ',    ,  , ,  , ,  , , ', '00.00, 01.01, 02.00, 02.01, 02.02, 02.03, 02.04, 02.05, 02.06, 02.07, 02.08, 02.09, 02.10, 02.11, 02.12, 02.13, 02.14, 02.15, 02.16, 02.17, 02.18, 03.00, 03.01, 03.02, 03.03, 03.04, 03.05, 03.06, 03.07, 03.08, 03.11, 03.12, 03.14, 03.15, 03.16, 03.22, 03.23, 03.24, 03.25, 04.01, 05.01, 07.01, 07.02, 07.03, 08.01, 08.02, 08.03, 08.04, 09.00, 09.01, 09.02, 09.03, 09.05, 09.06, 09.07, 12.01, 15.01, 16.01, 16.02, 17.01, 17.02, 18.05, 18.07, 18.09, 18.10, 18.12, 18.13, 18.14, 18.15, 18.16, 18.18, 18.19, 18.20, 18.21, 18.24, 18.25, 19.00, 19.01, 19.02, 19.03, 19.06, 22.00, 22.01, 25.01, 25.02, 25.03, 25.04, 28.01, 28.02, 30.01, 30.02, 30.03, 30.04, 30.05, 30.06, 30.10, 30.11, 36.10, 37.01, 39.01, 44.01, 44.03, 47.01, 48.01, 49.01, 49.02, 49.03, 51.01, 52.01, 53.01, 53.02, 53.03, 53.04, 53.05, 53.06, 54.01, 54.02, 55.01, 55.02, 55.03, 56.01, 96.01, 96.02, 96.03, 96.04, 97.01, 97.02, 97.09, 97.10, 97.11, 97.12, 97.13, 97.14, 97.16, 98.02, 98.03, 98.04, 98.05, 98.06, 98.08, 98.09, 98.10, 98.11, 98.12, 98.13, 98.14, 98.15, 98.16, 98.17, 98.18, 98.20, 98.21, 98.22, 98.23, 98.26, 98.27, 98.28, 98.29, 98.34, 98.35, 98.41, 98.42, 98.43, 98.44, 98.45, 98.46, 98.47, 98.48, 98.49, 98.50, 98.51, 98.52, 98.53, 98.54, 98.57, 98.58, 98.59, 98.60, 98.61, 98.62, 98.63, 98.64, 98.65, 98.67, 98.68, 98.69, 98.70, 98.71, 98.72, 98.78, 98.79, 98.80, 98.81, 98.82, 98.83, 98.84, 98.85, 98.86, 98.87, 98.88, 98.89, 98.90, 98.91, 98.92, 98.94, 98.95, 98.97, 98.98, 98.99, 99.03, 99.04, 99.05, 99.08, 99.12, 99.13, 99.14, 99.15, 99.16, 99.17, 99.18, 99.19, 99.20, 99.21, 99.22, 99.23, 99.24, 99.25, 99.26, 99.27, 99.28, 99.29, 99.30, 99.31, 99.32, 99.33, 99.34', 'JUROV/volchenkov', TO_DATE('30.08.2021 14:27:50', 'DD.MM.YYYY HH24:MI:SS'), '') ;

COMMIT WORK
/

--              (   14.00)
CREATE OR REPLACE procedure ChangeFieldsCodeToID(
   FIELDNAME_          VARCHAR2
) IS
  ID_new$ NUMBER(10);
BEGIN
  FOR REC$1 IN (select dlf.id AS DocLockRef, df.doctyperef AS DOCType, df.detailnumber AS DetailNumbers, df.isbudget  AS IsBudget from DOCLOCK dl
  left join DocLockFields dlf on (dlf.DocLockRef = dl.Id)
  left join DocumentFields df on (df.Id = dlf.FieldRef)
  where  (UPPER(df.Name) Like ('%'||FIELDNAME_||'%')) and (UPPER(df.Name) not like ('%%'))
  and (dl.isSystem = 0) and (dl.LockAction = 11)
  )
  LOOP
    BEGIN
      select df.id into ID_new$ from DocumentFields df where (UPPER(df.name) like ('%'||FIELDNAME_||'%'))
      and (UPPER(df.Name) like ('%%'))
      and (df.doctyperef = REC$1.DOCType) and (df.detailnumber = REC$1.DetailNumbers) and (df.IsBudget = REC$1.IsBudget) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (ID_new$ is not null) THEN
      update DocLockFields dlf set
      dlf.FIELDREF = ID_new$
      where
      dlf.Id = REC$1.DocLockRef;
    END IF;
  END LOOP;
END;
/

CALL ChangeFieldsCodeToID(' ')
/

CALL ChangeFieldsCodeToID(' ')
/

drop procedure ChangeFieldsCodeToID
/

commit work
/



-- #########################################################
-- #########################################################
-- Add_Const_ProgIndex_283.sql
-- #########################################################
-- #########################################################

CALL AddVarcharConst(1001, 283, '', '       ')
/
CALL AddVarcharConst(1002, 283, '', '        ')
/
commit work
/



-- #########################################################
-- #########################################################
-- DBVersion.sql
-- #########################################################
-- #########################################################

INSERT INTO DataBaseVersion(VERSION, Major, Minor, AComment)
  VALUES ('14.00.00', 1400, 00, ' 14.00.00')
/

COMMIT WORK
/

-- #########################################################
-- #########################################################
-- Index_Fix.sql
-- #########################################################
-- #########################################################

--      INDX
DECLARE
  CURSOR C$ IS
    select INDEX_NAME from DBA_INDEXES
    where OWNER = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      and TABLESPACE_NAME <> 'INDX'
      and INDEX_TYPE LIKE '%NORMAL%';
  CNT$ NUMBER(10);    
BEGIN
  BEGIN
    select count(*) into CNT$ from V$TABLESPACE
    where name = 'INDX';
  EXCEPTION
    WHEN OTHERS THEN
      CNT$ := 1;
  END;
  IF CNT$ = 1 THEN
    FOR R$ IN C$ LOOP
      EXECUTE IMMEDIATE 'ALTER INDEX ' || R$.INDEX_NAME || ' REBUILD TABLESPACE INDX';
    END LOOP;
  END IF;
END;
/

-- #########################################################
-- #########################################################
-- compile_scr.sql
-- #########################################################
-- #########################################################

--      , 
--  -  
--  DBMS_UTILITY.COMPILE_SCHEMA(user, TRUE);

DECLARE
  CURSOR C$ IS
    SELECT 'ALTER ' || object_type || ' ' || owner || '.' || object_name || ' COMPILE' AS str,
      object_type, object_name
    FROM SYS.ALL_OBJECTS
    WHERE owner = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      AND object_type IN ('VIEW', 'PROCEDURE', 'TRIGGER')
      AND status = 'INVALID'
      AND object_name not like 'BIN$%'
    ORDER BY DECODE(object_type, 'VIEW', 1, 'PROCEDURE', 2, 'TRIGGER', 3), object_name;
  S VARCHAR2(100);
BEGIN
  FOR R$ IN C$ LOOP
    BEGIN
      S := R$.object_type || ' ' || R$.object_name;
      EXECUTE IMMEDIATE R$.str;
    EXCEPTION
      WHEN OTHERS THEN 
        --DBMS_OUTPUT.PUT_LINE(S);
        RAISE_APPLICATION_ERROR(-20000, '    ' || S);
    END;
  END LOOP;
END;
/

-- #########################################################
-- #########################################################
-- dbms_stats_scr.sql
-- #########################################################
-- #########################################################

ALTER SESSION SET NLS_NUMERIC_CHARACTERS='.,'
/

BEGIN
  DBMS_STATS.GATHER_SCHEMA_STATS(
    SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA'),
    DBMS_STATS.AUTO_SAMPLE_SIZE,
    false,
    'FOR ALL COLUMNS SIZE AUTO',
    cascade=>TRUE
  );
END;
/

exit
